/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
    "project_type": "javascript",
    // "project_type" indicate the program language of your project, you can ignore this field

    "debugMode"     : 1,
    // "debugMode" possible values :
    //      0 - No message will be printed.
    //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
    //      2 - cc.error, cc.assert, cc.warn will print in console.
    //      3 - cc.error, cc.assert will print in console.
    //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
    //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
    //      6 - cc.error, cc.assert will print on canvas, available only on web.

    "showFPS"       : true,
    // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

    "frameRate"     : 60,
    // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.

    "id"            : "gameCanvas",
    // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

    "renderMode"    : 0,
    // "renderMode" sets the renderer type, only useful on web :
    //      0 - Automatically chosen by engine
    //      1 - Forced to use canvas renderer
    //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

    "engineDir"     : "frameworks/cocos2d-html5/",
    // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
    // but if you are using a single engine file, you can ignore it.

    "modules"       : ["cocos2d"],
    // "modules" defines which modules you will need in your game, it's useful only on web,
    // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
    // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

    "jsList"        : [
    ]
    // "jsList" sets the list of js files in your game.
 }
 *
 */

var MLExactFit = null;
var MLPolicy = null;
var MLEqualToFrame = null;
var MLResizeEvent = "MLResizeEvent";

var MLMark = 1

var ResetDesignResolution = function(){
	var fz = cc.view.getFrameSize();
	//var cz = cc.size(cc._canvas.width, cc._canvas.height);
	// 基本的缩放
    //适应最小边进行缩放，并且将最大边也铺满屏幕  (如果要实现UI与场景分别缩放不同的缩放倍数需要在LayerMgr里一个个的处理)   --merlin
    var scaleAll = 1;
    var designW = parseInt( 1334 / scaleAll );
    var designH = parseInt( 750 / scaleAll );
    var scaleW = fz.width / designW;
    var scaleH = fz.height / designH;
    if( scaleW > scaleH ){
        designW = parseInt( fz.width / scaleH );
    }
    else {
        designH = parseInt( fz.height / scaleW );
    }
    if (designW % 2 == 1)
        designW += 1;
    if (designH % 2 == 1)
        designH += 1;
	cc.view.setDesignResolutionSize(designW, designH, cc.ResolutionPolicy.SHOW_ALL);
    cc.log( "FrameSize: " + fz.width + "  " + fz.height + "   scaleW:" + scaleW + "  scaleH:" + scaleH+ "   designW:" + designW + "  designH:" + designH);
	//return;
	// 简单的无缩放阔大，但是宽度为奇数场景显示会模糊
	//cc.view.setDesignResolutionSize(fz.width, fz.height, cc.ResolutionPolicy.EXACT_FIT);
	//return;
	// 修正奇数的帧宽度，不会导致模糊
//	if (fz.width % 2 == 1)
//		fz.width += 1;
//
//	MLExactFit = MLExactFit || cc.ContentStrategy.extend({
//		apply: function (view, designedResolution) {
//			var containerW = view._frameSize.width;
//			if ((containerW % 2) == 1)
//				containerW = containerW + 1;
//			return this._buildResult(containerW, view._frameSize.height, containerW, view._frameSize.height, 1, 1);
//		}
//	});
//
//	MLEqualToFrame = MLEqualToFrame || cc.ContainerStrategy.extend({
//		apply: function (view) {
//			var containerW = view._frameSize.width;
//			if ((containerW % 2) == 1)
//				containerW = containerW + 1;
//			this._setupContainer(view, containerW, view._frameSize.height);
//		}
//	});
//
//	MLPolicy = MLPolicy || new cc.ResolutionPolicy(new MLEqualToFrame(), new MLExactFit());
//	//cc.log("SETToSIZE::" + fz.width + "," +  fz.height);
//	cc.view.setDesignResolutionSize(fz.width, fz.height, MLPolicy);
//	cc.eventManager.dispatchCustomEvent(MLResizeEvent, {w:fz.width, h:fz.height});
};

if (cc.sys.isNative) {
    var GameConfig = GameConfig || {};
    GameConfig.type = 6;
    GameConfig.storagePath = "update/";
    GameConfig.storageTempPath = "update_temp/";
    GameConfig.downloadPath = "web/";
    GameConfig.isWebMode = cc.sys.isMobile;     //暂时手机用web
    GameConfig.GATEWAY_URL = "http://interface.phone.jk3a.com/interface/";


    if (cc.sys.platform == cc.sys.ANDROID) {
        GameConfig.GATEWAY_URL = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getApplicationMetaData", "(Ljava/lang/String;)Ljava/lang/String;", "gateWay");
    }else if (cc.sys.os == cc.sys.OS_IOS) {
        // TODO add this
        //ret = jsb.reflection.callStaticMethod("AppController", "", text);
        GameConfig.GATEWAY_URL = jsb.reflection.callStaticMethod("AppController", "getConfig:","gateway");
        //GameConfig.GATEWAY_URL = "http://interface.ddqk.17wan7.com/interface/"
    }
    switch( GameConfig.type ){
        case 0: //0 本地    对应的appid要改成   applicationId "com.moloong.taiji"
            GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://192.168.51.69/phone/";
            break;
        case 1: //1 版署                        applicationId "org.cocos2d.XYJGame"
            GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://res.tjbs.mlwanwan.com/banshu/";
            break;
        case 2: //2 外网测试                        applicationId "com.morfirtech.taiji"
            // GameConfig.CDN_URL = "http://res.tjbs.mlwanwan.com/banshu/datarestssy/";
            GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://res.tjbs.morfirtech.com/sytest_version/datarestssy/";
            break;
        case 3: //外网Android
            break;
        case 4: //外网ios
            break;
		case 5: //外网bt
			GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://res.sybtts.morfirtech.com/sytest_version/datarestssy/bt/";
            // GameConfig.GATEWAY_URL = "http://interface.ddqk.17wan7.com/interface/";
			break;
        case 6: //本地bt
            GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://192.168.51.69/phonebt/";
            break;
        case 7:     //blank 测试空
            GameConfig.GATEWAY_URL = "";
            GameConfig.WEB_CDN_URL = GameConfig.CDN_URL = "http://res.sybtts.morfirtech.com/sytest_version/datarestssy/blank/";
            break;
    }

    GameConfig.engineVersion = "2018.10.01.01";   //version变了表示是重新安装
    // var pre = cc.sys.localStorage.getItem("engineVersion");
    // var preVersion = pre ? parseInt(pre) : 0;
    var hotUpdateStoragePath = cc.sys.localStorage.getItem("HotUpdateStoragePath");
    // if( preVersion < GameConfig.engineVersion ){
    //     //删除本地缓存与searchPath
    //     var localStorage = cc.sys.localStorage.getItem("storagePath");
    //     if( localStorage ){
    //         var storageArr = JSON.parse(localStorage);
    //         for( var i = 0; i < storageArr.length; i++ ){
    //             jsb.fileUtils.removeDirectory(storageArr[i]);
    //         }
    //     }
    //     cc.sys.localStorage.setItem("storagePath", JSON.stringify([]));
    //     cc.sys.localStorage.setItem("HotUpdateSearchPaths", JSON.stringify(jsb.fileUtils.getSearchPaths()));
    //     cc.sys.localStorage.setItem("engineVersion", GameConfig.engineVersion);
    // }
    // else if (hotUpdateSearchPaths) {
    if (hotUpdateStoragePath) {         //ios沙盒路径每次都会变  这里用相对路径拼凑   --merlin
        jsb.fileUtils.addSearchPath( jsb.fileUtils.getWritablePath() + GameConfig.storagePath, true );
    }

}
cc.game.onStart = function(){
    if(!cc.sys.isNative && document.getElementById("cocosLoading")) //If referenced loading.js, please remove it
        document.body.removeChild(document.getElementById("cocosLoading"));

    // Pass true to enable retina display, disabled by default to improve performance
    cc.view.enableRetina(false);
    // Adjust viewport meta
    cc.view.adjustViewPort(true);
    // Setup the resolution policy and design resolution size
    ResetDesignResolution();
    cc.log(cc.ENGINE_VERSION+"-------MEMEDAXIXIXIXI");
    // The game will be resized when browser size change
    cc.view.resizeWithBrowserSize(true);
    cc.view.setResizeCallback(function() {
    	//cc.log(" ResizeCallback canvas " + cc._canvas.width + "," + cc._canvas.height);
    	//cc.log(" ResizeCallback frameSize " + cc.view.getFrameSize().width + "," + cc.view.getFrameSize().height);
    	//cc.log(" ResizeCallback visibleSize" + cc.director.getVisibleSize().width + "," + cc.director.getVisibleSize().height);
    	//cc.log(" ResizeCallback winsize" + cc.winSize.width + "," + cc.winSize.height);
    	ResetDesignResolution();
    });
    //load resources
	cc.director.runScene(new GameRootScene());
//    cc.LoaderScene.preload(g_resources, function () {
//    	cc.director.runScene(new GameRootScene());
//    }, this);
};

cc.game.run();