﻿/**
 * 
 * 游戏的根容器，相当于一个boot程序。
 * （是唯一一个被Cocos系统预装载的Js文件）
 * （原则上这里就只负责加载脚本吧）
 * 
 * 会增加游戏具体类容的加载进度条
 * tyevlag
 */

//var WebSocket = WebSocket || window.WebSocket || window.MozWebSocket;

var GameRootScene = cc.Scene.extend({
	// 是否发布版
	bRelease:false,
	aEngineFiles:null,
	hotUpdatePanel:null,
	_jsList:null,
	_loadJsIndex:0,
    onEnter:function () {

        this._super();
		ChannelUtil.Init();		//先初始化 为了要监听sdk的init 应该问题不大 不确定一定来得及
		cc.director.setDisplayStats(GameConfig.type == 0);
		//背景层
		this.loadBg = new cc.Sprite("res/ui/image/load/bg.jpg");
		this.loadBg.x = cc.visibleRect.width * 0.5;
		this.loadBg.y = cc.visibleRect.height * 0.5;
		this.addChild(this.loadBg);

		this.InitLoadAnimation();

		this.hotUpdatePanel = new HotUpdatePanel();
		this.addChild(this.hotUpdatePanel);

		// this.TimeUpdate( this.LoadGameScript, this, 0, 1 );
		//this.scheduleOnce( this.LoadGameScript, 0 );
    },

	InitLoadAnimation:function(){
		var container = new cc.Node();
		this.loadBg.parts = container;
		this.loadBg.addChild(container);

		cc.spriteFrameCache.addSpriteFrames("res/ui/image/load/loadres.plist");

		 var logo = ChannelUtil.GetClientGameKey();
		 var LOGO_CONFIG = {
		 	HX : "buyaoicon",

		 }

		var logo = new cc.Sprite(LOGO_CONFIG[logo] || "#loadpart/logo.png");
		logo.x = this.loadBg.width * 0.5 + 12;
		logo.y = this.loadBg.height * 0.5 - 155;
		logo.setLocalZOrder(8);
		container.addChild(logo);

		var spArr = [];
		for( var i = 0; i < 10; i++ ){
			spArr.push(cc.spriteFrameCache.getSpriteFrame("logoeffect/0000" + i + ".png"));
		}
		var logogAnim = cc.repeatForever( cc.animate( new cc.Animation( spArr, 0.08 ) ) );
		var logoEff = new cc.Sprite();
		logoEff.runAction(logogAnim);
		logoEff.x = logo.width * 0.5;
		logoEff.y = logo.height * 0.5;
		logoEff.scale = 2;
		logoEff.setBlendFunc(cc.BlendFunc.ADDITIVE);
		logo.addChild(logoEff);

		var img = new cc.Sprite("#loadpart/1.png");
		img.x = this.loadBg.width * 0.5 - 190;
		img.y = this.loadBg.height * 0.5 + 17;
		img.setLocalZOrder(7);
		container.addChild(img);
		var move = cc.moveBy(3, 0, 6);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);

		img = new cc.Sprite("#loadpart/2.png");
		img.x = this.loadBg.width * 0.5 + 216;
		img.y = this.loadBg.height * 0.5 + 5;
		img.setLocalZOrder(6);
		container.addChild(img);
		move = cc.moveBy(2.5, 0, 6);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);

		img = new cc.Sprite("#loadpart/3.png");
		img.x = this.loadBg.width * 0.5 + 352;
		img.y = this.loadBg.height * 0.5 + 37;
		img.setLocalZOrder(5);
		container.addChild(img);
		move = cc.moveBy(3, 0, 10);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);
		img = new cc.Sprite("#loadpart/4.png");
		img.x = this.loadBg.width * 0.5 - 279;
		img.y = this.loadBg.height * 0.5 + 35;
		img.setLocalZOrder(4);
		container.addChild(img);
		move = cc.moveBy(3.5, 0, 8);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);
		img = new cc.Sprite("#loadpart/5.png");
		img.x = this.loadBg.width * 0.5 - 352;
		img.y = this.loadBg.height * 0.5 + 54;
		img.setLocalZOrder(3);
		container.addChild(img);
		move = cc.moveBy(3, 0, 8);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);
		img = new cc.Sprite("#loadpart/6.png");
		img.x = this.loadBg.width * 0.5 + 278;
		img.y = this.loadBg.height * 0.5 + 41;
		img.setLocalZOrder(2);
		container.addChild(img);
		move = cc.moveBy(3.5, 0, 10);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);
		img = new cc.Sprite("#loadpart/7.png");
		img.x = this.loadBg.width * 0.5 - 27;
		img.y = this.loadBg.height * 0.5 + 64;
		img.setLocalZOrder(1);
		container.addChild(img);
		move = cc.moveBy(4, 0, 10);
		var rp = cc.repeatForever( cc.sequence( move, move.reverse() ) );
		img.runAction(rp);
	},
    
    /*
     * 加载全部游戏脚本
     */
    LoadGameScript:function() {
    	cc.log( "[ScriptInit] Begin" )
		var self = this;
    	if (this.bRelease){
    		// 发布版本加载整个包
			self._jsList = ["gameclient.js"];
			self.scheduleUpdate();
    	} else {
    		// 调试版本
    		cc.loader.loadJson("src/engine/enginejs.json", function(erre, enginefiles) {
    			if (erre) {
					zz.Error("[ScriptInit] enginejs.json Parse Error! " + erre.toString());
    			} else {
    				self.aEngineFiles = enginefiles;
    				cc.loader.loadJson("src/game/gamejs.json", function(errg, gamefiles) {
    					if (errg) {
							zz.Error("[ScriptInit] gamejs.json Parse Error! " + errg.toString());
    					} else {
	    					var aarr = [];
	    					var curarr = self.aEngineFiles.jsfiles;
	    					var len = curarr.length;
	    					var i = 0;
	    					for (i = 0; i < len; ++i) {
	    						if (curarr[i].indexOf("src") == 0)
	    							aarr.push(curarr[i]);
	    					}
	    					cc.log("aarr length " + aarr.length);

	    					curarr = gamefiles.jsfiles;
	    					len = curarr.length;
	    					for (i = 0; i < len; ++i) {
	    						if (curarr[i].indexOf("src") == 0)
	    							aarr.push(curarr[i]);
	    					}
	    					cc.log("aarr length " + aarr.length);
							self.scheduleUpdate();
							self._jsList = aarr;
    					}
    				});
    			}
    		});
    	}
    },
    
    _LoadGameScript:function(scriptarr){
    	cc.loader.loadJs("", scriptarr, function(err) {
    		if (!err) {

    		} else {
    			zz.Error("[ScriptInit] Parse Error! " + err.toString());
    		}
    	} );
    },

	update:function(dt) {
		//做个分帧加载, 加载卡住时间太长了体验不太好
		var start = new Date().getTime();
		while( this._loadJsIndex < this._jsList.length ){
			this._LoadGameScript(this._jsList.slice(this._loadJsIndex, this._loadJsIndex + 50));
			this._loadJsIndex += 50;
			this.hotUpdatePanel.LoadProgress( this._loadJsIndex / this._jsList.length * 100);
			var end = new Date().getTime();
			if( this._loadJsIndex > this._jsList.length ){
				cc.log("[ScriptInit] LoadScript Complete.");
				this._jsList.length = 0;
				GameMain.GameStart(this);
			}
			else if( end - start > 100 )
				return;
		}
		GameMain.OnFrame(dt);
	}
});

