﻿/*
 * 
 * 多个动画对象集合类
 * 实现多个动画对象组合排序，播放统一的控制
 * tyevlag
 * 
 */
var MAnimationGroup = MAnimationGroup || DisplayNode.extend({
	oSceneObjRef:null,
	oBaseAnimObj:null,
	aPartList:null,
	
	bDispose:false,
	bCahce:false,
	
	nAlpha:1,
	defaultType:0,
	_isGray:false,
	
	ctor:function(){
		this._super();
		this.aPartList = [];
		this.oBaseAnimObj = new MAnimationObject();
		this.oBaseAnimObj.SetData(this);
		this.addChild(this.oBaseAnimObj);
        this.oBaseAnimObj.OnBound(this);
	},
	
	SetData:function(obj){
		if (this.bDispose)
			return;
		
		this.oSceneObjRef = obj;
	},
	
	Clear:function(){
		this.SetGray(false);
		this.RemoveAllBindPart();
		this.oBaseAnimObj.OnRecycle();
	},
	
	Dispose:function(){
		this.Clear();
		if (this.oBaseAnimObj != null){
			this.oBaseAnimObj.Dispose();
			this.oBaseAnimObj = null;
		}
		this.oSceneObjRef = null;
		this.bDispose = true;
		this.defaultType = 0;
	},

	OnRecycle:function(){
		this.Clear();
		this.bCahce = true;
	},

	OnRevert:function(){
		if (this.oBaseAnimObj != null && this.oBaseAnimObj.bDispose == false){
			this.oBaseAnimObj.OnRevert();
		}
		this.bCahce = false;
	},
	
	SetResUrlNoAction:function(animationUrl) {
		this.oBaseAnimObj.SetResUrlBase(animationUrl);
	},

	GetCurActionName:function(){
		return this.oBaseAnimObj.sCurActionName;
	},
	
	GetCurActionType:function(){
		return this.oBaseAnimObj.sCurActionName;
	},

    GetActionElaspsed:function(){
        return this.nRecordTime ? (TimerUtil.GetGameTimer() - this.nRecordTime) / 1000 : 0;
    },

	DoAction:function(actionkey, direction, defaulttype){

		if (this.bCahce || this.bDispose)
			return;
		this.defaultType = defaulttype;
		if (this.oBaseAnimObj.sResUrlBase == null || this.oBaseAnimObj.sResUrlBase == ""){
			return;
			//DebugTool.LogError("CAnimationGroup resUrlNoAction : " + "(== null)" + key);
		}

        var orderz = false;
        if(this.sActionkey != actionkey){
            this.sActionkey = actionkey;
            this.nRecordTime = TimerUtil.GetGameTimer();
            orderz = true;
        }

		var todir = direction < 0 ? this.oBaseAnimObj.nCurDirection : direction;
        orderz = (todir != this.oBaseAnimObj.nCurDirection) || orderz;
		this.oBaseAnimObj.DoAction(actionkey, direction, defaulttype);    //oBaseAnimObj 是一个动画对象 MAnimationObject  应该是当前的动作
		var len = this.aPartList.length;             //这个就是存 MAnimationObject 的
		for (var i = 0; i < len; i++){
			var part = this.aPartList[i];
			var partkey = actionkey;
			if ( part.actionChangeMap )
				partkey = part.actionChangeMap[actionkey];
			if ( !partkey ) {
				part.visible = false;
			}
			else {
				part.visible = true;
				part.DoAction(partkey, direction, 0);
			}
		}
		if (orderz){
			this.CheckPartZOrder();
		}
	},
	
	ForceDoAction:function(actionkey, direction){
		if (this.bCahce || this.bDispose)
			return;

        if(this.sActionkey != actionkey){
            this.sActionkey = actionkey;
            this.nRecordTime = TimerUtil.GetGameTimer();
        }

		var todir = direction < 0 ? this.oBaseAnimObj.nCurDirection : direction;
		var orderz = (todir != this.oBaseAnimObj.nCurDirection);
		this.oBaseAnimObj.ForceDoAction(actionkey, direction, this.defaultType);
		
		var len = this.aPartList.length;
		for (var i = 0; i < len; i++){
			var part = this.aPartList[i];
			var partkey = actionkey;
			if ( part.actionChangeMap )
				partkey = part.actionChangeMap[actionkey];
			if ( !partkey ) {
				part.ClearCCAnimation();
				part.visible = false;
			}
			else {
				part.visible = true;
				part.ForceDoAction(partkey, direction);
			}
		}
		//if (orderz){
			this.CheckPartZOrder();
		//}
	},
	
	SetAlpha:function(value){
		if (value < 0)
			value = 0;
		if (value > 1)
			value = 1;
		
		this.nAlpha = value;

		if (this.oBaseAnimObj != null){
			this.oBaseAnimObj.SetAlpha(this.nAlpha);
		}
		
		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			this.aPartList[i].SetAlpha(this.nAlpha);
		}
	},

	SetGray:function(value){
		if( this._isGray == value )
			return;
		this._isGray = value;

		if (this.oBaseAnimObj != null){
			this.oBaseAnimObj.SetGray(value);
		}

		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			this.aPartList[i].SetGray(value);
		}
	},
	
	SetDirection:function(direction){
		this.ForceDoAction(this.oBaseAnimObj.sCurActionName, direction);
	},
	
	CheckPartZOrder:function(){
		// this.aPartList.sort( function(a, b){
		// 	if ( a.aPartSortLevelArr == null && b.aPartSortLevelArr == null )
		// 		return 0;
        //
		// 	if ( a.aPartSortLevelArr == null && b.aPartSortLevelArr != null )
		// 		return -1;
        //
		// 	if ( a.aPartSortLevelArr != null && b.aPartSortLevelArr == null )
		// 		return 1;
        //
		// 	var objtar = self.oBaseAnimObj;
        //
		// 	var dir = self.oBaseAnimObj.nCurDirection;
		// 	var ordera = a.aPartSortLevelArr[dir];
		// 	var orderb = b.aPartSortLevelArr[dir];
		// 	if ( ordera > orderb )
		// 		return 1;
		// 	if ( ordera < orderb )
		// 		return;
        //
		// 	return 0;
		//
		// } );
		var dir = this.oBaseAnimObj.nCurDirection;
		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			var p = this.aPartList[i];
			this.reorderChild( p, p.aPartSortLevelArr ? p.aPartSortLevelArr[dir] : 1 + i );	//不需要像页游排序	没分方向都放人物上面就行了
		}

		this.reorderChild(this.oBaseAnimObj, 0);
	},

	/// <summary>
	/// 添加一个绑定动画挂件
	/// </summary>
	/// <param name="parturl">动画资源路径</param>
	/// <param name="sortlevel">8方向的排序等级</param>
	/// <param name="actionChangeMap">动作转换表，设置的动作会被转换成另外的动作</param>
	AddBindPart:function(parturl, sortlevelarr, actionChangeMap, offPos){
		if (this.bCahce || this.bDispose)
			return;
		
		if (parturl == null || parturl == "")
			return;

		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			if (this.aPartList[i].sResUrlBase == parturl){
				ToolBase.LogError("添加挂件重复！！！" + parturl);
				return;
			}
		}

		var part = new MAnimationObject();
//		if (externCheckFunc == null)
//			part.MbcAnimDir.IsPassive = true;
		part.SetResUrlBase(parturl);
		part.aPartSortLevelArr = sortlevelarr;
		part.SetAlpha(this.nAlpha);
		part.SetGray(this._isGray);
		part.actionChangeMap = actionChangeMap;
		this.aPartList.push(part);
		part.setLocalZOrder( part.aPartSortLevelArr ? part.aPartSortLevelArr[this.oBaseAnimObj.nCurDirection] : 1 + i );
		this.addChild(part);
        part.OnBound(this);
		if( offPos ){
			part.x = offPos.x;
			part.y = offPos.y;
		}
		
		// 这里更好的是从主动作当前播放位置开始播放
		// 但是由于使用的是cc官方类，不好控制，先全部统一播放吧
        //var action = (actionkey != null ? actionkey : this.oBaseAnimObj.sCurActionName);
        //this.ForceDoAction(action, this.oBaseAnimObj.nCurDirection);


        // find the action key.
        var partkey = this.oBaseAnimObj.sCurActionName;
        if (part.actionChangeMap) partkey = part.actionChangeMap[this.oBaseAnimObj.sCurActionName];

        if (!partkey) {
            part.ClearCCAnimation();
            part.visible = false;
        }else {
            part.visible = true;
            part.DoAction(partkey, this.oBaseAnimObj.nCurDirection);
        }
	},

	// 移除一个绑定动画挂件
	RemoveBindPart:function(parturl){
		if (parturl == null || parturl == "")
			return;

		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			if (this.aPartList[i].sResUrlBase == parturl){
				var delp = this.aPartList[i];
				this.aPartList.splice(i, 1);
				delp.Dispose();
				return;
			}
		}

		zz.Error("删除挂件没有找到！！！" + parturl);
	},

	RemoveAllBindPart:function(){
		var count = this.aPartList.length;
		var delp;
		for (var i = 0; i < count; ++i) {
			delp = this.aPartList[i];
			delp.Dispose();
		}

		this.aPartList.length = 0;
	},

	ShowAndHideBindPart:function (parturl, isShow) {
		if (parturl == null || parturl == "")
			return;

		var count = this.aPartList.length;
		for (var i = 0; i < count; ++i) {
			if (this.aPartList[i].sResUrlBase == parturl){
				var delp = this.aPartList[i];
				delp.visible = isShow;
				return;
			}
		}

		zz.Error("挂件没有找到！！！" + parturl);
	},
	
	// 动画播放完成回调，一般是切动作
	CallbackAnimationPlayEnd:function(){
		if (this.oSceneObjRef != null)
			this.oSceneObjRef.OnAnimationPlayEnd();
	},

    // this function might be useless
	CallbackResLoaded:function(animobj){
		if (animobj == this.oBaseAnimObj){
			this.ForceDoAction(this.oBaseAnimObj.sCurActionName, this.oBaseAnimObj.nCurDirection);
		} else {
			if (this.aPartList.indexOf(animobj) != -1){
				this.ForceDoAction(this.oBaseAnimObj.sCurActionName, this.oBaseAnimObj.nCurDirection);
			} else {
			}
		}
	},

	GetWidth:function(){
		if( this.oBaseAnimObj )
			return this.oBaseAnimObj.GetWidth();
		return 0;
	},

	GetHeight:function(){
		if( this.oBaseAnimObj )
			return this.oBaseAnimObj.GetHeight();
		return 0;
	},

	GetHitRect:function(){
		if( this.oBaseAnimObj )		//暂时不考虑挂件
			return this.oBaseAnimObj.GetHitRect();
		return cc.rect();
	}
});