﻿/**
 * 
 * 显示对象基础类，便于管理
 * （暂时场景用吧，UI也可以考虑继承或者单独写个基础类）
 * 1、实现Init, Dispose
 * 2、实现对象池接口
 * tyevlag
 * 
 */


// 根据cocos框架，这个应该更轻量一点，因为很多只是当做节点来使用
var DisplayNode = DisplayNode || cc.Node.extend({
	bDispose:false,
	ctor:function() {
		this._super();
		this.setName("DisplayNode");
		this.Init();
	},

	// 相当于构造函数
	Init:function() {
	},

	// 销毁对象方法
	Dispose:function(){
		this.cleanup();
		this.removeFromParent(true);
		this.bDispose = true;
	},

	// 从池从取出回调
	OnRevert:function(){
	},

	// 放入池中回调
	OnRecycle:function(){
	},

	// 异常调用检查
	InvaildCheck:function(s){
		if (this.bDispose)
			zz.Error("InvaildCheck error " + this.name + ":" + s);
		//ToolBase.Assert(this.bDispose == false, s);
	},

	// 官方对象池API接口
	unuse:function () {
		this.OnRecycle();
	},

	// 官方对象池API接口
	reuse:function () {
		this.OnRevert();
	},

	// 得到场景像素坐标，返回的y是正值
	GetPixPt:function(){
		return cc.p(this.x, -this.y);
	},

	// 得到场景像素坐标，pt的y是正值
	SetPixPt:function(pt){
		this.x = pt.x;
		this.y = -pt.y;
	}
});

//这个直接就是个Sprite了
var DisplayObject = DisplayObject || cc.Sprite.extend({
	bDispose:false,
	ctor:function() {
		this._super();
		this.setName("DisplayObject");
		this.Init();

	},
	
	// 相当于构造函数
	Init:function() {
	},
	
	// 销毁对象方法
	Dispose:function(){
		this.cleanup();
		this.removeFromParent(true);
		this.bDispose = true;
	},
	
	// 从池从取出回调
	OnRevert:function(){
	},
	
	// 放入池中回调
	OnRecycle:function(){
	},
	
	// 异常调用检查
	InvaildCheck:function(s){
		if (this.bDispose)
			zz.Error("InvaildCheck error " + this.name + ":" + s);
		//ToolBase.Assert(this.bDispose == false, s);
	},
	
	// 官方对象池API接口
	unuse: function () {
		this.OnRecycle();
	},
	
	// 官方对象池API接口
	reuse: function () {
		this.OnRevert();
	},
	
	// 得到场景像素坐标，返回的y是正值
	GetPixPt:function(){
		return cc.p(this.x, -this.y);
	},
	
	// 得到场景像素坐标，pt的y是正值
	SetPixPt:function(pt){
		this.x = pt.x;
		this.y = -pt.y;
	}
});


