﻿/*
 * 方向定义
 * 
 */

MDirection = {
	NUM:8,
	NONE:-1,
	UP:0,
	RIGHT_UP:1,
	RIGHT:2,
	RIGHT_DOWN:3,
	DOWN:4,
	LEFT_DOWN:5,
	LEFT:6,
	LEFT_UP:7,
		
	// 是否有效方向	
	IsValid:function(dir){
		if (dir == undefined)
			return false;
		return (dir >= 0 && dir <= 7);
	},

	// 得到反方向
	GetObDir:function(dir){
		return (dir + 4) % this.NUM;
	},

	// 得到方向差
	GetDirOff:function(dir1, dir2){
		var off = dir2 - dir1;
		if (off > 4){
			off -= this.NUM;
		}

		if (off < -4){
			off += this.NUM;
		}

		return off;
	},
		
	// 根据偏移得到新方向 
	GetOffDir:function(dir, off){
		if (dir == this.NONE)
			return this.NONE;

		off %= this.NUM;
		return (dir + off + this.NUM) % this.NUM;
	},
	
	// 根据两点计算方向
	GetDir:function(sx, sy, ex, ey){
		var xoff = sx - ex;
		var yoff = sy - ey;

		if ( xoff == 0 && yoff == 0 )
			return this.NONE;

		if ( xoff == 0 ){
			if ( yoff > 0 )
				return 0;
			else
				return 4;
		}
		else if ( xoff < 0 ){
			if ( yoff > 0 )
				return 1;
			else if ( yoff < 0 )
				return 3;
			else
				return 2;
		}
		else if ( xoff > 0 ){
			if ( yoff > 0 )
				return 7;
			else if ( yoff < 0 )
				return 5;
			else
				return 6;
		}

		return this.NONE;
	}
	
	
};

MDirection.HORSE_DIS = [{x:0,y:-230},{x:-250,y:-250},{x:-230,y:0},{x:-250,y:250},{x:0,y:230},{x:250,y:250},{x:230,y:0},{x:250,y:-250}];


