﻿/**
 * 与服务器网络通信模块
 * 使用socket进行通信
 * yq 2015年10月15日
 */


var WebSocket = WebSocket || window.WebSocket || window.MozWebSocket; 


var MessageMgr = cc.Class.extend( {
	
	_socket:null,  
	
	_ip:null,
	_port:null,
	
	ctor:function(){
//		this._super();
	},
	
	/**
	 * 连接服务器
	 * ip: IP地址
	 * port:端口号
	 * callbackTarget：服务器连接事件处理目标对象，至少需要实现以下方法 callbackTarget = { OnOpen:function(evt), // 连接成功 
	 *                                                     OnError:function( evt ), // 连接错误
	 *                                                     OnClose:function( evt ), // 连接关闭
	 *                                                     OnMeesage:function( evt ), // 接收到服务器消息   }
	 * */
	Connect:function( ip, port, callbackTarget ){
		this._ip = ip;
		this._port = port;
		this._socket = new WebSocket( "ws://" + ip + ":" + port + "/webgame" );
		
		// 设置接收数据为二进制数据类型
		this._socket.binaryType = 'arraybuffer';

		cc.log( "begin connect server ip:" + ip + ":" + port + "...");
		
		var self = this;
		
		// 连接成功事件
		this._socket.onopen = function(event){
			cc.log( "server connect open!" );
			callbackTarget.OnOpen( event );
		};
		
		// 连接错误
		this._socket.onerror = function(event){
//			cc.log( "server socket error!" );
//			cc.log( event );	
			callbackTarget.OnError( event );
		};
	
		// 连接关闭
		this._socket.onclose = function(event){
//			cc.log( "server socket close!" );
//			cc.log( event );
			callbackTarget.OnClose( event );
		};
		
		// 接收服务器消息
		this._socket.onmessage = function( event ){
			callbackTarget.OnMeesage( event );
		}
	},
	
	// 接收服务器消息
	OnRecv:function(event){
		var data = event.data;
		cc.log( "OnRecvMsg:" );
		cc.log( event );
	},
	
	Send:function( datas ){
		
		if(this._socket.readyState != WebSocket.OPEN)
			return false;
					
		this._socket.send( datas );
		return true;
	},
	
	
	Close:function(){
		if (this._socket){
			cc.log("server socket close...");  
			this._socket.close();  
			this._socket = null;  
		}
	}
} );



