﻿/**
 * Created by zj on 2015/10/19 0019.
 */

var ParticleColorArgb = cc.Class.extend({
    ctor:function(r, g, b, a){
        this.red = r;
        this.green = g;
        this.blue = b;
        this.alpha = a;
    },

    ToRgb:function(){
        var r = this.red;
        if (r < 0.0){
            r = 0.0;
        } else if (r > 1.0){
            r = 1.0;
        }
        var g = this.green;
        if (g < 0.0){
            g = 0.0;
        } else if (g > 1.0){
            g = 1.0;
        }
        var b = this.blue;
        if (b < 0.0){
            b = 0.0;
        } else if (b > 1.0){
            b = 1.0;
        }

        return parseInt(r * 255) << 16 | parseInt(g*255)<<8 | parseInt(b*255);
    },

    ToARgb:function(){
        var a = this.alpha;
        if (a < 0.0){
            a = 0.0;
        } else if (a > 1.0){
            a = 1.0;
        }
        var r = this.red;
        if (r < 0.0){
            r = 0.0;
        } else if (r > 1.0){
            r = 1.0;
        }
        var g = this.green;
        if (g < 0.0){
            g = 0.0;
        } else if (g > 1.0){
            g = 1.0;
        }
        var b = this.blue;
        if (b < 0.0){
            b = 0.0;
        } else if (b > 1.0){
            b = 1.0;
        }

        return parseInt(a*255) << 24 | parseInt(r * 255) << 16 | parseInt(g*255)<<8 | parseInt(b*255);
    },

    FromRgb:function(color){
        this.red = (color >> 16 & 0xff) / 255.0;
        this.green = (color >> 8 & 0xff) / 255.0;
        this.blue = (color & 0xff) / 255.0;
    },

    FromArgb:function(color){
        this.alpha = (color >> 24 & 0xff) / 255.0;
        this.red = (color >> 16 & 0xff) / 255.0;
        this.green = (color >> 8 & 0xff) / 255.0;
        this.blue = (color & 0xff) / 255.0;
    },

    CopyFrom:function(argb){
        this.red = argb.red;
        this.green = argb.green;
        this.blue = argb.blue;
        this.alpha = argb.alpha;
    }
});