﻿/**
 * Created by zj on 2015/10/19 0019.
 */

var ParticleVariance = cc.Class.extend({

    ctor:function(strData, valueType, lifeType){
        this._listVariance = new Array();
        this._varianceItem = new ParticleVarianceItem();
        this._iValueType = (valueType == undefined ? 1 : valueType);
        this._iLifeType = (lifeType == undefined ? 1 : lifeType);
        this.UpdateVariance(strData);
    },

    UpdateVariance:function(strData){
        this._listVariance.length = 0;
        var arr = strData.split(";");
        for ( var i=0; i < arr.length; ++i){
            var item = new ParticleVarianceItem();
            var tempArr = arr[i].split(",");
            // ����
            item.fLife = parseFloat(tempArr[0]);
            item.fLife = this._FormatLife(item.fLife);
            // ֵ
            item.x = parseFloat(tempArr[1]);
            item.x = this._FormatValue(item.x);

            if (tempArr.length > 2){
                item.y = parseFloat(tempArr[2]);
                item.y = this._FormatValue(item.y);
            }
            if (tempArr.length > 3){
                item.z = parseFloat(tempArr[3]);
                item.z = this._FormatValue(item.z);
            }
            if (tempArr.length > 4){
                item.w = parseFloat(tempArr[4]);
                item.w = this._FormatValue(item.w);
            }

            this._listVariance.push(item);
        }

        if (this._listVariance.length == 0){
            throw new Error("Error:this._listVariance length is zero!!!");
        }
    },

    _FormatLife:function(v){
        if (this._iLifeType == ParticleVariance.L_LIFEPER){
            v = v * 0.01;
        }else if (this._iLifeType == ParticleVariance.L_LIFETENPER){
            v = v * 0.1;
        }
        return v;
    },

    _FormatValue:function(v){
        if (this._iValueType == ParticleVariance.V_DEGREE){
            v = cc.degreesToRadians(v);
        }else if (this._iValueType == ParticleVariance.V_COLOR){
            v = v/ 255;
        }else if (this._iValueType == ParticleVariance.V_PERCENT){
            v = v * 0.01;
        }else if (this._iValueType == ParticleVariance.V_TENPERCENT){
            v = v * 0.1;
        }
        return v;
    },

    ToValue:function(life){
        return this.LifeToVariance(life).ToValue();
    },

    ToColor:function(life){
      return this.LifeToVariance(life).ToColor();
    },

    LifeToVariance:function(life){
        var next;
        var pre;
        for ( var i=0; i < this._listVariance.length; ++i){
            if (life <= this._listVariance[i].fLife){
                next = this._listVariance[i];
                if (i != 0){
                    pre = this._listVariance[i-1];
                }
                break;
            }
        }
        if (next == null){
            next = this._listVariance[this._listVariance.length-1];
        }
        if (pre == null){
            pre = next;
        }
        var rate = 0;
        if (next == pre){
            rate = 0;
        }else{
            if (this._iLifeType == ParticleVariance.L_LIFEPER){
                life = life > 1 ? 1 : life;
            }
            rate = (life - pre.fLife) / (next.fLife - pre.fLife);
        }

        if (isNaN(rate)){
            throw new Error("particleVariance--->rate NAN!!!!");
        }

        this._varianceItem.fLife = pre.fLife;
        this._varianceItem.x = (next.x - pre.x) * rate + pre.x;
        this._varianceItem.y = (next.y - pre.y) * rate + pre.y;
        this._varianceItem.z = (next.z - pre.z) * rate + pre.z;
        this._varianceItem.w = (next.w - pre.w) * rate + pre.w;
        return this._varianceItem;
    },

    GetList:function(){
        return this._listVariance;
    },

    InverseValue:function(){
        for (var i = 0; i < this._listVariance.length; ++i){
            var item = this._listVariance[i];
            item.x = -item.x;
            //item.y = -item.y;
            //item.z = -item.z;
            //item.w = -item.w;
        }
    }
});

// ֵ����

/** ����ֵ**/
ParticleVariance.V_NORMAL = 1;
/** �ٷֱ�**/
ParticleVariance.V_PERCENT = 2;
/** ��ɫ**/
ParticleVariance.V_COLOR = 3;
/** �Ƕ�**/
ParticleVariance.V_DEGREE = 4;
/** ʮ�ֱ�**/
ParticleVariance.V_TENPERCENT = 5;

// ��������
/** ����ʮ�ֱ�**/
ParticleVariance.L_LIFETENPER = 1;
/** ������ٷֱ�**/
ParticleVariance.L_LIFEPER = 2;
/** ����ֵ**/
ParticleVariance.L_NORMAL = 3;