/**
 * Created by zfs on 2017/9/29.
 */
var ParticleRain = ParticleRain || cc.Class.extend({
    _size:cc.winSize,
    _frameUrl:"public/weather/rain.png",
    _timer:0,
    _timeFps:0.3,
    _countRange:20,
    _scale:1,
    _scaleVar:0.5,
    _life:1,
    _lifeVar:1,
    _opacity:255,
    _opacityVar:50,
    _pool:null,
    _ranGap:1,
    _wind:0,
    _isPlaying:false,
    _verticleDistance:cc.winSize.height/3,
    ctor:function()
    {
        this._pool = new MCachePool();
        this._pool.SetSize(100);
    },
    //下雨
    PlayRain:function()
    {
        if(!this._isPlaying)
        {
            this._ResetProperties();
            this._SetFrameUrl("public/weather/rain.png");
            this._timer = TimerUtil.TimeUpdate(this._PlayRain,this,this._timeFps);
            this._isPlaying = true;
        }
    },
    //下雪
    PlaySnow:function()
    {
        if(!this._isPlaying)
        {
            this._ResetProperties();
            this._SetFrameUrl("public/weather/snow.png");
            this._timer = TimerUtil.TimeUpdate(this._PlayRain,this,this._timeFps);
            this._isPlaying = true;
        }
    },
    _PlayRain:function()
    {
        var pos = this._GetStartPos();
        for(var i = 0; i < this._countRange; i++)
        {
            this._InstantiateRain(pos);
        }
    },
    _InstantiateRain:function(pos)
    {
        var rain = this._pool.Gain();
        if(!rain)
        {
            rain = new DisplayObject();
            Mgr.sceneLayer.AddMiddle(rain);
        }
        else
        {
            rain.opacity = 255;
        }
        rain.initWithSpriteFrameName(this._frameUrl);
        rain.setLocalZOrder(1);
        rain.setPosition(pos[Math.floor(Math.random()*pos.length)]);
        rain.setRotation(-this._wind/2);
        rain.scale = this._scale - this._scaleVar*Math.random();
        rain.opacity = this._opacity - this._opacityVar*Math.random();
        var moveBy = cc.moveBy(this._life+Math.random()*this._lifeVar,this._wind,-this._size.height);
        var fadeOut = cc.fadeOut(0.1);
        var callfunc = cc.callFunc(function(target)
        {
            this._pool.Recycle(target);
        }.bind(this),this);
        var sequence = cc.sequence(moveBy,fadeOut,callfunc);
        rain.runAction(sequence);
    },
    StopPlay:function()
    {
        TimerUtil.ClearTimeUpdate(this._timer,this);
        this._isPlaying = false;
    },
    _SetFrameUrl:function(url)
    {
        this._frameUrl = url;
    },
    //风的大小，正负代表风向
    SetWind:function(wind)
    {
        this._wind = wind!=undefined?wind:this._wind;
    },
    //雨速
    SetLive:function(life,lifeVar)
    {
        this._life = life?life:this._life;
        this._lifeVar = lifeVar?lifeVar:this._lifeVar;
    },
    SetOpacityVar:function(opacityvar)
    {
        this._opacityVar = opacityvar?opacityvar:this._opacityVar;
    },
    SetScaleVar:function(scalevar)
    {
        this._scaleVar = scalevar?scalevar:this._scaleVar;
    },
    //每this._timeFps实例化的单位数量
    SetCountRange:function(countRange)
    {
        this._countRange = countRange?countRange:this._countRange;
    },
    _GetStartPos:function()
    {
        var gap = this._ranGap;
        var pos = [];
        var pPos = cc.p(Mgr.mainPlayer.x,Mgr.mainPlayer.y);
        var row = Math.floor(this._size.width*1.5/gap);
        for(var i = -1; i<row+1;i++)
        {
            //var p = cc.p(pPos.x-this._size.width*1.5/2+i*gap,pPos.y+this._size.height/2-this._verticleDistance*Math.random());
            var p = cc.p(pPos.x-this._size.width*1.5/2+i*gap,pPos.y+(1.5*this._size.height)*Math.random());
            pos.push(p);
        }
        return pos;
    },
    _ResetProperties:function()
    {
        this._timer = 0;
        this._timeFps = 0.3;
        this._countRange = 50;
        this._scale = 1;
        this._scaleVar = 0.5;
        this._life = 0.8;
        this._lifeVar = 0.5;
        this._opacity = 255;
        this._opacityVar = 50;
        this._ranGap = 1;
        this._wind = 20;
    },
});




