﻿/**
 * Created by zj on 2015/10/22 0022.
 */
var EmitterCircleProxy = cc.Class.extend({

    ctor:function(){
        this._oRadiusX = null;
        this._oRadiusY = null;
        this._listPoints = null;
    },

    SetInitData:function(config){
        this._oRadiusX = config.emitterCircleRadiusX;
        this._oRadiusY = config.emitterCircleRadiusY;
        if (config.emitterPointW > 0){
            this._listPoints = [];
            for ( var i=0; i < config.emitterPointW; ++i){
                this._listPoints.push(new cc.p(0 ,0));
            }
        }
    },

    InitParticle:function(p, life){
        var rx = this._oRadiusX.ToValue(life);
        var ry = this._oRadiusY.ToValue(life);
        rx = rx < 1 ? 1 : rx;
        ry = ry < 1 ? 1 : ry;

        var powA = rx * rx;
        var powB = ry * ry;

        var yOff = (Math.random() >= 0.5 ? 1 : -1);
        if (this._listPoints != null){
            var offAngle = 2 * Math.PI / this._listPoints.length;
            for ( var i=0; i < this._listPoints.length; ++i){
                var angle = offAngle * i;
                var x = this._GetX(powA, powB, angle);
                var y = this._GetY(powA, powB, x);
                x = this._IsPositive(angle, true) ? x : -x;
                y = this._IsPositive(angle, false) ? y : -y;
                this._listPoints[i].x = x;
                this._listPoints[i].y = y;
            }

            p.emitterOffX = this._listPoints[p.pointIndex].x;
            p.emitterOffY = this._listPoints[p.pointIndex].y;
        }else{
            p.emitterOffX = (Math.random() * 2  - 1 ) * rx;
            p.emitterOffY = this._GetY(powA, powB, p.emitterOffX) * yOff;
        }
    },

    _GetX:function(a, b, angle){
        return 1 / Math.sqrt((1 / a + Math.tan(angle) * Math.tan(angle) / b));
    },

    _GetY:function(a, b, x){
        return Math.sqrt((1 - (x * x) / a) * b);
    },

    _IsPositive:function(angle, isX){
        if (isX)
        {
            return (angle < Math.PI / 2 || angle > (Math.PI + Math.PI / 2));
        }
        else
        {
            return angle > Math.PI;
        }
    },

    GetNumPoint:function(){
        return this._listPoints != null ? this._listPoints.length : 1;
    }
})