﻿/**
 * 超大图类
 * 使用的是切片的图块，实际大小只比屏幕多出一些，目的是为了节约内存
 * yq tyevlag
 */

var LoadChunkInfo = LoadChunkInfo || {
	sPath:null,
	sKey:null,
	oImg:null,
};


var MMapChunk = MMapChunk || {

	// 加载控制锁，用于地图坐标还未知的情况下不进行加载地图
	bLoadChunkLock:true,

	// 图像实际总大小
	nBgWidth:0,
	nBgHeight:0,

	// 单一图块大小
	nChunkWidth:1024,
	nChunkHeight:1024,

	nPoolSize:200,
	oShowLayer:null,
	oTopLayer:null,

	// 资源路径
	sImgURL:null,
	sImgPath:null,

	//private Sprite[] chunks; // 保存图块的数组	
	nMaxWidthNum:0,// 最大列数	
	nMaxHeightNum:0, // 最大行数

	oChunkMaps:null, // 保存的地图块
	aImagesPool:[],

	aLoadList:[],
	oCurLoadInfo:null,

	oLastLookSceneRect:null,
	aNeedKeys:[],
	aDelChunkList:[],

	nCurMapResId:0,

	bDoRemove:false,

	nScreenH:0,
	nScreenW:0,

	XARR:[0, 1, 0, -1],
	YARR:[-1, 0, 1, 0],


	oFootLight:null,
	oFootLightDis:null,

	oThumbnails:null,
	oThumbnailsDis:null,

	oThumbnailsTopDis:null,
	nChunkRemoveTime:0,

	// 观察的目标位置
	oLookTarget:null,
	Init:function(showLayer, topLayer){
		this.oLastLookSceneRect = cc.RectZero();
		this.oChunkMaps = new HashMap();
		this.oShowLayer = showLayer;
		this.oShowLayer.setAnchorPoint(0, 0);
		this.oTopLayer = topLayer;
		//for (var i = 0; i < this.nPoolSize; ++i){
		//	this.RecyclePoolImage(this.GetPoolImage(cc.p(0, 0)));
		//}
		return this;
	},

	OnFrame:function(){
		if (this.oCurLoadInfo == null && this.aLoadList.length > 0){
			this.oCurLoadInfo = this.aLoadList.shift();
			this.LoadNext();
		}


		if (this.IsClear() || this.bLoadChunkLock)
			return;
		if (this.oLookTarget != null){
			var winw = ToolBase.GetWinWidth();
			var winh = ToolBase.GetWinHeight();
			
			var tmpX = this.oLookTarget.x;
			var tmpY = -this.oLookTarget.y;
			if (tmpX < (winw / 2))
				tmpX = (winw / 2);
			if (tmpX > (this.nBgWidth - (winw / 2)))
				tmpX = (this.nBgWidth - (winw / 2));

			if (tmpY < (winh / 2))
				tmpY = (winh / 2);
			if (tmpY > (this.nBgHeight - (winh / 2)))
				tmpY = (this.nBgHeight - (winh / 2));
			
			var pt = cc.p(this.oLookTarget.x - parseInt(winw / 2), -this.oLookTarget.y - parseInt(winh / 2));
			//pt = new Vector2(oLookTarget.localPosition.x - Screen.width / 2.0f, -oLookTarget.localPosition.y - Screen.height / 2.0f);
			
			// 场景中心坐标
			var pt = cc.p(tmpX, tmpY);
			
			var curT = ToolBase.GetTimerS();
			if (curT > this.nChunkRemoveTime){
				this.bDoRemove = true;
				this.nChunkRemoveTime = curT + 5.0;
			}

			if (this.oThumbnailsTopDis != null){
				var program = this.oThumbnailsTopDis.getShaderProgram();
				if (program != null){ 
					program.use();
					program.setUniformLocationWith2f(this.shaderUniformRefPos, this.oLookTarget.x, -this.oLookTarget.y);
					
					var rangv = (ToolBase.GetTimer() % 3000);
					if (rangv > 1500){
						rangv = 3000 - rangv;
					}
					program.setUniformLocationWith1f(this.shaderUniformRefRange, rangv / 3000.0);
				}
			}

			if (this.oFootLightDis != null){
				this.oFootLightDis.setPosition(this.oLookTarget.x, this.oLookTarget.y);
			}

			this.UpdateChunksMove(pt);
		}
	},

	ChangeMap:function(mapid, width, height, cw, ch){
		this.nCurMapResId = mapid;
		this.nBgWidth = width;
		this.nBgHeight = height;

		this.nChunkWidth = cw;
		this.nChunkHeight = ch;

		this.sImgURL = "map/" + this.nCurMapResId.toString() + "/chunks";

		this.oShowLayer.setScale( MGameDefine.MAP_SCALE );

		this.sImgPath = ToolBase.GetResURL(this.sImgURL);


		if (!this.CheckParam()){
			ToolBase.LogError( "CBigimage init error!!!" );
			return;
		}

		this.nMaxWidthNum = parseInt(this.nBgWidth / MGameDefine.MAP_SCALE / this.nChunkWidth);
		if (this.nBgWidth % this.nChunkWidth != 0)
			this.nMaxWidthNum++;

		this.nMaxHeightNum = parseInt(this.nBgHeight / MGameDefine.MAP_SCALE / this.nChunkHeight);
		if (this.nBgHeight % this.nChunkHeight != 0)
			this.nMaxHeightNum++;

		this.oLastLookSceneRect = cc.p(-this.nChunkWidth, -this.nChunkHeight);
		
		if ( EngineCost.engieType == EngineCost.TYPE_WEB )
			this.DrawBackground();
		
		if (this.oThumbnailsTopDis != null){
			var program = this.oThumbnailsTopDis.getShaderProgram();
			var wo = program.getUniformLocationForName("u_textw");
			var ho = program.getUniformLocationForName("u_texth");
			program.use();
			program.setUniformLocationWith1f(wo, this.nBgWidth);
			program.setUniformLocationWith1f(ho, this.nBgHeight);
		}
	},

	Clear:function(){
		this.nCurMapResId = 0;
		this.nBgWidth = 0;
		this.nBgHeight = 0;

		this.nChunkWidth = 0;
		this.nChunkHeight = 0;

		this.sImgPath = null;
		
		var self = this;
		this.oChunkMaps.EachValue(function(v){self.RecyclePoolImage(v);});
		this.oChunkMaps.Clear();

		this.aNeedKeys.length = 0;
		this.aDelChunkList.length = 0;
		this.oLastLookSceneRect = cc.RectZero()
		this.bLoadChunkLock = true;
		this.oThumbnails = null;
		this.oFootLight = null;

		if (this.oThumbnailsDis != null){
			this.oThumbnailsDis.removeFromParent(true);
			this.oThumbnailsDis = null;
		}
		if (this.oThumbnailsTopDis != null){
			this.oThumbnailsTopDis.removeFromParent(true);
			this.oThumbnailsTopDis = null;
		}
		if (this.oFootLightDis != null){
			this.oFootLightDis.removeFromParent(true);
			this.oFootLightDis = null;
		}

		this.oShowLayer.removeAllChildren(true);
	},

	IsClear:function(){
		return (this.nCurMapResId == 0);
	},

	CheckParam:function(){
		ToolBase.Log("MapChunk CheckParam:" + this.nBgWidth + " " + this.nBgHeight + " " + this.sImgPath + " " + this.nChunkWidth + " " + this.nChunkHeight);
		if (this.sImgPath == null || this.sImgPath == "")
			return false;

		if (this.nBgWidth <= 0 || this.nBgHeight <= 0 || this.nChunkWidth <= 0 || this.nChunkHeight <= 0 )
			return false;

		if (this.nChunkWidth > this.nBgWidth || this.nChunkHeight > this.nBgHeight )
			return false;

		return true;
	},
	
	SetLookTarget:function(tar){
		this.oLookTarget = tar;
	},

	GetPoolImage:function(pos, spr){
		var chunk = null;
//		if (this.aImagesPool.length > 0){
//			chunk = this.aImagesPool.pop();
//			//dis.gameObject.SetActive(true);
//			//dis.sprRenderer.sprite = null;
//		} else {
//			chunk = new DisplayObject();
//			chunk.setAnchorPoint(0, 1);
//			//dis.sprRenderer.material = ToolMaterial.getSpriteDefault();
//		}
		var chunkspr = new cc.Sprite(spr);
		chunkspr.setAnchorPoint(0, 1);
		chunkspr.isRefObj = false;
		chunkspr.setName("mapchunk-" + pos.toString());
		this.oShowLayer.addChild(chunkspr);
		chunkspr.x = pos.x;
		chunkspr.y = -pos.y;
		return chunkspr;
	},

	RecyclePoolImage:function(chunkimg){
//		if (this.aImagesPool.Count < this.nPoolSize){
//			//go.gameObject.SetActive(false);
//			chunkimg.removeAllChildren(true);
//			this.aImagesPool.push(chunkimg);
//		} else {
		// 还在下载中的
		if (chunkimg.isRefObj == true){
			chunkimg.bDispose = true;
		} else {
			chunkimg.refobj.bDispose = true;
			chunkimg.refobj = null;
			chunkimg.removeAllChildren(true);
			this.oShowLayer.removeChild(chunkimg);
		}
	},
	
	
	SetThumbnails:function(texture) {
		this.oThumbnails = texture;
	},

	SetFootLight:function(texture){
		this.oFootLight = texture;
	},

	DEFAULT_VERTEX_SHADER: 
		"attribute vec4 a_position; \n" 
		+ "attribute vec2 a_texCoord; \n" 
		+ "varying mediump vec2 v_texCoord; \n" 
		+ "void main() \n" 
		+ "{ \n" 
		+ "    gl_Position = (CC_PMatrix * CC_MVMatrix) * a_position;  \n" 
		+ "    v_texCoord = a_texCoord; \n" 
		+ "}", 

	GRAY_SCALE_FRAGMENT_SHADER: 
		"varying vec2 v_texCoord;   \n"
		+ "uniform vec2 u_midpos; 						\n"
		+ "uniform float u_range; 						\n"
		+ "uniform float u_textw;													\n"
		+ "uniform float u_texth;                                                                                                   \n"
		+ "void main(void)                                                                                                   \n"
		+ "{                                                                                                   \n"
		+ "                                                                                                 \n"
		+ "                                                                                                   \n"
		+ "                                                                                                   \n"
		+ "//vec4 sample = texture2D(CC_Texture0, v_texCoord.st);													\n"			
		+ "                                                                                                  \n"
		+ "                                                                                                          \n"
		+ "float disv = 0.4;                                                                                              \n"
		+ "float alph = 0.6;                                                                                               \n"
		+ "float range1 = 150.0;                                                                                                   \n"
		+ "float range2 = 300.0;                                                                                                  \n"
		+ "                                                                                                  \n"
		+ "                                                                                                  \n"
		+ "                                                                                                      \n"
		+ "vec2 pcur = vec2(v_texCoord.x * u_textw, v_texCoord.y * u_texth);                                                                                                 \n"
		+ "float checkdis = sqrt(disv * (pcur.x - u_midpos.x) * (pcur.x - u_midpos.x) + (pcur.y - u_midpos.y) * (pcur.y - u_midpos.y));                                                                                 \n"
		+ "                                                                                                          \n"
		+ "                                                                                                          \n"
		+ "// 还可以优化成不用缩放到全图可以（后面再搞了）                                                                                                        \n"
		+ "                                                                                                           \n"
		+ "float off = u_range * 50.0;                                                                                                           \n"
		+ "                                                                                                           \n"
		+ "                                                                                                \n"
		+ "                                                                                                   \n"
		+ "if (checkdis < range1)                                                                                                  \n"
		+ "     alph = 0.0;                                                                                             \n"
		+ "else if (checkdis < ((range2 - off) + range1))                                                                                                \n"
		+ "     alph = alph * ((checkdis - range1) / (range2 - off));                                                                                              \n"
		+ "//else       // test                                                                                         \n"
		+ "//   alph = 1.0;                                                                                   \n"
		+ "gl_FragColor = vec4(0, 0.0, 0, alph);	                                                                                                    \n"
		+ "                                                                                                   \n"
		+ "                                                                                                   \n"
		+ "}",
	
	
	shaderUniformRefPos:null,
	shaderUniformRefRange:null,
	DrawBackground:function() {
		if (this.IsClear())
			return;

		if (this.oThumbnails != null){
			this.oThumbnailsDis = new cc.Sprite(this.oThumbnails);
			this.oThumbnailsDis.setAnchorPoint(0, 1);
			this.oThumbnailsDis.setLocalZOrder(-1);
			this.oShowLayer.addChild(this.oThumbnailsDis, -2);
			
			this.oThumbnailsTopDis = new cc.Sprite(this.oThumbnails);
			this.oThumbnailsTopDis.setAnchorPoint(0, 1);
			this.oThumbnailsTopDis.setLocalZOrder(999999);
			this.oTopLayer.addChild(this.oThumbnailsTopDis, 999999);
			
			var program = cc.shaderCache.getProgram("MapHoleShader");
			if(!program){ 
				program = new cc.GLProgram(); 
				program.initWithVertexShaderByteArray(this.DEFAULT_VERTEX_SHADER, this.GRAY_SCALE_FRAGMENT_SHADER); 
				program.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
				program.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
				program.link();
				program.updateUniforms();
				cc.shaderCache.addProgram(program, "MapHoleShader");

				this.shaderUniformRefPos = program.getUniformLocationForName("u_midpos");
				this.shaderUniformRefRange = program.getUniformLocationForName("u_range");
			} 
			
			var th_w = this.oThumbnails.width;
			var th_h = this.oThumbnails.height;
			var sx = this.nBgWidth / th_w;
			var sy = this.nBgHeight / th_h;
			
			//this.oThumbnailsTopDis.setShaderProgram(program);

			this.oThumbnailsTopDis.setScaleX(sx);
			this.oThumbnailsTopDis.setScaleY(sy);
			
			this.oThumbnailsDis.setScaleX(sx);
			this.oThumbnailsDis.setScaleY(sy);
		}

		if (this.oFootLight != null){
			this.oFootLightDis = new cc.Sprite(this.oFootLight);
			this.oFootLightDis.setAnchorPoint(0.5, 0.5);
			this.oFootLightDis.setLocalZOrder(1000);
			//this.oFootLightDis.setBlendFunc(cc.SRC_ALPHA, cc.ONE);
			//this.oFootLightDis.setBlendFunc(cc.SRC_ALPHA, cc.ONE_MINUS_CONSTANT_ALPHA);
			this.oFootLightDis.setBlendFunc(cc.DST_COLOR, cc.SRC_ALPHA);
			//this.oFootLightDis.setBlendFunc(cc.DST_COLOR, cc.SRC_COLOR);
			//this.oFootLightDis.setBlendFunc(cc.DST_COLOR, cc.ONE);
			//this.oFootLightDis.setBlendFunc(cc.ONE_MINUS_DST_COLOR, cc.ONE);
			this.oShowLayer.addChild(this.oFootLightDis, 1000);
		}
	},

	textcurid1:0,
	textcurid2:0,
	TestChangeFunc:function(){
		var arr = [cc.ONE,
		cc.ZERO,
		cc.SRC_ALPHA ,
		cc.SRC_ALPHA_SATURATE,
		cc.SRC_COLOR,
		cc.DST_ALPHA,
		cc.DST_COLOR,
		cc.ONE_MINUS_SRC_ALPHA ,
		cc.ONE_MINUS_SRC_COLOR,
		cc.ONE_MINUS_DST_ALPHA,
		cc.ONE_MINUS_DST_COLOR,
		cc.ONE_MINUS_CONSTANT_ALPHA,
		cc.ONE_MINUS_CONSTANT_COLOR,
		]

		this.oFootLightDis.setBlendFunc(arr[this.textcurid1], arr[this.textcurid2]);

		this.textcurid1++;
		if (this.textcurid1 >= arr.length){

			this.textcurid1 = 0;
			this.textcurid2++;
			if (this.textcurid2 >= arr.length){
				this.textcurid2 = 0;
			}
		}

	},


//	public onAssetResError onChunckLoadErr()
//	{
//		return delegate(string err)
//		{
//			Debug.LogError(err);
//		};        
//	}

	// 蚊香型遍历下载图块
	SnakeTras:function(curx, cury, ww, hh, rect){
		curx = parseInt(curx);
		cury = parseInt(cury);
		var count = 0;
		var flag = 1;
		var flagj = 1;
		var dir = 0;
		var len = (ww > hh) ? ww : hh;
		len = len * len;

		if (curx >= 0 && cury >= 0 && curx < this.nMaxWidthNum && cury <= this.nMaxHeightNum)
			this.aNeedKeys.push(curx * 10000 + cury);

		for (var i = 0; i < len; ++i){
			curx += this.XARR[dir];
			cury += this.YARR[dir];

			flagj--;

			if (flagj == 0){
				dir = ((dir + 1) % 4);
				count++;
				if (count == 2){
					count = 0;
					flag++;
				}
				flagj = flag;
			}

			if (curx < 0 || cury < 0 || curx >= this.nMaxWidthNum || cury >= this.nMaxHeightNum || !cc.rectContainsPoint(rect, cc.p(curx, cury))){
				continue;
			} else {
				this.aNeedKeys.push(curx * 10000 + cury);
			}
		}
	},

	UpdateChunksMove:function(lookScenePt){
		var screenChange = false;

		var winw = ToolBase.GetWinWidth();
		var winh = ToolBase.GetWinHeight();
		
		if (this.nScreenH != winh || this.nScreenW != winw){
			this.nScreenH = winh;
			this.nScreenW = winw;
			screenChange = true;
		}

		var realW = MGameDefine.MAP_SCALE * this.nChunkWidth;
		var realH = MGameDefine.MAP_SCALE * this.nChunkHeight;

		//超出屏幕了0.25Chunk提前下载
		var minX = parseInt( ( lookScenePt.x - cc.winSize.width * 0.5 - 0.25 * this.nChunkWidth) / realW );
		var maxX = parseInt( ( lookScenePt.x + cc.winSize.width * 0.5 + 0.25 * this.nChunkWidth) / realW );
		var minY = parseInt( ( lookScenePt.y - cc.winSize.height * 0.5 - 0.25 * this.nChunkHeight ) / realH );
		var maxY = parseInt( ( lookScenePt.y + cc.winSize.height * 0.5 + 0.25 * this.nChunkHeight ) / realH );

		var rect = cc.rect(minX, minY, maxX - minX, maxY - minY);

		var bout = !cc.rectEqualToRect(rect, this.oLastLookSceneRect);
		//Debug.Log("lastLookPt : " + lastLookPt.ToString() + " lookScenePt:" + lookScenePt);
		if (screenChange || bout){
			this.oLastLookSceneRect = rect;
			var len = 0;
			var curScreenNeedNumW = rect.width + 2;		// 蚊香遍历固定方向 +2才能涵盖完
			var curScreenNeedNumH = rect.height + 2;
			var lookmidx = parseInt(lookScenePt.x / realW);
			var lookmidy = parseInt(lookScenePt.y / realH);

			this.SnakeTras(lookmidx, lookmidy, curScreenNeedNumW, curScreenNeedNumH, rect);
			if (this.bDoRemove){
				this.bDoRemove = false;
				var keys = this.oChunkMaps.Keys();
				len = keys.length;
				var thex = 0;
				var they = 0;
				var thecheckx = curScreenNeedNumW - 2;// + OFF * 2 + 4;		这里是半径了	节约内存 先不做缓存
				var thechecky = curScreenNeedNumH - 1;// + OFF * 2 + 4;
				for (var uu = 0; uu < len; ++uu){
					thex = parseInt(keys[uu] / 10000);
					they = (keys[uu] % 10000);
					thex = Math.abs(lookmidx - thex);
					they = Math.abs(lookmidy - they);

					if (thex > thecheckx || they > thechecky){
						this.aDelChunkList.push(keys[uu]);
					}
				}

				len = this.aDelChunkList.length;
				var thek = 0;
				for (var yy = 0; yy < len; ++yy) {
					thek = this.aDelChunkList[yy];
//					zz.Log("回收图块...." + thek);
					this.RecyclePoolImage(this.oChunkMaps.Get(thek));
					this.oChunkMaps.Remove(thek);
				}
				this.aDelChunkList.length = 0;
			}

			len = this.aNeedKeys.length;
			var chunkimg = null;
			var assetkey = null;
			var assetname = null;

			for (var i = 0; i < len; ++i){
				var key = this.aNeedKeys[i];
				if (!this.oChunkMaps.ContainsKey(key)) {
					var xx = parseInt(key / 10000);
					var yy = (key % 10000);
					
					assetkey = "ml_" + xx.toString() + "_" + yy.toString() + ".jpg";
					assetname = this.sImgPath + "/" + assetkey;

					// 因为cocos是下完才创建Sprite对象，所以先创建一个资源持有对象
					var resRefObj = {isRefObj:true, mapid:this.nCurMapResId, mapkey:key, bDispose:false,
						CallLoadOneChunk:function(ssspr, aaargs){
						MMapChunk.OnChunkLoaded.call(MMapChunk, ssspr, aaargs[0]);
						}};
					this.oChunkMaps.Put(key, resRefObj);
					this.LoadOneChunk(assetname, resRefObj);
				}
			}

			this.aNeedKeys.length = 0;
		}
	},

	LoadOneChunk:function(chunkURL, refobj){
		//cc.log( chunkURL + "!download!" );
		// 开始异步加载图片
		LoadMgr.LoadImage( chunkURL, refobj, LoadPriority_Common, {complete:refobj.CallLoadOneChunk, completeParam:[refobj]} )
	},

	OnChunkLoaded:function(spr, resRefObj){
		if (resRefObj == null)
			return;
		
		if (resRefObj.bDispose == true){
			return;
		}
		//ToolBase.Log("OnChunkLoaded  mapid:" + mapid + "spr:" + spr + " key:" + key + " chunkimg:" + chunkimg + " chunkimg.key:" + chunkimg.key);
		if (spr == null){
			resRefObj.bDispose = true;
			return;
		}
		
		if (resRefObj.mapid != this.nCurMapResId){
			resRefObj.bDispose = true;
			return;
		}

		if (this.IsClear()){
			resRefObj.bDispose = true;
			return;
		}

		var getRefObj = this.oChunkMaps.Get(resRefObj.mapkey);
		if (getRefObj.isRefObj){
			if (getRefObj == resRefObj){
				var xx = parseInt(getRefObj.mapkey / 10000);
				var yy = (getRefObj.mapkey % 10000);
				var chunkimg = this.GetPoolImage(cc.p(xx * this.nChunkWidth, yy * this.nChunkHeight), spr);
				chunkimg.refobj = resRefObj;
				this.oChunkMaps.Put(getRefObj.mapkey, chunkimg);
			} else {
				resRefObj.bDispose = true;
				ToolBase.LogError(" OnChunkLoaded but getRefObj != resRefObj");
			}
		} else {
			ToolBase.LogError(" OnChunkLoaded but resRefObj.isRefObj == false");
		}
			//chunkimg.setTexture(spr);
			//img.sprRenderer.sprite = Sprite.Create(texture, new Rect(0, 0, texture.width, texture.height), new Vector2(0, 1), 1, 0, SpriteMeshType.FullRect);                 
	},
	
	LoadNext:function(){
		//StartCoroutine(loadCoro());
	},

	// 显示chunk格子方式
	UpdateChunks:function( curWPos ){
		var winSize = cc.winSize;

		var self = this;

//		cc.log( "wx:" + curWPos.x + " wy:" + curWPos.y );

		var startX = Math.floor( Math.abs( ( curWPos.x / this._chunk_Width ) ) );

		var startY = ( ( curWPos.y - winSize.height ) / this._chunk_Height );
		startY = Math.floor( startY );
		if ( startY < 0 )
			startY = 0;

		// 起始坐标+屏幕大小
		var endX = startX + Math.ceil( winSize.width / this._chunk_Width );
		if ( curWPos.x % this._chunk_Width != 0 )
			endX += 1;

		// 起始坐标+屏幕大小
		var endY = startY + Math.ceil( winSize.height / this._chunk_Height );
		if ( ( ( curWPos.y - winSize.height ) % this._chunk_Height ) != 0  )
			endY += 1;

//		cc.log( "startX:" + startX + " startY:" + startY + " endX:" + endX + " endY:" + endY );

		// 设置需要显示的chunk
		for( var y = startY; y < endY; y++ ){
			for ( var x = startX; x < endX; x++ ){

				var idx = y * this._ck_widthMax + x;

				var chunk = this._chunks[ idx ];
				if ( chunk == null ){

					if ( !this._chunkloadings[idx] ){

						this._chunkloadings[idx] = true;

						var chunkURL = this._url + "/ml_" + x + "_" + y + ".jpg";
						var imgLoader = new ImageLoader();

						//cc.log( chunkURL + "!download!" );

						// 开始异步加载图片
						imgLoader.Download(chunkURL, function(img, args ){

							var tx = args[0];
							var ty = args[1]
							var index = ty * self._ck_widthMax + tx ;

							var chunk = new cc.Sprite( img );							

							chunk.attr({
								x:tx * self._chunk_Width,
								y:-ty * self._chunk_Height,
							});

							self.addChild( chunk, 1, index );

							self._chunks[ index ] = chunk;

							chunk.setAnchorPoint( 0, 1 );
							//cc.log( args[2] + ">>bigimg ok x:" + chunk.x + " y:" + chunk.y );

						}, null, null, [x, y, chunkURL] ); // <-------注意这里有传递参数x,y,chunkURL
					}
				}
			}
		}
	}
};
