﻿/*
 * 地图工具类 
 * tyevlag
 */

var ToolMap = {
		dirArrx:[0, 1, 1, 1, 0, -1, -1, -1],
		dirArry:[-1, -1, 0, 1, 1, 1, 0, -1],
		
		// 这里不能换定义的变量，直接写常数了
		dgw:50,
		dgh:50,
		dgwhalf:25,
		dghhalf:25,
		
		// 像素坐标转换为格子坐标
		PixPt2GridPt:function(x, y){
			return cc.p(parseInt(x / this.dgw), parseInt(y / this.dgh));
		},

		// 格子坐标转换为像素坐标
		GridPt2PixPt:function(x, y, ismiddle){
			if (ismiddle == true)
				return cc.p((x * this.dgw) + this.dgwhalf, (y * this.dgh) + this.dghhalf);
			
			return cc.p((x * this.dgw), (y * this.dgh));
		},
		
		// 批量转换格子坐标到像素坐标
		// 注意：这个函数是数组01，不是XY
		ArrayGridPt2PixPt:function(list){
			var ret = [];
			for ( var i = 0; i < list.length; i++ ){
				var u = list[i];
				ret.push(new Position(u[0] * this.dgw + this.dgwhalf, (u[1] * this.dgh + this.dghhalf)));
			}
			return ret;
		},
		
		
		// 格子坐标转换为消息POS
		GridPt2Pos:function(gdpt){
// Position ret = new Position();
// ret.x = (short)(gdpt.x * dgw);
// ret.y = (short)(gdpt.y * dgh);
// ret.x += (short)(dgw / 2);
// ret.y += (short)(dgh / 2);
// return ret;
		},

		// 消息POS转换为格子坐标
		Pos2GridPt:function(pos){
			return cc.p(parseInt(pos.x / this.dgw), parseInt(pos.y / this.dgh));
		},
		
		// 根据起点计算指定放向指定步数的终点
		CalcEndPtByDir:function(ptb, dir, step){
			return cc.p(ptb.x + this.dirArrx[dir] * step, ptb.y + this.dirArry[dir] * step);
		},
		
		// 点线性插值
		LerpPoint:function(start, end, per){
			return cc.p(start.x + (end.x - start.x) * per, start.y + (end.y - start.y) * per);
		},		
		
		// 根据终点计算指定方向指定步数的起点
		CalcBeginPtByDir:function(pte, dir, step){
			var ret = cc.p(pte.x, pte.y);
			dir = MDirection.GetObDir(dir);
			ret.x += this.dirArrx[dir] * step;
			ret.y += this.dirArry[dir] * step;
			return ret;
		},
		
		// 两点角度获取方向
		CalcDirByAngle:function( sx, sy, ex, ey ){
			var angle = this.GetAngle( sx, sy, ex, ey );
			angle += 180;

			if ( angle >= 337.5 || angle < 22.5 )
				return 6; 
			else if ( angle > 22.5 && angle < 67.5 )
				return 5;
			else if ( angle > 67.5 && angle < 112.5 )
				return 4;
			else if ( angle > 112.5 && angle < 157.5 )
				return 3;
			else if ( angle > 157.5 && angle < 202.5 )
				return 2;
			else if ( angle > 202.5 && angle < 247.5 )
				return 1;
			else if ( angle > 247.5 && angle < 292.5 )
				return 0;
			else if ( angle > 292.5 && angle < 337.5 )
				return 7;
		},

		// 获取两点间的角度
		GetAngle:function(x1 , y1 , x2 , y2 ){
			return Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;;
		},

		// 计算方向（带斜率）
		CalcDirSlant:function(x1, y1, x2, y2){
			var pn = arguments.length;
			if (pn == 2) {
				var pt1 = x1;
				var pt2 = y1;
				x1 = parseInt(pt1.x);
				y1 = parseInt(pt1.y);
				x2 = parseInt(pt2.x);
				y2 = parseInt(pt2.y);
			} else if(pn == 4) { 
				;
			}
			else
				return MDirection.NONE;
			
			if (y1 == y2){
				if (x1 < x2)
					return MDirection.RIGHT;
				else if (x1 > x2)
					return MDirection.LEFT;
				else
					return MDirection.NONE;
			}
			else if (x1 == x2){
				if (y1 < y2)
					return MDirection.DOWN;
				else
					return MDirection.UP;
			}
			else
			{
				var angle = Math.atan(parseFloat((y2 - y1) / -(x2 - x1)));
				var angle22d5 = Math.PI / 8;
				var angle67d5 = Math.PI / 2 - angle22d5;

				if (angle > -angle22d5 && angle <= angle22d5){
					if (x1 < x2)
						return MDirection.RIGHT;
					else
						return MDirection.LEFT;
				}
				else if (angle > angle22d5 && angle <= angle67d5){
					if (x1 < x2)
						return MDirection.RIGHT_UP;
					else
						return MDirection.LEFT_DOWN;
				}
				else if (angle > -angle67d5 && angle <= -angle22d5){
					if (x1 < x2)
						return MDirection.RIGHT_DOWN;
					else
						return MDirection.LEFT_UP;
				}
				else{
					if (y1 < y2)
						return MDirection.DOWN;
					else
						return MDirection.UP;
				}
			}
		},
		
		// 计算两点间的角度（弧度）
		GetAngle:function(x1, y1, x2, y2){
			return Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
		},
		
		// 计算两点间的角度（角度）
		GetAngle360:function(x1, y1, x2, y2){
			var ret = this.GetAngle(x1, y1, x2, y2);
			ret = (ret >= 0 && ret <= 180) ? ret += 90 : ( ( ret < 0 && ret >= -90 ) ? ret += 90 : ret += 450 );
			return ret;
		},

		// 是否在a,b两值之间
		AngleBetween:function(val, min, max){
			return (val > min && val <= max);
		},
		
		// 计算8区域方向，每个方向45度
		CalcDirEight:function(x1, y1, x2, y2){
			var dirAngle = this.GetAngle360(x1, y1, x2, y2);
			var moveDir = 0;
			if ( angleBetween( dirAngle, 22.5, 22.5 + 45 ) )
				moveDir = MDirection.RIGHT_UP;
			else if ( angleBetween( dirAngle, 67.5, 67.5 + 45 ) )
				moveDir = MDirection.RIGHT;
			else if ( angleBetween( dirAngle, 112.5, 112.5 + 45 ) )
				moveDir = MDirection.RIGHT_DOWN;
			else if ( angleBetween( dirAngle, 157.5, 157.5 + 45 ) )
				moveDir = MDirection.DOWN;
			else if ( angleBetween( dirAngle, 202.5, 202.5 + 45 ) )
				moveDir = MDirection.LEFT_DOWN;
			else if ( angleBetween( dirAngle, 247.5, 247.5 + 45 ) )
				moveDir = MDirection.LEFT;
			else if ( angleBetween( dirAngle, 292.5, 292.5 + 45 ) )
				moveDir = MDirection.LEFT_UP;
			else
				moveDir = MDirection.UP;
			return moveDir;
		},

		// 计算两点方向
		CalcDir:function(pt1, pt2){
			if (pt1.x = pt2.x && pt1.y == pt2.y) {
				return MDirection.NONE;
			} else {
				if (pt1.y < pt2.y) {
					if (pt1.x < pt2.x)
						return MDirection.RIGHT_DOWN;
					else if (pt1.x > pt2.x)
						return MDirection.LEFT_DOWN;
					else
						return MDirection.DOWN;
				}
				else if (pt1.y > pt2.y) {
					if (pt1.x < pt2.x)
						return MDirection.RIGHT_UP;
					else if (pt1.x > pt2.x)
						return MDirection.LEFT_UP;
					else
						return MDirection.UP;
				}
				else {
					if (pt1.x < pt2.x)
						return MDirection.RIGHT;
					else
						return MDirection.LEFT;
				}
			}
		},
		
		// 根据路径和终点算出起点
		CalcBeginPtByPath:function(path, endpt) {
			var ret = cc.p(endpt.x, endpt.y);
			for (var i = path.length - 1; i >= 0; i--) {
				var magic = (path[i] & 0x0ff);
				var dir = MDirection.GetObDir(magic >> 5);
				var len = (magic & 0x1f);
				ret.x += this.dirArrx[dir] * len;
				ret.y += this.dirArry[dir] * len;
			}
			return ret;
		},

		// 根据方向算出附近的点
		CalcNearPt:function(pt, dir, type, len){
			if (MDirection.IsValid(dir) == false)
				dir = MDirection.UP;
			len = len || 1;
			var ret = cc.p(pt.x, pt.y);
			for (var i = 0; i < MDirection.NUM; i++){
				ret.x = pt.x + this.dirArrx[(i + dir) % MDirection.NUM] * len;
				ret.y = pt.y + this.dirArry[(i + dir) % MDirection.NUM] * len;

				if (type == 0)
					break;
			}

			return ret;
		},
		
		// 节点路径转换为方向路径  传入值为像素  返回值也是像素
		PathToWay:function(list, beginpt)
		{
			var ret = [];
			beginpt = this.Pos2GridPt( beginpt );
			var startx = parseInt(beginpt.x);
			var starty = parseInt(beginpt.y);

			while (list.length > 0)
			{
				var vec = list.shift();
				if (vec < 0)
					return null;

				var dir = vec >> 5;
				var len = vec & 0x1f;

				startx += this.dirArrx[dir] * len;
				starty += this.dirArry[dir] * len;
				ret.push(this.GridPt2PixPt(startx, starty, true));
			}

			if (ret.length == 0)
				return null;

			return ret;
		},

		// 计算两点距离(圆)
		CalcDistance:function(a, b){
			return Math.sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
		},

		// 计算两点距离（方形最大距离）
		CalcDistanceRect:function(a, b){
			return Math.max(Math.abs(a.x - b.x), Math.abs(a.y - b.y));
		},


		// 计算单步路径
		CalcStepPath:function(list, beginpt){
			if (list == null)
				return null;

			if (list.length > 1)
			{
				var dir1 = this.CalcDir(beginpt, list[0]);
				var dir2 = this.CalcDir(list[0], list[1]);
				if (dir1 == dir2) {
					list.splice(2, list.length - 2);
				} else {
					list.splice(1, list.length - 1);
				}
			}
			return list;
		}
		
		
		
};

