﻿/**
 * 基础UI类
 * 负责解析UI文件最基础的数据部分
 * yq 2015年9月26日
 */

var BaseUI = cc.Scale9Sprite.extend({
	
	_name:"",
	_bgImgName:null,
	_imageType:0,
	
	_uiWidth:0,
	_uiHeight:0,
	
	_touchEvent:null,
	
	_startDownPos:null,
	
	_childList:[],
	
	ctor:function(){
		cc.log( "BaseUI:ctor" );
		this._super();
		this.setAnchorPoint(0, 0);
//		var self = this;
//		cc.Sprite.prototype.ctor.call(self);
	},
	
	/**获取UI面板大小*/
	GetSize:function(){
	
		return this.getPreferredSize();
//		var size = this.getContentSize();
//		return {
//			width: size.width * this.getScaleX(),
//			height: size.height * this.getScaleY(),
//		};
	},
	
	// 设置面板透明值
//	setOpacityTemp:function( val ){
//		if ( this._scale9Image == null )
//			return;
//		
//		for ( var i = 0; i < this._scale9Image._children.length; i++ ){
//			this._scale9Image._children[i].setOpacity( val );
//		}
//		
////		cc.Scale9Sprite.prototype.setOpacity.call(this, val);
//	},
	
	/**设置UI面板大小*/
	SetSize:function( w, h ){
		this.setPreferredSize( cc.size(w, h) );
	},
	
	ParseXML:function( element ){
		
		for ( var i = 0; i < element.attributes.length; i++ ){
			var att = element.attributes[i];
			
			if ( att.nodeName == "id" )
				this._name = att.nodeValue; 
			else if ( att.nodeName == "x" )
				this.x = parseInt(att.nodeValue);
			else if ( att.nodeName == "y" )
				this.y = parseInt(att.nodeValue);
			else if ( att.nodeName == "width" )
				this._uiWidth = parseInt(att.nodeValue);
			else if ( att.nodeName == "height" )
				this._uiHeight = parseInt(att.nodeValue);
			else if ( att.nodeName == "background-image0" )
				this._bgImgName = att.nodeValue;
			else if ( att.nodeName == "background-type" )
				this._imageType = parseInt(att.nodeValue);
//			this.setTexture(texture);
		}
		
		// 解析子节点
		for ( var i = 0; i < element.children.length; i++ ){
			var child = element.children[i];
			if ( child.nodeName == "Image" ){
				
			}
			else if ( child.nodeName == "Button" ){
				var btn = new UIButton();
			
				btn.ParseXML( child );				
				this._childList.push( btn );
//				this.getSprite().addChild( btn );
//				this.addChild(btn, 1);
			}
		}
				
	},
	
	Init:function(){
		for ( var i = 0; i < this._childList.length; i++ ){
			var child = this._childList[i];
			child.Init();
			this.addChild(child );
		}
	},
	
	ParesXMLtoMaps:function(xml){
		cc.log( "BaseUI:ParesXMLtoMaps" );
	},
	
	/**
	 * 设置该控件是否可以点击
	 * cbDown: 按下事件
	 * cbUp : 抬起事件
	 * cbMove( x, y ) : 移动事件
	 * */
	SetTouchEvent:function( cbDown, cbUp, cbMove ){
		
		var self = this;
		
		val = ( cbDown != null || cbUp!= null || cbMove!= null );
		
		if ( this._touchEvent != null ){
			cc.eventManager.removeListener( this._touchEvent );
			this._touchEvent = null;
		}
		
		if ( val == true ){
			this._touchEvent = cc.EventListener.create({
				event: cc.EventListener.TOUCH_ONE_BY_ONE,
				swallowTouches: true,                       // 设置是否吞没事件，在 onTouchBegan 方法返回 true 时吞掉事件，不再向下传递。
	
				onTouchBegan: function (touch, event) {     //实现 


					if ( self._testTouchMe( touch, event ) ) {
						var target = event.getCurrentTarget();
						var locationInNode = target.convertToNodeSpace(touch.getLocation());    
						
//						cc.log("sprite began... x = " + locationInNode.x + ", y = " + locationInNode.y);
						self._startDownPos = { x:locationInNode.x, y:locationInNode.y };
						if ( cbDown != null )
							cbDown();
	//					target.opacity = 180;
						return true;
					}
					return false;
				},
	
				onTouchEnded: function (touch, event) {
					
					if ( self._testTouchMe( touch, event ) ) {
						cc.log("sprite Ended... " );
						if ( cbDown != null )
							cbDown();
						return true;
					}
					return false;
				},
	
				onTouchMoved: function (touch, event) {
					var target = event.getCurrentTarget();
					
					if ( target.getParent() == null )
						return false;
					
					var parentInNode = target.getParent().convertToNodeSpace(touch.getLocation());
					if ( cbMove != null )
						cbMove.call( self, parentInNode.x - self._startDownPos.x, parentInNode.y - self._startDownPos.y  );
				},
	
			} );
			
			cc.eventManager.addListener(this._touchEvent, this);
		}

	},
	
	// 测试是否点击选中自己
	_testTouchMe:function( touch, event ){
		var target = event.getCurrentTarget();
		var locationInNode = target.convertToNodeSpace(touch.getLocation());    
		var s = target.getContentSize();
		var rect = cc.rect(0, 0, s.width, s.height);

		return (cc.rectContainsPoint(rect, locationInNode));
	}
	
});