﻿/**
 * UICheckBox控件，按钮控件
 */
var MUICheckBox = ccui.Widget.extend( {
	ptype:"" ,
	_stateImages:null ,
	buttonText:null ,
	_btnStates:null ,
	_background:null ,
	_mousestate:null ,
	_state:null ,
	_loop:null,
	_loopBeginId: 0 ,
	_group:null,
	_defaultState:null,
	_soundName:null,
	checkColor:null,
	uncheckColor:null,
	ctor:function(){
		this.ptype = EnumPanelType.CHECKBOX;
		this._super();
		this._stateImages = {};
		this._btnStates = [ MUICheckBox.STATE_CHECK , MUICheckBox.STATE_UNCHECK];
		this._loop = false;
		this.retain();
	},
	clone:function(){
		var cloneBtn = new MUICheckBox();
        cloneBtn.topPanel=cloneBtn;
		cloneBtn.ParseJson( this.jsonobj );
		cloneBtn.Init();
		return cloneBtn;
	},
	Init:function(){
		var self = this;
		var json = this.jsonobj;
		this.setTouchEnabled( true );
		//解析checkbox数据
		MLUIParseUtil.SetBaseAttributes( this , json);
        this._soundName="button_click";
		var i = 0;
		if(json.hasOwnProperty("loopBeginId"))
			this._loop = json.loop;
		if(json.hasOwnProperty("loopBeginId"))
			this._loopBeginId = json.loopBeginId;
		if(json.hasOwnProperty("group"))
			this._group = json.group;
		if(json.hasOwnProperty("states"))
		{
			var str = json.states;
			var strs = str.split(",");
			for (i = 0; i < strs.length; i++)
				this._btnStates[i] = strs[i];
		}
		if(json.hasOwnProperty("defaultState"))
			this._defaultState = json.defaultState;
		else
			this._defaultState = this._btnStates[0];

		for ( i = 0; i < this._btnStates.length; i++)
		{
			var bg = new MUIBackgroundImage();
//			bg.SetData(json[ this._btnStates[i]+"upImages"][0]  , false);
			var upImgUrl = json[this._btnStates[i]+"upImages"][0];
			var isScale9Enable = json[this._btnStates[i]+"upTypeS9Enable"] || false;
			var rect = json[this._btnStates[i]+"upTypeRect"] || null;
			EngineMgr.uiMgr.GetAsynResByUrl(upImgUrl, function(url, b){
				b.SetData(url, isScale9Enable, rect);	//isScale9Enable,rect应该都一样的 就不用传参了
				b.SetSize( self.getSize() );
			}, self, upImgUrl, bg );
			bg.retain();
			this._stateImages[this._btnStates[i] + "up"] = bg;
		}

		if(json.hasOwnProperty("buttonText"))
		{
			this.buttonText = new MUILabel();
			this.buttonText.setAnchorPoint(0, 0);
			this.addChild(this.buttonText);
			this.SetText( json["buttonText"] );

			if(json.hasOwnProperty("textColor"))
				this.SetTextColor(json["textColor"]);
			if(json.hasOwnProperty("textCheckColor"))
				this.checkColor = json["textCheckColor"];
			if(json.hasOwnProperty("textUnCheckColor"))
				this.uncheckColor = json["textUnCheckColor"];
            if(json.hasOwnProperty("textSize"))
                this.buttonText.SetFontSize(json["textSize"]);
            else
                this.buttonText.SetFontSize(24);
		}

		if (this._defaultState == null && this._btnStates.length > 0)
			this.SetButtonState(this._btnStates[0] , false );
		else
			this.SetButtonState(this._defaultState , false);

		this.AddChildren();
	},
	GetState:function(){
		return this._state;
	},
	//设置字体大小
    SetTextFontSize:function(sizeNum)
    {
        this.buttonText.SetFontSize(sizeNum);
    },
	/**
	 * 设置描边颜色 by zfs
	 * @param color
	 * @param lineWidth
	 * @constructor
     */
	EnableOutline:function(color, lineWidth)
    {
        this.buttonText.EnableOutline(color, lineWidth);
    },
	SetEnableOutline:function(color,lineWidth)
	{
		this.EnableOutline(color,lineWidth);
	},
    /**
     * 设置字体颜色
     * @param color:0xff0000
     * @param alpha:255
     * @constructor
     */
    SetTextColor:function(color , alpha)
    {
        this.buttonText.SetColor(color , alpha);
    },
	setTouchEnabled:function( value ){
		ccui.Widget.prototype.setTouchEnabled.call( this , value );
		if( value )
			UIComponentUtil.AddMouseEventComponent( this );
	},
	MouseUp:function ()
	{
		if(this._soundName)
            Mgr.gameSoundMgr.PlaySound(this._soundName,SoundType.UI,false);
		var state = this.GetNextState();
		if( state == null){
		}else{
			this.SetButtonState(state , true);
		}
	},
	MouseDown:function(){
	},
	SetText:function (text){
		if(this.buttonText != null && text != null && text != ""){
			this.buttonText.SetString(text);
			this.RePositon();
			//this.addProtectedChild( this.buttonText );
//			if ( this.buttonText.parent != null )
//				this.buttonText.parent.removeChild(this.buttonText);
//			this.addChild(this.buttonText);
		}
	},
	SetTextPosition:function(x,y)
	{
		this.buttonText.setPosition(x,y);
	},
	AddPossitionOffset:function (xOffset, yOffset) {
		this.buttonText.x += xOffset;
		this.buttonText.y += yOffset;
    },
	RePositon:function ()
	{
		if(this.buttonText != null){
			var ucbWid = this.width;
			var ucbHei = this.height;

			var twid = this.buttonText.GetWidth();
			var thei = this.buttonText.GetHeight();
			this.buttonText.setPositionX((ucbWid - twid) * 0.5);
			this.buttonText.setPositionY((ucbHei - thei) * 0.5);
		}
	},
	SetButtonState:function(state , groupNotify){
		if (this._state == state)
			return;
		if (state == null)
			return;
		this._state = state;
		this.SetMouseState("up", true);
		if (groupNotify && this._group != null && this._group != "" && this.parent != null){
			var children = this.parent.getChildren();
			var len = children.length;
			var child;
			for (var i = 0; i < len; i++){
				child = children[i];
				if(child != null && child instanceof MUICheckBox ){
					if(child._group === this._group && child != this){
						child.SetButtonState(this._btnStates[0], false);
					}
				}
			}
		}
	},
	SetMouseState:function (value , isForce ){
		if (isForce == false && this._mousestate == value)
			return;
		var stateimages = this._stateImages;
		var state = this._state;
		this._mousestate  = value;
		var newBk;
		if (this._mousestate  == "over")
		{
			newBk = stateimages[state + "over"];
		}
		else if (this._mousestate  == "down")
		{
			newBk = stateimages[state + "down"];
		}
		else if (this._mousestate  == "disable")
		{
			newBk = stateimages[state + "disable"];
		}
		else if (this._mousestate  == "up")
		{
			newBk = stateimages[state + "up"];
		}
		if (newBk == null)
			return;
		this.AutoChangeColor();
		if (this._background != null && this._background.parent != null)
			this.removeChild(this._background);

		this._background = newBk;
		this._background.SetSize( this.getSize() );
		if ( this._background.parent != null )
			this._background.setLocalZOrder(-1);
		else
			this.addChild( this._background ,-1);
	},
	GetNextState:function (){
		var idx = this._btnStates.indexOf(this._state);
		if (idx == this._btnStates.length - 1)
		{
			if(this._loop)
				return this._btnStates[this._loopBeginId];
			else
				return null;
		}
		else
		{
			return this._btnStates[idx + 1];
		}
	},	
	AutoChangeColor:function(){
		var stateColor = this[this._state + "Color"];
		if( stateColor )
			this.SetTextColor( stateColor );
	},
    SetSoundName:function (name) {
        this._soundName=name;
    },

    SetContentSize:function (width , height){
        ccui.Widget.prototype.setContentSize.call( this , width , height );
        this.uiWidth = this.width;
        this.uiHeight = this.height;

        this.SetMouseState(this._mousestate,true);
    },
} );

MUICheckBox.STATE_CHECK = "check";
MUICheckBox.STATE_UNCHECK = "uncheck";