var MUIColorLabel = ccui.Widget.extend({
    _labelArray:[],
    _fontSize:null,
    _alignment:0,
    _maxWidth:null,
    _intervalW:0,
    _intervalH:0,
    _fontColor:null,
    ctor: function (fontSize,alignment,fontColor) {
        this._super();
        this._fontSize=fontSize;
        if(alignment)
        this._alignment=alignment;
        if(fontColor)
        this._fontColor=fontColor;
    },
    SetText:function(textContent){
        this._labelArray.splice(0);
        var  wordArray = textContent.split("",textContent.length);
        for(var k=0;k<wordArray.length;++k){
           var word = new cc.LabelTTF(wordArray[k],"",this._fontSize);
            word.setAnchorPoint(0,0);
            word.setFontFillColor(this._fontColor);
            this._labelArray.push(word);
        }
        this._AddText();
    },
    _AddText:function(){
        this.removeAllChildren();
        var W=0;
        var H=0;
        //中对齐
        if(this._alignment==1)
        {
            var countW=0;
            var startPos=0;
            for(var i=0;i<this._labelArray.length;++i){
                countW+=this._labelArray[i].getBoundingBox().width+this._interval;
                if(this._maxWidth) {
                    //每一行添加一次
                    if (this._labelArray[i + 1]) {
                        if (countW + this._labelArray[i].getBoundingBox().width > this._maxWidth) {
                            W=-(countW-this._interval)/2;
                            for(var k=startPos;k<=i;++k)
                            {
                                this._labelArray[k].x=W;
                                this._labelArray[k].y=H;
                                this.addChild(this._labelArray[k]);
                                W+=this._labelArray[k].getBoundingBox().width+this._interval;
                            }
                            countW=0;
                            startPos=i+1;
                            H -= this._fontSize+this._intervalH;
                        }
                    }
                }
            }
            W=-(countW-this._interval)/2;
            for(var k=startPos;k<this._labelArray.length;++k)
            {
                this._labelArray[k].x=W;
                this._labelArray[k].y=H;
                this.addChild(this._labelArray[k]);
                W+=this._labelArray[k].getBoundingBox().width+this._interval;
            }
        }
        //右对齐
        else if(this._alignment==2)
        {
            var countW=0;
            var startPos=0;
            for(var i=0;i<this._labelArray.length;++i){
                countW+=this._labelArray[i].getBoundingBox().width+this._interval;
                if(this._maxWidth) {
                    if (this._labelArray[i + 1]) {
                        //每一行添加一次
                        if (countW + this._labelArray[i].getBoundingBox().width > this._maxWidth) {
                            W=0;
                            for(var k=i;k>=startPos;--k)
                            {
                                this._labelArray[k].x=W;
                                this._labelArray[k].y=H;
                                this.addChild(this._labelArray[k]);
                                W-=this._labelArray[k].getBoundingBox().width+this._interval;
                            }
                            countW=0;
                            startPos=i+1;
                            H -= this._fontSize+this._intervalH;
                        }
                    }
                }
            }
            W=0;
            for(var k=this._labelArray.length-1;k>=startPos;--k)
            {
                this._labelArray[k].x=W;
                this._labelArray[k].y=H;
                this.addChild(this._labelArray[k]);
                W-=this._labelArray[k].getBoundingBox().width+this._interval;
            }
        }
        //左对齐
        else {
            for (var i = 0; i < this._labelArray.length; ++i) {
                this._labelArray[i].x = W;
                this._labelArray[i].y = H;
                this.addChild(this._labelArray[i]);
                W += this._labelArray[i].getBoundingBox().width + this._interval;
                //换行
                if (this._maxWidth) {
                    if (this._labelArray[i + 1] && W + this._labelArray[i + 1].getBoundingBox().width > this._maxWidth) {
                        W = 0;
                        H -= this._fontSize+this._intervalH;
                    }
                }
            }
        }
    },
    //改变单个颜色
    ChangeColor:function(index,color){
        this._labelArray[index].setFontFillColor(color);
    },
    //改变单个字大小
    ChangeSize:function(index,size){
        this._labelArray[index].setFontSize(size);
        this._AddText();
    },
    //设置字之间横向的间隔
    SetIntervalW:function(interval){
        this._intervalW=interval;
        this._AddText();
    },
    //设置纵向间隔
    SetIntervalH:function(){
        this._intervalH=interval;
        this._AddText();
    },
    //设置最大长度
    SetMaxWidth:function(width){
        this._maxWidth=width;
        this._AddText();
    },
    GetString:function(){
        var str;
        for(var k in this._labelArray){
            str+=this._labelArray[k].getString();
        }
        return str;
    }
});


