﻿/**
 * UI 管理器
 * 管理UI使用的资源，UI资源添加，卸载， UI面板的显示和层级控制等。
 * yq 2015年9月23日
 * */

var PanelClassDic = PanelClassDic || {};

var UIMgr = cc.Layer.extend({
	//tips显示层
	_tipsLayer:null,
	//顶部面板层
	_topLayer:null,
	//弹出面板层
	_popLayer:null,
	//底部固定层
	_fixLayer:null,
	//层
	_layerList:null,
	/**存储的面板*/
	_panelMaps:null,
	//显示
	_showPanelMaps:null,
	_showPanelLists:null,
	//面板资源是否加载完成
	_panelResLoaded:null,
	//面板资源加载回调
	_panelResCallbackMaps:null,
	//是否是关闭的
	isClose:false,
	shadeUp:null,
	shadeDown:null,
	/**
	 * 存储每个面板独立的资源 key 为面板名，value 为该面板独立使用的纹理集
	 * 如:uiResPanelOtherMap["BackpackPanel"] = bgAtlases;
	 * */
	uiResPanelMap:{},
	uiPanelJsonMap:{},
	iconMap:{},
	//注册UI类型
	register:{},
	loadUIRes:0,
	_mouseListener:null,
	_removingpanel:"",
	_defaultTipsPanel:null,
	stageWidth:960,
	stageHeight:640,
	signalMouseScroll:null,
	ctor:function(){
		this._super();
	},
	Init:function( parentLayer ){
		parentLayer.addChild( this );
		
		this._fixLayer = new cc.Layer();
		this.addChild( this._fixLayer );
		
		this._popLayer = new cc.Layer();
		this.addChild( this._popLayer );
		
		this._topLayer = new cc.Layer();
		this.addChild( this._topLayer );
		
		this._tipsLayer = new cc.Layer();
		this.addChild( this._tipsLayer);
		this._tipsLayer.name = "tipsLayer";
		
		this._mouseUpArr = [];
		this._mouseDownArr = [];
		
		this._layerList = [this._popLayer , this._fixLayer , this._topLayer, this._tipsLayer];
		
		TipsCheckMgr.Init( this , this._tipsLayer );
		
		this._panelMaps = [{} , {} , {}, {}];
		this._showPanelMaps = [{} , {} , {}, {}];
		this._showPanelLists = [[], [], [], []];
		this._panelResLoaded = {};
		this._panelResCallbackMaps = {};
		
		cc.log( "uimgr:Init" );
		this.InitPanelClass();
		this.AddWidgetExtends();
		
		this.signalMouseScroll = new signals.Signal();
		//关闭屏幕
		//return this;	//这里在移动设备上有问题 上面会遮挡
		//var render = new cc.RenderTexture(1400, 380);
		//render.beginWithClear(127, 127, 127,255);
		//render.visit();
		//render.end();
		return this;
		if(!this.shadeUp)
		{
			this.shadeUp = new ccui.Layout();
			this.shadeUp.setSize(cc.size(1400,375));
			this.shadeUp.setBackGroundColor(cc.color(127,127,127));
			this.shadeUp.setBackGroundColorType(1);
			this.shadeUp.setTouchEnabled(true);
			this.shadeUp.setSwallowTouches(true);
			this.shadeUp.y=750;
			this._tipsLayer.addChild(this.shadeUp);
		}
		if(!this.shadeDown)
		{
			this.shadeDown = new ccui.Layout();
			this.shadeDown.setSize(cc.size(1400,375));
			this.shadeDown.setBackGroundColor(cc.color(127,127,127));
			this.shadeDown.setBackGroundColorType(1);
			this.shadeDown.setTouchEnabled(true);
			this.shadeDown.setSwallowTouches(true);
			this.shadeDown.y=-375;
			this._tipsLayer.addChild(this.shadeDown);
		}
		
//		var self = this;
//		this._mouseListener = cc.EventListener.create({
//			event:cc.EventListener.TOUCH_ONE_BY_ONE,
//			onTouchBegan:function (touch, event) {
//				zz.Log( "uimgr点击事件!!!" );
//				self._OnMouseDown( event );
//				return true;
//			}
//
//		});
		
//		this._mouseListener = new cc._EventListenerMouse();
//		this._mouseListener.onMouseDown = this._OnMouseDown;
////		this._mouseListener.onMouseUp = _OnMouseUp;
////		this._mouseListener.onMouseMove = _OnMosueMove;
		//this._mouseListener.onMouseScroll = this._OnMouseScroll;
		
//		cc.eventManager.addListener( this._mouseListener , this);
		
		return this;
	},
	_OnMouseDown:function( event ){
		event.stopPropagation();
	},
	_OnMouseScroll:function (event ){
		var self = event.getCurrentTarget();
		self.signalMouseScroll.dispatch( event );
	},
	OnPanelShown:function(panelName){
		Mgr.strong.OnPanelShown(panelName);
	},
	OnPanelHided:function(panelName){
		Mgr.strong.OnPanelHided(panelName);
	},
	InitPanelClass:function ()
	{
		this.register ={ "Panel": MUIPanel,
				"TipsPanel": MUITipsPanel,
				"Label": MUILabel,
				"Button": MUIButton,
				"StateButton": MUICheckBox,
				"TextStateButton": MUICheckBox,
				"ScrollPanel": MUIScrollPanel,
				"Image": MUIImage,
				"ProgressBar": MUIProgressBar,
				"ImageLabel": MUIImageLabel,
				"Edit": MUIEdit,
				"Grid": MUIGrid,
				"GridGroup": MUIGridGroup,
				"HSlider": MUISlider,
				"WSlider": MUISlider,
				"TextButton": MUIButton
		};
	},
	AddWidgetExtends:function ()
	{
		var self = this;
		ccui.Widget.prototype["jsonobj"] = null;
		ccui.Widget.prototype["_resList"] = null;
		ccui.Widget.prototype["AddChildren"] = function (){
			var json = this.jsonobj;
			if(json != null && json.childs != null){
				var len = json.childs.length;
				var childjson;
				var panelclass;
				var child;
				for (var i = 0; i < len; i++) {
					childjson = json.childs[i];
					if(childjson != null){
						panelclass = self.register[childjson.type];
						if(panelclass != null){

							child = new panelclass();
							child.topPanel = this.topPanel;
							child.ParseJson( childjson );
							child.Init();

							child.id = childjson.id;
//							this[childjson.id] = child;
							this.addChild(child);
							if( this.topPanel )		//目前clone的基本都没有复制topPanel
								this.topPanel[childjson.id] = child;
						}else{
						//	throw new Error("uimgr AddWidgetExtends not find panel class");
							cc.log("uimgr AddWidgetExtends not find "+childjson.type+" class");
						}
					}
				}
			}
		};
		
		ccui.Widget.prototype["ParseJson"] = function( json ){
	//		cc.log("UIPanel  ParseJson");
			this.jsonobj = json;
			this._resList = [];
			for(var url in json.publicres)
			{
				this._resList.push( json.publicres[url] );
			}
		};

		ccui.Widget.prototype["GetResList"] = function ()
		{
			return this._resList;
		};

		ccui.Widget.prototype["LoadPanel"] = function ( callback ){
			if( !this.sJsonUrl ){
				cc.log( "Warning: LoadPanel called with null params in 'sJsonUrl'.");
				if( callback )
					callback();
				return;
			}
			EngineMgr.uiMgr.LoadPanel( "res/ui/json/" + this.sJsonUrl + ".json", this , callback );
		};
		ccui.Widget.prototype["LoadPanelCallback"] = function(){
			this.Init();
		};
	},
	InitMainPanel:function (){
		this.ShowPanelByType( ShortcutPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
		//setTimeout( function(){self.ShowPanelByType( RoleHeadPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );}, 10);	//加个延迟， 不知道为什么文字边缘有bug
		this.ShowPanelByType( RoleHeadPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
		this.ShowPanelByType( MiniMapPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
		this.ShowPanelByType( TaskTrackPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
		var panel = this.ShowPanelByType( ChatPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
		panel.visible = false;
		//this.ShowPanelByType( ChatPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
//		this.ShowPanelByType( TMiniMapPanelExt.PanelName , UIMgr.PANEL_LAYER_FIX );
//		this._defaultTipsPanel = new ItemTipsPanelExt();
//		this._defaultTipsPanel.LoadPanel();
	},
	ShowPanel:function( panel , layerType ){
		var self = this;
		try{
			if ( this._layerList.length == 0 )
				return false;
			var container = this._layerList[ panel.showLayerType ];
			var panelmap = this._panelMaps[ panel.showLayerType ];
			var showmap = this._showPanelMaps[ panel.showLayerType ];
			
			if(this.IsPanelShow( panel )){
				panel.isOptimizeHide = false;
				self.ChangeShowList(panel, true);
			}else{
				showmap[panel.PanelName()] = panel;
				if(panel.modelPanelType != MUIPanelModelType.NONE )
				{
					this.ShowModelPanel(panel);
				}
				if(panel.parent == null )
					container.addChild( panel );

				var showFunction = function(){
					try{
						panel.isOptimizeHide = false;
						self.ChangeShowList(panel, true);
						var layoutPt = panel.GetLayoutPos();
						if ( layoutPt != null )
						{
							panel.x = layoutPt.x;
							panel.y = layoutPt.y;
						}
						if( panel .isShowTween )
							self.ShowPanelOpenTween( panel );
						if(panel.OnShow != null){
							panel.setVisible( true );
							panel.OnShow();
						}
						self.OnPanelShown(panel.PanelName());
					}catch (e) {
						var errLog = "uimgr onShow error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
						errLog = errLog.replace(/\n/g, "\nERROR : ");
						zz.Error( errLog + "\n");
					}
				}
				
				if(panelmap[panel.PanelName()] == null){
					panel.LoadPanel(function(){

						panel.Init();
						//cc.log("LoadPanel complete" , panel.PanelName());
						showFunction();
					} );
				}else{
					showFunction();
				}
				panelmap[panel.PanelName()] = panel;
			}
		}catch (e) {
            var errLog = "uimgr ShowPanel error:		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
            errLog = errLog.replace(/\n/g, "\nERROR : ");
			zz.Error( errLog + "\n");
		}

	},
	HidePanel:function (panel){
		var self = this;
		try{
			this.RemovePanel( panel );
		}catch (e) {
			cc.log("uimgr HidePanel ");
		}
	},
	RemovePanel:function (panel){
		var ret = false;
		if( this._removingpanel == panel.PanelName() && panel.PanelName() != "" ){
			return true;
		}
		try{
			this._removingpanel = panel.PanelName();
			var showmap = this._showPanelMaps[ panel.showLayerType ];
			if (panel != null){
				if(panel.parent != null && ( panel.visible || panel.isOptimizeHide )){
					if( panel.modelPanelType != MUIPanelModelType.NONE )
					{
						this.HideModelPanel(panel);
					}
					panel.isOptimizeHide = false;
					this.ChangeShowList(panel);
					panel.setVisible(false);
					panel.OnHide();
					this.OnPanelHided(panel.PanelName());
					delete showmap[panel.PanelName()];
					ret = true;
				}
			}
		}catch (e) {
			cc.log("uimgr RemovePanel error"+e);
		}finally{
			this._removingpanel = "";
		}
		return  ret;
	},
	HidePanelByType:function( name ){
		var self = this;
		if(!this.IsPanelShowByName(name))
			return;
		var panel = this._GetPanelByName( name );
		if ( panel != null ){
			try{
				this.RemovePanel( panel );
			}catch (e) {
				cc.log("uimgr HidePanel ");
			}
		}
	},
	ShowHidePanelByType:function ( name ){

		if(this.IsPanelShowByName( name )){
			this.HidePanelByType( name );
		}else{

			this.ShowPanelByType( name );
		}
	},
	/**
	 * 显示面板
	 * */
	ShowPanelByType:function( name , layerType ){
		var self = this;
		var panel = this._GetPanelByName( name );
		if ( panel == null ){
			var panelClass = PanelClassDic[name];
			if(panelClass != null){
				var panel = new panelClass();
				if(layerType && layerType != UIMgr.PANEL_LAYER_DEF){
					panel.showLayerType = layerType;
				}
			}else
			{
				throw new Error("uiMgr ShowPanelByType not find "+name);
			}
		}
		this.ShowPanel( panel , layerType);
		return panel;
	},
	_GetPanelByName:function(name){
		var panel = null;
		var len = this._panelMaps.length;
		var map;
		for (var i = 0; i < len; i++) {
			map = this._panelMaps[i];
			panel = map[name];
			if(panel != null)
				break;
		}
		return panel;
	},
	GetPanelByType:function ( type ){
		return this._GetPanelByName( type );
	},
	IsPanelShow:function ( panel ){
		if(panel == null || !(panel instanceof MUIPanel ))
			return false;
		var map = this._showPanelMaps[ panel.showLayerType ];
		if(map.hasOwnProperty(panel.PanelName())){
			return map[panel.PanelName()] != null;
		}else{
			return false;
		}
	},
	IsPanelShowByName:function (name){
		for(var key in this._showPanelMaps){
			if(this._showPanelMaps[key][name] != null)
				return true;
		}
		return false;
	},
	ChangeShowList:function(panel, isShow){
		var list = this._showPanelLists[panel.showLayerType];
		var oldIndex = list.indexOf(panel);
		if( oldIndex != -1 )
			list.splice(oldIndex, 1);
		if( isShow )
			list.push(panel);
		for( var i = 0, len = list.length; i < len; i++ ){
			panel = list[i];
			var order = panel.getLocalZOrder();
			if( order >= 0 && order < 500 )	//无特殊层级的才排序
				panel.setLocalZOrder(i*2+1);
			if( panel.modelPanel ){
				panel.modelPanel.setLocalZOrder(panel.getLocalZOrder() - 1);
			}
		}
		list.sort(function(p1, p2){ return p1.getLocalZOrder() - p2.getLocalZOrder();});
		this.UpdatePanelShow();
	},
	/**
	 * 处理面板堆叠太卡的问题
	 * @constructor
     */
	UpdatePanelShow:function(){
		var list = this._showPanelLists[UIMgr.PANEL_LAYER_POP];
		var isFindBlur = false;
		for( var i =  list.length - 1; i >= 0; i-- ){
			var panel = list[i];
			if( panel.modelPanel )
				panel.modelPanel.visible = !isFindBlur;
			panel.visible = !isFindBlur;
			panel.isOptimizeHide = isFindBlur;
			if( panel.modelPanelType == MUIPanelModelType.BLUR ){
				isFindBlur = true;
			}
		}
		this._fixLayer.visible = !isFindBlur;
	},
	/**
	 * 加载一个面板的other资源
	 * */
	LoadOtherRes:function( keyName, callTarget ){
		var self = this;
		if(!callTarget.hasOwnProperty("Callback") || !callTarget.hasOwnProperty("ErrCallback")){
			throw Error("UIMgr LoadOtherRes callTarget must be callback obj.");
		}
//		cc.log( "LoadOtherRes key:" + keyName +" millisecond:"+ new Date().getTime());
		//zz.Log( "LoadOtherRes: res/ui/image/" + keyName );
		LoadMgr.LoadTexture("res/ui/image/" + keyName, callTarget, LoadPriority_Common, {
			complete:function( retMap ){
//				zz.Log( "keyName:" + keyName );
//				zz.Log( retMap );
				self.uiResPanelMap[keyName] = retMap;
				// cc.log( "LoadOtherRes DOWNLOAD:" +" millisecond:"+ new Date().getTime() + keyName + retMap.frames);
				//cc.log( retMap  );
				var cbArr = EngineMgr.uiMgr._panelResCallbackMaps[keyName];
				if(cbArr){
					cbArr.forEach(function(asyn){
						asyn.Complete();
					});
				}
				EngineMgr.uiMgr._panelResCallbackMaps[keyName] = null;
				if ( callTarget.Callback != null )
					callTarget.Callback();
			},
			error:callTarget.ErrCallback,
			keyName:keyName})
	},
	LoadIconRes:function( keyName, callTarget ){
		var self = this;
		if(!callTarget.hasOwnProperty("Callback") || !callTarget.hasOwnProperty("ErrCallback")){
			throw Error("UIMgr LoadIconRes callTarget must be callback obj.");
		}
		LoadMgr.LoadTexture("res/ui/" + keyName, callTarget, LoadPriority_Common, {
			complete:function( retMap ){

				self.iconMap[keyName] = retMap;
				if ( callTarget.Callback != null )
					callTarget.Callback();
			},
			error:callTarget.ErrCallback,
			keyName:keyName})
	},
	GetIconByUrl:function(url){
		if(url == null)
			return null;
		var type = url.substring( 0 , url.indexOf( "/"));
		var id = url.substring( url.indexOf( "/")+1 , url.length);
		if(this.iconMap[type]){
			return this.iconMap[type][id];
		}
		return null;
	},
	//根据UI面板文件路径得到纹理
	GetResByUrl:function ( url ){
		//url like "public/image/fenggexian.png"
		if(url == null)
			return null;
		var pname = "";
		var key = "";
		if(url.indexOf("other") == 0){
			pname = url.substring( 0 , url.indexOf( "/" , 6));
			key = url.substring( url.indexOf( "/" , 6)+1 , url.length);
		}else{
			pname = url.substring( 0 , url.indexOf( "/" , 0));
			key = url.substring( url.indexOf( "/" , 0)+1 , url.length);
		}
		return this.GetRes( key, pname);
	},

	/**
	 * 获得纹理资源
	 * */
	GetRes:function( key, panelName ){
		
		var str = "";
	//	key = key.replace(new RegExp("/","g"), "_" );
		
		// 把第一个字符串替换到
		//key = key.replace( "_", "" );
		
//		cc.log( "GetRes：" + key + " panelName：" + panelName );
//		for ( var key in this.uiResPanelMap ){
//			zz.Log( key );
//		}
//		zz.Log( this.uiResPanelMap );
		if ( this.uiResPanelMap[panelName] != null ){
			var otherRes = this.uiResPanelMap[panelName];
			
//			if ( typeof data == "SpriteFrame"  )
//			cc.spriteFrameCache.addSpriteFrame(data, url);
			return otherRes[key];
		}
		return null;
	},
	GetAsynResByUrl:function( url, callback, target ){
		var pname = "";
		var key = "";
		if(url.indexOf("other") == 0){
			pname = url.substring( 0 , url.indexOf( "/" , 6));
			key = url.substring( url.indexOf( "/" , 6)+1 , url.length);
		}else{
			pname = url.substring( 0 , url.indexOf( "/" , 0));
			key = url.substring( url.indexOf( "/" , 0)+1 , url.length);
		}
		//资源加载回调 这里先不管回调的UI对象被销毁的问题了 UI对象应该很少销毁才对 涉及到的地方强制删除好了 --merlin
		var asyn = new AsynUICallBack(url, callback, target, arguments);
		var res = this.GetRes( key, pname);
		if( res ){
			asyn.Complete();
		}
		else{
			var cbArr = this._panelResCallbackMaps[pname];
			if( !cbArr )
			{
				cbArr = [];
				this._panelResCallbackMaps[pname] = cbArr;
			}
			cbArr.push(asyn);
		}
	},
	
	/**
	 * 加载一个xml面板文件
	 * */
	LoadPanel:function( url , panel , callback ){
		var self = this;
		if(this.uiPanelJsonMap[ url ] != null){
			self.CreatePanel(this.uiPanelJsonMap[ url ] , panel, callback );
		}else{
			LoadMgr.LoadCdnFile( url, function(){
				cc.loader.loadTxt( url, function( err, txt ){
					if ( err != null || !txt ){
						cc.log( "加载面板错误:" + url );
						cc.log( err );
						return;
					}
					var jsonObj = JSON.parse(txt);
					self.uiPanelJsonMap[ url ] = jsonObj;
					self.CreatePanel(jsonObj , panel, callback );
				});
			});
		}
	},
	
	/**
	 * 通过XML创建一个面板
	 * */
	CreatePanel:function( jsonObj , panel , callback ){
//		var xmlParse = new XMLParseUtil();
//		var xmlDoc = xmlParse.Parse(xml);
		panel.ParseJson( jsonObj );
		var self = this;
		var reslist = panel.GetResList();
		var len = reslist.length;
		var loaded = 0;
		// var complete = function ()
		// {
		// 	loaded ++;
		// 	if(loaded == len)
		// 	{
		// 		if(callback)
		// 			callback();
		// 		else
		// 			panel.LoadPanelCallback();
		// 	}
		// }
		for (var i = 0; i < len; i++) {
			this.LoadOtherRes( reslist[i] ,{
				Callback:function(){
					// complete();
				},
				ErrCallback:function(){
					// complete();
				}
			});
		}
		// if(reslist.length == 0)
		// {
		//直接回调 资源可以异步加载了
			if(callback)
				callback();
			else
				panel.LoadPanelCallback();
		// }
		return panel;
	},
	
	/**解析XML面板*/
	ParseXMLToPanel:function( xml ){
	},
	GetTipsLayer:function (){
		return this._tipsLayer;
	},
	GetDefaultTipsPanel:function (){
		return this._defaultTipsPanel;
	},
	GetLayerByType:function ( type ) {
		return this._layerList[type];
	},
	StageResize:function (width , height){
		this.stageWidth = width;
		this.stageHeight = height;
		this.GuiStageResizeHandler();
	},
	GuiStageResizeHandler:function ()
	{
		var ps = [];
		
		var map = this._showPanelMaps[UIMgr.PANEL_LAYER_POP];
		for (var key in map){
			ps.push( map[key] );
		}
		map = this._showPanelMaps[UIMgr.PANEL_LAYER_TOP];
		for (key in map){
			ps.push( map[key] );
		}
		
		if (this.stageHeight < 50)
			return;

		var i;
		var p;
		var pt;
		for (i = 0; i < ps.length; i++)
		{
			p = ps[i];
			if (p != null)
			{
//				if (p.isLayoutAlways && p.visible != null )
//				{
				pt = MLGetLayoutPos(cc.rect(0, 0, this.stageWidth, this.stageHeight), p, p.layoutCom.layoutType);
					if (pt == null)
						continue;
					p.x = pt.x;
					p.y = pt.y;
//				}
//				else
//				{
//					var newX:int = p.oldXPer * (_helper.stageWidthEx() - p.uiWidth);
//					var newY:int = p.oldYPer * (_helper.stageHeightEx() - p.uiHeight);
//		
//					if (newX > ( _helper.stageWidthEx() - p.uiWidth))
//						newX = _helper.stageWidthEx() - p.uiWidth;
//		
//					if (newX < 0) 
//						newX = 0;
//		
//					if (newY > (_helper.stageHeightEx() - p.uiHeight))
//						newY = _helper.stageHeightEx() - p.uiHeight;
//		
//					if (newY < 0)
//						newY = 0;
//		
//					p.panelx = newX;
//					p.panely = newY;
//				}
			}
		}
		map = this._showPanelMaps[UIMgr.PANEL_LAYER_FIX];
		ps.length = 0;
		for(key in map)
			ps.push( map[key] );
		for (i = 0; i < ps.length; i++)
		{
			p = ps[i];
//			if (p.isLayoutAlways && p.stage != null)
			{
				pt = MLGetLayoutPos(cc.rect(0, 0, this.stageWidth, this.stageHeight), p, p.layoutCom.layoutType);
				if (pt == null)
					continue;
				p.x = pt.x;
				p.y = pt.y;
			}
		}
	
//		ps = modelPanelList.values();
//		for (i = 0; i < ps.length; i++)
//		{
//			p = ps[i] as Panel;
//			if (p.isLayoutAlways && p.stage != null)
//			{
//				pt = LayoutComponent.GetLayoutPos(new Rectangle(0, 0, _helper.stageWidthEx(), _helper.stageHeightEx()), p, p.layoutType);
//				if (pt == null)
//					continue;
//	
//				p.x = pt.x;
//				p.y = pt.y;
//			}
//		}			
	},

	/************************************************************面板展示处理比较简单 就不单独做了*****************************************************************/
	_modelList:[],
	ShowModelPanel:function(panel)
	{
		var layerType = panel.showLayerType;
		if(false && panel.modelPanelType == MUIPanelModelType.BLUR)
		{
			var p = new BlurModelPanel(layerType);
			var container = this._layerList[ layerType ];
			container.addChild(p);
			// this._modelList.push(p);
		}
		else if (panel.modelPanelType == MUIPanelModelType.BLUR || panel.modelPanelType == MUIPanelModelType.ALPHABLACK)
		{
			var p = new BackgroundBlack(panel);
			var container = this._layerList[ layerType ];
			container.addChild(p);
			// this._modelList.push(p);
		}
		panel.modelPanel = p;
	},

	HideModelPanel:function(panel){
		// var p = this._modelList.pop();
		if(panel.modelPanel)
		{
			panel.modelPanel.removeFromParent();
		}
		panel.modelPanel = null;
	},

	ShowPanelOpenTween:function(panel){
		var layoutPt = panel.GetLayoutPos();
		if ( layoutPt != null )
		{
			panel.x = layoutPt.x - 600;
			var moveTo = cc.moveTo(0.3, layoutPt.x, layoutPt.y);
			panel.runAction(moveTo);
		}
	},
	/******************************************************				end					***********************************************************************/
	_hideZoneList:[],
	CheckShowInZone:function(inSingleZone){
		if( inSingleZone ){
			var showmap = this._showPanelMaps[ UIMgr.PANEL_LAYER_POP ];
			for(var key in showmap){
				var panel = showmap[key];
				if( panel ){
					if( key == BattlePanelExt.PanelName ){
						this.HidePanel( panel );
						this._hideZoneList.push(panel);
					}
				}
			}
		}
		else{
			while( this._hideZoneList.length ){
				this.ShowPanel( this._hideZoneList.pop() );
			}
		}

	},
    ReleasePanel:function (panelName) {
		if(this.IsPanelShowByName(panelName)){
			this.HidePanelByType(panelName);
		}
        var len = this._panelMaps.length;
        var map;
        for (var i = 0; i < len; i++) {
            map = this._panelMaps[i];
            var panel = map[panelName];
            if(panel) {
                delete map[panelName];
                panel.removeFromParent();
				break;
            }
        }
    }
} );

/**
 * UI初始化时用的回调，这样不用等资源加载完成就能操作面板
 * @type {Function}
 */
var AsynUICallBack = AsynUICallBack || cc.Class.extend({
	_func:null,
	_args:null,
	_url:null,
	_target:null,
	ctor:function(u, f, t, a){
		this._func = f;
		this._url = u;
		this._target = t;
		this._args = a;
	},
	Complete:function(){
		var texture = EngineMgr.uiMgr.GetResByUrl( this._url );
		if( texture ){
			if( this._target && !cc.sys.isObjectValid(this._target) ){
				cc.log("AsynUICallBack Target: The target was destoryed. ");
				return;
			}
			if (this._args.length > 3)
				this._func.apply( this._target, Array.prototype.slice.call(this._args, 3) );
			else{
				this._func.call( this._target, this._url, ccui.Widget.PLIST_TEXTURE );
			}
		}
		else{
			cc.log( "AsynUICallBack Error: " + this._url);
		}
	}
});
/**不改变面板默认级别**/
UIMgr.PANEL_LAYER_DEF = -1;
/** 弹出面板**/
UIMgr.PANEL_LAYER_POP = 0;
/** 固定面板**/
UIMgr.PANEL_LAYER_FIX = 1;
/** 顶部面板**/
UIMgr.PANEL_LAYER_TOP = 2;
/** 顶部面板**/
UIMgr.PANEL_LAYER_TIP = 3;

UIMgr.PanelNameIndex = 0;	// 面板自增长索引 为了有些面板多个实例不冲突

//单独的日志打印
//便于删除或关闭
var mxj = {
}
mxj.log = function (log){
	cc.log("mxj "+new Date().toDateString()+":",log);
}