var MUIRichType = {
    TEXT    :   1,
    NEWLINE    :   2,
    CUSTOM    :   3,

}

var MUIRichElement = ccui.Layout.extend({
    ctor:function(sender){
        this._super();
        this.uiRichText = sender;

        //this.setBackGroundColorType(1)
        //this.setBackGroundColor(cc.color(0x00,0x00,0xFF,0xFF))
        //this.setBackGroundColorOpacity(0xFF* 0.5)
    },
    Clone:function(){
        return new MUIRichElement();
    },
    GetWidth:function(){ return this.width;},
    GetHeight:function(){ return this.height;},
    GetRichText:function(){ return this.uiRichText;},

    UpdateView:function(data){
    },
    HandleLimitedWidth:function(widthMax,v,lineRenderCount){
        if(lineRenderCount == 1) return;

        this.width = 0,
        this.height = 0;
        return v;
    },

    OnRemove:function(){},
})

var MUIRichElementText = MUIRichElement.extend({
    ctor:function(uiRichText){
        this._super(uiRichText);

        var render = LabelRender.Create();
        render.setAnchorPoint(cc.p(0,0));
        render.x = 0;
        render.y = 0;
        this.render = render;
        this.addChild(render);
    },
    Clone:function(){
        return new MUIRichElementText(this.GetRichText());
    },

    UpdateView:function(parent,v){
        var render = this.render;

        var defaultFontSize = parent._fontSize;
        var defaultFont = parent._fontName;
        var defaultColor = parent._color;

        var font = v.font;
        render.SetColor(font && font.color || defaultColor);
        render.SetFontName(font && font.face || defaultFont);
        render.SetFontSize(font && font.size || defaultFontSize);
        //render.SetUnderLine(v.underline);

        if(v.hyperlink){
            render.setTouchEnabled(true);
            render.addClickEventListener(parent._OnClicked.bind(parent,v.hyperlink));
        }else{
            render.setTouchEnabled(false);
        }
        render.SetText(v.content);

        this.width = render.GetWidth();
        this.height = render.GetHeight();

        render.SetUnderLine(v.underline);
    },
    HandleLimitedWidth:function(widthMax,v,lineRenderCount){
        var render = this.render;
        var str = String(v.content);

        /// 假装自己支持使用超链接时，如果该行显示不下的话，直接换行。不挤着挤着显示了。
        if(v.hyperlink
            && this.GetRichText().GetHyperlinkBreakLine()
            // 会有整行都装不下的情况，强制分割并跳过
            && lineRenderCount != 1
        ){
            render.SetText("");
            render.SetUnderLine(false);
            this.width = 0,
            this.height = 0;
            return v;
        }

        var realLen = Math.max(parseInt(widthMax / render.GetWidth() * str.length), 1);	//最小也要保证为1 避免死循环
        //数字和文字的大小不一样这里检查下吧
        render.SetText(str.substr(0, realLen));
        if(realLen>1) {
            if( render.GetWidth() > widthMax ){
                while (true) {
                    realLen--;
                    render.SetText(str.substr(0, realLen));
                    if (realLen == 1 || render.GetWidth() <= widthMax)
                        break;
                }
            }
            else{
                while (render.GetWidth()  < widthMax) {
                    realLen++;
                    render.SetText(str.substr(0, realLen));
                    if (render.GetWidth()  > widthMax) {
                        realLen--;
                        render.SetText(str.substr(0, realLen));
                        break;
                    }
                }
            }
        }
        else{
            render.SetText(str.substr(0, realLen));
        }
        render.SetUnderLine(v.underline);
        str = str.substr(realLen);

        this.width = render.GetWidth();
        this.height = render.GetHeight();
        var result = {};
        for(var k in v){
            result[k] = v[k];
        }
        result.content = str;
        return result;
    },

    OnRemove:function(){
        LabelRender.Delete(this.render);
    },
})

var MUIRichElementCustom = MUIRichElement.extend({
    ctor:function(uiRichText){
        this._super(uiRichText);
    },
    Clone:function(){
        return new MUIRichElementCustom(this.GetRichText());
    },

    UpdateView:function(parent,data){
        var render = parent._OnCreateCustomContent(data.key);
        if(render){
            render.setAnchorPoint(cc.p(0,0));
            this.addChild(render);
            this.render = render;

            this.width = render.width;
            this.height = render.height;
        }else{
            this.width = 0;
            this.height = 0;
        }
    },
    HandleLimitedWidth:function(widthMax,v,lineRenderCount){
        if(lineRenderCount == 1) return;

        if(sys.isObjectValid(this.render)){
            this.render.removeFromParent();
        }
        this.render = null;

        this.width = 0,
        this.height = 0;
        return v;
    },
})


var MUIRichText = ccui.Layout.extend({
    _className : "MUIRichText",

    //@property
    _color : null,
    _fontSize : 22,
    _fontName : null,

    _text : null,
    _parsedText : null,
    _renderArr : null,

    _fixedHeight : 0,
    _width : 0,
    _height : 0,

    _hyperlinkBreakLine : false,
    //@
    _dirtyText : false,
    _dirty : false,

    ctor:function(){
        this._super();
        this.ignoreContentAdaptWithSize(true);

        this._parsedText = [];
        this._renderArr = [];
        this._fontName = GameFont.DEFAULT;
        this._color = new cc.Color(0xFF, 0xFF, 0xFF);

        //this.setBackGroundColorType(1)
        //this.setBackGroundColor(cc.color(0xFF,0x00,0x00,0xFF))
        //this.setBackGroundColorOpacity(0xFF* 0.5)
    },

    onEnter:function(){
        this._super();

        cc.eventManager.addListener({
            event : cc.EventListener.CUSTOM,
            //eventName :cc.Director.EVENT_AFTER_VISIT,
            eventName :cc.Director.EVENT_AFTER_UPDATE,
            callback : this.UpdateView.bind(this),
        },this);
    },
    GetColor:function(){ return this._color;},
    GetFontSize:function(){ return this._fontSize;},
    GetFontName:function(){ return this._fontName;},

    GetHyperlinkBreakLine:function(val){
        return this._hyperlinkBreakLine;
    },

    SetUserData:function(val){
        this._userdata = val;
    },
    GetUserData:function(){
        return this._userdata;
    },

    SetColor:function(val){
        if(cc.colorEqual(val, this._color)) return;
        this._color = val;
        this._dirty = true;
    },
    SetFontSize:function(val){
        if(this._fontSize == val) return;
        this._fontSize = val;
        this._dirty = true;
    },
    SetFontName:function(val){
        if(this._fontName == val) return;

        this._fontName = val;
        this._dirty = true;
    },

    SetString:function(val){
        this._text = String(val);

        this._dirtyText = true;
    },

    SetFixedHeight:function(val){
        if(!val || this._fixedHeight == val) return;
        this._fixedHeight = val;

        this._dirty = true;
    },
    SetDimensions:function(width,height){
        if(width) this._width = width;
        if(height) this._height = height;
    },

    SetOpenUrlCallback:function(callback,target){
        this._callback = callback;
        this._target = target;
    },
    SetCustomNodeCallback:function(callback,target){
        this._customCallback = callback;
        this._customTarget = target;
    },
    SetParseTextCallback:function(callback,target){
        this._parseTextCallback = callback;
        this._parseTextTarget = target;
    },

    SetHyperlinkBreakLine:function(val){
        if(!val || this._hyperlinkBreakLine == val) return;
        this._hyperlinkBreakLine = val;
        this._dirty = true;
    },

    UpdateView:function(){
        if(this._dirtyText) this._ParseText(this._parsedText,this._text);
        if(this._dirtyText || this._dirty) this._RenderThis();
        this._dirtyText = false;
        this._dirty = false;
    },

    _OnClicked:function(href,sender){
        if(this._callback && this._target){
             this._callback.call(this._target,href,this);
        }
    },
    _OnCreateCustomContent:function(key){
        if(this._customCallback && this._customTarget){
             return this._customCallback.call(this._customTarget,key,this);
        }
    },
    _ParseText:function(data,text){
        data.length = 0;

        // TIP add font support other than color.
        var fontArr = [];
        var font

        var isUnderline = false;
        var isNewLine = false;
        var hyperlink = null;
        var strArr;
        while (strArr = TextUtil.HTML_SPILT_PATTERN.exec(text)) {
            strArr.forEach(function (str, i) {
                if (i > 0 && str) {		//html做好标记 文本则创建text
                    var first = str.charAt(0);	//这里标签少 随便写了 不用正则也可以
                    if (first == '<') {
                        var second = str.charAt(1);
                        switch (second) {
                            case 'c':   // TAG CUSTOM
                            case 'C':
                                var href = str.match(/href=["'](.*)['"]/);
                                var custom = href && href[1];
                                data.push({ type  : MUIRichType.CUSTOM, key: custom});
                                break;
                            case 'u':
                            case 'U':
                                isUnderline = true;
                                break;
                            case 'f':
                            case 'F':
                                var hColor = str.match(/color=["']#(.+?)['"]/);
                                var hFace = str.match(/font=["'](.+?)['"]/);
                                var hSize = str.match(/size=["'](.+?)['"]/);
                                font = {
                                    color :UIUtil.GetCCColor(parseInt(hColor[1], 16)),
                                    face : hFace && hFace[1],
                                    size : hSize && hSize[1],

                                };

                                fontArr.push(font);
                                break;
                            case 'a':
                            case 'A':
                                var href = str.match(/href=["'](.*)['"]/);
                                hyperlink = href && href[1];
                                break;
                            case 'b':
                            case 'B':
                                if (str.charAt(2) == 'r' || str.charAt(2) == 'R'){
                                    data.push({ type  : MUIRichType.NEWLINE, });
                                }
                                break;
                            case '/':
                                var third = str.charAt(2);
                                switch (third) {
                                    case 'a':
                                    case 'A':
                                        hyperlink = null;
                                        break;
                                    case 'u':
                                    case 'U':
                                        isUnderline = false;
                                        break;
                                    case 'f':
                                    case 'F':
                                        fontArr.pop();
                                        font = fontArr.length > 0 ? fontArr[fontArr.length - 1] : null;
                                        break;
                                }
                                break;
                        }
                        return;	//forEach里return只是continue的作用而已
                    }
                    data.push({ type : MUIRichType.TEXT,content: str, font: font, underline: isUnderline, newline:isNewLine,hyperlink:hyperlink});
                    isNewLine = false;
                }
            });
        }

        if (data.length == 0) {
            data.push({ type : MUIRichType.TEXT,content: text, underline: isUnderline, newline:isNewLine,hyperlink:hyperlink});
        }

        if(this._parseTextCallback && this._parseTextTarget){
            this._parsedText = this._parseTextCallback.call(this._parseTextTarget,data);
        }
    },
    _ClearRender:function(){
        this.removeAllChildren();
        for(var i=0;i!=this._renderArr.length;++i){
            this._renderArr[i].OnRemove();
        }
        this._renderArr.length = 0;
    },

    _RenderThis:function(){
        this._ClearRender();

        var defaultFontSize = this._fontSize;
        var defaultFont = this._fontName;
        var defaultColor = this._color;

        var widthMax = this._width;
        var heightMax = this._height;
        var fixedHeight = this._fixedHeight;


        var leftW = this._width;
        var self = this;
        var data = this._parsedText;
        var costWidth = 0;
        var _textWidth = 0,_maxWidth = 0;
        var rowCount = 1;
        var lineHeight = 0;
        var lineRenderCount = 0;

        this.rowConfig = {};
        var newline = function(){
            _maxWidth = Math.max(_maxWidth,_textWidth);

            self.rowConfig[rowCount] = {
                width : _maxWidth,
                height : lineHeight,
            }
            lineHeight = 0;
            costWidth = 0;
            rowCount += 1;
            // 换行重置
            _textWidth = 0;
            lineRenderCount = 0;
        }

        for (var length = data.length,k = 0,v=data[k]; k != length; v=data[++k]) {

            var render = null;
            switch(v.type){
                case MUIRichType.NEWLINE: newline(); break;
                case MUIRichType.TEXT: render = new MUIRichElementText(this);  break;
                case MUIRichType.CUSTOM:   render = new MUIRichElementCustom(this); break;
            }
            if(!render) continue;

            var str = v.str;

            render.UpdateView(this,v);

            render.lineNum = rowCount;
            _textWidth += render.GetWidth();
            lineRenderCount ++;
            lineHeight = Math.max(lineHeight,render.GetHeight());


            self._renderArr.push(render);
            self.addChild(render);

            /// if not limit the width then draw the next one.
            if( widthMax <= 0) continue;

            while (render.GetWidth() + costWidth > widthMax) {
                // 减去本行已经加过的 --jaye
                _textWidth -= render.GetWidth() ;

                v = render.HandleLimitedWidth(widthMax - costWidth,v,lineRenderCount);

                // 重新加上本行没加的 --jaye
                _textWidth += render.GetWidth();

                if(!v) break;

                newline();
                lineRenderCount++;

                render = render.Clone();
                render.UpdateView(this,v);
                lineHeight = Math.max(lineHeight,render.GetHeight());

                render.lineNum = rowCount;

                self._renderArr.push(render);
                self.addChild(render);
            }
            costWidth += render.GetWidth();

        }

         newline();

        this._textWidth = _maxWidth
        this._textHeight = 200//_   textHeight;
        this._rowCount = rowCount;
        this._SortText();
    },

    _SortText: function () {
        var fixedHeight = this._fixedHeight;
        var height = 0
        if(fixedHeight <= 0){
            for(var i=1;i != this._rowCount;i++){
               height += this.rowConfig[i].height;
            }
        }else{
            height = fixedHeight * (this._rowCount - 1);
        }
        this._textHeight = height;

        var row = 1;
        var render;
        var startY = this._textHeight;
        var startX = 0;
        var curX = startX;

        for (var i = 0; i < this._renderArr.length; i++) {
            render = this._renderArr[i];
            render.setAnchorPoint(cc.p(0,0.5));

            if (row != render.lineNum) {
                curX = startX;
                startY -= fixedHeight <=0 ? this.rowConfig[row].height : fixedHeight;

                row = render.lineNum;
            }
            render.x = curX;
            curX += render.GetWidth();

            render.y = startY - (fixedHeight <=0 ? this.rowConfig[row].height / 2 : fixedHeight / 2);
        }

        this.width = this._textWidth;
        this.height = this._textHeight;
    },
});

Object.defineProperty(MUIRichText.prototype, 'color', { get:function() {  return this.GetColor(); }, set:function(){ this.SetColor.apply(this,arguments);}, });
Object.defineProperty(MUIRichText.prototype, 'fontSize', { get:function() {  return this.GetFontSize(); }, set:function(){ this.SetFontSize.apply(this,arguments);}, });
Object.defineProperty(MUIRichText.prototype, 'fontName', { get:function() {  return this.GetFontName(); }, set:function(){ this.SetFontName.apply(this,arguments);}, });
