﻿/**
 * UIProgressBar控件，按钮控件
 */
var MUISlider = ccui.Widget.extend( {
	ptype:"" ,
	parentPanel:null ,
	_type:"hscroll" ,
	_btnUp:null ,
	_btnDown:null ,
	_btnBar:null ,
	_btnBarImg:null,
	_bgImg:null,
	isBarDrag: false ,
	// 点击时候处于光标位置的偏移
	downBarOffX:0 ,
	downBarOffY:0 ,
	// bar的建议最小宽度
	_minHBarLen: 11,
	// 表示bar是否已经达到宽度下限
	isBarLenLimited: false,
	initBarPosFlag: true,
	_isChild: false,
	_barMoveRect:null,
	_barPosMiddle:0,
	_minHBarLen:0,
	isBarLenLimited: false,
	initBarPosFlag: true,
	signalBtnUp:null,
	signalBtnDown:null,
	signalCursor:null,
	signalCursorUp:null,
	signalChildChange:null,
	ctor:function(){
		this.ptype = EnumPanelType.SLIDER;
		this._super();
		
		this.signalBtnUp = new signals.Signal();
		this.signalBtnDown = new signals.Signal();
		this.signalCursor = new signals.Signal();
		this.signalCursorUp = new signals.Signal();
		this.signalChildChange = new signals.Signal();
		
	},
	Init:function(){
		//解析进度表已经刻度输入条
		UIParseUtil.ParseSlider( this , this.jsonobj);
		this.AddChildren();
	},
	UpdatePanel:function (){
		this._barMoveRect = cc.rect(0, 0, 0, 0);

		//滚动条（竖）
		if(this._type == MUISlider.H_SLIDER){
			this._btnUp.x = 0;
			this._btnUp.y = this.uiHeight - this._btnDown.height;
			this._btnDown.x = 0;
			this._btnDown.y = 0;
			this.ResizeBar(this._btnBar.width , 100);
			this._bgImg.x = 0;
			this._bgImg.y = 0;
			this._bgImg.setContentSize(this._bgImg.width , this.uiHeight );
			this.SetContentSize( this._bgImg.width , this.uiHeight );
		}else{
			this._btnUp.x = 0;
			this._btnUp.y = 0;
			this._btnDown.x = this.uiWidth - this._btnDown.width;
			this._btnDown.y = 0;
			this.ResizeBar(100 , this._btnBar.height);
			this._bgImg.x = 0;
			this._bgImg.y = 0;
			this._bgImg.setContentSize(this.uiWidth , this._bgImg.height);
			this.SetContentSize( this.uiWidth, this._bgImg.height);
		}
		this.AddListener();
	},

	ResizeBar:function( w, h ){
		if(this._type == MUISlider.H_SLIDER) {
			this._btnBar.SetContentSize( w, h );
			this._barMoveRect.y = this._btnDown.height;
			this._barMoveRect.height = this.uiHeight - this._btnUp.height -  this._btnBar.height;
			this._btnBar.x = 0;
			this._btnBar.y = this._barMoveRect.height;
			this._btnBarImg.y = (this._btnBar.height - this._btnBarImg.height) * 0.5;
		}
		else{
			this._btnBar.SetContentSize( w, h );
			this._barMoveRect.x = this._btnDown.width;
			this._barMoveRect.width = this.uiWidth - this._btnDown.width - this._btnBar.width;
			this._btnBar.x = this._barMoveRect.width;
			this._btnBar.y = 0;
			this._btnBarImg.x = (this._btnBar.width - this._btnBarImg.width) * 0.5;
		}
	},

	AddListener:function (){
		this._btnUp.AddMouseEventListener( ccui.Widget.TOUCH_ENDED , this.OnBtnUp , this );
		this._btnDown.AddMouseEventListener( ccui.Widget.TOUCH_ENDED , this.OnBtnDown , this );
		this._btnBar.AddMouseEventListener( ccui.Widget.TOUCH_BEGAN , this.OnBtnBarBegin , this );
		this._btnBar.AddMouseEventListener( ccui.Widget.TOUCH_MOVED , this.OnBtnBarMove , this );
	},
	OnBtnUp:function (event){
		this.signalBtnUp.dispatch();
	},
	OnBtnDown:function (event){
		this.signalBtnDown.dispatch();
	},
	OnBtnBarBegin:function (event ){
		this._downPostion = cc.p(this._btnBar.getTouchBeganPosition().x , this._btnBar.getTouchBeganPosition().y);
		this._curBarY = this._btnBar.y;
		this._curBarX = this._btnBar.x;
	},
	OnBtnBarMove:function (event){

		var move = this._btnBar.getTouchMovePosition();
		if(this._type === MUISlider.W_SLIDER){
			var mx = move.x - this._downPostion.x ;
			mx = this._curBarX + mx;
			if(mx < this._barMoveRect.x){
				mx = this._barMoveRect.x;
			}else if( mx > this._barMoveRect.width){
				mx = this._barMoveRect.width;
			}
			this._SetBarPos( mx );
		}else if(this._barMoveRect.y > 0){
			var my = move.y - this._downPostion.y ;
			my = this._curBarY + my;
			if(my < this._barMoveRect.y){
				my = this._barMoveRect.y;
			}else if(my > this._barMoveRect.height){
				my = this._barMoveRect.height;
			}
			this._SetBarPos( my );
		}
	},
	_SetBarPos:function( pos  ){
		if(this._type === MUISlider.H_SLIDER){
			this._btnBar.y = pos;
		}else{
			this._btnBar.x = pos;
		}
		this.signalCursor.dispatch();
	},
	SetContentSize:function(width , height){
		this.setContentSize( width , height );
		this.uiWidth = width;
		this.uiHeight = height;
	},
	GetRangeWidth:function (){
		if(this._barMoveRect == null)
			return 0;
		return this._barMoveRect.width;
	},
	GetRangeHeight:function (){
		if(this._barMoveRect == null)
			return 0;
		if(this._type == MUISlider.H_SLIDER)
			return this._barMoveRect.height - this._btnDown.height;
		else
			return this._barMoveRect.width - this._btnDown.width;
	},
	_GetBarPos:function (){
		if(this._barMoveRect == null)
			return 0;
		var pos;
		if(this._barMoveRect.x > 0){
			pos = this._btnBar.x - this._barMoveRect.x;
		}else if(this._barMoveRect.y > 0){
			pos = this._btnBar.y - this._barMoveRect.y;
		}
		return pos;
	},
	GetBarPosPer:function (){
		if(this._barMoveRect == null)
			return 0;
		var bgHei = 0;
		if(this._type == MUISlider.H_SLIDER)
			bgHei = this._barMoveRect.height - this._barMoveRect.y; 
		else
			bgHei = this._barMoveRect.width - this._barMoveRect.x;
		var per = (1 - this._GetBarPos() / bgHei);
		return per;
	},
	GetBarPosPerMiddle:function (){
		if(this._barMoveRect == null)
			return 0;
		var per;
		if(this._barMoveRect.x > 0){
			per = (this._btnBar.x - this._barMoveRect.x + this._btnBar.width * 0.5) / this._barMoveRect.width;
		}else if(this._barMoveRect.y > 0){
			per = (this._btnBar.y - this._barMoveRect.y + this._btnBar.height * 0.5) / this._barMoveRect.height;
		}
		return per;
	},
	SetBarPosPer:function (per){
		if(per == null)
			per = 0;
		if(per < 0)
			per = 0;
		if(per > 1)
			per = 1;
		per = 1 - per;
		var bgHei = 0;
		var newPos = 0;
		if(this._type == MUISlider.H_SLIDER){
			bgHei = this.GetRangeHeight();
			newPos = bgHei * per ;
			this.initBarPosFlag = false;
			this._btnBar.y = (newPos + this._barMoveRect.y) ? (newPos + this._barMoveRect.y) : 0;
		}else{
			bgHei = this.GetRangeHeight();
			newPos = bgHei * per ;
			this.initBarPosFlag = false;
			this._btnBar.x =  (newPos + this._barMoveRect.x) ? (newPos + this._barMoveRect.x) : 0;
		}
	},
	SetBarLengthPer:function ( per ){
		if(per == null)
			per = 0;
		if(per < 0)
			per = 0;
		if(per > 1)
			per = 1;
		
		this._btnBar.visible = true;
		this.isBarLenLimited = false;
		
		var bgHei = 0;
		if(this._type == MUISlider.H_SLIDER)
			bgHei = this._barMoveRect.height + this._btnBar.height;
		else
			bgHei = this._barMoveRect.width + this._btnBar.width;
		var newLen = bgHei * per;
		if(newLen <= this._minHBarLen){
			this.isBarLenLimited = true;
			newLen = this._minHBarLen;
			if(bgHei < this._minHBarLen){
				this._btnBar.visible = false;
			}
		}
		var posPer = this.GetBarPosPer();
		if(this._type == MUISlider.H_SLIDER){
			this.ResizeBar( this._btnBar.width , newLen );
		}else{
			this.ResizeBar( newLen , this._btnBar.height );
		}
		this.SetBarPosPer(posPer);
	},
} );

MUISlider.H_SLIDER = "HSlider";
MUISlider.W_SLIDER = "WSlider";
