/**
 * base64编码算法
 **/
var Base64Util = Base64Util || {
	keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
	
	encode:function(input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;

		while (i < input.length) {
			chr1 = input[i++];
			chr2 = i < input.length ? input[i++] : Number.NaN;
			chr3 = i < input.length ? input[i++] : Number.NaN;

			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;

			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			output += this.keyStr.charAt(enc1) + this.keyStr.charAt(enc2) + 
			this.keyStr.charAt(enc3) + this.keyStr.charAt(enc4);
		}
		return output;
	},
	
	decode:function(input) {
		var output = [],
		chr1, chr2, chr3,
		enc1, enc2, enc3, enc4,
		i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		while (i < input.length) {
			enc1 = this.keyStr.indexOf(input.charAt(i++));
			enc2 = this.keyStr.indexOf(input.charAt(i++));
			enc3 = this.keyStr.indexOf(input.charAt(i++));
			enc4 = this.keyStr.indexOf(input.charAt(i++));

			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;

			output.push(String.fromCharCode(chr1));

			if (enc3 !== 64) {
				output.push(String.fromCharCode(chr2));
			}
			if (enc4 !== 64) {
				output.push(String.fromCharCode(chr3));
			}
		}

		//output = output.join('');

		return output;
	},
};
