﻿/**
 * *********  操作实例  **************
 *	var map = new HashMap();
 *	map.put("key1","Value1");
 *	map.put("key2","Value2");
 *	map.put("key3","Value3");
 *	map.put("key4","Value4");
 *	map.put("key5","Value5");
 *	alert("size："+map.size()+" key1："+map.get("key1"));
 *	map.remove("key1");
 *	map.put("key3","newValue");
 *	var values = map.values();
 *	for(var i in values){
 *		document.write(i+"："+values[i]+"   ");
 *	}
 *	document.write("<br>");
 *	var keys = map.keys();
 *	for(var i in keySet){
 *		document.write(i+"："+keySet[i]+"  ");
 *	}
 *	alert(map.isEmpty());
 */

function HashMap(){
	//定义长度
	var length = 0;
	//创建一个对象
	var obj = new Object();

	/**
	 * 判断Map是否为空
	 */
	this.IsEmpty = function(){
		return length == 0;
	};

	/**
	 * 判断对象中是否包含给定Key
	 */
	this.ContainsKey=function(key){
		return (key in obj);
	};

	/**
	 * 判断对象中是否包含给定的Value
	 */
	this.ContainsValue=function(value){
		for(var key in obj){
			if(obj[key] == value){
				return true;
			}
		}
		return false;
	};

	/**
	 *向map中添加数据
	 */
	this.Put=function(key,value){
		if(!this.ContainsKey(key)){
			length++;
		}
		obj[key] = value;
	};

	/**
	 * 根据给定的Key获得Value
	 */
	this.Get=function(key){
		return this.ContainsKey(key)?obj[key]:null;
	};

	/**
	 * 根据给定的Key删除一个值
	 */
	this.Remove=function(key){
		if(this.ContainsKey(key)&&(delete obj[key])){
			length--;
		}
	};

	/**
	 * 获得Map中的所有Value
	 */
	this.Values=function(){
		var _values= new Array();
		for(var key in obj){
			_values.push(obj[key]);
		}
		return _values;
	};

	/**
	 * 获得Map中的所有Key
	 */
	this.Keys=function(){
		var _keys = new Array();
		for(var key in obj){
			_keys.push(key);
		}
		return _keys;
	};
	
	this.EachKey=function(f){
		for(var key in obj){
			f(key);
		}
	};

	this.EachValue=function(f){
		for(var key in obj){
			f(obj[key]);
		}
	};
	
	/**
	 * 获得Map的长度
	 */
	this.Size = function(){
		return length;
	};

	/**
	 * 清空Map
	 */
	this.Clear = function(){
		length = 0;
		obj = new Object();
	};
}