﻿/**
 * ui工具类
 */

var UIUtil = UIUtil || {
		GetCCColor: function (color, alpha) {
			alpha = alpha || 0xff;
			var a = color >> 24 & 0xff;
			var r = color >> 16 & 0xff;
			var g = color >> 8 & 0xff;
			var b = color & 0xff;
			if (!a)
				a = alpha;
			var c = new cc.Color(r, g, b, a);
			return c;
		},
		GetTextByHtmlText: function (htmlText) {
			if (htmlText == null)
				return "";
			var text = "";
			if (htmlText != null && htmlText != "") {
				var reg = /<[^<]+>/g;
				try {
					text = htmlText.replace(reg, "");
				} catch (err) {
					ToolBase.Log("UIUtil::GetTextByHtmlText ");
				}
			}
			return text;
		},
		ConnectLabelText: function (label, param) {
			if (label instanceof MUILabel) {
				label.SetString(this._ConectParam(label.GetText(), param));
			}
		},
		ConnectLabelHtmlText: function (label, param) {
			if (label instanceof MUILabel) {
				label.SetHtmlText(this._ConectParam(label.GetHtmlText(), param));
			}
		},
		_ConectParam: function (html, params) {
			if (params == null)
				return html;
			if (html == null)
				return null;
			if (params != null && params.length > 0) {
				var i = 0;
				var len = params.length;
				if (html.indexOf("{@}") != -1) {
					for (i = 0; i < len; ++i) {
						html = html.replace("{@}", params[i]);
					}
				}
				else {
					for (i = 0; i < len; ++i) {
						html = html.replace("{" + (i + 1).toString() + "}", params[i]);
					}
				}
			}
			return html;
		},
		ObjIsString: function (obj) {
			return typeof obj === "string";
		},
		//parent 是否包含显示对象child 不局限于子对象
		IsContains: function (parent, child) {
			var childp = child.parent;
			while (childp) {
				if (childp == parent)
					return true;
				childp = childp.parent;
			}
			return false;
		},
		/**
		 * 支持单图加载	理论上只有Icon才会用到
		 * @param url
		 * @param defaultUrl
         * @constructor
         */
		GetIconByUrl: function (url, defaultUrl, isItem) {
			isItem = isItem != false;

			var image = new MUIBackgroundImage();
			var res = isItem ? EngineMgr.uiMgr.GetIconByUrl( url ) : EngineMgr.uiMgr.GetResByUrl( url );
			if( !res && defaultUrl ){
				image.SetData( defaultUrl );		//设置默认图标
				image.width = image.height = 60;
			}
			else {
				image.SetData( url );
				image.width = image.height = 74;
			}
			return image;
		},
		GetMiniMapImageByMid: function (mid) {
			var image = new MUIBackgroundImage();
			var retBitmap = LoadMgr.LoadImage("res/map/" + mid + "/thumbnails.jpg", image, LoadPriority_Common, {
				complete: image.CallLoaded,
				completeParam: [image]
			})
			return image;
		},
		HitTestPoint: function (uiobj, globelPos) {
			if (uiobj == null || uiobj.parent == null)
				return false;
			var locpos = cc.p(globelPos.x, globelPos.y);
			var childp = uiobj.parnet;
			var inStage = false;
			while (childp) {
				locpos.x = locpos.x - childp.x;
				locpos.y = locpos.y - childp.y;
				if (childp == EngineMgr.uiMgr) {
					inStage = true;
					break;
				}
				childp = childp.parent;
			}
			if (!inStage) {
				return false;
			} else if (cc.rectContainsPoint(uiobj.getBoundingBox(), globelPos)) {
				return true;
			}
			return false;
		},
		UIRemoveSelf: function (uiobj) {
			if (uiobj == null)
				return;
			if (uiobj.parent == null)
				return;
			uiobj.retain();
			uiobj.parent.removeChild(uiobj);
		},
        ShowObjProperty:function (Obj)
        {
            var PropertyList='';
            var PropertyCount=0;
            for(i in Obj){
                if(Obj.i !=null)
                    PropertyList=PropertyList+i+'属性：'+Obj.i+'\r\n';
                else
                    PropertyList=PropertyList+i+'方法\r\n';
            }
            cc.log(PropertyList);
        },

		LocalToGlobel: function (widget, loc, stopPanel) {
			var locpos = cc.p(loc.x, loc.y);
			var temp = widget;
			var inStage = false;
			if (stopPanel == null)
				stopPanel = EngineMgr.uiMgr;
			while (temp) {
				if (temp == stopPanel)
					break;
				locpos.x = locpos.x + temp.x;
				locpos.y = locpos.y + temp.y;
				temp = temp.parent;
			}
			return locpos;
		},
		GlobelToLocal: function (widget, globel, stopPanel) {
			var locpos = cc.p(globel.x, globel.y);
			var temp = widget;
			var inStage = false;
			if (stopPanel == null)
				stopPanel = EngineMgr.uiMgr;
			while (temp) {
				if (temp == stopPanel)
					break;
				locpos.x = locpos.x - temp.x;
				locpos.y = locpos.y - temp.y;
				temp = temp.parent;
			}
			return locpos;
		},
		urlRegExp: function () {
			return new RegExp("^" +
					// protocol identifier
				"(?:(?:https?|ftp)://)" +
					// user:pass authentication
				"(?:\\S+(?::\\S*)?@)?" +
				"(?:" +
					// IP address dotted notation octets
					// excludes loopback network 0.0.0.0
					// excludes reserved space >= 224.0.0.0
					// excludes network & broacast addresses
					// (first & last IP address of each class)
				"(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])" +
				"(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}" +
				"(?:\\.(?:[1-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))" +
				"|" +
					// host name
				"(?:(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)" +
					// domain name
				"(?:\\.(?:[a-z\\u00a1-\\uffff0-9]-*)*[a-z\\u00a1-\\uffff0-9]+)*" +
					// TLD identifier
				"(?:\\.(?:[a-z\\u00a1-\\uffff]{2,}))" +
				"|" +
				"(?:localhost)" +
				")" +
					// port number
				"(?::\\d{2,5})?" +
					// resource path
				"(?:/\\S*)?" +
				"$", "i");
		},

		LoadImage:function( image, url, isScale9, isNew ,cb, isScale){
			isScale9 = isScale9 || false,
				isNew = isNew || false;
			isScale = isScale != false;
			EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
				// 异步，避免该控件已被销毁
				if(!sys.isObjectValid(image)) return;

				var render = image.getVirtualRenderer();
				if( render ){
					if( isNew )
						image.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
					else{
						render.setSpriteFrame(EngineMgr.uiMgr.GetResByUrl( url ), cc.RectZero());
						if( isScale )
							image.setContentSize(new cc.size( image.uiWidth, image.uiHeight ));
						else {
							image.setContentSize(render.getContentSize());
						}
					}
				}

				if( isScale9 )
					image.setCapInsets(image.getCapInsets());

				if(cb) cb.apply(this,arguments);
			}, image);
		},

		LoadButtonImage:function( button, url, isScale9){
			isScale9 = isScale9 || false,
			EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
				var render = button.getRendererNormal();
				if( render )
					render.setSpriteFrame(EngineMgr.uiMgr.GetResByUrl( url ), cc.RectZero());
				render = button.getRendererClicked();
				if( render )
					render.setSpriteFrame(EngineMgr.uiMgr.GetResByUrl( url ), cc.RectZero());
				render = button.getRendererDisabled();
				if( render )
					render.setSpriteFrame(EngineMgr.uiMgr.GetResByUrl( url ), cc.RectZero());
				if( isScale9 ){
					button.setCapInsetsNormalRenderer(button.getCapInsetsNormalRenderer());
					button.setCapInsetsPressedRenderer(button.getCapInsetsPressedRenderer());
					button.setCapInsetsDisabledRenderer(button.getCapInsetsDisabledRenderer());
				}
			}, button);
		},

    	SetRedTipVisible:function(tip, bool){
            if(!tip.isFirst){
                tip.setAnchorPoint(cc.p(0.5, 0.5));
                tip.x += tip.uiWidth/2;
                tip.y += tip.uiHeight/2;
                tip.isFirst = true;
            }
			if(bool){
                if(tip && !tip.isShow){
                    tip.visible = true;
                    // var blink = cc.Blink(0.5, 100);
                    var scale1 = cc.scaleTo(0.2, 0.7);
                    var scale2 = cc.scaleTo(0.2, 1);
                    // var scale_ease_in = scale1.easing(cc.easeIn(0.2));
                    // var scale_ease_in_back = scale2.easing(cc.easeOut(0.2));
                    var seq = cc.sequence(scale1, scale2);
                    tip.runAction(cc.repeatForever(seq));
                    tip.isShow = true;
                }
			}
			else{
                if(tip){
                    tip.visible = false;
                    tip.stopAllActions();
                    tip.isShow = false;
                }
			}
		},
		SetRedTipJump:function(tip){
			if(tip){
                var jump1 = cc.JumpTo(0.5, cc.p(0, 5));
                var jump2 = jump1.reverse();
                var jump_ease_in = jump1.easing(cc.easeIn(0.5));
                var jump_ease_in_back = jump2.easing(cc.easeOut(0.5));
                var seq = cc.sequence(jump_ease_in, jump_ease_in_back);
                tip.runAction(cc.repeatForever(seq));
			}
		},

        CloneUI:function(target){
            var ui = null;
            switch(target.ptype){
                case EnumPanelType.BUTTON:
                    ui = new MUIButton();
                    break;
                case EnumPanelType.CHECKBOX:
                    ui = new MUICheckBox();
                    break;
                case EnumPanelType.IMAGE:
                    ui = new MUIImage();
                    break;
                case EnumPanelType.LABEL:
                    ui = new MUILabel();
                    break;
                case EnumPanelType.GRID:
                    ui = new MUIGrid();
                    break;
                default:
                    return ui;
            }

            ui.topPanel = ui;
            ui.ParseJson( target.jsonobj );
            ui.Init();
            return ui;
        },

		IsAncestorsVisible:function(node){
			if (!node){
				return true;
			}

			if(!node.visible)
				return false;

			return this.IsAncestorsVisible(node.parent);
		},

		AddButtonEffect:function (btn, url) {
			var effect = new MAnimationObject();
			effect.setAnchorPoint(0.5, 0.5);
			effect.sCurActionName = null;
			effect.sResUrlBase = url;
			effect.DoAction("stand5", 1);
			effect.retain();
			btn.addChild(effect);
			btn.effect = effect;
			return effect;
		},

		AddButtonRedTip:function (button, type) {
			if(!type)//type == 0 leftUp type == 1 rightUp
				type = 1;
			var tip = new MUIImage();
			tip.jsonobj = {
				"images": [
					"other/zhujiemian/image/tishi.png"
				],
				"type": "Image",
				"backgroundType": 0,
				"AnchorPoint": {
					"ScaleX": 0.5,
					"ScaleY": 0.5
				},
				"id": "redWarm",
				"childs": [],
				"bindData": {},
				"Position": {
					"Y": button.uiHeight - 10,
					"X": type > 0 ? button.uiWidth - 10 : 0,
				},
				"Size": {
					"Y": 42,
					"X": 42
				},
				"tipsId": ""
			};
			tip.Init();
			tip.retain();
			button.addChild(tip);
			tip.setLocalZOrder(100);
			button.redWarm = tip;//这里做个标记，不然用到的地方都要声明变量来存
			return tip;
		},
	};

