/**
 * Created by merlin on 2016/8/16.
 */
var BlurShadowEffect = BlurShadowEffect || cc.Class.extend({
        _shadowArr:null,
        _oCo:null,
        _timerId:0,
        _startAlpha:128,
        _interval:0.12,
        _maxCount:7,
        _isRunning:false,

        ctor:function(){
            this._shadowArr = [];
        },

        OnFrame:function(){
            //停了就不生产新的 等全部透明后销毁
            var shadowObj;
            if( this._shadowArr.length >= this._maxCount ){
                shadowObj = this._shadowArr.shift();
                if( shadowObj.parent )
                    shadowObj.parent.removeChild( shadowObj );
            }

            var len = this._shadowArr.length;
            var intervalAlpha = this._startAlpha / this._maxCount;
            var alpha;
            for( var i = len - 1; i >= 0; i-- ){
                shadowObj = this._shadowArr[i];
                alpha = shadowObj.getOpacity() - intervalAlpha;
                if( alpha <= 0 ){
                    this._shadowArr.splice(i , 1);
                    if( shadowObj.parent )
                        shadowObj.parent.removeChild( shadowObj );
                }
                else
                    shadowObj.setOpacity( alpha );
            }

            if( this._isRunning && this._oCo && this._oCo.oAnimGroup ){
                var shadow = new cc.Sprite();
                shadow.setSpriteFrame( this._oCo.oAnimGroup.oBaseAnimObj.getSpriteFrame() );
                shadow.setFlippedX( this._oCo.oAnimGroup.oBaseAnimObj.isFlippedX() );
                shadow.setScale(MGameDefine.ANIMATION_SCALE);
                shadow.setOpacity( this._startAlpha );
                shadow.setPosition( this._oCo.x, this._oCo.y );
                this._shadowArr.push( shadow );
                Mgr.sceneLayer.AddBottom( shadow );
            }

            if( !this._isRunning  && this._shadowArr.length == 0 ){
            	TimerUtil.ClearTimeUpdate( this._timerId, this );
            	BlurShadowEffect.blurShadowMap.Remove( this._oCo.nGid );
            }
        },

        StartShadow:function( obj, count, startAlpha, interval ){
            this._oCo = obj;
            this._maxCount = count || 7;
            this._startAlpha = startAlpha || 128;
            this._interval = interval || 0.12;
            this._isRunning = true;
            this._timerId = TimerUtil.TimeUpdate( this.OnFrame, this, this._interval );
        },

        StopShadow:function () {
            this._isRunning = false;
        }
    });
BlurShadowEffect.blurShadowMap = new HashMap();
BlurShadowEffect.StartShadow = function( obj ){
    var shadow = BlurShadowEffect.blurShadowMap.Get( obj.nGid );
    if( !shadow ){
        shadow = new BlurShadowEffect();
        BlurShadowEffect.blurShadowMap.Put( obj.nGid , shadow );
        shadow.StartShadow( obj );
    }
    else{
    	shadow._isRunning = true;
    }
};
BlurShadowEffect.StopShadow = function( obj ){
    var shadow = BlurShadowEffect.blurShadowMap.Get( obj.nGid );
    if( shadow ){
        shadow.StopShadow( obj );
    }
};