/**
 * Created by merlin on 2018/6/7.
 */
var DragonEffect = DragonEffect || MAnimationObject.extend({

        _player:null,
        _modelId:0,
        _timeId:0,
        _isMoving:false,

        ctor:function(player){
            this._super();
            this._player = player;
        },

        SetModelId:function(modelId){
            if( this._modelId != modelId ){
                this._modelId = modelId;
                var url = SceneObjUtil.GetSceneReslineUrl( EnumResline.DRAGON, modelId, 0);
                this.SetResUrlBase(url);
                var dir = this._player.nCurDirection;
                if( dir == MDirection.NONE )
                    dir = MDirection.DOWN;
                this.DoAction("stand", dir);
            }
            this.ShowEffect();
        },

        ShowEffect:function(){
            if( !this._timeId ){
                this._timeId = TimerUtil.TimeUpdate( this.OnFrame, this );
                this.hideTimeId = TimerUtil.SetTimeout( this, this.HideEffect, ToolBase.RamdonRangeInt(3000, 8000));
            }
            if( this.showTimeId )
                TimerUtil.ClearTimeout( this.showTimeId );
            var dir = this._player.nCurDirection;
            if( dir == MDirection.NONE )
                dir = MDirection.DOWN;
            this.SetDirection( dir );
            this.x = this._player.x + DragonEffect.OFFSETS[dir][0];
            this.y = this._player.y - DragonEffect.OFFSETS[dir][1];
            this.runAction(cc.fadeIn(1));

        },

        Dispose:function(){
            if( this._timeId )
                TimerUtil.ClearTimeUpdate( this._timeId, this );
            if( this.showTimeId )
                TimerUtil.ClearTimeout( this.showTimeId );
            if( this.hideTimeId )
                TimerUtil.ClearTimeout( this.hideTimeId );
            this._super();
        },

        HideEffect:function(){
            if( this._timeId ){
                TimerUtil.ClearTimeUpdate( this._timeId, this );
                this._timeId = 0;
                this.runAction(cc.fadeOut(1));
                this.showTimeId = TimerUtil.SetTimeout( this, this.ShowEffect, ToolBase.RamdonRangeInt(8000, 15000));
            }
            if( this.hideTimeId )
                TimerUtil.ClearTimeout( this.hideTimeId );
        },

        OnFrame:function(){
            if( !this._player )
                return;
            var dir = this._player.nCurDirection;
            if( dir == MDirection.NONE )
                dir = MDirection.DOWN;
            var tarPos = cc.p( this._player.x + DragonEffect.OFFSETS[dir][0], this._player.y - DragonEffect.OFFSETS[dir][1] );
            var xDis = tarPos.x - this.x;
            var yDis = tarPos.y - this.y;
            if( !this._isMoving ){
                if( Math.abs(xDis) < 250 && Math.abs(yDis) < 250 )
                    return;
                this._isMoving = true;
            }
            if( Math.abs(xDis) < 5 && Math.abs(yDis) < 5 ){
                this._isMoving = false;
            }
            if( Math.abs(xDis) > 600 || Math.abs(yDis) > 600 ){
                this.x = this._player.x + DragonEffect.OFFSETS[dir][0];
                this.y = this._player.y - DragonEffect.OFFSETS[dir][1];
                this.SetDirection( dir );
                return;
            }
            dir = FightUtil.PosToDir( cc.p(this.x, -this.y), cc.p( tarPos.x, -tarPos.y) );
            this.SetDirection( dir );
            var speedX = this.GetSpeedRatio( Math.abs(xDis) );
            var speedY = this.GetSpeedRatio( Math.abs(yDis) );
            this.x += xDis * speedX;
            this.y += yDis * speedY;
        },

        GetSpeedRatio:function( dis ){
            var ratio = 0.05;
            if( dis < 1000 )
            {
                ratio += ( 1000 - dis ) * .00001;
                if( dis < 50 )
                {
                    ratio += ( 50 - dis ) * .0001;
                    if( dis < 10 )
                    {
                        ratio += ( 10 - dis ) * .003;
                    }
                }
            }
            return ratio;
        }
    });
DragonEffect.OFFSETS = [ [0, 60], [-100, 60], [-100, -40], [-100, -110], [0, -110], [100, -110], [100, -40], [100, 60] ];