/**
 * 击飞从移动里独立出来
 * Created by merlin on 2016/6/8.
 */
var FlyBackEffect = FlyBackEffect || cc.Class.extend({
    _objV:null,
    _radius:0,
    _startPos:null,
    _pixelPoint:null,
    _targetPos:null,
    _startTime:0,
    _totalTime:0,
    _isNextBar:false,	//下一个点是否是阻挡

    isFirst:true,
    _type:0,		//0正常死亡	1龙卷风秒杀
    _timerUpdateId:0,

    Start:function( objV, radius, type ){
        objV.flyEffect = this;
        this._objV = objV;
        this._radius = radius;
        this._startPos = new cc.p();
        this._pixelPoint = new cc.p();
        this._type = type;

        this.isFirst = true;
        this._isNextBar = false;

        this.CaculateMove();
        this._timerUpdateId = TimerUtil.TimeUpdate( this.OnFrame, this, 0.03 );
    },

    CaculateMove:function(){
        var dis = this.isFirst ? FlyBackEffect.FLY_DIS1 : FlyBackEffect.FLY_DIS2;
        this._startPos.x = this._pixelPoint.x = this._objV.x;
        this._startPos.y = this._pixelPoint.y = this._objV.y;
        if( this._type == FlyBackEffect.TYPE_STORM )
            dis *= FlyBackEffect.STORM;
        this._targetPos = FightUtil.GetTargetPointGL( this._startPos, this._radius, dis );
        var speed = this._objV.nMoveSpeed * ( this.isFirst ? FlyBackEffect.SPEED_SCALE1 : FlyBackEffect.SPEED_SCALE2 );
        if( this._type == FlyBackEffect.TYPE_STORM )
            speed *= FlyBackEffect.STORM;
        this._totalTime = dis / speed * 1000;
        this._startTime = TimerUtil.GetTimer();
    },

    OnFrame:function(){
        if( this._objV == null ){   //底层按时间触发 每帧可能触发多次 移除后可能再触发一次（所有在帧循环内移除帧循环的操作都要注意） --merlin
            return;
        }
        var useTime = TimerUtil.GetTimer() - this._startTime;
        var tempX;
        var tempY;
        var isEnd = false;
        if( useTime < this._totalTime ){
            var moveX = (this._targetPos.x - this._startPos.x) * useTime / this._totalTime;
            var moveY = (this._targetPos.y - this._startPos.y) * useTime / this._totalTime;

            tempX = this._startPos.x + moveX;
            tempY = this._startPos.y + moveY;
        }
        else{
            tempX = this._targetPos.x;
            tempY = this._targetPos.y;
            isEnd = true;
        }

        var gridPt = ToolMap.PixPt2GridPt( tempX, -tempY );
        if ( !this._isNextBar && Mgr.sceneMap.IsGridCanMove( gridPt.x, gridPt.y ) ){
            this._objV.x = tempX;
            this._objV.y = tempY;
        }
        else{
            this._isNextBar = true;
        }

        var ret  = useTime / this._totalTime;
        if( ret > 1 )
            ret = 1;
        var jumpHeight;
        if( !isEnd )
        	jumpHeight = Math.sin(Math.PI * ret ) * ( this.isFirst ? FlyBackEffect.FLY_DIS1 : FlyBackEffect.FLY_DIS2 ) / 3;
        else
            jumpHeight = 0;
        this._objV.SetObjectHeightPos( jumpHeight );
        if( isEnd ){
            if( this.isFirst ){
                this.CaculateMove();
                this.isFirst = !this.isFirst;
            }
            else
                this.OnFlyEnd();
        }
    },

    OnFlyEnd:function(){
        if(this._timerUpdateId){
            if(this._objV)
                this._objV.flyEffect = null;
            this._objV = null;
            TimerUtil.ClearTimeUpdate(this._timerUpdateId, this);
            this._timerUpdateId = 0;
            FlyBackEffect.Delete( this );
        }
    },

    OnRecycle:function(){
    },
    OnRevert:function(){
    },
    Dispose:function() {
    }
});
FlyBackEffect.FLY_DIS1 = 140;		//击飞距离
FlyBackEffect.FLY_DIS2 = 110;
FlyBackEffect.SPEED_SCALE1 = 2.0;		//移速倍率
FlyBackEffect.SPEED_SCALE2 = 2.2;
FlyBackEffect.STORM = 1.3;
FlyBackEffect.TYPE_STORM = 1;

FlyBackEffect.oPool = new MCachePool();
FlyBackEffect.oPool.SetSize( 20 );
FlyBackEffect.oList = [];

FlyBackEffect.Delete = function(o){
    if( o ){
        FlyBackEffect.oPool.Recycle(o);
        for (var i = FlyBackEffect.oList.length - 1; i >= 0; --i){
            if (FlyBackEffect.oList[i] == o){
                FlyBackEffect.oList.splice(i, 1);
                break;
            }
        }
    }
};

FlyBackEffect.Create = function(src, tar, type){
    var eff = FlyBackEffect.oPool.Gain();
    if( !eff ){
        eff = new FlyBackEffect();
    }
    eff.Start(tar, FightUtil.PosToRadian(src.GetPixPt(), tar.GetPixPt()), type);
    FlyBackEffect.oList.push( eff );
    return eff;
};
FlyBackEffect.DisposeAll = function(){
    for (var i = FlyBackEffect.oList.length - 1; i >= 0; --i){
        FlyBackEffect.oList[i].OnFlyEnd();
    }
}
