/*
 *
 * 角色特效
 * tyevlag
 *
 */

var PlayerEffect = PlayerEffect || MAnimationObject.extend({
    STATE_UNINIT:0,
    STATE_INITED:1,
    STATE_DISPOSE:-1,

    nId:0,
    nType:0,
    bStand5:false,
    nDir:-1,
    nLifetime:0,
    nSpeed:0,

    nDelayInitTime:0,
    nEndTime:-1,
    nState:0,
    sCurAction:null,
    nCurDir:0,

    _timeId:-1,

    Init:function() {
        this._super();
        this.setName("PlayerEffect");
    },

    Start:function(){
        this.nState = this.STATE_UNINIT;
        this._timeId = TimerUtil.TimeUpdate( this.OnFrame, this );
    },

    InitEffect:function(){
        if (this.nState != this.STATE_UNINIT)
            return;

        this.nState = this.STATE_INITED;
        this.SetResUrlBase(SceneObjUtil.GetUIModelUrl(this.nId, this.nType));
        this.sCurAction = this.bStand5 ? EnumActionName.STAND5 : EnumActionName.STAND;

        //name = "skilleffect " + url;
        if (this.nLifetime == 0) {
            this.nEndTime = ToolBase.GetTimer() + 3000;		//3秒
        } else if (this.nLifetime < 0) {
            this.nEndTime = -1;
        } else {
            this.nEndTime = ToolBase.GetTimer() + this.nLifetime;
        }

        if (this.nDir < 0)
            this.nDir = MDirection.UP;

        // this.nInitTime = ToolBase.GetTimer();
        this.nCurDir = this.nDir;
        this.SetPlaySpeed(this.nSpeed);
        this.DoAction(this.sCurAction, this.nCurDir);
    },

    Clear:function(){
        this._super();
    },

    OnRecycle:function(){
        this._super();
        if( this._timeId >= 0 )
            TimerUtil.ClearTimeUpdate( this._timeId, this );
        this._timeId = -1;
        this.removeFromParent();  //  因为retain了一次   所以remove没事  不会不会被销毁   不remove会很奇怪
    },

    OnRevert:function(){
        this._super();
    },

    Dispose:function(){
        if( this._timeId >= 0 )
            TimerUtil.ClearTimeUpdate( this._timeId, this );
        this._timeId = -1;
        if (this.bDispose == false){
            this.nState = this.STATE_DISPOSE;
            // this.oTweenskillm = null;
            this._super();
            this.release();
        }
    },

    SetResUrlBase:function(url){
        this._super(url);
    },

    OnFrame:function(){
        if (this.nEndTime > 0 && (ToolBase.GetTimer() > this.nEndTime) ){
            PlayerEffect.Delete(this);
        }
    },

    CallbackAnimationPlayEnd:function(){
        this._super();
        if (this.nLifetime == 0){
            PlayerEffect.Delete(this);
        }
    },
});

PlayerEffect.oPool = new MCachePool();
PlayerEffect.oPool.SetSize( 200 );
PlayerEffect.Delete = function(o){
    if( o ){
        PlayerEffect.oPool.Recycle(o);
    }
};

PlayerEffect.Create = function(id, type, isStand5, dir, lifetime, speed){

    if (isStand5 == undefined)
        isStand5 = true;

    if (type == undefined)
        return null;
    if (dir == undefined)
        dir = MDirection.UP;
    if (lifetime == undefined )
        lifetime = isStand5 ? -1 : 0;
    if (speed == undefined)
        speed = 1;

    var ret  = PlayerEffect.oPool.Gain();
    if( !ret ){
        ret = new PlayerEffect();
        ret.retain();
    }

    ret.nId = id;
    ret.nType = type;
    ret.bStand5 = isStand5;
    ret.nDir = dir;
    ret.nLifetime = lifetime;
    ret.nSpeed = speed;
    ret.Start();
    ret.InitEffect();
    return ret;
};