﻿/*
 * 
 * 自动锁定攻击模块
 * （这个模块只是控制对象的自动锁定攻击目标功能，并非完全的自动挂机战斗）
 * tyevlag
 * 
 */

var AutoFightControl = AutoFightControl || cc.Class.extend({
	// 控制的场景对象
	oCo:null,
	oSkillcd:null,

	// 自动锁定攻击目标
	nAutoAttackGID:0,
	// 自动锁定攻击技能id
	nAutoAttackSkillMID:0,

	/// 攻击冷却（启动攻击开始到要走动或下次攻击需要等待的时间，主要是为了等服务器反馈）
	nAttackLockTime:0,

	nCurTryFightSkillmid:0,
	nCurTryFightTargetgid:0,
	nextMoveTime:0,

	bDispose:false,

	nCurMoveParam:null,
	
	ctor:function() {
		this.oSkillcd = new HashMap();
	},

	StartControl:function(tar) {
		this.oCo = tar;
	},

	ReleaseControl:function() {
		this.Dispose();
	},

	Dispose:function() {
		this.oCo = null;
		this.bDispose = true;
	},

	OnFrame:function(){
		if (this.nAutoAttackGID != 0){
			this.GoonAttackTarget();
		}
	},
	
	IsAttackLock:function() {
		return (ToolBase.GetTimer() < this.nAttackLockTime);
	},

	SetAttackDelay:function() {
		this.nAttackLockTime = ToolBase.GetTimer() + 1000;
	},

	ClearAttackDelay:function() {
		this.nAttackLockTime = 0;
	},

	// 设置锁定自动攻击目标
	SetLockAutoAttackTarget:function(tar, skillmid) {
		this.nAutoAttackGID = tar.nGid;
		this.nAutoAttackSkillMID = skillmid;
		//this.GoonAttackTarget();
	},

	/// 清除锁定自动攻击目标
	ClearLockAutoAttackTarget:function(){
		this.nAutoAttackGID = 0;
		this.nAutoAttackSkillMID = 0;
		this.nCurMoveParam = null;
	},
	
	CheckClearAutoLock:function(gid){
		if (gid == this.nAutoAttackGID){
			this.ClearLockAutoAttackTarget();
		}
	},
	
	// 继续追击目标，可能直接攻击，可能寻路追
	GoonAttackTarget:function() {
		if (this.bDispose)
			return;

		if( !Mgr.sceneAction.oCtrlObject )
			return;

		if (this.nCurMoveParam != null && this.oCo.IsMoving()){		//这里移动中也应该继续才对	不然目标如果移动 移动路径不会更新  	-- merlin
			if( Date.now() < this.nextMoveTime )	//跑得太久了还是及时更新追踪点
				return;
		}

		if( this.oCo.IsDeadState() )
			return;

		if( !Mgr.mainPlayer.CanSetState( EnumActionType.ATTACK ) )
			return;

		var to = Mgr.sceneObj.FindObject(this.nAutoAttackGID);

		if( !to )
			return;

		if( this.IsAttackLock() )
			return;

		if( !this.nAutoAttackSkillMID ){	//有指定技能时先走指定技能
			var autoId = this.GetAutoSkillId();	//技能不受动作影响 前端根据cd自动施放
			if( autoId > 0 ){
				if (!to.IsDeadState()) {
					var togGridpt = to.GetGridPt();
					var dis = ToolMap.CalcDistance(this.oCo.GetGridPt(), togGridpt);
					var needdis = SkillUtil.GetSkillDis(autoId);

					if (dis < needdis) {
						Mgr.fight.FightToTarget(this.oCo, to, autoId);
						return;
					}
				}
			}
		}
		
		// 移动的时候都不可以
//		if (this.oCo.IsMoving())
//			return false;
		if (this.oCo.IsActionAttacking())
			return false;
		//优先使用指定技能
		var skillmid = this.nAutoAttackSkillMID ? this.nAutoAttackSkillMID : this.GetAutoBaseSkillId();
		if (this.IsSkillCoolDown(skillmid))
			return false;

		if (!to.IsDeadState()) {
			var begin = this.oCo.GetGridPt();
			var togGridpt = to.GetGridPt();
			var dis = ToolMap.CalcDistance(begin, togGridpt);
			var needdis = SkillUtil.GetSkillDis(skillmid);
			if (this.oCo.IsMoving())
				needdis = Math.max( needdis - 3, 1 );
			if (dis > needdis) {
				if (this.oCo.IsCanDoRun() == false)
					return false;

				var radian = FightUtil.PosToRadian(togGridpt, begin);
				var cosX = 2 * Math.cos( radian );
				var sinY = 2 * Math.sin( radian );
				if( Math.abs(cosX) < 1 ){
					sinY = (sinY < 0 ? Math.floor(sinY) : Math.ceil(sinY));
				}
				else if( Math.abs(sinY) < 1 ){
					cosX = (cosX < 0 ? Math.floor(cosX) : Math.ceil(cosX));
				}
				var movept = new cc.p( togGridpt.x + (cosX > 0 ? Math.floor(cosX) : Math.ceil(cosX)), togGridpt.y + (sinY > 0 ? Math.floor(sinY) : Math.ceil(sinY)) );//FightUtil.GetTargetPoint(togGridpt, FightUtil.PosToRadian(togGridpt, begin), 2);//ToolMap.CalcNearPt(togGridpt, MDirection.GetObDir(dir), 0, 2);
				this.nCurMoveParam = new AutoPathParam();
				if(!Mgr.sceneMap.IsGridCanMove(movept.x, movept.y))		// 不能用直接从原点开始找周围的点,  RunToPt里优先靠近自己的 如果跨阻挡点可能要GG
					movept = Mgr.sceneMap.oMapGrid.FixBlockPoint2( togGridpt );
				this.oCo.oCtrlAutoPath.RunToPt(movept, this.nCurMoveParam, true);
				this.nextMoveTime = Date.now() + 1000;
				return true;
			} else {
				if (this.oCo.IsMoving())
				{
					// this.oCo.StopMove();
					Mgr.map.SendReqPlayerStopMessage();
				}
				Mgr.fight.FightToTarget(this.oCo, to, skillmid);
				if( this.nAutoAttackSkillMID )	//指定技能只放一次
					this.nAutoAttackSkillMID = 0;
				return true;
			}
		} else {
			this.ClearLockAutoAttackTarget();
			return false;
		}
	},
	
	ClearTryFightToTarget:function() {
		this.nCurTryFightSkillmid = 0;
		this.nCurTryFightTargetgid = 0;
	},

	/// <summary>
	/// 老版追击寻路，其实追击攻击已经通用了，这个可以淘汰了
//	TryFightToTarget(target, skillmid)
//	{
//		SkillVo svo = this.oCo.getSkillVo(skillmid);
//		if (svo == null)
//			return -2;
//
//		if (checkCanDoAttack())
//			return -2;
//
//		if (checkTargetCanBeAttack(target) == false)
//			return -2;
//
//		bool isAutoNear = (this.oCo.jobId == PlayerUtil.JOB_ZHAN) || (this.oCo.jobId == PlayerUtil.JOB_DAO && SettingAutoFight.IsTAutoNear) || (this.oCo.jobId == PlayerUtil.JOB_FA && SettingAutoFight.IsMAutoNear);
//
//		Q_skill_model skillm = svo.fullmodel;
//		int nearDis = SkillUtil.getSkillCastDis(svo.mid, svo.fulllevel);
//		int dis = ToolMap.calcDistanceS(this.oCo.ServPt, target.ServPt);
//		int dir = ToolMap.calcDirSlant(this.oCo.ServPt, target.ServPt);
//		if (dis > nearDis)
//		{
//			if ((skillm.q_target & 0x1) != 0 && (target is SceneMonster))
//			{// 可以对自己施放的 在目标距离不够的情况下对自己放 a
//				Mod.fight.sendFightTo(this.oCo, target, svo.mid, -1, -1);
//				return 0;
//			}
//
//			if (skillm.q_skill_job > PlayerUtil.JOB_ZHAN && skillm.q_area_target != 1 && isAutoNear == false)
//			{
//				//Mgr.promptMgr.addPersonInfo( PersIthis.oConTypeEnum.Wrong, TextUtil.formatStr("超过施法范围，技能施放失败") );
//				return -3;
//			}
//			else
//			{
//				Vector2 movept = ToolMap.calcNearPt(target.ServPt, MDirection.getObDir(dir), 0);
//				//if (isRush == false)
//				//	autotype = 1;
//				this.nCurTryFightSkillmid = svo.mid;
//				this.nCurTryFightTargetgid = target.gid;
//				this.oCo.CtrlAutoPathRun.moveToPt(movept, true, new AutoPathParam(AutoPathParam.ENDDO_TRY_MOVE_ATTACK));
//				//getSkillCastDis
//				return 0;
//			}
//		}
//		else
//		{
//			if (isSkillCoolDown(svo.mid))
//				return -2;
//
//			Mod.fight.sendFightTo(this.oCo, target, svo.mid, -1, -1);
//			return 0;
//		}
//	}

	TryFightNoTarget:function(tarPt, skillmid){
		var svo = this.oCo.GetSkillVo(skillmid);
		if (svo == null)
			return -2;

		if (this.CheckCanDoAttack() == false)
			return -2;

		if (this.IsSkillCoolDown(svo.mid))
			return -2;

		var skillm = svo.fullmodel;
		var nearDis = SkillUtil.GetSkillCastDis(svo.mid, svo.fulllevel);
		var dis = ToolMap.CalcDistanceS(this.oCo.ServPt, tarPt);
		var dir = ToolMap.CalcDirSlant(this.oCo.ServPt, tarPt);
		if (dis > nearDis){
			if (SkillUtil.IsSkillNeedRangeCheck(skillm)){
				//Mgr.promptMgr.addPersonInfo( PersIthis.oConTypeEnum.Wrong, TextUtil.formatStr("超过施法范围，技能施放失败") );
				return -3;
			}
		}

		Mgr.fight.SendFightTo(this.oCo, null, svo.mid, tarPt.x, tarPt.y);
		return 0;
	},

	// 是否能进行攻击
	CheckCanDoAttack:function(){
		if (this.oCo == null)
			return false;

		if (this.oCo.IsMoving())
			return false;

//		if (this.oCo.isBackoutStem)
//			return false;
//
//		// 眩晕中，冲撞中
//		if (this.oCo.isAttackAction)
//			return false;
//
//		if (this.oCo.isDeadState)
//			return false;

		return true;
	},

	// 是否可以攻击此目标
	CheckTargetCanBeAttack:function(target){
		if (target == null)
			return false;

		// 是友好目标
		return true;
	},

	OnMoveEnd:function(autopathparam){
		this.nCurMoveParam = null;
		this.GoonAttackTarget();
	},

	DoRushAttack:function(){
		return this.GoonAttackTarget();
	},

	DoNullAttack:function(pixx, pixy, skillmid){
		if (this.IsAttackLock())
			return false;

		if (this.IsSkillCoolDown(skillmid)){
			return false;
		}

		Mgr.fight.SendFightTo(this.oCo, null, skillmid, pixx, pixy);
		return true;
	},

	AddSkillCooldown:function(skillmid, state) {
		var model = Q_skill_model.Get( skillmid + "_" + 1 );
		var cd = model.q_cd;
		
		var pubcd = model.q_public_cd;//SkillUtil.BASE_SKILL_CD.Get(SkillUtil.NORMAL_SKILL_MID_PLAYER)[(state&SkillUtil.MAX_FIGHT_STATE) -1];
		// if(SkillUtil.IsBaseSkill(skillmid)){
		// 	cd = pubcd;
		// }
		if (cd != 0) {
			cd = SkillUtil.GetSkillCd( cd );
			cd += ToolBase.GetTimer();
			if(cd>this.oSkillcd.Get(skillmid))
			this.oSkillcd.Put(skillmid, cd);

			var skills = Mgr.skill.skillInfos.Values();
			var len = skills.length;
			pubcd =  SkillUtil.GetSkillCd( pubcd )+ToolBase.GetTimer();

			//for(var i=0;i<aButton.length;++i){
			//	if(aButton[i].data.Model().q_skillID==skillmid) {
			//		aButton[i].cdImg.SkillCdStar(cd, aButton[i],pubcd);
			//		break;
			//	}
			//}
			for( var i = 0; i < len; i++ ){
				var otherModel =  skills[i].Model();
				if( otherModel && otherModel.q_skillID != skillmid && otherModel.q_public_cd_level == model.q_public_cd_level ){
					if(pubcd>this.oSkillcd.Get(otherModel.q_skillID))
					this.oSkillcd.Put(otherModel.q_skillID, pubcd);
				}
			}
			//让技能面板进入冷却
			Mgr.player.shortPanel.UpdateSkillCd(skillmid);
		}
	},

	IsSkillCoolDown:function(skillmid) {
		var v = this.oSkillcd.Get(skillmid);
		if (v)
		{
			if (ToolBase.GetTimer() < v){
				return true;
			}
			this.oSkillcd.Remove(skillmid);
		}
		return false;
	},

	GetSkillCoolDown:function(mid){
		var v = this.oSkillcd.Get(mid);
		if (v)
		{
			if (ToolBase.GetTimer() < v){
				return v;
			}
		}
		return 0;
	},
	
	RemoveSkillCd:function(mid){
		this.oSkillcd.Remove( mid );
	},

	UpdateSkillCoolDown:function(mid, cd){
		this.oSkillcd.Put(mid, cd);
	},

	GetAutoBaseSkillId:function(){
		// var autoId = SkillUtil.NORMAL_SKILL_MID_PLAYER[0];		//默认取第一个
		// var len = SkillUtil.NORMAL_SKILL_MID_PLAYER.length;
		// for( var i = 0; i < len; i++ )
		// {
		// 	var mid = SkillUtil.NORMAL_SKILL_MID_PLAYER[i];
		// 	if( !this.IsSkillCoolDown(mid) )
		// 	{
		// 		autoId = mid;
		// 		SkillUtil.NORMAL_SKILL_MID_PLAYER.splice(i, 1);
		// 		SkillUtil.NORMAL_SKILL_MID_PLAYER.push(mid);
		// 		break;
		// 	}
		// }
		//
		// return autoId;

		var autoId = SkillUtil.NORMAL_SKILL_MID_PLAYER[0];
		var arr = Mgr.skill.skillInfos.Values();
		var model;
		var len = arr.length;
		var canArr = [];
		for (var j = 0; j < len; j++)
		{
			var skill = arr[j];
			model = skill.Model();
			if( model && model.q_skill_user == 1 && model.q_trigger_type == 1 )	//	这里需要过滤掉被动技能
			{
				if( !SkillUtil.IsNuqiSkill( skill.Mid() ) && !this.IsSkillCoolDown( skill.Mid() ) ){
					canArr.push(skill.Mid());
				}
			}
		}
		if( canArr.length )
			autoId = canArr[ToolBase.RamdonRangeInt(0, canArr.length)];
		return autoId;
	},
	
	GetAutoSkillId:function(){
		var autoId = 0;
		var arr = Mgr.skill.skillInfos.Values();
		var model;
		var len = arr.length;
		for (var j = 0; j < len; j++)
		{
			var skill = arr[j];
			if( SkillUtil.IsBaseSkill( skill.Mid() ) )
				continue;
			model = skill.Model();
			if( model && model.q_skill_user == 1 && model.q_trigger_type == 1 )	//	这里需要过滤掉被动技能
			{
				if( SkillUtil.IsNuqiSkill( skill.Mid() ) ){
					if(  Mgr.player.mainPlayer.attributeData.nuqiPercent >= 100 ){
						var plugset = Mgr.plugset.GetPlugSetInfo();
						if(plugset.skillauto){
                            autoId = skill.Mid();
                            break;
						}
					}
				}
				else if( !this.IsSkillCoolDown( skill.Mid() ) ){
					autoId = skill.Mid();
				}
			}
		}
		return autoId;
	},

	/**
	 * 自动反击
	 * @param tar
	 */
	CounterAttack:function (tar) {
		if( !this.oCo.CanCounterAttack() )
			return;
		if( this.IsAttackLock() )
			return
		// // 如果玩家是活跃状态，则不反击
		// if ( Mgr.mainPlayerV.isActiveState() == true )
		// 	return;
		// 如果选择目标是NPC也不执行自动反击 (暂时改成有目标就不反击 不然同时被多个怪物攻击会频繁调用)
		if ( Mgr.map.nCurtargetgid && Mgr.map.nCurtargetgid != tar.nGid )
			return ;
        //
		// // 自动寻路就不反击了
		// if ( Mgr.mainPlayerV.autoFindPath )
		// 	return;
        //
		// // 如果是采集过程中不反击
		// if ( Mgr.npcMgr.isPlucking() )
		// 	return;
        //
		// 自动战斗状态就不反击了
		if ( Mgr.player.isAutoFight )
			return;
		Mgr.map.SelTarget(tar);
		this.SetLockAutoAttackTarget(tar);
	}
	
});
