var SceneTouchEffectLayer = cc.Layer.extend({

    ctor: function() {
        this._super();
        this._pool = new MCachePool();
        this._pool.SetSize(8);

        this.listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan: this.onTouchBegan.bind(this),
            onTouchMoved: this.onTouchMoved.bind(this),
            onTouchEnded: this.onTouched.bind(this),
            onTouchCancelled: this.onTouched.bind(this),
        });

        cc.eventManager.addListener(this.listener, this);
        this.timerId = TimerUtil.TimeUpdate(this.onTimer, this, 0.1, cc.REPEAT_FOREVER);
    },

    onTouchBegan: function(touch, event) {
        this.toucheTime = Date.now() - 1000;
        this.onShowTouchEffect(touch.getLocation());
        return true;
    },
    onTouched: function(touch, event) {
        //this.onShowTouchEffect(touch.getLocation(), true);
    },
    onTouchMoved: function(touch, event) {
        //this.onShowTouchEffect(touch.getLocation());
    },

    onShowTouchEffect: function(pos, ended) {
        this._markShow = pos;
        TimerUtil.NextFrame(function(){
            if(this._markShow){
                this._onShowTouchEffect(pos, ended);
            }
        },this)
    },
    _onShowTouchEffect: function(pos, ended) {

        //this.autoEffDt = ended ? 0xFFFFFFFF : 1;
        this.autoEffDt = 0xFFFFFFFF;
        this.touchPos = pos;

        var time = Date.now();
        if (time - this.toucheTime < (ended ? 400 : 100)) return;
        this.toucheTime = time;
        this.ShowScreenTouchedEffect(pos);
    },
    onTimer: function(dt) {
        if (this.autoEffDt == null || this.autoEffDt == 0xFFFFFFFF) return;

        this.autoEffDt -= dt;
        if (this.autoEffDt > 0) return;

        this.autoEffDt = 1;
        this.ShowScreenTouchedEffect(this.touchPos);
    },

    CancelMark:function CancelMark(){
        this._markShow = null;
    },

    ShowScreenTouchedEffect: function(pos) {
        var effect = this._pool.Gain();
        if (!effect) {
            effect = new MAnimationObject();
            this.addChild(effect);
        }
        var effectUrl = EffectUtil.GetEffectUrl(EffectUtil.ENUM_TYPE_UI, 999);
        effect.SetResUrlBase(effectUrl);
        effect.SetPlaySpeedScale(0.3);
        effect.SetData(this);

        effect.x = pos.x;
        effect.y = pos.y;
        effect.DoAction("stand", 0, EnumDefaultResType.NONE);
        effect.visible = true;
    },
    CallbackAnimationPlayEnd: function(sender) {
        sender.visible = false;
        this._pool.Recycle(sender);
    }
});