﻿/*
 * 场景怪物
 * tyevlag
 */

var SceneMonster = SceneFightObject.extend({
	hpRate:0,	//血条数目 boss血太多 需要很多管
	nFriendType:0,	//怪物敌对类型 0-全体玩家敌对， 1-全体玩家友好， 2-帮派敌对 3-分身
	sFriendParam:null,

    nWepFashionId:0,
    nJobId:0,
    sWepResUrl:"",

	nextTalkTime:0,
	flyEffect:null,
	
	Init:function() {
		this._super();
		this.setName("SceneMonster");
	},

	Dispose:function(){
		this._super();
		this.nJobId = 0;
		this.sWepResUrl = "";
	},

	OnRecycle:function(){
		this._super();
		this.nJobId = 0;
		this.sWepResUrl = "";
		if( this.flyEffect ){
			this.flyEffect.OnFlyEnd();
		}
	},

	OnRevert:function(){
		this._super();
	},

	OnFrame:function(curTime){
		this._super(curTime);
		var now = TimerUtil.GetTimer();
		if( this.nextTalkTime > 0 && now > this.nextTalkTime ){
			var model = Q_monster.Get(this.nBodyModelId);
			if( model.q_tosay_timeinterval && model.q_say_condition ) {
				Mgr.gameSoundMgr.PlaySound(model.q_say_condition, SoundType.BossTalk, false);
				this.nextTalkTime = now + model.q_tosay_timeinterval;
			}
		}
	},

    SetHide:function (type) {
        this._super(type);

        this.visible = type;
    },
	
	SetDataWithBean:function(msgb){
		this.SetDelayDel(0);
		this.bDeadState = false;
		
		var info = msgb;
		this.oSid = info.monsterId;
		this.nGid = this.oSid.toGID();
		var model = Q_monster.Get( info.monsterModelId );
		this.sBaseName = info.monsterName ? info.monsterName : model.q_name;
		this.setName(this.sBaseName + info.monsterId.toString());
//		this.nGameState = info.state;
		this.nCurLevel = info.level;
//		this.nMaxHp = info.maxHp;
//		this.nMaxMp = info.maxMp;
//		this.nCurHp = info.hp;
//		this.nCurMp = info.mp;
		this.oBloodBar.visible = false;
		// this.oNameBar.visible = false;
		this.nCurDirection = info.dir;

		if (info.monsterRes != null && info.monsterRes != ""){
			this.nWeaponModelId = parseInt( JSON.parse(info.monsterRes).WEAPONRIDE );
			this.nJobId = parseInt( JSON.parse(info.monsterRes).JOB );
			// cc.log( " --------------------------------------------------------------> " + info.monsterRes );//这里有资源造型的时候需要处理
		}

		this.nextTalkTime = 0;
		if( model.q_tosay_timeinterval && model.q_say_condition ){
			Mgr.gameSoundMgr.PlaySound(model.q_say_condition,SoundType.BossTalk,false);
			this.nextTalkTime = TimerUtil.GetTimer() + model.q_tosay_timeinterval;
		}

		this.nBodyModelId = info.monsterModelId;
		this.RefreshShowBody();

		if( model.q_is_direction_fixed != -2 )
			this.nCurDirection = info.dir;
		else
			this.nCurDirection = MDirection.UP;

		if( model.q_exchange == 1 )
			this.SetModelReverse(true);

//		this.SetShowBloodBar(2, false);
// 		this.SetNameShow(this.sBaseName);
		this.hpRate = info.hprate;
		this.UpdateHp(info.hp, info.maxHp);
//
//		this.SetMoveSpeed(info.speed);
		
		var gridpt = ToolMap.PixPt2GridPt(info.x, info.y);
		this.SetServPt(gridpt);
		this.SetGridPt(gridpt);

		this.nFriendType = info.friend;
		this.sFriendParam = info.friendPara;
		//CtrlBuff.setBuffList(BuffUtil.buffInfoToVo(info.buffs));
		this.InitAction();
		this._super(msgb);
	},

	UpdateHp:function(cur, max){
		this._super(cur, max);
		if( cur <= 0  && this.IsNormalMonster() )	//空血怪 实际上已经死了 服务器计算限制延迟1秒才会发死亡
			this.bDeadState = true;
	},
	
	RefreshShowBody:function(){
		var nresid = SceneObjUtil.GetSceneMonsterId(this);
		if (this.nBodyResId != nresid && !this.nJobId) {
			this.nBodyResId = nresid;
			this.sBodyResUrl = SceneObjUtil.GetMonsterBodyUrl(this.nBodyResId);
			this.oAnimGroup.SetResUrlNoAction(this.sBodyResUrl);
		}
		else if(this.nBodyResId != nresid && this.nJobId){
            this.nBodyResId = nresid;
            this.sBodyResUrl = SceneObjUtil.GetPlayerBodyUrl(this.nBodyResId);
            this.oAnimGroup.SetResUrlNoAction(this.sBodyResUrl);
            this.RefreshShowWep();
		}
	},

    RefreshShowWep:function(){
        var weaponUrl = SceneObjUtil.GetSceneWepIdAndUrl(this);
        if ( weaponUrl != this.sWepResUrl){
			if( this.sWepResUrl )
            	this.oAnimGroup.RemoveBindPart(this.sWepResUrl);
            this.sWepResUrl = weaponUrl;
            this.oAnimGroup.AddBindPart(this.sWepResUrl, SceneObjUtil.BIND_ACTION_LAYER_GUANGWU);
        }
    },
	
	DoDeadState:function(){
		this._super();
		//setShowBloodBar(0, false);
		//this.SetDelayDel(2000);
	},
	
	CalcZOrder:function() {
		if (this.bDeadState)
			this.setLocalZOrder(0);
		else
			this._super();
	},

	IsNormalMonster:function(){
		var model = Q_monster.Get(this.nBodyModelId);
		return model.q_monster_type == 1;
	},
	
	IsBoss:function(){
		var model = Q_monster.Get(this.nBodyModelId);
		return (model.q_monster_type == 2 || model.q_monster_type == 3 || model.q_monster_type == 5);
	},

	IsFriend:function () {
		var f = false;
		if( this.nFriendType == 1 )
			f = true;
		else if( this.nFriendType == 3 ){
			var parentId = new Long(this.sFriendParam);
			if( Mgr.mainPlayer.oSid.Equal( parentId ) )
				f = true;
			// if ( Mgr.pvpMgr.curPKMode == EnumPKMode.PK_MODE_PEACE )//和平模式直接友好
			// 	return 1;
		}
		return f;
	},

	/**
	 * 是否是自己分身
	 */
	IsMyShadow:function(){
		if( this.nFriendType == 3 ){
			var parentId = new Long(this.sFriendParam);
			if( Mgr.mainPlayer.oSid.Equip( parentId ) )
				return true;
		}
		return false;
	}
});
