﻿/*
 * 场景NPC
 * tyevlag
 */



var SceneNpc = SceneActiveObject.extend({

	modelType:0,	//0 npc造型 1怪物资源造型
	nServerResId:0,	//服务器资源造型
	_taskArr:null,
	taskImage:null,


	Init:function() {
		this._super();
		this.setName("SceneNpc");
	},

	Dispose:function(){
		this._super();
		if( this.taskImage ){
			this.taskImage.removeFromParent();
			this.taskImage = null;
		}
	},

	OnRecycle:function(){
		this._super();
	},

	OnRevert:function(){
		this._super();
	},

	OnFrame:function(curTime){
		this._super(curTime);
	},
	
	SetDataWithBean:function(msgb){
		var info = msgb;
		this.oSid = info.npcId;
		this.nGid = this.oSid.toGID();
		this.setName(this.sBaseName + info.npcId.toString());
		this.nCurDirection = info.dir;
		this.sBaseName = info.npcName;
		this.nBodyModelId = info.npcModelId;
		
		var gridpt = ToolMap.PixPt2GridPt(info.x, info.y);
		this.SetServPt(gridpt);
		this.SetGridPt(gridpt);
		
		if( info.npcRes )
			this.nServerResId = parseInt( info.npcRes );
		var model = Q_npc.Get( this.nBodyModelId );
		
		
		if (model)
		{
			this.modelType = model.q_resources;
			this.nCurDirection = model.q_direction;
			
			this.SetNameShow(model.q_name);
			if( model.q_isturn == 1 )
				this.SetModelReverse( true );

			if( model.q_task )
				this._taskArr = model.q_task.split(";");
		}
		else{
			this.nCurDirection = info.dir;
		}
//		obj.npcType = model.q_type;
//		obj.isModelTurn = (model.q_isturn == 1);
//		if (!info.npcName)
//			obj.strName = model.q_name;
		
		this.RefreshShowBody();
		this.SetState(0);
		this.SetStateShow(EnumActionType.STAND);

		this.UpdateTaskState();
		this._super(msgb);
		this.oAnimGroup.scale = this.nBodyModelId == NpcUtil.BAO_XIANG_ID ? 1.5 : 1;
	},
	
	RefreshShowBody:function(){
		var nResid = SceneObjUtil.GetSceneNpcId(this);
		if (this.nBodyResId != nResid) {
			this.nBodyResId = nResid;
			this.sBodyResUrl = SceneObjUtil.GetNpcBodyUrl(this.nBodyResId, this.modelType);
			this.oAnimGroup.SetResUrlNoAction(this.sBodyResUrl);
		}
	},

	UpdateTaskState:function(){
		if( this.taskImage ){
			this.taskImage.removeFromParent();
			this.taskImage = null;
		}
        var showMark = false;
		if( this._taskArr ){
			var curId = Mgr.task.aCurTaskId;
			for( var i = 0; i < this._taskArr.length; i++ ){
				if( this._taskArr[i] == curId ){
					if( Mgr.task.GetTaskState(curId) == EnumTaskState.STATE_UNSUBMIT ){
                        showMark = true;
                        break;
                    }
                }
            }
        }
        showMark = showMark || TaskUtil.UpdateSpecialTaskState(this);

        if(showMark){
            this.taskImage = new cc.Sprite( EngineMgr.uiMgr.GetResByUrl( "public/image/renwubiaoshi.png" ) );
            this.taskImage.y = 200;
            this.addChild(this.taskImage);
        }
	},

	UpdateNameShow:function(){
		if( !this.oNameBar )
			return;
		this.oNameBar.visible = NpcUtil.IsNpcShowName(this);
	},

	// 0正常  1行走  2采集中
	SetState:function(state){
		if( this.oAnimGroup )
			this.oAnimGroup.SetGray( state == 2 );
	}

});