﻿var ScenePet = SceneFightObject.extend({

	_ownerId:0,
	nType:0,
	nHorseUpState:0,
	nHorseModelId:0,
	nHorseResId:0,
	sHorseResUrlUp:"",
	sHorseResUrlDown:"",
	checkFightTimeId:-1,

	Init:function() {
		this._super();
		this.setName("ScenePet");
	},

	Dispose:function(){
		this._super();
		if( this.checkFightTimeId >= 0 ){
			TimerUtil.ClearTimeUpdate( this.checkFightTimeId, this );
			this.checkFightTimeId = -1;
		}
	},

	OnRecycle:function(){
		this._super();
		this.ClearBindPartParam();
		if( this.checkFightTimeId >= 0 ){
			TimerUtil.ClearTimeUpdate( this.checkFightTimeId, this );
			this.checkFightTimeId = -1;
		}
	},

	OnRevert:function(){
		this._super();
	},

	lockAttackGID:null,
	CheckAutoFight:function () {
		var time = TimerUtil.GetTimer();
		if( this.IsAttackLock(time) )
			return;

		if( Mgr.sceneMap.bChangingState )
			return;

		if( this.IsMoving() )
			return;

		this.SetAttackLock(time);

		var owner = Mgr.sceneObj.FindObject(this._ownerId.toGID());
		if (owner && owner.oCtrlAutoFight && owner.oCtrlAutoFight.nAutoAttackGID != 0) {
			this.lockAttackGID = owner.oCtrlAutoFight.nAutoAttackGID;
		}

		if( this.lockAttackGID ){
			var tar = Mgr.sceneObj.FindObject(this.lockAttackGID);
			if (tar && !tar.IsDeadState()) {
				this.AttackToTarget(tar);
			}
			else{
				this.lockAttackGID = 0;
			}
		}
	},

	attackLockTime:0,
	SetAttackLock:function(time){
		this.attackLockTime = time + 500;
	},

	ClearAttackLock:function(){
		this.attackLockTime = 0;
	},

	IsAttackLock:function(time){
		return time < this.attackLockTime;
	},

	AttackToTarget:function(tar){
		var skill = Q_retinue_skill.Get( this.nType * 10000 + this.nCurLevel );
		if( skill ){
			var skillArr = JSON.parse( skill.q_skill_id );
			var attackType = 0;
			if ( tar instanceof ScenePlayer  )
				attackType = 1;
			if( !Mgr.mainPlayer.oCtrlAutoFight.IsSkillCoolDown(skillArr[0]) )
				Mgr.fight.SendReqReslineAttackMessage(attackType, tar.oSid, skillArr[0], this.nType);
		}
	},
	
	SetDataWithBean:function(msgb){
		var info = msgb;
		this.oSid = info.petId;
		this.nGid = this.oSid.toGID();
		this.nBodyModelId = info.petModelId;
		this.nType = (msgb.nType != undefined ? msgb.nType : 0);
		this.nHorseModelId = (msgb.nHorseModelId != undefined ? msgb.nHorseModelId:0);
		this._ownerId = info.ownerId;
		if( this.checkFightTimeId >= 0 ){
			TimerUtil.ClearTimeUpdate( this.checkFightTimeId, this );
			this.checkFightTimeId = -1;
		}
		if( this._ownerId.toGID() == Mgr.mainPlayer.nGid ){
			this.checkFightTimeId = TimerUtil.TimeUpdate( this.CheckAutoFight, this, 0.3 );
		}
		this.nCurLevel = info.level;

		this.nCurDirection = info.dir;

        this.RefreshShowBody();

		this.SetStateShow(EnumActionType.STAND);

		var gridpt = ToolMap.PixPt2GridPt(info.x, Math.abs(info.y));
		gridpt.x += 2;
		gridpt.y += 2;
		this.SetServPt(gridpt);
		this.SetGridPt(gridpt);

		this._super(msgb);
	},

	RefreshShowBody:function(){
		var nResid = SceneObjUtil.GetScenePetId(this);
		if (this.nBodyResId != nResid) {
			this.nBodyResId = nResid;
			this.sBodyResUrl = SceneObjUtil.GetPetBodyUrl(this.nBodyResId, this.nType);
			this.oAnimGroup.SetResUrlNoAction(this.sBodyResUrl);
			// 宝骑是绑定书童的，也得重刷一次
			this.RefreshResline(EnumResline.BAOQI);
		}
	},

	UpdateReslineModelid:function ( type, modelid ) {
		switch ( type )
		{
			case EnumResline.BAOQI:
				this.nHorseModelId = modelid;
				break;
		}
	},

	//重写此方法获得状态机
    GetCurActionName:function(){
        if( this.nHorseModelId != 0 )
        {
            var curState = this.nCurActionType;
            switch( curState )
            {
                case EnumActionType.STAND:
                    return "ridestand";
                case EnumActionType.RUN:
                    return "ridewalk";
				case EnumActionType.ATTACK:
                    return "rideattack";
                //case EnumActionType.ATTACK2:
                // case EnumActionType.ATTACK3:
                // case EnumActionType.ATTACK4:
                // case EnumActionType.ATTACK5:
                // case EnumActionType.ATTACK6:
                // case EnumActionType.ATTACK7:
            }
        }
        return this._super();
    },

	RefreshResline:function (reslineType) {
		var self = this;
		switch ( reslineType )
		{
			case EnumResline.BAOQI:
				if (this.sHorseResUrlUp && this.sHorseResUrlDown) {
					this.oAnimGroup.RemoveBindPart(this.sHorseResUrlUp);
					this.oAnimGroup.RemoveBindPart(this.sHorseResUrlDown);
					this.sHorseResUrlUp = "";
					this.sHorseResUrlDown = "";
				}
				if ( this.nHorseModelId > 0 ) {
					var nresid = SceneObjUtil.GetSceneReslineId( reslineType, self);
					var nupurl = SceneObjUtil.GetSceneReslineUrl( reslineType, nresid, 0);
					var ndownurl = SceneObjUtil.GetSceneReslineUrl( reslineType, nresid, 1);

					this.nHorseResId = nresid;
					this.sHorseResUrlUp = nupurl;
					this.sHorseResUrlDown = ndownurl;

					this.oAnimGroup.AddBindPart(this.sHorseResUrlUp, SceneObjUtil.BIND_ACTION_LAYER_HORSE_TOP,SceneObjUtil.horseActionMapping);//添加动画Mapping
					this.oAnimGroup.AddBindPart(this.sHorseResUrlDown, SceneObjUtil.BIND_ACTION_LAYER_HORSE_BOTTOM,SceneObjUtil.horseActionMapping);

				}
				break;
		}

		return true;//暂时这样
	},

	ClearBindPartParam:function () {
		this.nHorseUpState=0;
		this.nHorseModelId=0;
		this.nHorseResId=0;
		this.sHorseResUrlUp="";
		this.sHorseResUrlDown="";
	}
});