﻿/*
 * 场景玩家
 * tyevlag
 */

var ScenePlayer = SceneFightObject.extend({
	nWepModelId:0,
	nWepResId:0,
	sWepResUrl:null,

	nWepEffResId:0,
	sWepEffResUrl:null,

	nJobId:0,

	nDragonModelId:0,
	dragonEff:null,
	nWingId:0,
	sWingResUrl:null,

	sCloakResUrl:null,
	nCloakResId:0,
	nCloakModelId:0,

	// 光武  与上面武器分开
	nWeaponModelId:0,
	nWeaponResId:0,
	sWeaponResUrl:null,
	
	nGodWeaponId:0,	//神武幻化

	nShutongModelId:0,
	sShutongGid:null,

	illusionPetModelId:0,
	illusionPetGid:null,

	nBaoqiModelId:0,

	nHorseUpState:0,
	nHorseModelId:0,
	nHorseResId:0,
	sHorseResUrlUp:"",
	sHorseResUrlDown:"",

	nFashionId:0,
	nWepFashionId:0,

	nDisguiseId:0,
	oHeadTitleId:0,

	nTaijiModelId:0,
	sTaijiResUrl:null,
	sTaijiEff:null,

	nSteepModelId:0,
	sSteepResUrl:null,
	sSteepEffs:null,
	steepCount:0,

    nJianLingModelId:0,
	sJianLingGid:0,

	killNum:0,	//杀人数量 1-2黄名 3-∞红名
	pkValue:0,	//pk值 大于0为灰色时间（优先级高于白和黄名）

	teamId:null,
	guildId:null,
	serverKey:0,

	_timerNum:0,

	attributeData:null,
	Init:function() {
		this._super();
		this.setName("ScenePlayer");
		this.attributeData = new AttributeData();
		this.sSteepEffs = [];
	},

	Dispose:function(){
		this.RemovePet();
		this.RemoveIllusionPet();
		this.RemoveJianLing();
		if( this.oSpouseNameBar )
			this.oSpouseNameBar.Dispose();
		this.oSpouseNameBar = null;
		if( this.sTaijiEff )
			this.sTaijiEff.Dispose();
		this.sTaijiEff=null;
		if( this.dragonEff )
			this.dragonEff.Dispose();
		this.dragonEff = null;
		if( this._simulateHorse )
			this._simulateHorse.Dispose();
		this._simulateHorse = null;
		if( this._wingTimeId )
			TimerUtil.ClearTimeout( this._wingTimeId );
		this._wingTimeId = 0;
		this._super();
	},

	RemovePet:function () {
		if ( this.sShutongGid > 0 ) {
			Mgr.sceneObj.oRoundPetList.Remove(this.sShutongGid);
		}
	},

	RemoveIllusionPet:function(){
        if ( this.illusionPetGid > 0 ) {
            Mgr.sceneObj.oRoundIllusionPetList.Remove(this.illusionPetGid);
        }
	},

	RemoveJianLing:function(){
        if ( this.sJianLingGid > 0 ) {
            Mgr.sceneObj.oRountJianLingList.Remove(this.sJianLingGid);
        }
	},

	ClearBindPartParam:function () {
		this.nWepModelId=0;
		this.nWepResId=0;
		this.sWepResUrl=null;

		this.nDragonModelId=0;
		this.nWingId=0;
		this.sWingResUrl=null;

		this.sCloakResUrl = null;
		this.nCloakResId = 0;
		this.nCloakModelId = 0;

		// 光武  与上面武器分开
		this.nWeaponModelId=0;
		this.nWeaponResId=0;
		this.sWeaponResUrl=null;
		
		this.nGodWeaponId = 0;

		this.nShutongModelId=0;
		this.sShutongGid=null;

        this.illusionPetModelId = 0;
        this.illusionPetGid = null;

		this.nHorseUpState=0;
		this.nHorseModelId=0;
		this.nHorseResId=0;
		this.sHorseResUrlUp="";
		this.sHorseResUrlDown="";

		this.nTaijiModelId=0;
		this.sTaijiResUrl="";
		this.sTaijiEff=null;
	},

	OnRecycle:function(){
		this.RemovePet();
		this.RemoveIllusionPet();
        this.RemoveJianLing();
		if( this.sTaijiEff )
			this.sTaijiEff.Dispose();
		this.sTaijiEff=null;
		if( this.dragonEff )
			this.dragonEff.Dispose();
		this.dragonEff = null;
		if( this._simulateHorse )
			this._simulateHorse.Dispose();
		this._simulateHorse = null;
		if( this._wingTimeId )
			TimerUtil.ClearTimeout( this._wingTimeId );
		this._wingTimeId = 0;
		this.ClearBindPartParam();
		this._super();
	},

	OnRevert:function(){
		this._super();
	},

	OnFrame:function(curTime){
		this._super(curTime);

		if( this._simulateAllTime != 0 ){
			var delta = Date.now() - TimerUtil._lastTime;
			this._simulateJumpTime += delta;
			if( this._simulateJumpTime < this._simulateAllTime ){
				var ret = this._simulateJumpTime / this._simulateAllTime ;
				var height = Math.sin( Math.PI * ret ) * 150;
				this.SetObjectHeightPos( height );
				if( this._simulateHorse ){
					var offPos = MDirection.HORSE_DIS[this.GetCurDirection()];
					this._simulateHorse.x = this.x + offPos.x * ( 1 - ret );
					this._simulateHorse.y = this.y + offPos.y * ( 1 - ret );
				}
			}
			else {
				this.SimulateJumpEnd();
			}
		}
	},

	SetPartHide:function(type, showDragon, showPet, showTitle){
		this.SetHide(type);

		//暂时只做隐藏 不考虑资源加载与内存占用
		var pet = Mgr.sceneObj.FindObject( this.sShutongGid );
		if(pet){
			pet.visible = type && showPet;
			pet.oShadow.visible = type && showPet;
		}
		var jianLing = Mgr.sceneObj.FindObject( this.sJianLingGid );
		if( jianLing ){
			jianLing.visible = type && showPet;
			jianLing.oShadow.visible = type && showPet;
		}
		if( this.dragonEff ){
			this.dragonEff.visible = type && showDragon;
		}

		if(this.otitleBar){
			this.otitleBar.visible = type && showTitle && (this.otitleBar._titleData && this.otitleBar._titleData.q_subfield == 5);
		}
	},

    SetHide:function (type) {
        this._super(type);
        this.oAnimGroup.visible = type;
        this.oBottomContainer.visible = type;
        // this.oShadow.visible = type;

		if( this.otitleBar ){
			this.otitleBar.visible = type;
		}
		if( this.oGuildNameBar ){
			this.oGuildNameBar.visible = type;
		}
		if( this.oNameBar ){
			this.oNameBar.visible = type;
		}
    },

	SetDataWithBean:function(msgb){
		var info = msgb;
		if (msgb.objinfotype == SceneObjectInfoType.PLAYER){
			this.oSid = info.personId;
			this.nGid = this.oSid.toGID();
			this.oHeadTitleId = info.headTitleId;
			this.killNum = info.killnum;
			this.pkValue = info.isGreyname;
			this.sBaseName = SceneObjUtil.GetScenePlayerName(info.name);
			this.setName(this.sBaseName + info.personId.toString());
			this.nCurDirection = info.dir;
			this.UpdateGuangyuId(info.armorShowId);
			this.nWingId = info.armorShowId;
//			name = baseName + info.personId.ToString();
//			gameState = info.state;
			this.nJobId = info.job;
			this.nCurLevel = info.level;
//			sexId = info.sex;
//			curLevel = info.level;
//			maxHp = info.maxHp;
//			maxMp = info.maxMp;
//			curHp = info.hp;
//			curMp = info.mp;
			this.teamId = info.team;
			this.guildId = info.guildid;
			this.serverKey = info.serverKey;

			this.spouseName = info.spouseName;
			this.marryExteriorId = info.marryExteriorId;
            this.aureoleId = info.aureoleId;
            this.marriageId = info.marriageId;
//			nHorseUpState = info.horseisdown;
//
//			nBodyModelId = info.armor;
//			nWepModelId = info.weapon;
//			nDragonModelId = info.raywing;
			this.nBodyModelId = info.job;
			// this.nWepModelId = info.job;
			this.nDisguiseId=info.disguiseId;
			this.nTaijiModelId=info.gossipLevel;
			this.UpdateFashionId(info.curFashion);
            this.RefreshShowBody();
            this.InitAction();

			//var resfreshBody = this.RefreshResline();
			//this.RefreshShowBody();
			//this.RefreshShowWep();
//
//			setDirection(info.dir);
//
//			setMoveSpeed(info.speed);
//			Vector2 gridpt = ToolMap.pixPt2GridPt(info.x, info.y);
//			setServPt(gridpt);
//			setGridPt(gridpt);
//
//			CtrlBuff.setBuffList(BuffUtil.buffInfoToVo(info.buffs));
//
//			initAction();
//
//			setNameShow(info.name);
//			setShowBloodBar(2, true);
//			Mod.minimap.addMinMapPoint(this);

			var gridpt = ToolMap.PixPt2GridPt(info.x, info.y);
			this.SetServPt(gridpt);
			this.SetGridPt(gridpt);
			this.SetNameShow(info.name, true);
			this.SetTitleShow(info.useTitleModel);		//其他玩家不显示称号
			this.SetGuildNameShow( info.guildName );
			this.SetSpouseNameShow( info.spouseName );
			this.UpdateHp(info.hp, info.maxHp);
			if( EnumPlayerState.CheckState( EnumPlayerState.DIE, info.state ) )
				this.DoDeadState();

			// 刷新资源线
			for ( var i = 0; i < info.playerResLineInfo.length; i++ )
			{
				var temp = info.playerResLineInfo[i];

				var mgr = Mgr.resline.GetMgrByType( temp.type );
				// 判断正负负数， 资源线携带Id不同的地方数据类型不一样，心累
				var modelId = temp.modelid;
				if ( (modelId&0x80) > 0 ) {
					modelId = 255 - (modelId - 1);
					mgr._lastEquipModel = modelId;
					modelId = 0;
				}
				this.UpdateReslineModelid( temp.type, modelId);
				this.RefreshResline(temp.type)
			}
		}

        for(var j = 0; j < info.showIllusionInfo.length; j++){
            var temp = info.showIllusionInfo[j];
            this.UpdateIllusionModelId(temp.illusionType, temp.illusionId);
            this.RefreshIllusion(temp.illusionType);
        }

		this._super(msgb);
	},

	SetNameShow:function(n, isPlayer){
		this._super(n, isPlayer);
		this.oNameBar.UpdateNameColor(this.killNum, this.pkValue);
	},

	SetSpouseNameShow:function(n){
		this.spouseName = n;
		if (n && this.oSpouseNameBar == null){
			this.oSpouseNameBar = new SceneSpouseNameBar();
			this.oCtrlDecor.AddTop(this.oSpouseNameBar);
		} else if (!n && this.oSpouseNameBar != null){
			this.oCtrlDecor.RemoveTop(this.oSpouseNameBar);
			this.oSpouseNameBar = null;
		}

		if (this.oSpouseNameBar != null){
			n += "的配偶";
			this.oSpouseNameBar.SetNameShow(n);
		}
	},

	RefreshShowBody:function(force){
		var nresid = SceneObjUtil.GetSceneBodyId(this);
		var nurl = SceneObjUtil.GetPlayerBodyUrl(nresid, this.nSexId, this.nHorseResId != 0, false);
		//if (this.nBodyResId != nresid || nurl != this.sBodyResUrl || force){
		this.nBodyResId = nresid;
		this.sBodyResUrl = nurl;
        this.oAnimGroup.SetResUrlNoAction(this.sBodyResUrl);
		this.SetStateShow(this.nCurActionType, this.nCurDirection, EnumDefaultResType.SCENE_OBJ, true);
		this.RefreshShowWep();
		//}
	},

	RefreshShowWep:function(){
		var weaponUrl = SceneObjUtil.GetSceneWepIdAndUrl(this);
		if ( weaponUrl != this.sWepResUrl){
			this.oAnimGroup.RemoveBindPart(this.sWepResUrl);
			this.sWepResUrl = weaponUrl;
			this.oAnimGroup.AddBindPart(this.sWepResUrl, SceneObjUtil.BIND_ACTION_LAYER_GUANGWU);
		}
	},

	RefreshResline:function( reslineType ){
		var changeBody = false;
		var self = this;
		switch ( reslineType )
		{
			case EnumResline.HORSE:
				if (this.sHorseResUrlUp && this.sHorseResUrlDown) {
					this.oAnimGroup.RemoveBindPart(this.sHorseResUrlUp);
					this.oAnimGroup.RemoveBindPart(this.sHorseResUrlDown);
					this.sHorseResUrlUp = "";
					this.sHorseResUrlDown = "";
				}
				if ( this.nHorseModelId > 0 ) {
					var nresid = SceneObjUtil.GetSceneReslineId( reslineType, self);
					var nupurl = SceneObjUtil.GetSceneReslineUrl( reslineType, nresid, 0);
					var ndownurl = SceneObjUtil.GetSceneReslineUrl( reslineType, nresid, 1);

					this.nHorseResId = nresid;
					this.sHorseResUrlUp = nupurl;
					this.sHorseResUrlDown = ndownurl;

					this.oAnimGroup.AddBindPart(this.sHorseResUrlUp, SceneObjUtil.BIND_ACTION_LAYER_HORSE_TOP, SceneObjUtil.horseActionMapping);
					this.oAnimGroup.AddBindPart(this.sHorseResUrlDown, SceneObjUtil.BIND_ACTION_LAYER_HORSE_BOTTOM, SceneObjUtil.horseActionMapping);
					if( this.nTaijiModelId > 0 ){
						if(this.sTaijiEff){
							this.sTaijiEff.Dispose();
							this.sTaijiEff = null;
						}
					}
				}else{
					if( this.nTaijiModelId > 0 ){
						this.sTaijiResUrl = SceneObjUtil.GetSceneReslineUrl( EnumResline.TAIJI, Q_taijizhidian.Get(this.nTaijiModelId).q_show );

						if(!this.sTaijiEff){
							this.sTaijiEff = new MAnimationObject();
							this.sTaijiEff.sResUrlBase = this.sTaijiResUrl;
							this.sTaijiEff.DoAction("stand5", 0, EnumDefaultResType.NONE);
                            this.oBottomContainer.addChild(this.sTaijiEff,-1);
						}
					}
				}
				break;
			case EnumResline.DRAGON:
				if ( this.nDragonModelId > 0 ) {
					if( !this.dragonEff ){
						this.dragonEff = new DragonEffect(this);
						Mgr.sceneLayer.AddTop( this.dragonEff );
					}
					this.dragonEff.SetModelId( SceneObjUtil.GetSceneReslineId( reslineType, self) )

				}
				else if (this.dragonEff) {
					this.dragonEff.Dispose();
					this.dragonEff = null;
				}
				break;
			case EnumResline.GUANGWU:
				// this.oAnimGroup.ShowAndHideBindPart(this.sWepResUrl, true);
				// if (this.sWeaponResUrl) {
				// 	this.oAnimGroup.RemoveBindPart(this.sWeaponResUrl);
				// 	this.sWeaponResUrl = "";
				// }
                //
				// if ( this.nWeaponModelId > 0 ) {
				// 	this.oAnimGroup.ShowAndHideBindPart(this.sWepResUrl, false);
                //
				// 	var nresid = SceneObjUtil.GetSceneReslineId( reslineType, self);
				// 	var nupurl = SceneObjUtil.GetSceneReslineUrl( reslineType, nresid, 0);
                //
				// 	this.nWeaponResId = nresid;
				// 	this.sWeaponResUrl = nupurl;
                //
				// 	cc.log( "RefreshResline:" + this.sWeaponResUrl, "	nResId:" + this.nWeaponResId  );
				// 	this.oAnimGroup.AddBindPart(this.sWeaponResUrl, SceneObjUtil.BIND_ACTION_LAYER_GUANGWU);
				// }
				this.RefreshShowWep();
				break;
			case EnumResline.SHUTONG:
				if ( this.sShutongGid > 0 ) {
					Mgr.sceneObj.DeleteObject(this.sShutongGid);
					this.sShutongGid = 0;
				}
				if ( this.nShutongModelId > 0 ) {
					var info = new PetInfo();
					info.petId = SceneObjUtil.CreateSimSID();
					this.sShutongGid = info.petId.toGID();
					var nresid = SceneObjUtil.GetSceneReslineId( reslineType, self);
					info.petModelId = nresid;
					info.nType = reslineType;
					info.nHorseModelId = this.nBaoqiModelId;
					info.ownerId = this.oSid;
					info.level = this.nShutongModelId;
					info.speed = 280;
					info.dir = this.nCurDirection;
					info.x = this.x ; // 宠物所在X
					info.y = this.y; // 宠物所在Y
					Mgr.sceneObj.CreatePet( info );
				}
				break;
			case EnumResline.BAOQI:
				if ( this.sShutongGid > 0 ) {
					var pet = Mgr.sceneObj.FindObject( this.sShutongGid );
					if ( pet ) {
						var resfreshBody = pet.RefreshResline(reslineType);
						if (resfreshBody)
							pet.RefreshShowBody();
					}
				}
				break;
			case EnumResline.TAIJI:
				if ( this.nHorseModelId == 0 ) {
					if( this.nTaijiModelId > 0 ){
						var oldUrl = this.sTaijiResUrl;
						this.sTaijiResUrl = SceneObjUtil.GetSceneReslineUrl( EnumResline.TAIJI, Q_taijizhidian.Get(this.nTaijiModelId).q_show );

						if( oldUrl != this.sTaijiResUrl ){
							if(this.sTaijiEff){
								this.sTaijiEff.Dispose();
								this.sTaijiEff = null;
							}
						}
						if(!this.sTaijiEff){
							this.sTaijiEff = new MAnimationObject();
							this.sTaijiEff.sResUrlBase = this.sTaijiResUrl;
							this.sTaijiEff.DoAction("stand5", 0, EnumDefaultResType.NONE);
							this.oBottomContainer.addChild(this.sTaijiEff,0);
						}
					}
				}
				break;
            case EnumResline.STEP:
            // if(this.nHorseModelId == 0){
            if(this.nSteepModelId > 0){
                var step = PlayerEffect.Create(this.nSteepModelId, EnumResline.STEP, false);
                step.x = this.x;
                step.y = this.y;
                Mgr.sceneLayer.AddMiddle(step);
                // for(var i = 0; i < 20; i++){
                // 	var url = SceneObjUtil.GetUIModelUrl(this.nSteepModelId, EnumResline.STEP);;
                // 	if(!this.sSteepEffs[i]){
                // 		var effect = new MAnimationObject();
                //        effect.sResUrlBase = url;
                //        effect.DoAction("stand");
                //        effect.x = this.x;
                //        effect.y = this.y;
                //        Mgr.sceneLayer.AddMiddle(effect);
                //        this.sSteepEffs.push(effect);
                //        break;
                // }
                // else if(!this.sSteepEffs[i]._isForever && this.sSteepEffs[i]._playEnd){
                //        this.sSteepEffs[i].sCurActionName = null;
                //        this.sSteepEffs[i].sResUrlBase = url;
                //        this.sSteepEffs[i].x = this.x;
                //        this.sSteepEffs[i].y = this.y;
                //        this.sSteepEffs[i].DoAction("stand");
                //        break;
                // }
                // }
                // cc.log("=========  no steep  to use  =========");
            }
            // }
            break;
            case EnumResline.JIANLING:
                if ( this.sJianLingGid > 0 ) {
                    Mgr.sceneObj.DeleteObject(this.sJianLingGid);
                    this.sJianLingGid = 0;
                }
                if ( this.nJianLingModelId > 0 ) {
                    var info = new PetInfo();
                    info.petId = SceneObjUtil.CreateSimSID();
                    this.sJianLingGid = info.petId.toGID();
                    var nresid = SceneObjUtil.GetSceneReslineId(reslineType, this);
                    info.petModelId = nresid;
                    info.nType = reslineType;
                    // info.nHorseModelId = this.nBaoqiModelId;
                    info.ownerId = this.oSid;
                    info.level = this.nJianLingModelId;
                    info.speed = 500;
                    info.dir = this.nCurDirection;
                    info.x = this.x ; // 宠物所在X
                    info.y = this.y; // 宠物所在Y
                    Mgr.sceneObj.CreateJianLing( info );
                }
                break;
		}

		return true;//暂时这样
	},

	RefreshIllusion:function(illusionType){
		switch(illusionType){
            case HuanhuaType.TYPE_PET:
                if ( this.illusionPetGid > 0 ) {
                    Mgr.sceneObj.DeleteObject(this.illusionPetGid);
                    this.illusionPetGid = 0;
                }
                if ( this.illusionPetModelId > 0 ) {
                    var info = new PetInfo();
                    info.petId = SceneObjUtil.CreateSimSID();
                    this.illusionPetGid = info.petId.toGID();
                    var nresid = SceneObjUtil.GetIllusionId(illusionType, this.illusionPetModelId);
                    info.petModelId = nresid;
                    info.nType = illusionType;
                    // info.nHorseModelId = this.nBaoqiModelId;
                    info.ownerId = this.oSid;
                    info.level = this.illusionPetModelId;
                    info.speed = 280;
                    info.dir = this.nCurDirection;
                    info.x = this.x ; // 宠物所在X
                    info.y = this.y; // 宠物所在Y
                    Mgr.sceneObj.CreateIllusionPet( info );
                }
                break;
			case HuanhuaType.TYPE_CLOAK:
                if (this.sCloakResUrl) {
                    this.oAnimGroup.RemoveBindPart(this.sCloakResUrl);
                    this.sCloakResUrl = "";
                }

                if ( this.nCloakModelId > 0 ) {
                    this.nCloakResId = SceneObjUtil.GetIllusionId( illusionType, this.nCloakModelId);
                    this.sCloakResUrl  = SceneObjUtil.GetSceneReslineUrl( illusionType, this.nCloakModelId, 0);
                    this.oAnimGroup.AddBindPart(this.sCloakResUrl, SceneObjUtil.BIND_ACTION_LAYER_CLOAK, SceneObjUtil.cloakActionMapping);
                }
                break;
			case HuanhuaType.TYPE_WEAPON:
				this.RefreshShowWep();
				break;
		}
	},

//	SetWingModelId:function(id){
//		nDragonModelId = id;
//		if (this is CMainPlayer)
//		{ 
//			//nDragonModelId = 99995;
//		}
//
//		refreshShowWing();
//	}

	SetHorseState:function(id, state){
		this.nHorseModelId = id;
		this.nHorseUpState = state;

		if (this.IsMainPlayer()){
			//nHorseModelId = 99995;
			//nHorseUpState = (int)Random.Range(0, 2);
		}
		this.RefreshResline(EnumResline.HORSE);
	},

	IsHorseState:function(){
		return this.nHorseUpState == 1;
	},


//	public override void doDeadState()
//	{
//		base.doDeadState();
//		setStateShow(EnumActionType.DEAD);
//	}
//
//	public override void doReviveState()
//	{
//		base.doReviveState();
//		setStateShow(EnumActionType.STAND);
//	}

	IsMainPlayer:function(){
		return false;
	},

	OnMoveEnd:function(dir, movetype) {
		this._super(dir, movetype);
		BlurShadowEffect.StopShadow( this );
	},

	UpdateReslineModelid:function ( type, modelid ) {
		switch ( type )
		{
			case EnumResline.HORSE:
				this.nHorseModelId = modelid;
				break;
			case EnumResline.DRAGON:
				this.nDragonModelId = modelid;
				break;
			case EnumResline.GUANGWU:
				this.nWeaponModelId = modelid;
				break;
			case EnumResline.SHUTONG:
				this.nShutongModelId = modelid;
				break;
			case EnumResline.BAOQI:
				this.nBaoqiModelId = modelid;
				if ( this.sShutongGid > 0 ) {
					var pet = Mgr.sceneObj.FindObject( this.sShutongGid );
					if ( pet )
						pet.UpdateReslineModelid(type, modelid);
				}
				break;
			case EnumResline.TAIJI:
				this.nTaijiModelId = modelid;
				break;
            case EnumResline.STEP:
                this.nSteepModelId = modelid;
                break;
            case EnumResline.JIANLING:
                this.nJianLingModelId = modelid;
                break;
		}
	},

	UpdateIllusionModelId:function(type, modelid){
        switch ( type )
        {
            case HuanhuaType.TYPE_CLOAK:
            	this.nCloakModelId = modelid;
                break;
            case HuanhuaType.TYPE_HORSE:
                break;
            case HuanhuaType.TYPE_PET:
                this.illusionPetModelId = modelid;
                break;
            case HuanhuaType.TYPE_WING:
                break;
            case HuanhuaType.TYPE_WEAPON:
				this.nGodWeaponId = modelid;
                break;

        }
	},

	GetCurActionName:function(){
		if( this.nCurActionType == EnumActionType.JUMP || this.nCurActionType == EnumActionType.JUMP_FLY )
			return MAnimationDefine.GetRandomJump();
		else if( this.nHorseModelId != 0 ){
			var curState = this.nCurActionType;
			switch( curState )
			{
				case EnumActionType.STAND:
					return "ridestand";
				case EnumActionType.RUN:
					return "ridewalk";
				case EnumActionType.ATTACK:
				case EnumActionType.ATTACK2:
				case EnumActionType.ATTACK3:
				case EnumActionType.ATTACK4:
				case EnumActionType.ATTACK5:
				case EnumActionType.ATTACK6:
				case EnumActionType.ATTACK7:
					return "ridestand";
			}
		}
		return this._super();
	},

	SetStateShow:function(at, dir, defaultrestype, bForce){
		var success = this._super(at, dir, defaultrestype, bForce);
		if( success ){
			if( this.nCurActionType === EnumActionType.RUN || this.nCurActionType === EnumActionType.STAND){
				if( !this._wingTimeId )
					this._wingTimeId = TimerUtil.SetTimeout(this, this.ShowWing, ToolBase.RamdonRangeInt( 3000, 10000));
			}
			else{
				this.HideWing(true);
			}
		}
		return success;
	},

	ChangeFlyAction:function(){
		this.oAnimGroup.DoAction( MAnimationDefine.GetRandomJump(), this.nCurDirection );
	},

	UpdateFashionId:function(newFashion){
		this.nWepFashionId = this.nFashionId = 0;//先清零
		if(newFashion){
			//角色时装范围
			for(var i=0;i<newFashion.length;++i){
				var tempId = newFashion[i];
				//武器时装范围
				if( tempId > 100 )
					this.nWepFashionId = tempId;
				else if( tempId > 0 )
					this.nFashionId = tempId;
			}
		}
	},

	UpdateGuangyuId:function(guangyuId)
	{
		if(guangyuId == this.nWingId)
		{
			return;
		}
		this.nWingId = 0;
		if(guangyuId > 0)
		{
			this.nWingId = guangyuId;
		}
		this._RefreshGuangyuRes()
	},
	_wingTimeId:0,
	_isShowWing:false,
	_RefreshGuangyuRes:function()
	{
		if (this.sWingResUrl) {
			this.HideWing(true);
			this.sWingResUrl = "";
		}
		if ( this.nWingId > 0 ) {
			var nresid = this._Getnresid(this.nWingId);
			var nupurl = "res/animation/parts/wing/" + nresid;
			this.nWingId = nresid;
			this.sWingResUrl = nupurl;
			this.ShowWing();
		}
	},
	ShowWing:function(){
		if( this.sWingResUrl && !this._isShowWing ){
			this._isShowWing = true;
			if( this.oAnimGroup ){
				this.oAnimGroup.AddBindPart(this.sWingResUrl, SceneObjUtil.BIND_ACTION_LAYER_WING, SceneObjUtil.guangyiActionMapping);
				this._wingTimeId = TimerUtil.SetTimeout( this, this.HideWing, ToolBase.RamdonRangeInt( 3000, 7000 ));
			}
		}
	},
	HideWing:function(clear){
		if( this._wingTimeId )
			TimerUtil.ClearTimeout(this._wingTimeId);
		this._wingTimeId = 0;
		if( !this.oAnimGroup )
			return;
		if( this._isShowWing )
			this.oAnimGroup.RemoveBindPart(this.sWingResUrl);
		this._isShowWing = false;
		if( !clear )
			this._wingTimeId = TimerUtil.SetTimeout(this, this.ShowWing, ToolBase.RamdonRangeInt( 3000, 10000));
	},
	_Getnresid:function(guangyuid)
	{
		var data = Q_global.Get(1029);
		var list = JSON.parse(data.q_string_value);
		for(var i = 0;i<list.length;i++)
		{
			if(guangyuid == list[i][0])
			{
				return list[i][3];
			}
		}
		return 103;
	},
	OnMoveEnterGird:function (newGridPos) {
		this._super(newGridPos);
		if(this.oMoveRule.nCurMoveActionType == EnumActionType.RUN){ // 两个格子  刷一个脚印
            if(this.steepCount > 1){
                this.RefreshResline(EnumResline.STEP);
                this.steepCount = 0;
            }
            else
                this.steepCount++;
		}
		// 书童跟随
		if ( this.sShutongGid > 0 ) {
			var petObj = Mgr.sceneObj.FindObject( this.sShutongGid );
			if( petObj ){
				var dis = ToolMap.CalcDistance( {x:this.x,y:this.y}, {x:petObj.x,y:petObj.y} );
				if ( Math.abs(dis) > 900 ) {
					petObj.x = this.x + 50;
					petObj.y = this.y - 50;
					petObj.StopMove();
				}
				else if ( Math.abs(dis) > 300 ) {  // 超出距离，跟随
					petObj.SetRunWay([cc.p(this.GetPixPt().x + 50, this.GetPixPt().y - 50)]);
				}
			}
		}
		//跟宠跟随
        if ( this.illusionPetGid > 0 ) {
            var illusionPet = Mgr.sceneObj.FindObject( this.illusionPetGid );
            if( illusionPet ){
                var dis = ToolMap.CalcDistance( {x:this.x,y:this.y}, {x:illusionPet.x,y:illusionPet.y} );
                if ( Math.abs(dis) > 900 ) {
                    illusionPet.x = this.x + 100;
                    illusionPet.y = this.y + 100;
                    illusionPet.StopMove();
                }
                else if ( Math.abs(dis) > 300 ) {  // 超出距离，跟随
                    illusionPet.SetRunWay([cc.p(this.GetPixPt().x + 100, this.GetPixPt().y + 100)]);
                }
            }
        }
        //剑灵跟随
		if(this.sJianLingGid > 0){
            var jianLing = Mgr.sceneObj.FindObject( this.sJianLingGid );
            if( jianLing ){
                var dis = ToolMap.CalcDistance( {x:this.x,y:this.y}, {x:jianLing.x,y:jianLing.y} );
                if ( Math.abs(dis) > 500 ) {
                    jianLing.x = this.x + 120;
                    jianLing.y = this.y + 80;
                    jianLing.StopMove();
                }
                else if ( Math.abs(dis) > 200 ) {  // 超出距离，跟随
                    jianLing.SetRunWay([cc.p(this.GetPixPt().x + 100, this.GetPixPt().y + 100)]);
                }
            }
		}
	},
	GetCurDirection:function(){
		if( this.nCurDirection >= MDirection.UP && this.nCurDirection <= MDirection.LEFT_UP )
			return this.nCurDirection;
		return MDirection.UP;
	},
	_simulateJumpTime:0,
	_simulateAllTime:0,
	_simulateHorse:null,
	OnRideJump:function(modelId){
		if( this._simulateHorse ){
			this._simulateHorse.Dispose();
			this._simulateHorse = null;
		}
		var offPos = MDirection.HORSE_DIS[this.GetCurDirection()];
		if( this.sHorseResUrlDown ){		//只要之前有马就模拟个下马动作
			var downHorse = new MAnimationObject();
			downHorse.SetResUrlBase(this.sHorseResUrlDown);
			downHorse.setPosition(this.getPosition());
			downHorse.setLocalZOrder(this.oAnimGroup.getLocalZOrder()-1);
			downHorse.DoAction("walk",this.GetCurDirection());
			var downMove = cc.MoveBy.create(0.5,cc.p( -offPos.x, -offPos.y ));
			downHorse.runAction(downMove);
			Mgr.sceneLayer.AddMiddle(downHorse);
			TimerUtil.SetTimeout(downHorse, downHorse.Dispose,500);

            /// 屏蔽
            if(this.GetHide()){
                downHorse.visible = false;
            }
		}
		if( modelId > 0 ){ //骑马
			var resId = SceneObjUtil.GetSceneReslineId( EnumResline.HORSE, this, modelId);
			var url = SceneObjUtil.GetSceneReslineUrl( EnumResline.HORSE, resId, 1);

			var upHorse = new MAnimationObject();
			upHorse.SetResUrlBase(url);
			upHorse.x = this.x + offPos.x;
			upHorse.y = this.y + offPos.y;
			upHorse.setLocalZOrder(this.oAnimGroup.getLocalZOrder()-1);
			upHorse.DoAction("walk",this.nCurDirection);
			Mgr.sceneLayer.AddMiddle(upHorse);
			this._simulateHorse = upHorse;
            /// 屏蔽
            if(this.GetHide()){
                upHorse.visible = false;
            }

            this.SetCantSetState(true);
		}
		else{	//下马先刷状态
			var resfreshBody = this.RefreshResline( EnumResline.HORSE );
			if ( resfreshBody )
				this.RefreshShowBody();
		}
		this.oAnimGroup.DoAction("jump2");
		this._simulateAllTime = 1000;
		this._simulateJumpTime = 0;
	},

	SimulateJumpEnd:function(){
        this.SetCantSetState(false);

		this._simulateAllTime = this._simulateJumpTime = 0;
		if( this._simulateHorse ){
			this._simulateHorse.Dispose();
			this._simulateHorse = null;
			var resfreshBody = this.RefreshResline( EnumResline.HORSE );
			if ( resfreshBody )
				this.RefreshShowBody();
		}
		if( this.IsMoving() ){
			switch (this.nCurActionType){
				case EnumActionType.RUN:
					this.oAnimGroup.DoAction( this.nHorseModelId > 0 ? "ridewalk" : "walk");
					this.SetStateShow( EnumActionType.RUN );
					this.SetObjectHeightPos(0);
					break;
				case EnumActionType.JUMP:
					break;
				default:
					break;
			}
		}
		else{
			switch (this.nCurActionType){
				case EnumActionType.STAND:
					this.oAnimGroup.DoAction( this.nHorseModelId > 0 ? "ridestand" : "stand");
					break;
				case EnumActionType.JUMP:
				case EnumActionType.JUMP_SKY2:
					break;
				default:
					this.SetStateShow( EnumActionType.STAND );
					break;
			}
			this.SetObjectHeightPos(0);
		}
	},

	IsSafeArea:function(){
		var pos = this.GetGridPt();
		Mgr.sceneMap.IsGridSafe(pos.x, pos.y);
	}
});
