﻿var SceneObjectType = SceneObjectType || {};

SceneObjectType.ERROR = 0;
SceneObjectType.MAINPLAYER = 1;
SceneObjectType.PLAYER = 2;
SceneObjectType.MONSTER = 3;
SceneObjectType.NPC = 4;
SceneObjectType.PET = 5;
SceneObjectType.ITEM = 6;
SceneObjectType.ILLUSIONPET = 7;
SceneObjectType.JIANLING = 8;
SceneObjectType.EFFECT = 10;
SceneObjectType.HALO = 99;


// 场景对象消息类型
var SceneObjectInfoType = SceneObjectInfoType || {};

SceneObjectInfoType.MAINPLAYER = 1;
SceneObjectInfoType.PLAYER = 2;
SceneObjectInfoType.MONSTER = 3;
SceneObjectInfoType.NPC = 4;
SceneObjectInfoType.PET = 5;
SceneObjectInfoType.ITEM = 6;
SceneObjectInfoType.ILLUSIONPET = 7;
SceneObjectInfoType.JIANLING = 8;
SceneObjectInfoType.EFFECT = 10;
SceneObjectInfoType.MAGIC = 11;
SceneObjectInfoType.HALO = 99;


var SceneModelShowData = SceneModelShowData || cc.Class.extend({
        nBodyModelId: 0,
        nFasionModelId: 0,
        nWepModelId: 0,
        nWingModelId: 0
    });


var SceneObjUtil = SceneObjUtil || {

        BIND_ACTION_LAYER_HORSE_TOP: [2, 2, 2, 2, 2, 2, 2, 2],
        BIND_ACTION_LAYER_HORSE_BOTTOM: [-2, -2, -2, -2, -2, -2, -2, -2],
        horseActionMapping: {"ridewalk": "walk", "ridestand": "stand", "rideattack": "attack"},
        wingActionMapping: {"stand": "stand", "ridestand": "stand", "walk":"stand", "ridewalk":"stand"},
        guangyiActionMapping: {"stand": "stand2", "ridestand": "stand2", "walk":"stand2", "ridewalk":"stand2"},
        cloakActionMapping: {"stand": "stand", "walk": "walk", "attack": "attack", "ridewalk": "walk", "ridestand": "stand", "rideattack": "attack"},

        BIND_ACTION_LAYER_WING: [1, 1, 1, -1, -1, -1, 1, 1],
        BIND_ACTION_LAYER_GUANGWU: [1, 1, 1, 1, -1, 1, 1, 1],
        BIND_ACTION_LAYER_CLOAK: [1, 1, 1, -1, -1, -1, 1, 1],

        MODEL_SEX_HASH:null,


        // 模拟生成唯一id
        CreateSimGID: function () {
            this.CreateSimSID().toGID();
        },

        CreateSimSID: function () {
            return LongUtil.GetLong();
        },

        GetScenePlayerName: function (name) {
            return name;
        },

        GetSceneMonsterId: function (monster) {
            var ret = 1;
            if (monster.nBodyModelId <= 0)
                return ret;

            if (monster.nJobId > 0)
                return monster.nJobId;

            var model = Q_monster.Get(monster.nBodyModelId);
            if (model != null) {
                return model.q_sculpt_resid;
            }
            return monster.nBodyModelId;
        },

        GetScenePetId: function (pet) {
            return pet.nBodyModelId;
        },

        GetSceneNpcId: function (npc) {
            if (npc.nServerResId != 0)
                return npc.nServerResId;

            var model = Q_npc.Get(npc.nBodyModelId);
            if (model != null) {
                return model.q_resource;
            }
            return npc.nBodyModelId;
        },

        /**
         * @param player  ScenePlayer
         * @returns {*}
         * @constructor
         */
        GetSceneBodyId: function (player) {
            var bodyId = player.nJobId;
            //按展示优先级  结婚 > 易容 > 时装 > 职业
            if( player.spouseName && player.marryExteriorId ){
                bodyId = player.marryExteriorId;  //( info.job == 1 ? 1142 : 1143 );
            }
            else if(player.nDisguiseId){
                var disguise = Q_disguise.Get(player.nDisguiseId);
                if( disguise )
                    bodyId = disguise.q_show;
            }
            else if (player.nFashionId > 0)
                bodyId = player.nFashionId;
            else if (player.nBodyModelId > 0)
                bodyId = player.nBodyModelId;
            return bodyId;
        },

        /**
         *
         * @param info 可能是MyPlayerInfo PlayerInfo PlayerBriefInfo
         * @constructor
         */
        GetBodyIdByInfo:function(info){
            var bodyId = info.job;
            if( info.spouseName && info.marryExteriorId ){
                bodyId = info.marryExteriorId;  //( info.job == 1 ? 1142 : 1143 );
            }
            else if( info.wingModel ){
                bodyId = info.wingModel;
            }
            else if( info.disguiseId ){
                var disguise = Q_disguise.Get(info.disguiseId);
                if( disguise )
                    bodyId = disguise.q_show;
            }
            return bodyId;
        },

        GetSceneWepIdAndUrl: function (player) {
            var url = null;
            var job = SceneObjUtil.MODEL_SEX_HASH.Get(player.nBodyResId);
            if( !job )
                job = player.nJobId;
            if (player.nGodWeaponId > 0){
                var resid = Q_illusion.Get( HuanhuaType.TYPE_WEAPON + "_" + player.nGodWeaponId ).q_show;
                var id = job * 100 + resid;        //光武不同性别的模型对应的武器不同
                url = this.PlayerGuangWuPathRoot + id;
            }
            else if (player.nWepFashionId > 0)
                url = "res/animation/parts/fashion/weapon/" + player.nWepFashionId;
            else if (player.nWeaponModelId > 0) {
                var reslineType = EnumResline.GUANGWU;
                var q_id = reslineType + "_" + player.nWeaponModelId;
                var resid = Q_resline.Get(q_id).q_scene_show_id;
                var id = job * 100 + resid;        //光武不同性别的模型对应的武器不同
                url = this.PlayerGuangWuPathRoot + id;
            }
            else {
                url = null;
            }
            return url;
        },

        GetSceneReslineUrl: function (reslineType, id, upstate) {
            var resurl = "res/animation/parts/";
            if (id == 0)
                return "";//不能用0的id
            switch (reslineType) {
                case EnumResline.HORSE:
                    resurl += "mounts/";
                    resurl += id;
                    if (upstate != 0)
                        resurl += "/down";
                    else
                        resurl += "/up";
                    break;
                case EnumResline.DRAGON:
                    resurl += "dragon/";
                    resurl += id;
                    break;
                case EnumResline.GUANGWU:
                    resurl += "flashweapon/";
                    var job = Mgr.mainPlayer.nJobId;
                    job = job *100 + id;
                    resurl += job.toString();
                    break;
                case EnumResline.SHUTONG:
                    resurl += "attendant/";
                    resurl += id;
                    break;
                case EnumResline.BAOQI:
                    resurl += "attendanthorse/";
                    resurl += id;
                    if (upstate != 0)
                        resurl += "/down";
                    else
                        resurl += "/up";
                    break;
                case EnumResline.TAIJI:
                    resurl += "taichi/";
                    resurl += id;
                    break;
                case EnumResline.STEP:
                    resurl += "zuji/";
                    if(id < 10)
                        resurl += "0" + id;
                    else
                        resurl += id;
                    break;
                case EnumResline.JIANLING:
                    resurl += "jingling/";
                    resurl += id;
                    break;
                case HuanhuaType.TYPE_CLOAK:
                    resurl += "pifeng/";
                    var job = Mgr.mainPlayer.nJobId;
                    job = job * 1000 + id;
                    resurl += job.toString();
                    break;
                default:
                    resurl = "";
                    break;
            }
            if (resurl == "")
                return "";

            return resurl;
        },

        GetSceneReslineId: function (reslineType, player, modelId) {
            var resid = 0, q_id;
            if( modelId ){
                q_id = reslineType + "_" + modelId;
                return Q_resline.Get(q_id).q_scene_show_id;
            }
            if (player == null)
                return resid;
            switch (reslineType) {
                case EnumResline.HORSE:
                    // if (player.nHorseUpState == 0)
                    //     return resid;
                    if (player.nHorseModelId <= 0)
                        return resid;

                    q_id = reslineType + "_" + player.nHorseModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
                case EnumResline.DRAGON:
                    if (player.nDragonModelId <= 0)
                        return resid;
                    q_id = reslineType + "_" + player.nDragonModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
                case EnumResline.GUANGWU:
                    if (player.nWeaponModelId <= 0)
                        return resid;
                    q_id = reslineType + "_" + player.nWeaponModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
                case EnumResline.SHUTONG:
                    if (player.nShutongModelId <= 0)
                        return resid;
                    q_id = reslineType + "_" + player.nShutongModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
                case EnumResline.BAOQI:
                    if (player.nHorseModelId <= 0)
                        return resid;
                    q_id = reslineType + "_" + player.nHorseModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
                case EnumResline.JIANLING:
                    if (player.nJianLingModelId <= 0)
                        return resid;
                    q_id = reslineType + "_" + player.nJianLingModelId;
                    resid = Q_resline.Get(q_id).q_scene_show_id;
                    break;
            }
            return resid;
        },

        GetIllusionId:function(illusionType, id){
            var q_id, resid;
            switch(illusionType){
                case HuanhuaType.TYPE_CLOAK:
                    q_id = illusionType + "_" + id;
                    resid = Q_illusion.Get(q_id).q_show;
                    break;
                case HuanhuaType.TYPE_HORSE:
                    q_id = illusionType + "_" + id;
                    resid = Q_illusion.Get(q_id).q_show;
                    break;
                case HuanhuaType.TYPE_PET:
                    q_id = illusionType + "_" + id;
                    resid = Q_illusion.Get(q_id).q_show;
                    break;
                case HuanhuaType.TYPE_WING:
                    q_id = illusionType + "_" + id;
                    resid = Q_illusion.Get(q_id).q_show;
                    break;
                case HuanhuaType.TYPE_KING:
                    q_id = illusionType + "_" + id;
                    resid = Q_illusion.Get(q_id).q_show;
                    break;
            }
            return resid;
        },

        GetGodWeaponResId:function(list){
            var IL = 0
            if(!list) return IL;
            list.find(v=>{
                if(v.illusionType != HuanhuaType.TYPE_WEAPON) return;

                let illusionId = 0
                if(v instanceof ShowIllusionInfo){
                    illusionId = v.illusionId;
                }else if(v instanceof IllusionInfo){
                    illusionId = v.illusionId;
                }else if(v instanceof IllusionDataInfo){
                    illusionId = v.illusionShowId;
                }

                var illusion = Q_illusion.Get(HuanhuaType.TYPE_WEAPON + "_" + illusionId);
                if( illusion ){
                    IL = illusion.q_show;
                    return true;
                }
            })

            return IL;
        },

        ///////////////////////////////////////////////////////////
        // 动画资源相关 暂时先把接口留好吧
        ///////////////////////////////////////////////////////////

        PlayerPathRoot: "res/animation/player",
        PlayerGuangWuPathRoot: "res/animation/parts/flashweapon/",
        MonsterPathRoot: "res/animation/monster",
        NpcPathRoot: "res/animation/npc",
        PetPathRoot: "res/animation/parts/attendant",

        UIPlayerPath: "res/animation/effect/ui/roleshow/player/",
        UIHorsePath: "res/animation/effect/ui/roleshow/part/mounts/",
        UIShuTongPath: "res/animation/effect/ui/roleshow/part/attendant/",
        UIBaoQiPath: "res/animation/effect/ui/roleshow/part/attendanthorse/",
        UIGuangWuPath: "res/animation/effect/ui/roleshow/part/flashweapon/",
        UIGuangWuSinglePath: "res/animation/effect/ui/roleshow/part/flashweapon-ui/",
        UIWuXuePath: "res/animation/effect/ui/roleshow/part/wuxue/",
        UIWingPath: "res/animation/effect/ui/roleshow/part/wing/",
        UIDragonPath: "res/animation/effect/ui/roleshow/part/dragon/",
        UIJianFaPath: "res/animation/effect/ui/roleshow/part/jianfa/",
        UIJianQiaoPath: "res/animation/effect/ui/roleshow/part/jianqiao/",
        UIJiaoYinPath: "res/animation/parts/zuji/",
        UITaiChiPath: "res/animation/effect/ui/roleshow/part/taichi/",
        UIPifengPath: "res/animation/effect/ui/roleshow/part/pifeng/",
        UIChongwuPath: "res/animation/effect/ui/roleshow/part/chongwu/",
        UIJianLingPath: "res/animation/effect/ui/roleshow/part/jingling/",

        UIHaloPath: "res/animation/effect/ui/halo/",

        GetUIModelUrl:function(id, type){
            var url;
            if( type == EnumResline.PLAYER ){
                url = this.UIPlayerPath + id;
            }
            else if( type == EnumResline.WING ){
                url = this.UIWingPath + id;
            }
            else if(type == HuanhuaType.TYPE_CLOAK){
                url = this.UIPifengPath + id;
            }
            else if(type == HuanhuaType.TYPE_PET){
                url = this.UIChongwuPath + id;
            }
            else if(type == HuanhuaType.TYPE_WEAPON){
                url = this.UIGuangWuSinglePath + id;
            }
            else if(type == HuanhuaType.TYPE_PET){
                url = this.UIChongwuPath + id;
            }
            else if(type == EnumResline.MARRIAGE_HALO){
                url = this.UIHaloPath + (id - EnumMarryResline.HALO + 1);
            }
            else{
                var resline = Q_resline.Get( type + "_" + id );
                // if( resline )
                //     url += resline.q_panel_show_id;
                switch(type){
                    case EnumResline.HORSE:
                        url = this.UIHorsePath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.GUANGWU:
                        url = this.UIGuangWuSinglePath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.SHUTONG:
                        url = this.UIShuTongPath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.BAOQI:
                        url = this.UIBaoQiPath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.WUXUE:
                        url = this.UIWuXuePath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.DRAGON:
                        url = this.UIDragonPath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.SCABBARD:
                        url = this.UIJianQiaoPath;
                        url += resline.q_panel_show_id;
                        break;
                    case EnumResline.STEP:
                        url = this.UIJiaoYinPath;
                        if(resline.q_panel_show_id < 10)
                            url += "0" + resline.q_panel_show_id;
                        else
                            url += resline.q_panel_show_id;
                        break;
                    case EnumResline.ZHAOSHI:
                        url = this.UIJianFaPath;
                        if(resline.q_panel_show_id < 10)
                            url += "0" + resline.q_panel_show_id;
                        else
                            url += resline.q_panel_show_id;
                        break;
                    case EnumResline.JIANLING:
                        url = this.UIJianLingPath;
                        url += resline.q_panel_show_id;
                        break;
                }
            }
            return url;
        },

        GetPlayerBodyUrl: function (id, sex, isRide, isWater) {
            var ret = this.PlayerPathRoot;
            return ret + "/" + id.toString();
        },

         GetPlayerWepUrl: function (wepid) {
             if (wepid == 0)
                 return "";

             var ret = this.PlayerWepPathRoot;

             ret += "/" + wepid.toString();
             return ret;
         },

        GetMonsterBodyUrl: function (id) {
            if (id == 0)
                return null;

            var ret = this.MonsterPathRoot;
            ret += "/" + id.toString();
            return ret;
        },

        GetNpcBodyUrl: function (id, type) {
            if (id == 0)
                return null;

            if (type == 1)
                return this.GetMonsterBodyUrl(id);

            if (type == 2)
                return this.GetPetBodyUrl(id);

            if (type == 3)
                return this.GetPlayerBodyUrl(id);

            var ret = this.NpcPathRoot;
            ret += "/" + id.toString();
            return ret;
        },

        GetPetBodyUrl: function (id, ntype) {
            ntype = ntype || 0;
            if (id == 0)
                return null;

            var ret = this.PetPathRoot;
            if ( ntype == EnumResline.SHUTONG ){
                ret = "res/animation/parts/attendant";
                ret += "/" + id.toString();
            }
            else if(ntype == HuanhuaType.TYPE_PET){
                ret = "res/animation/parts/chongwu";
                ret += "/" + id.toString();
            }
            else if(ntype == EnumResline.JIANLING){
                ret = "res/animation/parts/jingling";
                ret += "/" + id.toString();
            }
            return ret;
        },

        // 模拟创建场景对象info

        SimCreateSceneObjInfo: function (infotype) {
            var ret = {};
            ret.objinfotype = infotype;
            ret.x = 90 * 50 + 25;
            ret.y = 40 * 50 + 25;
            ret.dir = parseInt(Math.random() * MDirection.NUM);
            var simgid = this.CreateSimSID();
            ret.sceneobjgid = simgid.toGID();
            ret.name = "机器对象" + ret.sceneobjgid;
            ret.personId = simgid;
            ret.sid = simgid;
            ret.monsterId = simgid;
            ret.npcId = simgid;
            ret.petId = simgid;
            ret.dropGoodsId = simgid;
            ret.magicid = simgid;
            ret.effectId = simgid;

            return ret;
        },
        /// 更新MODEL
        UpdatePlayerUIModel:function(uiModel,player){
            uiModel.RemoveAll();
            uiModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(player));

            /// 光武
            if(player instanceof PlayerBriefInfo){
                let illusionId = SceneObjUtil.GetGodWeaponResId(player.illusionDataInfos, false)
                if(illusionId == 0){
                    let GW = player.reslineInfo && player.reslineInfo.find(v=>v.reslineType == EnumResline.GUANGWU)
                    illusionId = GW ? GW.reslineModelId : 0
                }
                uiModel.AddWeapon(illusionId, player.job);
            }else{
                /// main player
                let illusionId = SceneObjUtil.GetGodWeaponResId(player.showIllusionInfo, true)
                if(illusionId == 0){
                    let GW = player.playerResLineInfo && player.playerResLineInfo.find(v=>v.type == EnumResline.GUANGWU)
                    illusionId = GW ? GW.modelid : 0
                }
                uiModel.AddWeapon(illusionId, player.job);
            }
            /// 光翼
            if(player.armorShowId > 0){
                var wingId = ScenePlayer.prototype._Getnresid(player.armorShowId);
                uiModel.AddWing(wingId);
            }
        },
    }
