var Q_map = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** 地图中文名 */
        self.q_map_name = data.ReadString();
        /** 地图ID（100为普通地图、200为副本地图、1000为连服地图） */
        self.q_map_id = data.ReadInt();
        /** 地图资源ID */
        self.q_mapresid = data.ReadInt();
        /** 地图宽度 */
        self.q_map_width = data.ReadInt();
        /** 地图高度 */
        self.q_map_height = data.ReadInt();
        /** 进入等级下限 */
        self.q_map_min_level = data.ReadInt();
        /** 进入等级上限 */
        self.q_map_max_level = data.ReadInt();
        /** 进入转生等级下限 */
        self.q_map_reincarnation_min = data.ReadInt();
        /** 进入转生等级上限 */
        self.q_map_reincarnation_max = data.ReadInt();
        /** 进入VIP限制（与货币需求互斥） */
        self.q_map_vip = data.ReadInt();
        /** 进入货币需求（与VIP限制互斥，格式：[货币类型，货币数量]） */
        self.q_map_currency = data.ReadString();
        /** 是否安全区(0战斗区域,1安全区域)本列取消，安全区改为刷格方式 */
        self.q_map_safe = data.ReadInt();
        /** 是否可打坐(0不可打坐,1可打坐) */
        self.q_map_sit = data.ReadInt();
        /** 是否可跳跃(0不可跳跃,1可跳跃) */
        self.q_map_jump = data.ReadInt();
        /** 是否可骑乘(0不可骑乘,1可骑乘) */
        self.q_map_ride = data.ReadInt();
        /** 被玩家击杀后给予的BUFF（0：添加默认BUFF，大于1就添加配置的BUFF，但若BUFF表没有对应的BUFFID 会添加失败，所以若不想添加BUFF配置1即可） */
        self.q_map_buff = data.ReadInt();
        /** 等级差距过大是否可PK（0可PK，1不可PK，2无视等级且PK不受惩罚） */
        self.q_map_pk = data.ReadInt();
        /** 是否可以PK新人（0可PK，1不可PK） */
        self.q_map_pkprotection = data.ReadInt();
        /** 夜晚挂机是否开启挂机保护（0不开启，1开启） */
        self.q_map_hangprotection = data.ReadInt();
        /** 死亡回到地图ID */
        self.q_map_die = data.ReadInt();
        /** 回到X坐标 */
        self.q_map_die_x = data.ReadInt();
        /** 回到Y坐标 */
        self.q_map_die_y = data.ReadInt();
        /** 死亡随机回城坐标（x_y,x_y） */
        self.q_rnd_die_xy = data.ReadString();
        /** 下线回到地图ID */
        self.q_map_quit = data.ReadInt();
        /** 下线回到X坐标 */
        self.q_map_quit_x = data.ReadInt();
        /** 下线回到Y坐标 */
        self.q_map_quit_y = data.ReadInt();
        /** 退出随机回城坐标（x_y;x_y） */
        self.q_rnd_quit_xy = data.ReadString();
        /** 地图开放线路（想要几个线就写几条） */
        self.q_map_lines = data.ReadInt();
        /** 是否为公共区地图（1普通 2中立区（联服） 4跨服地图 3普通+中立 5普通+跨服 7所有（副本都填3）） */
        self.q_map_public = data.ReadInt();
        /** 是否为副本（0普通 1副本）（副本地图不能直接传送） */
        self.q_map_zones = data.ReadInt();
        /** 承载最大人数 */
        self.q_max_online = data.ReadInt();
        /** 本地图默认帮旗，0不可插，其他填指定怪物ID */
        self.q_default_flag = data.ReadInt();
        /** 帮旗坐标[x,y] */
        self.q_flag_pos = data.ReadString();
        /** 默认开启线路 */
        self.q_default_line = data.ReadInt();
        /** 轮询人数 */
        self.q_poll_num = data.ReadInt();
        /** 音乐关联（音乐资源编号_播放完后空闲秒数;音乐资源编号_播放完后空闲秒数) */
        self.q_music = data.ReadString();
        /** 地图是否是附属地图（1是，0否） */
        self.q_map_subsidiary = data.ReadInt();
        /** 附属地图的主地图id */
        self.q_subsidiary_main = data.ReadInt();
        /** 关联BOSSid（寻径时，找有BOSS的地图） */
        self.q_boss_id = data.ReadInt();
        /** 是否可用玫瑰复活（0是，1否，3_10秒自动复活且需要配置复活地图为本地图及对应的复活坐标点） */
        self.q_rose_resurrection = data.ReadInt();
        /** 开区X天合并线程 */
        self.q_merge_thread_day = data.ReadInt();
        /** 合并到目标地图线程 */
        self.q_target_mapid = data.ReadInt();
        /** 区域类型（0表示程序默认(生成很多区域),  1表示1个区域(节省内存)） */
        self.q_areaMode = data.ReadInt();
        /** 地图环境光效（0是正常显示，有太阳，1限制视线，无灯） */
        self.q_dark_fog = data.ReadInt();
        /** 副本类型(1剧情副本，2进阶副本，3经验副本，4VIP副本，5问鼎江湖，6 多人副本  7华山论剑 ，10心魔副本<任务>，14转生副本) */
        self.q_mapzone_type = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_map.list = Q_map.list|| [];
	/** 配置数据索引*/
	Q_map.map = Q_map.map || {};
	
	/** 设置配置数据*/
	Q_map.SetData = Q_map.SetData || function( data ){

		var list = Q_map.list;
		var map = Q_map.map;

		Q_map.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_map();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_map_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_map.GetList = Q_map.GetList || function(){
		return Q_map.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_map.Get = Q_map.Get || function( id ){
		return Q_map.map[ id ];
	};
})();