var Q_npc = cc.Class.extend({
	_Read:function( data ){
		var self = this;
        /** NPC编号10000-39990任务NPC、40000-49990功能NPC、50000-55000特殊类、59010-59990采集类 */
        self.q_id = data.ReadInt();
        /** 刷新地图ID */
        self.q_map = data.ReadInt();
        /** 刷新X坐标 */
        self.q_x = data.ReadInt();
        /** 刷新Y坐标 */
        self.q_y = data.ReadInt();
        /** 刷新NPC坐标集合[11,22],[22,33] */
        self.q_pos = data.ReadString();
        /** NPC名字 */
        self.q_name = data.ReadString();
        /** NPC称号 */
        self.q_title = data.ReadString();
        /** NPC上绑定的功能列表（格式：功能类型|选项文字描述;功能类型|选项文字描述;） */
        self.q_function = data.ReadString();
        /** NPC功能描述（小地图tips描述，支持html） */
        self.q_npcdesc = data.ReadString();
        /** 0在小地图和列表显示，1只在小地图显示，2只在列表显示，3都不显示 */
        self.q_isminimap = data.ReadInt();
        /** NPC绑定的商店出售模板编号 */
        self.q_shop = data.ReadInt();
        /** NPC传送序列（文字描述|MAPid,X,Y,半径|等级|元宝=Y金币=G|价格;文字描述|MAPid,X,Y,半径|等级|元宝=Y金币=G|价格） */
        self.q_transfer = data.ReadString();
        /** NPC身上绑定的任务编号列表,多个任务用；隔开 */
        self.q_task = data.ReadString();
        /** NPC功能面板上的简单对白（需支持基本的Html语法） */
        self.q_dialog = data.ReadString();
        /** NPC在场景中的发言内容(多句以分号分隔) */
        self.q_speak = data.ReadString();
        /** 发言频率间隔(单位：毫秒) */
        self.q_speak_time = data.ReadInt();
        /** 资源类型（0默认，1怪物，2侍宠，3主角） */
        self.q_resources = data.ReadInt();
        /** 造型是否翻转（0否，1是） */
        self.q_isturn = data.ReadInt();
        /** 默认朝向（0开始，顺时针转到7） */
        self.q_direction = data.ReadInt();
        /** 造型资源编号（资源使用：单方向6帧） */
        self.q_resource = data.ReadString();
        /** 头像资源编号 */
        self.q_head = data.ReadString();
        /** 任务接取播放（任务ID+动作名） */
        self.q_access_play = data.ReadString();
        /** 任务完成播放（任务号+动作名） */
        self.q_complete_play = data.ReadString();
        /** 是否可见（0不可见，1可见） */
        self.q_isvisible = data.ReadInt();
        /** NPC默认行为(42是采集) */
        self.q_behavior = data.ReadInt();
        /** 是否跟随玩家 */
        self.q_follow = data.ReadInt();
        /** 点击播放动作 */
        self.q_clickplay = data.ReadInt();
        /** 玩家状态 */
        self.q_playerstate = data.ReadInt();
        /** 点击触发脚本编号 */
        self.q_clickscriptid = data.ReadInt();
        /** 进入视野播放动作 */
        self.q_viewplay = data.ReadInt();
        /** npc视野范围 */
        self.q_field = data.ReadInt();
        /** 采集后触发脚本编号(47默认编号） */
        self.q_collectscript = data.ReadInt();
        /** 采集时间（毫秒） */
        self.q_collecttime = data.ReadInt();
        /** 是否显示NPC */
        self.q_displaynpc = data.ReadString();
        /** 采集道具冷却时间（不填为没有CD时间，CD时间毫秒计算） */
        self.q_cdtime = data.ReadInt();
        /** 采集获得物品 */
        self.q_acquisition_item = data.ReadInt();
        /** npc类型（1：代表采集类NPC，没有影子，会出现呼吸提升光效） */
        self.q_type = data.ReadInt();
        /** 像素X坐标 */
        self.q_px = data.ReadInt();
        /** 像素Y坐标 */
        self.q_py = data.ReadInt();
        /** 采集完成任务 */
        self.q_acquisition_task = data.ReadInt();
        /** npc交互距离(格子) */
        self.q_Interactive = data.ReadInt();
        /** npcAI */
        self.q_ai = data.ReadInt();
        /** NPC对话音效 */
        self.q_npctalk = data.ReadInt();
        /** 采集时显示ICON */
        self.q_collection_icon = data.ReadInt();
        /** 每次行走格子数量(0不走,最高6格) */
        self.q_patrolgrid = data.ReadInt();
        /** 巡逻几率(万分比,0永远不走) */
        self.q_patrolPro = data.ReadInt();
        /** 移动速度 */
        self.q_speed = data.ReadInt();
        /** 行走后冷却时间(至少大于1000毫秒) */
        self.q_patrolcd = data.ReadInt();
        
	}
});

(function(){
	/** 配置数据列表*/
	Q_npc.list = Q_npc.list|| [];
	/** 配置数据索引*/
	Q_npc.map = Q_npc.map || {};
	
	/** 设置配置数据*/
	Q_npc.SetData = Q_npc.SetData || function( data ){

		var list = Q_npc.list;
		var map = Q_npc.map;

		Q_npc.version = data.ReadInt();

		var len = data.ReadInt();
		var bean = null;

		for ( var i = 0; i < len; ++i ){
			bean = new Q_npc();
			bean._Read( data );
			list.push( bean );
			map[String(bean.q_id)] = bean;
		}
	};

	/** 获取配置数据列表*/
	Q_npc.GetList = Q_npc.GetList || function(){
		return Q_npc.list;
	};

	/** 根据ID获取对应配置数据*/
	Q_npc.Get = Q_npc.Get || function( id ){
		return Q_npc.map[ id ];
	};
})();