﻿/**
 * 正式的游戏逻辑初始化
 * （GameMain的GameStart为第一个执行的未被Cocos预装载的Js）
 * （到这里所有游戏的js文件已经加载完毕）
 * 
 * tyevlag
 * 
 * 1、所有单例Mgr建议都是用Init显示初始化
 * 
 * 
 */
var GameMain = GameMain || {
	// 游戏跟节点
	oStageLayer:null,
	oStartParam:{},
	
	GameStart:function(stagelayer){
		this.fontCache = new ccui.Text();
		this.fontCache.setFontName("res/font/dfpyuanw7.ttf");
		this.fontCache.retain();

        ChannelUtil.Login();		//显示登陆
		GameEvent.Init();
		TimerUtil.Init();
		EngineMgr.Init();
		BtnGroupUtil.Init();
//		zz.ShowDebug( stagelayer );
		this.oStageLayer = stagelayer;
		this.InitParam();
		this.InitManager(stagelayer);

		EngineMgr.uiMgr.LoadOtherRes("public" , this);

		GameMain.OnWinResize( MGameDefine.SCREEN_WIDTH, MGameDefine.SCREEN_HEIGHT );
		cc.eventManager.addCustomListener(MLResizeEvent, function(event){
			//var fsz = cc.view.getFrameSize();
			GameMain.OnWinResize(event._userData.w, event._userData.h);
		})
		
		var self = this;
		cc.eventManager.addCustomListener(cc.Director.EVENT_AFTER_VISIT, function(event){
			Profiler.RecordUpdate(Profiler.AFTER_VISIT);
		});
		cc.eventManager.addCustomListener(cc.Director.EVENT_AFTER_DRAW, function(event){
			Profiler.RecordUpdate(Profiler.AFTER_DRAW);
		});
		cc.eventManager.addCustomListener(cc.Director.EVENT_BEFORE_UPDATE, function(event){
			Profiler.RecordUpdate(Profiler.BEFORE_UPDATE);
		});
		cc.eventManager.addCustomListener(cc.Director.EVENT_AFTER_UPDATE, function(event){
			Profiler.RecordUpdate(Profiler.AFTER_UPDATE);
		});
		cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(event){
			cc.log("event show")
		});
		cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function(event){
			cc.log("event hide")
		});
	},

	Callback:function(){
		this._LoadConfigData();
	},
	ErrCallback:function(){

	},

	// 加载配置表文件
	_LoadConfigData:function(){
		var self = this;
		GameDataMgr.LoadData( self,
			self._LoadConfigDataComplete,
			self._LoadConfigDataError,
			self._LoadConfigDataPorgress );
	},

	// 加载配置表文件加载进度
	_LoadConfigDataPorgress:function( name, max, cur ){
		zz.Log( "load config:" + name + "  " + cur + "/" + max )
	},

	// 加载配置表文件失败（单一文件失败，不影响整个加载进度）
	_LoadConfigDataError:function(){
	},

	_LoadConfigDataComplete:function(){
		this.oStageLayer.loadBg.setTexture("res/ui/image/load/bg2.jpg");
		this.oStageLayer.loadBg.parts.visible = false;
		Mgr.login.ShowLogin();
		var loginPanel = Mgr.login.loginPanel;
		var bg = this.oStageLayer.loadBg;
		bg.x = loginPanel.width * 0.5;
		bg.y = loginPanel.height * 0.5;
		bg.retain();
		bg.removeFromParent(false);
		loginPanel.addChild( bg, -1 );
		bg.release();
		this.oStageLayer.hotUpdatePanel.Dispose();
	},

	// 初始化参数加载
	InitParam:function(){
		if( GameConfig.isWebMode )
			LoadMgr.InitVersion();	
	},
	
	// 初始化所有管理器，必要的可以调Init
	InitManager:function(stagelayer){
		Mgr.Init(stagelayer);
	},
	
	OnWinResize:function(w, h){
		//zz.Log("StageResize : "  + w + "," + h + "|" + cc.winSize.width + "," + cc.winSize.height);
		Mgr.uiMgr.StageResize( w , h);
		Mgr.sceneLayer.OnWinResize(w, h);
	},

	/**
	 * 这里要注意一下每帧执行顺序	scheduleUpdate( priority从小到大  ActionManager > OnFrame ) > schedule ( MessageHandler )
	 * @constructor
	 */
	OnFrame:function(dt){
		Profiler.RecordUpdate(Profiler.BEFORE_ONFRAME);
		Profiler.Start("TimerUtil.OnFrame");
        TimerUtil.OnFrame(dt);
		Profiler.Stop("TimerUtil.OnFrame", 100);

        Profiler.Start("GameEventMgr.OnFrame");
        GameEventMgr.OnFrame();
        Profiler.Stop("GameEventMgr.OnFrame", 100);

		Profiler.Start("Mgr.sceneObj");
		// Mgr.robotMgr.OnFrame();
		Mgr.login.OnFrame();
		Mgr.sceneObj.OnFrame();
		Profiler.Stop("Mgr.sceneObj", 100);
		Mgr.sceneMap.OnFrame();

		Mgr.sceneLayer.OnFrame();
		Mgr.particleMgr.OnFrame();
		Profiler.RecordUpdate(Profiler.AFTER_ONFRAME);
	}
};

////修复IE8不兼容indexOf
//if (!Array.prototype.indexOf){
//	Array.prototype.indexOf = function(elt /*, from*/){
//		var len = this.length >>> 0;
//		var from = Number(arguments[1]) || 0;
//		from = (from < 0)
//		? Math.ceil(from)
//				: Math.floor(from);
//		if (from < 0)
//			from += len;
//		for (; from < len; from++){
//			if (from in this &&
//					this[from] === elt)
//				return from;
//		}
//		return -1;
//	};
//}

//// 输出删除指定元素
//if ( !Array.prototype.delElement ){
//	Array.prototype.delElement = function( elt ){
//		var len = this.length;
//		for ( var i = 0; i < len; ++i ){
//			if ( elt === this[i] ){
//				this.splice( i, 1 );
//				return true;
//			}
//		}
//		return false;
//	};
//}
//数组乱序
if (!Array.Shuffle) {
	Array.Shuffle = function( arr ) {
		for(var j, x, i = arr.length; i;){
			j = parseInt(Math.random() * i);
			x = arr[--i];
			arr[i] = arr[j];
			arr[j] = x;
		}
		return arr;
	}
}



