///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//AchievementInfo 成就类型对应的完成度

// 请求消息
//153201,ReqSendAchievementDataInfo 请求成就信息
//153202,ReqSendGetAchievementAward 请求成就奖励

// 接收消息
//153101,ResSendAchievementDataInfo 发送成就基本信息 
//153102,ResSendFinishAchievement 达成某个成就
//153103,ResSendGetAchievementAward 领取成就奖励结果(成功才会发 前端做特效)
//153104,ResAchievementPointToClient 发送成就点变化信息(登录和改变的时候发送)
//153105,ResAchievementChangeToClient 成就变化信息同步给前段


var AchievementInfo = cc.Class.extend({
	ctor:function(){
		this.achievementType = 0; // 成就类型
        this.value = 0; // 当前完成度
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.achievementType);
        _buf.WriteVarInt(this.value);
	},
	
	reading:function( _buf ){
		this.achievementType = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
	},
});
////////////////////
// 发送成就基本信息  //
////////////////////
var ResSendAchievementDataInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.rewardAchievementIds = []; // 已经领取过奖励的成就id int
        this.achievementDataInfo = []; // 成就类型对应的完成度 AchievementInfo
	},

	getId:function(){
		return 153101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.rewardAchievementIds.length );
        for (var i = 0; i < this.rewardAchievementIds.length; i++) {
            _buf.WriteVarInt(this.rewardAchievementIds[i]);
        }
        _buf.WriteShort( this.achievementDataInfo.length );
        for (var i = 0; i < this.achievementDataInfo.length; i++) {
            _buf.WriteBean(this.achievementDataInfo[i]);
        }
	},
	
	reading:function( _buf ){
        var rewardAchievementIds_length = _buf.ReadShort();
        for (var i = 0; i < rewardAchievementIds_length; i++) {
            this.rewardAchievementIds[i] = _buf.ReadVarInt();
        }
        var achievementDataInfo_length = _buf.ReadShort();
        for (var i = 0; i < achievementDataInfo_length; i++) {
            this.achievementDataInfo[i] = _buf.ReadBean(AchievementInfo);
        }
	},

	action:function(){
		Mgr.achievement.RecvResSendAchievementDataInfoMessage(this);
	},

});
////////////////////
// 达成某个成就 //
////////////////////
var ResSendFinishAchievementMessage = cc.Class.extend( {
	ctor:function(){
		this.achievementId = []; // 成就ID int
	},

	getId:function(){
		return 153102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.achievementId.length );
        for (var i = 0; i < this.achievementId.length; i++) {
            _buf.WriteVarInt(this.achievementId[i]);
        }
	},
	
	reading:function( _buf ){
        var achievementId_length = _buf.ReadShort();
        for (var i = 0; i < achievementId_length; i++) {
            this.achievementId[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.achievement.RecvResSendFinishAchievementMessage(this);
	},

});
////////////////////
// 领取成就奖励结果(成功才会发 前端做特效) //
////////////////////
var ResSendGetAchievementAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.achievementId = 0; // 成就ID
	},

	getId:function(){
		return 153103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.achievementId);
	},
	
	reading:function( _buf ){
        this.achievementId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.achievement.RecvResSendGetAchievementAwardMessage(this);
	},

});
////////////////////
// 发送成就点变化信息(登录和改变的时候发送) //
////////////////////
var ResAchievementPointToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.achievementPoint = 0; // chengjiu
	},

	getId:function(){
		return 153104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.achievementPoint);
	},
	
	reading:function( _buf ){
        this.achievementPoint = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.achievement.RecvResAchievementPointToClientMessage(this);
	},

});
////////////////////
// 成就变化信息同步给前段 //
////////////////////
var ResAchievementChangeToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.achievementDataInfo = null; // 成就变化信息同步给前段
	},

	getId:function(){
		return 153105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.achievementDataInfo);
	},
	
	reading:function( _buf ){
        this.achievementDataInfo = _buf.ReadBean(AchievementInfo);
	},

	action:function(){
		Mgr.achievement.RecvResAchievementChangeToClientMessage(this);
	},

});
////////////////////
// 请求成就信息 //
////////////////////
var ReqSendAchievementDataInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 153201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求成就奖励 //
////////////////////
var ReqSendGetAchievementAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.achievementId = 0; // 
	},

	getId:function(){
		return 153202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.achievementId);
	},
	
	reading:function( _buf ){
        this.achievementId = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(153101, ResSendAchievementDataInfoMessage);
MESSAGE_POOL.Add(153102, ResSendFinishAchievementMessage);
MESSAGE_POOL.Add(153103, ResSendGetAchievementAwardMessage);
MESSAGE_POOL.Add(153104, ResAchievementPointToClientMessage);
MESSAGE_POOL.Add(153105, ResAchievementChangeToClientMessage);

