var AchievementPanelExt = AchievementPanel.extend ( {
	_className:"AchievementPanelExt",

	buttonPanel:null,
	buttonList:null,
    selPanel:null,
    mainPanel:null,

	ctor:function () {
        this._super();
		this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -30;
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.buttonList = [];
    },

    onClean:function(){
        this._super();
        if(this._panelCache){
            for(var k in this._panelCache){
                this._panelCache[k].release();
            }
        }
    },
	Init:function () {
		AchievementPanel.prototype.Init.call(this);
		var self = this;
        this.buttonPanel= new ccui.ListView();
        this.buttonPanel.setSize(cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight - 15));
        this.buttonPanel.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.buttonPanel.setItemsMargin(2);
        this.buttonPanel.setBounceEnabled(true);
        this.buttonPanel.setScrollBarEnabled(false);
        this.buttonPanel.x = 15;
        this.imgBg1.addChild(this.buttonPanel);

        this.btnClose.addClickEventListener(function (target) {
			Mgr.uiMgr.HidePanel(self);
        });
    },

	OnShow:function () {
        Mgr.achievement.SendReqSendAchievementDataInfoMessage();
        this.InitButton();
    },

	InitButton:function () {
		var self = this;

		if(this.buttonList.length == 0){
            var keys = Mgr.achievement.AchievementHash().Keys();
            for(var i = 0, len = keys.length; i < len; i++){
                var key = keys[i];
                cc.log("========key========   " + key)
                var data = Mgr.achievement.AchievementHash().Get(key);
                var button = new AchievementBtnExt();
                button.LoadPanel();
                button.SetData(data);
                button.type = data[1][0].q_subfield;
                button.SetWarn(false);
                button.id = key;
                this.buttonList.push(button);
                this.buttonPanel.addChild(button);
                button.sbtn1.addClickEventListener(function (target) {
                    self.InitCell(target);
                });
            }
        }

		this.InitCell(this.buttonList[0].sbtn1);
    },

    UpdateBtnWarn:function(){
	    for(var i = 0; i < this.buttonList.length; i++){
            this.buttonList[i].SetWarn(Mgr.achievement.HaveRawardCanGet(this.buttonList[i].type));
        }
    },

    ShowPanelById:function(id){
	    var info =  Q_achievement.Get(id);
	    if(id && info){
	        for(var i = 0; i < this.buttonList.length; i++){
	            if(this.buttonList[i].id == info.q_subfield){
	                this.InitCell(this.buttonList[i].sbtn1);
	                break;
                }
            }
        }
    },

	InitCell:function (button) {
        this.ResetButtonState(button);
		this.imgBg2.removeAllChildren(false);

		var panel;
		var type = button.detail[1][0].q_subfield;
		var idArr = this.GetAchievementIDArr(button);

        // 这个鬼加个缓存免得卡
        this._panelCache = this._panelCache || {};
        var category = type == 1 ? 1 : 0;

        if(!this._panelCache[category]){
            if(type == 1){
                panel = new AchievementSelExt();
                panel.achievementPanel = this;
            }else {
                panel = new AchievementMainExt();
            }
            panel.LoadPanel();
            panel.retain();
            this._panelCache[type] = panel;
        }else{
            panel = this._panelCache[type];
        }
        if(type == 1)
            TimerUtil.SetTimeout(this, function () {
                panel.SetData(type, idArr);
            }, 200);
        else
            panel.SetData(type, idArr);
        this.imgBg2.addChild(panel);
    },

    ResetButtonState:function (button) {
        var list = this.buttonList;
        for (var i=0,len=list.length;i<len;i++){
            if (list[i].sbtn1 != button){
                list[i].sbtn1.SetButtonState("uncheck");
            }else {
                list[i].sbtn1.SetButtonState("check");
            }
        }
    },

    GetAchievementIDArr:function (buttonInfo) { // 成就子选项排序   可激活  -》  未完成  -》  已激活
        var headlist = [], list = [], backList = [];
        for(var i = 0, len = buttonInfo.detail[1].length; i < len; i++){
            var temp = buttonInfo.detail[1][i];
            var info =  Q_achievement.Get(temp.q_id);
            var typeNum = 0;
            if(Mgr.achievement.achievementTypeNowValueHash && Mgr.achievement.achievementTypeNowValueHash.Get(info.q_type))
                typeNum = Mgr.achievement.achievementTypeNowValueHash.Get(info.q_type);
            if( Mgr.achievement.rewardAchievementIds.indexOf(info.q_id) != -1 ){//已领奖
                backList.push(temp.q_id);
            }else{
                if( typeNum >= info.q_value ){//可领奖
                    headlist.push(temp.q_id);
                }else{
                    list.push(temp.q_id);
                }
            }
        }
        headlist.push.apply(headlist, list);
        headlist.push.apply(headlist, backList);
        return headlist;
    },
} );
AchievementPanelExt.PanelName = "AchievementPanelExt";
PanelClassDic["AchievementPanelExt"] = AchievementPanelExt;
