var ArenaModMgr = ArenaModMgr || cc.Class.extend({ 

    ctor:function() {
        this._jjPnael = null;

        this._buyChallengeCount = 0;
        this._usedChallengeCount = 0;

        this._countDown = 0;
        this._countDownTime = TimerUtil.GetGameTimer();
    },

    CheckBuyChallengeCount:function(noTip){
        var max = this.GetChallengeLimit();
        var count = this.GetAvailableChallengeCount();

        if(max <= count){
            if(!noTip) Mgr.tips.ShowNotice("您的挑战次数还很足！");
            return false;
        }

        if(max <= this._buyChallengeCount){
            if(!noTip) Mgr.tips.ShowNotice("购买次数达到上限！");
            return false;
        }

        return true;
    },

    CheckNeedClearCoolDown:function(noTip){
        if(this._needClearCool && (this.GetCountdown() > 0)){
            return true;
        }
        if(!noTip) Mgr.tips.ShowNotice("不需要清除冷却时间！");
        return false;
    },

    GetCoolDownCostGold:function(){
        var per = parseInt(Q_global.Get(58).q_int_value);

        return Math.ceil(this.GetCountdown() / 60) * per;
    },
    GetChallengeLimit:function(){
        if(!this._challengeLimite){
            this._challengeLimite = parseInt(Q_global.Get(60).q_int_value);
        }
        return this._challengeLimite;
    },

    GetAvailableChallengeCount:function(){
        var max = this.GetChallengeLimit();
        return max + this._buyChallengeCount - this._usedChallengeCount;
    },

    GetAwardByRank:function(rank){
        var last = now = null;

        if(!this._arenaAwardList){
            var list = Q_arena.GetList();
            var result = [];
            for(var k=0,v=list[k];k!=list.length;v=list[++k]){
                var ret = v.q_id.match(/(\d+)_(\d+)/);

                result.push({
                    start : ret[1],
                    end : ret[2],
                    q_id : v.q_id,
                    q_reward_daily : v.q_reward_daily,
                })
            }
            result.sort(function temp(a,b){
                return a - b;
            });
            this._arenaAwardList =result;
        }

        var list = this._arenaAwardList;
        for(var k=0,v=list[k];k!=list.length;v=list[++k]){

            if(v.start <= rank && rank <= v.end){
                now = v.q_reward_daily;
                break;
            }

            last = v.q_reward_daily;
        }
        if(last == null) last = now;

        return [now,last];
    },

    GetCountdown:function(){
        return Math.ceil(this._countDown - (TimerUtil.GetGameTimer() - this._countDownTime) / 1000);
    },

    SetCountdown:function(time){
        this._countDown = time;
        this._countDownTime = TimerUtil.GetGameTimer();
    },

    // 收到玩家简介时更新界面
    RecvResPlayerBriefMessage:function(msg){
        if(msg.controlType != EnumBriefType.ARENA) return;

        // 任务界面
        var doUpdateView = false;
        for(var i=0;i!=msg.playerBriefs.length;++i){
            var v = msg.playerBriefs[i];
            for(var ii=0;ii!=this._arenaInfo.arenaInfos.length;++ii){
                var vv = this._arenaInfo.arenaInfos[ii];
                if(v.playerid.toGID() == vv.playerid.toGID()){
                    vv.brief = v;
                    vv.fightpower = v.fightpower;
                    doUpdateView = true;
                    break;
                }
            }
        }
        if(doUpdateView) Mgr.arena._jjPnael.RequestUpdateView();

        // 排行
        var doUpdateView = false;
        for(var i=0;i!=msg.playerBriefs.length;++i){
            var v = msg.playerBriefs[i];
            for(var ii=0;ii!=this._arenaRankInfo.arenaInfolist.length;++ii){
                var vv = this._arenaRankInfo.arenaInfolist[ii];
                if(v.playerid.toGID() == vv.playerid.toGID()){
                    vv.brief = v;
                    vv.fightpower = v.fightpower;
                    doUpdateView = true;
                    break;
                }
            }
        }
        if(doUpdateView) Mgr.arena._jjPnael.RequestUpdateRankView();
    },
    RecvResArenaInfosMessage:function(msg) {
        // 获取玩家简要信息
        var playerIds = [];
        for(var i=0;i!=msg.arenaInfos.length;++i){
            var v = msg.arenaInfos[i];
            if(v.type == 0){
                this.SendReqArenaMonsterInfoMessage({
                    arenaId : v.playerid,
                });
            }else{
                playerIds.push(v.playerid);
            }
        }
        if(playerIds.length > 0) Mgr.player.SendReqPlayerBriefMessage(playerIds,EnumBriefType.ARENA);


        this._arenaInfo = msg;

        this._buyChallengeCount = msg.buyJoinCount;
        this._usedChallengeCount = msg.joinCount;
        this._needClearCool = msg.needClearCool == 1;

        this.SetCountdown(msg.coolDown);

        Mgr.arena._jjPnael.RequestUpdateView();
    },

    RecvResStartArenaMessage:function(msg) {
        var data = null;
        for(var ii=0;ii!=this._arenaInfo.arenaInfos.length;++ii){
            var vv = this._arenaInfo.arenaInfos[ii];
            if(msg.arenaInfo.playerid.toGID() == vv.playerid.toGID()){
                data = vv;
                break;
            }
        }

        for(var ii=0;ii!=this._arenaRankInfo.arenaInfolist.length;++ii){
            var vv = this._arenaRankInfo.arenaInfolist[ii];
            if(msg.arenaInfo.playerid.toGID() == vv.playerid.toGID()){
                data = vv;
                break;
            }
        }

        var panel = EngineMgr.uiMgr.ShowPanelByType(jingjichangExt.PanelName,UIMgr.PANEL_LAYER_TOP);
        if(panel) panel.UpdateView(msg,data || msg.arenaInfo);
    },

    RecvResArenaTopRankRewardMessage:function(msg) {
    },

    RecvResArenaMonsterInfoMessage:function(msg) {
        for(var ii=0;ii!=this._arenaInfo.arenaInfos.length;++ii){
            var vv = this._arenaInfo.arenaInfos[ii];
            if(msg.name == vv.name){
                vv.monster_data = msg;
                break;
            }
        }
    },

    RecvResArenaCooleDownTimeMessage:function(msg) {
        this.SetCountdown(msg.time);
    },

    RecvResJoinArenaCountMessage:function(msg) {
        this._buyChallengeCount = msg.buyJoinCount;
        this._usedChallengeCount = msg.joinCount;

        if(Mgr.arena._jjPnael) Mgr.arena._jjPnael.RequestUpdateView();
    },

    RecvResArenalistToClientMessage:function(msg) {
        this._arenaRankInfo = msg;

        var playerIds = [];
        for(var i=0;i!=msg.arenaInfolist.length;++i){
            var v = msg.arenaInfolist[i];
            if(v.type){
                playerIds.push(v.playerid);
            }
        }
        if(playerIds.length > 0) Mgr.player.SendReqPlayerBriefMessage(playerIds,EnumBriefType.ARENA);

        Mgr.arena._jjPnael.RequestUpdateRankView();
    },

    SendReqArenaInfoMessage:function(msg) {
        var message = new ReqArenaInfoMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqStartArenaMessage:function(msg) {
        var message = new ReqStartArenaMessage();
        message.index = msg.index;
        message.personId = msg.personId;
        Mgr.msgMgr.Send(message);
    },

    SendReqRefreshArenaMessage:function(msg) {
        var message = new ReqRefreshArenaMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqClearArenaCoolDownMessage:function(msg) {
        var message = new ReqClearArenaCoolDownMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqBuyJoinArenaCountMessage:function(msg) {
        var message = new ReqBuyJoinArenaCountMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqArenaMonsterInfoMessage:function(msg) {
        var message = new ReqArenaMonsterInfoMessage();
        message.arenaId = msg.arenaId;
        Mgr.msgMgr.Send(message);
    },

    SendReqArenaFightOverMessage:function(msg) {
        var message = new ReqArenaFightOverMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqArenaRankRewardMessage:function(msg) {
        var message = new ReqArenaRankRewardMessage();
        Mgr.msgMgr.Send(message);
    },

    SendReqArenalistToGameMessage:function(msg) {
        var message = new ReqArenalistToGameMessage();
        message.type = msg.type;
        message.start = msg.start;
        message.length = msg.length;
        Mgr.msgMgr.Send(message);
    }
    });