///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ItemInfo 物品信息类
//TempItemInfo 临时物品信息类
//AttributeInfo 附加属性信息
//Walletlog 钱包记录
//SimpleItemInfo 简易道具信息
//BriefItemInfo 简要道具信息

// 请求消息
//108201,ReqGetItems 背包物品请求
//108202,ReqMoveItem 移动物品
//108203,ReqUseItem 使用物品
//108204,ReqDelItem 删除物品
//108205,ReqClearUpGoods 整理物品
//108209,ReqDiscard 物品丢弃
//108210,ReqDestroy 物品销毁
//108211,ReqTakeUp 拾取
//108212,ReqOpenCell 花元宝打开格子申请
//108208,ReqCellTimeQuery 格子开启剩余时间查询
//108213,ReqOpenTimeCell 时间到打开格子申请
//108214,ReqSplitItem 拆分道具
//108215,ReqGiftinfoToGame 请求礼包详细信息
//108216,ReqGetItemAlone 单独请求更新物品消息
//108217,ReqGetwallet 获取钱包

// 接收消息
//108101,ResItemInfos 物品信息列表
//108102,ResItemAdd 物品信息增加
//108103,ResItemChange 物品信息修正
//108104,ResItemRemove 物品删除
//108105,ResUseItemSuccess 使用物品成功
//108106,ResBackpackFull 背包已满
//108107,ResTakeUpSuccess 拾取成功
//108108,ResCellTime 打开格子所需时间
//108109,ResOpenCellResult 打开格子结果
//108110,ResGiftinfoToClient 发送礼包详细信息
//108111,ResFlyItemInfoToClient 发送道具飞包包信息
//108112,ResGetwalletlog 获取钱包日志
//108113,ResGetwalletnum 获取钱包元宝数量
//108114,ResUseGiftGetItems 打开礼包活动的道具
//108115,ResItemDisplayPanelInfoToClient 通用的一个获得道具的展示面板消息


var ItemInfo = cc.Class.extend({
	ctor:function(){
		this.itemId = null; // 物品唯一Id
        this.itemModelId = 0; // 物品模板Id
        this.num = 0; // 物品数量
        this.isbind = 0; // 是否绑定 1是 0否 
        this.gridId = 0; // 道具所在格子Id
        this.lostTime = 0; // 过期时间
        this.strenthenLv = 0; // 强化等级
        this.extraNum = 0; // 附加属性条数
        this.parameters = null; // 参数，额外信息
        this.magicAttributeInfos = []; // 魔化属性表 AttributeInfo
        this.enchantAttributeInfos = []; // 附魔属性表 AttributeInfo
        this.reincarnateLv = 0; // 装备转生等级
	},

	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
        _buf.WriteByte(this.isbind);
        _buf.WriteVarInt(this.gridId);
        _buf.WriteVarInt(this.lostTime);
        _buf.WriteVarInt(this.strenthenLv);
        _buf.WriteVarInt(this.extraNum);
        _buf.WriteString(this.parameters);
        _buf.WriteUShort( this.magicAttributeInfos.length );
        for (var i = 0; i < this.magicAttributeInfos.length; i++) {
            _buf.WriteBean(this.magicAttributeInfos[i]);
        }
        _buf.WriteUShort( this.enchantAttributeInfos.length );
        for (var i = 0; i < this.enchantAttributeInfos.length; i++) {
            _buf.WriteBean(this.enchantAttributeInfos[i]);
        }
        _buf.WriteVarInt(this.reincarnateLv);
	},
	
	reading:function( _buf ){
		this.itemId = _buf.ReadLong();
        this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.isbind = _buf.ReadByte();
        this.gridId = _buf.ReadVarInt();
        this.lostTime = _buf.ReadVarInt();
        this.strenthenLv = _buf.ReadVarInt();
        this.extraNum = _buf.ReadVarInt();
        this.parameters = _buf.ReadString();
        var magicAttributeInfos_length = _buf.ReadUShort();
        for (var i = 0; i < magicAttributeInfos_length; i++) {
            this.magicAttributeInfos[i] = _buf.ReadBean(AttributeInfo);
        }
        var enchantAttributeInfos_length = _buf.ReadUShort();
        for (var i = 0; i < enchantAttributeInfos_length; i++) {
            this.enchantAttributeInfos[i] = _buf.ReadBean(AttributeInfo);
        }
        this.reincarnateLv = _buf.ReadVarInt();
	},
});
var TempItemInfo = cc.Class.extend({
	ctor:function(){
		this.itemId = null; // 物品唯一Id
        this.mod = 0; // 物品模板Id
        this.num = 0; // 物品数量
        this.isbind = 0; // 是否绑定 1是 0否 
        this.ltime = 0; // 过期时间（获得道具XX秒后过期）
        this.ldate = null; // 到期时间(到达指定时间过期)
        this.parameters = null; // 参数，额外信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.mod);
        _buf.WriteVarInt(this.num);
        _buf.WriteByte(this.isbind);
        _buf.WriteVarInt(this.ltime);
        _buf.WriteString(this.ldate);
        _buf.WriteString(this.parameters);
	},
	
	reading:function( _buf ){
		this.itemId = _buf.ReadLong();
        this.mod = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.isbind = _buf.ReadByte();
        this.ltime = _buf.ReadVarInt();
        this.ldate = _buf.ReadString();
        this.parameters = _buf.ReadString();
	},
});
var AttributeInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 附加属性类型
        this.value = 0; // 附加属性值
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.value);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
	},
});
var Walletlog = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 类型,1取出,0交易获得
        this.time = 0; // 时间
        this.num = 0; // 元宝数量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},
});
var SimpleItemInfo = cc.Class.extend({
	ctor:function(){
		this.itemModelId = 0; // 道具ModelID
        this.num = 0; // 道具数量
        this.reincarnateLv = 0; // 装备转生等级
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.reincarnateLv);
	},
	
	reading:function( _buf ){
		this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.reincarnateLv = _buf.ReadVarInt();
	},
});
var BriefItemInfo = cc.Class.extend({
	ctor:function(){
		this.itemModelId = 0; // 道具ModelID
        this.num = 0; // 道具数量
        this.bind = 0; // 道具绑定状态,1绑定,0没有绑定
        this.othertype = 0; // 其他类型,0普通,1极品(公告)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
        _buf.WriteByte(this.bind);
        _buf.WriteVarInt(this.othertype);
	},
	
	reading:function( _buf ){
		this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.bind = _buf.ReadByte();
        this.othertype = _buf.ReadVarInt();
	},
});
////////////////////
// 物品信息列表 //
////////////////////
var ResItemInfosMessage = cc.Class.extend( {
	ctor:function(){
		this.cellnum = 0; // 已开格子数量
        this.items = []; // 物品信息列表 ItemInfo
	},

	getId:function(){
		return 108101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellnum);
        _buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
	},
	
	reading:function( _buf ){
        this.cellnum = _buf.ReadVarInt();
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(ItemInfo);
        }
	},

	action:function(){
		Mgr.backpack.RecvResItemInfosMessage(this);
	},

});
////////////////////
// 物品信息增加 //
////////////////////
var ResItemAddMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(1-获得新物品)
        this.item = null; // 物品信息
	},

	getId:function(){
		return 108102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.backpack.RecvResItemAddMessage(this);
	},

});
////////////////////
// 物品信息修正 //
////////////////////
var ResItemChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(1-获得新物品)
        this.item = null; // 物品信息
	},

	getId:function(){
		return 108103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.backpack.RecvResItemChangeMessage(this);
	},

});
////////////////////
// 物品删除 //
////////////////////
var ResItemRemoveMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 108104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

	action:function(){
		Mgr.backpack.RecvResItemRemoveMessage(this);
	},

});
////////////////////
// 使用物品成功 //
////////////////////
var ResUseItemSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.itemModelId = 0; // 物品ModelIdId
        this.num = 0; // 物品数量
	},

	getId:function(){
		return 108105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.itemModelId = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.backpack.RecvResUseItemSuccessMessage(this);
	},

});
////////////////////
// 背包已满 //
////////////////////
var ResBackpackFullMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 108106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.backpack.RecvResBackpackFullMessage(this);
	},

});
////////////////////
// 拾取成功 //
////////////////////
var ResTakeUpSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.itemIds = []; // 物品id列表 long
	},

	getId:function(){
		return 108107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.itemIds.length );
        for (var i = 0; i < this.itemIds.length; i++) {
            _buf.WriteLong(this.itemIds[i]);
        }
	},
	
	reading:function( _buf ){
        var itemIds_length = _buf.ReadUShort();
        for (var i = 0; i < itemIds_length; i++) {
            this.itemIds[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.backpack.RecvResTakeUpSuccessMessage(this);
	},

});
////////////////////
// 打开格子所需时间 //
////////////////////
var ResCellTimeMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
        this.type = 0; // 1 包裹  2仓库 3寻宝仓库
        this.timeRemaining = 0; // 剩余时间(秒)
	},

	getId:function(){
		return 108108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.timeRemaining);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.timeRemaining = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.backpack.RecvResCellTimeMessage(this);
	},

});
////////////////////
// 打开格子结果 //
////////////////////
var ResOpenCellResultMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
        this.type = 0; // 1 包裹  2仓库 3寻宝仓库
        this.isSuccess = 0; // 1成功 0失败
	},

	getId:function(){
		return 108109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.isSuccess);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.isSuccess = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.backpack.RecvResOpenCellResultMessage(this);
	},

});
////////////////////
// 发送礼包详细信息 //
////////////////////
var ResGiftinfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.gold = 0; // 打开需要元宝数量
        this.itemId = null; // 礼包唯一Id
        this.itemModelId = 0; // 礼包道具模板Id
        this.items = []; // 礼包内容 TempItemInfo
	},

	getId:function(){
		return 108110;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
        _buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.itemModelId);
        _buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
	},
	
	reading:function( _buf ){
        this.gold = _buf.ReadVarInt();
        this.itemId = _buf.ReadLong();
        this.itemModelId = _buf.ReadVarInt();
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(TempItemInfo);
        }
	},

	action:function(){
		Mgr.backpack.RecvResGiftinfoToClientMessage(this);
	},

});
////////////////////
// 发送道具飞包包信息 //
////////////////////
var ResFlyItemInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型（和前端定义）
        this.itemModelIds = []; // 道具类容 int
	},

	getId:function(){
		return 108111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteUShort( this.itemModelIds.length );
        for (var i = 0; i < this.itemModelIds.length; i++) {
            _buf.WriteVarInt(this.itemModelIds[i]);
        }
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        var itemModelIds_length = _buf.ReadUShort();
        for (var i = 0; i < itemModelIds_length; i++) {
            this.itemModelIds[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.backpack.RecvResFlyItemInfoToClientMessage(this);
	},

});
////////////////////
// 获取钱包日志 //
////////////////////
var ResGetwalletlogMessage = cc.Class.extend( {
	ctor:function(){
		this.walletlogs = []; // 日志列表,前端按照时间排序 Walletlog
	},

	getId:function(){
		return 108112;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.walletlogs.length );
        for (var i = 0; i < this.walletlogs.length; i++) {
            _buf.WriteBean(this.walletlogs[i]);
        }
	},
	
	reading:function( _buf ){
        var walletlogs_length = _buf.ReadUShort();
        for (var i = 0; i < walletlogs_length; i++) {
            this.walletlogs[i] = _buf.ReadBean(Walletlog);
        }
	},

	action:function(){
		Mgr.backpack.RecvResGetwalletlogMessage(this);
	},

});
////////////////////
// 获取钱包元宝数量 //
////////////////////
var ResGetwalletnumMessage = cc.Class.extend( {
	ctor:function(){
		this.num = 0; // 元宝数量
	},

	getId:function(){
		return 108113;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.num = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.backpack.RecvResGetwalletnumMessage(this);
	},

});
////////////////////
// 打开礼包活动的道具 //
////////////////////
var ResUseGiftGetItemsMessage = cc.Class.extend( {
	ctor:function(){
		this.items = []; // 获得道具简要信息 SimpleItemInfo
        this.itemModel = 0; // 使用的道具model
        this.itemNum = 0; // 使用的道具num
	},

	getId:function(){
		return 108114;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.itemNum);
	},
	
	reading:function( _buf ){
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(SimpleItemInfo);
        }
        this.itemModel = _buf.ReadVarInt();
        this.itemNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.backpack.RecvResUseGiftGetItemsMessage(this);
	},

});
////////////////////
// 通用的一个获得道具的展示面板消息 //
////////////////////
var ResItemDisplayPanelInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型(0普通1有领取按钮)
        this.title = null; // 标题
        this.content = null; // 内容
        this.items = []; // 道具 SimpleItemInfo
	},

	getId:function(){
		return 108115;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteString(this.title);
        _buf.WriteString(this.content);
        _buf.WriteUShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.title = _buf.ReadString();
        this.content = _buf.ReadString();
        var items_length = _buf.ReadUShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(SimpleItemInfo);
        }
	},

	action:function(){
		Mgr.backpack.RecvResItemDisplayPanelInfoToClientMessage(this);
	},

});
////////////////////
// 背包物品请求 //
////////////////////
var ReqGetItemsMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 108201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 移动物品 //
////////////////////
var ReqMoveItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.toGridId = 0; // 移动到格子Id
	},

	getId:function(){
		return 108202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.toGridId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.toGridId = _buf.ReadVarInt();
	},

});
////////////////////
// 使用物品 //
////////////////////
var ReqUseItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.num = 0; // 使用数量
	},

	getId:function(){
		return 108203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.num = _buf.ReadVarInt();
	},

});
////////////////////
// 删除物品 //
////////////////////
var ReqDelItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 108204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 整理物品 //
////////////////////
var ReqClearUpGoodsMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 108205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 物品丢弃 //
////////////////////
var ReqDiscardMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
	},

	getId:function(){
		return 108209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
	},

});
////////////////////
// 物品销毁 //
////////////////////
var ReqDestroyMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
	},

	getId:function(){
		return 108210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
	},

});
////////////////////
// 拾取 //
////////////////////
var ReqTakeUpMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsId = []; // 掉落ID long
	},

	getId:function(){
		return 108211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.goodsId.length );
        for (var i = 0; i < this.goodsId.length; i++) {
            _buf.WriteLong(this.goodsId[i]);
        }
	},
	
	reading:function( _buf ){
        var goodsId_length = _buf.ReadUShort();
        for (var i = 0; i < goodsId_length; i++) {
            this.goodsId[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 花元宝打开格子申请 //
////////////////////
var ReqOpenCellMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
        this.type = 0; // 1 包裹  2仓库  3寻宝仓库
	},

	getId:function(){
		return 108212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 格子开启剩余时间查询 //
////////////////////
var ReqCellTimeQueryMessage = cc.Class.extend( {
	ctor:function(){
		this.cellId = 0; // 格子编号
	},

	getId:function(){
		return 108208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.cellId);
	},
	
	reading:function( _buf ){
        this.cellId = _buf.ReadVarInt();
	},

});
////////////////////
// 时间到打开格子申请 //
////////////////////
var ReqOpenTimeCellMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1 包裹  2仓库  3寻宝仓库
	},

	getId:function(){
		return 108213;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 拆分道具 //
////////////////////
var ReqSplitItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
        this.num = 0; // 拆分数量
	},

	getId:function(){
		return 108214;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.num = _buf.ReadVarInt();
	},

});
////////////////////
// 请求礼包详细信息 //
////////////////////
var ReqGiftinfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 礼包唯一Id
        this.itemModelId = 0; // 礼包道具模板Id
	},

	getId:function(){
		return 108215;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
        _buf.WriteVarInt(this.itemModelId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
        this.itemModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 单独请求更新物品消息 //
////////////////////
var ReqGetItemAloneMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 唯一Id
	},

	getId:function(){
		return 108216;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 获取钱包 //
////////////////////
var ReqGetwalletMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0取出,1查看记录,2查看元宝数量
	},

	getId:function(){
		return 108217;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(108101, ResItemInfosMessage);
MESSAGE_POOL.Add(108102, ResItemAddMessage);
MESSAGE_POOL.Add(108103, ResItemChangeMessage);
MESSAGE_POOL.Add(108104, ResItemRemoveMessage);
MESSAGE_POOL.Add(108105, ResUseItemSuccessMessage);
MESSAGE_POOL.Add(108106, ResBackpackFullMessage);
MESSAGE_POOL.Add(108107, ResTakeUpSuccessMessage);
MESSAGE_POOL.Add(108108, ResCellTimeMessage);
MESSAGE_POOL.Add(108109, ResOpenCellResultMessage);
MESSAGE_POOL.Add(108110, ResGiftinfoToClientMessage);
MESSAGE_POOL.Add(108111, ResFlyItemInfoToClientMessage);
MESSAGE_POOL.Add(108112, ResGetwalletlogMessage);
MESSAGE_POOL.Add(108113, ResGetwalletnumMessage);
MESSAGE_POOL.Add(108114, ResUseGiftGetItemsMessage);
MESSAGE_POOL.Add(108115, ResItemDisplayPanelInfoToClientMessage);

