﻿/**
 * 背包管理
 */
var BackpackModMgr = BackpackModMgr || cc.Class.extend({
        //超级进阶大于或等于才能开始的阶数
        _superUpLayer:0,
        //进阶消耗
        _superUpNum:0,
        extraGrid:0,
        _backpackPanel: null,
        // 格子数据信息
        gridNumInfo: null,
        //背包物品信息vo
        backpackVO: null,
        //背包信息vo
        backpackInfoVo: null,
        dropItems:null,//掉落物品
        //================ 事件通知 ==================
        signalRecItemInfos: null,
        showLock: 1,//物品展示全局设置，这里还是设成int型，可用于多种lock形
        showHash:null,
        gridList:[],
        delayTime:0,
        newResEquipList:[],
        newEquipList:[],

        warehousePanel:null,
        ctor: function () {
            this.gridNumInfo = new BackpackGridNumInfo();
            this.backpackVO = new BackpackVo();
            this.backpackInfoVo = new BackpackInfoVO();
            this.signalRecItemInfos = new signals.Signal();
            this.oItemCd = new HashMap();
            this.showHash=new HashMap();
            this.dropItems = new HashMap();
        },
        SetPanel:function (Panel)
        {
            this._backpackPanel = Panel;
        },
        GetBackpackPanel:function(){
            return this._backpackPanel;
        },
        RecItemInfos: function (list, opennum) {
            var tempHash = new HashMap();
            var len = list.length;
            for (var i = 0; i < len; i++) {
                var item = this.FromItemInfoToItem(list[i]);
                if (item == null) {
                    // 可能是物品表非最新，但是也不能抛出异常
                    continue;
                }
                var oldItem = this.backpackInfoVo.GetItemInfoHash().Get(item.itemId.hexValue);
                if (oldItem != null) {
                    item.itemislocked = oldItem.itemislocked;
                }
//			    checkTimeItem( item );
                tempHash.Put(item.itemId.hexValue, item);
            }
            this.backpackVO.SetItemInfoHash(tempHash);
            this.OpenGridChange( opennum );
            this.signalRecItemInfos.dispatch(this.backpackVO);
        },

        GetBPEmptyGrid:function () {
            if(!Mgr.backpack.GetEmptyGrid()){
                return -1;
            }
            var bpItemLists = new HashMap();
            var vo = Mgr.backpack.backpackVO;
            var items = vo.GetItemInfoHash().Values();
            for(var i = 0, len = items.length; i < len; i++){
                var item = items[i];
                bpItemLists.Put(item.gridId, item);
            }

            var keys = bpItemLists.Keys();
            keys.sort(function (a, b) { return b - a; });
            var max = keys[0];
            for(var i = 1; i <= max; i++){
                if(bpItemLists.Get(i) == null){
                    return i;
                }
            }
            return (parseInt(max) + 1);
        },

        GetEmptyGrid:function(){
           var num= this.gridNumInfo.GetOpendNum()-this.backpackVO.GetItemInfoHash().Values().length;
            return num;
        },

        OpenGridChange: function (openedNum) {
            this.gridNumInfo.SetOpening(openedNum + 1);
            // 查询当前开启中 剩余时间

            // 刷新格子数量
            if ( Mgr.uiMgr.IsPanelShow( this._backpackPanel ))
            {
               // this._backpackPanel.UpdateGrid();
                this._backpackPanel.Update();
            }
        },
        GetItemGridNum:function()
        {
            return this.backpackVO.GetItemInfoHash().Size();
        },
        GetRemainGridNum:function()
        {
            var openedNum = this.gridNumInfo.GetOpendNum();
            var itemNum = this.GetItemGridNum();
            var  remainGridNum = openedNum - itemNum;
            return remainGridNum;
        },
        FromItemInfoToItem: function (info) {
            var itemm = Q_item.Get(info.itemModelId);
            if (itemm == null)
            {
                cc.log("客户端没有配置的道具 [fromItemInfoToItem]" + info.itemModelId);
            }
            var item = ItemUtil.ItemInfoToItem(info);
            this.AddItemCoolDown2(item);
            return item;
        },
        RecvResItemInfosMessage: function (msg) {
            this.RecItemInfos(msg.items, msg.cellnum);

            if(Mgr.uiMgr.IsPanelShow(this.warehousePanel)) {
                this.warehousePanel.InitBPItems();
                this.warehousePanel.RefreshBPPanel();
            }
        },
        AddNewItemFlyTobackpack:function(item){
            this.delayTime += 0.1;
            var pushV = false;
            var grid = null;
            for(var i = 0; i < this.gridList.length; i++){
                if(!this.gridList[i].isShow){
                    grid = this.gridList[i];
                    pushV = true;
                }
            }
            if(!pushV){
                var newGrid = new MUIGrid();
                var json = {"images":["public/grid/xiaokuang.png"],
                    "backgroundType":0,
                    "type":"Grid",
                    "childs":[],
                    "AnchorPoint":{"ScaleX":0,"ScaleY":0},
                    "id":"gridAward",
                    "tipsId":"",
                    "Size":{"Y":62,"X":62},
                    "bindData":{},
                    "Position":{"Y":200,"X":90}};
                newGrid.ParseJson(json);
                newGrid.Init();
                newGrid.isShow = true;
                Mgr.uiMgr.addChild(newGrid, 100000);
                this.gridList.push(newGrid);
                grid = newGrid;
            }
            grid.isShow = true;
            grid.visible = true;
            grid.x = ToolBase.GetWinWidth()/2;
            grid.y = ToolBase.GetWinHeight()/2 - 100;
            var coinInfo = {};
            coinInfo.itemModelId = item.itemModelId;
            coinInfo.itemNum = item.num;
            coinInfo.itemBind = item.isbind;
            GridUtil.SetItemGrid(grid, coinInfo);
            var delay = new cc.DelayTime(this.delayTime);
            var action1 = new cc.MoveBy(0.5, cc.p(0, 100));
            var action2 = new cc.MoveTo(1, cc.p(157, 20));
            var action = cc.sequence([delay, action1, action2,
                new cc.CallFunc(function(){
                    grid.isShow = false;
                    grid.Clean();
                    grid.visible = false;
                    this.delayTime -= 0.1;
                    if(this.delayTime < 0)
                        this.delayTime = 0;
                }, this)
            ]);
            grid.runAction(action);
        },
        RecvResItemAddMessage: function (msg) {
            // this.AddNewItemFlyTobackpack(msg.item);
            if(Mgr.uiMgr.IsPanelShow(this.warehousePanel)) {
                this.warehousePanel.AddBPItem(msg.item, msg.item.gridId);
                this.warehousePanel.RefreshWHPanel();
                this.warehousePanel.RefreshBPPanel();
            }

            var iteminfo = msg.item;
            var item = this.FromItemInfoToItem(iteminfo);
            if (item == null)
            {
                cc.log("没有该物品");
                return;
            }
            this.backpackVO.GetItemInfoHash().Put(item.itemId.hexValue, item);

            this.RealUpdateAndRefresh( iteminfo.itemModelId );

            if (Mgr.backpack.GetRemainGridNum() == 0)
            {
                Mgr.tips.ShowNotice( "背包满了");
            }
            //更新装备精炼相关处理显示状态的列表
            // if ( ItemUtil.getItemSmeltValue(item) != 0 || ( item.model != null && (ItemUtil.isMaterial(item.model.q_type) || ItemUtil.isGem(item.model.q_type) || ItemUtil.isEquip(item.model.q_type)) ) )//材料变化、有炼化值/熔炼的不在这里更新
            //     Mgr.refiningMgr.updateRefiningPanel(item.itemModelId);

            //坐骑、骑兵、美人系统刷新升阶道具
            // if( Mgr.uiMgr.isPanelShowByType(PlayerPanelExt) && Mgr.equipMgr.playerPanel.isReslinePanel() )
            //     Mgr.equipMgr.playerPanel.generalSystemPanel.updateNeedItem();
            var qitem = Q_item.Get(msg.item.itemModelId);
            //自动使用道具
            if( ItemUtil.IsAutoUse( item.itemModelId ) )
            {
                if( qitem.q_type == EnumItemType.Fashion ){
                    var isOpen = BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.OPEN_TYPE_SHOW,BtnGroupUtil.SHORT_DISGUISE);
                    if(isOpen)
                    {
                        Mgr.disguise.UseItem(item);
                    }
                }
                else{
                    this.SendReqUseItemMessage(item.itemId,item.itemNum);
                }
            }else{
                // 正常添加
                if ( qitem.q_type == EnumItemType.Equip
                    || qitem.q_type == EnumItemType.Equip_Shutong
                    || qitem.q_type == EnumItemType.Equip_Holy
                ){
                    //符合要求的装备直接穿戴20160719 by zfs
                    var pJob = Mgr.player.mainPlayer.job;
                    var iJob = qitem.q_job;

                    if ( pJob == iJob || iJob == 0 )
                    {
                        this.WearEquip(msg.item,pJob);
                    }
                    else{
                        this.AutoMelting(msg);
                    }
                }
                else if(qitem.q_type == EnumItemType.EquipBook )//装备图纸
                {
                    this.WearEquip(msg.item,0);
                }
                else if(qitem.q_type == EnumItemType.Handbook )//激活称号所需道具
                {
                    Mgr.tujian.CheckJihuoItem(msg.item.itemModelId);
                }
                else if(qitem.q_type == EnumItemType.PifengActivi){//披风幻化所需道具

                }
                else if(qitem.q_type == EnumItemType.PetActivi){//跟宠幻化所需道具
                    Mgr.illusion.SendReqIllusionDataInfoToGameMessage(HuanhuaType.TYPE_PET);
                }
                // TIP 看不懂的逻辑改下排版
                else if(qitem.q_whether_batch == 1
                    && qitem.q_type == EnumItemType.GIFT
                    || qitem.q_type == EnumItemType.AUTOUSE
                    || qitem.q_type == EnumItemType.ATTRIBUTE
                    || qitem.q_type == EnumItemType.ADDBUFF
                    || qitem.q_type == EnumItemType.SCRIPT
                    || qitem.q_type == EnumItemType.SELECT_GIFT
                ){
                    var panel = Mgr.uiMgr.ShowPanelByType(NewItemCueExt.PanelName);
                    panel.SetInfo(item);
                }else if(ItemUtil.IsEquip(qitem.q_type)) {      // 资源线装备提醒
                    var resLineType, type, subtype;
                    if (qitem.q_type == EnumItemType.MountEquip) {
                        type = BtnGroupUtil.M_JINJIE
                        subtype = BtnGroupUtil.JINJIE_HOURSE;
                        resLineType = EnumResline.HORSE;
                    } else if (qitem.q_type == EnumItemType.GuangWuEquip) {
                        type = BtnGroupUtil.M_JINJIE
                        subtype = BtnGroupUtil.JINJIE_GUANGWU;
                        resLineType = EnumResline.GUANGWU;
                    } else if (qitem.q_type == EnumItemType.GirlEquip) {
                        type = BtnGroupUtil.M_JINJIE
                        subtype = BtnGroupUtil.JINJIE_SHUTONG;
                        resLineType = EnumResline.SHUTONG;
                    } else if (qitem.q_type == EnumItemType.BaoQiEquip) {
                        type = BtnGroupUtil.M_JINJIE
                        subtype = BtnGroupUtil.JINJIE_BAOQI;
                        resLineType = EnumResline.BAOQI;
                    } else if (qitem.q_type == EnumItemType.FaqiEquip) {
                        type = BtnGroupUtil.M_JINJIE
                        subtype = BtnGroupUtil.JINJIE_FAQI;
                        resLineType = EnumResline.DRAGON;
                    }
                    this.AutoMelting(msg);
                    if (BtnGroupUtil.IsFunctionOpen(type, subtype)) {
                        var _mgr = Mgr.resline.GetMgrByType(resLineType);
                        if ( _mgr.GetLayer() >= qitem.q_rank ) {
                            var isfound = false;
                            var resEquips = _mgr._equips;
                            if ( resEquips ) {
                                for (var m = 0; m != resEquips.length; m++) {
                                    if (resEquips[m].itemModelId > 0 && qitem.q_type == Q_item.Get(resEquips[m].itemModelId).q_type
                                        && Q_item.Get(qitem.q_id).q_kind == Q_item.Get(resEquips[m].itemModelId).q_kind) {
                                        isfound = true;
                                        // 战力对比
                                        var fighting1 = DuanzaoUtil.GetEquipFighting(iteminfo.itemModelId, iteminfo.strenthenLv);
                                        var fighting2 = DuanzaoUtil.GetEquipFighting(resEquips[m].itemModelId, resEquips[m].strenthenLv);
                                        if (fighting1 > fighting2) {
                                            // Mgr.uiMgr.ShowPanelByType( NewEquipWarnExt.PanelName ).ShowNewEquip(msg.item);
                                            this.newResEquipList.push(msg.item);
                                        }
                                        break;
                                    }
                                }
                            }
                            if ( !isfound )
                                // Mgr.uiMgr.ShowPanelByType( NewEquipWarnExt.PanelName ).ShowNewEquip(msg.item);
                                this.newResEquipList.push(msg.item);
                        }
                    }
                }
                else if(qitem.q_type == EnumItemType.EQUIP_DISGUISE){
                    this.AutoMelting(msg);
                }
            }
            if ( Mgr.uiMgr.IsPanelShow( this._backpackPanel ) && msg.item.itemId != undefined )
            {
                this._backpackPanel.UpdateItemById(msg.item.itemId);
            }

            if(!Mgr.uiMgr.IsPanelShow(NewEquipWarnExt.PanelName) && this.newResEquipList.length > 0){
                var newItem = this.newResEquipList.shift();
                Mgr.uiMgr.ShowPanelByType(NewEquipWarnExt.PanelName).ShowNewEquip(newItem);
            }

            if(Mgr.uiMgr.IsPanelShowByName(XunBaoPanelExt.PanelName)){
                var panel = Mgr.uiMgr.GetPanelByType(XunBaoPanelExt.PanelName);
                panel.RefreshPanel();
            }
        },

        AutoMelting:function(msg){
            //物品变化时自动熔炼装备
            var item = msg.item;
            if(msg.type == -1)
                return;
            // var type = Q_item.Get(item.itemModelId).q_type;
            // var fighting = 0;
            if(Mgr.melting.isAutoMelting){
                var list = [];
                var q_item=Q_item.Get(item.itemModelId);
                var powerDis = ItemUtil.GetFightPowerFromCurrent(item);
                if(powerDis <= 0 && q_item.q_default <= ItemUtil.ITEM_QT_ORANGE || q_item.q_type == EnumItemType.EQUIP_DISGUISE){
                    list.push(item.itemId);
                }
                if(list.length > 0)
                    Mgr.melting.SendReqMeltingToGameMessage(list);
            }
        },

        //穿戴部位没有装备时穿装备，有装备时，穿装备图纸
        WearEquip:function(item,job)
        {
            if ( job != 0 )
            {
                var powerDis = ItemUtil.GetFightPowerFromCurrent(item);
                if(powerDis > 0){
                    this.newEquipList.push(item);
                }else {
                    var quality = ItemUtil.GetItemQuality(item);
                    if(quality < ItemUtil.ITEM_QT_ORANGE){
                        this.AutoMelting({item : item});
                        return;
                    }
                }

                if(!Mgr.uiMgr.IsPanelShowByName(GuildBossMarkExt.PanelName) && this.newEquipList.length > 0){
                    var panel = Mgr.uiMgr.ShowPanelByType(GuildBossMarkExt.PanelName);
                    var newItem = this.newEquipList.shift();
                    panel.GetNewEquipTips(newItem, function(){
                        Mgr.equip.SendWearEquipMessage(newItem.itemId);
                    });
                }
            }
            else
            {
                //装备图纸，直接使用
                Mgr.backpack.SendReqUseItemMessage(item.itemId, 1);
            }
        },
        RecvResGetwalletnumMessage:function(){
            cc.log("收到元宝消息");
        },
        
        /**
         * 客户端使用道具
         * @param item
         */
        UseItem:function(item, num, isManul){
            isManul = isManul || false;//设置参数a的默认值为false
            num = num? num : 1;//设置参数b的默认值为1

            if (item == null)
                return;

            if (item.GetBackNum() < num)
                return;

            var itemmodel = item.GetModel();
            if (itemmodel == null)
                return;

            //过场景的时候还是先断掉
            if ( Mgr.sceneMap.bChangingState == true )
                return;

            if ( item.IsOverdue() )
            {
                Mgr.tips.ShowNotice("无法使用的过期物品");
                return;
            }
            if ( Mgr.mainPlayer.IsDeadState() )//还是一样死了先GG
                return;

            if ( item.itemModelId == 103 ) {  // 神机宝箱
                Mgr.luckydraw.SendReqLuckyDrawInfoClientToGameMessage(EnumLucky.GODBOX);
                return;
            }

            var cdvo = this.GetItemCoolDown(itemmodel.q_id);
            if (cdvo != null && item.GetCoolDownTime() <= 0 )//（&& item.itemModelId != 1025 元宝卡让后端提示）这种强制不进入cd的先提出来
            {
                var html = TextUtil.GetHtmlStr("物品还在冷却中，请稍后使用。", null, -1);
                // Mgr.promptMgr.addPersonInfo(PersonalNoticeTypeEnum.Wrong, html);
                Mgr.tips.ShowNotice( html );//暂时这样加咯
                return;
            }
            switch (itemmodel.q_type) {
                case EnumItemType.Currency:
                case EnumItemType.MATERIAL:
                case EnumItemType.Equip_Shutong:
                case EnumItemType.Equip_Holy:
                case EnumItemType.Equip:
                    var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
                    if(pLevel<itemmodel.q_level)
                    {
                        Mgr.tips.ShowNotice("需要达到"+itemmodel.q_level+"级,才可以使用"+itemmodel.q_name);
                        return;
                    }
                    break;
                case EnumItemType.EquipBook:
                    var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
                    if(pLevel<itemmodel.q_level)
                    {
                        Mgr.tips.ShowNotice("需要达到"+itemmodel.q_level+"级,才可以使用"+itemmodel.q_name);
                        return;
                    }
                    break;
            }
            this.SendReqUseItemMessage(item.itemId, num);
        },
        GetItems:function(){
            return this.backpackVO.GetItemInfoHash().Values()
        },

        GetItemsByMid:function(modelId, outTimeCheck, isBind, timeLimit){
            outTimeCheck = outTimeCheck || false;
            isBind = isBind || -1;
            timeLimit = timeLimit || false;

            var itemArray = this.backpackVO.GetItemInfoHash().Values();
            var list = [];
            for( var i = 0, len = itemArray.length; i != len; i++ ){
                var item = itemArray[i];
                if ( item != null ){

                    if (outTimeCheck){
                        if (item.GetCoolDownTime() != 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.overdueTime) < 0)
                            continue;
                    }

                    if (timeLimit){
                        if (item.GetCoolDownTime() > 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.overdueTime) >= 0)
                            continue;
                    }
                    if (item.itemModelId == modelId && ( isBind == -1 || item.itemBind == isBind ))
                    {
                        list.push(item);
                        continue;
                    }
                }
            }
            return list;
        },

        GetItemsByType:function(type, outTimeCheck, isBind, timeLimit){
            outTimeCheck = outTimeCheck || false;
            isBind = isBind || -1;
            timeLimit = timeLimit || false;

            var itemArray = this.backpackVO.GetItemInfoHash().Values();
            var item;
            var list = [];
            for( var i = 0, len = itemArray.length; i != len; i++ ){
                item = itemArray[i];
                if ( item != null ){

                    if (outTimeCheck){
                        if (item.GetOverdueTime() != 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.GetOverdueTime()) < 0)
                            continue;
                    }

                    if (timeLimit){
                        if (item.GetOverdueTime() > 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.GetOverdueTime()) >= 0)
                            continue;
                    }

                    var model = Q_item.Get(item.itemModelId);
                    if(model){
                        if (model.q_type == type && ( isBind == -1 || item.itemBind == isBind ))
                        {
                            list.push(item);
                            continue;
                        }
                    }
                }
            }
            return list;
        },

        ItemIsEnough:function (mid, num) {
            var hold = this.GetItemNumber(mid);
            return hold >= num;
        },


        GetItemById:function(itemId)
        {
            return this.backpackVO.GetItemInfoHash().Get(itemId.hexValue);
        },

        GetItemNumber:function(mid, outTimeCheck, isBind, timeLimit ){
           outTimeCheck = outTimeCheck || false;
            isBind = isBind || -1;
            timeLimit = timeLimit || false;

            var num = 0;
            var itemArray = this.backpackVO.GetItemInfoHash().Values();
            for( var i = 0, len = itemArray.length; i != len; i++ ){
                var item = itemArray[i];
                if( item ){
                    if (outTimeCheck){
                        if (item.GetOverdueTime() != 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.GetOverdueTime()) < 0)
                            continue;
                    }

                    if (timeLimit){
                        if (item.GetOverdueTime() > 0 && TimeUtil.GetDeltaSecondsAtServerNow(item.GetOverdueTime()) >= 0)
                            continue;
                    }

                    if (item.itemModelId == mid && ( isBind == -1 || item.itemBind == isBind ))
                    {
                        num += item.itemNum;
                        continue;
                    }
                }
            }
            return num;
        },

        RecvResItemChangeMessage: function (msg) {
            // cc.log("物品修正---> "+ msg.item.itemModelId + "     " +JSON.stringify(msg));
            var info = msg.item;
            var newItem = this.FromItemInfoToItem(info);
            if( newItem ){
                var olditem = this.GetItemById( newItem.itemId );
                var oldNum = 0;
                if(olditem)
                {
                    oldNum = olditem.itemNum;
                    newItem.SetItemislocked(olditem.GetItemislocked());
                }
                this.backpackVO.GetItemInfoHash().Put( newItem.itemId.hexValue, newItem );
                var qitem = Q_item.Get(msg.item.itemModelId);
                if( qitem.q_whether_batch == 1 && oldNum < newItem.itemNum && (qitem.q_type == EnumItemType.GIFT || qitem.q_type == EnumItemType.AUTOUSE || qitem.q_type == EnumItemType.ATTRIBUTE || qitem.q_type == EnumItemType.ADDBUFF
                		|| qitem.q_type == EnumItemType.SCRIPT || qitem.q_type == EnumItemType.SELECT_GIFT)){
                    var panel = Mgr.uiMgr.ShowPanelByType(NewItemCueExt.PanelName);
                    panel.SetInfo(info);
                }
                if(qitem.q_type == EnumItemType.Handbook )//激活称号所需道具
                {
                	Mgr.tujian.CheckJihuoItem(msg.item.itemModelId);
                }
            }

            if ( Mgr.uiMgr.IsPanelShow( this._backpackPanel ) && msg.item.itemId != undefined )
            {
                this._backpackPanel.UpdateItemById(msg.item.itemId);
            }

            if(Mgr.uiMgr.IsPanelShowByName(XunBaoPanelExt.PanelName)){
                var panel = Mgr.uiMgr.GetPanelByType(XunBaoPanelExt.PanelName);
                panel.RefreshPanel();
            }
            this.RealUpdateAndRefresh(newItem.itemModelId);
        },

        RecvResItemRemoveMessage: function (msg) {
            if(Mgr.uiMgr.IsPanelShow(this.warehousePanel)){
                this.warehousePanel.RemoveBPItem(msg.itemId);
                this.warehousePanel.RefreshBPPanel();
                this.warehousePanel.RefreshWHPanel();
            }

            var item = this.backpackVO.GetItemInfoHash().Get(msg.itemId.hexValue);
            this.backpackVO.GetItemInfoHash().Remove( msg.itemId.hexValue );
            if(Mgr.uiMgr.IsPanelShowByName(BackpackPanelExt.PanelName)) {
                this._backpackPanel.UpdateShowItem();
                this._backpackPanel.SetItemShow(null);
            }
            this.RealUpdateAndRefresh(item.itemModelId);

            if(item.itemModelId>0){
            	var qitem = Q_item.Get(item.itemModelId);
            	if(qitem.q_type == EnumItemType. Handbook )//激活称号所需道具
            	{
            		Mgr.tujian.CheckJihuoItem(item.itemModelId);
            	}
            }
        },

        _RealUpdateAndRefresh:function(id){
            var list = this._updateList;
             this._updateList = [];

            this._timer4update = null;
            var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName);
            if (panel) panel.GoodsChange(list);

            ElseStrongUtil.OnConditionChanged();
        },

        RealUpdateAndRefresh:function(id){
            this._updateList = this._updateList || [];
            this._updateList.push(id);

            if(this._timer4update){
                TimerUtil.ClearTimeUpdate(this._timer4update);
            }
            this._timer4update = TimerUtil.SetTimeout(this, this._RealUpdateAndRefresh, 1000);

            Mgr.step.OnBackpackRefreshed(id)
        },

        RecvResUseItemSuccessMessage: function (msg) {
            var model = Q_item.Get(msg.itemModelId);
            if (model) {
                this.AddItemCoolDown(model);
                //刷新属性丹数量
                if( model.q_type == EnumItemType.ATTRIBUTE )
                {
                    var usedInfo = Mgr.player.mainPlayer.attrItem;
                    var o = false;
                    for(var i = 0, len = usedInfo.length; i < len; i++){
                        var info = usedInfo[i];
                        if(info.itemModelId == msg.itemModelId){
                            info.itemNum += msg.num;
                            usedInfo[i] = info;
                            o = true;
                            break;
                        }
                    }

                    if(!o){
                        var newInfo = new PlayerUseItem();
                        newInfo.itemModelId = msg.itemModelId;
                        newInfo.itemNum = msg.num;
                        usedInfo.push(newInfo);
                    }
                }
            }
            //刷一波面板
            var panel = Mgr.uiMgr.GetPanelByType(ShuXingDanMainExt.PanelName);
            if(panel && Mgr.uiMgr.IsPanelShow(panel)){
                panel.RefreshPanel();
            }

            if(msg.itemModelId == 221){//刷新元宝数量
                if(this._backpackPanel && Mgr.uiMgr.IsPanelShow(this._backpackPanel)){
                    this._backpackPanel.UpdateCurrency();
                }
            }

            // cc.log("use success!!!" + JSON.stringify(msg));
            // var backpack = Mgr.uiMgr.GetPanelByType(BackpackPanelExt.PanelName);
            // if(backpack && Mgr.uiMgr.IsPanelShow(backpack)){
            //     var items = this.backpackVO.GetItemInfoHash();
            //     cc.log(items.Keys()[0] + "   --   " + msg.itemModelId);
            //     var item = ItemUtil.ItemIdToItem(msg.itemModelId);
            //     if(!items.Get(item.itemId.hexValue) || !item){
            //         backpack.SetItemShow(null);
            //     }
            // }
            // Mgr.tips.ShowNotice("成功使用" + model.q_name + "*" + msg.num);
        },

        RecvResBackpackFullMessage: function (msg) {
        },
        RecvResTakeUpSuccessMessage: function (msg) {
            var list = msg.itemIds;
            for(var i = 0; i<list.length;i++)
            {
                var dropGoodsId = list[i];
                var item = this.dropItems.Get(dropGoodsId);
                this._PlayPickupAction(item,dropGoodsId)
            }
        },
        RecvResCellTimeMessage: function (msg) {
        },

        RecvResOpenCellResultMessage: function (msg) {
        },

        RecvResGiftinfoToClientMessage: function (msg) {
        },

        RecvResFlyItemInfoToClientMessage: function (msg) {
            cc.log("========发送道具飞包包信息=======")
            for(var i = 0; i < msg.itemModelIds.length; i++){
                var item = Q_item.Get(msg.itemModelIds[i]);
                this.AddNewItemFlyTobackpack({itemModelId: msg.itemModelIds[i], num: 0, isbind: item.q_bind});
            }
        },
        RecvResUseGiftGetItemsMessage:function (msg) {
           var panel = EngineMgr.uiMgr.ShowPanelByType(AwardZhanshiExt.PanelName,UIMgr.PANEL_LAYER_POP);
           panel.SetData(msg.items,msg.itemModel, msg.itemNum);
        },
        RecvResItemDisplayPanelInfoToClientMessage:function(msg){
            //zz.Error("this message is not in handle  -->  RecvResItemDisplayPanelInfoToClientMessage");

            // fix http://192.168.11.50/zentaopms/www/index.php?m=bug&f=view&id=8552
            // 应策划要求直接替换
            if(msg.title == "答题奖励"){
                msg.content = msg.content.replace(/本次帮派答题竞赛活动中，您的帮派共答对(\d+)道题，以下为活动奖励。/,"您的帮会共答对$1道题");
            }

            var panel = EngineMgr.uiMgr.ShowPanelByType(AwardZhanshiExt.PanelName,UIMgr.PANEL_LAYER_POP);
            panel.UpdateWithItemDisplay(msg);
        },

        //这个消息应该是用不上的
        SendReqGetItemsMessage: function (msg) {
            var msg = new ReqGetItemsMessage();
            Mgr.msgMgr.Send(msg);
        },

        SendReqMoveItemMessage: function (msg) {
        },

        SendReqUseItemMessage: function (itemId, num) {
            num = num || 1;
            var msg = new ReqUseItemMessage();
            msg.itemId = itemId;
            msg.num = num;
            Mgr.msgMgr.Send( msg );
        },

        SendReqDelItemMessage: function (itemId) {
            var msg = new ReqDelItemMessage();
            msg.itemId = itemId;
            Mgr.msgMgr.Send(msg);
        },

        /**
         * 整理
         * @param msg
         * @constructor
         */
        SendReqClearUpGoodsMessage: function () {
            this.backpackInfoVo.BeginSort();
            var msg = new ReqClearUpGoodsMessage();
            Mgr.msgMgr.Send(msg);
        },
        //上架后整理一下背包
        SendReqClearUpGoodsMessage01: function () {
            var msg = new ReqClearUpGoodsMessage();
            Mgr.msgMgr.Send(msg);
        },
        /**
         * 请求丢弃物品
         */
        SendReqDiscardMessage: function (gridId) {
            var msg = new ReqDiscardMessage();
            msg.cellId = gridId;
            Mgr.msgMgr.Send(msg);
        },

        SendReqDestroyMessage: function (msg) {
        },
        /**
         * 请求拾取物品
         */
        SendReqTakeUpMessage: function (sid) {
            var msg = new ReqTakeUpMessage();
            msg.goodsId = sid;
            Mgr.msgMgr.Send(msg);
        },

        SendReqOpenCellMessage: function (msg) {
        },

        SendReqCellTimeQueryMessage: function (msg) {
        },

        SendReqOpenTimeCellMessage: function (msg) {
        },

        SendReqSplitItemMessage: function (msg) {
        },

        SendReqGiftinfoToGameMessage: function (msg) {
        },

        SendReqGetItemAloneMessage: function (msg) {
        },

        oItemCd: null,
        AddItemCoolDown: function (model) {
            if (ItemUtil.IsDrawGoldCard(model.q_id) || (model.q_cooldown == 0 && model.q_cooldown_type == 0)) {
                return;
            }
            var itemsArr = this.backpackInfoVo.GetItemInfoHash().Values();
            var len = itemsArr.length;
            var item;
            var q_item;
            for (var i = 0; i < len; i++) {
                item = itemsArr[i];
                q_item = Q_item.Get(item.itemModelId);
                if (q_item && q_item.q_cooldown_level == model.q_cooldown_level) {
                    this.oItemCd.Put(item.itemModelId, {
                        end: (q_item.q_cooldown_type + TimerUtil.GetTimer()),
                        max: q_item.q_cooldown_type
                    });
                }
            }
        },

        AddItemCoolDown2: function (item) {
            if (item.GetCoolDownTime() <= 0)
                return;

            if (ItemUtil.IsDrawGoldCard(item.itemModelId)) {
                this.oItemCd.Put(item.itemId.hexValue, {
                    end: (item.GetCoolDownTime() + TimerUtil.GetTimer()),
                    max: 24 * 3600 * 1000
                });
                return;
            }
            var q_item = Q_item.Get(item.itemModelId);
            if (q_item) {
                this.oItemCd.Put(item.itemModelId, {
                    end: (item.GetCoolDownTime() + TimerUtil.GetTimer()),
                    max: 24 * 3600 * 1000
                });
            }
        },
        GetItemCoolDown:function(mid){
        	var vo = this.oItemCd.Get(mid);
            if (vo == null)
            	return null;
            
            var ret = vo.end - ToolBase.GetTimer();
            if (ret <= 0)
            {
            	this.oItemCd.Remove(mid);
            	vo = null;
            }
            return vo;
        },
        IsItemCoolDown: function (mid) {
            var v = this.oItemCd.Get(mid);
            if (v) {
                if (ToolBase.GetTimer() < v.end) {
                    return true;
                }
                this.oItemCd.Remove(mid);
            }
            return false;
        },
        GetSuperUpLayer:function()
        {
            if( this._superUpLayer == 0 )
                this._superUpLayer = JSON.parse(Q_global.Get(529).q_string_value)[0];
            return this._superUpLayer;
        },
        GetSuperUpNum:function()
        {
            if( this._superUpNum == 0 )
                this._superUpNum = JSON.parse(Q_global.Get(529).q_string_value)[1];
            return this._superUpNum;
        },
        UpdatePriceInfo:function(info){
            this._backpackPanel.UpdatePriceInfo(info);
        },
        _PlayPickupAction:function(item,dropGoodsId)
        {
            this.dropItems.Remove(dropGoodsId);
            var panel = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName );
            var icon = ItemUtil.GetItemIcon(item.itemModelId);
            icon.scale = item.itemScale;
            var pos = item.worldPos;
            icon.setPosition(pos);
            panel.addChild(icon);
            var backpackIcon = panel.btnBackpack;
            var endPos = backpackIcon.parent.convertToWorldSpace(backpackIcon.getPosition());
            var moveTo = cc.moveTo(1.5,cc.p(endPos.x+backpackIcon.width/2,endPos.y+backpackIcon.height/2));
            var callback = cc.callFunc(function(target)
            {
                target.removeFromParent();
            },this);
            var easeOut= cc.EaseIn.create(moveTo,0.5);
            var sequence = cc.sequence(easeOut,callback);
            icon.runAction(sequence);
        },

        CheckOutTimeItem:function(){
            var items = this.backpackInfoVo.GetItemInfoHash().Values();
            var arr = [];
            for( var i = 0, len = items.length; i < len; i++ ){
                var item = items[i];
                if( item.IsOverdue() ){
                    arr.push(item.itemId);
                }
            }
            if( arr.length > 0 ){
                AlertExt.Show("是否自动摧毁过期道具？\n" + TextUtil.AddColor("（摧毁后将无法找回）", "fe2323"), TipsEnum.BUTTON_SURE_AND_FALSE, {
                    _onFunc:function(){
                        Mgr.shop.SendReqSellItemsMessage(arr);
                    },
                },1)
            }
        },
    });