///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//134201,ReqBankInfoToGame 前端请求玩家投资信息
//134202,ReqBankBuyMonthToGame 请求购买月卡投资
//134203,ReqBankMonthAwardToGame 请求领取月卡投资返利
//134204,ReqBankBuyLevelToGame 请求购买等级投资
//134205,ReqBankLevelAwardToGame 请求领取等级返利
//134206,ReqBankBuyAdvanceToGame 请求购买进阶投资
//134207,ReqBankAdvanceAwardToGame 请求领取进阶投资奖励
//134208,ReqBankBuyWeekToGame 请求购买周礼包投资
//134209,ReqBankWeekAwardToGame 请求领取周礼包投资奖励

// 接收消息
//134101,ResBankMonthInfoToClient 返回给前端玩家投资月卡信息
//134102,ResBankLevelInfoToClient 返回给前端玩家投资等级信息
//134103,ResBankAdvanceInfoToClient 返回给前端玩家进阶投资信息
//134104,ResBankWeekInfoToClient 返回给前端玩家周礼包投资信息


////////////////////
// 返回给前端玩家投资月卡信息 //
////////////////////
var ResBankMonthInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.buyMonthTime = 0; // 月卡购买时间（1970年至今天数）
        this.flage = 0; // 月卡领取标记(二进制1是第一天已领取)
	},

	getId:function(){
		return 134101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.buyMonthTime);
        _buf.WriteVarInt(this.flage);
	},
	
	reading:function( _buf ){
        this.buyMonthTime = _buf.ReadVarInt();
        this.flage = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.bank.RecvResBankMonthInfoToClientMessage(this);
	},

});
////////////////////
// 返回给前端玩家投资等级信息 //
////////////////////
var ResBankLevelInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.buyLevelGold = 0; // 等级投资购买金额
        this.levels = []; // 已领取等级投资 int
        this.getLevelGold = []; // 已领取等级投资的金额（和上面已领取返利的等级列表索引一一对应） int
	},

	getId:function(){
		return 134102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.buyLevelGold);
        _buf.WriteShort( this.levels.length );
        for (var i = 0; i < this.levels.length; i++) {
            _buf.WriteVarInt(this.levels[i]);
        }
        _buf.WriteShort( this.getLevelGold.length );
        for (var i = 0; i < this.getLevelGold.length; i++) {
            _buf.WriteVarInt(this.getLevelGold[i]);
        }
	},
	
	reading:function( _buf ){
        this.buyLevelGold = _buf.ReadVarInt();
        var levels_length = _buf.ReadShort();
        for (var i = 0; i < levels_length; i++) {
            this.levels[i] = _buf.ReadVarInt();
        }
        var getLevelGold_length = _buf.ReadShort();
        for (var i = 0; i < getLevelGold_length; i++) {
            this.getLevelGold[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.bank.RecvResBankLevelInfoToClientMessage(this);
	},

});
////////////////////
// 返回给前端玩家进阶投资信息 //
////////////////////
var ResBankAdvanceInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.isGet = 0; // 今日是否领取奖励(0没1领取)
        this.advanceRemianTime = 0; // 进阶投资剩余天数(-1为永久)
	},

	getId:function(){
		return 134103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.isGet);
        _buf.WriteVarInt(this.advanceRemianTime);
	},
	
	reading:function( _buf ){
        this.isGet = _buf.ReadByte();
        this.advanceRemianTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.bank.RecvResBankAdvanceInfoToClientMessage(this);
	},

});
////////////////////
// 返回给前端玩家周礼包投资信息 //
////////////////////
var ResBankWeekInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.indexDay = 0; // 今天是第几天
        this.getRwardNum = 0; // 已领取次数
	},

	getId:function(){
		return 134104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.indexDay);
        _buf.WriteVarInt(this.getRwardNum);
	},
	
	reading:function( _buf ){
        this.indexDay = _buf.ReadVarInt();
        this.getRwardNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.bank.RecvResBankWeekInfoToClientMessage(this);
	},

});
////////////////////
// 前端请求玩家投资信息 //
////////////////////
var ReqBankInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 投资类型(1等级2月卡3进阶4周礼包)
	},

	getId:function(){
		return 134201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求购买月卡投资 //
////////////////////
var ReqBankBuyMonthToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 134202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取月卡投资返利 //
////////////////////
var ReqBankMonthAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.day = 0; // 第几天
	},

	getId:function(){
		return 134203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
	},
	
	reading:function( _buf ){
        this.day = _buf.ReadVarInt();
	},

});
////////////////////
// 请求购买等级投资 //
////////////////////
var ReqBankBuyLevelToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.gold = 0; // 购买金额
	},

	getId:function(){
		return 134204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
	},
	
	reading:function( _buf ){
        this.gold = _buf.ReadVarInt();
	},

});
////////////////////
// 请求领取等级返利 //
////////////////////
var ReqBankLevelAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.level = 0; // 等级
	},

	getId:function(){
		return 134205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.level);
	},
	
	reading:function( _buf ){
        this.level = _buf.ReadVarInt();
	},

});
////////////////////
// 请求购买进阶投资 //
////////////////////
var ReqBankBuyAdvanceToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 134206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取进阶投资奖励 //
////////////////////
var ReqBankAdvanceAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 134207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求购买周礼包投资 //
////////////////////
var ReqBankBuyWeekToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 134208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取周礼包投资奖励 //
////////////////////
var ReqBankWeekAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 134209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(134101, ResBankMonthInfoToClientMessage);
MESSAGE_POOL.Add(134102, ResBankLevelInfoToClientMessage);
MESSAGE_POOL.Add(134103, ResBankAdvanceInfoToClientMessage);
MESSAGE_POOL.Add(134104, ResBankWeekInfoToClientMessage);

