///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//BuffInfo buff信息类
//BuffParameter buff参数类

// 请求消息
//121201,ReqRemoveBuff 移除Buff请求
//121202,ReqBuffInfo 获取Buff信息
//121203,ReqShowBuffInfo 获取身上可展示的Buff信息

// 接收消息
//121101,ResBuffs Buff列表
//121102,ResAddBuff 增加Buff
//121103,ResRemoveBuff 移除Buff
//121104,ResBuffInfo Buff信息
//121105,ResChangeBuff Buff改变
//121106,ResShowBuffInfo 别人能展示的Buff列表


var BuffInfo = cc.Class.extend({
	ctor:function(){
		this.buffId = null; // buff唯一Id
        this.buffModelId = 0; // buff模板Id
        this.overlay = 0; // 叠加层数
        this.totalTime = 0; // 持续时间
        this.remainTime = 0; // 持续剩余时间
        this.value = 0; // 值加成
        this.percent = 0; // 比例加成
        this.buffParameter = []; // 参数 BuffParameter
	},

	writing:function( _buf ){
		_buf.WriteLong(this.buffId);
        _buf.WriteVarInt(this.buffModelId);
        _buf.WriteVarInt(this.overlay);
        _buf.WriteVarInt(this.totalTime);
        _buf.WriteVarInt(this.remainTime);
        _buf.WriteVarInt(this.value);
        _buf.WriteVarInt(this.percent);
        _buf.WriteShort( this.buffParameter.length );
        for (var i = 0; i < this.buffParameter.length; i++) {
            _buf.WriteBean(this.buffParameter[i]);
        }
	},
	
	reading:function( _buf ){
		this.buffId = _buf.ReadLong();
        this.buffModelId = _buf.ReadVarInt();
        this.overlay = _buf.ReadVarInt();
        this.totalTime = _buf.ReadVarInt();
        this.remainTime = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
        this.percent = _buf.ReadVarInt();
        var buffParameter_length = _buf.ReadShort();
        for (var i = 0; i < buffParameter_length; i++) {
            this.buffParameter[i] = _buf.ReadBean(BuffParameter);
        }
	},
});
var BuffParameter = cc.Class.extend({
	ctor:function(){
		this.type = 0; // buff参数类型
        this.value = 0; // buff参数值
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.value);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
	},
});
////////////////////
// Buff列表 //
////////////////////
var ResBuffsMessage = cc.Class.extend( {
	ctor:function(){
		this.fightState = 0; // 战斗状态
        this.buff = []; // buff BuffInfo
	},

	getId:function(){
		return 121101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.fightState);
        _buf.WriteShort( this.buff.length );
        for (var i = 0; i < this.buff.length; i++) {
            _buf.WriteBean(this.buff[i]);
        }
	},
	
	reading:function( _buf ){
        this.fightState = _buf.ReadVarInt();
        var buff_length = _buf.ReadShort();
        for (var i = 0; i < buff_length; i++) {
            this.buff[i] = _buf.ReadBean(BuffInfo);
        }
	},

	action:function(){
		Mgr.buff.RecvResBuffsMessage(this);
	},

});
////////////////////
// 增加Buff //
////////////////////
var ResAddBuffMessage = cc.Class.extend( {
	ctor:function(){
		this.sourceId = null; // 来源Id
        this.personId = null; // 角色Id
        this.fightState = 0; // 战斗状态
        this.buff = null; // buff
	},

	getId:function(){
		return 121102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.sourceId);
        _buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.fightState);
        _buf.WriteBean(this.buff);
	},
	
	reading:function( _buf ){
        this.sourceId = _buf.ReadLong();
        this.personId = _buf.ReadLong();
        this.fightState = _buf.ReadVarInt();
        this.buff = _buf.ReadBean(BuffInfo);
	},

	action:function(){
		Mgr.buff.RecvResAddBuffMessage(this);
	},

});
////////////////////
// 移除Buff //
////////////////////
var ResRemoveBuffMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.fightState = 0; // 战斗状态
        this.buffId = null; // buff Id
	},

	getId:function(){
		return 121103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteVarInt(this.fightState);
        _buf.WriteLong(this.buffId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.fightState = _buf.ReadVarInt();
        this.buffId = _buf.ReadLong();
	},

	action:function(){
		Mgr.buff.RecvResRemoveBuffMessage(this);
	},

});
////////////////////
// Buff信息 //
////////////////////
var ResBuffInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.buffId = null; // buff Id
        this.remain = 0; // Buff 剩余时间
        this.value = 0; // Buff 数值 主要用于血池
	},

	getId:function(){
		return 121104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.buffId);
        _buf.WriteVarInt(this.remain);
        _buf.WriteVarInt(this.value);
	},
	
	reading:function( _buf ){
        this.buffId = _buf.ReadLong();
        this.remain = _buf.ReadVarInt();
        this.value = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.buff.RecvResBuffInfoMessage(this);
	},

});
////////////////////
// Buff改变 //
////////////////////
var ResChangeBuffMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.sourceId = null; // 来源Id
        this.fightState = 0; // 战斗状态
        this.buff = null; // buff
	},

	getId:function(){
		return 121105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteLong(this.sourceId);
        _buf.WriteVarInt(this.fightState);
        _buf.WriteBean(this.buff);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.sourceId = _buf.ReadLong();
        this.fightState = _buf.ReadVarInt();
        this.buff = _buf.ReadBean(BuffInfo);
	},

	action:function(){
		Mgr.buff.RecvResChangeBuffMessage(this);
	},

});
////////////////////
// 别人能展示的Buff列表 //
////////////////////
var ResShowBuffInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.buffs = []; // buff列表 BuffInfo
	},

	getId:function(){
		return 121106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteShort( this.buffs.length );
        for (var i = 0; i < this.buffs.length; i++) {
            _buf.WriteBean(this.buffs[i]);
        }
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        var buffs_length = _buf.ReadShort();
        for (var i = 0; i < buffs_length; i++) {
            this.buffs[i] = _buf.ReadBean(BuffInfo);
        }
	},

	action:function(){
		Mgr.buff.RecvResShowBuffInfoMessage(this);
	},

});
////////////////////
// 移除Buff请求 //
////////////////////
var ReqRemoveBuffMessage = cc.Class.extend( {
	ctor:function(){
		this.buffId = null; // buff Id
	},

	getId:function(){
		return 121201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.buffId);
	},
	
	reading:function( _buf ){
        this.buffId = _buf.ReadLong();
	},

});
////////////////////
// 获取Buff信息 //
////////////////////
var ReqBuffInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.buffId = null; // buff Id
	},

	getId:function(){
		return 121202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.buffId);
	},
	
	reading:function( _buf ){
        this.buffId = _buf.ReadLong();
	},

});
////////////////////
// 获取身上可展示的Buff信息 //
////////////////////
var ReqShowBuffInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 121203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(121101, ResBuffsMessage);
MESSAGE_POOL.Add(121102, ResAddBuffMessage);
MESSAGE_POOL.Add(121103, ResRemoveBuffMessage);
MESSAGE_POOL.Add(121104, ResBuffInfoMessage);
MESSAGE_POOL.Add(121105, ResChangeBuffMessage);
MESSAGE_POOL.Add(121106, ResShowBuffInfoMessage);

