/**
 * 聊天信息item
 *
 */
var ChatItem_V1 = ChatItem_V1 || ccui.Widget.extend({
    _strColor:cc.color(0,0,0,255),//描边顏色
    _strokeWidth:0.01,//描边宽度
    RICHUIWIDTH_ONE:389,
    //RICHUIWIDTH_TWO:328,
    RICHUIWIDTH_TWO:340,
    RICHUIWIDTH_THREE:455,
    RICHUIWIDTH_FOUR:360,
    RICHUIWIDTH_FIVE:2000,
    callBack:null,
    callbackTarget:null,
    _lineHeight:null,
    ctor:function(callback,callbackTarget,lineHeight) {
        this._super();
        this.setTouchEnabled(true);
        this.setSwallowTouches(false);
        this.callBack = callback;
        this.callbackTarget = callbackTarget;

        this._lineHeight = lineHeight || 28;
    },

    CreateItem:function (msg,isMainUI) {
        var chanelType = msg.type,sendName = msg.name,extraResInfo = msg.extraResInfo;
        if(sendName.length < 2){
            sendName = "";
        }else{
            sendName = "<font color=\"#26c4eb\">[<u>"+sendName+"</u>]</font>";//html
        }

        var contentText = "";
        if(msg.chatText instanceof Array)
        {
            contentText = msg.chatText;
        }
        else
        {
            contentText = TextUtil.RemoveHTMLTag(msg.chatText);
        }
        this.customRichWidth = 0;
        //频道
        var channelLabel = this.GetCurrentChannelType(chanelType);
        if(chanelType == EnumChatChannelType.SYSTEM
            || chanelType == EnumChatChannelType.NEWSYSTEM
            || sendName.length<2)
        {
            sendName = "";
        }
        var fontName = GameFont.DEFAULT;
        var contentColor = this.GetContentColor(chanelType,isMainUI);
        var contentFontSize = EnumFontFormat.FONTSIZE_TIP;
        if (chanelType == EnumChatChannelType.MANY
        	|| chanelType == EnumChatChannelType.SYSTEM
        	|| chanelType == EnumChatChannelType.NEWSYSTEM
        	|| chanelType == EnumChatChannelType.SOUND
        	|| isMainUI
        	|| chanelType == EnumChatChannelType.SOUND_GUANGBO)
        {
            var gapX = 5;
            var fmt = this.GetChatChannelColor(chanelType);
            var channelNameText = new MUILabel();
            channelNameText.height = channelNameText.GetHeight();
            channelNameText.setAnchorPoint(0,0);
            channelNameText.SetString(channelLabel);
            channelNameText.SetColor(fmt.color);
            channelNameText.SetFontSize(fmt.fontsize);
            channelNameText.width = channelNameText.GetWidth();
            this.addChild(channelNameText,10);
            if(!isMainUI)
            {
                var bg = ChatUtil.getChannelBgName(chanelType);
                if(bg){
                    var channelBg = new ccui.ImageView();
                    channelBg.setPosition(channelNameText.width/2,channelNameText.height/2);
    //                var imageRes = this._GetChannelBgRes(chanelType);

                    UIUtil.LoadImage(channelBg,bg,false,true);

                    channelNameText.SetString("     ");
                    channelNameText.addChild(channelBg, -1);

                    channelNameText.x = 25
                    gapX = 30
                }
            }else{
                var format = this.GetZJMChannelColor(chanelType);
                channelNameText.SetColor(format.color);
                channelNameText.SetFontSize(format.fontsize);
                channelNameText.EnableOutline(format.miaobian,0.1);
                gapX = 5;
                contentFontSize = EnumFontFormat.FONTSIZE_TIP;
            }
            if(isMainUI && chanelType != EnumChatChannelType.SOUND_GUANGBO)
            {
                this.customRichWidth = this.RICHUIWIDTH_ONE;
            }
            var richUI = new RichUI(this.customRichWidth,this.callBack,this.callbackTarget);
            var richText = new RichElement();
            richUI.SetLineHeight(this._lineHeight);
            richUI.setTouchEnabled(true);
            richUI.setSwallowTouches(true);
            richText.CreateElementText( 1, contentColor, contentText, fontName, contentFontSize ,sendName,extraResInfo,chanelType);
            richUI.PushBackElement(richText,msg,isMainUI);
            this.addChild(richUI,10);
            richUI.x = channelNameText.x+channelNameText.width+gapX;
            richUI.y = chanelType == EnumChatChannelType.SOUND?12:0;
            channelNameText.y = richUI.height -channelNameText.height / 2 - this._lineHeight / 2 ;
//            if(chanelType == EnumSystemInfoType.GUILD_ANSWER)
//            {
//                channelNameText.y = richUI.height - channelNameText.height;
//            }
            this.ResetSize(richUI.width, richUI.height + (isMainUI ? 0 : 5));
        }
        else
        {
            var richUI = new RichUI(this.customRichWidth,this.callBack,this.callbackTarget);
            var richText = new RichElement();
            richUI.setTouchEnabled(true);
            richUI.setSwallowTouches(true);
            richText.CreateElementText( 1, contentColor, contentText, fontName, contentFontSize ,sendName,extraResInfo,chanelType);
            richUI.PushBackElement(richText,msg,isMainUI);
            richUI.x+=20;
            this.addChild(richUI,10);
            this.ResetSize(richUI.width, richUI.height);
        }
    },
    //获取主界面聊天频道颜色
    GetChatChannelColor:function(channeltype)
    {
        var color = EnumFontFormat.COMMON_COLOR07;
        var fontsize = EnumFontFormat.FONTSIZE_TIP;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                color = EnumFontFormat.COMMON_COLOR01;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                break;
            }
            default:break;
        }
        var obj = {color:color,fontsize:fontsize}
        return obj;
    },
    //获取聊天内容字体颜色
    GetContentColor:function(channeltype,isMainUI)
    {
        var color = EnumFontFormat.CHAT_ZHONGHE;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                color = EnumFontFormat.CHAT_ZHONGHE;
                break;
            }
            case EnumChatChannelType.NEWSYSTEM://系统
                color = EnumFontFormat.CHAT_NEWSYSTEM;
                break;
            case EnumChatChannelType.SYSTEM://系统
            {
                color = EnumFontFormat.CHAT_SYSTEM;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                color = EnumFontFormat.CHAT_WORLD;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                color = EnumFontFormat.CHAT_WORLD;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                color = EnumFontFormat.CHAT_TEAM;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                color = EnumFontFormat.CHAT_BANGPAN;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会答题
            {
                color = EnumFontFormat.COMMON_COLOR10;
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                color = EnumFontFormat.CHAT_PRIVATE;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                color = EnumFontFormat.CHAT_LABA;
                break;
            }
            case EnumChatChannelType.SOUND_GUANGBO://传音
            {
                color = EnumFontFormat.CHAT_SYSTEM;
                break;
            }
            default:break;
        }
        return color;
    },
    //获取主界面聊天频道颜色
    GetZJMChannelColor:function(channeltype)
    {
        var color = EnumFontFormat.ZJM_SHIJIE_COLOR;
        var fontsize = EnumFontFormat.FONTSIZE_TIP;
        var miaobian = EnumFontFormat.COMMON_COLOR11;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                color = EnumFontFormat.ZJM_SHIJIE_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                color = EnumFontFormat.ZJM_SHIJIE_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                color = EnumFontFormat.ZJM_BANGHUI_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会
            {
                color = EnumFontFormat.ZJM_BANGHUI_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                break;
            }
            default:break;
        }
        var obj = {color:color,fontsize:fontsize,miaobian:miaobian}
        return obj;
    },
    //获取当前聊天频道
    GetCurrentChannelType:function(chanelType)
    {
        var channelLabel = "";
        this.customRichWidth = this.RICHUIWIDTH_TWO;
        switch (chanelType)
        {
            case EnumChatChannelType.MANY://综合
            {
                channelLabel = "综合";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.NEWSYSTEM://系统
            case EnumChatChannelType.SYSTEM://系统
            {
                channelLabel = "系统";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                channelLabel = "世界";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                channelLabel = "世界";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                channelLabel = "队伍";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                channelLabel = "帮会";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会
            {
                channelLabel = "帮会";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                channelLabel = "传音";
                this.customRichWidth = this.RICHUIWIDTH_FOUR;
                break;
            }
            case EnumChatChannelType.SOUND_GUANGBO://传音
            {
                channelLabel = "传音";
                this.customRichWidth = this.RICHUIWIDTH_FIVE;
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                channelLabel = "私人";
                this.customRichWidth = this.RICHUIWIDTH_THREE;
                break;
            }
            default:break;
        }
        return channelLabel;
    },
    _GetChannelBgRes:function(chanelType)
    {
        var resUrl = "other/liaotian/image/biaoqian/di_zi.png";
        return resUrl;
        var resUrl = "other/liaotian/image/biaoqian/di_lv.png";
        switch (chanelType)
        {
            case EnumChatChannelType.MANY://综合
            {
                resUrl = "other/liaotian/image/biaoqian/di_lv.png";
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                resUrl = "other/liaotian/image/biaoqian/di_hong.png";
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                resUrl = "other/liaotian/image/biaoqian/di_zi.png";
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                resUrl = "other/liaotian/image/biaoqian/di_zi.png";
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                resUrl = "other/liaotian/image/biaoqian/di_huang.png";
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                resUrl = "other/liaotian/image/biaoqian/di_lan.png";
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                resUrl = "other/liaotian/image/biaoqian/di_lv.png";
                break;
            }
            default:break;
        }
        return resUrl;
    },
    ResetSize:function(width, height)
    {
        this.setContentSize(cc.size(width, height));
        this.setAnchorPoint(0,0);
    },

    OnMenuCallbackNameLink:function(sender){
        this.parent.switchTo(0);
    }
});


/**
 * 聊天信息item
 *
 */
var ChatItem_V2 = ChatItem_V2 || ccui.Widget.extend({
    _strColor:cc.color(0,0,0,255),//描边顏色
    _strokeWidth:0.01,//描边宽度
    RICHUIWIDTH_ONE:389,
    //RICHUIWIDTH_TWO:328,
    RICHUIWIDTH_TWO:340,
    RICHUIWIDTH_THREE:455,
    RICHUIWIDTH_FOUR:360,
    RICHUIWIDTH_FIVE:2000,
    callBack:null,
    callbackTarget:null,
    _lineHeight:null,
    ctor:function(callback,callbackTarget,lineHeight) {
        this._super();
        this.setTouchEnabled(true);
        this.setSwallowTouches(false);
        this.callBack = callback;
        this.callbackTarget = callbackTarget;

        this._lineHeight = lineHeight || 28;
    },

    CreateItem:function (msg,isMainUI) {
        var chanelType = msg.type,sendName = msg.name,extraResInfo = msg.extraResInfo;
        if(sendName.length < 2){
            sendName = "";
        }else{
            sendName = "<font color=\"#26c4eb\">[<u>"+sendName+"</u>]</font>";//html
        }

        var contentText = "";
        if(msg.chatText instanceof Array)
        {
            contentText = msg.chatText;
        }
        else
        {
            contentText = TextUtil.RemoveHTMLTag(msg.chatText);
        }
        this.customRichWidth = 0;
        //频道
        var channelLabel = this.GetCurrentChannelType(chanelType);
        if(chanelType == EnumChatChannelType.SYSTEM
            || chanelType == EnumChatChannelType.NEWSYSTEM
            || sendName.length<2)
        {
            sendName = "";
        }
        var fontName = GameFont.DEFAULT;
        var contentColor = this.GetContentColor(chanelType,isMainUI);
        var contentFontSize = EnumFontFormat.FONTSIZE_TIP;
        if (chanelType == EnumChatChannelType.MANY
        	|| chanelType == EnumChatChannelType.SYSTEM
        	|| chanelType == EnumChatChannelType.NEWSYSTEM
        	|| chanelType == EnumChatChannelType.SOUND
        	|| isMainUI
        	|| chanelType == EnumChatChannelType.SOUND_GUANGBO)
        {
            var gapX = 5;
            var fmt = this.GetChatChannelColor(chanelType);
            var channelNameText = new MUILabel();
            channelNameText.height = channelNameText.GetHeight();
            channelNameText.setAnchorPoint(0,0);
            channelNameText.SetString(channelLabel);
            channelNameText.SetColor(fmt.color);
            channelNameText.SetFontSize(fmt.fontsize);
            channelNameText.width = channelNameText.GetWidth();
            this.addChild(channelNameText,10);
            if(!isMainUI)
            {
                var bg = ChatUtil.getChannelBgName(chanelType);
                if(bg){
                    var channelBg = new ccui.ImageView();
                    UIUtil.LoadImage(channelBg,bg,false,true);

                    channelBg.setPosition(channelNameText.width/2,channelNameText.height/2);
    //                var imageRes = this._GetChannelBgRes(chanelType);

                    channelNameText.SetString("     ");
                    channelNameText.addChild(channelBg, -1);

                    channelNameText.x = 25
                    gapX = 30
                }
            }else{
                var format = this.GetZJMChannelColor(chanelType);
                channelNameText.SetColor(format.color);
                channelNameText.SetFontSize(format.fontsize);
                channelNameText.EnableOutline(format.miaobian,0.1);
                gapX = 5;
                contentFontSize = EnumFontFormat.FONTSIZE_TIP;
            }
            if(isMainUI && chanelType != EnumChatChannelType.SOUND_GUANGBO)
            {
                this.customRichWidth = this.RICHUIWIDTH_ONE;
            }

            // 尝试替换
            //var richUI = new RichUI(this.customRichWidth,this.callBack,this.callbackTarget);
            //var richText = new RichElement();
            //richUI.SetLineHeight(this._lineHeight);
            //richUI.setTouchEnabled(true);
            //richUI.setSwallowTouches(true);
            //richText.CreateElementText( 1, contentColor, contentText, fontName, contentFontSize ,sendName,extraResInfo,chanelType);
            //richUI.PushBackElement(richText,msg,isMainUI);
            //this.addChild(richUI,10);
            //richUI.x = channelNameText.x+channelNameText.width+gapX;
            //richUI.y = chanelType == EnumChatChannelType.SOUND?12:0;
            // 尝试替换


            //richUI.visible = false;
            // 创建聊天内容
            var richText = ChatUtil.createRichText(msg,sendName);
            richText.setAnchorPoint(0,0);
            richText.SetDimensions(this.customRichWidth);
            richText.SetFixedHeight(this._lineHeight);
            richText.color = UIUtil.GetCCColor(contentColor);
            richText.fontSize = contentFontSize;
            richText.fontName = fontName;
            richText.UpdateView();
            richText.x = channelNameText.x+channelNameText.width+gapX;
            richText.y = 0;
            this.addChild(richText);
            this.richText = richText;


            channelNameText.y = richText.height -channelNameText.height / 2 - this._lineHeight / 2 ;
//            if(chanelType == EnumSystemInfoType.GUILD_ANSWER)
//            {
//                channelNameText.y = richUI.height - channelNameText.height;
//            }
//            this.ResetSize(richUI.width, richUI.height + (isMainUI ? 0 : 5));
            this.ResetSize(richText.width, richText.height + (isMainUI ? 0 : 5));
        }
        else
        {
            // 尝试替换
            //var richUI = new RichUI(this.customRichWidth,this.callBack,this.callbackTarget);
            //var richText = new RichElement();
            //richUI.setTouchEnabled(true);
            //richUI.setSwallowTouches(true);
            //richText.CreateElementText( 1, contentColor, contentText, fontName, contentFontSize ,sendName,extraResInfo,chanelType);
            //richUI.PushBackElement(richText,msg,isMainUI);
            //richUI.x+=20;
            //this.addChild(richUI,10);
            //this.ResetSize(richUI.width, richUI.height);
            // 尝试替换


            // 创建聊天内容
            var richText = ChatUtil.createRichText(msg,sendName);
            richText.setAnchorPoint(0,0);
            richText.SetDimensions(this.customRichWidth);
            richText.SetFixedHeight(this._lineHeight);
            richText.color = UIUtil.GetCCColor(contentColor);
            richText.fontSize = contentFontSize;
            richText.fontName = fontName;
            richText.UpdateView();
            richText.x = 20;
            richText.y = 0;
            this.addChild(richText);
            this.richText = richText;

            this.ResetSize(richText.width, richText.height);
        }
    },
    //获取主界面聊天频道颜色
    GetChatChannelColor:function(channeltype)
    {
        var color = EnumFontFormat.COMMON_COLOR07;
        var fontsize = EnumFontFormat.FONTSIZE_TIP;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                color = EnumFontFormat.COMMON_COLOR01;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                break;
            }
            default:break;
        }
        var obj = {color:color,fontsize:fontsize}
        return obj;
    },
    //获取聊天内容字体颜色
    GetContentColor:function(channeltype,isMainUI)
    {
        var color = EnumFontFormat.CHAT_ZHONGHE;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                color = EnumFontFormat.CHAT_ZHONGHE;
                break;
            }
            case EnumChatChannelType.NEWSYSTEM://系统
                color = EnumFontFormat.CHAT_NEWSYSTEM;
                break;
            case EnumChatChannelType.SYSTEM://系统
            {
                color = EnumFontFormat.CHAT_SYSTEM;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                color = EnumFontFormat.CHAT_WORLD;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                color = EnumFontFormat.CHAT_WORLD;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                color = EnumFontFormat.CHAT_TEAM;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                color = EnumFontFormat.CHAT_BANGPAN;
                if(isMainUI)
                {
                    color = EnumFontFormat.CHAT_SYSTEM;
                }
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会答题
            {
                color = EnumFontFormat.COMMON_COLOR10;
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                color = EnumFontFormat.CHAT_PRIVATE;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                color = EnumFontFormat.CHAT_LABA;
                break;
            }
            case EnumChatChannelType.SOUND_GUANGBO://传音
            {
                color = EnumFontFormat.CHAT_SYSTEM;
                break;
            }
            default:break;
        }
        return color;
    },
    //获取主界面聊天频道颜色
    GetZJMChannelColor:function(channeltype)
    {
        var color = EnumFontFormat.ZJM_SHIJIE_COLOR;
        var fontsize = EnumFontFormat.FONTSIZE_TIP;
        var miaobian = EnumFontFormat.COMMON_COLOR11;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                color = EnumFontFormat.ZJM_SHIJIE_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                color = EnumFontFormat.ZJM_SHIJIE_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                color = EnumFontFormat.ZJM_BANGHUI_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会
            {
                color = EnumFontFormat.ZJM_BANGHUI_COLOR;
                fontsize = EnumFontFormat.FONTSIZE_TIP;
                miaobian = EnumFontFormat.COMMON_COLOR11;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                break;
            }
            default:break;
        }
        var obj = {color:color,fontsize:fontsize,miaobian:miaobian}
        return obj;
    },
    //获取当前聊天频道
    GetCurrentChannelType:function(chanelType)
    {
        var channelLabel = "";
        this.customRichWidth = this.RICHUIWIDTH_TWO;
        switch (chanelType)
        {
            case EnumChatChannelType.MANY://综合
            {
                channelLabel = "综合";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.NEWSYSTEM://系统
            case EnumChatChannelType.SYSTEM://系统
            {
                channelLabel = "系统";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                channelLabel = "世界";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                channelLabel = "世界";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                channelLabel = "队伍";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                channelLabel = "帮会";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumSystemInfoType.GUILD_ANSWER://帮会
            {
                channelLabel = "帮会";
                this.customRichWidth = this.RICHUIWIDTH_TWO;
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                channelLabel = "传音";
                this.customRichWidth = this.RICHUIWIDTH_FOUR;
                break;
            }
            case EnumChatChannelType.SOUND_GUANGBO://传音
            {
                channelLabel = "传音";
                this.customRichWidth = this.RICHUIWIDTH_FIVE;
                break;
            }
            case EnumChatChannelType.PRIVATE://私人
            {
                channelLabel = "私人";
                this.customRichWidth = this.RICHUIWIDTH_THREE;
                break;
            }
            default:break;
        }
        return channelLabel;
    },
    _GetChannelBgRes:function(chanelType)
    {
        var resUrl = "other/liaotian/image/biaoqian/di_zi.png";
        return resUrl;
        var resUrl = "other/liaotian/image/biaoqian/di_lv.png";
        switch (chanelType)
        {
            case EnumChatChannelType.MANY://综合
            {
                resUrl = "other/liaotian/image/biaoqian/di_lv.png";
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                resUrl = "other/liaotian/image/biaoqian/di_hong.png";
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                resUrl = "other/liaotian/image/biaoqian/di_zi.png";
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                resUrl = "other/liaotian/image/biaoqian/di_zi.png";
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                resUrl = "other/liaotian/image/biaoqian/di_huang.png";
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                resUrl = "other/liaotian/image/biaoqian/di_lan.png";
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                resUrl = "other/liaotian/image/biaoqian/di_lv.png";
                break;
            }
            default:break;
        }
        return resUrl;
    },
    ResetSize:function(width, height)
    {
        this.setContentSize(cc.size(width, height));
        this.setAnchorPoint(0,0);
    },

    OnMenuCallbackNameLink:function(sender){
        this.parent.switchTo(0);
    }
});


var ChatItem  = ChatItem_V1;
var ChatItem  = ChatItem_V2;
