﻿var ChatPanelExt = ChatPanel.extend({
    _className: "ChatPanelExt",
    _listIndex: 0,
    chatListCount: 0,
    isLocked: false,
    _btnStates: [MUICheckBox.STATE_CHECK, MUICheckBox.STATE_UNCHECK],
    _scrollview: null,
    _chatItemArr: [],
    ctor: function () {
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_LB;
        Mgr.chat.SetPanel(this);
    },
    Init: function () {
        ChatPanel.prototype.Init.call(this);
        this._SetLocalProperty();
        this._AddListener();
        this._HandleButton();
        this._AddListview();
        this._ShowOrHideListview();
        this._SetBaseProperty();
    },
    _SetLocalProperty: function () {
        this.PING_OFF = 0;
        this.PING_ON = 1;
        this._btnArr = [this.sbtnMany, this.sbtnXitong, this.sbtnWord, this.sbtnTeam, this.sbtnGuild, this.sbtnChuanyin];
        this._listCount = 6;
        this.extraReqInfo = new ExtraReqInfo();
        this.btnLeft.visible = false;
        this.btnRight.visible = false;
        //for (var i = 0; i < this._btnArr.length; i ++)
        //{
        //	var xx = this._btnArr[i].width / 2 - this._btnArr[i].buttonText.width >> 1;
        //	this._btnArr[i].SetTextPosition( xx , this._btnArr[i].buttonText.y );
        //}
        this.imgBg1.setTouchEnabled(true);
        this.imgBg1.setSwallowTouches(true);
    },
    _HandleButton: function () {
        var self = this;
        //发送
        this.btnGo.addClickEventListener(function (event) {
            this.OnSendMsg();
        }.bind(this));
        //综合
        this.sbtnMany.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.MANY;
            self.ShowChatMsg();
        });
        //系统
        this.sbtnXitong.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.SYSTEM;
            self.ShowChatMsg();
        });
        //世界
        this.sbtnWord.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.WORLD;
            self.ShowChatMsg();
        });
        //队伍
        this.sbtnTeam.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.TEAM;
            self.ShowChatMsg();
        });
        //帮会
        this.sbtnGuild.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.FACTION;
            self.ShowChatMsg();
        });
        //传音
        this.sbtnChuanyin.addClickEventListener(function (event) {
            Mgr.chat.curChatChannel = EnumChatChannelType.SOUND;
            self.ShowChatMsg();
        });
        //表情
        this.btnBiaoqing.addClickEventListener(function (event) {
            self._ShowBiaoQingPanel();
        });
        //锁屏
        this.btnOFF.addClickEventListener(function (event) {
            self.btnOFF.visible = false;
            self.btnON.visible = true;
            self._HandleSuoPing(self.PING_OFF);
        });
        this.btnOFF.visible = false;
        this.btnON.addClickEventListener(function (event) {
            self.btnON.visible = false;
            self.btnOFF.visible = true;
            self._HandleSuoPing(self.PING_ON);
        });
        this.btnON.visible = true;
        //语音录制
        this.btnYuyin.addTouchEventListener(function (target, state) {
            Sougou.HandleYuyin(target, state);
        });
        var self = this;
        this.btnRight.addClickEventListener(function (event) {
            Mgr.chat.ShowHideChatPanel(true);
        });
        this.btnLeft.addClickEventListener(function (event) {
            Mgr.chat.ShowHideChatPanel(false);
        });
        this.btnRight.x -= 1;
        this.btnLeft.x -= 1;
        this.btnRight.setZoomScale(0);
        this.btnLeft.setZoomScale(0);
    },

    _AddListview: function () {
        var size = cc.size(440, this.imgBg2.height - 10);
        var pos = this.imgBg2.getPosition();
        var sc = ccui.ScrollView.create();
        sc.setContentSize(size);
        sc.setDirection(ccui.ScrollView.DIR_VERTICAL);
        sc.setInnerContainerSize(size);
        sc.setScrollBarEnabled(false);
        sc.setBounceEnabled(true);
        sc.setPosition(pos.x, pos.y);
        this.addChild(sc, 200);
        this._scrollview = sc;
    },
    UpdateChatListInfo: function (msg) {
        this._InitChatListInfo(msg);
    },
    _InitChatListInfo_temp: function (msg)	//TODO
    {
        this._InitChatListInfo_temp_Scroll(msg);
    },
    _InitChatListInfo_temp_Scroll: function (msg) {
        var chatListArr = [];
        if (msg) {
            chatListArr = [msg];
        }

        var offset = this._scrollview.getInnerContainerPosition();
        var height = this._scrollview.getContentSize().height;
        var heightInner = this._scrollview.getInnerContainerSize().height;
        var y = offset.y - (height - heightInner);

        for (var i = 0; i < chatListArr.length; i++) {
            var item = chatListArr[i];
            var listItem = this._GetChatItem(item);
            listItem.channelTp = item.type;
            if (item.type == EnumSystemInfoType.GUILD_ANSWER)	//帮会答题
            {
                listItem.channelTp = EnumChatChannelType.FACTION;
            }
            else if (item.type == EnumSystemInfoType.CHAT_TEAM)	//帮会答题
            {
                listItem.channelTp = EnumChatChannelType.TEAM;
            }
            this._scrollview.addChild(listItem);
            this._chatItemArr.push(listItem);
        }
        this.chatListCount = this._chatItemArr.length;

       //当聊天item大于100条的时候自动删除最老的item
        while(this._chatItemArr.length > 80){
            var v = this._chatItemArr.shift();
            y -= v.height + 10;
            v.removeFromParent();
        }

        this._ChangeChatChannel_temp_Scroll(false,y);
    },
    _ChangeChatChannel_temp_Scroll: function (force,offsetY) {
        var items = this._scrollview.getChildren();
        var len = items.length;
        var tempArr = [], hCount = 10;
        for (var i = 0; i < len; i++) {
            var item = items[i];

            if (item.channelTp == Mgr.chat.curChatChannel
                || Mgr.chat.curChatChannel == EnumChatChannelType.MANY
                // SYSTEM多个筛选先简单这样写这儿
                || (Mgr.chat.curChatChannel == EnumChatChannelType.SYSTEM && item.channelTp == EnumChatChannelType.NEWSYSTEM)
                ) {
                item.visible = true;
                tempArr.push(item);
                hCount += item.height + 10;
            }
            else {
                item.visible = false;
            }
        }

        var size = this._scrollview.getContentSize();
        if (hCount > size.height) {
            this._scrollview.setInnerContainerSize(cc.size(size.width, hCount));
        }
        else {
            this._scrollview.setInnerContainerSize(cc.size(size.width, size.height));
        }
        size = this._scrollview.getInnerContainerSize();
        var count = 0, gg = 10;
        for (var i = 0; i < tempArr.length; i++) {
            tempArr[i].y = size.height - tempArr[i].height - count;
            count += tempArr[i].height + 10;
        }
        if (!this.isLocked || force) {
            this._scrollview.jumpToBottom();
        }else{
            var height = this._scrollview.getContentSize().height;
            var heightInner = this._scrollview.getInnerContainerSize().height;
            offsetY = Math.max(0,offsetY);
            var offset = cc.p(0, height - heightInner + offsetY);
            this._scrollview.setInnerContainerPosition(offset);
        }
    },
    //刷新聊天记录
    _InitChatListInfo: function (msg) {
        this._InitChatListInfo_temp(msg);
    },
    ShowChatMsg: function () {
        this._ChangeChatChannel();
    },
    _ChangeChatChannel: function () {
        var isCanSendMsg = true;
        this.editCue.setPlaceHolder("请输入聊天内容");
        this.btnYuyin.visible = true;
        switch (Mgr.chat.curChatChannel) {
            case EnumChatChannelType.MANY://综合
            {
                var level = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base) || 0;
                if(level < ChatUtil.NORMAL_TALK_NEED_LEVEL){
                    isCanSendMsg = false;
                    this.labCue.SetString("综合聊天频道 " + ChatUtil.NORMAL_TALK_NEED_LEVEL + "级开启");
                }

                this._listIndex = 0;
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            case EnumChatChannelType.NEWSYSTEM://系统
            {
                this._listIndex = 1;
                isCanSendMsg = false;
                this.labCue.SetString("请切换到其他频道发言");
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                var level = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base) || 0;
                if(level < ChatUtil.WORLD_TALK_NEED_LEVEL){
                    isCanSendMsg = false;
                    this.labCue.SetString("世界聊天频道 " + ChatUtil.WORLD_TALK_NEED_LEVEL + "级开启");
                }

                this._listIndex = 2;
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                this._listIndex = 3;
                if (!Mgr.team.IsTeamMember(Mgr.player.mainPlayer.sid)) {
                    isCanSendMsg = false;
                    this.labCue.SetString("请加入队伍后再使用此频道");
                }
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                this._listIndex = 4;
                if (Mgr.player.mainPlayer.guildId.IsZero()) {
                    isCanSendMsg = false;
                    this.labCue.SetString("请加入帮派后再使用此频道");
                }
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                this._listIndex = 5;
                this.editCue.setPlaceHolder("消耗2元宝传音");
                this.btnYuyin.visible = false;
                break;
            }
            default:
                break;
        }
        this.imgBg1.visible = !isCanSendMsg;
        this.imgBg.visible = isCanSendMsg;
        this._ShowOrHideListview();
        this._ChangeChatChannel_temp_Scroll(true);
    },
    _ShowOrHideListview: function () {
        for (var i = 0; i < this._listCount; i++) {
            if (i == this._listIndex) {
                this._btnArr[i].SetTextColor(EnumFontFormat.COMMON_COLOR01);
                this._btnArr[i].SetTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);
                this._btnArr[i].SetButtonState(this._btnStates[0]);
            }
            else {
                this._btnArr[i].SetTextColor(EnumFontFormat.COMMON_COLOR06);
                this._btnArr[i].SetTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);
                this._btnArr[i].SetButtonState(this._btnStates[1]);
            }
        }
    },

    _GetChatItem: function (msg) {
        return Mgr.chat.GetChatItem(msg, false, 28);
    },
    //显示表情面板
    _ShowBiaoQingPanel: function () {
        EngineMgr.uiMgr.ShowHidePanelByType(FacePanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
        var pos = this.btnBiaoqing.getWorldPosition();
        Mgr.uiMgr.GetPanelByType(FacePanelExt.PanelName).ShowFacePanel(pos, this, 1);
    },

    OnSendMsg: function (chatstr) {
        var str = chatstr ? chatstr : this.editCue.string;
        if (str.length > Mgr.chat.MAXCHATTEXTLENGTH) {
            Mgr.tips.ShowNotice("输入的字数过多");
            return;
        }
        var type = Mgr.chat.curChatChannel;
        if (str.length > 0) {
            if (type == EnumChatChannelType.FACTION) {
                if (Mgr.player.mainPlayer.guildId.IsZero()) {
                    return;
                }
            }
            else if (type == EnumChatChannelType.TEAM) {
                if (!Mgr.team.IsTeamMember(Mgr.player.mainPlayer.sid)) {
                    return;
                }
            }
            else if (type == EnumChatChannelType.SYSTEM) {
                return;
            }
            Mgr.chat.SendChantMsg(type, str, this._GetExtraReqInfo());
        }
        this.editCue.string = "";
        this.extraReqInfo = new ExtraReqInfo();
    },
    _GetExtraReqInfo: function () {
        return this.extraReqInfo;
    },
    SetExtraReqInfo: function (showvo) {
        if (showvo) {
            var itemreq = new HyperInfo();
            itemreq.hyperType = showvo.type;//EnumLinkType.ITEM_HTML;
            itemreq.params_ = showvo.hexsid;
            itemreq.index = showvo.pos;
            itemreq.clientUseText = showvo.str;
            this.extraReqInfo.hyperInfos.push(itemreq);
        }
        else {
            this.extraReqInfo = new ExtraReqInfo();
        }
    },
    //type 0:off,1:on
    _HandleSuoPing: function (type) {
        if (type) {
            this.isLocked = true;
        }
        else {
            this.isLocked = false;
            this._ChangeChatChannel_temp_Scroll(true);
        }
    },
    _SogouStart: function () {
        this._isCancel = false;
    },
    _SetBaseProperty: function () {
        this.editCue.setPlaceHolder("请输入聊天内容");
        this.editCue.setPlaceholderFontColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));
        this.editCue.setFontSize(EnumFontFormat.FONTSIZE_TIP);
        this.editCue.setTextColor(UIUtil.GetCCColor(EnumFontFormat.COMMON_COLOR08));
        // FIX 保持居中
        //this.editCue.y = 8;

        this.btnGo.SetTitleTextColor(EnumFontFormat.COMMON_COLOR05);
        this.btnGo.SetTitleTextFontSize(EnumFontFormat.FONTSIZE_BUTTON);

        this.labOFF.SetColor(EnumFontFormat.PING_COLOR);
        this.labON.SetColor(EnumFontFormat.PING_COLOR);
        this.labOFF.SetFontSize(EnumFontFormat.FONTSIZE_TIP);
        this.labON.SetFontSize(EnumFontFormat.FONTSIZE_TIP);
        this.labOFF.DisableEffect();
        this.labON.DisableEffect();
    },
    _AddListener: function () {
        var self = this;
        this.lister = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            onTouchBegan: function (touch, event) {
                return self.btnLeft.visible;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {
                var pos = touch.getLocation();
                if (pos.x > (self.imgBg2.x + 500)) {
                    Mgr.chat.ShowHideChatPanel(false);
                }
            }
        });
        cc.eventManager.addListener(this.lister, this);
    },
    OnShow: function () {
        this.setPosition(-this.width, ToolBase.GetWinHeight() - this.height - 10);
        this.setLocalZOrder(1000);
    },

    OnHide: function () {
        this._super();
        this.lister.setSwallowTouches(false);
    },
    AddStrMsg: function (text) {
        var size = richText.getVirtualRendererSize();
    },
    ShowHidePanel: function (value) {
        this.btnLeft.visible = value;
        this._PlayAction(value);
        if (value) {
            this.visible = value;
            this._ChangeChatChannel();
        }
    },
    _PlayAction: function (value) {
        var xOffset = value ? 0 : -this.width;
        this.stopAllActions();
        var moveTo = cc.moveTo(0.2, xOffset, this.y);
        var self = this;
        this.runAction( cc.sequence( moveTo, cc.callFunc(function(){ self.visible = value;}) ));
    },
});
ChatPanelExt.PanelName = "ChatPanelExt";
PanelClassDic["ChatPanelExt"] = ChatPanelExt;






