/**
 * rich控件扩展
 *
 */
var  ElementType = ElementType || {
    TEXT : 1,
    IMAGE : 2,
    CUSTOM : 3,
    NEWLINE : 4,
};

var RichElement = cc.Class.extend({
    ctor:function() {
        var self = this;
        self._type = 0;
        self._tag = 0;
        self._color = 0;
    },

    //*** text   Start  ************//
    _text : null,
    _fontName : null,
    _fontSize : 0,
    _sendName : "",
    _extraResInfo : null,
    chanelType:0,
    CreateElementText:function ( tag, color, text, fontName, fontSize ,sendName,extraResInfo,chanelType) {
        this._type = ElementType.TEXT;
        this._tag = tag;
        this._color = color;

        this._text = text;
        this._fontName = fontName;
        this._fontSize = fontSize;
        this._sendName = sendName;
        this._extraResInfo = extraResInfo;
        this.chanelType = chanelType;
    },
});

var RichUI = RichUI || ccui.Widget.extend({
    _chatInfo:null,
    _faceArr:null,
    _strColor:cc.color(0,0,0,255),//描边顏色
    _strokeWidth:0.01,//描边宽度
    richText:null,
    customRichWidth:null,
    zijieWidthNum:10,
    hGap:30,//单行高度
    faceWidth : 41,//表情的宽度
    currentLineTempWidth : 0,
    fontSize : 20,
    isMainUI : false,
    totalTextStr:"",
    callback:null,
    callbackTarget:null,
    _richHeight:0,
    _fontWidth:0,
    ctor:function (width,callback,callbackTarget) {
        this._super();
        this.customRichWidth = width;//富文本框宽度
        this.callback = callback;
        this.callbackTarget = callbackTarget;
        this._faceArr = new HashMap();
        this.Init();
    },

    Init:function () {
        //return; //先屏蔽表情
        this._faceArr.Clear();
         for ( var i = 1; i < 24; i++ )
         {
             var str = "#1000" + i;
             if ( i >= 10 )
             {
                 str = "#100"+i;
             }
             var obj = {face:str,index:i-1};
             this._faceArr.Put(str,obj);
         }
    },
    SetLineHeight:function(height){
    	this.hGap = height || 30;
    },
    ResetSize:function(width, height,hgap)
    {
        this.setAnchorPoint(0,0);
        this.setContentSize(cc.size(width, height));
    },

    PushBackElement:function ( element, msg,isMainUI) {
        this.isMainUI = isMainUI;
        this._chatInfo = element;
        this.HandleTextRenderer(element._text, element._fontName, element._fontSize, element._color,element._sendName,element.chanelType,msg,isMainUI);
    },

    HandleTextRenderer:function (text, fontName, fontSize, color ,sendName,chanelType,msg,isMainUI) {
        this.totalTextStr = text;
        this.fontSize = fontSize;
        var richText = new ccui.RichText();
        richText.ignoreContentAdaptWithSize(false);
        richText.setVerticalSpace(this.hGap - fontSize);
        richText.width = this.customRichWidth;
        richText.y = (this.hGap - fontSize) / 2 + 2
        richText.setAnchorPoint(0,0);
        this.richText = richText;
        this.addChild(richText,999);
        this.setSwallowTouches(false);
        richText.setSwallowTouches(false);
        //var len = this.GetCharactersByString(text);
        if (chanelType == EnumChatChannelType.MANY || chanelType == EnumChatChannelType.SYSTEM ||chanelType == EnumChatChannelType.SOUND || isMainUI)
        {
            //玩家名字链接
            //var len = this.GetCharactersByString(text+sendName,isMainUI);
            this.CheckCurrentLineTempWidth(this.GetCharactersByString(sendName+" ")*this.zijieWidthNum);
            msg.hyperType = EnumLinkType.PLAYER;
            //var recustom = this._GetLinkText(sendName+"",color,fontName,fontSize,msg,true);
            var recustom = this._GetNameLinkText(sendName+"",color,fontName,fontSize,msg,true);
            for(var i = 0; i < recustom.length; i++ )
            {
                richText.pushBackElement(recustom[i]);
            }
            if ( chanelType == EnumChatChannelType.SOUND )
            {
                var resUrl = "other/liaotian/image/biaoqian/xiaolaba.png";
                EngineMgr.uiMgr.GetAsynResByUrl(resUrl, function(){
                    var laba = ccui.ImageView.create(resUrl,ccui.Widget.PLIST_TEXTURE);
                    var recustom = new ccui.RichElementCustomNode(1, UIUtil.GetCCColor(color), 255, laba);
                    richText.insertElement(recustom,0);
                }, this);
                //len+=20;
                this.CheckCurrentLineTempWidth(30);
            }
        }
        var contentElement = this._GetAnalysisedContentText(text,color,fontName,fontSize);
        for( var i = 0; i < contentElement.length;i++ )
        {
            richText.pushBackElement(contentElement[i]);
        }
        if(text instanceof Array)
        {
            //this._SetFontTotalWidth(msg.linkText,false,true);
            var color = msg.color ? UIUtil.GetCCColor(msg.color):UIUtil.GetCCColor(color);
            //var custom =  new ccui.RichElementText(1,color,255,msg.linkText,GameFont.DEFAULT,fontSize);
            var linkE = this._GetLinkText(msg.linkText,color,fontName,fontSize,msg.lData);
            var custom = linkE[0];
            richText.pushBackElement(custom);
        }
        richText.height = this._GetRichtextHgt()*this.hGap;
        this.ResetSize(richText.width, richText.height,this.hGap);
    },
    //检测并查找是否有物品展示
    _CheckAndSearchItems_temp:function(str,color,fontName,fontSize)
    {
        var items = this._chatInfo._extraResInfo.itemInfos;//array
        if ( !this._chatInfo )
        {
            return false;
        }
        var temp = str;
        if(items && items.length > 0)
        {
            var customarr = [],itemNameArr=[];
            for ( var i = 0; i < items.length; i++ )
            {
                items[i].itemInfos.hyperType = EnumLinkType.ITEM;
                var cItem = Q_item.Get(items[i].itemInfos.itemModelId);
                var matchStr = temp.match(cItem.q_name);
                temp = temp.replace(matchStr,"-");
                if(matchStr)
                {
                    var custom = this._GetLinkText("["+cItem.q_name+"]",color,fontName,fontSize,items[i].itemInfos);
                    //custom.index = this.totalTextStr.indexOf("["+cItem.q_name+"]",i);
                    itemNameArr.push("["+cItem.q_name+"]");
                    for(var j = 0; j < custom.length; j++)
                    {
                        customarr.push(custom[j]);
                    }
                }
                else if( i == items.length-1)
                {
                    temp = temp.replace(/\[-\]/g,"");
                    var tLen = temp.length;
                    if(tLen>0)
                    {
                        if(tLen == 2)
                        {
                            tLen = cItem.q_name.length+1;
                        }
                        str = str.substring(0,str.length-tLen);
                    }
                }
            }
            for(var i = 0; i < itemNameArr.length; i++)
            {
                str = str.replace(itemNameArr[i],",");
            }
            var tStr = str.split(",",str.length);
            var strArr = [];
            for ( var i = 0; i < tStr.length; i++ )
            {
                if(tStr[i].length > 0)
                {
                    var ss = this._GetTextElement(tStr[i],color,fontName,fontSize);
                    strArr.push(ss);
                }
            }
            for(var i = 0; i < strArr.length; i++ )
            {
                for (var j= 0; j < strArr[i].length; j++ )
                {
                    customarr.push(strArr[i][j]);
                }
            }
            customarr.sort(function(a,b){return a.index- b.index;});
            return customarr;
        }
        return false;
    },
    //处理接收到的字符串信息
    _GetAnalysisedContentText:function(str,color,fontName,fontSize)
    {
        if(str instanceof Array)
        {
            var arr0 = this._GetTextElement(str,color,fontName,fontSize);
            return arr0;
        }
        else
        {
            var itemsLink = this._CheckAndSearchItems_temp(str,color,fontName,fontSize);
            if(itemsLink)
            {
                return itemsLink;
            }
            var arr0 = this._GetTextElement(str,color,fontName,fontSize);
            return arr0;
        }
    },
    //筛选出非物品展示的[]链接
    _SelecteLinks:function(links, reArr)
    {
        (function()
        {
            for ( var i = 0; i < reArr.length; i++ )
            {
                for(var j = 0; j < links.length; j++ )
                {
                    if ( reArr[i].start > links[j].start && reArr[i].end < links[j].end )//将超链接内的reArr项删除
                    {
                        reArr.splice(i, 1);
                        arguments.callee();
                    }
                }
            }
        })();
    },
    _ConnectBothArray:function(originArr,arr)
    {
        Array.prototype.push.apply(originArr,arr);
    },
    //自定义项,物品展示
    //_GetCustomElement:function(str,color,fontName,fontSize,itemIndex)
    //{
    //    var itemData = this._CheckAndSearchItems(itemIndex);
    //    if ( !itemData )
    //    {
    //        return this._GetTextElement(str,color,fontName,fontSize);
    //    }
    //    var custom = this._GetLinkText(str,color,fontName,fontSize,itemData);
    //    return custom;
    //    //return [custom];
    //},
    _GetNameFontFormat:function()
    {
        var color = EnumFontFormat.LINK_NAME_COLOR;
        var fontsize = EnumFontFormat.FONTSIZE_TIP;
        var obj = {color:color,fontsize:fontsize}
        if( this.isMainUI)
        {
            return obj;
        }
        var channeltype = this._chatInfo.chanelType;
        color = EnumFontFormat.SYS_NAME_COLOR;
        fontsize = EnumFontFormat.FONTSIZE_TIP;
        switch (channeltype)
        {
            case EnumChatChannelType.MANY://综合
            {
                break;
            }
            case EnumChatChannelType.SYSTEM://系统
            {
                color = EnumFontFormat.SYS_NAME_COLOR;
                break;
            }
            case EnumChatChannelType.WORLD://世界
            {
                break;
            }
            case EnumChatChannelType.WORLDSINGLE://世界
            {
                break;
            }
            case EnumChatChannelType.TEAM://队伍
            {
                break;
            }
            case EnumChatChannelType.FACTION://帮会
            {
                break;
            }
            case EnumChatChannelType.SOUND://传音
            {
                color = EnumFontFormat.SYS_CHUANYING_NAME_COLOR;
                break;
            }
            default:break;
        }
        var obj = {color:color,fontsize:fontsize}
        return obj;
    },
    //普通超链接文本
    _GetLinkText:function(str,color,fontName,fontSize,itemData,isName)
    {
        //return this._GetNameLinkText(str,color,fontName,fontSize,itemData,isName);
        var gap = 5,self = this,arr = [];
        //var mstr = [str.substring( 0,Math.floor(str.length/2)),str.substring(Math.floor(str.length/2),str.length)];
        //for(var i = 0; i < mstr.length; i++ )
        {
            var custom = new MUILabel();
            //custom.SetString(mstr[i]);
            custom.SetString(str)
            var widt = this.GetCharactersByString(str)*this.zijieWidthNum;
            custom.setContentSize(cc.size(widt,custom.GetHeight()));
            custom.setTouchEnabled(true);
            custom.setSwallowTouches(true);
            custom.data = itemData?itemData:{};
            var colorObj = this.GetLinkTextColor(custom.data);
            color = colorObj.color;
            custom.SetFontSize(fontSize);
            custom.SetColor(color);
            custom.index = this.totalTextStr.indexOf(str.substring(1,str.length-1),0);
            var size = cc.size(custom.GetWidth()-10,custom.GetHeight());

            var layer = cc.Layer.create();
            layer.setContentSize(size);
            custom.y-=2;
            layer.addChild(custom);
            var recustom = new ccui.RichElementCustomNode(10,  UIUtil.GetCCColor(color) , 255, layer);
            recustom.width = size.width;
            custom.addTouchEventListener(function(target,state)
            {
                if ( state == ccui.Widget.TOUCH_BEGAN )
                {
                    if(self.callback && self.callbackTarget)
                    {
                        self.callback.call(self.callbackTarget,target.data,target)
                    }
                }
                else if( state == ccui.Widget.TOUCH_ENDED)
                {
                }
            });
            recustom.index = custom.index;
            arr.push(recustom);
        }
        this._SetFontTotalWidth(str,false,false,size.width);
        return arr;
    },
    _GetNameLinkText:function(str,color,fontName,fontSize,itemData,isName)
    {
        if(str.length<2){return [];}
        //Profiler.Start("start---------------------------------------xixixii__0");
        var gap = -8,self = this,arr = [];
        var custom = new MUILabel();
        custom.SetString(str);
        custom.setContentSize(cc.size(custom.GetWidth(),custom.GetHeight()));
        custom.setTouchEnabled(true);
        custom.setSwallowTouches(true);
        custom.data = itemData?itemData:{};
        var format = this._GetNameFontFormat();
        color = format.color;
        fontSize = format.fontsize;
        custom.SetFontSize(fontSize);
        custom.SetColor(color);
        var size = cc.size(custom.GetWidth(),custom.GetHeight());
        size.width-=5;
        var layer = cc.Layer.create();
        layer.setContentSize(size);
        custom.y-=2;
        layer.addChild(custom);
        var recustom = new ccui.RichElementCustomNode(10,  UIUtil.GetCCColor(color) , 255, layer);
        recustom.width = custom.width;
        custom.addTouchEventListener(function(target,state)
        {
            if ( state == ccui.Widget.TOUCH_BEGAN )
            {
                if(self.callback && self.callbackTarget)
                {
                    self.callback.call(self.callbackTarget,target.data,target)
                }
            }
            else if( state == ccui.Widget.TOUCH_ENDED)
            {
            }
        });
        recustom.index = custom.index;
        arr.push(recustom);
        //Profiler.Stop("stoop---------------------------------------xixixii__0");
        this._SetFontTotalWidth(str);
        return arr;
    },
    GetLinkTextColor:function(data)
    {
        var color = EnumFontFormat.SYS_NAME_COLOR;
        var isUnderline = false;
        switch(data.hyperType)
        {
            case EnumLinkType.PLAYER:
                color = EnumFontFormat.LINK_NAME_COLOR;
                break;
            case EnumLinkType.TEAM_APPLY://队伍申请
            {
                color = EnumFontFormat.LINK_OTHER_COLOR;
                break;
            }
            case EnumLinkType.TEAM_APPLY_LF://队伍申请
            {
                color = EnumFontFormat.LINK_OTHER_COLOR;
                break;
            }
            case EnumLinkType.ITEM://物品展示（0白色，1绿色，2蓝色，3紫色，4橙色，5红色）
            {
                var q_default = Q_item.Get(data.itemModelId).q_default;
                if(q_default == 0) {color = EnumFontFormat.COMMON_COLOR01;}
                else if(q_default == 1) {color = EnumFontFormat.COMMON_COLOR04;}
                else if(q_default == 2) {color = EnumFontFormat.LINK_NAME_COLOR;}
                else if(q_default == 3) {color = EnumFontFormat.LINK_ITEM_COLOR;}
                else if(q_default == 4) {color = EnumFontFormat.LINK_OTHER_COLOR;}
                else if(q_default == 5) {color = EnumFontFormat.COMMON_COLOR09;}
                break;
            }
            default :
            {
                color = EnumFontFormat.LINK_OTHER_COLOR;
                break;
            }
        }
        return {color:color,isUnderLine:isUnderline};
    },
    //普通文本
    _GetTextElement:function(str,color,fontName,fontSize,isFace,isHide)
    {
        if(str instanceof Array)
        {
            var arr = [];
            for(var i = 0; i<str.length;i++)
            {
                if(str[i].newline) {
                    arr.push(new ccui.RichElementNewLine(1,color,0xFF));
                }
                if(str[i].text.length<1){continue;}
                var custom = null;
                if(!str[i].isLink)
                {
                    this._SetFontTotalWidth(str[i].text,false,true);
                    var color = str[i].color ? UIUtil.GetCCColor(str[i].color):UIUtil.GetCCColor(color);
                    custom =  new ccui.RichElementText(1,color,255,str[i].text,GameFont.DEFAULT,fontSize);
                }
                else
                {
                    var linkE = this._GetLinkText(str[i].text,color,fontName,fontSize,str[i].lData);
                    custom = linkE[0];
                }
                arr.push(custom);
            }
            return arr;
        }
        else
        {
            var imageElement = this._CheckFackChat(str,color,fontName,fontSize,isFace);
            if(imageElement)
            {
                return imageElement;//array;
            }
            else
            {
                var linkElement = this._GetLinkElementText(str,color,fontName,fontSize);
                if( linkElement )
                {
                    return linkElement;
                }
            }
            var arr = [];
            this._SetFontTotalWidth(str,false,true);
            var custom =  new ccui.RichElementText(1,UIUtil.GetCCColor(color),255,str,GameFont.DEFAULT,fontSize);
            custom.index = this.totalTextStr.indexOf(str,0);
            //this.totalTextStr = this.totalTextStr.replace(str,"-");//避免重复的字符找错编号
            arr.push(custom);
            var arr2 = [custom];
            return arr2;
            //return arr;
        }
    },
    //判断聊天内容是否需要描边
    JugementMiaobian:function()
    {
        var chanelType = this._chatInfo.chanelType;
        if (chanelType == EnumChatChannelType.MANY || chanelType == EnumChatChannelType.SYSTEM || chanelType == EnumChatChannelType.SOUND || this.isMainUI)
        {
            return true;
        }
        return false;
    },
    //表情
    _GetImageElement:function(index)
    {
        var node = ccui.Widget();
//        sp.setContentSize(cc.size(30,20));
        node.setAnchorPoint(cc.p(0,0));
        node.setContentSize(cc.size(38,this.fontSize))
        var sp = Mgr.chat.GetChatAnimationByIndex(index);
        sp.setAnchorPoint(cc.p(0.5,0.5))
        sp.x = 19;
        sp.y = this.fontSize / 2;
        node.addChild(sp);
        var reimg = new ccui.RichElementCustomNode(1, cc.color.RED, 255, node);
        return reimg;
    },
    //检测是否有表情
    _CheckFackChat:function(str,color,fontName,fontSize,isFace)
    {
        var regexp  = /\#[0-9]{5}/g;
        var faceArr = str.match(regexp);
        var strArr  = str.split(regexp,str.length);
        if (!faceArr || faceArr.length < 1 || isFace)
        {
            return false;
        }
        this._ConnectBothArray(faceArr,strArr);
        faceArr.sort(function(a,b)
        {
            var ai = str.indexOf(String(a),0);
            var bi = str.indexOf(String(b), 0);
            return ai-bi;
        });
        var groupElement = [];
        for ( var i = 0; i < faceArr.length; i++ )
        {
            if(this._faceArr.Size() > 0)
            {
                var tempface = this._faceArr.Get(faceArr[i]);
                if ( tempface )
                {
                    var imgItem = this._GetImageElement(tempface.index);
                    //imgItem.width = this.faceWidth;
                    imgItem.index = this.totalTextStr.indexOf(tempface.face,i);
                    groupElement.push(imgItem);
                    this._SetFontTotalWidth(faceArr[i],true);
                    continue;
                }
                else
                {
                    var textItem = this._GetTextElement(faceArr[i],color,fontName,fontSize,true);
                    for (var mm = 0; mm<textItem.length; mm++)
                    {
                        groupElement.push(textItem[mm]);
                    }
                }
            }
            else
            {
                var textItem = this._GetTextElement(str,color,fontName,fontSize,true);
                for (var mm = 0; mm<textItem.length; mm++)
                {
                    groupElement.push(textItem[mm]);
                }
            }
        }
        return groupElement;
    },
    //获取连接富文本项
    _GetLinkElementText:function(str,color,fontName,fontSize)
    {
        var links = this._chatInfo._extraResInfo.hyperInfos;
        if ( links.length < 1 ){return false;}
        var linkTextArr = [];
        var lData = links[0];
        //for ( var i = 0; i < 1; i++ )
        {
            var txt = lData.clientUseText;
            linkTextArr.push(txt);
        }
        var textElementArr = [];
        var linkElementArr = [];
        var groupElement = [];
        var strArr = str.split(txt,str.length);
        if (strArr.length < 2)
        {
            return false;
        }
        for (var i = 0; i < strArr.length-1; i++ )
        {
            var linkitem = this._GetLinkText(txt,color,fontName,fontSize,lData);
            linkitem.index = this.totalTextStr.indexOf(String(txt),0);
            for(var j = 0; j < linkitem.length; j++ )
            {
                linkElementArr.push(linkitem[j]);
            }
            //linkElementArr.push(linkitem);
        }
        for ( var i = 0; i < strArr.length; i++ )
        {
            var textItem = this._GetTextElement(strArr[i],color,fontName,fontSize);
            for(var mm = 0; mm < textItem.length; mm++)
            {
                textItem[mm].index = this.totalTextStr.indexOf(String(strArr[i]),0);
                textElementArr.push(textItem[mm]);
            }
        }

        for ( var i = 0,j = 0; i < textElementArr.length,j < linkElementArr.length; i+=2,j++ )
        {
            if( linkElementArr[j] )
            {
                textElementArr.splice(i,0,linkElementArr[j]);
            }
        }
        groupElement = textElementArr;
        groupElement.sort(function(a,b){return a.index - b.index;});
        return groupElement;
    },
    //检测并查找是否有物品展示
    _CheckAndSearchItems:function(itemIndex)
    {
        var items = this._chatInfo._extraResInfo.itemInfos;//array
        if ( !this._chatInfo )
        {
            return false;
        }
        if(items && items.length > 0)
        {
            for ( var i = 0; i < items.length; i++ )
            {
                var cItem = Q_item.Get(items[i].itemInfos.itemModelId);
                if ( items[i].index == itemIndex )
                {
                    items[i].itemInfos.hyperType = EnumLinkType.ITEM;
                    return items[i].itemInfos;
                }
            }
        }
        return false;
    },
    //获取字符串字符数
    GetCharactersByString:function (str,isMainUI) {
        str = TextUtil.RemoveHTMLTag(str)
        if ( isMainUI )
        {
            return this.GetCharactersByString01(str);
        }
        var num=0;
        for ( var i = 0; i < str.length; i++ ) {
            if (/^[a-zA-Z]*$/.test(str.charAt(i)))      //这是判断英文的正则表达式
            {
                num += 1;
            }
            else if (/^[\u4e00-\u9fa5]*$/.test(str.charAt(i)) || /^[\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b]*$/.test(str.charAt(i))) {        //这是判断中文和中文符号的正则表达式
                num += 2;
            }
            else
            {
                num += 1;
            }
        }
        var regexp  = /\#[0-9]{5}/g;
        var faceArr = str.match(regexp)?str.match(regexp):[];
        num = num-faceArr.length*3.1;
        return num;
    },
    GetCharactersByString01:function ( str) {
        var num=0;
        for ( var i = 0; i < str.length; i++ ) {
            if (/^[a-zA-Z]*$/.test(str.charAt(i)))      //这是判断英文的正则表达式
                num += 1;
            else if (/^[\u4e00-\u9fa5]*$/.test(str.charAt(i)) ||
                /^[\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b]*$/.test(str.charAt(i))) {        //这是判断中文和中文符号的正则表达式
                num += 2;
            }
            else
            {
                num += 1;
            }
            if ( num * (this.zijieWidthNum) >= (this.customRichWidth-this.currentLineTempWidth) )
            {
                this.currentLineTempWidth = 0;
                return i;
            }
        }
        return i;
    },
    CheckCurrentLineTempWidth:function(cWidth)
    {
        this.currentLineTempWidth+= (cWidth/*-5*/);
        if ( this.currentLineTempWidth > this.customRichWidth)
        {
            this.currentLineTempWidth = 0;
        }
    },
    _SetFontTotalWidth:function(str,isNotAdd,isText,currentAdd)
    {
        var num = this.GetCharactersByString(str);
        var width = this._fontWidth % this.richText.width;
        var count01 = Math.floor(this._fontWidth/this.richText.width);
        width = this._fontWidth - count01*this.richText.width;
        var currentAdd = currentAdd ? currentAdd : num*this.zijieWidthNum;
        if((width + currentAdd)>this.richText.width)
        {
            if(!isNotAdd && !isText )
            {
                this._fontWidth += currentAdd;
                this._fontWidth += (this.richText.width-width);
            }
            else
            {
                this._fontWidth += currentAdd;
            }
        }
        else
        {
            this._fontWidth += currentAdd;
        }
    },
        //换行，用空格去占位，先留着
    //_GetKongGeZhanWei:function(count)
    //{
    //    var kongStr = "    ";
    //    var kongGe = "";
    //    for(var i = 0; i < count; i++)
    //    {
    //        kongGe += kongStr;
    //    }
    //    return kongGe;
    //},
    _GetRichtextHgt:function()
    {
        var num = this._fontWidth/(this.richText.width);
        for(var i = 1; i<10;i++)
        {
            if(num>i && num<i+1)
            {
                if(num>i+0.8)
                {
                    num+=1;
                    break;
                }
            }
        }
        var hgt = Math.ceil(num);
        return hgt;
    }
});