///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//CustomTaginfo 客户端设定info
//VersionInfo 客户端设定info

// 请求消息
//301201,ReqClientCustomTagSet 请求设置客户端自定义标记

// 接收消息
//301101,ResClientMessage 被丢弃的消息
//301102,ResClientCustomTag 发送客户端自定义标记
//301103,ResVersionUpdateToClientMessage 客户端在线更新res通知
//301104,ResServerinfoToClient 服务器状态信息同步
//301105,ResFlushClientMessageToClient 发送刷新客户端的消息


var CustomTaginfo = cc.Class.extend({
	ctor:function(){
		this.key = null; // 客户端设定key
        this.value = null; // 客户端设定value
	},

	writing:function( _buf ){
		_buf.WriteString(this.key);
        _buf.WriteString(this.value);
	},
	
	reading:function( _buf ){
		this.key = _buf.ReadString();
        this.value = _buf.ReadString();
	},
});
var VersionInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 类型
        this.version = null; // 版号
        this.param = null; // 扩展键值参数
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteString(this.version);
        _buf.WriteString(this.param);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.version = _buf.ReadString();
        this.param = _buf.ReadString();
	},
});
////////////////////
// 被丢弃的消息 //
////////////////////
var ResClientMessageMessage = cc.Class.extend( {
	ctor:function(){
		this.msgid = 0; // 消息id
        this.context = null; // 消息内容
	},

	getId:function(){
		return 301101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.msgid);
        _buf.WriteString(this.context);
	},
	
	reading:function( _buf ){
        this.msgid = _buf.ReadVarInt();
        this.context = _buf.ReadString();
	},

	action:function(){
		Mgr.client.RecvResClientMessageMessage(this);
	},

});
////////////////////
// 发送客户端自定义标记 //
////////////////////
var ResClientCustomTagMessage = cc.Class.extend( {
	ctor:function(){
		this.CustomTaginfos = []; // 自定义标记列表 CustomTaginfo
	},

	getId:function(){
		return 301102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.CustomTaginfos.length );
        for (var i = 0; i < this.CustomTaginfos.length; i++) {
            _buf.WriteBean(this.CustomTaginfos[i]);
        }
	},
	
	reading:function( _buf ){
        var CustomTaginfos_length = _buf.ReadShort();
        for (var i = 0; i < CustomTaginfos_length; i++) {
            this.CustomTaginfos[i] = _buf.ReadBean(CustomTaginfo);
        }
	},

	action:function(){
		Mgr.client.RecvResClientCustomTagMessage(this);
	},

});
////////////////////
// 客户端在线更新res通知 //
////////////////////
var ResVersionUpdateToClientMessageMessage = cc.Class.extend( {
	ctor:function(){
		this.versions = []; // 版号信息 VersionInfo
	},

	getId:function(){
		return 301103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.versions.length );
        for (var i = 0; i < this.versions.length; i++) {
            _buf.WriteBean(this.versions[i]);
        }
	},
	
	reading:function( _buf ){
        var versions_length = _buf.ReadShort();
        for (var i = 0; i < versions_length; i++) {
            this.versions[i] = _buf.ReadBean(VersionInfo);
        }
	},

	action:function(){
		Mgr.client.RecvResVersionUpdateToClientMessageMessage(this);
	},

});
////////////////////
// 服务器状态信息同步 //
////////////////////
var ResServerinfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.confederation_num = 0; // 连服数量
        this.joinTime = 0; // 合区时间(秒)
        this.joinNum = 0; // 合区次数
        this.openTime = 0; // 开区时间(秒)
	},

	getId:function(){
		return 301104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.confederation_num);
        _buf.WriteVarInt(this.joinTime);
        _buf.WriteVarInt(this.joinNum);
        _buf.WriteVarInt(this.openTime);
	},
	
	reading:function( _buf ){
        this.confederation_num = _buf.ReadVarInt();
        this.joinTime = _buf.ReadVarInt();
        this.joinNum = _buf.ReadVarInt();
        this.openTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.client.RecvResServerinfoToClientMessage(this);
	},

});
////////////////////
// 发送刷新客户端的消息 //
////////////////////
var ResFlushClientMessageToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型
        this.context = null; // 内容
	},

	getId:function(){
		return 301105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteString(this.context);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.context = _buf.ReadString();
	},

	action:function(){
		Mgr.client.RecvResFlushClientMessageToClientMessage(this);
	},

});
////////////////////
// 请求设置客户端自定义标记 //
////////////////////
var ReqClientCustomTagSetMessage = cc.Class.extend( {
	ctor:function(){
		this.customTaginfo = null; // 客户端设定内容
	},

	getId:function(){
		return 301201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.customTaginfo);
	},
	
	reading:function( _buf ){
        this.customTaginfo = _buf.ReadBean(CustomTaginfo);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(301101, ResClientMessageMessage);
MESSAGE_POOL.Add(301102, ResClientCustomTagMessage);
MESSAGE_POOL.Add(301103, ResVersionUpdateToClientMessageMessage);
MESSAGE_POOL.Add(301104, ResServerinfoToClientMessage);
MESSAGE_POOL.Add(301105, ResFlushClientMessageToClientMessage);

