///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//140201,ReqConvoyToGame 请求护送面板信息
//140202,ReqConvoyStartToGame 请求开始护送
//140203,ReqConvoyDianzanToGame 请求点赞
//140204,ReqConvoyTransferToGame 前端请求传送致任务npc
//140205,ReqConvoyGiveupToGame 请求放弃护送
//140207,ReqConvoyOpenMidToGame npc请求完成本阶段

// 接收消息
//140101,ResConvoyInfoToClient 发送面板消息
//140102,ResConvoyStatusToClient 同步护送状态
//140103,ResConvoyResultToClient 护送结果信息
//140104,ResConvoyMidToClient 护送过程阶段完成


////////////////////
// 发送面板消息 //
////////////////////
var ResConvoyInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.lefttime = 0; // 剩余护送次数
	},

	getId:function(){
		return 140101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.lefttime);
	},
	
	reading:function( _buf ){
        this.lefttime = _buf.ReadByte();
	},

	action:function(){
		Mgr.convoy.RecvResConvoyInfoToClientMessage(this);
	},

});
////////////////////
// 同步护送状态 //
////////////////////
var ResConvoyStatusToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.pro = 0; // 第一段结束的获得奖励百分比（只有第二段的时候才有值）
        this.dianzannum = 0; // 被点赞次数
        this.berobnum = 0; // 被打劫次数
        this.period = 0; // 当前阶段
        this.remainTime = 0; // 护送剩余时间（秒）
	},

	getId:function(){
		return 140102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.pro);
        _buf.WriteVarInt(this.dianzannum);
        _buf.WriteVarInt(this.berobnum);
        _buf.WriteVarInt(this.period);
        _buf.WriteVarInt(this.remainTime);
	},
	
	reading:function( _buf ){
        this.pro = _buf.ReadVarInt();
        this.dianzannum = _buf.ReadVarInt();
        this.berobnum = _buf.ReadVarInt();
        this.period = _buf.ReadVarInt();
        this.remainTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.convoy.RecvResConvoyStatusToClientMessage(this);
	},

});
////////////////////
// 护送结果信息 //
////////////////////
var ResConvoyResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 结果类型（0是失败，1是成功）
        this.convoytype = 0; // 护送类型（1是普通，2是高级）
        this.pro = 0; // 获得奖励比例（百分比，前端做除以100处理）
        this.lefttime = 0; // 剩余护送次数
	},

	getId:function(){
		return 140103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.convoytype);
        _buf.WriteVarInt(this.pro);
        _buf.WriteByte(this.lefttime);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.convoytype = _buf.ReadVarInt();
        this.pro = _buf.ReadVarInt();
        this.lefttime = _buf.ReadByte();
	},

	action:function(){
		Mgr.convoy.RecvResConvoyResultToClientMessage(this);
	},

});
////////////////////
// 护送过程阶段完成 //
////////////////////
var ResConvoyMidToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.convoytype = 0; // 护送类型（1是普通，2是高级）
        this.period = 0; // 当前完成的阶段数
        this.pro = 0; // 获得奖励比例（百分比，前端做除以100处理）
	},

	getId:function(){
		return 140104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.convoytype);
        _buf.WriteVarInt(this.period);
        _buf.WriteVarInt(this.pro);
	},
	
	reading:function( _buf ){
        this.convoytype = _buf.ReadVarInt();
        this.period = _buf.ReadVarInt();
        this.pro = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.convoy.RecvResConvoyMidToClientMessage(this);
	},

});
////////////////////
// 请求护送面板信息 //
////////////////////
var ReqConvoyToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 140201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求开始护送 //
////////////////////
var ReqConvoyStartToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.convoytype = 0; // 护送类型（1是普通，2是高级）
        this.auto = 0; // 是否自动购买（1是自动购买）
	},

	getId:function(){
		return 140202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.convoytype);
        _buf.WriteVarInt(this.auto);
	},
	
	reading:function( _buf ){
        this.convoytype = _buf.ReadVarInt();
        this.auto = _buf.ReadVarInt();
	},

});
////////////////////
// 请求点赞 //
////////////////////
var ReqConvoyDianzanToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 点赞的玩家id
	},

	getId:function(){
		return 140203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 前端请求传送致任务npc //
////////////////////
var ReqConvoyTransferToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 140204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求放弃护送 //
////////////////////
var ReqConvoyGiveupToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 140205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// npc请求完成本阶段 //
////////////////////
var ReqConvoyOpenMidToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.period = 0; // 请求完成的阶数
	},

	getId:function(){
		return 140207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.period);
	},
	
	reading:function( _buf ){
        this.period = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(140101, ResConvoyInfoToClientMessage);
MESSAGE_POOL.Add(140102, ResConvoyStatusToClientMessage);
MESSAGE_POOL.Add(140103, ResConvoyResultToClientMessage);
MESSAGE_POOL.Add(140104, ResConvoyMidToClientMessage);

