///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//BalancePlayerInfo 结算玩家信息

// 请求消息
//252201,ReqApplyBfClientToGame 前端请求进入战场报名
//252202,ReqCancelBfClientToGame 玩家取消报名发送到游戏服

// 接收消息
//252101,ResApplyStatusBfGameToClient 返回给前端报名状态
//252102,ResPlayerCampToClient 返回给前端当前玩家的阵营（进入地图时主动发送）
//252103,ResResourceTracingToClient 返回给前端资源信息
//252104,ResBossTracingToClient 返回给前端BOSS信息
//252105,ResKillInfoToClient 返回我的击杀信息
//252106,ResResourcePointToClient 同步资源点数变化 每秒更新
//252107,ResClearInfoToClient 结算信息
//252108,ResResourceContentionToClient 资源点争夺信息
//252109,ResStartCountdownToClient 开场倒计时


var BalancePlayerInfo = cc.Class.extend({
	ctor:function(){
		this.webName = null; // 平台名
        this.serverId = 0; // 区
        this.name = null; // 角色名
        this.fightpower = 0; // 战斗力
        this.killnum = 0; // 杀人数
	},

	writing:function( _buf ){
		_buf.WriteString(this.webName);
        _buf.WriteVarInt(this.serverId);
        _buf.WriteString(this.name);
        _buf.WriteVarInt(this.fightpower);
        _buf.WriteVarInt(this.killnum);
	},
	
	reading:function( _buf ){
		this.webName = _buf.ReadString();
        this.serverId = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.fightpower = _buf.ReadVarInt();
        this.killnum = _buf.ReadVarInt();
	},
});
////////////////////
// 返回给前端报名状态 //
////////////////////
var ResApplyStatusBfGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.Status = 0; // 状态1报名成功,2取消报名,-1错误
	},

	getId:function(){
		return 252101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.Status);
	},
	
	reading:function( _buf ){
        this.Status = _buf.ReadByte();
	},

	action:function(){
		Mgr.crossbf.RecvResApplyStatusBfGameToClientMessage(this);
	},

});
////////////////////
// 返回给前端当前玩家的阵营（进入地图时主动发送） //
////////////////////
var ResPlayerCampToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.camp = 0; // 1红方 2蓝方
	},

	getId:function(){
		return 252102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.camp);
	},
	
	reading:function( _buf ){
        this.camp = _buf.ReadByte();
	},

	action:function(){
		Mgr.crossbf.RecvResPlayerCampToClientMessage(this);
	},

});
////////////////////
// 返回给前端资源信息 //
////////////////////
var ResResourceTracingToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.resourceCamps = []; // 资源占领方 0无占领 1红方 2蓝方 byte
	},

	getId:function(){
		return 252103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.resourceCamps.length );
        for (var i = 0; i < this.resourceCamps.length; i++) {
            _buf.WriteByte(this.resourceCamps[i]);
        }
	},
	
	reading:function( _buf ){
        var resourceCamps_length = _buf.ReadShort();
        for (var i = 0; i < resourceCamps_length; i++) {
            this.resourceCamps[i] = _buf.ReadByte();
        }
	},

	action:function(){
		Mgr.crossbf.RecvResResourceTracingToClientMessage(this);
	},

});
////////////////////
// 返回给前端BOSS信息 //
////////////////////
var ResBossTracingToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.bossModel = 0; // BossModelId
        this.isDie = 0; // 是否死亡
        this.position = null; // 刷新坐标
	},

	getId:function(){
		return 252104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.bossModel);
        _buf.WriteByte(this.isDie);
        _buf.WriteBean(this.position);
	},
	
	reading:function( _buf ){
        this.bossModel = _buf.ReadVarInt();
        this.isDie = _buf.ReadByte();
        this.position = _buf.ReadBean(Position);
	},

	action:function(){
		Mgr.crossbf.RecvResBossTracingToClientMessage(this);
	},

});
////////////////////
// 返回我的击杀信息 //
////////////////////
var ResKillInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.killNum = 0; // 击杀数量
	},

	getId:function(){
		return 252105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.killNum);
	},
	
	reading:function( _buf ){
        this.killNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.crossbf.RecvResKillInfoToClientMessage(this);
	},

});
////////////////////
// 同步资源点数变化 每秒更新 //
////////////////////
var ResResourcePointToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.redPoint = 0; // 红方资源点数量
        this.bluePoint = 0; // 蓝方资源点数量
	},

	getId:function(){
		return 252106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.redPoint);
        _buf.WriteVarInt(this.bluePoint);
	},
	
	reading:function( _buf ){
        this.redPoint = _buf.ReadVarInt();
        this.bluePoint = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.crossbf.RecvResResourcePointToClientMessage(this);
	},

});
////////////////////
// 结算信息 //
////////////////////
var ResClearInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.redInfos = []; // 红方结算信息 BalancePlayerInfo
        this.blueInfos = []; // 蓝方结算信息 BalancePlayerInfo
        this.winner = 0; // 胜利方1红 2蓝
	},

	getId:function(){
		return 252107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.redInfos.length );
        for (var i = 0; i < this.redInfos.length; i++) {
            _buf.WriteBean(this.redInfos[i]);
        }
        _buf.WriteShort( this.blueInfos.length );
        for (var i = 0; i < this.blueInfos.length; i++) {
            _buf.WriteBean(this.blueInfos[i]);
        }
        _buf.WriteByte(this.winner);
	},
	
	reading:function( _buf ){
        var redInfos_length = _buf.ReadShort();
        for (var i = 0; i < redInfos_length; i++) {
            this.redInfos[i] = _buf.ReadBean(BalancePlayerInfo);
        }
        var blueInfos_length = _buf.ReadShort();
        for (var i = 0; i < blueInfos_length; i++) {
            this.blueInfos[i] = _buf.ReadBean(BalancePlayerInfo);
        }
        this.winner = _buf.ReadByte();
	},

	action:function(){
		Mgr.crossbf.RecvResClearInfoToClientMessage(this);
	},

});
////////////////////
// 资源点争夺信息 //
////////////////////
var ResResourceContentionToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.playernum = 0; // 人数差 正是红 负是蓝
        this.point = 0; // 点数差值 正是红 负是蓝
	},

	getId:function(){
		return 252108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.playernum);
        _buf.WriteVarInt(this.point);
	},
	
	reading:function( _buf ){
        this.playernum = _buf.ReadVarInt();
        this.point = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.crossbf.RecvResResourceContentionToClientMessage(this);
	},

});
////////////////////
// 开场倒计时 //
////////////////////
var ResStartCountdownToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 1开场倒计时 2结束倒计时
        this.time = 0; // 开场倒计时时间 秒
	},

	getId:function(){
		return 252109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.crossbf.RecvResStartCountdownToClientMessage(this);
	},

});
////////////////////
// 前端请求进入战场报名 //
////////////////////
var ReqApplyBfClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 252201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 玩家取消报名发送到游戏服 //
////////////////////
var ReqCancelBfClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 252202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(252101, ResApplyStatusBfGameToClientMessage);
MESSAGE_POOL.Add(252102, ResPlayerCampToClientMessage);
MESSAGE_POOL.Add(252103, ResResourceTracingToClientMessage);
MESSAGE_POOL.Add(252104, ResBossTracingToClientMessage);
MESSAGE_POOL.Add(252105, ResKillInfoToClientMessage);
MESSAGE_POOL.Add(252106, ResResourcePointToClientMessage);
MESSAGE_POOL.Add(252107, ResClearInfoToClientMessage);
MESSAGE_POOL.Add(252108, ResResourceContentionToClientMessage);
MESSAGE_POOL.Add(252109, ResStartCountdownToClientMessage);

