///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//CrossTeamMemberInfo 队员信息
//CrossTeamInfo 组队信息类

// 请求消息
//254201,ReqCrossTeamsForZoneModelClientToGame 按副本请求队伍列表
//254202,ReqCreateCrossTeamClientToGame 创建队伍
//254203,ReqJoinCrossTeamClientToGame 加入队伍
//254204,ReqLeaveCrossTeamClientToGame 玩家离队
//254205,ReqKickMemberClientToGame 把玩家踢出队伍
//254206,ReqChangeStateClientToGame 改变准备状态
//254207,ReqStartCrossTeamZoneClientToGame 请求开始多人副本
//254208,ReqInviteZoneNoticeClinetToGame 请求发送加入副本公告
//254209,ReqChangeCrossTeamConfigToGame 请求改变队伍设置
//254210,ReqCrossTeamInvitePlayerToGame 请求邀请玩家进入跨服队伍

// 接收消息
//254101,ResCrossTeamInfoGameToClinet 更新队伍信息
//254102,ResCrossTeamsForZoneModelGameToClinet 按副本返回队伍列表
//254103,ResLeaveCrossTeamGameToClinet 玩家离队
//254104,ResInviteZoneNoticeGameToClinet 请求发送加入副本公告游戏服到前端
//254105,ResCrossTeamInvitePlayerGameToClinet 邀请玩家加入队伍信息到前段


var CrossTeamMemberInfo = cc.Class.extend({
	ctor:function(){
		this.memberId = null; // 队员ID
        this.webId = 0; // 队员webId
        this.serverId = 0; // 队员serverId
        this.name = null; // 队员名字
        this.job = 0; // 队员职业
        this.level = 0; // 队员等级
        this.fightPower = 0; // 队员战力
        this.isReady = 0; // 是否准备 （0未准备 1准备）
	},

	writing:function( _buf ){
		_buf.WriteLong(this.memberId);
        _buf.WriteVarInt(this.webId);
        _buf.WriteVarInt(this.serverId);
        _buf.WriteString(this.name);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.level);
        _buf.WriteVarInt(this.fightPower);
        _buf.WriteByte(this.isReady);
	},
	
	reading:function( _buf ){
		this.memberId = _buf.ReadLong();
        this.webId = _buf.ReadVarInt();
        this.serverId = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.level = _buf.ReadVarInt();
        this.fightPower = _buf.ReadVarInt();
        this.isReady = _buf.ReadByte();
	},
});
var CrossTeamInfo = cc.Class.extend({
	ctor:function(){
		this.teamId = null; // 队伍Id
        this.autoLoop = 0; // 是否自动循环 1是自动循环 0不自动循环
        this.zoneModelId = 0; // 绑定副本模版
        this.needCheck = 0; // 是否需要验证密码（0否 1是）
        this.autoStart = 0; // 是否满员自动开始（0否 1是）
        this.memberinfo = []; // 队伍列表 CrossTeamMemberInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.teamId);
        _buf.WriteByte(this.autoLoop);
        _buf.WriteVarInt(this.zoneModelId);
        _buf.WriteByte(this.needCheck);
        _buf.WriteByte(this.autoStart);
        _buf.WriteShort( this.memberinfo.length );
        for (var i = 0; i < this.memberinfo.length; i++) {
            _buf.WriteBean(this.memberinfo[i]);
        }
	},
	
	reading:function( _buf ){
		this.teamId = _buf.ReadLong();
        this.autoLoop = _buf.ReadByte();
        this.zoneModelId = _buf.ReadVarInt();
        this.needCheck = _buf.ReadByte();
        this.autoStart = _buf.ReadByte();
        var memberinfo_length = _buf.ReadShort();
        for (var i = 0; i < memberinfo_length; i++) {
            this.memberinfo[i] = _buf.ReadBean(CrossTeamMemberInfo);
        }
	},
});
////////////////////
// 更新队伍信息 //
////////////////////
var ResCrossTeamInfoGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.teamInfo = null; // 队伍信息
	},

	getId:function(){
		return 254101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.teamInfo);
	},
	
	reading:function( _buf ){
        this.teamInfo = _buf.ReadBean(CrossTeamInfo);
	},

	action:function(){
		Mgr.crossteam.RecvResCrossTeamInfoGameToClinetMessage(this);
	},

});
////////////////////
// 按副本返回队伍列表 //
////////////////////
var ResCrossTeamsForZoneModelGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.teamNum = 0; // 队伍总数量
        this.teamInfo = []; // 队伍信息 CrossTeamInfo
	},

	getId:function(){
		return 254102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.teamNum);
        _buf.WriteShort( this.teamInfo.length );
        for (var i = 0; i < this.teamInfo.length; i++) {
            _buf.WriteBean(this.teamInfo[i]);
        }
	},
	
	reading:function( _buf ){
        this.teamNum = _buf.ReadVarInt();
        var teamInfo_length = _buf.ReadShort();
        for (var i = 0; i < teamInfo_length; i++) {
            this.teamInfo[i] = _buf.ReadBean(CrossTeamInfo);
        }
	},

	action:function(){
		Mgr.crossteam.RecvResCrossTeamsForZoneModelGameToClinetMessage(this);
	},

});
////////////////////
// 玩家离队 //
////////////////////
var ResLeaveCrossTeamGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 玩家id
        this.type = 0; // 离队原因 0-主动离队 1-被踢 2-队伍解散
	},

	getId:function(){
		return 254103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
        this.type = _buf.ReadByte();
	},

	action:function(){
		Mgr.crossteam.RecvResLeaveCrossTeamGameToClinetMessage(this);
	},

});
////////////////////
// 请求发送加入副本公告游戏服到前端 //
////////////////////
var ResInviteZoneNoticeGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModel = 0; // 副本modelid
        this.needFightPower = 0; // 所需战斗力
        this.name = null; // 队长名
        this.teamId = null; // 队伍Id
	},

	getId:function(){
		return 254104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModel);
        _buf.WriteVarInt(this.needFightPower);
        _buf.WriteString(this.name);
        _buf.WriteLong(this.teamId);
	},
	
	reading:function( _buf ){
        this.zoneModel = _buf.ReadVarInt();
        this.needFightPower = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.teamId = _buf.ReadLong();
	},

	action:function(){
		Mgr.crossteam.RecvResInviteZoneNoticeGameToClinetMessage(this);
	},

});
////////////////////
// 邀请玩家加入队伍信息到前段 //
////////////////////
var ResCrossTeamInvitePlayerGameToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 发起邀请的玩家名
        this.zoneModel = 0; // 副本modelid
        this.teamId = null; // 队伍Id
	},

	getId:function(){
		return 254105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteVarInt(this.zoneModel);
        _buf.WriteLong(this.teamId);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.zoneModel = _buf.ReadVarInt();
        this.teamId = _buf.ReadLong();
	},

	action:function(){
		Mgr.crossteam.RecvResCrossTeamInvitePlayerGameToClinetMessage(this);
	},

});
////////////////////
// 按副本请求队伍列表 //
////////////////////
var ReqCrossTeamsForZoneModelClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 绑定副本模版(0表示所有副本)
        this.startNum = 0; // 第几个开始
        this.num = 0; // 需要显示几个
        this.type = 0; // 0所有 1允许加入的队伍
	},

	getId:function(){
		return 254201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
        _buf.WriteVarInt(this.startNum);
        _buf.WriteVarInt(this.num);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
        this.startNum = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 创建队伍 //
////////////////////
var ReqCreateCrossTeamClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 绑定副本模版
        this.autoLoop = 0; // 是否自动循环 1是自动循环 0不自动循环
        this.autoStart = 0; // 是否自动开始
        this.passWord = null; // 队伍密码
	},

	getId:function(){
		return 254202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
        _buf.WriteByte(this.autoLoop);
        _buf.WriteByte(this.autoStart);
        _buf.WriteString(this.passWord);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
        this.autoLoop = _buf.ReadByte();
        this.autoStart = _buf.ReadByte();
        this.passWord = _buf.ReadString();
	},

});
////////////////////
// 加入队伍 //
////////////////////
var ReqJoinCrossTeamClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.teamid = null; // 队伍Id（id为0表示快速加入）
        this.zoneModelId = 0; // 副本模版
        this.passWord = null; // 队伍密码
	},

	getId:function(){
		return 254203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.teamid);
        _buf.WriteVarInt(this.zoneModelId);
        _buf.WriteString(this.passWord);
	},
	
	reading:function( _buf ){
        this.teamid = _buf.ReadLong();
        this.zoneModelId = _buf.ReadVarInt();
        this.passWord = _buf.ReadString();
	},

});
////////////////////
// 玩家离队 //
////////////////////
var ReqLeaveCrossTeamClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 254204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 把玩家踢出队伍 //
////////////////////
var ReqKickMemberClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.playerid = null; // 被踢的玩家Id
	},

	getId:function(){
		return 254205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.playerid = _buf.ReadLong();
	},

});
////////////////////
// 改变准备状态 //
////////////////////
var ReqChangeStateClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.isReady = 0; // 是否准备 （0未准备 1准备）
        this.zoneModelId = 0; // 副本ModelId
	},

	getId:function(){
		return 254206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.isReady);
        _buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.isReady = _buf.ReadByte();
        this.zoneModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求开始多人副本 //
////////////////////
var ReqStartCrossTeamZoneClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelId = 0; // 副本ModelId
	},

	getId:function(){
		return 254207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelId);
	},
	
	reading:function( _buf ){
        this.zoneModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求发送加入副本公告 //
////////////////////
var ReqInviteZoneNoticeClinetToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 254208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求改变队伍设置 //
////////////////////
var ReqChangeCrossTeamConfigToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.onlyInvite = 0; // 是否只允许邀请的玩家加入 1是 0否
        this.autoStart = 0; // 是否满员自动开始（0否 1是）
        this.autoLoop = 0; // 是否自动循环 1是自动循环 0不自动循环
	},

	getId:function(){
		return 254209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.onlyInvite);
        _buf.WriteByte(this.autoStart);
        _buf.WriteByte(this.autoLoop);
	},
	
	reading:function( _buf ){
        this.onlyInvite = _buf.ReadByte();
        this.autoStart = _buf.ReadByte();
        this.autoLoop = _buf.ReadByte();
	},

});
////////////////////
// 请求邀请玩家进入跨服队伍 //
////////////////////
var ReqCrossTeamInvitePlayerToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.invitePlayerId = null; // 邀请玩家的唯一id
	},

	getId:function(){
		return 254210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.invitePlayerId);
	},
	
	reading:function( _buf ){
        this.invitePlayerId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(254101, ResCrossTeamInfoGameToClinetMessage);
MESSAGE_POOL.Add(254102, ResCrossTeamsForZoneModelGameToClinetMessage);
MESSAGE_POOL.Add(254103, ResLeaveCrossTeamGameToClinetMessage);
MESSAGE_POOL.Add(254104, ResInviteZoneNoticeGameToClinetMessage);
MESSAGE_POOL.Add(254105, ResCrossTeamInvitePlayerGameToClinetMessage);

