///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ActivityBriefInfo 活动简要信息（登录和活动改变时候发送 是所有活动的一个汇总）
//BaseDetailedInfo 活动详细信息
//ActivityDetailedInfo 活动详细信息
//SpecialDetailedInfo 跨服充值活动信息(现在又包含了战斗力提升排行)
//RechargeActivityInfo 充值活动信息
//CostActivityInfo 消费类型活动信息
//ConditionActivityInfo 简单条件类型活动信息
//RankingActivityInfo 简单条件类型活动信息
//ExchangeActivityInfo 兑换活动类型信息
//DailyRechargeActivityInfo 按天充值的活动信息
//AchievementActivityInfo 成就活动类型
//GradeTebateInfo 充值档次返利信息
//GradeTebateActivityInfos 充值返利活动信息

// 请求消息
//130201,ReqDailyActivitiesBriefInfo 请求日常活动简要信息
//130202,ReqDailyActivitiesDetailedInfo 请求日常活动详细信息
//130203,ReqDailyActivitiesGetReward 请求日常活动领奖
//130204,ReqDailyRechargeActivitiesBuQian 请求活动补签
//130205,ReqGradeTebateGetRewardToGame 前端请求获取充值返利档次奖励
//130206,ReqGradeTebateActivityToGame 前端请求获取充值返利活动信息
//130211,ReqSmashEggToGame 请求砸蛋
//130212,ReqSmashEggInfoToGame 请求砸蛋信息

// 接收消息
//130101,ResActivitiesBriefInfo 返回活动简要信息
//130102,ResActivityDetailedInfo 返回活动详细信息
//130103,ResActivityGetRewardResultInfo 领奖返回信息
//130104,ResDailyActivitiesRefresh 活动刷新广播(服务器跨天的时候广播前端请求活动)
//130105,ResGradeTebateInfoToClinet 发送充值档次返利信息给前端
//130106,ResGradeTebateActivityInfoToClinet 发送所有充值返利活佛那个信息给前端
//130111,ResSmashEggActivitiesInfo 返回砸蛋活动信息
//130112,ResSmashEggResultInfo 返回本次砸蛋结果信息


var ActivityBriefInfo = cc.Class.extend({
	ctor:function(){
		this.activityId = 0; // 活动id
        this.activityType = 0; // 活动类型
        this.repeatTimes = 0; // 剩余可领次数
        this.startTime = 0; // 活动开始时间
        this.endTime = 0; // 活动结束时间
        this.overTime = 0; // 活动结束剩余时间(秒)
        this.entranceIcon = null; // 入口资源
        this.groupType = 0; // 活动分组
        this.mainPanelKey = 0; // 主面板键值
        this.correlation = 0; // 活动关联类型
        this.mainPanelType = 0; // 主面板类型
        this.childPanelType = 0; // 子面板类型
        this.row = 0; // 前段用的
        this.rowValue = 0; // 前段用的
        this.activityTabKey = 0; // 活动所在的分页key值
        this.status = 0; // 是否满足条件配置 1满足 2不满足
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.activityId);
        _buf.WriteVarInt(this.activityType);
        _buf.WriteVarInt(this.repeatTimes);
        _buf.WriteVarInt(this.startTime);
        _buf.WriteVarInt(this.endTime);
        _buf.WriteVarInt(this.overTime);
        _buf.WriteString(this.entranceIcon);
        _buf.WriteVarInt(this.groupType);
        _buf.WriteVarInt(this.mainPanelKey);
        _buf.WriteVarInt(this.correlation);
        _buf.WriteVarInt(this.mainPanelType);
        _buf.WriteVarInt(this.childPanelType);
        _buf.WriteVarInt(this.row);
        _buf.WriteVarInt(this.rowValue);
        _buf.WriteVarInt(this.activityTabKey);
        _buf.WriteVarInt(this.status);
	},
	
	reading:function( _buf ){
		this.activityId = _buf.ReadVarInt();
        this.activityType = _buf.ReadVarInt();
        this.repeatTimes = _buf.ReadVarInt();
        this.startTime = _buf.ReadVarInt();
        this.endTime = _buf.ReadVarInt();
        this.overTime = _buf.ReadVarInt();
        this.entranceIcon = _buf.ReadString();
        this.groupType = _buf.ReadVarInt();
        this.mainPanelKey = _buf.ReadVarInt();
        this.correlation = _buf.ReadVarInt();
        this.mainPanelType = _buf.ReadVarInt();
        this.childPanelType = _buf.ReadVarInt();
        this.row = _buf.ReadVarInt();
        this.rowValue = _buf.ReadVarInt();
        this.activityTabKey = _buf.ReadVarInt();
        this.status = _buf.ReadVarInt();
	},
});
var BaseDetailedInfo = cc.Class.extend({
	ctor:function(){
		this.activityId = 0; // 活动id
        this.activityName = null; // 活动名称
        this.activityReward = null; // 活动奖励(json)
        this.status = 0; // 是否满足条件配置 1满足 2不满足
        this.rewardTimes = 0; // 已经领取次数
        this.allTimes = 0; // 总共可领取次数
        this.startTime = 0; // 活动开始时间
        this.endTime = 0; // 活动结束时间
        this.overTime = 0; // 活动结束剩余时间(秒)
        this.info = null; // 活动内容介绍
        this.resflag = null; // resflag
        this.top = 0; // 活动顺序（用于面板内的排序）
        this.titleUrl = null; // 面板内标题资源
        this.activityTabKey = 0; // 活动所在的分页key值
        this.activityImgName = null; // 活动所在的分页img名,最好是资源名而不用url
        this.activityTabName = null; // 活动所在的分页显示名
        this.thirdPanel = null; // 子子面板信息
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.activityId);
        _buf.WriteString(this.activityName);
        _buf.WriteString(this.activityReward);
        _buf.WriteVarInt(this.status);
        _buf.WriteVarInt(this.rewardTimes);
        _buf.WriteVarInt(this.allTimes);
        _buf.WriteVarInt(this.startTime);
        _buf.WriteVarInt(this.endTime);
        _buf.WriteVarInt(this.overTime);
        _buf.WriteString(this.info);
        _buf.WriteString(this.resflag);
        _buf.WriteVarInt(this.top);
        _buf.WriteString(this.titleUrl);
        _buf.WriteVarInt(this.activityTabKey);
        _buf.WriteString(this.activityImgName);
        _buf.WriteString(this.activityTabName);
        _buf.WriteString(this.thirdPanel);
	},
	
	reading:function( _buf ){
		this.activityId = _buf.ReadVarInt();
        this.activityName = _buf.ReadString();
        this.activityReward = _buf.ReadString();
        this.status = _buf.ReadVarInt();
        this.rewardTimes = _buf.ReadVarInt();
        this.allTimes = _buf.ReadVarInt();
        this.startTime = _buf.ReadVarInt();
        this.endTime = _buf.ReadVarInt();
        this.overTime = _buf.ReadVarInt();
        this.info = _buf.ReadString();
        this.resflag = _buf.ReadString();
        this.top = _buf.ReadVarInt();
        this.titleUrl = _buf.ReadString();
        this.activityTabKey = _buf.ReadVarInt();
        this.activityImgName = _buf.ReadString();
        this.activityTabName = _buf.ReadString();
        this.thirdPanel = _buf.ReadString();
	},
});
var ActivityDetailedInfo = cc.Class.extend({
	ctor:function(){
		this.baseInfo = null; // 活动基本信息
        this.specialDetaileds = []; // 针对不同活动细节信息 SpecialDetailedInfo
	},

	writing:function( _buf ){
		_buf.WriteBean(this.baseInfo);
        _buf.WriteUShort( this.specialDetaileds.length );
        for (var i = 0; i < this.specialDetaileds.length; i++) {
            _buf.WriteBean(this.specialDetaileds[i]);
        }
	},
	
	reading:function( _buf ){
		this.baseInfo = _buf.ReadBean(BaseDetailedInfo);
        var specialDetaileds_length = _buf.ReadUShort();
        for (var i = 0; i < specialDetaileds_length; i++) {
            this.specialDetaileds[i] = _buf.ReadBean(SpecialDetailedInfo);
        }
	},
});
var SpecialDetailedInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 活动类型（这个是和后端特殊定义）
        this.beanInfo = null; // 活动信息抽象的bytes 对应的是那几个特殊定义的info的bean
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteBean(this.beanInfo);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadVarInt();
        this.beanInfo = _buf.ReadBean(Bean);
	},
});
var RechargeActivityInfo = cc.Class.extend({
	ctor:function(){
		this.gold = 0; // 充值数量
        this.need = 0; // 需要的数量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.need);
	},
	
	reading:function( _buf ){
		this.gold = _buf.ReadVarInt();
        this.need = _buf.ReadVarInt();
	},
});
var CostActivityInfo = cc.Class.extend({
	ctor:function(){
		this.gold = 0; // 充值数量
        this.need = 0; // 需要的数量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.need);
	},
	
	reading:function( _buf ){
		this.gold = _buf.ReadVarInt();
        this.need = _buf.ReadVarInt();
	},
});
var ConditionActivityInfo = cc.Class.extend({
	ctor:function(){
		this.mainType = 0; // 主类型（1资源线）
        this.subType = 0; // 子类型（主类型为1时 表示资源线类型）
        this.condition = []; // 条件值 int
        this.conditionNum = []; // 条件值对应的服务器完成度 int
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.mainType);
        _buf.WriteVarInt(this.subType);
        _buf.WriteUShort( this.condition.length );
        for (var i = 0; i < this.condition.length; i++) {
            _buf.WriteVarInt(this.condition[i]);
        }
        _buf.WriteUShort( this.conditionNum.length );
        for (var i = 0; i < this.conditionNum.length; i++) {
            _buf.WriteVarInt(this.conditionNum[i]);
        }
	},
	
	reading:function( _buf ){
		this.mainType = _buf.ReadVarInt();
        this.subType = _buf.ReadVarInt();
        var condition_length = _buf.ReadUShort();
        for (var i = 0; i < condition_length; i++) {
            this.condition[i] = _buf.ReadVarInt();
        }
        var conditionNum_length = _buf.ReadUShort();
        for (var i = 0; i < conditionNum_length; i++) {
            this.conditionNum[i] = _buf.ReadVarInt();
        }
	},
});
var RankingActivityInfo = cc.Class.extend({
	ctor:function(){
		this.rankInfos = []; // 排行信息 TopInfo
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.rankInfos.length );
        for (var i = 0; i < this.rankInfos.length; i++) {
            _buf.WriteBean(this.rankInfos[i]);
        }
	},
	
	reading:function( _buf ){
		var rankInfos_length = _buf.ReadUShort();
        for (var i = 0; i < rankInfos_length; i++) {
            this.rankInfos[i] = _buf.ReadBean(TopInfo);
        }
	},
});
var ExchangeActivityInfo = cc.Class.extend({
	ctor:function(){
		this.items = null; // 兑换需要的道具[[item,id]]
	},

	writing:function( _buf ){
		_buf.WriteString(this.items);
	},
	
	reading:function( _buf ){
		this.items = _buf.ReadString();
	},
});
var DailyRechargeActivityInfo = cc.Class.extend({
	ctor:function(){
		this.gold = 0; // 每天要的充值数量
        this.needDay = 0; // 需要的天数
        this.day = 0; // 已经达成的天数
        this.buqianday = 0; // 可以补签的天数
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.needDay);
        _buf.WriteVarInt(this.day);
        _buf.WriteVarInt(this.buqianday);
	},
	
	reading:function( _buf ){
		this.gold = _buf.ReadVarInt();
        this.needDay = _buf.ReadVarInt();
        this.day = _buf.ReadVarInt();
        this.buqianday = _buf.ReadVarInt();
	},
});
var AchievementActivityInfo = cc.Class.extend({
	ctor:function(){
		this.mainType = 0; // 主类型（1资源线进阶消耗 2资源线进阶次数）
        this.subType = 0; // 子类型（主类型为1时 表示资源线类型）
        this.condition = 0; // 条件值
        this.conditionNum = 0; // 完成度
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.mainType);
        _buf.WriteVarInt(this.subType);
        _buf.WriteVarInt(this.condition);
        _buf.WriteVarInt(this.conditionNum);
	},
	
	reading:function( _buf ){
		this.mainType = _buf.ReadVarInt();
        this.subType = _buf.ReadVarInt();
        this.condition = _buf.ReadVarInt();
        this.conditionNum = _buf.ReadVarInt();
	},
});
var GradeTebateInfo = cc.Class.extend({
	ctor:function(){
		this.actId = 0; // 活动Id
        this.gold = 0; // 档次
        this.receiveFlag = 0; // (0可领取,1已领取)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.actId);
        _buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.receiveFlag);
	},
	
	reading:function( _buf ){
		this.actId = _buf.ReadVarInt();
        this.gold = _buf.ReadVarInt();
        this.receiveFlag = _buf.ReadVarInt();
	},
});
var GradeTebateActivityInfos = cc.Class.extend({
	ctor:function(){
		this.actId = 0; // 活动Id
        this.danci = []; // 所有档次 int
        this.rewards = []; // 所有档次的奖励 string
        this.infos = []; // 所有描述信息 string
        this.resFlag = []; // 所有resflag string
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.actId);
        _buf.WriteUShort( this.danci.length );
        for (var i = 0; i < this.danci.length; i++) {
            _buf.WriteVarInt(this.danci[i]);
        }
        _buf.WriteUShort( this.rewards.length );
        for (var i = 0; i < this.rewards.length; i++) {
            _buf.WriteString(this.rewards[i]);
        }
        _buf.WriteUShort( this.infos.length );
        for (var i = 0; i < this.infos.length; i++) {
            _buf.WriteString(this.infos[i]);
        }
        _buf.WriteUShort( this.resFlag.length );
        for (var i = 0; i < this.resFlag.length; i++) {
            _buf.WriteString(this.resFlag[i]);
        }
	},
	
	reading:function( _buf ){
		this.actId = _buf.ReadVarInt();
        var danci_length = _buf.ReadUShort();
        for (var i = 0; i < danci_length; i++) {
            this.danci[i] = _buf.ReadVarInt();
        }
        var rewards_length = _buf.ReadUShort();
        for (var i = 0; i < rewards_length; i++) {
            this.rewards[i] = _buf.ReadString();
        }
        var infos_length = _buf.ReadUShort();
        for (var i = 0; i < infos_length; i++) {
            this.infos[i] = _buf.ReadString();
        }
        var resFlag_length = _buf.ReadUShort();
        for (var i = 0; i < resFlag_length; i++) {
            this.resFlag[i] = _buf.ReadString();
        }
	},
});
////////////////////
// 返回活动简要信息 //
////////////////////
var ResActivitiesBriefInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.activityBriefInfos = []; // 活动简要信息 ActivityBriefInfo
	},

	getId:function(){
		return 130101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.activityBriefInfos.length );
        for (var i = 0; i < this.activityBriefInfos.length; i++) {
            _buf.WriteBean(this.activityBriefInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var activityBriefInfos_length = _buf.ReadUShort();
        for (var i = 0; i < activityBriefInfos_length; i++) {
            this.activityBriefInfos[i] = _buf.ReadBean(ActivityBriefInfo);
        }
	},

	action:function(){
		Mgr.dailyactivity.RecvResActivitiesBriefInfoMessage(this);
	},

});
////////////////////
// 返回活动详细信息 //
////////////////////
var ResActivityDetailedInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.activityDetailedInfo = []; // 活动详细信息 ActivityDetailedInfo
	},

	getId:function(){
		return 130102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.activityDetailedInfo.length );
        for (var i = 0; i < this.activityDetailedInfo.length; i++) {
            _buf.WriteBean(this.activityDetailedInfo[i]);
        }
	},
	
	reading:function( _buf ){
        var activityDetailedInfo_length = _buf.ReadUShort();
        for (var i = 0; i < activityDetailedInfo_length; i++) {
            this.activityDetailedInfo[i] = _buf.ReadBean(ActivityDetailedInfo);
        }
	},

	action:function(){
		Mgr.dailyactivity.RecvResActivityDetailedInfoMessage(this);
	},

});
////////////////////
// 领奖返回信息 //
////////////////////
var ResActivityGetRewardResultInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.result = 0; // 领奖结果 和后端定义
        this.activityDetailedInfo = null; // 活动详细信息
	},

	getId:function(){
		return 130103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.result);
        _buf.WriteBean(this.activityDetailedInfo);
	},
	
	reading:function( _buf ){
        this.result = _buf.ReadVarInt();
        this.activityDetailedInfo = _buf.ReadBean(ActivityDetailedInfo);
	},

	action:function(){
		Mgr.dailyactivity.RecvResActivityGetRewardResultInfoMessage(this);
	},

});
////////////////////
// 活动刷新广播(服务器跨天的时候广播前端请求活动) //
////////////////////
var ResDailyActivitiesRefreshMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 130104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.dailyactivity.RecvResDailyActivitiesRefreshMessage(this);
	},

});
////////////////////
// 发送充值档次返利信息给前端 //
////////////////////
var ResGradeTebateInfoToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.gradeTebateInfos = []; // 活动数据 GradeTebateInfo
	},

	getId:function(){
		return 130105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.gradeTebateInfos.length );
        for (var i = 0; i < this.gradeTebateInfos.length; i++) {
            _buf.WriteBean(this.gradeTebateInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var gradeTebateInfos_length = _buf.ReadUShort();
        for (var i = 0; i < gradeTebateInfos_length; i++) {
            this.gradeTebateInfos[i] = _buf.ReadBean(GradeTebateInfo);
        }
	},

	action:function(){
		Mgr.dailyactivity.RecvResGradeTebateInfoToClinetMessage(this);
	},

});
////////////////////
// 发送所有充值返利活佛那个信息给前端 //
////////////////////
var ResGradeTebateActivityInfoToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.gradeTebateActivityInfos = []; // 充值返利活动数据 GradeTebateActivityInfos
	},

	getId:function(){
		return 130106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.gradeTebateActivityInfos.length );
        for (var i = 0; i < this.gradeTebateActivityInfos.length; i++) {
            _buf.WriteBean(this.gradeTebateActivityInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var gradeTebateActivityInfos_length = _buf.ReadUShort();
        for (var i = 0; i < gradeTebateActivityInfos_length; i++) {
            this.gradeTebateActivityInfos[i] = _buf.ReadBean(GradeTebateActivityInfos);
        }
	},

	action:function(){
		Mgr.dailyactivity.RecvResGradeTebateActivityInfoToClinetMessage(this);
	},

});
////////////////////
// 返回砸蛋活动信息 //
////////////////////
var ResSmashEggActivitiesInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.indexs = []; // 已经砸过的位置 int
        this.indexReward = []; // 已经砸过的位置奖励 TempItemInfo
        this.surplusNum = 0; // 剩余次数
        this.totalNum = 0; // 活动期间累计获得次数
	},

	getId:function(){
		return 130111;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.indexs.length );
        for (var i = 0; i < this.indexs.length; i++) {
            _buf.WriteVarInt(this.indexs[i]);
        }
        _buf.WriteUShort( this.indexReward.length );
        for (var i = 0; i < this.indexReward.length; i++) {
            _buf.WriteBean(this.indexReward[i]);
        }
        _buf.WriteVarInt(this.surplusNum);
        _buf.WriteVarInt(this.totalNum);
	},
	
	reading:function( _buf ){
        var indexs_length = _buf.ReadUShort();
        for (var i = 0; i < indexs_length; i++) {
            this.indexs[i] = _buf.ReadVarInt();
        }
        var indexReward_length = _buf.ReadUShort();
        for (var i = 0; i < indexReward_length; i++) {
            this.indexReward[i] = _buf.ReadBean(TempItemInfo);
        }
        this.surplusNum = _buf.ReadVarInt();
        this.totalNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.dailyactivity.RecvResSmashEggActivitiesInfoMessage(this);
	},

});
////////////////////
// 返回本次砸蛋结果信息 //
////////////////////
var ResSmashEggResultInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.indexs = 0; // 位置
        this.reward = null; // 奖励
	},

	getId:function(){
		return 130112;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.indexs);
        _buf.WriteBean(this.reward);
	},
	
	reading:function( _buf ){
        this.indexs = _buf.ReadVarInt();
        this.reward = _buf.ReadBean(TempItemInfo);
	},

	action:function(){
		Mgr.dailyactivity.RecvResSmashEggResultInfoMessage(this);
	},

});
////////////////////
// 请求日常活动简要信息 //
////////////////////
var ReqDailyActivitiesBriefInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 130201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求日常活动详细信息 //
////////////////////
var ReqDailyActivitiesDetailedInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.activityId = []; // 请求的活动id int
	},

	getId:function(){
		return 130202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteUShort( this.activityId.length );
        for (var i = 0; i < this.activityId.length; i++) {
            _buf.WriteVarInt(this.activityId[i]);
        }
	},
	
	reading:function( _buf ){
        var activityId_length = _buf.ReadUShort();
        for (var i = 0; i < activityId_length; i++) {
            this.activityId[i] = _buf.ReadVarInt();
        }
	},

});
////////////////////
// 请求日常活动领奖 //
////////////////////
var ReqDailyActivitiesGetRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.activityId = 0; // 请求的活动id
        this.times = 0; // 领取次数
	},

	getId:function(){
		return 130203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.activityId);
        _buf.WriteVarInt(this.times);
	},
	
	reading:function( _buf ){
        this.activityId = _buf.ReadVarInt();
        this.times = _buf.ReadVarInt();
	},

});
////////////////////
// 请求活动补签 //
////////////////////
var ReqDailyRechargeActivitiesBuQianMessage = cc.Class.extend( {
	ctor:function(){
		this.activityId = 0; // 请求的活动id
	},

	getId:function(){
		return 130204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.activityId);
	},
	
	reading:function( _buf ){
        this.activityId = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求获取充值返利档次奖励 //
////////////////////
var ReqGradeTebateGetRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.gold = 0; // 档次
        this.actId = 0; // 活动id
	},

	getId:function(){
		return 130205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.actId);
	},
	
	reading:function( _buf ){
        this.gold = _buf.ReadVarInt();
        this.actId = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求获取充值返利活动信息 //
////////////////////
var ReqGradeTebateActivityToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.actId = 0; // 活动id(0全部)
	},

	getId:function(){
		return 130206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.actId);
	},
	
	reading:function( _buf ){
        this.actId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求砸蛋 //
////////////////////
var ReqSmashEggToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.index = 0; // 索引
	},

	getId:function(){
		return 130211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
	},
	
	reading:function( _buf ){
        this.index = _buf.ReadVarInt();
	},

});
////////////////////
// 请求砸蛋信息 //
////////////////////
var ReqSmashEggInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 130212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(130101, ResActivitiesBriefInfoMessage);
MESSAGE_POOL.Add(130102, ResActivityDetailedInfoMessage);
MESSAGE_POOL.Add(130103, ResActivityGetRewardResultInfoMessage);
MESSAGE_POOL.Add(130104, ResDailyActivitiesRefreshMessage);
MESSAGE_POOL.Add(130105, ResGradeTebateInfoToClinetMessage);
MESSAGE_POOL.Add(130106, ResGradeTebateActivityInfoToClinetMessage);
MESSAGE_POOL.Add(130111, ResSmashEggActivitiesInfoMessage);
MESSAGE_POOL.Add(130112, ResSmashEggResultInfoMessage);

