var DailyactivitiesModMgr = DailyactivitiesModMgr || cc.Class.extend({ 

	_activityHash:null,
	_keyHash:null,				//根据mainPanelKey分类好的
	_panelHash:null,			//mainPanelKey对应唯一面板

	_autoShowSC:true,  //自动弹首冲
	_autoShowMR:true,  //自动弹每日特惠

	eggCount:0,
	eventEggInfo:null,
	eventEggResult:null,

	ctor:function() {
		this._activityHash = new HashMap();
		this._keyHash = new HashMap();
		this._panelHash = new HashMap();
		this._gradeHash = new HashMap();

		this.eventEggInfo = new signals.Signal();
		this.eventEggResult = new signals.Signal();

        SpecialDetailedInfo.prototype.reading = function( _buf ){
            this.type = _buf.ReadVarInt();
            //活动信息抽象的bytes 对应的是那几个特殊定义的info的bean
                switch( this.type )
                {
					case EnumSpecialType.RECHARGE://充值活动信息
						this.beanInfo = _buf.ReadBean(RechargeActivityInfo);
						break;
					case EnumSpecialType.COST://消费类型活动信息
						this.beanInfo = _buf.ReadBean(CostActivityInfo);
						break;
					case EnumSpecialType.CONDITION://简单条件类型活动信息
						this.beanInfo = _buf.ReadBean(ConditionActivityInfo);
						break;
					case EnumSpecialType.RANK://排行榜类型活动信息
						this.beanInfo = _buf.ReadBean(RankingActivityInfo);
						break;
					case EnumSpecialType.EXCHANGE://兑换
						this.beanInfo = _buf.ReadBean(ExchangeActivityInfo);
						break;
					case EnumSpecialType.SERIES_RECHARGE://天天充值
                        this.beanInfo = _buf.ReadBean(DailyRechargeActivityInfo);
						break;
					case EnumSpecialType.ACHIEVEMENT://成就
                        this.beanInfo = _buf.ReadBean(AchievementActivityInfo);
						break;
				}
            }
	},

	RecvResActivitiesBriefInfoMessage:function(msg) {
		cc.log("收到活动 RecvResActivitiesBriefInfoMessage");
		this.reqTypeArr.length = 0;
		this._activityHash.Clear();
        var KFwarnState = false, SCwarnState = false, THwarnState = false, LJwarnState = false, TTwarnState = false, MRwarnState = false, XSwarnState = false;
		var reqIds = [];
		for( var i = 0, len = msg.activityBriefInfos.length; i < len; i++ ){
			var vo = new ActivityVo( msg.activityBriefInfos[i] );
			//这里特殊处理一下每日特惠活动，领取过就不再展示
			if((vo.mainPanelKey == EnumActivityKey.M_MRTH || vo.mainPanelKey == EnumActivityKey.M_XSHK) && vo.status == 0)
				continue;
			this._activityHash.Put( vo.activityId, vo );
			ActivityUtil.ResetRewardStatus(vo);
			if(vo.status == 1){
				switch (vo.mainPanelKey) {
					case EnumActivityKey.M_KAI_FU:
                        KFwarnState = true;
						break;
                    case EnumActivityKey.M_SHOU_CHONG:
                        SCwarnState = true;
                        break;
					case EnumActivityKey.M_TE_HUI:
						THwarnState = true;
                        break;
					case EnumActivityKey.M_LEI_JI:
						LJwarnState = true;
						break;
					case EnumActivityKey.M_TTFL:
                        TTwarnState = true;
                        break;
					case EnumActivityKey.M_MRTH:
						MRwarnState = true;
						break;
					case EnumActivityKey.M_XSHK:
						XSwarnState = true;
						break;
				}
			}
			if( vo.subPanelType == EnumActivityType.S_GOLD_EGG ){	//金蛋展示红点
				vo.status = this.eggCount > 0 ? 1 : 2;
			}else if(vo.subPanelType == EnumActivityType.S_BBGS){
                vo.status = Mgr.step.GetRequestItemAmount() > 0 ? 1 : 2
            }

			//这里检测活动的面板是否打开 是则刷新数据(先这样简单处理, 其实应该把多余活动删掉, 然后直接刷新面板之类)
			var panel = this._panelHash.Get(vo.mainPanelKey);
			if(Mgr.uiMgr.IsPanelShow(panel) && ( vo.mainPanelKey != EnumActivityKey.M_REAL_DOUBLE_RECHARGE )){	//双倍充值的面板要单独判断
				reqIds.push(vo.activityId);
			}
		}
		this._SortActivity();

		//自动弹首冲(首冲完成弹每日特惠)
        if(ActivityUtil.IsActivityFinishedStatus(EnumActivityKey.M_SHOU_CHONG) && Mgr.player.rechargeInfo.all > 0){//首冲完成
			if(this._autoShowMR && this.GetActivityByKey(EnumActivityKey.M_MRTH)){
                ActivityUtil.OpenGuidePanel(EnumActivityKey.M_MRTH);
                this._autoShowMR = false;
			}
		}
        else if(this._autoShowSC && this.GetActivityByKey(EnumActivityKey.M_SHOU_CHONG)){
            OpenFuncUtil.OpenFirstRecharge();
            this._autoShowSC = false;
        }

		//更新活动入口按钮显示
		Mgr.player.roleHeadPanel.UpdateChargeShow();
        var panel = Mgr.map.miniMapPanel;
        panel.UpdateActivityButton(this._keyHash.Values());
		var bbgsWarn = ActivityUtil.IsRewardStatus(this.GetActivityByKey(EnumActivityKey.M_BBGS));
        panel.UpdateKFWarn(KFwarnState || bbgsWarn);
        panel.UpdateSCwarn(SCwarnState);
        panel.UpdateTHWarn(THwarnState);
        panel.UpdateLJWarn(LJwarnState);
        panel.UpdateTTFLWarn(TTwarnState);
        panel.UpdateMRTHWarn(MRwarnState);
        panel.UpdateXSHKWarn(XSwarnState);
        panel.UpdateSpecialIcon();//这里刷新特殊的活动icon（比如打折什么的）
		//上线请求链接活动
		var data = ActivityUtil.GetGuideKeys();
		for(var i = 0, len = data.length; i < len; i++){
			var id = data[i];
			if(this._activityHash.ContainsKey(id)){
				reqIds.push(id);
			}
		}
        Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds, 1);
	},

	RecvResActivityDetailedInfoMessage:function(msg) {
        var allHash = new HashMap();
		var guideList = ActivityUtil.GetGuideKeys();
		var hasDoubleCharge = false;
		for( var i = 0, len = msg.activityDetailedInfo.length; i < len; i++ ){
			var info = msg.activityDetailedInfo[i];
			var vo = this._activityHash.Get(info.baseInfo.activityId);
			if( vo ){
				vo.SetDetail(info);
				ActivityUtil.ResetRewardStatus(vo);
				if( vo.mainPanelKey == EnumActivityKey.M_REAL_DOUBLE_RECHARGE )		//双倍面板特殊处理
					hasDoubleCharge = true;
				else if( guideList.indexOf(info.baseInfo.activityId) == -1 || vo.mainPanelKey ==EnumActivityKey.M_XSHK)	//跳转类活动不能根据自身key打开面板(限时回馈活动特殊处理)
					allHash.Put( vo.mainPanelKey, vo.mainPanelType );

				if(vo.subPanelType == EnumActivityType.S_GOLD_EGG)
					vo.status = this.eggCount > 0 ? 1 : 2;
                else if(vo.subPanelType == EnumActivityType.S_BBGS){
                    vo.status = Mgr.step.GetRequestItemAmount() > 0 ? 1 : 2
                }
			}
		}

		if( hasDoubleCharge ){
			var p = Mgr.uiMgr.ShowPanelByType(RechargePanelExt.PanelName)
			if(p) p.ChangePanel(RechargeTypeEnum.TYPE_RECHARGE);
		}

		var reqType = this.reqTypeArr.length ? this.reqTypeArr.shift() : 1;
		var mainPanelKeys = allHash.Keys();
		for( var i = 0, len = mainPanelKeys.length; i < len; i++ ){
			var mainKey = mainPanelKeys[i];
			var mainType = allHash.Get(mainKey);
			var panel = this._panelHash.Get(mainKey);
			if( Mgr.uiMgr.IsPanelShow(panel) ){
				panel.SetActivityKey(mainKey, mainType);
			}
			else if (reqType == 0) {
				if( !panel ){
					var className = ActivityUtil.GetClassByMainType( mainType );
                    /// 策划不配字段，特殊处理
                    if(mainKey == EnumActivityKey.M_QYMM){
                        className = QinYiMMPanelExt
                    }
					panel = new className();
					panel._className = panel._className + (UIMgr.PanelNameIndex++);
					this._panelHash.Put(mainKey, panel);
				}
				Mgr.uiMgr.ShowPanel(panel);
				panel.SetActivityKey(mainKey, mainType, true);
			}
		}
	},

	RecvResActivityGetRewardResultInfoMessage:function(msg) {
        if (msg.result <= 0)
            return;

        var vo = this._activityHash.Get(msg.activityDetailedInfo.baseInfo.activityId);
        if (vo) {
            vo.SetDetail(msg.activityDetailedInfo);

            if( vo.mainPanelKey == EnumActivityKey.M_KAI_FU && vo.subPanelType == 8 ){
                //限购商城
                Mgr.tips.ShowNotice("购买成功！");
            }
			if( vo.mainPanelKey == EnumActivityKey.M_REAL_DOUBLE_RECHARGE )	{		//双倍面板特殊处理
				var p = Mgr.uiMgr.ShowPanelByType(RechargePanelExt.PanelName)
				if(p) p.ChangePanel(RechargeTypeEnum.TYPE_RECHARGE);
				return;
			}

            var warn = false;
            if (vo.status == 1)
                warn = true;
            switch (vo.mainPanelKey) {
                case EnumActivityKey.M_KAI_FU:
				case EnumActivityKey.M_BBGS:
                    var kfAcs = this._keyHash.Get(EnumActivityKey.M_KAI_FU);
                    for (var i = 0, len = kfAcs.length; i < len; i++) {
                        var ac = kfAcs[i];
                        if (ac.status == 1) {
                            warn = true;
                            break;
                        }
                    }
					var bbgsWarn = ActivityUtil.IsRewardStatus(this.GetActivityByKey(EnumActivityKey.M_BBGS));
                    Mgr.map.miniMapPanel.UpdateKFWarn(warn || bbgsWarn);
                    break;
                case EnumActivityKey.M_SHOU_CHONG:
                    var scAcs = this._keyHash.Get(EnumActivityKey.M_SHOU_CHONG);
                    for (var i = 0, len = scAcs.length; i < len; i++) {
                        var ac = scAcs[i];
                        if (ac.status == 1) {
                            warn = true;
                            break;
                        }
                    }
                    Mgr.map.miniMapPanel.UpdateSCwarn(warn);
                    break;
				case EnumActivityKey.M_LEI_JI:
                    var ljAcs = this._keyHash.Get(EnumActivityKey.M_LEI_JI);
                    for (var i = 0, len = ljAcs.length; i < len; i++) {
                        var ac = ljAcs[i];
                        if (ac.status == 1) {
                            warn = true;
                            break;
                        }
                    }
                    Mgr.map.miniMapPanel.UpdateLJWarn(warn);
                    break;
				case EnumActivityKey.M_TTFL:
                    var ttflAcs = this._keyHash.Get(EnumActivityKey.M_TTFL);
                    for (var i = 0, len = ttflAcs.length; i < len; i++) {
                        var ac = ttflAcs[i];
                        if (ac.status == 1) {
                            warn = true;
                            break;
                        }
                    }
                    Mgr.map.miniMapPanel.UpdateTTFLWarn(warn);
                    break;
				case EnumActivityKey.M_MRTH://每日特惠活动只有一个，领取奖励后隐藏按钮，关闭面板
				case EnumActivityKey.M_XSHK://限时回馈活动只有一个，领取奖励后隐藏按钮，关闭面板
					this.RemoveActivityByKey(vo.mainPanelKey);
					Mgr.map.miniMapPanel.UpdateActivityButton(this._keyHash.Values());
					break;
            }
            //这里检测活动的面板是否打开 是则刷新数据
            var panel = this._panelHash.Get(vo.mainPanelKey);
            if(vo.mainPanelKey == EnumActivityKey.M_SHOU_CHONG || vo.mainPanelKey == EnumActivityKey.M_MRTH || vo.mainPanelKey == EnumActivityKey.M_XSHK){
                Mgr.uiMgr.HidePanel(panel);
			}
            if (Mgr.uiMgr.IsPanelShow(panel)) {
                panel.UpdateSingleActivity(vo);
            }
			if( vo.mainPanelKey == EnumActivityKey.M_BBGS ){	//步步高升没面板 放在通用活动S_BBGS里面
				var list = ActivityUtil.GetActivityBySubPanelType(EnumActivityKey.M_KAI_FU, EnumActivityType.S_BBGS);
				if( list && list.length ){
					vo = list[0];
					panel = this._panelHash.Get(vo.mainPanelKey);
					if (Mgr.uiMgr.IsPanelShow(panel))
						panel.UpdateSingleActivity(vo);
				}
			}
        }
        GameEventMgr.DispatchEvent(msg.getId(),msg)
    },

	RecvResDailyActivitiesRefreshMessage:function(msg) {
		this.SendReqDailyActivitiesBriefInfoMessage();
	},

	_gradeHash:null,
	RecvResGradeTebateActivityInfoToClinetMessage:function(msg){
		for( var i = 0, len = msg.gradeTebateActivityInfos.length; i < len; i++ ){
			var info = msg.gradeTebateActivityInfos[i];
			var list = [];
			for( var j = 0, k = info.danci.length; j < k; j++ ){
				list.push( { activityId:info.actId, gold:info.danci[j], reward:info.rewards[j], info:info.infos[j], resFlag:info.resFlag[j], state:2 } );
			}
			this._gradeHash.Put( info.actId, list );
		}
	},

	RecvResGradeTebateInfoToClinetMessage:function(msg){
		for( var i = 0, len = msg.gradeTebateInfos.length; i < len; i++ ){
			var info = msg.gradeTebateInfos[i];
			var list = this._gradeHash.Get( info.actId );
			if( list ){
				for( var j = 0, k = list.length; j < k; j++ ){
					var fullInfo = list[j];
					if( fullInfo.gold == info.gold ){
						if( fullInfo.status != info.receiveFlag ){
							fullInfo.status = info.receiveFlag;
							this.UpdateSingleGrade(fullInfo);
						}
						break;
					}
				}
			}
		}
	},

	RecvResSmashEggActivitiesInfoMessage:function(msg){
		this.eggCount = msg.surplusNum;
		var vo = this._activityHash.Get(151);	//151 金蛋
		if( vo ){
			vo.status = msg.surplusNum > 0 ? 1 : 2;
			var panel = this._panelHash.Get(vo.mainPanelKey);
			if (Mgr.uiMgr.IsPanelShow(panel)) {
				panel.UpdateSingleActivity(vo);
			}
			Mgr.map.miniMapPanel.UpdateActivityButton(this._keyHash.Values());
		}
		this.eventEggInfo.dispatch(msg);
	},

	RecvResSmashEggResultInfoMessage:function(msg){
		this.eventEggResult.dispatch(msg);
	},

	HasSingleRechargeReward:function(id){
		var list = this._gradeHash.Get(id);
		if( list ){
			for( var i = 0, len = list.length; i < len; i++ ){
				if( list[i].status == 0 )
					return true;
			}
		}
		return false;
	},

	UpdateSingleGrade:function(info){
		var vo = this._activityHash.Get(info.activityId);
		if( vo ){
			ActivityUtil.ResetRewardStatus(vo);
			var warn = false;
			if(vo.status == 1)
				warn = true;
			switch (vo.mainPanelKey) {
				case EnumActivityKey.M_KAI_FU:
					var bbgsWarn = ActivityUtil.IsRewardStatus(this.GetActivityByKey(EnumActivityKey.M_BBGS));
					Mgr.map.miniMapPanel.UpdateKFWarn(warn || bbgsWarn);
					break;
				case EnumActivityKey.M_SHOU_CHONG:
					Mgr.map.miniMapPanel.UpdateSCwarn(warn);
					break;
			}
			//这里检测活动的面板是否打开 是则刷新数据
			var panel = this._panelHash.Get(vo.mainPanelKey);
			if(Mgr.uiMgr.IsPanelShow(panel)){
				panel.UpdateSingleActivity(vo);
			}
		}
	},

	GetGradeInfoById:function(id){
		return this._gradeHash.Get(id);
	},

	/**
	 * 请求活动列表
	 * @constructor
	 */
	SendReqDailyActivitiesBriefInfoMessage:function() {
		var msg = new ReqDailyActivitiesBriefInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 请求活动详情
	 * @param ids []
	 * @constructor
	 */
	reqTypeArr:[],
	SendReqDailyActivitiesDetailedInfoMessage:function(ids, type) {
		type = type || 0;		// 0 打开面板   1 收到简要信息请求的 只刷新面板和数据
		if( ids && ids.length ){
			var msg = new ReqDailyActivitiesDetailedInfoMessage();
			msg.activityId = ids;
			Mgr.msgMgr.Send(msg);
			this.reqTypeArr.push(type);
		}
	},

	/**
	 * 请求领奖
	 * @param id
	 * @param count
	 * @constructor
	 */
	SendReqDailyActivitiesGetRewardMessage:function(id, count) {
		count = count || 1;
		var msg = new ReqDailyActivitiesGetRewardMessage();
		msg.activityId = id;
		msg.times = count;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGradeTebateActivityToGameMessage:function(id){
		var msg = new ReqGradeTebateActivityToGameMessage();
		msg.actId = id;
		Mgr.msgMgr.Send(msg);
	},

	SendReqGradeTebateGetRewardToGameMessage:function(id, gold){
		var msg = new ReqGradeTebateGetRewardToGameMessage();
		msg.actId = id;
		msg.gold = gold;
		Mgr.msgMgr.Send(msg);
	},

	SendReqSmashEggInfoToGameMessage:function(){
		Mgr.msgMgr.Send(new ReqSmashEggInfoToGameMessage());
	},

	SendReqSmashEggToGameMessage:function(index){
		var msg = new ReqSmashEggToGameMessage();
		msg.index = index;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 活动根据mainPanelKey进行分类 打开面板的时候好取得对应的活动
	 * @constructor
	 */
	_SortActivity:function(){
		this._keyHash.Clear();
		var arr = this._activityHash.Values();
		var group;
		var activity;
		for( var i = 0, len = arr.length; i < len; i++ ){
			activity = arr[i];
			group = this._keyHash.Get(activity.mainPanelKey);
			if( group ){
				group.push(activity);
			}
			else{
				group = [activity];
				this._keyHash.Put(activity.mainPanelKey, group);
			}
		}
	},

	RemoveActivityByKey:function(key){
		var list = this._keyHash.Get(key);
		for( var i = 0; i < list.length; i++ ){
			this._activityHash.Remove(list[i].activityId);
		}
		this._keyHash.Remove(key);
	},

    GetActivityById:function(key){
        return this._activityHash.Get(key);
    },

	GetActivityByKey:function(key){
		return this._keyHash.Get(key);
	},
});
var ActivityVo = ActivityVo || cc.Class.extend({
		activityId:0,			//id
		activityType:0,			//活动类型
		groupType:0,			//活动分组	图标过多的时候 将同一类型的做到一个group里 点击后再显示该类的图标
		startTime:0,			//开始时间
		endTime:0,				//结束时间
		overTime:0,				//剩余秒数
		repeatTimes:0,			//剩余可领次数
		activityIcon:null,		//入口图标
		durationStr:null,		//活动时间文本

		activityName:null,		//活动名称
		activityReward:null,	//活动奖励
		status:2,				//活动状态	0 已领取 1 可领取 2 不可领取
		rewardTimes:0,			//已经领取次数
		allTimes:0,				//总共可领取次数
		introduction:null,		//活动介绍
		top:0,					//面板排序值
		tabKey:0,				//分页key
		resFlag:null,			//title图片 兑换次数等资源配置 每个类型的活动自己处理对应的值
		activityImgName:null,	//分页image
		tabType:0,				// 0文本 1美术字
		tabName:null,			// 分页tabBtn文本或美术路径
		titleType:0,			// 0文本 1美术字
		titleName:null,			// 面板标题 文本或美术路径
		special:null,			//条件 排行榜 充值 消费等特殊信息
		thirdPanelKey:0,
		thirdPanelName:null,

		mainPanelKey:0,			//主面板key  唯一标志 一组活动一个按钮入口
		mainPanelType:0,		//主面板类型 面板样式
		subPanelType:0,			//子面板类型

		ctor:function(info){
			this.activityId = info.activityId;
			this.activityType = info.activityType;
			this.groupType = info.groupType;

			this.startTime = info.startTime;
			this.endTime = info.endTime;
			this.overTime = info.overTime;
			this.repeatTimes = info.repeatTimes;

			this.mainPanelKey = info.mainPanelKey;
			this.activityIcon = info.entranceIcon;
			this.mainPanelType = info.mainPanelType;
			this.subPanelType = info.childPanelType;
			this.tabKey = info.activityTabKey;
            this.status = info.status;
			if (info.startTime == 0 || info.endTime == 0){
				this.durationStr = "永久";
			}
			else{
				this.durationStr = TimeUtil.GetDateStr(info.startTime) + " - " + TimeUtil.GetDateStr(info.endTime);
			}

		},
		SetDetail:function(info){
			this.activityName = info.baseInfo.activityName;
			this.activityReward = info.baseInfo.activityReward;
			this.status = info.baseInfo.status;
			this.rewardTimes = info.baseInfo.rewardTimes;
			this.allTimes = info.baseInfo.allTimes;
			this.introduction = info.baseInfo.info;
			this.top = info.baseInfo.top;
			this.tabKey = info.baseInfo.activityTabKey;
            if(info.baseInfo.resflag){
                this.resFlag = this._ParseFlag(info.baseInfo.resflag);
			}
            this.activityImgName = info.baseInfo.activityImgName;
            if(info.baseInfo.activityTabName){
                var arr = info.baseInfo.activityTabName.split(":");
                this.tabType = parseInt(arr[0]);
                this.tabName = arr[1];
            }
            if(info.baseInfo.titleUrl){
                arr = info.baseInfo.titleUrl.split(":");
                this.titleType = parseInt(arr[0]);
                this.titleName = arr[1];
                this.special = info.specialDetaileds;
                if(info.baseInfo.thirdPanel){
                    arr = info.baseInfo.thirdPanel.split(":");
                    this.thirdPanelKey = arr[0];
                    this.thirdPanelName = arr[1];
                }
            }
		},

		_ParseFlag:function(flag){
			var hash = new HashMap();
			var flagArr = flag.split(",");
			for( var i = 0, len = flagArr.length; i < len; i++ ){
				flag = flagArr[i];
				var keyValue = flag.split(":");
				if( keyValue.length == 2 )
					hash.Put(keyValue[0], keyValue[1]);
			}
			return hash;
		},

		GetFlagValue:function (str) {
			if(!this.resFlag){
				return null;
			}
			return this.resFlag.Get(str);
        },

		GetRewardList:function () {
			if(!this.activityReward)
				return null;
            var awards = JSON.parse(this.activityReward);

            var arr = [];
            for(var i=0;i!=awards.length;++i){
                var v = awards[i];
                var item = ItemUtil.ItemConfigToItem(v);
                arr.push(item);
            }

            return arr;
        },

		IsEnd:function(){
			return this.endTime > 0 && this.endTime < ( Mgr.login.GetServerTime() / 1000 );
		}
	});

var EnumActivityFlag = EnumActivityFlag || {};
EnumActivityFlag.F_NEW_PRICE = "newprice";		//当前价格
EnumActivityFlag.F_CORRELATION = "correlation";		//关联过滤活动
EnumActivityFlag.F_POWER = "power"; 
EnumActivityFlag.F_BACKGROUND = "background";
EnumActivityFlag.F_TITLE = "title";
EnumActivityFlag.F_GUIDE = "guide";		//跳转活动key
EnumActivityFlag.F_VIP = "vip";			//需要vip等级
EnumActivityFlag.F_LIMIT = "limit";		//根据status分段显示

var EnumActivityKey = EnumActivityKey || {};		//主面板类型
EnumActivityKey.M_KAI_FU = 1;			//开服活动(其实现在是与精彩活动共用一个)
EnumActivityKey.M_SHOU_CHONG = 2;		//首冲
EnumActivityKey.M_WU_LIN = 5;			//武林庆典
EnumActivityKey.M_TE_HUI = 6;		//特惠礼包
EnumActivityKey.M_LEI_JI = 13;    //6888免费福利
EnumActivityKey.M_MRTH = 14; 		//每日特惠
EnumActivityKey.M_XSHK = 15; 		//限时回馈
EnumActivityKey.M_XYZP = 17;        //幸运转盘（鸿运转盘）
EnumActivityKey.M_BBGS = 18;         //步步高升
EnumActivityKey.M_REAL_DOUBLE_RECHARGE = 19;         //真双倍返利	要屏蔽icon
EnumActivityKey.M_DOUBLE_RECHARGE = 1000;	//双倍返利 显示icon  跳转 M_REAL_DOUBLE_RECHARGE  19_1
EnumActivityKey.M_TTFL = 9999999;  //天天返利,这货没有特么的
EnumActivityKey.M_QYPH = 1004;  //情缘排行
EnumActivityKey.M_QYMM = 1005;  //情意绵绵

EnumActivityKey.S_DOUBLE_RECHARGE = 8;	//双倍返利

var EnumActivityType = EnumActivityType || {};		//主面板模板类型
EnumActivityType.M_DEFAULT = 1;			//通用面板
EnumActivityType.M_GUANG_WU = 2;		//光武寻宝
EnumActivityType.M_SHOU_CHONG = 4;		//首冲豪礼
EnumActivityType.M_TE_HUI = 6;			//特惠礼包
EnumActivityType.M_LEI_JI = 13;         //6888免费福利
EnumActivityType.M_MRTH = 14; 			//每日特惠
EnumActivityType.M_XSHK = 15; 			//限时回馈
EnumActivityType.M_XYZP = 17;         //幸运转盘（鸿运转盘）
EnumActivityType.M_BBGS = 18;         //步步高升

EnumActivityType.S_TUAN_GOU = 56;                //团购等带页签的
EnumActivityType.S_CHOU_JIANG = 3;              //幸运抽奖
EnumActivityType.S_PAI_HANG = 2;              //消耗排行
EnumActivityType.S_KUANG_HUAN = 21;              //消耗排行(公测狂欢)
EnumActivityType.S_DOUBLE_RECHARGE = 12;        //双倍返利
EnumActivityType.S_DOUBLE_DROP = 17;         //双倍掉落
EnumActivityType.S_SINGLE_RECHARGE = 48;		//单笔充值(新返利 特殊消息)
EnumActivityType.S_XIAN_GOU = 64;   //限购商城
EnumActivityType.S_GOLD_EGG = 1001;   //砸金蛋
EnumActivityType.S_BBGS = 1003;  //步步高升
EnumActivityType.S_NEW_SINGLE_RECHARGE = 1004;	//单笔充值
EnumActivityType.S_SERIES_RECHARGE = 1005;		//连续充值
EnumActivityType.S_ADDUP_RECHARGE = 1006;		//累计充值
EnumActivityType.S_HE_TI = 1007;		//消耗排行（合体专题）

var EnumSpecialType = EnumSpecialType || {};
EnumSpecialType.RECHARGE = 1;			//充值活动
EnumSpecialType.COST = 2;				//消费活动
EnumSpecialType.CONDITION = 3;			//简单条件活动
EnumSpecialType.RANK = 4;				//排行活动
EnumSpecialType.EXCHANGE = 5;			//兑换活动
EnumSpecialType.SERIES_RECHARGE = 6;	//连续充值
EnumSpecialType.ACHIEVEMENT = 7;		//成就活动

var ActivityUtil = ActivityUtil || {
	Filter_Data:null,		// [[filterMainType],[filterSubType],[GuideId]]
	_guideHash:null,

    GetClassByMainType:function( mainType ){
        var className = ActivitiesBackGroundExt;
        switch( mainType ){
			case EnumActivityType.M_DEFAULT:
				className = ActivitiesBackGroundExt;
				break;
			case EnumActivityType.M_SHOU_CHONG:
				className = ShouChongMainExt;
				break;
			case EnumActivityType.M_TE_HUI:
				className = TeHuiLiBaoPanelExt;
				break;
			case EnumActivityType.M_LEI_JI:
				className = SignShouChongExt;
				break;
			case EnumActivityType.M_MRTH:
				className = JinRiTeHuiMainExt;
				break;
			case EnumActivityType.M_XSHK:
				className = XianShiHuiKuiMainExt;
				break;
			case EnumActivityType.M_XYZP:
				className = XingYunZhuanPanPanelExt;
				break;
			case EnumActivityType.M_GUANG_WU:
				className = WuLinQingDianPanelExt;
				break;
            case EnumActivityType.M_BBGS:
                className = BuBuGaoShengFrameExt;
                break;
		}
        return className;
    },

    GetClassBySubType:function( subType ){
        var name = CommonPanel.PanelName;
        switch (subType){
            case EnumActivityType.S_TUAN_GOU:
                name = TuangouMainExt.PanelName;
                break;
            case EnumActivityType.S_CHOU_JIANG:
                name = ChouJiangMainExt.PanelName;
                break;
			case EnumActivityType.S_SINGLE_RECHARGE:
				name = SingleRechargePanelExt.PanelName;
				break;
			case EnumActivityType.S_DOUBLE_DROP:
				name = BossDoubleExt.PanelName;
				break;
            case EnumActivityType.S_XIAN_GOU:
                name = kaifuhuodongExt.PanelName;
                break;
			case EnumActivityType.S_GOLD_EGG:
				name = ZaJinDanExt.PanelName;
				break;
			case EnumActivityType.S_BBGS:
                name = BuBuGaoShengMainExt.PanelName;
                break;
			case EnumActivityType.S_PAI_HANG:
				name = PaiHangMainExt.PanelName;
				break;
			case EnumActivityType.S_KUANG_HUAN:
                name = PaiHangBangExt.PanelName;
                break;
            case EnumActivityType.S_HE_TI:
                name = ShenJiangExt.PanelName;
                break;
			case EnumActivityType.S_NEW_SINGLE_RECHARGE:
			case EnumActivityType.S_SERIES_RECHARGE:
			case EnumActivityType.S_ADDUP_RECHARGE:
				name = LianXuChongZhiExt.PanelName;
				break;
        }
        return PanelClassDic[name];
    },

	//需要跳转的mainPanelKey
	GetGuideKeys:function(){
		if( this.Filter_Data )
			return this.Filter_Data[2];
		return [];
	},

	OpenGuidePanel:function (mainpanelkey, subpanelkey, onlySub) {
		onlySub = onlySub || false;
		var acs =  Mgr.dailyactivity.GetActivityByKey(mainpanelkey);
		var reqIds = [];
		for(var i = 0, len = acs.length; i < len; i++){
			var ac = acs[i];
			//打开一组的话 要排除掉双倍充值 因为不在一个面板
			if( !onlySub || ac.tabKey == subpanelkey )
				reqIds.push(ac.activityId);
		}
		Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds);
		if( !this._guideHash )
			this._guideHash = new HashMap();
		this._guideHash.Put(mainpanelkey, subpanelkey);
	},
	//取得要跳转到的子标签
	GetGuideSubKey:function(mainPanelKey){
		var subKey = 0;
		if( this._guideHash ){
			subKey = this._guideHash.Get(mainPanelKey);
			this._guideHash.Remove(mainPanelKey);
		}
		return subKey;
	},

	/**
	 * 获得面板内活动的标签并按标签分组
	 * @param mainPanelKey
	 * @returns {HashMap}
	 * @constructor
	 */
    GetHashByTabKey:function(mainPanelKey){
		var list = Mgr.dailyactivity.GetActivityByKey(mainPanelKey);
		return this.GetTabHashByKey( list, "tabKey" );
	},

    /**
     * 获得面板内活动的标签并按标签分组
     * @param mainPanelKey
     * @returns {HashMap}
     * @constructor
     */
    GetTabHashByKey:function(list, keyName){
        var hash = new HashMap();
        keyName = keyName || "tabKey";
        if( list ){
            var arr;
            var activity;
            for(var i = 0, len = list.length; i < len; i++){
                activity = list[i];
                arr = hash.Get(activity[keyName]);
                if(arr){
                    arr.push(activity);
                }else {
                    arr = [activity];
                    hash.Put(activity[keyName], arr);
                }
            }
        }
        return hash;
    },

    GetActivityBySubPanelType:function(mainKey,subPanelType){
        var list = Mgr.dailyactivity.GetActivityByKey(mainKey);
        var tabHash = this.GetTabHashByKey( list, "subPanelType" );

        return tabHash && tabHash.Get(subPanelType);
    },

	GetActivityList:function( mainKey, tabKey ){
		var tabHash = this.GetHashByTabKey(mainKey);
		if( tabHash )
			return tabHash.Get(tabKey);
		return null;
	},

	//过滤后的活动
	GetListByCorrelation:function (infoList) {
		var arr = [];
		for(var i = 0, len = infoList.length; i < len; i++){
			var info = infoList[i];
			var correlation = info.GetFlagValue(EnumActivityFlag.F_CORRELATION);
            if( !this.IsClearByCorrelation(correlation, infoList) && !this.IsOtherCorrelationClear(info, infoList) ){
                arr.push(info);
            }
		}
		return arr.sort(function (a, b) { return a.top - b.top;});
	},

	//根据显示条件进行过滤
    IsClearByCorrelation:function (correlation, list) {
		if(!correlation){
			return false;
		}
        correlation = parseInt(correlation);
		for(var i = 0, len = list.length; i < len; i++){
			var info = list[i];
			if(info.activityId == correlation){
                if( info.rewardTimes < info.allTimes ){
                    return true;
                }
				break;
			}
		}
		return false;
	},

	IsOtherCorrelationClear:function (info, list) {
        for(var i = 0, len = list.length; i < len; i++){
        	if(!list[i].GetFlagValue("correlation"))
        		continue;
            if(parseInt( list[i].GetFlagValue("correlation") ) == info.activityId ){
                if(info.rewardTimes >= info.allTimes){
                    return true;
                }
                break;
            }
        }
		return false;
	},
	SortByStatus:function(vo1, vo2){
		if( vo1.status == 0 ){
			return vo2.status - 0;
		}
		else if( vo1.status == 1 ){
			return -1;
		}
		else{
			return vo2.status == 1 ? 1 : -1;
		}
	},
	GetLimitList:function(list){
		var startIndex = 0;
		var endIndex = 0;
		for( var i = 0, len = list.length; i < len; i++ ){
			var vo = list[i];
			if( vo.GetFlagValue(EnumActivityFlag.F_LIMIT) != null ){
				if( vo.status == 0 ){
					startIndex = i+1;
				}
				else{
					endIndex = i;
					break;
				}
			}
		}
		return list.slice( startIndex, endIndex - startIndex + 1 );
	},
	ResetRewardStatus:function( vo ){
		switch (vo.subPanelType){
			case EnumActivityType.S_SINGLE_RECHARGE:
				vo.status = Mgr.dailyactivity.HasSingleRechargeReward(vo.activityId) ? 1 : 2;
				break;
		}
	},
	IsRewardStatus:function(group){
		if( !group )
			return false;
		for(var i = 0, len = group.length; i < len; i++){
			var ac = group[i];
			if(ac.status == 1){
				return true;
			}
		}
		return false;
	},

    //是否完成状态
    IsActivityFinishedStatus:function(key){
        var list = Mgr.dailyactivity.GetActivityByKey(key);
        if(!list) return true;

        for(var i = 0; i < list.length; i++){
            var v = list[i];
            if(v.status !== 0){
                return false;
            }
        }
        return true;
    },
	/**
	 * 一些条件过滤活动的处理
	 * @param arr
	 * @returns {boolean}
	 * @constructor
	 */
	IsFilterActivity:function( arr ){
		if( !arr || !arr.length )
			return true;
		var vo = arr[0];

        if(vo.mainPanelKey == EnumActivityKey.M_QYPH) return true; /// 情意绵绵
        if(vo.mainPanelKey == EnumActivityKey.M_QYMM) return true; /// 情意绵绵

		if( vo.mainPanelKey == EnumActivityKey.M_REAL_DOUBLE_RECHARGE || vo.mainPanelKey == EnumActivityKey.M_BBGS )
			return true;
		if( vo.mainPanelKey == EnumActivityKey.M_DOUBLE_RECHARGE && !ActivityUtil.IsActivityFinishedStatus(EnumActivityKey.M_SHOU_CHONG) )
			return true;
		return false;
	}
}