var LevelMainExt = LevelMain.extend ( {
	_className:"LevelMainExt",
    buttonList:null,
    cellPanel:null,
    cellList:null,
    totalNum:null,
	ctor:function(){
		this._super();
	},

    Init:function () {
        LevelMain.prototype.Init.call(this);
        this.buttonList = [];
        this.sbtnCue.visible = false;
    },

    SetData:function (info) {
        if(!info){
            return;
        }
        var self = this;
        var acs = this.SortACByThirdKey(info);
        for(var i = 0, len = acs.Keys().length; i < len; i++){
            var key = acs.Keys()[i];
            var group = acs.Get(key);
            var button = new MUICheckBox();
            button.detail = group;
            button.ParseJson(this.sbtnCue.jsonobj);
            button.Init();
            button.setTouchEnabled(true);
            button.SetText(group[0].thirdPanelName);
            button.addClickEventListener(function (target) {
                self.ResetButtonState(target);
                self.InitCell(target.detail);
            });
            this.addChild(button);
            this.buttonList.push(button);
        }
        this.InitButtonState();
        this.InitCell(acs.Get(acs.Keys()[0]));
    },

    SortACByThirdKey:function (info) {
        var ac = new HashMap();
        var arr;
        var activity;
        for(var i = 0, len = info.length; i < len; i++){
            activity = info[i];
            arr = ac.Get(activity.thirdPanelKey);
            if(arr){
                arr.push(activity);
            }else {
                arr = [activity];
                ac.Put(activity.thirdPanelKey, arr);
            }
        }
        return ac;
    },

    InitCell:function (info) {
        if(!this.cellPanel){
            var tableView = new cc.TableView(this,cc.size(this.imgBg1.uiWidth, this.imgBg1.uiHeight));
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.uiWidth=this.imgBg1.uiWidth;
            tableView.uiHeight=this.imgBg1.uiHeight;
            this.cellPanel=tableView;
            this.imgBg1.addChild(tableView);
        }

        this.cellList = ActivityUtil.GetListByCorrelation(info);
        this.totalNum = this.cellList.length;
        this.cellPanel.reloadData();
    },

    InitButtonState:function () {
        for(var i = 0, len = this.buttonList.length; i < len; i++){
            var button = this.buttonList[i];
            if(i == 0){
                button.SetButtonState("check");
            }else {
                button.SetButtonState("uncheck");
            }
            button.x = this.sbtnCue.x + this.sbtnCue.uiWidth * i;
            button.y = this.sbtnCue.y;
        }
    },

    ResetButtonState:function (button) {
      for(var i = 0, len = this.buttonList.length; i < len; i++){
          var btn = this.buttonList[i];
          if(btn == button){
              btn.SetButtonState("check");
          }else {
              btn.SetButtonState("uncheck");
          }
      }
    },

    tableCellSizeForIndex: function (table, idx) {
        return cc.size(805,150);
    },
    tableCellAtIndex: function (table, idx) {
        var item;
        var ac = this.cellList[idx];
        var cell = table.dequeueCell();
        if (!cell) {
            cell=cc.Sprite();
            item = new LevelListExt();
            item.LoadPanel();
            item.SetData(ac);
            item.setTouchEnabled(false);
            cell.item = item;
            item.x = -4;
            cell.addChild(item);
        }
        cell.item.SetData(ac);
        return cell;
    },
    numberOfCellsInTableView: function (table) {
        return this.totalNum;
    }
} );
LevelMainExt.PanelName = "LevelMainExt";
PanelClassDic["LevelMainExt"] = LevelMainExt;
