///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//136201,ReqDazuo 单人打座  或者取消打座
//136202,ReqShuangXiu 请求双修
//136203,ReqAgreeShuangXiu 同意其他玩家的双修申请
//136204,ReqRefuseShuangXiu 拒绝其他玩家的双修申请

// 接收消息
//136101,ResDazuoStateChange 打座状态变化 发给自己
//136102,ResDazuoStateBroadCast 以两个玩家为中心点进行 打座状态变化  广播
//136103,ResDazuoErupt 打座收益
//136104,ResShuangXiuApply 双修请求


////////////////////
// 打座状态变化 发给自己 //
////////////////////
var ResDazuoStateChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0未打座  1单人  2与玩家双修
        this.otherid = null; // 双修对象ID
        this.otherx = 0; // 双修对象坐标X
        this.othery = 0; // 双修对象坐标Y
        this.startTime = null; // 打座开始时间
	},

	getId:function(){
		return 136101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.state);
        _buf.WriteLong(this.otherid);
        _buf.WriteShort(this.otherx);
        _buf.WriteShort(this.othery);
        _buf.WriteLong(this.startTime);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadByte();
        this.otherid = _buf.ReadLong();
        this.otherx = _buf.ReadShort();
        this.othery = _buf.ReadShort();
        this.startTime = _buf.ReadLong();
	},

	action:function(){
		Mgr.dazuo.RecvResDazuoStateChangeMessage(this);
	},

});
////////////////////
// 以两个玩家为中心点进行 打座状态变化  广播 //
////////////////////
var ResDazuoStateBroadCastMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0未打座  1单人  2与玩家双修
        this.roleAId = null; // 双修玩家A
        this.roleAX = 0; // 双修玩家AX
        this.roleAY = 0; // 双修玩家AY
        this.roleBId = null; // 双修玩家B 如果不是与玩家双修 则只发A
        this.roleBX = 0; // 双修玩家BX
        this.roleBY = 0; // 双修玩家BY
	},

	getId:function(){
		return 136102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.state);
        _buf.WriteLong(this.roleAId);
        _buf.WriteShort(this.roleAX);
        _buf.WriteShort(this.roleAY);
        _buf.WriteLong(this.roleBId);
        _buf.WriteShort(this.roleBX);
        _buf.WriteShort(this.roleBY);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadByte();
        this.roleAId = _buf.ReadLong();
        this.roleAX = _buf.ReadShort();
        this.roleAY = _buf.ReadShort();
        this.roleBId = _buf.ReadLong();
        this.roleBX = _buf.ReadShort();
        this.roleBY = _buf.ReadShort();
	},

	action:function(){
		Mgr.dazuo.RecvResDazuoStateBroadCastMessage(this);
	},

});
////////////////////
// 打座收益 //
////////////////////
var ResDazuoEruptMessage = cc.Class.extend( {
	ctor:function(){
		this.duration = 0; // 打座持续时间
        this.dazuoexp = 0; // 打坐获得经验
        this.isCrit = 0; // 本次是否是暴击(1是暴击0不是)
	},

	getId:function(){
		return 136103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.duration);
        _buf.WriteVarInt(this.dazuoexp);
        _buf.WriteVarInt(this.isCrit);
	},
	
	reading:function( _buf ){
        this.duration = _buf.ReadVarInt();
        this.dazuoexp = _buf.ReadVarInt();
        this.isCrit = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.dazuo.RecvResDazuoEruptMessage(this);
	},

});
////////////////////
// 双修请求 //
////////////////////
var ResShuangXiuApplyMessage = cc.Class.extend( {
	ctor:function(){
		this.role = null; // 玩家ID
	},

	getId:function(){
		return 136104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.role);
	},
	
	reading:function( _buf ){
        this.role = _buf.ReadLong();
	},

	action:function(){
		Mgr.dazuo.RecvResShuangXiuApplyMessage(this);
	},

});
////////////////////
// 单人打座  或者取消打座 //
////////////////////
var ReqDazuoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 136201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求双修 //
////////////////////
var ReqShuangXiuMessage = cc.Class.extend( {
	ctor:function(){
		this.role = null; // 玩家ID
	},

	getId:function(){
		return 136202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.role);
	},
	
	reading:function( _buf ){
        this.role = _buf.ReadLong();
	},

});
////////////////////
// 同意其他玩家的双修申请 //
////////////////////
var ReqAgreeShuangXiuMessage = cc.Class.extend( {
	ctor:function(){
		this.otherRoleId = null; // 他人ID
	},

	getId:function(){
		return 136203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.otherRoleId);
	},
	
	reading:function( _buf ){
        this.otherRoleId = _buf.ReadLong();
	},

});
////////////////////
// 拒绝其他玩家的双修申请 //
////////////////////
var ReqRefuseShuangXiuMessage = cc.Class.extend( {
	ctor:function(){
		this.otherRoleId = null; // 他人ID
	},

	getId:function(){
		return 136204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.otherRoleId);
	},
	
	reading:function( _buf ){
        this.otherRoleId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(136101, ResDazuoStateChangeMessage);
MESSAGE_POOL.Add(136102, ResDazuoStateBroadCastMessage);
MESSAGE_POOL.Add(136103, ResDazuoEruptMessage);
MESSAGE_POOL.Add(136104, ResShuangXiuApplyMessage);

