///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//EquipDazzlingInfo 装备部位耀晶信息

// 请求消息
//240201,ReqEquipDazzlingInfoToGame 请求装备耀晶信息
//240202,ReqEquipDazzlingChangeToGame 请求装备耀晶打造

// 接收消息
//240101,ResEquipDazzlingAllInfoToClient 发送所有装备耀晶信息 
//240102,ResEquipDazzlingInfoToClient 发送单个装备耀晶数据信息 


var EquipDazzlingInfo = cc.Class.extend({
	ctor:function(){
		this.equipType = 0; // 装备类型(对应的ItemTypeConst)
        this.equipLocation = 0; // 装备部位(子类型)
        this.dazzlingLevel = 0; // 装备部位耀晶等级
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.equipType);
        _buf.WriteVarInt(this.equipLocation);
        _buf.WriteVarInt(this.dazzlingLevel);
	},
	
	reading:function( _buf ){
		this.equipType = _buf.ReadVarInt();
        this.equipLocation = _buf.ReadVarInt();
        this.dazzlingLevel = _buf.ReadVarInt();
	},
});
////////////////////
// 发送所有装备耀晶信息  //
////////////////////
var ResEquipDazzlingAllInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.dazzlingInfos = []; // 装备耀晶基本数据信息 EquipDazzlingInfo
	},

	getId:function(){
		return 240101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.dazzlingInfos.length );
        for (var i = 0; i < this.dazzlingInfos.length; i++) {
            _buf.WriteBean(this.dazzlingInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var dazzlingInfos_length = _buf.ReadShort();
        for (var i = 0; i < dazzlingInfos_length; i++) {
            this.dazzlingInfos[i] = _buf.ReadBean(EquipDazzlingInfo);
        }
	},

	action:function(){
		Mgr.dazzling.RecvResEquipDazzlingAllInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个装备耀晶数据信息  //
////////////////////
var ResEquipDazzlingInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.equipType = 0; // 装备类型(对应的ItemTypeConst)
        this.equipDazzlingInfo = null; // 装备耀晶信息
	},

	getId:function(){
		return 240102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.equipType);
        _buf.WriteBean(this.equipDazzlingInfo);
	},
	
	reading:function( _buf ){
        this.equipType = _buf.ReadVarInt();
        this.equipDazzlingInfo = _buf.ReadBean(EquipDazzlingInfo);
	},

	action:function(){
		Mgr.dazzling.RecvResEquipDazzlingInfoToClientMessage(this);
	},

});
////////////////////
// 请求装备耀晶信息 //
////////////////////
var ReqEquipDazzlingInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.equipType = 0; // 装备类型(对应的ItemTypeConst)(0请求所有的)
	},

	getId:function(){
		return 240201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.equipType);
	},
	
	reading:function( _buf ){
        this.equipType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求装备耀晶打造 //
////////////////////
var ReqEquipDazzlingChangeToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.equipType = 0; // 装备类型(对应的ItemTypeConst)
        this.equipLocation = 0; // 装备子类型
        this.mainItemId = null; // 升级的装备id
        this.itemIds = []; // 消耗道具唯一ID long
	},

	getId:function(){
		return 240202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.equipType);
        _buf.WriteVarInt(this.equipLocation);
        _buf.WriteLong(this.mainItemId);
        _buf.WriteShort( this.itemIds.length );
        for (var i = 0; i < this.itemIds.length; i++) {
            _buf.WriteLong(this.itemIds[i]);
        }
	},
	
	reading:function( _buf ){
        this.equipType = _buf.ReadVarInt();
        this.equipLocation = _buf.ReadVarInt();
        this.mainItemId = _buf.ReadLong();
        var itemIds_length = _buf.ReadShort();
        for (var i = 0; i < itemIds_length; i++) {
            this.itemIds[i] = _buf.ReadLong();
        }
	},

});
// 接收消息注册
MESSAGE_POOL.Add(240101, ResEquipDazzlingAllInfoToClientMessage);
MESSAGE_POOL.Add(240102, ResEquipDazzlingInfoToClientMessage);

