///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//DisguiseInfo 易容单个信息
//DisguiseDataInfo 易容基本数据信息

// 请求消息
//236201,ReqDisguiseDataInfoToGame 请求易 容信息
//236202,ReqUseDisguiseToGame 请求使用这个 易容展示
//236203,ReqAddDisguiseToGame 请求激活这 个易容
//236204,ReqDisguiseUpToGame 请求升星和突 破这个易容
//236205,ReqDisguiseAdvanceUpToGame 请求升阶 这个易容
//236206,ReqAddDisguiseBySuitRankToGame 请求激活这 个易容(集齐了装备品质套装)
//236207,ReqDisguiseEquipSetToGame 穿戴装备
//236208,ReqDisguiseEquipClearToGame 卸下装备

// 接收消息
//236101,ResDisguiseDataInfoToClient 发送易容数据信息 
//236102,ResAddDisguiseToClient 发送激活易容信息 
//236103,ResChangeDisguiseToClient 发送切换 易容信息（广播） 
//236104,ResDisguiseInfoToClient 发送单个易容数据信息 
//236105,ResDisguiseUpResultToClient 发送升星和突 破和升阶易容结果
//236106,ResDisguiseEquipChangeToClient 易容装备改变


var DisguiseInfo = cc.Class.extend({
	ctor:function(){
		this.skillInfo = null; // 已获得技能信息
        this.disguiseId = 0; // 易容ID 
        this.disguiseUp = 0; // 当前星图阶数
        this.disguiseStar = 0; // 当前星数
        this.disguiseAdvanceUp = 0; // 当前 阶数
        this.equips = []; // 装备列表(2个格子) ItemInfo
	},

	writing:function( _buf ){
		_buf.WriteBean(this.skillInfo);
        _buf.WriteVarInt(this.disguiseId);
        _buf.WriteVarInt(this.disguiseUp);
        _buf.WriteVarInt(this.disguiseStar);
        _buf.WriteVarInt(this.disguiseAdvanceUp);
        _buf.WriteShort( this.equips.length );
        for (var i = 0; i < this.equips.length; i++) {
            _buf.WriteBean(this.equips[i]);
        }
	},
	
	reading:function( _buf ){
		this.skillInfo = _buf.ReadBean(SkillInfo);
        this.disguiseId = _buf.ReadVarInt();
        this.disguiseUp = _buf.ReadVarInt();
        this.disguiseStar = _buf.ReadVarInt();
        this.disguiseAdvanceUp = _buf.ReadVarInt();
        var equips_length = _buf.ReadShort();
        for (var i = 0; i < equips_length; i++) {
            this.equips[i] = _buf.ReadBean(ItemInfo);
        }
	},
});
var DisguiseDataInfo = cc.Class.extend({
	ctor:function(){
		this.useDisguiseId = 0; // 当前展示易容ID 
        this.disguiseInfoList = []; // 已激活的 易容数据 DisguiseInfo
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.useDisguiseId);
        _buf.WriteShort( this.disguiseInfoList.length );
        for (var i = 0; i < this.disguiseInfoList.length; i++) {
            _buf.WriteBean(this.disguiseInfoList[i]);
        }
	},
	
	reading:function( _buf ){
		this.useDisguiseId = _buf.ReadVarInt();
        var disguiseInfoList_length = _buf.ReadShort();
        for (var i = 0; i < disguiseInfoList_length; i++) {
            this.disguiseInfoList[i] = _buf.ReadBean(DisguiseInfo);
        }
	},
});
////////////////////
// 发送易容数据信息  //
////////////////////
var ResDisguiseDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseDataInfo = null; // 易容基本 数据信息
	},

	getId:function(){
		return 236101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.disguiseDataInfo);
	},
	
	reading:function( _buf ){
        this.disguiseDataInfo = _buf.ReadBean(DisguiseDataInfo);
	},

	action:function(){
		Mgr.disguise.RecvResDisguiseDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送激活易容信息  //
////////////////////
var ResAddDisguiseToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 激活的 易容ID
	},

	getId:function(){
		return 236102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.disguise.RecvResAddDisguiseToClientMessage(this);
	},

});
////////////////////
// 发送切换 易容信息（广播）  //
////////////////////
var ResChangeDisguiseToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
        this.playerId = null; // 玩家ID
	},

	getId:function(){
		return 236103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
        _buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
	},

	action:function(){
		Mgr.disguise.RecvResChangeDisguiseToClientMessage(this);
	},

});
////////////////////
// 发送单个易容数据信息  //
////////////////////
var ResDisguiseInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseInfo = null; // 单个易容  数据信息
	},

	getId:function(){
		return 236104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.disguiseInfo);
	},
	
	reading:function( _buf ){
        this.disguiseInfo = _buf.ReadBean(DisguiseInfo);
	},

	action:function(){
		Mgr.disguise.RecvResDisguiseInfoToClientMessage(this);
	},

});
////////////////////
// 发送升星和突 破和升阶易容结果 //
////////////////////
var ResDisguiseUpResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
        this.type = 0; // 操作类型（0是升星1是突破2是升阶）
        this.result = 0; // 操作结果(0是成功1是失败)
	},

	getId:function(){
		return 236105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.result);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.disguise.RecvResDisguiseUpResultToClientMessage(this);
	},

});
////////////////////
// 易容装备改变 //
////////////////////
var ResDisguiseEquipChangeToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
        this.type = 0; // 操作类型(0穿戴1脱下)
        this.pos = 0; // 位置(0到1)
        this.equipInfo = null; // 装备信息
	},

	getId:function(){
		return 236106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.pos);
        _buf.WriteBean(this.equipInfo);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
        this.pos = _buf.ReadVarInt();
        this.equipInfo = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.disguise.RecvResDisguiseEquipChangeToClientMessage(this);
	},

});
////////////////////
// 请求易 容信息 //
////////////////////
var ReqDisguiseDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID（0表示请求所有）
	},

	getId:function(){
		return 236201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求使用这个 易容展示 //
////////////////////
var ReqUseDisguiseToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID（0表示脱下）
	},

	getId:function(){
		return 236202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求激活这 个易容 //
////////////////////
var ReqAddDisguiseToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
	},

	getId:function(){
		return 236203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求升星和突 破这个易容 //
////////////////////
var ReqDisguiseUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
	},

	getId:function(){
		return 236204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求升阶 这个易容 //
////////////////////
var ReqDisguiseAdvanceUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
	},

	getId:function(){
		return 236205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求激活这 个易容(集齐了装备品质套装) //
////////////////////
var ReqAddDisguiseBySuitRankToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
	},

	getId:function(){
		return 236206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
	},

});
////////////////////
// 穿戴装备 //
////////////////////
var ReqDisguiseEquipSetToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
        this.pos = 0; // 位置(0到1)
        this.itemmodelid = null; // 要穿戴的装备唯一ID
	},

	getId:function(){
		return 236207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
        _buf.WriteByte(this.pos);
        _buf.WriteLong(this.itemmodelid);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
        this.pos = _buf.ReadByte();
        this.itemmodelid = _buf.ReadLong();
	},

});
////////////////////
// 卸下装备 //
////////////////////
var ReqDisguiseEquipClearToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.disguiseId = 0; // 易容ID
        this.pos = 0; // 位置(0到1))
	},

	getId:function(){
		return 236208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.disguiseId);
        _buf.WriteByte(this.pos);
	},
	
	reading:function( _buf ){
        this.disguiseId = _buf.ReadVarInt();
        this.pos = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(236101, ResDisguiseDataInfoToClientMessage);
MESSAGE_POOL.Add(236102, ResAddDisguiseToClientMessage);
MESSAGE_POOL.Add(236103, ResChangeDisguiseToClientMessage);
MESSAGE_POOL.Add(236104, ResDisguiseInfoToClientMessage);
MESSAGE_POOL.Add(236105, ResDisguiseUpResultToClientMessage);
MESSAGE_POOL.Add(236106, ResDisguiseEquipChangeToClientMessage);

