///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//RollItemInfo Roll点物品信息

// 请求消息
//210201,ReqRollPoint 请求Roll点
//210202,ReqTodayDropCountInfo 请求今日野外掉落信息

// 接收消息
//210101,ResDropRollItemInfo 发送Roll点物品信息
//210102,ResRollPointResult 发送Roll点结果给玩家
//210103,ResRollItemMaxPointInfo 发送Roll点最大的玩家信（广播）
//210104,ResDropBackpackToClient 掉落道具进包裹
//210105,ResTodayDropCountInfoToClient 发送今日野外掉落信息


var RollItemInfo = cc.Class.extend({
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.type = 0; // 0原先的roll点 1是新roll点
        this.tempItemInfo = null; // 物品信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteVarInt(this.type);
        _buf.WriteBean(this.tempItemInfo);
	},
	
	reading:function( _buf ){
		this.uniqueId = _buf.ReadLong();
        this.type = _buf.ReadVarInt();
        this.tempItemInfo = _buf.ReadBean(TempItemInfo);
	},
});
////////////////////
// 发送Roll点物品信息 //
////////////////////
var ResDropRollItemInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.rollInfo = null; // Roll点物品信息
	},

	getId:function(){
		return 210101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.rollInfo);
	},
	
	reading:function( _buf ){
        this.rollInfo = _buf.ReadBean(RollItemInfo);
	},

	action:function(){
		Mgr.drop.RecvResDropRollItemInfoMessage(this);
	},

});
////////////////////
// 发送Roll点结果给玩家 //
////////////////////
var ResRollPointResultMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.type = 0; //  type 0需求 1贪婪 2弃权
        this.point = 0; // 点数
	},

	getId:function(){
		return 210102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.point);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
        this.type = _buf.ReadByte();
        this.point = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.drop.RecvResRollPointResultMessage(this);
	},

});
////////////////////
// 发送Roll点最大的玩家信（广播） //
////////////////////
var ResRollItemMaxPointInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.playername = null; // 玩家名
        this.point = 0; // 点数
	},

	getId:function(){
		return 210103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteString(this.playername);
        _buf.WriteVarInt(this.point);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
        this.playername = _buf.ReadString();
        this.point = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.drop.RecvResRollItemMaxPointInfoMessage(this);
	},

});
////////////////////
// 掉落道具进包裹 //
////////////////////
var ResDropBackpackToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
        this.mapModelid = 0; // 地图模组ID
        this.simpleItemInfos = []; // 奖励列表 SimpleItemInfo
	},

	getId:function(){
		return 210104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.mapModelid);
        _buf.WriteShort( this.simpleItemInfos.length );
        for (var i = 0; i < this.simpleItemInfos.length; i++) {
            _buf.WriteBean(this.simpleItemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
        this.mapModelid = _buf.ReadVarInt();
        var simpleItemInfos_length = _buf.ReadShort();
        for (var i = 0; i < simpleItemInfos_length; i++) {
            this.simpleItemInfos[i] = _buf.ReadBean(SimpleItemInfo);
        }
	},

	action:function(){
		Mgr.drop.RecvResDropBackpackToClientMessage(this);
	},

});
////////////////////
// 发送今日野外掉落信息 //
////////////////////
var ResTodayDropCountInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.dropItemInfos = []; // 掉落道具列表 SimpleItemInfo
	},

	getId:function(){
		return 210105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.dropItemInfos.length );
        for (var i = 0; i < this.dropItemInfos.length; i++) {
            _buf.WriteBean(this.dropItemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var dropItemInfos_length = _buf.ReadShort();
        for (var i = 0; i < dropItemInfos_length; i++) {
            this.dropItemInfos[i] = _buf.ReadBean(SimpleItemInfo);
        }
	},

	action:function(){
		Mgr.drop.RecvResTodayDropCountInfoToClientMessage(this);
	},

});
////////////////////
// 请求Roll点 //
////////////////////
var ReqRollPointMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.type = 0; //  type 0需求 1贪婪 2弃权
	},

	getId:function(){
		return 210201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求今日野外掉落信息 //
////////////////////
var ReqTodayDropCountInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 210202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(210101, ResDropRollItemInfoMessage);
MESSAGE_POOL.Add(210102, ResRollPointResultMessage);
MESSAGE_POOL.Add(210103, ResRollItemMaxPointInfoMessage);
MESSAGE_POOL.Add(210104, ResDropBackpackToClientMessage);
MESSAGE_POOL.Add(210105, ResTodayDropCountInfoToClientMessage);

