var DuanzaoPanelExt = DuanzaoPanel.extend ( {
    _className:"DuanzaoPanelExt",

    ctor:function(){
        this._super();
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.layoutCom.layoutOffy = -28;
        this._btnArr = [];
        this.showType = DuanzaoTypeEnum.EQUIP_UP;

        this.panelMgr = {};
    },

    Init:function() {
        this._super();

         this.SetPendantMovie(this.imgJian);

        this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));

        this._btnTabArr = [
            { btn : this.sbtnRole,	type : EnumItemType.Equip,	warn: this.imgWarn,	lab : this.labRole },
        ];

        var config = this.InitTabConfig();
        this.InitTabWithConfig(config);
    },

    InitMarkCondition:function(){
        return DuanzaoUtil.IsMarkBySubType.apply(DuanzaoUtil,arguments)
    },

    InitTabConfig:function(){
        return config = [
            { text : "装备强化",	type : DuanzaoTypeEnum.EQUIP_UP,			panelName: QianhuaMainExt.PanelName},	// 装备强化
            { text : "宝石镶嵌",	type : DuanzaoTypeEnum.EQUIP_INLAY, 		panelName: XiangqianMainExt.PanelName},	// 宝石镶嵌
            //{ text : "宝石合成",	type : DuanzaoTypeEnum.EQUIP_COMPOSE,		panelName: HechengMainExt.PanelName},	// 宝石合成
            { text : "合成",	type : DuanzaoTypeEnum.EQUIP_COMPOSE_NEW, 	panelName: HechengMainExt.PanelName},	// 装备合成
            { text : "熔炼",		type : DuanzaoTypeEnum.EQUIP_MELTING, 		panelName: RonglianMainExt.PanelName},	// 熔炼
            { text : "装备精炼",	type : DuanzaoTypeEnum.EQUIP_REFINE, 		panelName: JinglianMainExt.PanelName},	// 装备精炼
            { text : "神装套装",	type : DuanzaoTypeEnum.EQUIP_SUIT,		panelName: SuitMakePanelExt.PanelName},

        ];
    },

    InitTabWithConfig:function(config){
        var imgQianghua = this.imgQianghua;
        config.forEach((v,k)=>{
            let btn = k === 0 ? imgQianghua : null;

            if(!btn){
                btn = UIUtil.CloneUI(imgQianghua);
                imgQianghua.parent.addChild(btn);
            }else{
                btn.imgTanhao = this.imgTanhao;
            }
            btn.SetText( v.text );
            btn.addClickEventListener(this.ChangePanel.bind(this,v.type));

            v.btn = btn;
            v.warn = btn.imgTanhao;
        })

        this._btnArr = config;
    },

    InitSubTabWithConfig:function(config){
        this._btnTabArr.forEach(v=>v.btn.visible=false);

        var sbtnRole = this.sbtnRole;

        var initY = this._btnTabArr[0].btn.y + this._btnTabArr[0].btn.uiHeight;

        config = config;
        config.forEach((v,k)=>{
            let btnC = this._btnTabArr[k];
            if(!btnC){
                btnC = {};
                btnC.btn = UIUtil.CloneUI(sbtnRole);
                btnC.warn = btnC.btn.imgWarn;
                btnC.lab = btnC.btn.labRole;
                sbtnRole.parent.addChild(btnC.btn,-1);
                this._btnTabArr.push(btnC);
            }

            btnC.type = v.type;
            btnC.lab.SetText(v.text.split("").join("\n"));
            // 按钮大小适配
            let height = Math.max(89,btnC.lab.GetTextHeight() + 30);
            btnC.btn.SetContentSize(btnC.btn.uiWidth,height);
            // 文本位置适配
            btnC.lab.y = 68 +  height - 89 - btnC.lab.uiHeight;
            btnC.warn.y = 90 +  height - 89 - btnC.warn.uiHeight;

            btnC.btn.addClickEventListener(this.OnSubTabChanged.bind(this,v.type));
            btnC.btn.visible = true;

            initY -= btnC.btn.uiHeight;
            btnC.btn.y = initY;
        })
    },

    OnSubTabChanged:function(type){
        this._btnTabArr.forEach(function(v){
            if(!v.btn.visible) return;
            v.btn.SetButtonState(v.type == type?"check":"uncheck");
        })

        this.selectedItemType = type;

        let curPanel = this._curPanel;
        if(curPanel && curPanel.SetData) curPanel.SetData(type);
    },

    OnShow:function () {
        this._super();

        this.OnCheckTabOpened();

        this.ChangePanel(this.selectedDuanzaoType);

        this.UpdateWarn();
    },
    OnHide:function()
    {
        this._super();
        var curPanel = this._curPanel;
        if(curPanel){
            curPanel.visible = false;
            if(curPanel.OnHide) curPanel.OnHide();
        }
    },
    OnCheckTabOpened:function(){
        var initX = this._btnArr[0].btn.x;
        this._btnArr.forEach(function(v){
            var ret = DuanzaoUtil.CheckDuanzaoFuncOpenWithType(v.type);
            v.btn.visible = ret;
            if(ret){
                v.btn.x = initX;
                initX += 160;
            }
        });
    },

    ChangePanel:function(type){
        // 判断开放则重选
        var btnC = this._btnArr.find(v=>v.type == type);
        if(!(btnC && btnC.btn.visible)){
            btnC = this._btnArr.find(v=>v.btn.visible);
            type = btnC && btnC.type;
        }

        this.selectedDuanzaoType = type;

        this._btnArr.forEach(function(v){
            v.btn.SetButtonState(v.type == type?"check":"uncheck");
        })

        // 中间内容
        var curPanel = this._curPanel;
        if(curPanel){
            curPanel.visible = false;
            if(curPanel.OnHide) curPanel.OnHide();
        }

        var config = this._btnArr.find(function(v){
            return v.type == type;
        });

        if(config){
            if ( !this.panelMgr[type] ) {
                var panel = new PanelClassDic[config.panelName]();
                panel.LoadPanel();
                panel.x = config.x || 0;
                panel.y = config.y || 0;
                this.imgTitleBg.addChild(panel);
                this.panelMgr[type] = panel;
            }
            curPanel = this.panelMgr[type];
        }

        if(curPanel){
            this._curPanel = curPanel;
            curPanel.visible = true;

            // 二级接口
            let subTabType = null;
            do{
                let config = curPanel.InitSubTabConfig && curPanel.InitSubTabConfig() || [];
                this.InitSubTabWithConfig(config);
                if(!config.length) break;

                let conf = config.find(v=>v.type == this.selectedItemType);
                subTabType = conf ? conf.type : config[0].type;
            }while(false);

            this.OnSubTabChanged(subTabType);
            this.UpdateSecondWarn();

            if(curPanel.OnShow) curPanel.OnShow();
        }
    },

    UpdataWarn:function(){
        this.UpdateWarn()
    },
    /// 更新提醒
    UpdateWarn:function(){
        this._btnArr.forEach(v=>{
            if(!v.btn.visible) return;
            v.warn.visible = this.InitMarkCondition(v.type);
        });
        this.UpdateSecondWarn();
    },

    UpdateSecondWarn:function(){
        this._btnTabArr.forEach(v=>{
            if(!v.btn.visible) return;
            v.warn.visible = this.InitMarkCondition(this.selectedDuanzaoType,v.type)
        })
    },
} );
DuanzaoPanelExt.PanelName = "DuanzaoPanelExt";
PanelClassDic["DuanzaoPanelExt"] = DuanzaoPanelExt;
