var NewFuncCueExt = NewFuncCue.extend({
    _className: "NewFuncCueExt",
    _autoTimeId: -1,
    _model: null,
    _effectUrl: 0,
    _disguiseId:0,

    ctor: function() {
        this._super();
        this.modelPanelType = MUIPanelModelType.ALPHABLACK;
    },

    Init: function() {
        NewSkillCue.prototype.Init.call(this);

        var self = this;

        this.btnGet.addClickEventListener(function() {
            self.OnGetHandler();
        });
    },

    OnGetHandler: function() {
        EngineMgr.uiMgr.HidePanelByType(NewFuncCueExt.PanelName);
    },

    OnShow: function() {
        this._super();
        Mgr.task.StopAutoTask();
    },

    OnHide: function() {
        this._super();
        TimerUtil.ClearTimeout(this._autoTimeId);
        this._autoTimeId = -1;
        Mgr.task.StartAutoTask();
        if( this._model )
            this._model.Dispose();
        this._model = null;
        if( this._disguiseId ){
            Mgr.disguise.newDisguiseId = this._disguiseId;
            Mgr.uiMgr.ShowPanelByType( YiRongPanelExt.PanelName );
            this._disguiseId = 0;
            Mgr.disguise.newDisguiseId = this._disguiseId;
        }
    },
    UpdateView: function(main, sub, model) {
        var self = this;
        this._autoTimeId = TimerUtil.SetTimeout(this, this.OnGetHandler, 20000);
        this.labCue.SetString(model.q_info);

        var str = model.q_img_url.split(";");
        var modelId = str[2];

        if (this._model)
            this._model.Dispose();

        var actionKey = "stand";
        this._model = new MAnimationObject();
        if( main == BtnGroupUtil.M_ROLE && ( sub == BtnGroupUtil.ROLE_GUANGWU || sub == BtnGroupUtil.ROLE_WUXUE || sub == BtnGroupUtil.ROLE_DRAGON || sub == BtnGroupUtil.ROLE_ARMOR) )
            actionKey = "stand5";

        this._model.x = this.imgModel.width / 2;

        if( main == BtnGroupUtil.M_ROLE && sub == BtnGroupUtil.ROLE_RIDE ){
            this._effectUrl = SceneObjUtil.GetUIModelUrl( 1, EnumResline.HORSE );
            this._model.y = 50;
        }
        else if( main == BtnGroupUtil.M_SHUTONG && sub == BtnGroupUtil.SHUTONG_SHUTONG ){
            this._effectUrl = SceneObjUtil.GetUIModelUrl( 1, EnumResline.SHUTONG );
        }
        else if (main == BtnGroupUtil.M_SHORTCUT && sub == BtnGroupUtil.SHORT_DISGUISE) {
            this._effectUrl = "res/animation/effect/ui/roleshow/player/" + modelId.toString();
        } else {
            this._effectUrl = "res/animation/effect/ui/roleshow/ui/part/" + modelId.toString();
        }

        this._model.SetResUrlBase(this._effectUrl);
        this._model.DoAction(actionKey);
        this.imgModel.addChild(this._model);
        if( modelId == 9 )  //坐骑
            modelId = 1;
        if( modelId == 1 || modelId == 2 || modelId == 5 )
            Mgr.gameSoundMgr.PlaySound("obtain" + modelId, SoundType.UI);
    },

    ShowDisguise:function(disguiseId){
        if (this._model)
            this._model.Dispose();

        this._disguiseId = disguiseId;
        var data = Q_disguise.Get(disguiseId);
        if( data ){
            this._model = new MAnimationObject();
            this._model.x = this.imgModel.width / 2;
            this._effectUrl = "res/animation/effect/ui/roleshow/player/" + data.q_show.toString();
            this._model.SetResUrlBase(this._effectUrl);
            this._model.DoAction("stand");
            this.imgModel.addChild(this._model);
            this.labCue.SetString(this.labCue.GetHtmlText());
        }
    }
});
NewFuncCueExt.PanelName = "NewFuncCueExt";
PanelClassDic["NewFuncCueExt"] = NewFuncCueExt;