﻿/**
 * 物品信息类
 */
var Item = cc.Class.extend({
	/**物品Id**/
	itemId:null,
	/**物品模板Id**/
	itemModelId: 0,
	/**默认品阶**/
	_itemDefault: 0,
	/**数量**/
	itemNum: 0,
	/**物品绑定 0,1 未绑定/绑定**/
	itemBind: 0,
	/**格子Id**/
	_gridId: 0,
	/**过期时刻**/
	_overdueTime:0,
	/**过期时刻字符串**/
	_overdueTimeStr:"",
	/**过期剩余秒**/
	_overdueSec :0,
	/**冷却*/
	_coolDownTime:-1,
	/**是否被锁定**/
	_itemislocked : false,
	/**物品强化等级*/
	_itemLevel :0,
	/**万能强化等级*/
	_itemExtLevel:0,
	/**物品对应职业*/
	_job :0,
	/**进阶等级*/
	_advancedLv : 0,
	/**传说等级（传说1 银河2）*/
	_csLv:0,
	/**转生等级*/
	_reinLv:0,
	/**所有者名*/
	_ownname:"",
	/**物品附加属性AttributeInfo*/
	_itemAttributes:null,
	/**物品附加条数*/
	_itemAppendNum:0,
	/**储存经验*/
	_itemExp:0,
	/**白装是否显示成最高品质*/
	_isShowHighQt:false,
	/**显示品质*/
	_showQuality:-1,
	/**装备位置*/
	_equipPosType:0,
	/**拓展参数*/
	_parameters:null,
	/**所属面板Id**/
	_packageId: 0,
	/** 是否模糊属性**/
	isBlurPpt:false,
	/** 物品数量是否使用美术字**/
	isNumPic:false,

	/**是否在格子中展示奖励**/
	isShowTips:true,
	//attBlessValue:HashMap = new HashMap(),
	/**帮会仓库捐献者名字*/
	guildDonatePlayerName:"",
	/** 悬赏任务已经收集经验*/
	postTaskCurExp :0,
	/** 悬赏任务需要收集经验*/
	postTaskMaxExp :0,

	CopyItemClone:function (newitem)
	{
		if (newitem != null)
		{
			newitem.itemId = ( this.itemId == null ? null : this.itemId.clone() );
			newitem._itemModelId = this._itemModelId;
			newitem._itemDefault = this._itemDefault;
			newitem._itemNum = this._itemNum;
			newitem._itemBind = this._itemBind;
			newitem._gridId = this._gridId;
			newitem._overdueTime = this._overdueTime;
			newitem._overdueTimeStr = this._overdueTimeStr;
			newitem._overdueSec = this._overdueSec;
			newitem._coolDownTime = this._coolDownTime;
			newitem._itemislocked = this._itemislocked;
			newitem._itemLevel = this._itemLevel;
			newitem._job = this._job;
			newitem._advancedLv = this._advancedLv;
			newitem._csLv = this._csLv;
			newitem._reinLv = this._reinLv;
			newitem._ownname = this._ownname;
			newitem._itemAttributes = this._itemAttributes;
			newitem._itemAppendNum = this._itemAppendNum;
			newitem._itemExp = this._itemExp;
			newitem._isShowHighQt = this._isShowHighQt;
			newitem._showQuality = this._showQuality;
			newitem._equipPosType = this._equipPosType;
			newitem._packageId = this._packageId;
			newitem.fixOverTime = this.fixOverTime;
			newitem.isBlurPpt = this.isBlurPpt;
			newitem.isNumPic = this.isNumPic;
			newitem.isShowTips = this.isShowTips;
			newitem.guildDonatePlayerName = this.guildDonatePlayerName;
			newitem.postTaskCurExp = this.postTaskCurExp;
			newitem.postTaskMaxExp = this.postTaskMaxExp;
		}
	},
	GetMoney:function ()
	{
		if ( Item._q_item_money == null )
			Item._q_item_money = Q_item.Get( EnumItemId.Money );

		return Item._q_item_money;
	},
	GetGold:function ()
	{
		if ( Item._q_item_gold == null )
			Item._q_item_gold=  Q_item.Get( EnumItemId.GOLD );
		return Item._q_item_gold;
	},
	GetEquipPosType:function ()
	{
		return this._equipPosType;
	},
	SetEquipPosType:function (value)
	{
		this._equipPosType = value;
	},
	GetItemislocked:function ()
	{
		return this._itemislocked;
	},
	SetItemislocked:function (value)
	{
		this._itemislocked = value;
	},
    ParseParams:function(params){
        if( !params )
            return;
        var date = Mgr.login.GetServerDate();
        var time = 0;
        if ( params["SUPER_GOLD_CARD"] ){
            time = parseInt( params["SUPER_GOLD_CARD"] ) - date.getTime();
            if ( time > 0 ) //容错
                time = 0;
            this.coolDownTime = time + 24 * 3600 * 1000;
        }
        if ( params["ITEM_USE_CD"] ){
            time = parseInt( params["ITEM_USE_CD"] * 1000 ) - date.getTime();
            if ( time < 0 ) //容错
                time = 0;
            this.coolDownTime = time;
            if( params["ITEM_CD_TIME"] ){
                this.coolDownTotal = parseInt( params["ITEM_CD_TIME"] * 1000 );
            }
        }

        //附加属性
        if ( params["EXTRA"] )
            this._itemAppendNum = parseInt( params["EXTRA"] );
        //强化
        if ( params["STRENGTH"] )
            this.itemLevel = parseInt( params["STRENGTH"] );
        //经验罐
        if ( params["EXP_JAR_EXP"] )
            this.itemExp = parseInt( params["EXP_JAR_EXP"] );
        //装备转生等级
        if ( params["REINCARNAT"] )
            this.reinLv = parseInt( params["REINCARNAT"] );
    },
	/**
	 * 是否顶级强化
	 */
	GetIsFullStrength:function()
	{
		var item = Q_item.Get(this._itemModelId);
		if(this._itemLevel != 0 && this._itemLevel == item.q_max_strengthen)
		{
			return 1;
		}
		return 0;
	},
	/**
	 * 强化等级
	 */
	GetStrengthLv:function()
	{
		return this._itemLevel;
	},
	/**
	 * 是否顶级万能强化
	 */
	GetIsFullStrengthExt:function()
	{
		return 0;
	},
	/**
	 * 物品是否有时限
	 */
	GetIsItemHasTimeLimit:function()
	{
		return (( this.fixOverTime != null && this.fixOverTime != "" ) || this._overdueSec != 0 || ( this._overdueTimeStr != "" && this._overdueTimeStr != null ) );
	},
	/**
	 * 物品默认品阶
	 */
	GetItemDefault:function ()
	{
		var item = Q_item.Get(this.itemModelId);
		if(item!=null)
			return item.q_default;
		return 0;
	},
	/**
	 * 物品默认品阶
	 */
	SetItemDefault:function (value)
	{
		this._itemDefault = value;
	},
	/**
	 * set 过期时刻
	 */
	SetOverdueTime:function (value)
	{
		this._overdueTime = value;
		//if (value == 0)
		{
			this._overdueTimeStr = "";
			this._overdueSec = 0;
		}
		//else
		//{
		//	this._overdueTimeStr = TextUtil.changeSecondToDateStr(_overdueTime);
		//	this._overdueSec = TextUtil.getDeltaSecondsAtNow(_overdueTime);
		//}
	},

	GetOverdueTime:function ()
	{
		return this._overdueTime;
	},
	/**
	 * get 过期时刻字符串形式
	 * @return
	 */
	SetOverdueTimeStr:function (value)
	{
		this._overdueTimeStr = value;
	},
	GetOverdueTimeStr:function ()
	{
		return this._overdueTimeStr;
	},
	IsOverdue:function()
	{
		if ( this._overdueTime )
			return TimeUtil.GetDeltaSecondsAtServerNow(this._overdueTime) < 0;

		return false;
	},
	/**
	 * get 过期剩余秒数，多少秒后过期
	 * @return
	 */
	SetOverdueSec:function (value)
	{
		this._overdueSec = value;
	},
	GetOverdueSec:function ()
	{
		return this._overdueSec;
	},
	/**
	 * set 扩展参数
	 */
	SetParameters:function(value)
	{
		try{
			this._parameters = JSON.parse(value);
		}catch(e){
			this._parameters = new Object();
		}
	},
	GetParamObj:function()
	{
		return this._parameters;
	},
	GetStrengthExtstate:function()
	{
		return 0;
	},
	GetOwnname:function ()
	{
		return this._ownname;
	},
	SetOwnname:function (value)
	{
		this._ownname = value;
	},
	GetModel:function ()
	{
		return Q_item.Get(this.itemModelId);
	},
	GetName:function ()
	{
		return ItemUtil.GetItemName(this.itemModelId);
	},
	/**
	 * get 物品万能强化等级
	 * @return
	 */
	GetItemExtLevel:function ()
	{
		return this._itemExtLevel;
	},
	/**
	 * set 物品万能强化等级
	 */
	SetItemExtLevel:function(value)
	{
		this._itemExtLevel = value;
	},
	/**
	 * get 物品附加属性
	 * @return
	 */
	GetItemAttributes:function()
	{
		return this._itemAttributes || [];
	},
	/**
	 * set 物品附加属性
	 */
	SetItemAttributes:function(value)
	{
		this._itemAttributes = value;
		if (this._itemAttributes != null)
			this._itemAppendNum = this._itemAttributes.length;
	},
	/**
	 * get 物品附加条数
	 */
	GetItemAppendNum:function()
	{
		return this._itemAppendNum;
	},
	/**
	 * set 物品附加条数
	 */
	SetItemAppendNum:function( value )
	{
		this._itemAppendNum = value;
	},
	/**
	 * get 物品附加经验
	 */
	GetItemExp:function()
	{
		return this._itemExp;
	},
	/**
	 * set 物品附加经验
	 */
	SetItemExp:function( value )
	{
		this._itemExp = value;
	},
	/**
	 * 背包数量
	 * @return
	 */
	GetBackNum:function ()
	{
		return Mgr.backpack.GetItemNumber(this.itemModelId);
	},
	GetType:function ()
	{
		var itemm = this.GetModel();
		if (itemm != null)
			return itemm.q_type;
		return 0;
	},
	/**
	 * get 是否显示成最高品质
	 */
	GetIsShowHighQt:function()
	{
		return this._isShowHighQt;
	},
	/**
	 * set 是否显示成最高品质
	 */
	SetIsShowHighQt:function( value )
	{
		this._isShowHighQt = value;
	},
	/**
	 * get 品质
	 */
	GetShowQuality:function()
	{
		return this._showQuality;
	},
	/**
	 * set 品质
	 */
	SetShowQuality:function( value )
	{
		this._showQuality = value;
	},
	/**
	 * get 冷却
	 */
	GetCoolDownTime:function()
	{
		return this._coolDownTime;
	},
	/**
	 * set 冷却
	 */
	SetCoolDownTime:function( value )
	{
		this._coolDownTime = value;
	},
	/**
	 * get 传说等级
	 */
	GetCsLv:function()
	{
		return this._csLv;
	},
	/**
	 * set 传说等级
	 */
	SetCsLv:function( value )
	{
		this._csLv = value;
	},
	/**
	 * get 进阶等级
	 */
	GetAdvancedLv:function()
	{
		return this._advancedLv;
	},
	/**
	 * set 进阶等级
	 */
	SetAdvancedLv:function( value )
	{
		this._advancedLv = value;
	},
	/**
	 * get 转生等级
	 */
	GetReinLv:function()
	{
		return this._reinLv;
	},
	/**
	 * set 转生等级
	 */
	SetReinLv:function( value )
	{
		this._reinLv = value;
	},
	GetPackageId:function ()
	{
		return this._packageId;
	},
	SetPackageId:function (value)
	{
		this._packageId = value;
	}
});
