///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//EquipRefineInfo 单个装备精炼信息
//EquipPosSuitInfo 装备部位套装信息
//RefineSysInfo 装备系统精炼信息

// 请求消息
//234201,ReqEquipRefineInfoToGame 请求装备精炼信息
//234202,ReqEquipRefineChangeToGame 请求装备精炼
//234203,ReqEquipPosSuitChangeToGame 请求装备套装升级

// 接收消息
//234101,ResEquipRefineAllInfoToClient 发送整个装备精炼数据信息 
//234102,ResEquipRefineInfoToClient 发送单个装备精炼数据信息 
//234103,ResEquipPosSuitInfoToClient 发送单个装备精炼数据信息 
//234104,ResEquipPosSuitAllInfoToClient 发送单个装备精炼数据信息 
//234105,ResEquipSuitRankToClient 发送玩家当前装备品质套装等级 


var EquipRefineInfo = cc.Class.extend({
	ctor:function(){
		this.equipLocation = 0; // 装备子类型
        this.refinelList = []; // 镶嵌的精炼道具ID,数量列表（modelId,数量....） int
	},

	writing:function( _buf ){
		_buf.WriteByte(this.equipLocation);
        _buf.WriteShort( this.refinelList.length );
        for (var i = 0; i < this.refinelList.length; i++) {
            _buf.WriteVarInt(this.refinelList[i]);
        }
	},
	
	reading:function( _buf ){
		this.equipLocation = _buf.ReadByte();
        var refinelList_length = _buf.ReadShort();
        for (var i = 0; i < refinelList_length; i++) {
            this.refinelList[i] = _buf.ReadVarInt();
        }
	},
});
var EquipPosSuitInfo = cc.Class.extend({
	ctor:function(){
		this.equipPos = 0; // 装备部位
        this.equipSuit = 0; // 装备套装星级
        this.itemType = 0; // 宝石系统类型（装备类型）
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.equipPos);
        _buf.WriteVarInt(this.equipSuit);
        _buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
		this.equipPos = _buf.ReadVarInt();
        this.equipSuit = _buf.ReadVarInt();
        this.itemType = _buf.ReadVarInt();
	},
});
var RefineSysInfo = cc.Class.extend({
	ctor:function(){
		this.sysType = 0; // 宝石系统类型（装备类型）
        this.equipRefinelList = []; // 装备精炼信息 EquipRefineInfo
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.sysType);
        _buf.WriteShort( this.equipRefinelList.length );
        for (var i = 0; i < this.equipRefinelList.length; i++) {
            _buf.WriteBean(this.equipRefinelList[i]);
        }
	},
	
	reading:function( _buf ){
		this.sysType = _buf.ReadVarInt();
        var equipRefinelList_length = _buf.ReadShort();
        for (var i = 0; i < equipRefinelList_length; i++) {
            this.equipRefinelList[i] = _buf.ReadBean(EquipRefineInfo);
        }
	},
});
////////////////////
// 发送整个装备精炼数据信息  //
////////////////////
var ResEquipRefineAllInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.refineSysInfos = []; // 装备精炼基本数据信息 RefineSysInfo
	},

	getId:function(){
		return 234101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.refineSysInfos.length );
        for (var i = 0; i < this.refineSysInfos.length; i++) {
            _buf.WriteBean(this.refineSysInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var refineSysInfos_length = _buf.ReadShort();
        for (var i = 0; i < refineSysInfos_length; i++) {
            this.refineSysInfos[i] = _buf.ReadBean(RefineSysInfo);
        }
	},

	action:function(){
		Mgr.equipRefine.RecvResEquipRefineAllInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个装备精炼数据信息  //
////////////////////
var ResEquipRefineInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.sysType = 0; // 宝石系统类型（装备类型）
        this.refineSysInfo = null; // 装备精炼信息
	},

	getId:function(){
		return 234102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.sysType);
        _buf.WriteBean(this.refineSysInfo);
	},
	
	reading:function( _buf ){
        this.sysType = _buf.ReadVarInt();
        this.refineSysInfo = _buf.ReadBean(RefineSysInfo);
	},

	action:function(){
		Mgr.equipRefine.RecvResEquipRefineInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个装备精炼数据信息  //
////////////////////
var ResEquipPosSuitInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.equipPosSuitInfo = null; // 装备部位套装信息
	},

	getId:function(){
		return 234103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.equipPosSuitInfo);
	},
	
	reading:function( _buf ){
        this.equipPosSuitInfo = _buf.ReadBean(EquipPosSuitInfo);
	},

	action:function(){
		Mgr.equipRefine.RecvResEquipPosSuitInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个装备精炼数据信息  //
////////////////////
var ResEquipPosSuitAllInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.equipPosSuitInfolist = []; // 装备部位套装信息列表 EquipPosSuitInfo
	},

	getId:function(){
		return 234104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.equipPosSuitInfolist.length );
        for (var i = 0; i < this.equipPosSuitInfolist.length; i++) {
            _buf.WriteBean(this.equipPosSuitInfolist[i]);
        }
	},
	
	reading:function( _buf ){
        var equipPosSuitInfolist_length = _buf.ReadShort();
        for (var i = 0; i < equipPosSuitInfolist_length; i++) {
            this.equipPosSuitInfolist[i] = _buf.ReadBean(EquipPosSuitInfo);
        }
	},

	action:function(){
		Mgr.equipRefine.RecvResEquipPosSuitAllInfoToClientMessage(this);
	},

});
////////////////////
// 发送玩家当前装备品质套装等级  //
////////////////////
var ResEquipSuitRankToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.suitRank = 0; // 等级（1蓝色，2紫色，3橙色，4红色）
        this.rankHistoryList = []; // 历史穿戴的最大装备品质（下标0表示装备子类型1表示品质，依次类推） int
        this.suitSet = []; // 已经激活的套装ID int
	},

	getId:function(){
		return 234105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.suitRank);
        _buf.WriteShort( this.rankHistoryList.length );
        for (var i = 0; i < this.rankHistoryList.length; i++) {
            _buf.WriteVarInt(this.rankHistoryList[i]);
        }
        _buf.WriteShort( this.suitSet.length );
        for (var i = 0; i < this.suitSet.length; i++) {
            _buf.WriteVarInt(this.suitSet[i]);
        }
	},
	
	reading:function( _buf ){
        this.suitRank = _buf.ReadVarInt();
        var rankHistoryList_length = _buf.ReadShort();
        for (var i = 0; i < rankHistoryList_length; i++) {
            this.rankHistoryList[i] = _buf.ReadVarInt();
        }
        var suitSet_length = _buf.ReadShort();
        for (var i = 0; i < suitSet_length; i++) {
            this.suitSet[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.equipRefine.RecvResEquipSuitRankToClientMessage(this);
	},

});
////////////////////
// 请求装备精炼信息 //
////////////////////
var ReqEquipRefineInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.sysType = 0; // 装备类型
	},

	getId:function(){
		return 234201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.sysType);
	},
	
	reading:function( _buf ){
        this.sysType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求装备精炼 //
////////////////////
var ReqEquipRefineChangeToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.sysType = 0; // 装备类型
        this.equipLocation = 0; // 装备子类型
        this.itemIds = []; // 精炼道具唯一ID long
	},

	getId:function(){
		return 234202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.sysType);
        _buf.WriteVarInt(this.equipLocation);
        _buf.WriteShort( this.itemIds.length );
        for (var i = 0; i < this.itemIds.length; i++) {
            _buf.WriteLong(this.itemIds[i]);
        }
	},
	
	reading:function( _buf ){
        this.sysType = _buf.ReadVarInt();
        this.equipLocation = _buf.ReadVarInt();
        var itemIds_length = _buf.ReadShort();
        for (var i = 0; i < itemIds_length; i++) {
            this.itemIds[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 请求装备套装升级 //
////////////////////
var ReqEquipPosSuitChangeToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.equipLocation = 0; // 装备部位
        this.itemType = 0; // 宝石系统类型（装备类型）
	},

	getId:function(){
		return 234203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.equipLocation);
        _buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
        this.equipLocation = _buf.ReadVarInt();
        this.itemType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(234101, ResEquipRefineAllInfoToClientMessage);
MESSAGE_POOL.Add(234102, ResEquipRefineInfoToClientMessage);
MESSAGE_POOL.Add(234103, ResEquipPosSuitInfoToClientMessage);
MESSAGE_POOL.Add(234104, ResEquipPosSuitAllInfoToClientMessage);
MESSAGE_POOL.Add(234105, ResEquipSuitRankToClientMessage);

