var EquipRefineModMgr = EquipRefineModMgr || cc.Class.extend({

	// 精炼石缓�
	_refineStonesCache : null,
	// 套装星级缓存
	_suitStarCache : null,

		// 终点协议发送控�
	_isSend:null,

	ctor:function() {
		this._refineStonesCache = new HashMap();
		this._suitStarCache = {};
		this._equipSuitInfo = [];
	},

	RecvResEquipRefineAllInfoToClientMessage:function(msg) {
		this._refineStonesCache.Clear();
		for ( var i = 0; i != msg.refineSysInfos.length; i++ ) {
			this._refineStonesCache.Put(msg.refineSysInfos[i].sysType,msg.refineSysInfos[i].equipRefinelList);
		}

		var panel = Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName);
		if (panel) {
			var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_REFINE];
			if (page)
				page.SetEquips();
		}
	},

	RecvResEquipRefineInfoToClientMessage:function(msg) {
		cc.log("RecvResEquipRefineInfoToClientMessage ");
		this._refineStonesCache.Put(msg.refineSysInfo.sysType,msg.refineSysInfo.equipRefinelList);

		Mgr.tips.ShowNotice("精炼成功");

        var panel = Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName);
        if (panel) {
            var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_REFINE];
            if ( page ) {
                page.SetEquips();

                //自动精炼
                if (page.AutoRefine) {
                    if ( page.visible && panel.visible ) {  // 确保精炼界面打开的情况，才自动精�
                        TimerUtil.SetTimeout(this, function () {
                            page.AutoRefineHeader();
                        }, 300);
                    }
                    else {
                        page.AutoRefine = false;
                        page._ChangeAutoRefineState(false);
                    }
                }
            }
        }
	},

	RecvResEquipPosSuitInfoToClientMessage:function(msg) {
		cc.log("发送单个装备套装数据信�   " + JSON.stringify(msg));
		var location = msg.equipPosSuitInfo.equipPos;
		var star = msg.equipPosSuitInfo.equipSuit;
		var itemType = msg.equipPosSuitInfo.itemType;

        this._suitStarCache[itemType] = this._suitStarCache[itemType] || {};
        this._suitStarCache[itemType][location] = star;

        GameEventMgr.DispatchEvent(EnumEventType.GAME_EQUIP_REFINING_SUIT_CHANGED);
	},

	RecvResEquipPosSuitAllInfoToClientMessage:function(msg) {
		cc.log("发送整个装备套装数据信� "  + JSON.stringify(msg));

		for ( var i = 0; i != msg.equipPosSuitInfolist.length; i++ ) {
			var location = msg.equipPosSuitInfolist[i].equipPos;
			var star = msg.equipPosSuitInfolist[i].equipSuit;
			var itemType = msg.equipPosSuitInfolist[i].itemType;

            this._suitStarCache[itemType] = this._suitStarCache[itemType] || {};
            this._suitStarCache[itemType][location] = star;
		}
        GameEventMgr.DispatchEvent(EnumEventType.GAME_EQUIP_REFINING_SUIT_CHANGED);
	},
		RecvResEquipSuitRankToClientMessage:function(){},
	//add-12-12
    RecvResEquipSuitRankToClientMessage:function (msg) {

    },

	SendReqEquipRefineInfoToGameMessage:function( type  ) {
		cc.log("SendReqEquipRefineInfoToGameMessage " + type);
		var msg = new ReqEquipRefineInfoToGameMessage();
		msg.sysType = type;
		Mgr.msgMgr.Send(msg);
	},

	SendReqEquipRefineChangeToGameMessage:function(sysType, equipLocation, itemIds) {
		cc.log("SendReqEquipRefineChangeToGameMessage ");
		var msg = new ReqEquipRefineChangeToGameMessage();
		msg.sysType = sysType; // 装备精炼系统类型（其实就是资源线类型 -1为人物装备）
		msg.equipLocation = equipLocation; // 装备子类�
		msg.itemIds = itemIds; // 精炼道具唯一ID long
		Mgr.msgMgr.Send(msg);
	},

	SendReqEquipPosSuitChangeToGameMessage:function(itemType,equipLocation) {
		cc.log("请求装备套装升级 ");
		var msg = new ReqEquipPosSuitChangeToGameMessage();
		msg.itemType = itemType;
		msg.equipLocation = equipLocation;
		Mgr.msgMgr.Send(msg);
	},

	GetRefineStones:function (type) {
		if ( !this._refineStonesCache.Get(type) ) {
			this._refineStonesCache.Put(type, []);
		}
		return this._refineStonesCache.Get(type);
	},
	GetSuitByLocation:function (itemType,location) {
        this._suitStarCache[itemType] =  this._suitStarCache[itemType] || {};
        return this._suitStarCache[itemType][location] || 0
	},

    GetAllSuitInfo:function(){
        var map = {};
        for(var k in this._suitStarCache){
            for(var kk in this._suitStarCache[k]){
                var star = this._suitStarCache[k][kk];
                var itemType = k;

                map[itemType] = map[itemType] || {};
                map[itemType][star] = map[itemType][star] || 0;
                map[itemType][star] ++;
            }
        }
        return map;
    }
});