var MenuPanelExt = MenuPanel.extend ( {
	_className:"MenuPanelExt",
	data:null,
	isFriend:false,
	isBlack:false,
	_friendsBtnArr:[],
	_othersBtnArr:[],
	_blacksBtnArr:[],
	_labNameY:0,
	_labLevelY:0,
	_baseContentSize:null,
	_panelGlobPos:null,
	ctor:function(){
		this._super();
	},
	Init:function()
	{
		var self = this;
		MenuPanel.prototype.Init.call(this);
		this._SetBaseProperty();
		this._SetTouchListener();
		this._HandleButton();
	},
	_SetBaseProperty:function()
	{
		this.labName.SetFontSize(22);
		this.labName.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.labName.DisableEffect();
		this.labLevel.SetFontSize(22);
		this.labLevel.SetColor(EnumFontFormat.COMMON_COLOR01);
		this.labLevel.DisableEffect();
		this.btnLook.SetTitleTextColor(EnumFontFormat.COMMON_COLOR02);
		this.btnLook.SetTitleTextFontSize(24);

		this.btnChat.SetTitleTextColor(EnumFontFormat.COMMON_COLOR02);
		this.btnChat.SetTitleTextFontSize(24);

		this.btnAdd.SetTitleTextColor(EnumFontFormat.COMMON_COLOR02);
		this.btnAdd.SetTitleTextFontSize(24);

		this.btnBlack.SetTitleTextColor(EnumFontFormat.COMMON_COLOR02);
		this.btnBlack.SetTitleTextFontSize(24);

		this._labLevelY = this.labLevel.y;
		this._labNameY	  = this.labName.y;
		this._baseContentSize = this.getContentSize();
		this._friendsBtnArr = [
			{btn:this.btnBlack,pos:this.btnBlack.getPosition()},
			{btn:this.btnChat,pos:this.btnAdd.getPosition()},
			{btn:this.btnLook,pos:this.btnChat.getPosition()}
		]
		this._othersBtnArr  = [
			{btn:this.btnBlack,pos:this.btnBlack.getPosition()},
			{btn:this.btnAdd,pos:this.btnAdd.getPosition()},
			{btn:this.btnChat,pos:this.btnChat.getPosition()},
			{btn:this.btnLook,pos:this.btnLook.getPosition()}
		]
		this._blacksBtnArr  = [
			{btn:this.btnBlack,pos:this.btnBlack.getPosition()},
			{btn:this.btnAdd,pos:this.btnAdd.getPosition()},
			{btn:this.btnLook,pos:this.btnChat.getPosition()}
		]
	},
	_ResetFuncBtn:function()
	{
		var size = this._baseContentSize;
		if(this.isBlack)
		{
			cc.log("this.isblack=> "+this.isBlack);
			var gap = this._blacksBtnArr[0].btn.height+10;
			size = cc.size(size.width,size.height-gap);
			this.labName.y = size.height - this.labName.height - 14;
			this.labLevel.y  = this.labName.y - this.labLevel.height ;
			for(var i = 0; i < this._blacksBtnArr.length; i++ )
			{
				this._blacksBtnArr[i].btn.setPosition(this._othersBtnArr[i].pos);
				this._blacksBtnArr[i].btn.visible = true;
			}
		}
		else if(!this.isFriend)
		{
			this.labName.y = size.height - this.labName.height - 14;
			this.labLevel.y  = this.labName.y - this.labLevel.height ;
			for(var i = 0; i < this._othersBtnArr.length; i++)
			{
				this._othersBtnArr[i].btn.setPosition(this._othersBtnArr[i].pos);
				this._othersBtnArr[i].btn.visible = true;
			}
		}
		else
		{
			var gap = this._friendsBtnArr[0].btn.height+10;
			size = cc.size(size.width,size.height-gap);
			this.labName.y = size.height - this.labName.height - 14;
			this.labLevel.y  = this.labName.y - this.labLevel.height ;
			for(var i = 0; i < this._friendsBtnArr.length; i++ )
			{
				this._friendsBtnArr[i].btn.setPosition(this._othersBtnArr[i].pos);
				this._friendsBtnArr[i].btn.visible = true;
			}
		}
		this.setContentSize(size);
		var pos = this._panelGlobPos;
		var pos01 = cc.p(pos.x+80,pos.y-this.height+80);
		if(pos01.y<0)
		{
			pos01.y =0;
		}
		this.setPosition(pos01);
	},
	_SetTouchListener:function()
	{
		var self = this;
		this.listener = cc.EventListener.create({
			event: cc.EventListener.TOUCH_ONE_BY_ONE,
			swallowTouches: true,
			onTouchBegan: function (touch, event) {
				self.listener.setSwallowTouches(false);
				self._HideSelf();
				return true;
			},
			onTouchMoved: function (touch, event) {
			},
			onTouchEnded: function (touch, event) {
			},
			onTouchCancelled: function (touch, event) {
			}
		});
		cc.eventManager.addListener(this.listener, this);
	},
	_HandleButton:function()
	{
		var self = this;
		//查看玩家信息
		this.btnLook.addClickEventListener(function ()
		{
			Mgr.player.SendReqPlayerBriefMessage([self.data.playerid],EnumBriefType.PAIHANB);
			self._HideSelf();
		});
		//私聊
		this.btnChat.addClickEventListener(function ()
		{
			Mgr.chat.ShowHideChatPanel(false);
			var panel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
			if(!panel || !panel.visible)
			{
				EngineMgr.uiMgr.ShowHidePanelByType( YoujianPanelExt.PanelName, UIMgr.PANEL_LAYER_DEF);
				var panel = Mgr.uiMgr.GetPanelByType(YoujianPanelExt.PanelName);
				panel.SetStranger(self.data);
				panel.ChangePanel(panel.FRIEND_PANEL);
			}
			self._HideSelf();
		});
		//加为好友
		this.btnAdd.addClickEventListener(function ()
		{
			if(self.isFriend)
			{
				Mgr.friend.SendReqDeleteFriendMessage(self.data.playerid);
			}
			else
			{
				Mgr.friend.SendReqApplyFriendMessage(self.data.playerid);
				Mgr.tips.ShowNotice("好友申请发送成功");
			}
			self._HideSelf();
		});
		//加入黑名单
		this.btnBlack.addClickEventListener(function ()
		{
			if(self.isBlack)
			{
				Mgr.friend.SendReqAddBlackMessage(self.data.playerid,EnumRelationType.OPERATION_DELETE);
			}
			else
			{
				Mgr.friend.SendReqAddBlackMessage(self.data.playerid,EnumRelationType.OPERATION_ADD);
			}
			self._HideSelf();
		});
	},
	SetInformation:function(data, pos)
	{
		this.setLocalZOrder(1000);
		//请求玩家简要信息data.playerId
		//Mgr.player.SendReqPlayerBriefMessage([data.playerId],EnumBriefType.HEAD_MENUE);
		this.setPosition(pos.x+80,pos.y-this.height+80);
		this._panelGlobPos = pos;
		if(this.y <0)
		{
			this.y = 0;
		}
		this.listener.setSwallowTouches(true);
	},
	UpdateInformation:function(msg) {
		this._HideButton();
		var data = msg.playerBriefs[0];
		this.data = data;
		this.labName.SetString(data.playerName);
		this.labLevel.SetString("等级：" + data.level);
		if (Mgr.friend.GetFriendList().Get(data.playerid))
		{
			this.btnAdd.setTitleText("删除好友");
			this.btnAdd.visible = false;
			this.isFriend = true;
		}
		else
		{
			this.isFriend = false;
			this.btnAdd.setTitleText("加为好友");
			this.btnAdd.visible = true;
		}
		if(Mgr.friend.GetBlackList().Get(data.playerid))
		{
			this.btnBlack.setTitleText("移除黑名单");
			this.btnBlack.visible = false;
			this.isBlack = true;
		}
		else
		{
			this.btnBlack.setTitleText("加入黑名单");
			this.isBlack = false;
			this.btnBlack.visible = true;
		}
		//this._SetBaseProperty();
		this._ResetFuncBtn();
	},
	_HideButton:function()
	{
		for(var i = 0; i < this._othersBtnArr.length; i++)
		{
			this._othersBtnArr[i].btn.visible = false;
		}
	},
	OnHide:function()
	{
		this._super();
		this._HideSelf();
	},
	_HideSelf:function()
	{
		this.listener.setSwallowTouches(false);
		EngineMgr.uiMgr.HidePanel(this);
	},
} );
MenuPanelExt.PanelName = "MenuPanelExt";
PanelClassDic["MenuPanelExt"] = MenuPanelExt;
