///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//GemItemInfo 宝石道具信息
//GemInfo 宝石信息

// 请求消息
//182201,ReqGemInfoToGame 请求宝石信息
//182202,ReqGemChangeToGame 请求宝石镶嵌或升级

// 接收消息
//182101,ResSendGemAllInfoToClient 发送整个宝石数据信息 
//182102,ResSendGemInfoToClient 发送单个宝石数据信息 


var GemItemInfo = cc.Class.extend({
	ctor:function(){
		this.gemModelId = 0; // 宝石模板ID
        this.isbind = 0; // 宝石是否绑定(1是绑定0是不绑定)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.gemModelId);
        _buf.WriteVarInt(this.isbind);
	},
	
	reading:function( _buf ){
		this.gemModelId = _buf.ReadVarInt();
        this.isbind = _buf.ReadVarInt();
	},
});
var GemInfo = cc.Class.extend({
	ctor:function(){
		this.itemType = 0; // 宝石系统类型（装备类型）
        this.gemModelList = []; // 镶嵌的宝石列表（与下面的列表index对应） GemItemInfo
        this.equipLocationList = []; // 镶嵌的宝石装备类型列表（这个其实就是装备的子类型） int
        this.gemLocationList = []; // 镶嵌的宝石位置列表（1，2，3） int
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.itemType);
        _buf.WriteShort( this.gemModelList.length );
        for (var i = 0; i < this.gemModelList.length; i++) {
            _buf.WriteBean(this.gemModelList[i]);
        }
        _buf.WriteShort( this.equipLocationList.length );
        for (var i = 0; i < this.equipLocationList.length; i++) {
            _buf.WriteVarInt(this.equipLocationList[i]);
        }
        _buf.WriteShort( this.gemLocationList.length );
        for (var i = 0; i < this.gemLocationList.length; i++) {
            _buf.WriteVarInt(this.gemLocationList[i]);
        }
	},
	
	reading:function( _buf ){
		this.itemType = _buf.ReadVarInt();
        var gemModelList_length = _buf.ReadShort();
        for (var i = 0; i < gemModelList_length; i++) {
            this.gemModelList[i] = _buf.ReadBean(GemItemInfo);
        }
        var equipLocationList_length = _buf.ReadShort();
        for (var i = 0; i < equipLocationList_length; i++) {
            this.equipLocationList[i] = _buf.ReadVarInt();
        }
        var gemLocationList_length = _buf.ReadShort();
        for (var i = 0; i < gemLocationList_length; i++) {
            this.gemLocationList[i] = _buf.ReadVarInt();
        }
	},
});
////////////////////
// 发送整个宝石数据信息  //
////////////////////
var ResSendGemAllInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.gemInfos = []; // 宝石基本数据信息 GemInfo
	},

	getId:function(){
		return 182101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.gemInfos.length );
        for (var i = 0; i < this.gemInfos.length; i++) {
            _buf.WriteBean(this.gemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var gemInfos_length = _buf.ReadShort();
        for (var i = 0; i < gemInfos_length; i++) {
            this.gemInfos[i] = _buf.ReadBean(GemInfo);
        }
	},

	action:function(){
		Mgr.gem.RecvResSendGemAllInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个宝石数据信息  //
////////////////////
var ResSendGemInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.itemType = 0; // 宝石系统类型（装备类型）
        this.gemInfo = null; // 宝石单个数据信息
	},

	getId:function(){
		return 182102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemType);
        _buf.WriteBean(this.gemInfo);
	},
	
	reading:function( _buf ){
        this.itemType = _buf.ReadVarInt();
        this.gemInfo = _buf.ReadBean(GemInfo);
	},

	action:function(){
		Mgr.gem.RecvResSendGemInfoToClientMessage(this);
	},

});
////////////////////
// 请求宝石信息 //
////////////////////
var ReqGemInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.itemType = 0; // 宝石系统类型（装备类型）
	},

	getId:function(){
		return 182201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.itemType);
	},
	
	reading:function( _buf ){
        this.itemType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求宝石镶嵌或升级 //
////////////////////
var ReqGemChangeToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.opType = 0; // 操作类型(0是穿戴 1是升级)
        this.itemType = 0; // 宝石系统类型（装备类型）
        this.equipLocation = 0; // 镶嵌的宝石装备位置（这个其实就是装备的子类型）
        this.gemId = null; // 宝石唯一ID
        this.gemLocation = 0; // 镶嵌的宝石位置列表（1，2，3...）
	},

	getId:function(){
		return 182202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.opType);
        _buf.WriteVarInt(this.itemType);
        _buf.WriteVarInt(this.equipLocation);
        _buf.WriteLong(this.gemId);
        _buf.WriteVarInt(this.gemLocation);
	},
	
	reading:function( _buf ){
        this.opType = _buf.ReadByte();
        this.itemType = _buf.ReadVarInt();
        this.equipLocation = _buf.ReadVarInt();
        this.gemId = _buf.ReadLong();
        this.gemLocation = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(182101, ResSendGemAllInfoToClientMessage);
MESSAGE_POOL.Add(182102, ResSendGemInfoToClientMessage);

