var GemModMgr = GemModMgr || cc.Class.extend({
	// 所有宝石
	_allStones:null,

	// 人物镶嵌宝石
	_inlayStones:null,

	ctor:function() {
		this._allStones = {};
		this._inlayStones = {};
		this._allStoneList = [];
	},

	RecvResSendGemAllInfoToClientMessage:function(msg) {
		cc.log(" RecvResSendGemAllInfoToClientMessage!!! ");
		this._allStones = {};
		for ( var i = 0; i != msg.gemInfos.length; i++ ) {
			var data = msg.gemInfos[i];
			this._allStones[data.itemType] = data;
		}
		this._RoleStones();
	},

	RecvResSendGemInfoToClientMessage:function(msg) {
		cc.log("---------------- ResSendGemInfoToClientMessage!!! ");
		this._allStones[msg.itemType] = msg.gemInfo;
		this._RoleStones();
	},

	SendReqGemInfoToGameMessage:function( type ) {
		cc.log(" ReqGemInfoToGameMessage!!! ",type);
		var msg = new ReqGemInfoToGameMessage();
		msg.itemType = type;
		Mgr.msgMgr.Send( msg );
	},

	SendReqGemChangeToGameMessage:function( operate, itemType, equipType, sid, pos ) {
		cc.log(" ReqGemChangeToGameMessage!!! ");
		var msg = new ReqGemChangeToGameMessage();
		msg.opType = operate;
		msg.itemType = itemType;
		msg.equipLocation = equipType;
        msg.gemId = sid;
		msg.gemLocation = pos;
		Mgr.msgMgr.Send( msg );
	},

	GetStonesByType:function (type) {
		return this._allStones[type];
	},

	_RoleStones:function () {
        this._allStoneList.length = 0;
        for(var k in this._allStones){
            var info = this._allStones[k];

            var inlayStones = {};

            this._inlayStones[k] = inlayStones;

            var stoneList = info && info.gemModelList || [];
            var equipTypes = info && info.equipLocationList || [];



            for ( var i = 0; i != stoneList.length; i++ ) {
                var gemInfo = stoneList[i];
                var equipType = equipTypes[i];

                var stoneC = Q_item.Get( gemInfo.gemModelId );
                var stoneType = stoneC.q_location;

                // new
                var data = { item_type : k,equip_type:equipType, stone_type:stoneType, mid:gemInfo.gemModelId, stoneC:stoneC, isbind:gemInfo.isbind };

                inlayStones[equipType] = inlayStones[equipType] || [];
                inlayStones[equipType].push(data);
                this._allStoneList.push(data);
            }
        }

        var panel = Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName);
        if (panel) {
            var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_INLAY];
            if ( page )
                page.LayOutGrids();
        }
	},

    GetAllInlayStones:function(){
        return this._allStoneList;
    },

    GetInlayStonesWithinItemType:function(itemType){
        return this._inlayStones[itemType];
    },

    GetInlayStonesExt:function(itemType,equipType){
        var v = this._inlayStones[itemType];
        return (v && v[equipType] || []).concat();
    },

	GetInlayStones:function (equipType) {
		return this.GetInlayStonesExt(EnumItemType.Equip,equipType);
	},

    GetInlayStoneExt:function(itemType, equipType, stoneType){
        var list = this.GetInlayStonesExt(itemType,equipType);
        return list.find(function(v){
            return v.stone_type == stoneType;
        })
    },

	// 获取单个精确宝石
	GetInlayStone:function (equipType, stoneType) {
		var list = this.GetInlayStones(equipType);
		for ( var i = 0; i != list.length; i++ ) {
			if (list[i].stone_type == stoneType)
				return list[i];
		}
		return null;
	},

    GetInlayStoneById:function(itemType,equipType,mid){
        var list = this.GetInlayStonesExt(itemType,equipType);
        return list.find(function(v){
            return v.mid == mid;
        })
    },
});