var GuildApplyListExt = GuildApplyList.extend ( {
	_className:"GuildApplyListExt",

	_listView : null,
	_itemList:null,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this._itemList = [];
	},

	Init:function() {
		GuildApplyList.prototype.Init.call(this);
		var self = this;
		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		this.btnAutoSure.addClickEventListener(function (event){
			var items = self._listView.getItems();
			if ( items.length <= 0 ) {
				Mgr.tips.ShowNotice( "不存在申请玩家!");
				return;
			}

			for ( var i = 0; i != items.length; i++ ) {
				(function(j){
					if ( j % 10 == 0 ) {
						self.scheduleOnce(function () {
							items[j].SendProp(1);
						}, 0.5);
					}
					else {
						items[j].SendProp( 1 );
					}
				})(i);
			}
		});
		this.btnAutoFail.addClickEventListener(function (event){
			var items = self._listView.getItems();
			if ( items.length <= 0 ) {
				Mgr.tips.ShowNotice( "不存在申请玩家!");
				return;
			}

			for ( var i = 0; i != items.length; i++ ) {
				(function (j) {
					if (j % 10 == 0) {
						self.scheduleOnce(function () {
							items[j].SendProp(0);
						}, 0.5);
					}
					else {
						items[j].SendProp(0);
					}
				})(i);
			}
		});

		this._InitPanel();
	},

	_FixGuildConfig:function () {
		var config = new GuildConfig();
		var state = this._GetCheckBoxState();
		if ( state )
			config.vipAutoJoin = 1;
		else
			config.vipAutoJoin = 0;
		Mgr.guild.SendReqGuildConfigMessage( config );
	},

	_InitPanel:function () {
		this._InitParam();
	},

	_InitParam:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);
		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg1.addChild(list);
		this._listView = list;

		this._SetCheckBox();
	},

	_SetCheckBox:function () {
		// VIP自动加入
		if ( this._IsOperator() )
			this.sbtnChoose.setTouchEnabled(true);
		else
			this.sbtnChoose.setTouchEnabled(false);
		this.sbtnChoose.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				var checkBtn = sender;
				var parent = sender.getParent();
				var boo = parent._GetCheckBoxState();
				if ( boo )
					checkBtn.SetButtonState( "uncheck" );
				else
					checkBtn.SetButtonState( "check" );

				// 修改帮会配置
				parent._FixGuildConfig();
			}
		});
	},

	SetVipState:function () {
		// vip自动加入 初始状态
		if ( Mgr.guild.guildConfig.vipAutoJoin )
			this.sbtnChoose.SetButtonState( "check" );
		else
			this.sbtnChoose.SetButtonState( "uncheck" );
	},

	CallBackProp:function () {
		this.SetVipState();
		this.LoadItems();
	},

	LoadItems:function () {
		this._listView.removeAllChildren(true);

		var boo = false;
		var applyList = Mgr.guild.guildAppliedHash.Values();
		for ( var i = 0; i != applyList.length; i++ ) {
			var item;
			if ( i < this._itemList.length )
				item = this._itemList[i];
			else {
				item = new GuildApplyItemExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
			}
			boo = !boo;
			item.SetData( applyList[i], boo );
			this._AddItem(item);
		}

		// btn
		boo = this._IsOperator();
		this.btnAutoSure.visible = boo;
		this.btnAutoFail.visible = boo;
	},

	_IsOperator:function () {
		var personId = Mgr.player.mainPlayer.sid;
		var memberInfo = Mgr.guild.guildMembers.Get( personId );
		cc.assert(null != memberInfo, "guildInfo can't be nil!  personId: " + personId);
		var job = memberInfo.guildPowerLevel;
		if ( job == GuildEnum.MEMBER_GUILDER || job == GuildEnum.MEMBER_SECONDGUILDER )
			return true;
		return false;
	},

	_GetCheckBoxState:function () {
		var auto = false;
		var state = this.sbtnChoose.GetState();
		if ( state === "check" )
			auto = true;

		return auto;
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	OnShow:function () {
		Mgr.guild.SendReqApplyListMessage();
		// 刷新帮会信息  （为了更新 VIP自动加入配置）
		TimerUtil.SetTimeout( Mgr.guild, Mgr.guild.SendReqUpdateGuildInfoMessage, 300);
	},
} );
GuildApplyListExt.PanelName = "GuildApplyListExt";
PanelClassDic["GuildApplyListExt"] = GuildApplyListExt;
