var GuildBossMainExt = GuildBossMain.extend ( {
	_className:"GuildBossMainExt",

	_maxLevel:10,
	_minLevel:1,
	_changeLevel:0,

	// 展示道具grid
	_rewardList:null,

	ctor:function(){
		this._super();
		this._isKilled = false;
		this._rewardList = [];
	},
	Init:function() {
		var self = this;
		GuildBossMain.prototype.Init.call(this);

		this.btnCallBoss.addClickEventListener(function (event){
			if ( self._isKilled ) {
				this.imgKill.setVisible(true);
				Mgr.tips.ShowNotice( "boss已被击杀!" );
				return;
			}
			Mgr.guild.SendReqRefreshGuildForbiddenBossMessage( 0 ); // 0: 普通召唤
		});
		this.btnChallenge.addClickEventListener(function (event){
			if(!Mgr.guild.CheckGuildActivityIsOpen() && !Mgr.guild.CheckGuildBossActivityIsOpen()){
				Mgr.tips.ShowNotice("帮派首领活动尚未开启,无法进入");
				return;
			}
			Mgr.guild.SendReqGuildEnterForbiddenMessage();  // 进入禁地
		});

		// 不用手动切换
		// this.btnLeft.addClickEventListener(function (event){
		// 	if ( self._changeLevel > self._minLevel ) {
		// 		--self._changeLevel;
		// 		self.SetPageByLevel( self._changeLevel );
		// 	}
		// });
		// this.btnRight.addClickEventListener(function (event){
		// 	if ( self._changeLevel  < self._maxLevel ) {
		// 		++self._changeLevel;
		// 		self.SetPageByLevel( self._changeLevel );
		// 	}
		// });

		this._InitPanel();
	},

	_InitPanel:function () {

		//pos
		this.x = 0;
		this.y = 0;

		this._InitParam();
	},

	_InitParam:function () {
		this.labCue.SetString("");

		this.imgKill.setVisible(false);

		this.labReward.setVisible(false);
		this.gridReward.setVisible(false);

		this.btnCallBoss.setVisible(false);
		//this.btnChallenge.setVisible(false);
	},

	_SetData:function () {
		var guildId = Mgr.player.mainPlayer.guildId;
		var guildInfo = Mgr.guild.guildMap.Get( guildId.hexValue );
		cc.assert(null != guildInfo, "guildInfo can't be nil!  guildId: " + guildId);

		this.SetPageByLevel( guildInfo.level );
	},

	SetPageByLevel:function ( lv ) {
		this._changeLevel = lv;

		// 按钮状态
		// this.btnLeft.setVisible(true);
		// this.btnRight.setVisible(true);
		// if (lv <= this._minLevel)
			this.btnLeft.setVisible(false);
		//else if (lv >= this._maxLevel)
			this.btnRight.setVisible(false);

		var guildC = Q_guild.Get( lv );
		cc.assert(null != guildC, "Q_guild Item can't be nil!  level: " + lv);

		var bossId = guildC.q_monster_boss;
		var mosterC = Q_monster.Get( bossId );
		cc.assert(null != mosterC, "Q_monster Item can't be nil!  bossId: " + bossId);

		// name
		this.labCue.SetString(mosterC.q_name)
		//this.labCue.EnableOutline("0x331a0b");

		// body
		var url = this.imgModel.jsonobj.images[0];
		url = url.substring( 0 , url.lastIndexOf( "/")) + "/";
		url = url + bossId + ".png";
		var imgModel = this.imgModel;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			imgModel.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgModel);

		// 物品奖励
		var rawards = JSON.parse( guildC.q_item_show );
		if ( rawards ) {
			this.labReward.setVisible(true);

			var len = this._rewardList.length;
			var i;
			for ( i = 0; i != rawards.length; i++ ) {
				var grid = null;
				if ( i < len )
					grid = this._rewardList[i];
				else {
					grid = this.gridReward.Clone();
					grid.retain();
					this._rewardList.push(grid);
				}
				grid.x = this.gridReward.x + (this.gridReward.width + 3) * i;
				grid.y = this.gridReward.y;
				if ( !grid.getParent() )
					this.gridReward.parent.addChild(grid);
				var item = ItemUtil.ItemIdToItem(rawards[i].mod, rawards[i].num, rawards[i].bind);
				GridUtil.SetItemGrid(grid,item);
			}
			for ( ; i < len; i++ ) {
				if ( this._rewardList[i].getParent() )
					this._rewardList[i].removeFromParent();
			}
		}

		var guildId = Mgr.player.mainPlayer.guildId;
		var guildInfo = Mgr.guild.guildMap.Get( guildId.hexValue );
		cc.assert(null != guildInfo, "guildInfo can't be nil!  guildId: " + guildId);

		// 召唤boss按钮
		// var playerId = Mgr.player.mainPlayer.sid;
		// var isGuilder = playerId.Equal(guildInfo.bangZhuid);
		// this.btnCallBoss.setVisible(isGuilder);

		// 是否击杀
		Mgr.guild.SendReqGuildForbiddenBossInfoMessage();
	},

	CallBackProp:function ( msg ) {
		// 是否击杀
		var isKilled = msg.bossDie != 0;
		this.imgKill.setVisible(isKilled);
	},

	OnShow:function () {
		this._SetData();
	},
} );
GuildBossMainExt.PanelName = "GuildBossMainExt";
PanelClassDic["GuildBossMainExt"] = GuildBossMainExt;
