var GuildInfoPanelExt = GuildInfoPanel.extend ( {
	_className:"GuildInfoPanelExt",

	_info:null,
	_uiModel:null,

	_isGted:null,

	_orgStrNotice:null,

	_sended:null,

	ctor:function(){
		this._super();

		this._isGted = false;
		this._sended = false;
	},

	Init:function() {
		var self = this;
		GuildInfoPanel.prototype.Init.call(this);
		this.labGuildName1.x = this.labGuildName.x + this.labGuildName.uiWidth + 5;
        this.labGuildLevel1.x = this.labGuildLevel.x + this.labGuildLevel.uiWidth + 5;
        self.labGuildMembers1.x = this.labGuildMembers.x + this.labGuildMembers.uiWidth + 5;
        self.labBangZhu1.x = this.labBangZhu.x + this.labBangZhu.uiWidth + 5;

		this.btnDaily.addClickEventListener(function (event){
			if ( self._isGted ) {
				Mgr.tips.ShowNotice( "已经领取" );
				return;
			}
			// 发送领取协议
			Mgr.guild.SendReqWelfareRewardStateMessage();
		});
		this.btnSkill.addClickEventListener(function (event){
			Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName).ChangePanel(GuildEnum.PANEL_SKILL );
		});
		this.btnBoss.addClickEventListener(function (event){
			Mgr.uiMgr.GetPanelByType(GuildPanelExt.PanelName).ChangePanel( GuildEnum.PANEL_BOSS );
		});

		this.btnChange.addClickEventListener(function (event){
			Mgr.uiMgr.ShowPanelByType(GuildNoticePanelExt.PanelName);
		});

		this.btnQuit.addClickEventListener(function (event){
			if(!Mgr.guild.CheckGuildActivityIsOpen() && !Mgr.guild.CheckGuildBossActivityIsOpen()){
				Mgr.tips.ShowNotice("帮派活动尚未开启");
				return;
			}
			if ( this.type == 1 ) {   // 退出领地
				Mgr.zone.SendReqZoneOutToGameMessage();
			}
			else {  // 进入禁地
				Mgr.guild.SendReqGuildEnterForbiddenMessage();
			}
			Mgr.uiMgr.HidePanelByType(GuildPanelExt.PanelName);
		});

		this.imgModel.y -= 30;

		this._InitPanel();
	},

	_InitPanel:function () {
		this._InitParam();
	},

	_InitParam:function () {
		this.labGuildName1.SetString("");
		this.labGuildLevel1.SetString("");
		this.labGuildMembers1.SetString("");
		this.labBangZhu1.SetString("");

		this.editNotice.setString("");

		this.labChange.setVisible(false);

		this.labName.SetString("");
		this.imgGeted.setVisible(false);

		this.labTime.SetString("");
	},

	SetDailyWelfare:function ( boo ) {
		this._isGted = boo;
		this.imgGeted.setVisible(boo);
		this.imgCue.visible = !boo;
	},

	editBoxTextChanged: function (editBox, text) {
		cc.log("editBox "  + ", TextChanged, text: " + text);
		var ediText = editBox.getString();
		if (this.editNotice == editBox) {
			if ( ediText != "" ) {
				this.BrushGuildNotice(ediText);
				//this.labNotice.SetString( ediText );
				//this.editNotice
			}
		}
	},

	BrushGuildNotice:function (notice) {
		if(notice == null){
			notice = "            暂无公告!";
		}
		this.labNotice.SetString(notice);
	},

	SetData:function () {
		var guildId = Mgr.player.mainPlayer.guildId;
		var guildInfo = Mgr.guild.guildMap.Get( guildId.hexValue );
		cc.assert(null != guildInfo, "guildInfo can't be nil!  guildId: " + guildId);

		if(!guildInfo){
			Mgr.tips.ShowNotice("guildInfo is null!!!");
			return;
		}

		// guild name
		var str = guildInfo.guildName;
		this.labGuildName1.SetString( str );

		// guild level
		str = guildInfo.level;
		this.labGuildLevel1.SetString( str );

		// guild num
		var guildC = Q_guild.Get( guildInfo.level );
		cc.assert(null != guildC, "guildC can't be nil!  level: " + guildInfo.level);
		str = guildInfo.memberNum + "/" + guildC.q_member;
		this.labGuildMembers1.SetString( str );

		// guilder name
		str = guildInfo.bangZhuName;
		this.labBangZhu1.SetString( str );

		// 更改公告
		var mainSid = Mgr.player.mainPlayer.sid;
		var LeaderId = guildInfo.bangZhuid;
		var isguilder = mainSid.Equal( LeaderId );
		this.labChange.setVisible( isguilder );

		// 公告I
		this._orgStrNotice = guildInfo.guildAnnouncement;
		//this.labNotice.setPlaceHolder( "请输入公会公告内容" );
		this.BrushGuildNotice(this._orgStrNotice);
		//this.labNotice.SetString( this._orgStrNotice );
		this.editNotice.setDelegate(this);
		this.editNotice.setOpacity(0);
		//if ( !isguilder )
			this.editNotice.enabled = false;
		//this.editNotice.addEventListener(this._TextFieldEvent);

		// guilder name
		this.labName.SetString(guildInfo.bangZhuName);

		// 获取脱机外挂状态
		Mgr.guild.SendReqWelfareStateMessage();

		var second = guildC.q_time_offline;
		var H =  Math.floor(second/3600);
		var M = Math.floor(second/60%60);

		var restTimeStr;
		if(H>0) {
            restTimeStr = H + "时";
        }else {
            restTimeStr = 0 + "时";
		}
		if(M>0){
			restTimeStr += M+"分";
		}else{
            restTimeStr += 0+"分";
		}
		UIUtil.ConnectLabelHtmlText( this.labTime, [restTimeStr] );

		// btn state
		if ( Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_GUILDBOSS ) {
			this.btnQuit.setTitleText("退出领地");
			this.btnQuit.type = 1;
		}
		else {
			this.btnQuit.setTitleText("进入领地");
			this.btnQuit.type = 0;
		}

		// model
		// 获取玩家简要信息
		var personId = guildInfo.bangZhuid;
		Mgr.player.SendReqPlayerBriefMessage([personId],EnumBriefType.TEAM_MAP_INVISITE);
	},

	_TextFieldEvent: function(textField, type){
		switch (type){
			case ccui.TextField.EVENT_ATTACH_WITH_IME:
				cc.log("attach with IME  " );
				break;
			case ccui.TextField.EVENT_DETACH_WITH_IME:
				cc.log("detach with IME");
				textField.SetText( textField.parent._orgStrNotice );
				break;
			case ccui.TextField.EVENT_INSERT_TEXT:
				cc.log("insert words");
				break;
			case ccui.TextField.EVENT_DELETE_BACKWARD:
				cc.log("delete word");
				break;
			default:
				break;
		}
	},

	SetPlayerBriefMsg:function ( data ) {
		this._AddPlayerModule(data)
	},

	_AddPlayerModule:function( info )
	{
		if( !this._uiModel ){
			this._uiModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(info));
			this.imgModel.addChild(this._uiModel);
		}
		else{
			this._uiModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(info));
		}
		for( var i = 0; i < info.reslineInfo.length; i++ ){
			var resline = info.reslineInfo[i];
			if( resline.reslineType == EnumResline.GUANGWU )
				this._uiModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(info.illusionDataInfos) || resline.reslineModelId, info.job);
		}
	},

	OnHide:function(){
		this._super();
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	},

	OnShow:function () {
		if ( this._sended ) {   // 避免死循环
			this._sended = false;
			this.SetData();
		}
		else {
			this._sended = true;
			Mgr.guild.SendReqUpdateGuildInfoMessage();
		}
	},
} );
GuildInfoPanelExt.PanelName = "GuildInfoPanelExt";
PanelClassDic["GuildInfoPanelExt"] = GuildInfoPanelExt;
