var GuildMemberExt = GuildMember.extend ( {
	_className:"GuildMemberExt",

	// 链表三件套
	_listView : null,
	_itemList:null,

	_curSelectKey:null,
	_curSelectItem:null,

	// 排序按钮  // 排序方式  0:普通排序  1：按职位   2：按等级  3：按战力  4：按帮贡 5:按离线时间
	_sortType:null,
	_sortLables:null,

	_restTime:null,
	_timerNum:null,

	ctor:function(){
		this._super();
		this._itemList = [];
		this._sortLables = [];
		this._sortType = 1 ;
		this._timerNum = 0;
		this._restTime = 0;
	},
	Init:function() {
		GuildMember.prototype.Init.call(this);

		this._InitPanel();
		this._RegisterListeners()
	},

	_RegisterListeners:function () {
		var self = this;
		this.btnApplyMember.addClickEventListener(function (event){
			Mgr.uiMgr.ShowHidePanelByType( GuildApplyListExt.PanelName );
		});

		// checkBox
		this.sbtnGouxuan.SetButtonState( "uncheck" );
		this.sbtnGouxuan.setTouchEnabled(true);
		this.sbtnGouxuan.addTouchEventListener(function (sender, type) {
			if (type == ccui.Widget.TOUCH_ENDED) {
				var state = sender.GetState();

				var boo = (state == "check") ? true : false;
				if (boo)
					sender.SetButtonState("uncheck");
				else
					sender.SetButtonState("check");
				self._LaodItems(self._sortType);
			}
		});

		for ( var i = 0; i != this._sortLables.length; i++ ) {
			var _label = this._sortLables[i].label;
			var _type = this._sortLables[i].type;
			// 排序
			(function (_type) {
				_label.setTouchEnabled(true);
				_label.addTouchEventListener(function (sender, type) {
					if (type == ccui.Widget.TOUCH_BEGAN) {
						sender.setScale(1.01);
					}
					else if (type == ccui.Widget.TOUCH_ENDED) {
						sender.setScale(1.0);
						if ( !sender.sortIndex )    // 第一次，向下排序
							sender.sortIndex = true;
						else
							sender.sortIndex = !sender.sortIndex;

						self._LaodItems(_type, sender.sortIndex);
					}
					else if (type == ccui.Widget.TOUCH_CANCELED) {
						sender.setScale(1.0);
					}
				});
			})(_type);
		}
	},

	_InitPanel:function () {
		// pos
		this.x = 0;
		this.y = 0;

		this._InitParam();
	},

	_InitParam:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(0);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);
		list.addEventListener(this._SelectedItemEvent);
		this.imgBg1.addChild(list);
		this._listView = list;

		this._sortLables = [
			{label:this.labJob, type:1, sortIndex:true},    // sortIndex:true   向下排序    false: 向上排序
			{label:this.labLevel, type:2, sortIndex:true},
			{label:this.labFight, type:3, sortIndex:true},
			{label:this.labGongxian, type:4, sortIndex:true},
			{label:this.labLastTime, type:5, sortIndex:true},
		];
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:
				var parent = sender.parent.parent;
				if ( parent._curSelectItem != null) {
					parent._curSelectItem.SetSelect(false);
					parent._curSelectItem = null;
					parent._curSelectKey = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent._curSelectItem = itemSelect;
				parent._curSelectKey = itemSelect.GetData().playerId;

				//if ( itemSelect.GetData().playerId.Equal(Mgr.player.mainPlayer.sid) )
					//return;
				// playerInfo panle
				// 获取玩家简要信息  (先发协议，代码会有点乱)
				Mgr.player.SendReqPlayerBriefMessage([itemSelect.GetData().playerId],EnumBriefType.TEAM_MAP_INVISITE);
				break;

			default:
				break;
		}
	},

	SetPlayerBriefMsg:function ( data ) {
		// 角色详情界面
		var panel = Mgr.uiMgr.ShowPanelByType( OtherRolePanelExt.PanelName );
		panel.SetData(data, EnumDetails.OPEN_MODE_GUILD_MEMBER);
		this._checkMemberId = data.playerid;
	},

	CallBackProp:function () {
		this.SetJiesanState();
		this._LaodItems();
		this.UpdataWarn();
	},

	SetJiesanState:function () {
		var guildInfo = Mgr.guild.guildMap.Get( Mgr.player.mainPlayer.guildId.hexValue );
		var isguilder = Mgr.player.mainPlayer.sid.Equal( guildInfo.bangZhuid );
		// btn
		var type, str;
		if ( !isguilder ) {
			str = "退出帮会";
			type = 1;
		}
		else {
			if ( Mgr.guild.deleteCountdown > 0 ) {
				str = "取消解散";
				type = 2;
			}
			else {
				str = "解散帮会";
				type = 3;
			}
		}
		this.btnQuit.type = type;
		this.btnQuit.setTitleText( str );
		this.btnQuit.addClickEventListener(this._PowerHander.bind(this));

		// time
		this._restTime = Mgr.guild.deleteCountdown;
		if ( this._restTime > 0 ) {
			this.labDownTime.visible = true;
			if( this._timerNum == 0 )
				this._timerNum = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
			this.OnTimer();
		}
		else {
			this.labDownTime.visible = false;
		}
	},

	OnTimer:function () {
		this._restTime--;
		if ( this._restTime <= 0 )
		{
			this._restTime = 0;
			TimerUtil.ClearTimeUpdate(this._timerNum, this);
			this._timerNum = 0;
		}
		var second = this._restTime;
		var H =  Math.floor(second/3600);
		var M = Math.floor(second/60%60);
		var S = Math.floor(second%60);
		UIUtil.ConnectLabelHtmlText(this.labDownTime, [H,M,S]);
	},

	_PowerHander:function (event) {
		if (event.type == 1) {
			AlertExt.Show( "是否确认退出帮会?",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.guild.SendReqGuildQuitMessage();
				},
			},1);
		}
		else if ( event.type == 2 ) {
			AlertExt.Show( "是否确认取消解散帮会?",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.guild.SendReqGuildDeleteGuildMessage(0);
				},
			},1);
		}
		else if ( event.type == 3 ) {
			AlertExt.Show( "是否确认解散帮会?",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.guild.SendReqGuildDeleteGuildMessage(1);
				},
			},1);
		}
	},

	_BrushOnlineMembers:function() {
		var maxMembers = 0;
		var realMembers = 0;
		var onlineMembers = 0;

		var members = Mgr.guild.guildMembers;
		realMembers = members.Values().length;
		for ( var i = 0; i != members.Values().length; i++ ) {
			if ( members.Values()[i].isOnline > 0 )
				++onlineMembers;
		}

		//
		var guildId = Mgr.player.mainPlayer.guildId;
		var info = Mgr.guild.guildMap.Get(guildId.hexValue);
		if ( info ) {
			maxMembers = Q_guild.Get(info.level).q_member;
		}

		UIUtil.ConnectLabelHtmlText(this.labCue, [onlineMembers, realMembers, maxMembers]);
	},

	_LaodItems:function (sortType, index) {
		this._sortType = arguments.length > 0 ? parseInt(sortType):0;

		var memberMap = Mgr.guild.guildMembers;
		if ( memberMap.IsEmpty() )
			return;

		// // 提取自身信息
		// var playerId = Mgr.player.mainPlayer.sid;
		// var playerInfo = memberMap.Get( playerId );
		// cc.assert(null != playerInfo, "playerInfo can't be nil!  playerId: " + playerId);
		// memberMap.Remove( playerId );

		// 分离离线玩家
		var list = [], offLineList = [];
		memberMap.EachValue(function(obj){
			if (obj.isOnline > 0 )
				list.push(obj);
			else
				offLineList.push(obj);
		});

		// 先按正常排序
		list.sort(this._SortFunc);
		offLineList.sort(this._SortFunc);

		var gouxuan = (this.sbtnGouxuan.GetState() == "check") ? true : false;
		if ( !gouxuan ) {
			list = list.concat(offLineList);
		}

		// 非正常排序
		if ( this._sortType == 1 ) {
			if ( index )
				list.sort(this._SortFunc1);
			else
				list.sort(this._SortFunc1_reverse);
		}
		else if ( this._sortType == 2 ) {
			if ( index )
				list.sort(this._SortFunc2);
			else
				list.sort(this._SortFunc2_reverse);
		}
		else if ( this._sortType == 3 ) {
			if ( index )
				list.sort(this._SortFunc3);
			else
				list.sort(this._SortFunc3_reverse);
		}
		else if ( this._sortType == 4 ) {
			if ( index )
				list.sort(this._SortFunc4);
			else
				list.sort(this._SortFunc4_reverse);
		}
		else if ( this._sortType == 5 ) {
			if ( index )
				list.sort(this._SortFunc5);
			else
				list.sort(this._SortFunc5_reverse);
		}

		// // 置顶自身
		// list.unshift( playerInfo );
		// memberMap.Put( playerId, playerInfo );

		var i;
		var boo = false;
		for ( i = 0; i != list.length; i++ ) {
			var item;
			if ( i < this._itemList.length )
				item = this._itemList[i];
			else {
				item = new GuildMemberItemExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
			}
			boo = !boo;
			item.SetData( list[i], boo );
			if (!item.parent)
				this._AddItem(item);
		}
		for ( ;i < this._itemList.length; i++ ) {
			var item = this._itemList[i];
			if ( item.parent )
				this._listView.removeChild( item); //.removeFromParent();
		}

		// select
		this._ResetSelectItem();
		if ( this._curSelectItem ) {
			if( Mgr.uiMgr.IsPanelShowByName( OtherRolePanelExt.PanelName ))
				Mgr.player.SendReqPlayerBriefMessage([this._curSelectItem.GetData().playerId],EnumBriefType.TEAM_MAP_INVISITE);
		}
		else
			Mgr.uiMgr.HidePanelByType( OtherRolePanelExt.PanelName )

		// 刷新在线成员数
		this._BrushOnlineMembers();
	},

	_ResetSelectItem:function ( ) {
		if ( this._curSelectItem ) {
			this._curSelectItem.SetSelect(false);
			this._curSelectItem = null;
		}

		if ( this._curSelectKey ) {
			var items = this._listView.getItems();
			for (var i = 0; i != items.length; i++) {
				var playerId = items[i].GetData().playerId;
				if (this._curSelectKey.Equal(playerId)) {
					this._curSelectItem = items[i];
					this._curSelectItem.SetSelect(true);
					break;
				}
			}
		}
	},

	// 按战力、职位、等级、、帮贡、离线排序
	_SortFunc:function(a, b) {
		if (a.fightPower < b.fightPower) {
			return 1;
		}
		else if ( a.fightPower == b.fightPower ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc1:function(a, b) {
		if (a.guildPowerLevel > b.guildPowerLevel) {
			return 1;
		}
		else if ( a.guildPowerLevel == b.guildPowerLevel ) {
			if ( a.fightPower < b.fightPower ) {
				return 1;
			}
		}
		return 0;
	},

	_SortFunc1_reverse:function(a, b) {
		if (a.guildPowerLevel < b.guildPowerLevel) {
			return 1;
		}
		else if ( a.guildPowerLevel == b.guildPowerLevel ) {
			if ( a.fightPower < b.fightPower ) {
				return 1;
			}
		}
		return 0;
	},

	_SortFunc2:function(a, b) {
		if (a.level < b.level) {
			return 1;
		}
		else if ( a.level == b.level ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc2_reverse:function(a, b) {
		if (a.level > b.level) {
			return 1;
		}
		else if ( a.level == b.level ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},

	_SortFunc3:function(a, b) {
		if (a.fightPower < b.fightPower) {
			return 1;
		}
		else if ( a.fightPower == b.fightPower ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc3_reverse:function(a, b) {
		if (a.fightPower > b.fightPower) {
			return 1;
		}
		else if ( a.fightPower == b.fightPower ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},

	_SortFunc4:function(a, b) {
		if (a.devoteValue < b.devoteValue) {
			return 1;
		}
		else if ( a.devoteValue == b.devoteValue ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc4_reverse:function(a, b) {
		if (a.devoteValue > b.devoteValue) {
			return 1;
		}
		else if ( a.devoteValue == b.devoteValue ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc5:function(a, b) {
		if (a.lastOnlineTime < b.lastOnlineTime) {
			return 1;
		}
		else if ( a.lastOnlineTime == b.lastOnlineTime ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},
	_SortFunc5_reverse:function(a, b) {
		if (a.lastOnlineTime > b.lastOnlineTime) {
			return 1;
		}
		else if ( a.lastOnlineTime == b.lastOnlineTime ) {
			if ( a.guildPowerLevel > b.guildPowerLevel ) {
				return 1;
			}
		}
		return 0;
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	OnShow:function () {
		// 帮会成员信息
		Mgr.guild.SendReqGuildGetMemberListMessage();
		this.UpdataWarn();
	},

	UpdataWarn:function () {
		var warn = (Mgr.guild.guildAppliedHash.Values().length > 0 && ( Mgr.guild.IsGuilder() || Mgr.guild.IsSecondGuilder()) );
		this.imgTanhao.visible = warn;
	},
} );
GuildMemberExt.PanelName = "GuildMemberExt";
PanelClassDic["GuildMemberExt"] = GuildMemberExt;
