///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ShowIllusionInfo 幻化外显信息
//IllusionInfo 幻化对象数据信息
//IllusionDataInfo 单个幻化类型数据信息

// 请求消息
//238201,ReqIllusionDataInfoToGame 请求幻化数据信息
//238202,ReqUseIllusionToGame 请求使用这个幻化展示
//238203,ReqAddIllusionToGame 请求激活这个幻化

// 接收消息
//238101,ResAllIllusionDataInfoToClient 发送整个幻化数据信息 
//238102,ResIllusionDataInfoToClient 发送单个幻化数据信息 
//238103,ResChangeIllusionShowToClient 发送切换 幻化ID信息（广播） 
//238104,ResAddIllusionResultToClient 发送激活幻化结果


var ShowIllusionInfo = cc.Class.extend({
	ctor:function(){
		this.illusionId = 0; // 展示的幻化ID 
        this.illusionType = 0; // 展示的幻化类型 
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
	},
	
	reading:function( _buf ){
		this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
	},
});
var IllusionInfo = cc.Class.extend({
	ctor:function(){
		this.skillInfo = null; // 技能信息
        this.illusionId = 0; // 幻化ID 
        this.illusionType = 0; // 幻化类型 
	},

	writing:function( _buf ){
		_buf.WriteBean(this.skillInfo);
        _buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
	},
	
	reading:function( _buf ){
		this.skillInfo = _buf.ReadBean(SkillInfo);
        this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
	},
});
var IllusionDataInfo = cc.Class.extend({
	ctor:function(){
		this.illusionType = 0; // 幻化类型 
        this.illusionShowId = 0; // 当前展示的幻化ID 
        this.qianNengNum = 0; // 潜能丹数量
        this.huanHuaNum = 0; // 幻化丹数量 
        this.illusionInfoList = []; // 已激活的该类型幻化数据 IllusionInfo
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionType);
        _buf.WriteVarInt(this.illusionShowId);
        _buf.WriteVarInt(this.qianNengNum);
        _buf.WriteVarInt(this.huanHuaNum);
        _buf.WriteShort( this.illusionInfoList.length );
        for (var i = 0; i < this.illusionInfoList.length; i++) {
            _buf.WriteBean(this.illusionInfoList[i]);
        }
	},
	
	reading:function( _buf ){
		this.illusionType = _buf.ReadVarInt();
        this.illusionShowId = _buf.ReadVarInt();
        this.qianNengNum = _buf.ReadVarInt();
        this.huanHuaNum = _buf.ReadVarInt();
        var illusionInfoList_length = _buf.ReadShort();
        for (var i = 0; i < illusionInfoList_length; i++) {
            this.illusionInfoList[i] = _buf.ReadBean(IllusionInfo);
        }
	},
});
////////////////////
// 发送整个幻化数据信息  //
////////////////////
var ResAllIllusionDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionDataInfoList = []; // 整个幻化数据信息 IllusionDataInfo
	},

	getId:function(){
		return 238101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.illusionDataInfoList.length );
        for (var i = 0; i < this.illusionDataInfoList.length; i++) {
            _buf.WriteBean(this.illusionDataInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        var illusionDataInfoList_length = _buf.ReadShort();
        for (var i = 0; i < illusionDataInfoList_length; i++) {
            this.illusionDataInfoList[i] = _buf.ReadBean(IllusionDataInfo);
        }
	},

	action:function(){
		Mgr.illusion.RecvResAllIllusionDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送单个幻化数据信息  //
////////////////////
var ResIllusionDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionType = 0; // 幻化类型 
        this.illusionDataInfo = null; // 幻化数据信息
	},

	getId:function(){
		return 238102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionType);
        _buf.WriteBean(this.illusionDataInfo);
	},
	
	reading:function( _buf ){
        this.illusionType = _buf.ReadVarInt();
        this.illusionDataInfo = _buf.ReadBean(IllusionDataInfo);
	},

	action:function(){
		Mgr.illusion.RecvResIllusionDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送切换 幻化ID信息（广播）  //
////////////////////
var ResChangeIllusionShowToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionId = 0; // 幻化ID 
        this.illusionType = 0; // 幻化类型 
        this.playerId = null; // 玩家ID
	},

	getId:function(){
		return 238103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
        _buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
	},

	action:function(){
		Mgr.illusion.RecvResChangeIllusionShowToClientMessage(this);
	},

});
////////////////////
// 发送激活幻化结果 //
////////////////////
var ResAddIllusionResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionId = 0; // 幻化ID 
        this.illusionType = 0; // 幻化类型 
        this.type = 0; // 激活类型(1是道具2是任务...)
        this.result = 0; // 操作结果(0是成功1是失败)
	},

	getId:function(){
		return 238104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.result);
	},
	
	reading:function( _buf ){
        this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.illusion.RecvResAddIllusionResultToClientMessage(this);
	},

});
////////////////////
// 请求幻化数据信息 //
////////////////////
var ReqIllusionDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionType = 0; // 幻化类型
	},

	getId:function(){
		return 238201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionType);
	},
	
	reading:function( _buf ){
        this.illusionType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求使用这个幻化展示 //
////////////////////
var ReqUseIllusionToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionId = 0; // 幻化ID（0表示脱下）
        this.illusionType = 0; // 幻化类型 
	},

	getId:function(){
		return 238202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
	},
	
	reading:function( _buf ){
        this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求激活这个幻化 //
////////////////////
var ReqAddIllusionToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.illusionId = 0; // 幻化ID
        this.illusionType = 0; // 幻化类型 
	},

	getId:function(){
		return 238203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.illusionId);
        _buf.WriteVarInt(this.illusionType);
	},
	
	reading:function( _buf ){
        this.illusionId = _buf.ReadVarInt();
        this.illusionType = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(238101, ResAllIllusionDataInfoToClientMessage);
MESSAGE_POOL.Add(238102, ResIllusionDataInfoToClientMessage);
MESSAGE_POOL.Add(238103, ResChangeIllusionShowToClientMessage);
MESSAGE_POOL.Add(238104, ResAddIllusionResultToClientMessage);

