var KingGuildTaskTrackPanelExt = MUIPanel.extend ( {
    _className:"KingGuildTaskTrackPanelExt",

    ctor:function(parent){
        this._super();


        parent.height = 270;
        this.width = parent.width;
        this.height = parent.height;

        this.confLab = [
            { name : "labTitle" , size:24,color:"0xf2a757",},
            { name : "labOwner" , size:20,color:ColorUtil.N_GREEN_STR,},
            { name : "labDesc" , size:18,color:"0xf2a757",},
            { name : "labLeftTime" , size:22,color:"0xf2a757",},
            { name : "labTarget" , size:20,color:ColorUtil.SYS_RED,},
            { name : "labTarget0" , size:20,color:ColorUtil.SYS_GREEN,},
            { name : "labTarget1" , size:20,color:ColorUtil.SYS_GREEN,},
        ];

        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30;
            label.SetFontSize(v.size);
            label.SetUISize(200);
            label.SetColor(v.color);
            this.addChild(label);
            this[v.name] = label;

        }
        this.labDesc.SetMultiline(true);
        this.labDesc.SetUISize(200);


        this.labTitle.SetText("[定时活动] 帮派争霸");
        this.labDesc.SetText("活动结束时旗帜归属帮会占领此领地，每个帮会只能占领一个领地。");
        this.labTarget.SetText("<u>争夺帮派旗帜</>");
        this.labTarget.setTouchEnabled(true);
        this.labTarget.addClickEventListener(function(config){
            // 找点怪打打
            var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
            var boss,normal
            for(var v of list){
                if(!v.IsDeadState()){
                    if( v.IsBoss() ){
                        boss = v;
                    }else{
                        normal = v;
                    }
                }
            }
            if(boss) {
                Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, boss.oServPt, AutoPathParam.CreateAutoFight());
            }else if(normal) {
                Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, normal.oServPt, AutoPathParam.CreateAutoFight());
            }
        }.bind(this));
        this.UpdateView();

    },

    Init:function(){
        this._super();

    },

    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
         if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);

    },

    OnTimer:function(){
        var owner = Mgr.kingguild.battleInfo && Mgr.kingguild.battleInfo.ocguildname || "虚位以待";
        this.labOwner.SetText(this.curMapName + "[" + owner +"]");

        var serverTime = Mgr.login.GetServerTime()/1000;
        var leftTime = Mgr.kingguild.endTime - serverTime;
        var text = leftTime < 0 ?"??:??" : TextUtil.SecondToHMS2( leftTime);
        this.labLeftTime.SetText(TextUtil.AddColor(text, ColorUtil.SYS_RED) + "后活动结束");

//remandtime

    },

    UpdateView:function(){
        var mapConfig = [
            { mapid:18010,name:"青龙城",zoneid:12004 ,},
            { mapid:18011,name:"白虎城",zoneid:12005 ,},
            { mapid:18012,name:"玄武城",zoneid:12006,},
        ];

        this.OnTimer();

        var curMapId = Mgr.sceneMap.nMapId;
        for(var length=mapConfig.length,k=0,config=mapConfig[k];k<length;config=mapConfig[++k]){
            if(config.mapid == curMapId){
                mapConfig.splice(k,1);
                this.curMapName = config.name;
                break;
            }
        }

        for(var length=mapConfig.length,k=0,config=mapConfig[k];k<length;config=mapConfig[++k]){
            this["labTarget" + k].SetText("<u>前往" + config.name + "</u>");
            this["labTarget" + k].setTouchEnabled(true);
            this["labTarget" + k].addClickEventListener(function(config){
                  Mgr.kingguild.SendReqkingguildEnterClientToGameMessage({
                      zoneid: config.zoneid,
                  });
            }.bind(this,config));
        }

        var height = this.height - 5;
        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {

            height -= this[v.name].GetHeight() + 10;

            this[v.name].y = height;

        }
    }
});

KingGuildTaskTrackPanelExt.PanelName = "KingGuildTaskTrackPanelExt";
PanelClassDic["KingGuildTaskTrackPanelExt"] = KingGuildTaskTrackPanelExt;


var KingNeutralTaskTrackPanelExt = MUIPanel.extend ( {
    _className:"KingNeutralTaskTrackPanelExt",

    ctor:function(parent){
        this._super();


        parent.height = 270;
        this.width = parent.width;
        this.height = parent.height;

        this.confLab = [
            { name : "labTitle" , size:24,color:"0xf2a757",},
            { name : "labSubTitle" , size:20,color:ColorUtil.N_GREEN_STR,},
            { name : "labDesc" , size:18,color:"0xf2a757",},
            { name : "labLeftTime" , size:22,color:"0xf2a757",},
            { name : "labTarget" , size:20,color:ColorUtil.SYS_RED,},

        ];

        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30;
            label.SetFontSize(v.size);
            label.SetUISize(250);
            label.SetColor(v.color);
            label.SetLeading(0);
            this.addChild(label);
            this[v.name] = label;

        }
        this.labDesc.SetMultiline(true);
        this.labDesc.SetUISize(200);


        this.labTitle.SetText("[定时活动] 王城领地站");

        this.UpdateView();
    }   ,
    Init:function(){
        this._super();

    },
    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
         if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);

    },

    OnTimer:function(){
        var battleInfo =  Mgr.kingneutral.battleInfo;
        if(!battleInfo) return;
        var serverTime = Mgr.login.GetServerTime()/1000;
        var leftTime = battleInfo.__remandtime - serverTime;
        var text = leftTime < 0 ?"??:??" : TextUtil.SecondToHMS2( leftTime);

        if(this.isInCity ){
            var holdTime = serverTime - battleInfo.__npcOwnTime;
            if(!(battleInfo && battleInfo.npcOwnId != 0)) holdTime = 0;

            var textHold = leftTime < 0 ?"??:??" : TextUtil.SecondToHMS2( holdTime);
            var holdLeftTime = Math.max(0,600 - holdTime);
            var textHoldLeft = TextUtil.SecondToHMS2( holdLeftTime);

            var pos = cc.p(0,0);
            if(battleInfo && battleInfo.npcOwnId != 0){
                var obj = Mgr.sceneObj.FindObject(battleInfo.npcOwnId.toGID());
                if(obj) pos = obj.oServPt;
            }else{
                var list = Mgr.sceneObj.oRoundNpcList.oHashList.aList;

                for (var length =list.length,i = 0, v = list[i]; i < length; v = list[++i]) {
                    if(v.nBodyModelId == 1041){
                        break;
                    }
                }
                if(v){
                    pos = v.oServPt;
                }
            }

            this.labLeftTime.SetText(TextUtil.AddColor(text, ColorUtil.SYS_RED) + "后活动结束");
            this.labDesc.SetText("玉玺持有人：" + (battleInfo.npcOwnName || '无')
                +"\n玉玺位置：<u>" + pos.x + ":" + pos.y + "</u>"
                + "\n当前被持有时间：" + textHold
                + "\n继续持有" + textHoldLeft + "后将获得胜利");



            var height = this.height - 5;
            for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {

                height -= this[v.name].GetHeight() + 10;

                this[v.name].y = height;
            }
        }else{
            this.labLeftTime.SetText(TextUtil.AddColor(text, ColorUtil.SYS_RED) + "后城门将彻底关闭");
        }
    },
    UpdateView:function(){

        var curMapId = Mgr.sceneMap.nMapId;
        var isInCity = false;
        switch(curMapId){
            case 18006:
            case 18007:
            case 18008:
                isInCity = false;
                break;
            default:
                isInCity = true;
                break

        }
        this.isInCity = isInCity;
        if(isInCity){

            this.labSubTitle.SetText("内城战");
            this.labDesc.SetText("玉玺持有人：\n玉溪位置\n当前呗持有时间\n继续持有多久");
            this.labTarget.visible = false;

            this.labDesc.setTouchEnabled(true);
            this.labDesc.addClickEventListener(function(config){
                var battleInfo =  Mgr.kingneutral.battleInfo;
                if(battleInfo && battleInfo.npcOwnId != 0){
                    var obj = Mgr.sceneObj.FindObject(battleInfo.npcOwnId.toGID());
                    if(obj) Mgr.mainPlayer.oCtrlAutoPath.RunToPt(obj.oServPt, AutoPathParam.CreateAutoFight(), true);
                }else{
                    var list = Mgr.sceneObj.oRoundNpcList.oHashList.aList;
                    for (var length =list.length,i = 0, v = list[i]; i < length; v = list[++i]) {
                        if(v.nBodyModelId == 1041){
                          break;
                        }
                    }
                    if(v){
                        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(v.oServPt, AutoPathParam.CreateSelectNpcInfo(v), true);
                    }
                }
            })

            this.OnTimer();
        }else{

            this.labSubTitle.SetText("外城战");
            this.labDesc.SetText("时间紧迫，请速速攻破城门，进入内城，5分钟后城门将彻底关闭，无法进入，击破城门可获得丰厚奖励。");
            this.labDesc.setTouchEnabled(false);
            this.labTarget.visible = true;
            this.labTarget.SetText("<u>攻破城门进入内城</u>");
            this.labTarget.setTouchEnabled(true);
            this.labTarget.addClickEventListener(function(config){
                // 找点怪打打
                var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
                var boss,normal
                for(var v of list){
                    if(!v.IsDeadState()){
                        if( v.IsBoss() ){
                            boss = v;
                        }else{
                            normal = v;
                        }
                    }
                }
                if(boss) {
                    Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, boss.oServPt, AutoPathParam.CreateAutoFight());
                }else if(normal) {
                    Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, normal.oServPt, AutoPathParam.CreateAutoFight());
                }
            }.bind(this));
        }

        var height = this.height - 5;
        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {

            height -= this[v.name].GetHeight() + 10;

            this[v.name].y = height;

        }
    },
});
KingNeutralTaskTrackPanelExt.PanelName = "KingNeutralTaskTrackPanelExt";
PanelClassDic["KingNeutralTaskTrackPanelExt"] = KingNeutralTaskTrackPanelExt;
