var ChooseServerPanelExt = function(){
    var ChooseServerPanelExt = ChooseServerPanel.extend ( {
        _className:"ChooseServerPanelExt",
        severIcoList:null,
        TYPE : {
            OWN : 1,
            RECOMMAND : 2,
        },
        ctor:function(){
            this._super();
            this.modelPanelType = MUIPanelModelType.ALPHABLACK;
            this.layoutCom.layoutType = MLLAYOUT_C;
            this.severIcoList=[];
            this.showLayerType = UIMgr.PANEL_LAYER_TOP;
            this.CELL_HEIGHT = 102;

            this.selectedType = this.TYPE.RECOMMAND;
        },
        Init:function () {
            ChooseServerPanel.prototype.Init.call( this );
            this.setLocalZOrder(1000);
            this.sbtnTuiJian.SetButtonState("check");
            this.sbtnTuiJian.SetText("推荐");

            this.sbtnYiyou.addClickEventListener(function(event){
                this.selectedType = this.TYPE.OWN;
                this.FilterServerAndReload();
            }.bind(this));
            this.sbtnTuiJian.addClickEventListener(function(event){
                this.selectedType = this.TYPE.RECOMMAND;
                this.FilterServerAndReload();
            }.bind(this));


            var size = this.imgTitleBg.getContentSize();
            var contentSize = cc.size(size.width, this.CELL_HEIGHT * 5)
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            //tableView.setTouchEnabled(false);
            tableView.setPosition(0, size.height - contentSize.height + 5);
            tableView.reloadData();

            this.imgTitleBg.addChild(tableView);
            this.tableView = tableView;
        },

        FilterServerAndReload:function(){
            var severList = this.serverList;

            switch(this.selectedType){
                case this.TYPE.OWN:
                {
                    var temp = [];
                    var roles = GameConfig.roleData || [];
                    for(var i=0;i<roles.length;++i){
                        var v = roles[i];
                        for(var j=0;j < severList.length;++j){
                            var vv = severList[j];
                            if(v.serverId == vv.SERVER_ID){
                                temp.push(vv);
                                break;
                            }
                        }
                    }
                    severList = temp;
                    break;
                }
                case this.TYPE.RECOMMAND:
                default:
                    break;
            }

            this.data = severList;
            this.tableView.reloadData();
        },
        UpdateSever:function (severList) {
            this.serverList = severList || this.serverList;
            this.FilterServerAndReload();
        },
        tableCellSizeForIndex:function(sender,index){
            if(this.selectedType == this.TYPE.OWN){
                return cc.size(sender.width,sender.getViewSize().height / 2);
            }
            // 加点间距
            return cc.size(sender.width,this.CELL_HEIGHT);
        },

        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
                cell = new Cell();
            }

            cell.UpdateView(this,sender,index);
            return cell;
        },

        numberOfCellsInTableView:function(sender){
            if(this.selectedType == this.TYPE.OWN){
                return this.data ? Math.ceil(this.data.length / 4) : 0;
            }
            return this.data ? Math.ceil(this.data.length / 2) : 0;
        },
    } );

    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        UpdateView:function(target){
            if(this._ownCell) this._ownCell.visible = false;
            if(this._commonCell) this._commonCell.visible = false;

            var cell
            if(target.selectedType == target.TYPE.OWN){
                if(!this._ownCell){
                    this._ownCell = new CellOwn();
                    this.addChild(this._ownCell);
                }
                cell = this._ownCell;
            }else{
                if(!this._commonCell){
                    this._commonCell = new CellCommon();
                    this.addChild(this._commonCell);
                }
                cell = this._commonCell;
            }
            cell.visible = true;
            cell.UpdateView.apply(cell,arguments);
        },
    })
    var CellCommon = ccui.Widget.extend({
        ctor:function(){
            this._super();
            this.setAnchorPoint(cc.p(0,0));
            this._cells = {};

            //this.setBackGroundColorType(1)
            //this.setBackGroundColor(cc.color(0x00,0x00,0xFF,0xFF))
            //this.setBackGroundColorOpacity(0xFF* 0.5)
        },
        UpdateView:function(target,sender,index){
            var data = target.data;

            var pos = [0,sender.width / 2 - 5];
            for(var i=0;i!=2;++i){
                var v = data[index * 2 + i];
                var c = this._cells[i];
                if(v && !c){
                    c = new ServerListExt();
                    c.LoadPanel();
                    this.addChild(c)
                    c.x = pos[i];
                    c.y = -7;
                    this._cells[i] = c;
                }

                if(c) c.visible = v;
                if(c && v) c.SetData(v);
            }
        },
    })
    var CellOwn = CellCommon.extend({
        ctor:function(){
            this._super();
            this._cells = {};
        },

        UpdateView:function(target,sender,index){
            this.width = sender.width
            this.height = sender.getViewSize().height / 2

            var data = target.data;

            var pos = [0,sender.width / 4 - 5,sender.width /2 - 5,sender.width *3 / 4 - 5];
            for(var i=0;i!=4;++i){
                var v = data[index * 4 + i];
                var c = this._cells[i];
                if(v && !c){
                    c = new RoleListExt();
                    c.LoadPanel();
                    this.addChild(c)
                    c.x = pos[i];
                    c.y = this.height - c.height - 10;
                    this._cells[i] = c;
                }

                if(c) c.visible = v;
                if(c && v) c.SetData(v);
            }
        }
    })

    return ChooseServerPanelExt;
}();
ChooseServerPanelExt.PanelName = "ChooseServerPanelExt";
PanelClassDic["ChooseServerPanelExt"] = ChooseServerPanelExt;
