///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构

// 请求消息
//100201,ReqLogin 内部登陆
//100202,ReqCreateCharacter 创建角色
//100203,ReqLoadFinish 加载完成
//100204,ReqHeart 心跳消息
//100205,ReqLoginForPlatform 平台登陆
//100206,ReqLoginForApp 平台登陆

// 接收消息
//100101,ResCreateCharacter 创建角色信息
//100102,ResLoginSuccess 登陆成功
//100103,ResSubstitute 被顶替下线信息
//100104,ResError 错误信息
//100105,ResQuit 退出游戏
//100106,ResHeart 心跳消息
//100107,ResSessionCreate Session创建
//100108,ResDontLogin 通知前端不要重连接


////////////////////
// 创建角色信息 //
////////////////////
var ResCreateCharacterMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 100101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.login.RecvResCreateCharacterMessage(this);
	},

});
////////////////////
// 登陆成功 //
////////////////////
var ResLoginSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.mapType = 0; // 角色所在地图类型
        this.line = 0; // 切换线
        this.mapModelId = 0; // 角色所在地图资源Id
        this.cityId = 0; // 玩家所在主城
        this.job = 0; // 玩家职业
	},

	getId:function(){
		return 100102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.mapType);
        _buf.WriteVarInt(this.line);
        _buf.WriteVarInt(this.mapModelId);
        _buf.WriteVarInt(this.cityId);
        _buf.WriteByte(this.job);
	},
	
	reading:function( _buf ){
        this.mapType = _buf.ReadByte();
        this.line = _buf.ReadVarInt();
        this.mapModelId = _buf.ReadVarInt();
        this.cityId = _buf.ReadVarInt();
        this.job = _buf.ReadByte();
	},

	action:function(){
		Mgr.login.RecvResLoginSuccessMessage(this);
	},

});
////////////////////
// 被顶替下线信息 //
////////////////////
var ResSubstituteMessage = cc.Class.extend( {
	ctor:function(){
		this.ip = null; // ip地址
	},

	getId:function(){
		return 100103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.ip);
	},
	
	reading:function( _buf ){
        this.ip = _buf.ReadString();
	},

	action:function(){
		Mgr.login.RecvResSubstituteMessage(this);
	},

});
////////////////////
// 错误信息 //
////////////////////
var ResErrorMessage = cc.Class.extend( {
	ctor:function(){
		this.reason = 0; // 失败原因 1-服务器未开启 等
	},

	getId:function(){
		return 100104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.reason);
	},
	
	reading:function( _buf ){
        this.reason = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.login.RecvResErrorMessage(this);
	},

});
////////////////////
// 退出游戏 //
////////////////////
var ResQuitMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色唯一Id
	},

	getId:function(){
		return 100105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

	action:function(){
		Mgr.login.RecvResQuitMessage(this);
	},

});
////////////////////
// 心跳消息 //
////////////////////
var ResHeartMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 当前时间
        this.time2 = 0; // 服务器启动时间
        this.reset = 0; // 0-无需重置， 1-必须重置
	},

	getId:function(){
		return 100106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.time2);
        _buf.WriteVarInt(this.reset);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
        this.time2 = _buf.ReadVarInt();
        this.reset = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.login.RecvResHeartMessage(this);
	},

});
////////////////////
// Session创建 //
////////////////////
var ResSessionCreateMessage = cc.Class.extend( {
	ctor:function(){
		this.id1 = 0; // id1
        this.rnd = 0; // rnd
        this.id2 = 0; // id2
	},

	getId:function(){
		return 100107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.id1);
        _buf.WriteVarInt(this.rnd);
        _buf.WriteVarInt(this.id2);
	},
	
	reading:function( _buf ){
        this.id1 = _buf.ReadVarInt();
        this.rnd = _buf.ReadVarInt();
        this.id2 = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.login.RecvResSessionCreateMessage(this);
	},

});
////////////////////
// 通知前端不要重连接 //
////////////////////
var ResDontLoginMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 不重连原因(1作弊)
	},

	getId:function(){
		return 100108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

	action:function(){
		Mgr.login.RecvResDontLoginMessage(this);
	},

});
////////////////////
// 内部登陆 //
////////////////////
var ReqLoginMessage = cc.Class.extend( {
	ctor:function(){
		this.agent = null; // 平台标识
        this.serverId = 0; // 服务器Id
        this.name = null; // 玩家用户名
        this.password = null; // 玩家密码
        this.win_high = 0; // 窗口高像素
        this.win_width = 0; // 窗口宽像素
	},

	getId:function(){
		return 100201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.agent);
        _buf.WriteVarInt(this.serverId);
        _buf.WriteString(this.name);
        _buf.WriteString(this.password);
        _buf.WriteVarInt(this.win_high);
        _buf.WriteVarInt(this.win_width);
	},
	
	reading:function( _buf ){
        this.agent = _buf.ReadString();
        this.serverId = _buf.ReadVarInt();
        this.name = _buf.ReadString();
        this.password = _buf.ReadString();
        this.win_high = _buf.ReadVarInt();
        this.win_width = _buf.ReadVarInt();
	},

});
////////////////////
// 创建角色 //
////////////////////
var ReqCreateCharacterMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 角色名字
        this.sex = 0; // 角色性别,1男,2女(这是不可选的,rolemodelid就决定了性别)
        this.auto = 0; // 是否自动生成(1自动，0手动)
        this.icon = null; // 角色头像
        this.job = 0; // 角色职业,模型ID(1-4)
        this.win_high = 0; // 窗口高像素
        this.win_width = 0; // 窗口宽像素
	},

	getId:function(){
		return 100202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteByte(this.sex);
        _buf.WriteByte(this.auto);
        _buf.WriteString(this.icon);
        _buf.WriteByte(this.job);
        _buf.WriteVarInt(this.win_high);
        _buf.WriteVarInt(this.win_width);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.sex = _buf.ReadByte();
        this.auto = _buf.ReadByte();
        this.icon = _buf.ReadString();
        this.job = _buf.ReadByte();
        this.win_high = _buf.ReadVarInt();
        this.win_width = _buf.ReadVarInt();
	},

});
////////////////////
// 加载完成 //
////////////////////
var ReqLoadFinishMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 100203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 心跳消息 //
////////////////////
var ReqHeartMessage = cc.Class.extend( {
	ctor:function(){
		this.time = 0; // 当前时间
	},

	getId:function(){
		return 100204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.time = _buf.ReadVarInt();
	},

});
////////////////////
// 平台登陆 //
////////////////////
var ReqLoginForPlatformMessage = cc.Class.extend( {
	ctor:function(){
		this.serverId = null; // 服务器Id
        this.username = null; // 玩家用户名
        this.agent = null; // 平台标识
        this.ad = null; // 服务器Id
        this.time = null; // 平台服务器的LINUX时间戳(为长整数, 单位为秒)
        this.isadult = null; // 1成年,0未成年,-1未知
        this.sign = null; // 全小写MD5验证码
        this.localref = null; // 
        this.reserva1 = null; // 
        this.reserva2 = null; // 
        this.logintype = null; // 登陆类型
        this.agentPlusdata = null; // 平台数据
        this.agentColdatas = null; // 平台数据
        this.adregtime = null; // 平台数据
        this.win_high = 0; // 窗口高像素
        this.win_width = 0; // 窗口宽像素
	},

	getId:function(){
		return 100205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.serverId);
        _buf.WriteString(this.username);
        _buf.WriteString(this.agent);
        _buf.WriteString(this.ad);
        _buf.WriteString(this.time);
        _buf.WriteString(this.isadult);
        _buf.WriteString(this.sign);
        _buf.WriteString(this.localref);
        _buf.WriteString(this.reserva1);
        _buf.WriteString(this.reserva2);
        _buf.WriteString(this.logintype);
        _buf.WriteString(this.agentPlusdata);
        _buf.WriteString(this.agentColdatas);
        _buf.WriteString(this.adregtime);
        _buf.WriteVarInt(this.win_high);
        _buf.WriteVarInt(this.win_width);
	},
	
	reading:function( _buf ){
        this.serverId = _buf.ReadString();
        this.username = _buf.ReadString();
        this.agent = _buf.ReadString();
        this.ad = _buf.ReadString();
        this.time = _buf.ReadString();
        this.isadult = _buf.ReadString();
        this.sign = _buf.ReadString();
        this.localref = _buf.ReadString();
        this.reserva1 = _buf.ReadString();
        this.reserva2 = _buf.ReadString();
        this.logintype = _buf.ReadString();
        this.agentPlusdata = _buf.ReadString();
        this.agentColdatas = _buf.ReadString();
        this.adregtime = _buf.ReadString();
        this.win_high = _buf.ReadVarInt();
        this.win_width = _buf.ReadVarInt();
	},

});
////////////////////
// 平台登陆 //
////////////////////
var ReqLoginForAppMessage = cc.Class.extend( {
	ctor:function(){
		this.serverId = null; // 服务器Id
        this.agent = null; // 平台标识
        this.userId = null; // u8用户id
        this.userName = null; // u8用户名
        this.sdkUserId = null; // 渠道用户id
        this.sdkUserName = null; // 渠道用户名
        this.timestamp = null; // 登录时间
        this.extension = null; // 扩展参数
        this.token = null; // token
	},

	getId:function(){
		return 100206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.serverId);
        _buf.WriteString(this.agent);
        _buf.WriteString(this.userId);
        _buf.WriteString(this.userName);
        _buf.WriteString(this.sdkUserId);
        _buf.WriteString(this.sdkUserName);
        _buf.WriteLong(this.timestamp);
        _buf.WriteString(this.extension);
        _buf.WriteString(this.token);
	},
	
	reading:function( _buf ){
        this.serverId = _buf.ReadString();
        this.agent = _buf.ReadString();
        this.userId = _buf.ReadString();
        this.userName = _buf.ReadString();
        this.sdkUserId = _buf.ReadString();
        this.sdkUserName = _buf.ReadString();
        this.timestamp = _buf.ReadLong();
        this.extension = _buf.ReadString();
        this.token = _buf.ReadString();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(100101, ResCreateCharacterMessage);
MESSAGE_POOL.Add(100102, ResLoginSuccessMessage);
MESSAGE_POOL.Add(100103, ResSubstituteMessage);
MESSAGE_POOL.Add(100104, ResErrorMessage);
MESSAGE_POOL.Add(100105, ResQuitMessage);
MESSAGE_POOL.Add(100106, ResHeartMessage);
MESSAGE_POOL.Add(100107, ResSessionCreateMessage);
MESSAGE_POOL.Add(100108, ResDontLoginMessage);

