///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//Attachment 附件信息
//MailDetailInfo 邮件详细信息
//MailBriefInfo 邮件概要信息

// 请求消息
//120201,ReqGetMailAttachment 读取邮件
//120202,ReqReceiveMail 领取邮件
//120203,ReqRDelMail 删除邮件
//120251,ResSendMailPublicToGame public发送邮件到游戏服

// 接收消息
//120101,ResAllMails 展示所有邮件概要消息(发送邮件列表)
//120102,ResMailDetailInfo 展示邮件的详细信息(请求单个邮件的详细信息)
//120103,ResRecevieNewMail 收到新的邮件消息
//120104,ResGetMailAttachmentSueccess 获取邮件成功,通知前端刷新


var Attachment = cc.Class.extend({
	ctor:function(){
		this.tempItemInfo = null; // 物品信息
	},

	writing:function( _buf ){
		_buf.WriteBean(this.tempItemInfo);
	},
	
	reading:function( _buf ){
		this.tempItemInfo = _buf.ReadBean(TempItemInfo);
	},
});
var MailDetailInfo = cc.Class.extend({
	ctor:function(){
		this.mailInfoId = null; // 邮件编号
        this.subject = null; // 邮件标题
        this.content = null; // 邮件内容
        this.sender = null; // 发送者
        this.senderName = null; // 发送者姓名
        this.sendTime = 0; // 发送时间
        this.leftDays = 0; // 剩余天数
        this.attachments = []; // 附件列表 Attachment
        this.isReceive = 0; // 是否领取附件,1表示已经领取
	},

	writing:function( _buf ){
		_buf.WriteLong(this.mailInfoId);
        _buf.WriteString(this.subject);
        _buf.WriteString(this.content);
        _buf.WriteLong(this.sender);
        _buf.WriteString(this.senderName);
        _buf.WriteVarInt(this.sendTime);
        _buf.WriteVarInt(this.leftDays);
        _buf.WriteShort( this.attachments.length );
        for (var i = 0; i < this.attachments.length; i++) {
            _buf.WriteBean(this.attachments[i]);
        }
        _buf.WriteVarInt(this.isReceive);
	},
	
	reading:function( _buf ){
		this.mailInfoId = _buf.ReadLong();
        this.subject = _buf.ReadString();
        this.content = _buf.ReadString();
        this.sender = _buf.ReadLong();
        this.senderName = _buf.ReadString();
        this.sendTime = _buf.ReadVarInt();
        this.leftDays = _buf.ReadVarInt();
        var attachments_length = _buf.ReadShort();
        for (var i = 0; i < attachments_length; i++) {
            this.attachments[i] = _buf.ReadBean(Attachment);
        }
        this.isReceive = _buf.ReadVarInt();
	},
});
var MailBriefInfo = cc.Class.extend({
	ctor:function(){
		this.mailInfoId = null; // 邮件编号
        this.subject = null; // 邮件标题
        this.type = 0; // 哪一模块的邮件
        this.sendTime = 0; // 发送时间
        this.items = []; // 附件简要信息 Attachment
        this.isReceive = 0; // 是否领取附件,1表示已经领取
	},

	writing:function( _buf ){
		_buf.WriteLong(this.mailInfoId);
        _buf.WriteString(this.subject);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.sendTime);
        _buf.WriteShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteVarInt(this.isReceive);
	},
	
	reading:function( _buf ){
		this.mailInfoId = _buf.ReadLong();
        this.subject = _buf.ReadString();
        this.type = _buf.ReadVarInt();
        this.sendTime = _buf.ReadVarInt();
        var items_length = _buf.ReadShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(Attachment);
        }
        this.isReceive = _buf.ReadVarInt();
	},
});
////////////////////
// 展示所有邮件概要消息(发送邮件列表) //
////////////////////
var ResAllMailsMessage = cc.Class.extend( {
	ctor:function(){
		this.mailBriefInfos = []; // 概要邮件列表 MailBriefInfo
	},

	getId:function(){
		return 120101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mailBriefInfos.length );
        for (var i = 0; i < this.mailBriefInfos.length; i++) {
            _buf.WriteBean(this.mailBriefInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var mailBriefInfos_length = _buf.ReadShort();
        for (var i = 0; i < mailBriefInfos_length; i++) {
            this.mailBriefInfos[i] = _buf.ReadBean(MailBriefInfo);
        }
	},

	action:function(){
		Mgr.mail.RecvResAllMailsMessage(this);
	},

});
////////////////////
// 展示邮件的详细信息(请求单个邮件的详细信息) //
////////////////////
var ResMailDetailInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.mailDetailInfo = null; // 邮件详细信息
	},

	getId:function(){
		return 120102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.mailDetailInfo);
	},
	
	reading:function( _buf ){
        this.mailDetailInfo = _buf.ReadBean(MailDetailInfo);
	},

	action:function(){
		Mgr.mail.RecvResMailDetailInfoMessage(this);
	},

});
////////////////////
// 收到新的邮件消息 //
////////////////////
var ResRecevieNewMailMessage = cc.Class.extend( {
	ctor:function(){
		this.mailInstance = null; // 邮件概要信息
	},

	getId:function(){
		return 120103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.mailInstance);
	},
	
	reading:function( _buf ){
        this.mailInstance = _buf.ReadBean(MailBriefInfo);
	},

	action:function(){
		Mgr.mail.RecvResRecevieNewMailMessage(this);
	},

});
////////////////////
// 获取邮件成功,通知前端刷新 //
////////////////////
var ResGetMailAttachmentSueccessMessage = cc.Class.extend( {
	ctor:function(){
		this.mailId = null; // 邮件Id
	},

	getId:function(){
		return 120104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.mailId);
	},
	
	reading:function( _buf ){
        this.mailId = _buf.ReadLong();
	},

	action:function(){
		Mgr.mail.RecvResGetMailAttachmentSueccessMessage(this);
	},

});
////////////////////
// 读取邮件 //
////////////////////
var ReqGetMailAttachmentMessage = cc.Class.extend( {
	ctor:function(){
		this.mailId = null; // 邮件Id
	},

	getId:function(){
		return 120201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.mailId);
	},
	
	reading:function( _buf ){
        this.mailId = _buf.ReadLong();
	},

});
////////////////////
// 领取邮件 //
////////////////////
var ReqReceiveMailMessage = cc.Class.extend( {
	ctor:function(){
		this.mailIds = []; // 邮件Id列表,发个-1表示所有邮件 long
	},

	getId:function(){
		return 120202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mailIds.length );
        for (var i = 0; i < this.mailIds.length; i++) {
            _buf.WriteLong(this.mailIds[i]);
        }
	},
	
	reading:function( _buf ){
        var mailIds_length = _buf.ReadShort();
        for (var i = 0; i < mailIds_length; i++) {
            this.mailIds[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 删除邮件 //
////////////////////
var ReqRDelMailMessage = cc.Class.extend( {
	ctor:function(){
		this.mailIds = []; // 邮件Id列表,发个-1表示所有邮件 long
	},

	getId:function(){
		return 120203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.mailIds.length );
        for (var i = 0; i < this.mailIds.length; i++) {
            _buf.WriteLong(this.mailIds[i]);
        }
	},
	
	reading:function( _buf ){
        var mailIds_length = _buf.ReadShort();
        for (var i = 0; i < mailIds_length; i++) {
            this.mailIds[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// public发送邮件到游戏服 //
////////////////////
var ResSendMailPublicToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 玩家Id
        this.webname = null; // 平台名
        this.serverid = 0; // 区服id
        this.type = 0; // type
        this.subject = null; // 邮件标题
        this.content = null; // 邮件内容
        this.reward = null; // 奖励内容
	},

	getId:function(){
		return 120251;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.webname);
        _buf.WriteVarInt(this.serverid);
        _buf.WriteByte(this.type);
        _buf.WriteString(this.subject);
        _buf.WriteString(this.content);
        _buf.WriteString(this.reward);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.webname = _buf.ReadString();
        this.serverid = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
        this.subject = _buf.ReadString();
        this.content = _buf.ReadString();
        this.reward = _buf.ReadString();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(120101, ResAllMailsMessage);
MESSAGE_POOL.Add(120102, ResMailDetailInfoMessage);
MESSAGE_POOL.Add(120103, ResRecevieNewMailMessage);
MESSAGE_POOL.Add(120104, ResGetMailAttachmentSueccessMessage);

