﻿var MajoreventsModMgr = MajoreventsModMgr || cc.Class.extend({

	activityHash:null,

	ctor:function() {
		this.activityHash = new HashMap();
	},

    GetBestInProgressActivity:function(){
        var temp = [];
        var config = Q_timing.GetList();
        this.activityHash.EachValue(function(v){
            var conf = config.find(function(vv){
                return vv.q_type == v.type;
            });

            if(v.status == 1 && conf){
                temp.push(v);
            }
        })
        temp.sort(function(a,b){
            return a.type - b.type;
        })

        return temp[0];
    },

    OnActivityStateChanged:function(){
        /// 多个活动开启时，择优显示
        var data = this.GetBestInProgressActivity();
        if(data){
            Mgr.map.miniMapPanel.OnActivityStarted(data);
        }else{
            Mgr.map.miniMapPanel.OnActivityEnded(data);
        }
    },

    OnActivityStart:function(data){
        this.ShowActiveMarkPanel(data);
        /// 发送活动进行中消息提示。
        var config = Q_timing.GetList();
        for(var v of config){
            if(v.q_type == data.type){
                this._SendNotice("【" + v.q_name + "】活动正在火热进行中");
                break;
            }
        }


        // 更新任务追踪
        switch(data.type){
            case EnumZoneActiveType.TYPE_MASTERBUCKET:
                Mgr.task._taskTrackPanel.UpdateView();
                break;
        }
    },
    OnActivityEnd:function(data){

        /// 发送活动进行中消息提示。
        var config = Q_timing.GetList();
        for(var v of config){
            if(v.q_type == data.type){
                this._SendNotice("【" + v.q_name + "】活动已结束");
                break;
            }
        }
        // 更新任务追踪
        switch(data.type){
            case EnumZoneActiveType.TYPE_MASTERBUCKET:
                Mgr.task._taskTrackPanel.UpdateView();
                MasterBucketUtil.UpdateGatherCount(0);
                break;
            case EnumZoneActiveType.TYPE_MASTERBUCKET://掌门夺宝结束
                Mgr.map.miniMapPanel.OnActivityEnded();
                break;
        }
    },

	RecvResSendMajorEventsInfoMessage:function(msg) {
		for(var i = 0; i < msg.majoreventsinfo.length; i++){
			if(msg.majoreventsinfo[i].status == 1){//活动开始
                this.activityHash.Put(msg.majoreventsinfo[i].type, msg.majoreventsinfo[i]);
                this.OnActivityStart(msg.majoreventsinfo[i]);
                cc.log("活动开启 ： " + msg.majoreventsinfo[i].type + "  startTime  " + msg.majoreventsinfo[i].startTime+ "  endTime  " + msg.majoreventsinfo[i].endTime)
				// break;
                if(msg.majoreventsinfo[i].type == EnumZoneActiveType.TYPE_GUILD){
                    var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                    panel.UpdateView();
                }
			}
		}

       this.OnActivityStateChanged();
        Mgr.task._taskTrackPanel.UpdateView();
	},

	RecvResSendChangeMajorEventInfoMessage:function(msg) {
        // cc.log("msg   " + JSON.stringify(msg));
		//cc.log("msg.majoreventinfo.status:"+msg.majoreventinfo.status);
        this.activityHash.Put(msg.majoreventinfo.type, msg.majoreventinfo);
        // cc.log("活动开启 ： " + msg.majoreventinfo.type + "  startTime  " + msg.majoreventinfo.startTime+ "  endTime  " + msg.majoreventinfo.endTime)
		if(msg.majoreventinfo.status == 1){//活动开始(进行中
			this.OnActivityStart(msg.majoreventinfo);
		}else if(msg.majoreventinfo.status == 2){//活动结束
			this.OnActivityEnd(msg.majoreventinfo);
			this.ShowActiveEnded(msg.majoreventinfo.type);
			this._CheckActiveEndAction(msg.majoreventinfo.type);
            if(msg.majoreventinfo.type == EnumZoneActiveType.TYPE_GUILD){//帮派答题结束退出领地
                Mgr.zone.SendReqZoneOutToGameMessage();
            }
		}
        this.OnActivityStateChanged();
        if(msg.majoreventinfo.type == EnumZoneActiveType.TYPE_GUILD){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.UpdateView();
        }

	},

		//处理一些特殊的活动结束需求
		_CheckActiveEndAction:function(type) {
			if(type == EnumZoneActiveType.TYPE_SWORD)
			{
				if(Mgr.sword.IsInZoneMap() && Mgr.sword._curlayer == 3 && Mgr.sword._myscore > 0)
				{
					Mgr.uiMgr.ShowPanelByType(WendingCueExt.PanelName);
					Mgr.uiMgr.GetPanelByType(WendingCueExt.PanelName).SetInfo(3);
					Mgr.sword._curlayer = 0;
					Mgr.sword._myscore = 0;
				}
			}
			else if(type == EnumZoneActiveType.TYPE_ZHUJIANTIANXIA){
                if (Mgr.sceneMap.nMapId == 1003 || Mgr.sceneMap.nMapId == 1002)
                    Mgr.map.SendReqReturnToPreviousMapMessage();
            }
		},

	ShowActiveMarkPanel:function(info){
		var type = info.type;
		if(type == EnumZoneActiveType.TYPE_GUARDCPITAL){
			// if(Mgr.sceneMap.nMapId != 888){//没在活动地图
				Mgr.activeMark.Show(EnumZoneActiveType.TYPE_GUARDCPITAL,info);
			// }
		}else if(type == EnumZoneActiveType.TYPE_SWORD){
			if(!Mgr.sword.IsInZoneMap()){//没在活动地图
				Mgr.activeMark.Show(EnumZoneActiveType.TYPE_SWORD,info);
			}
		}else if(type == EnumZoneActiveType.TYPE_GUILD){
			if(!Mgr.sword.IsInZoneMap() && !Mgr.player.mainPlayer.guildId.IsZero()){//没在活动地图
				Mgr.activeMark.Show(EnumZoneActiveType.TYPE_GUILD,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_GUILDBOSS){
			if(!Mgr.sword.IsInZoneMap() && !Mgr.player.mainPlayer.guildId.IsZero()){//没在活动地图
				Mgr.activeMark.Show(EnumZoneActiveType.TYPE_GUILDBOSS,info);
			}
		}else if(type == EnumZoneActiveType.TYPE_HUSONG){
            Mgr.convoy.isDouble=true;
			Mgr.activeMark.Show(EnumZoneActiveType.TYPE_HUSONG,info);
			}
		else if(type == EnumZoneActiveType.TYPE_ZONE){
			if(!Mgr.zone.IsInZoneMap()){//没在活动地图
				Mgr.activeMark.Show(EnumZoneActiveType.TYPE_ZONE,info);
			}
        }else if(type == EnumZoneActiveType.TYPE_KINGGUID){
            if(!Mgr.zone.IsInZoneMap()){//没在活动地图
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_KINGGUID,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_KINGNEUTRAL){
            if(!Mgr.zone.IsInZoneMap()){//没在活动地图
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_KINGNEUTRAL,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_MASTERBUCKET){
            if(!MasterBucketUtil.CheckPlayerInActivityMap()){
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_MASTERBUCKET,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_WORLDBOSS){
            if(!Mgr.zone.IsInZoneMap()){
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_WORLDBOSS,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_ZHUJIANTIANXIA){
            if(!Mgr.zone.IsInZoneMap()){
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_ZHUJIANTIANXIA,info);
            }
        }else if(type == EnumZoneActiveType.TYPE_ERENGU){
            if(!Mgr.zone.IsInZoneMap()){
                Mgr.activeMark.Show(EnumZoneActiveType.TYPE_ERENGU,info);
            }
        }
    } ,

    /// 获取正在进行的活动信息
    GetActivityInfoByType:function(type){
        return this.activityHash.Get(type);
    },

    ShowActiveEnded: function (info) {
        var type = info.type;
        switch (type) {
            case EnumZoneActiveType.TYPE_GUARDCPITAL:
            {
//                Mgr.task._taskTrackPanel.HideActiveData();
                this._SendNotice( "守卫京城活动结束" );
                break;
            }
            case EnumZoneActiveType.TYPE_SWORD:
            {
//                Mgr.task._taskTrackPanel.HideActiveData();
                this._SendNotice( "华山论剑活动结束" );
                break;
            }
            case EnumZoneActiveType.TYPE_GUILD:
            {
                //Mgr.tips.ShowNotice( "帮会答题活动结束" );
                break;
            }
            case EnumZoneActiveType.TYPE_ZONE:
            {
                this._SendNotice( "英雄崛起活动结束");
                break;
            }
            case EnumZoneActiveType.TYPE_HUSONG:
            {
                Mgr.convoy.isDouble = false;
                this._SendNotice( "护送双倍奖励活动结束");
                break;
            }
            default :
                // 显示活动结束公告
                var config = Q_timing.GetList();
                var curDate = Mgr.login.GetServerDate();
                var today = curDate.getDay();
                var minDate,activity;
                for(var v of config){
                    if(v.q_type == type){
                        var dayArr = JSON.parse(v.q_day);
                        var timeArr =  v.q_time.match(/[0-9]+/g);
                        for (var vv of dayArr) {
                            var day = parseInt(vv);
                            if (day == 7) day = 0;
                            if (day == -1 ) day = today;

                            var newDate = new Date(curDate.getTime() + (day + 7 - today) % 7 * 86400000);
                            newDate.setHours(parseInt(timeArr[0]));
                            newDate.setMinutes(parseInt(timeArr[1]));

                            if(minDate == null){
                                minDate = newDate.getTime();
                                activity = v;
                            }else{
                                if(newDate.getTime() - curDate.getTime() >=0
                                    && newDate.getTime() - curDate.getTime() < minDate){
                                    minDate = newDate.getTime();
                                    activity = v;
                                }
                            }
                        }
                    }
                }
                if(minDate && activity){
                    this._SendNotice("本次【" + activity.q_name + "】已经结束，下一场将在"
                        +  TimeUtil.GetDateStr(minDate / 1000, "yyyy年MM月dd日hh时mm分")
                        +"开启");
                }
                break;
        }
    } ,
    _SendNotice: function (str)
    {
        str = TextUtil.AddColor(str, "6df38e");
        Mgr.chat.OnRecvClientMesage(EnumChatChannelType.NEWSYSTEM,str);

    }
} );