var BiaoBaiQiangPanelExt = (function(){
    var CONFESSION_ROW_COUNT = 3

    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new BiaoBaiQiangbtnExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
    })
    var ConfessionCell = cc.TableViewCell.extend({
        ctor:function(width,height){
            this._super();

            var widthX = width / CONFESSION_ROW_COUNT
            this.Cells = Array.from({ length : CONFESSION_ROW_COUNT },(v,k)=>{
                let c = new BiaoBaiQiangListExt();
                c.LoadPanel();
                this.addChild(c)
                c.x = widthX * k + widthX / 2 - c.width / 2
                c.y = height / 2 - c.height / 2
                return c
            })
        },
        SetData:function(sender,data){
            this.Cells.forEach((v,k)=>{
                let d = data[k]
                if(d){
                    v.visible = true
                    v.SetData(d)
                }else{
                    v.visible = false
                }
            })
        },
    })

    return BiaoBaiQiangPanel.extend ( {
        _className:"BiaoBaiQiangPanelExt",
        ctor:function(){
           this._super();
           this.modelPanelType = 2
        },

        Init:function(){
            this._super();

            this.btnClose.addClickEventListener(_=>EngineMgr.uiMgr.HidePanel(this));
            this.btn1.addClickEventListener(_=>OpenFuncUtil.OpenConfessPanel());

            /// tab tableView
            var size = this.imgContentZuo.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.CellHeight = 90
            tableView.CellClass = Cell

            this.imgContentZuo.addChild(tableView);
            this.tableView = tableView;

            /// content tableView
            var size = this.imgContent.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(ccui.ScrollView.DIR_VERTICAL);
            tableView.setDelegate(this);
            tableView.setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
            tableView.reloadData();
            tableView.CellHeight = 300//294
            tableView.CellClass = ConfessionCell

            this.imgContent.addChild(tableView);
            this.tableViewContent = tableView;

            /// 排行信息
            var viewRank = new BiaoBaiQiangFrameExt()
            viewRank.LoadPanel();
            viewRank.x = 310
            viewRank.y = 20
            this.addChild(viewRank)
            this.viewRank = viewRank
        },

        OnShow:function(){
            this._super()

            GameEventMgr.AddEventListener(this,new ResConfessionPanelInfoMessage().getId(),this.ReloadConfessionData.bind(this))
            GameEventMgr.AddEventListener(this,new ReqConfessionToPlayerMessage().getId(),this.OnReqConfessionToPlayerMessage.bind(this))

            this.OnTabSelected({type : 1})
        },
        OnHide:function(){
            this._super()

            GameEventMgr.RemoveEventListener(this);
        },

        OnTabSelected:function(data){
            this.selectedTab = data.type
            this.ReloadTab()

            var viewSize = this.tableView.getViewSize();
            var size = this.tableView.getContentSize();

            this.tableView.setTouchEnabled(viewSize.height <= size.height);
            this.RequestConfessionInfoByType(this.selectedTab)
        },
        OnReqConfessionToPlayerMessage:function(){
            this.RequestConfessionInfoByType(this.selectedTab)
        },
        RequestConfessionInfoByType:function(type){
            this.viewRank.OnHide()
            this.viewRank.visible = false
            this.tableViewContent.visible = false

            switch(type){
                case 1:
                case 2:
                case 3:
                    this.tableViewContent.visible = true
                    Mgr.marriage.SendReqConfessionPanelInfoMessage(type,0,0)
                    break
                case 4:
                case 5:
                    this.viewRank.OnShow()
                    this.viewRank.visible = true
                    this.viewRank.SetData(type)
                    break
            }
        },

        ReloadConfessionData:function(msg){
            var data = Array.from({ length : Math.ceil(msg.infos.length / CONFESSION_ROW_COUNT)},(v,k)=>{
                v = [
                    msg.infos[k * CONFESSION_ROW_COUNT + 0],
                    msg.infos[k * CONFESSION_ROW_COUNT + 1],
                    msg.infos[k * CONFESSION_ROW_COUNT + 2],
                ]
                return v
            })

            this.tableViewContent.CellData = data
            this.tableViewContent.reloadData()
        },

        ReloadTab:function(){
            this.data = [
                { type : 1	, name : "所有表白"	,},
                { type : 2	, name : "对我的表白"	,},
                { type : 3	, name : "我的表白"	,},
            ]

            if(MarriageUtil.CheckMarriageFuncOpened()
                && (Mgr.dailyactivity.GetActivityById(6001) || Mgr.dailyactivity.GetActivityById(6002))
            ){
                this.data.push({ type : 4	, name : "表白排行(男)"	,})
                this.data.push({ type : 5	, name : "表白排行(女)"	,})
            }

            this.selectedTab = this.selectedTab || this.data[0].type

            this.tableView.CellData =  this.data
            this.tableView.reloadData()
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.width,sender.CellHeight);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
               cell = new sender.CellClass(sender.width,sender.CellHeight);
            }

            cell.SetData(this,sender.CellData[index]);
            return cell;
        },

        numberOfCellsInTableView:function(sender){
            return sender.CellData ? sender.CellData.length : 0;
        },
    } );
})()
BiaoBaiQiangPanelExt.PanelName = "BiaoBaiQiangPanelExt";
PanelClassDic["BiaoBaiQiangPanelExt"] = BiaoBaiQiangPanelExt;
