var MarriageUtil = {
    WARN_TYPE:{
        "结婚" : 1,
        "婚戒" : 6,
        "副本" : 2,
        "表白" : 3,
        "相思" : 4,
        "光环" : 5,
    },
    WARN_CONDITION:{
        "结婚" : function(){
            return false
        },
        "婚戒" : function(){
            return MarriageUtil.CheckRESWarnWithType(EnumMarryResline.RING)
        },
        "副本" : function(){ return false; },
        "表白" : function(){
            return MarriageUtil.CheckRESWarnWithType(EnumMarryResline.TALK)
        },
        "相思" : function(){
            return MarriageUtil.CheckRESWarnWithType(EnumMarryResline.MISS)
        },
        "光环" : function(){
            var list = Q_marry_aureole.GetList()
            return list.findIndex(function(v){
                return MarriageUtil.CheckRESWarnWithType(v.q_id)
            }) != -1
        },
    },
    CheckAureoleActivated:function(id){
        let v = Q_marry_aureole.Get(id)
        /// 等级限制
        let lv = Mgr.player.mainPlayer.attributeData.level;
        if(v.q_level > lv) return false;
        var SL = JSON.parse(v.q_condition)
        if(SL){
            let data = Mgr.marriageres.GetResInfoByType(SL[0])
            if((data ? data.level : 0) < SL[1]) return false;
        }

        return true;
    },
    CheckRESWarnWithType:function(type){
        /// 光环类
        if(type >= EnumMarryResline.HALO){
            if(!this.CheckAureoleActivated(type)) return false;
        }

        var baseC = Q_marry_base.Get(type)

        var data = Mgr.marriageres.GetResInfoByType(type)
        if((data ? data.level : 0) >= baseC.q_max) return false;

        var data = JSON.parse(baseC.q_item_cost)
        if(data.length == 0) return true
        return data.findIndex(function(v){
            let num = Mgr.backpack.GetItemNumber(v[0], true );
            return num > 0
        }) != -1
    },
    CheckRESWarn:function(type){
        var list = Object.keys(this.WARN_TYPE)
        return list.findIndex(k=>{
            let v = this.WARN_TYPE[k]
            if(type != undefined && type != v) return false;

            return this.WARN_CONDITION[k]()
        }) != -1
    },
    /// 检查婚姻功能开启 1015
    CheckMarriageFuncOpened:function(){
        return BtnGroupUtil.IsFunctionOpen(BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_MARRIAGE)
    },
    //// 检查资源线是否激活 NOTE 没啥用，被策划弃用
    CheckMarriageRESActivated:function(type){
        var data = Mgr.marriageres.GetResInfoByType(type)
        return data && data.level > 0
    },
    /// 计算结婚光环属性
    CalcAureoleAttribute:function(aureoleId,level){
        var aureoleC = Q_marry_aureole.Get(aureoleId)
        var levelC = Q_marry_aureole_base.Get(level)

        if(!aureoleC) return
        if(!levelC) return

        var baseValue = levelC.q_attribute_value.toString(10)
        var data = new AttributeData();
        var C = JSON.parse(aureoleC.q_attribute_rise)
        C.forEach(v=>{
            switch(v[1]){
                case 1:{
                    data.PutAttribute(v[0],v[2] * baseValue,AttributeData.Fight);
                } break;
                case 2:{
                    data.PutAttribute(v[0],v[2] + v[3] * level,AttributeData.Fight);
                } break;
            }
        })

        return data;
    },
    /// 计算升级结婚光环所需经验
    CalcAureoleExp:function(aureoleId,level){
        var aureoleC = Q_marry_aureole.Get(aureoleId)
        var levelC = Q_marry_aureole_base.Get(level + 1)

        return (aureoleC ? aureoleC.q_exp : 0) * (levelC ? levelC.q_exp : 0)
    },
    DoSpecialWithSelectNpc:function(npcId){
        if(npcId == 30001){
            EngineMgr.uiMgr.ShowPanelByType(MarriageFrameExt.PanelName);
            return true
        }
        return false
    },
    GetQYMMActivity:function(){
        return Mgr.dailyactivity.GetActivityById(6101);
    },
    // 活动剩余时间
    GetActivityTime:function(){
        var vo6001 = Mgr.dailyactivity.GetActivityById(6001)
        var vo6002 = Mgr.dailyactivity.GetActivityById(6002)

        var vo
        var st = Mgr.login.GetServerTime() / 1000
        if(vo6001 && vo6001.startTime <= st && st <= vo6001.endTime) vo = vo6001;
        if(vo6002 && vo6002.startTime <= st && st <= vo6002.endTime) vo = vo6002;

        var overTime = vo ? vo.endTime - st : 0

        var describe = overTime <= 0 ? "活动已结束" : TimeUtil.SecondToDHMS(overTime)
        return describe
    },
    ///
    GetConfessionItemConfig:function(){
        var globalC = Q_global.Get(20009)
        var arr = JSON.parse(globalC.q_string_value) || []
        return arr
    },

    GetQiuhunItemConfig:function(){
        var globalC24 = Q_global.Get(20024)
        return JSON.parse(globalC24.q_string_value)
    },
    /// 飞去参加婚宴
    GoForHunyan:function(){
        let globalC = Q_global.Get(20019)
        Mgr.map.SendReqGoldMapTransMessage(globalC.q_int_value);
    },

    /// 请求离婚
    RequestDivorce:function(){
        /// 没有结婚
        var data = Mgr.marriage.GetMarriageInfo()
        if(!data){
            Mgr.tips.ShowNotice("当前状态未结婚！");
            return
        }

        var globalC = Q_global.Get(20013)
        var intervalTime = globalC ? globalC.q_int_value : 0
        var serverTime = Mgr.login.GetServerTime();
        if(serverTime - data.marryTime < intervalTime){
            Mgr.tips.ShowNotice(TextUtil.FormatStr(
                "结婚后需要{@}才能离婚,当前还剩{2}", [
                TimeUtil.SecondToDHMS(intervalTime)
                , TimeUtil.SecondToDHMS(serverTime - data.marryTime)
            ]));
            return
        }

        var self = this
        var str = "你确定向TA提出离婚请求？"
        AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
            _onFunc: function() {
                Mgr.marriage.SendReqDivorceMessage(0)
            }.bind(this),
            _offFunc: function(notClose) {
                if(notClose){
                    self.RequestForceDivorce()
                }
            }
        });
        AlertExt.SetButtonTitle("离婚","强制离婚")
    },
    /// 请求强制离婚
    RequestForceDivorce:function(){
        var globalC = Q_global.Get(336)

        if(!globalC){
            Mgr.marriage.SendReqDivorceMessage(1)
            return
        }

        var require = JSON.parse(globalC.q_string_value)

        var str = "强制离婚需要消耗{@}x{@}";
        str = TextUtil.FormatStr(str,[
            ShopUtil.GetMoneyNameByType(require[0])
            , require[1]
        ])

        AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
            _onFunc: function() {
                Mgr.marriage.SendReqDivorceMessage(1)
            }.bind(this),
            _offFunc: function(notClose) {}
        });
    },


    /// 请求升级结婚资源线
    // type
    // auto
    // callback 失败回调
    RequestUpgradeResLine:function(type,auto,callback){
        /// 没有结婚不能升级
        if(!Mgr.marriage.GetMarriageInfo()){
            if(callback) callback()
            Mgr.tips.ShowNotice("需要结婚后才能升级!!!");
            return
        }

        /// 免费次数
        var data = Mgr.marriageres.GetResInfoByType(type)
        if((data ? data.freeUpNm : 0) > 0){
            Mgr.marriageres.SendReqMarriageResUpToGameMessage(type,1)
            return
        }

        var baseC = Q_marry_base.Get(type)
        var itemCost = JSON.parse(baseC.q_item_cost)
        if(itemCost.length == 0) return

        var itemId = itemCost[0][0]
        var num = Mgr.backpack.GetItemNumber(itemId, true);
        /// 自动购买
        if(num == 0){
            if(!auto){
                if(callback) callback()
            }
            ShopUtil.QuickBuyItem(itemId,auto,_=>{
                Mgr.marriageres.SendReqMarriageResUpToGameMessage(type,0)
            },_=>{
                if(auto && callback) callback()
            },info=>{
                if(info == "钱不够"){
                    Mgr.uiMgr.ShowPanelByType(ChongZhiExt.PanelName);
                    return true
                }
            })
            return
        }

        Mgr.marriageres.SendReqMarriageResUpToGameMessage(type,0)
    },

    /// 跑到月老那儿嗨
    RunToMatchmaker:function(callback){
        if(!BtnGroupUtil.unOpenAseert(BtnGroupUtil.M_ROLE,BtnGroupUtil.ROLE_MARRIAGE)){
            return
        }

        var str = "是否前往月老处结婚？\n<font color='#0077ff'>(月老处可结婚，离婚，预约婚宴)</font>";
        AlertExt.Show(str, TipsEnum.BUTTON_SURE_AND_FALSE, {
            _onFunc: function() {
                if(callback) callback()

                var npcId = 30001;
                var npc = Q_npc.Get(npcId);

                if( Mgr.mainPlayer.IsCanDoRun(true) ) {
                    Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(npc.q_map, new cc.p( npc.q_x, npc.q_y), AutoPathParam.CreateSelectNpc(npcId), "");
                }
            },
            _offFunc: function() {}
        });
    },
    /// 更新自己的场景光环效果
    UpdatePlayerHaloEffect:function(){
        ///TODO

    },
}