var GuangHuanPanelExt = (function(){
    var Cell = cc.TableViewCell.extend({
        ctor:function(){
            this._super();
        },
        SetData:function(){
            if(!this.container){
                let c = new GuangHuanListExt();
                c.LoadPanel();
                this.addChild(c)
                this.container = c
            }

            this.container.SetData.apply(this.container,arguments)
        },
        SetSelected:function(){
            if(this.container)this.container.SetSelected.apply(this.container,arguments)
        },
    })

    return GuangHuanPanel.extend ( {
        _className:"GuangHuanPanelExt",
        ctor:function(){
            this._super();
        },
        Init:function(){
            this._super();

            this.imgjiantou1.setAnchorPoint(cc.p(0.5,0.5))
            this.imgjiantou1.x += this.imgjiantou1.width/2
            this.imgjiantou1.y += this.imgjiantou1.height/2
            this.imgjiantou1.setScaleX(-1)

            this.imgjiantou.setTouchEnabled(true)
            this.imgjiantou1.setTouchEnabled(true)
            this.imgjiantou.addClickEventListener(this.OnBtnChanged.bind(this,false))
            this.imgjiantou1.addClickEventListener(this.OnBtnChanged.bind(this,true))

            this.btnQiuHun.setTitleText("自动升级")
            this.btnQiuHun.addClickEventListener(this.OnAutoReqUpgrade.bind(this))
            this.btnWenHao.addClickEventListener(_=>{
                AlertTipsExt.Show(
                    "1.可消耗光环石升级光环增加战力,夫妻双方战力共享<font color='#0900d1'>50%,离婚后对方属性消失<font color='#3a2707'>.\n"
                    + "2.当光环等级满足<font color='#0900d1'>对应等级<font color='#3a2707'>要求时才会激活光环形象.\n"
                    + "3.夫妻光环一共有7个.升级下一个光环需要<font color='#0900d1'>前一个光环<font color='#3a2707'>达到要求的等级.\n"
                    + "4.夫妻一方<font color='#0900d1'>装备光环<font color='#3a2707'>,并且两人走在一起时会有特殊光环包围,为单身狗造成一万点伤害.\n"
                );
            })

            /// content tableView
            var size = this.imgContent.getContentSize();
            var tableView = new cc.TableView(this,size);
            tableView.setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL);
            tableView.setDelegate(this);
            tableView.setTouchEnabled(false)
            tableView.reloadData()
            tableView.CellWidth = 140
            tableView.CellHeight = 135
            tableView.CellClass = Cell

            this.imgContent.addChild(tableView);
            this.tableView = tableView;

            /// 形象信息
            var $cubeL = new GuangHuanCubeExt()
            var $cubeR = new GuangHuanCubeExt()
            $cubeL.LoadPanel()
            $cubeR.LoadPanel()
            this.imgModeL.addChild($cubeL)
            this.imgModeR.addChild($cubeR)
            this.$cubeL = $cubeL
            this.$cubeR = $cubeR
        },

        OnShow:function(){
            GameEventMgr.AddEventListener(this,new ResMarriagePanelMessage().getId(),this.OnResMarriageResInfoToClientMessage.bind(this))
            GameEventMgr.AddEventListener(this,new ResMarriageResInfoToClientMessage().getId(),this.OnResMarriageResInfoToClientMessage.bind(this))
            GameEventMgr.AddEventListener(this,new ResMarriageResResultToClientMessage().getId(),this.OnResMarriageResResultToClientMessage.bind(this))

            ///---
            var list = Q_marry_aureole.GetList()

            this.OnTabSelected(list[0])
            this.OnResMarriageResInfoToClientMessage()
        },
        OnHide:function(){
            GameEventMgr.RemoveEventListener(this);
            this.OnCancelAutoUpgrade()
        },
        OnBtnChanged:function(isLeft){
            if(this.$locked) return;

            this.OnCancelAutoUpgrade()
            this.OnTabSelectedIndex(
                isLeft
                ? Math.max(0,this.$index - 1)
                : Math.min(this.$data.length - 1,this.$index + 1)
            )
        },
        OnCancelAutoUpgrade:function(){
            this.$autoUpgrading = false
            this.btnQiuHun.setTitleText(this.$autoUpgrading ? "取消" : "自动升级")
        },
        OnAutoReqUpgrade:function(sender){
            this.$autoUpgrading = !this.$autoUpgrading;

            sender.setTitleText(this.$autoUpgrading ? "取消" : "自动升级")
            /// 进阶
            if(this.$autoUpgrading){
                this.OnReqUpgrade()
            }
        },
        OnReqUpgrade:function(){
            ///TODO 条件添加
            var aureoleC = this.selectedData
            /// 等级条件不满足
            if(aureoleC.q_level > Mgr.player.mainPlayer.attributeData.level){
                Mgr.tips.ShowNotice(TextUtil.FormatStr("Lv.{@}激活该光环形象",[aureoleC.q_level]));
                return
            }

            var condition = JSON.parse(aureoleC.q_condition)
            if(condition && condition[0]){
                let data = Mgr.marriageres.GetResInfoByType(condition[0])

                if((data ? data.level : 0) < condition[1]){
                    let C = Q_marry_aureole.Get(condition[0])
                    return Mgr.tips.ShowNotice(TextUtil.FormatStr("需要{@}达到{@}级才可升级",[C.q_name,condition[1]]));
                }
            }

            MarriageUtil.RequestUpgradeResLine(this.$type,false)
        },
        OnResMarriageResResultToClientMessage:function(msg){
            if(msg.marriageResType != this.$type) return;
            /// 自动升级
            TimerUtil.SetTimeout(this,function(){
                if(!this.$autoUpgrading) return;

                this.OnReqUpgrade();
            },150)
        },
        OnResMarriageResInfoToClientMessage:function(){
            var aureoleC = this.selectedData

            var data = Mgr.marriageres.GetResInfoByType(this.$type)

            var level = 0,exp = 0
            if(data){
                level = data.level
                exp = data.exp
            }

            var expMax = MarriageUtil.CalcAureoleExp(aureoleC.q_id,level)

            /// 当前经验
            UIUtil.ConnectLabelHtmlText(this.labwordw		,[exp,expMax])
            /// 名字和等级
            UIUtil.ConnectLabelHtmlText(this.labwords		,[level,aureoleC.q_name])
            UIUtil.ConnectLabelHtmlText(this.lab1		,[level])


            /// 属性
            var mineAttribute = MarriageUtil.CalcAureoleAttribute(aureoleC.q_id,level)
            var fightpower = Mgr.attributeMgr.GetFightPowerWithAttrData(mineAttribute);
            var hp = mineAttribute?mineAttribute.GetAttribute(EnumAttribute.MAX_BASEHP,AttributeData.Fight):0;
            var dp = mineAttribute?mineAttribute.GetAttribute(EnumAttribute.DEFEND,AttributeData.Fight):0;
            var at = mineAttribute?mineAttribute.GetAttribute(EnumAttribute.ATTACK,AttributeData.Fight):0;
            /// TA的表白等级
            var ohp="", odp="", oat=""
            var marriageInfo = Mgr.marriage.GetMarriageInfo()
            if(marriageInfo){
                let oLevel = marriageInfo.getResLevel(this.$type)
                UIUtil.ConnectLabelHtmlText(this.lab11		,[oLevel])

                let otherAttribute = MarriageUtil.CalcAureoleAttribute(aureoleC.q_id,oLevel)
                if(otherAttribute){
                    let per =  aureoleC.q_attribute_partner / 100

                    fightpower += parseInt(Mgr.attributeMgr.GetFightPowerWithAttrData(otherAttribute) * per);

                    ohp = otherAttribute.GetAttribute(EnumAttribute.MAX_BASEHP,AttributeData.Fight) * per;
                    odp = otherAttribute.GetAttribute(EnumAttribute.DEFEND,AttributeData.Fight) * per;
                    oat = otherAttribute.GetAttribute(EnumAttribute.ATTACK,AttributeData.Fight) * per;

                    ohp = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(ohp) + ")"
                    odp = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(odp) + ")"
                    oat = "\t<font color='#f0d36e'>(伴侣+" + Math.floor(oat) + ")"
                }
            }else{
            //  TODO
//                this.lab11.SetText("暂无伴侣")
            }

            UIUtil.ConnectLabelHtmlText(this.labShengMing	,[hp + ohp])
            UIUtil.ConnectLabelHtmlText(this.labFangYu		,[dp + odp])
            UIUtil.ConnectLabelHtmlText(this.labGongji		,[at + oat])

            /// 光环激活需要等级
            UIUtil.ConnectLabelHtmlText(this.labjihuo		,[aureoleC.q_level])

            this.imglab1.SetText(Math.floor(fightpower))


            this.$cubeL.UpdateView(this.$type, true)
            this.$cubeR.UpdateView(this.$type, false)

            this.UpdateUpgradeInfo()
            this.ReloadData()
        },
        OnTabSelectedIndex:function(index){
            this.$index = index

            //TODO
            this.imgjiantou.visible = index != this.$data.length - 1
            this.imgjiantou1.visible = index != 0

            var x = -this.tableView.CellWidth * (index - 1)
            var viewSize = this.tableView.getViewSize();
            var size = this.tableView.getContentSize();

            x = Math.min(0,x)
            x = Math.max(x,viewSize.width - size.width)

            var interval = Math.abs(this.tableView.getContentOffset().x - x) < 10 ? 0 : 200

            this.tableView.setContentOffsetInDuration(cc.p(x,0),interval / 1000);
            this.$locked = true
            TimerUtil.SetTimeout(this,function(){
                this.OnTabSelected(this.$data[index])
                this.$locked = false
            },interval)
        },
        OnTabSelected:function(data){
            this.selectedData = data
            this.ReloadData()

            this.$type = data.q_id

            /// 光环MODEL
            if(this.$uiModel) this.$uiModel.Dispose()
            var uiModel = new UIModel(data.q_id,EnumResline.MARRIAGE_HALO);
            uiModel.setScale(1.3);
            this.$uiModel = uiModel;
            this.imgModeC.addChild(uiModel);
            /// offset
            var offset = [
                [-30,-220]
                ,[-30,-180]
                ,[-30,-200]
                ,[-30,-180]
                ,[-30,-190]
                ,[-30,0]
                ,[-30,0]
            ]
            var of = offset[data.q_id - EnumMarryResline.HALO]
            this.$uiModel.x = of[0]
            this.$uiModel.y = of[1]

            Mgr.marriageres.SendReqMarriageResInfoToGameMessage(this.$type)
        },
        UpdateUpgradeInfo:function(){
            var baseC = Q_marry_base.Get(this.$type)

            var data = JSON.parse(baseC.q_item_cost)

            if(data.length == 0) return

            var itemId = data[0][0]

            var num = Mgr.backpack.GetItemNumber(itemId, true );

            var item = ItemUtil.ItemIdToItem(itemId, num, 0);
            GridUtil.SetItemGrid(this.grid1, item);
            this.labnun.visible = false
            //UIUtil.ConnectLabelHtmlText(this.labnun	,[num,1])
        },
        ReloadData:function(){
            var list = Q_marry_aureole.GetList()

            this.$data = list
            this.$index = this.$index || 0

            this.tableView.CellData = list

            /// 位置适配
            var viewSize = this.tableView.getViewSize();
            var oldOffset = this.tableView.getContentOffset();
            var oldSize = this.tableView.getContentSize();

            var x = viewSize.width - oldSize.width - oldOffset.x;
            /// 数据刷新
            this.tableView.reloadData()
            /// 位置偏移的自动适应
            var offset = this.tableView.getContentOffset();
            var size = this.tableView.getContentSize();
            do{
                // 小于viewSize则必须这么大
                if(viewSize.width >= size.width){
                     offset.x = viewSize.width - size.width;
                     break;
                }

                offset.x = oldOffset.x;
            }while(false);
            this.tableView.setContentOffset(offset);
        },
        tableCellTouched: function(sender, cell) {
            var index = cell.getIdx()
            this.OnTabSelected(sender.CellData[index])
        },
        tableCellSizeForIndex:function(sender,index){
            return cc.size(sender.CellWidth,sender.CellHeight);
        },
        tableCellAtIndex:function(sender,index){
            var cell = sender.dequeueCell();
            if (!cell) {
               cell = new sender.CellClass(sender.CellWidth,sender.height);
            }
            cell.SetData(sender.CellData[index],this.$data[this.$index]);
            return cell;
        },
        numberOfCellsInTableView:function(sender){
            return sender.CellData ? sender.CellData.length : 0;
        },
    } );
})()
GuangHuanPanelExt.PanelName = "GuangHuanPanelExt";
PanelClassDic["GuangHuanPanelExt"] = GuangHuanPanelExt;

