///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//WGBossInfo 世界或帮会boss信息
//BossDamageInfo 玩家对BOSS伤害信息
//UndergroundBossInfo 地宫bossInfo

// 请求消息
//114201,ReqQueryBossList 请求BOSS列表
//114202,ReqErrorMonsterToGame 出错的怪物
//114203,ReqQueryBossAlone 单独请求Boss信息
//114204,ReqClearKillMonsterNum 请求手动清理疲劳值

// 接收消息
//114101,ResMonsterHpChange 生命变化
//114104,ResMonsterMaxHpChange 最大生命变化
//114107,ResMonsterSpeedChange 速度变化
//114108,ResMonsterDie 怪物死亡
//114109,ResMonsterRevive 怪物复活
//114110,ResMonsterSay 怪物说话
//114111,ResMonsterDoubleNotice 双倍经验消息
//114112,ResMonsterHpRateChange 血条倍率变化
//114113,ResWGBossListToClient 发送世界和帮会boss信息
//114114,ResWGBossInfoToClient 发送单个boss的信息
//114115,ResBossDamageInfosToClient 发送玩家对BOSS伤害排行列表
//114116,ResUndergroundBossPanelInfosToClient 发送地宫boss刷新信息
//114117,ResMyBossDamageInfoToClient 发送自己对BOSS伤害信息
//114118,ResUndergroundBossAllDieToClient 地宫boss全部死亡通知前段退出地图


var WGBossInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // boss类型，3是世界boss，5帮会boss
        this.monsterModelId = 0; // boss的id
        this.mapModelId = 0; // boss所在地图id
        this.line = 0; // boss所在线
        this.status = 0; // boss当前状态，（-1是已死亡，0可击杀，大于0下次刷新时间（秒））
        this.bless = 0; // 当前血量万份比，（前端拿去除10000来显示）
        this.killerId = null; // 上次最后一刀击杀者id
        this.killerName = null; // 上次最后一刀击杀者Name
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.monsterModelId);
        _buf.WriteVarInt(this.mapModelId);
        _buf.WriteByte(this.line);
        _buf.WriteVarInt(this.status);
        _buf.WriteVarInt(this.bless);
        _buf.WriteLong(this.killerId);
        _buf.WriteString(this.killerName);
	},

	reading:function( _buf ){
		this.type = _buf.ReadByte();
        this.monsterModelId = _buf.ReadVarInt();
        this.mapModelId = _buf.ReadVarInt();
        this.line = _buf.ReadByte();
        this.status = _buf.ReadVarInt();
        this.bless = _buf.ReadVarInt();
        this.killerId = _buf.ReadLong();
        this.killerName = _buf.ReadString();
	},
});
var BossDamageInfo = cc.Class.extend({
	ctor:function(){
		this.damage = 0; // 伤害值
        this.playerName = null; // 玩家名字Name
        this.playerId = null; // 玩家id(奖励信息用，排行榜同步时为0)
        this.job = 0; // 玩家职业
	},

	writing:function( _buf ){
		_buf.WriteVarLong(this.damage);
        _buf.WriteString(this.playerName);
        _buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.job);
	},

	reading:function( _buf ){
		this.damage = _buf.ReadVarLong();
        this.playerName = _buf.ReadString();
        this.playerId = _buf.ReadLong();
        this.job = _buf.ReadVarInt();
	},
});
var UndergroundBossInfo = cc.Class.extend({
	ctor:function(){
		this.modeldId = 0; // 怪物modelid
        this.x = 0; // 刷新坐标X
        this.y = 0; // 刷新坐标Y
        this.alive = 0; // 是否是存活状态 1是 0不是
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.modeldId);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.alive);
	},

	reading:function( _buf ){
		this.modeldId = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.alive = _buf.ReadVarInt();
	},
});
////////////////////
// 生命变化 //
////////////////////
var ResMonsterHpChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.currentHp = 0; // 当前HP
	},

	getId:function(){
		return 114101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarLong(this.currentHp);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.currentHp = _buf.ReadVarLong();
	},

	action:function(){
		Mgr.monster.RecvResMonsterHpChangeMessage(this);
	},

});
////////////////////
// 最大生命变化 //
////////////////////
var ResMonsterMaxHpChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.currentHp = 0; // 当前HP
        this.maxHp = 0; // 最大HP
	},

	getId:function(){
		return 114104;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarLong(this.currentHp);
        _buf.WriteVarLong(this.maxHp);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.currentHp = _buf.ReadVarLong();
        this.maxHp = _buf.ReadVarLong();
	},

	action:function(){
		Mgr.monster.RecvResMonsterMaxHpChangeMessage(this);
	},

});
////////////////////
// 速度变化 //
////////////////////
var ResMonsterSpeedChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.speed = 0; // 当前速度
	},

	getId:function(){
		return 114107;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarInt(this.speed);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.speed = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResMonsterSpeedChangeMessage(this);
	},

});
////////////////////
// 怪物死亡 //
////////////////////
var ResMonsterDieMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 角色Id
        this.die = 0; // 死亡状态 2-假死 3-死亡
        this.killer = null; // 杀死人Id
        this.type = 0; // 死亡特效(0正常死亡 1龙卷风秒杀)
	},

	getId:function(){
		return 114108;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteByte(this.die);
        _buf.WriteLong(this.killer);
        _buf.WriteByte(this.type);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.die = _buf.ReadByte();
        this.killer = _buf.ReadLong();
        this.type = _buf.ReadByte();
	},

	action:function(){
		Mgr.monster.RecvResMonsterDieMessage(this);
	},

});
////////////////////
// 怪物复活 //
////////////////////
var ResMonsterReviveMessage = cc.Class.extend( {
	ctor:function(){
		this.monster = null; // 怪物信息
	},

	getId:function(){
		return 114109;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.monster);
	},

	reading:function( _buf ){
        this.monster = _buf.ReadBean(MonsterInfo);
	},

	action:function(){
		Mgr.monster.RecvResMonsterReviveMessage(this);
	},

});
////////////////////
// 怪物说话 //
////////////////////
var ResMonsterSayMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物id
        this.saycontent = null; // 说话内容
	},

	getId:function(){
		return 114110;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteString(this.saycontent);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.saycontent = _buf.ReadString();
	},

	action:function(){
		Mgr.monster.RecvResMonsterSayMessage(this);
	},

});
////////////////////
// 双倍经验消息 //
////////////////////
var ResMonsterDoubleNoticeMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 类型：1双倍经验，2其他。。。
        this.status = 0; // 1开启，0关闭
        this.content = null; // 内容
        this.time = 0; // 剩余时间（秒）
	},

	getId:function(){
		return 114111;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.status);
        _buf.WriteString(this.content);
        _buf.WriteVarInt(this.time);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.status = _buf.ReadByte();
        this.content = _buf.ReadString();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResMonsterDoubleNoticeMessage(this);
	},

});
////////////////////
// 血条倍率变化 //
////////////////////
var ResMonsterHpRateChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物唯一Id
        this.currentHpRate = 0; // 当前血条倍率
	},

	getId:function(){
		return 114112;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarInt(this.currentHpRate);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.currentHpRate = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResMonsterHpRateChangeMessage(this);
	},

});
////////////////////
// 发送世界和帮会boss信息 //
////////////////////
var ResWGBossListToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 请求boss大类型，0全部请求，3是世界boss，5帮会boss
        this.bossType = 0; // boss小类型(q_boss_word里面的type,为0发送当前大类型下所有boss)
        this.worldbossList = []; // boss列表 WGBossInfo
        this.killBossNum = 0; // 击杀本国BOSS数量
        this.clearnum = 0; // 清理次数
	},

	getId:function(){
		return 114113;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.bossType);
        _buf.WriteUShort( this.worldbossList.length );
        for (var i = 0; i < this.worldbossList.length; i++) {
            _buf.WriteBean(this.worldbossList[i]);
        }
        _buf.WriteByte(this.killBossNum);
        _buf.WriteByte(this.clearnum);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.bossType = _buf.ReadByte();
        var worldbossList_length = _buf.ReadUShort();
        for (var i = 0; i < worldbossList_length; i++) {
            this.worldbossList[i] = _buf.ReadBean(WGBossInfo);
        }
        this.killBossNum = _buf.ReadByte();
        this.clearnum = _buf.ReadByte();
	},

	action:function(){
		Mgr.monster.RecvResWGBossListToClientMessage(this);
	},

});
////////////////////
// 发送单个boss的信息 //
////////////////////
var ResWGBossInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.wgBossInfo = null; // 世界或帮会boss信息
        this.notifyType = 0; // 通知类型(0不通知 1复活通知 2死亡通知)
	},

	getId:function(){
		return 114114;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.wgBossInfo);
        _buf.WriteByte(this.notifyType);
	},

	reading:function( _buf ){
        this.wgBossInfo = _buf.ReadBean(WGBossInfo);
        this.notifyType = _buf.ReadByte();
	},

	action:function(){
		Mgr.monster.RecvResWGBossInfoToClientMessage(this);
	},

});
////////////////////
// 发送玩家对BOSS伤害排行列表 //
////////////////////
var ResBossDamageInfosToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.BossDamageInfos = []; // 玩家对BOSS伤害列表 BossDamageInfo
        this.monsterModelId = 0; // boss的id
        this.totalDamage = 0; // 总伤害
	},

	getId:function(){
		return 114115;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.BossDamageInfos.length );
        for (var i = 0; i < this.BossDamageInfos.length; i++) {
            _buf.WriteBean(this.BossDamageInfos[i]);
        }
        _buf.WriteVarInt(this.monsterModelId);
        _buf.WriteVarInt(this.totalDamage);
	},

	reading:function( _buf ){
        var BossDamageInfos_length = _buf.ReadUShort();
        for (var i = 0; i < BossDamageInfos_length; i++) {
            this.BossDamageInfos[i] = _buf.ReadBean(BossDamageInfo);
        }
        this.monsterModelId = _buf.ReadVarInt();
        this.totalDamage = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResBossDamageInfosToClientMessage(this);
	},

});
////////////////////
// 发送地宫boss刷新信息 //
////////////////////
var ResUndergroundBossPanelInfosToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.bossInfos = []; // 这个地图存在所有boss信息 UndergroundBossInfo
        this.refreshTime = 0; // 刷新倒计时(秒)
	},

	getId:function(){
		return 114116;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.bossInfos.length );
        for (var i = 0; i < this.bossInfos.length; i++) {
            _buf.WriteBean(this.bossInfos[i]);
        }
        _buf.WriteVarInt(this.refreshTime);
	},

	reading:function( _buf ){
        var bossInfos_length = _buf.ReadUShort();
        for (var i = 0; i < bossInfos_length; i++) {
            this.bossInfos[i] = _buf.ReadBean(UndergroundBossInfo);
        }
        this.refreshTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResUndergroundBossPanelInfosToClientMessage(this);
	},

});
////////////////////
// 发送自己对BOSS伤害信息 //
////////////////////
var ResMyBossDamageInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.bossDamageInfo = null; // 对BOSS伤害信息
        this.monsterModelId = 0; // boss的id
        this.totalDamage = 0; // 总伤害
	},

	getId:function(){
		return 114117;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.bossDamageInfo);
        _buf.WriteVarInt(this.monsterModelId);
        _buf.WriteVarInt(this.totalDamage);
	},

	reading:function( _buf ){
        this.bossDamageInfo = _buf.ReadBean(BossDamageInfo);
        this.monsterModelId = _buf.ReadVarInt();
        this.totalDamage = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.monster.RecvResMyBossDamageInfoToClientMessage(this);
	},

});
////////////////////
// 地宫boss全部死亡通知前段退出地图 //
////////////////////
var ResUndergroundBossAllDieToClientMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 114118;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

	action:function(){
		Mgr.monster.RecvResUndergroundBossAllDieToClientMessage(this);
	},

});
////////////////////
// 请求BOSS列表 //
////////////////////
var ReqQueryBossListMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 请求boss大类型，0全部请求，3是世界boss，5帮会boss
        this.bossType = 0; // boss小类型(q_boss_word里面的type,为0发送当前大类型下所有boss)
	},

	getId:function(){
		return 114201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteByte(this.bossType);
	},

	reading:function( _buf ){
        this.type = _buf.ReadByte();
        this.bossType = _buf.ReadByte();
	},

});
////////////////////
// 出错的怪物 //
////////////////////
var ReqErrorMonsterToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterId = null; // 怪物唯一Id
        this.type = 0; // 1怪物死亡后还打人,2隐身怪物打人
	},

	getId:function(){
		return 114202;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteLong(this.monsterId);
        _buf.WriteVarInt(this.type);
	},

	reading:function( _buf ){
        this.monsterId = _buf.ReadLong();
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 单独请求Boss信息 //
////////////////////
var ReqQueryBossAloneMessage = cc.Class.extend( {
	ctor:function(){
		this.monsterModel = 0; // 怪物ModelId
        this.mapModel = 0; // 地图ModelId
        this.lineId = 0; // 地图线
	},

	getId:function(){
		return 114203;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.monsterModel);
        _buf.WriteVarInt(this.mapModel);
        _buf.WriteVarInt(this.lineId);
	},

	reading:function( _buf ){
        this.monsterModel = _buf.ReadVarInt();
        this.mapModel = _buf.ReadVarInt();
        this.lineId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求手动清理疲劳值 //
////////////////////
var ReqClearKillMonsterNumMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 请求类型（世界boss发bossworld对应的type）
	},

	getId:function(){
		return 114204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},

	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(114101, ResMonsterHpChangeMessage);
MESSAGE_POOL.Add(114104, ResMonsterMaxHpChangeMessage);
MESSAGE_POOL.Add(114107, ResMonsterSpeedChangeMessage);
MESSAGE_POOL.Add(114108, ResMonsterDieMessage);
MESSAGE_POOL.Add(114109, ResMonsterReviveMessage);
MESSAGE_POOL.Add(114110, ResMonsterSayMessage);
MESSAGE_POOL.Add(114111, ResMonsterDoubleNoticeMessage);
MESSAGE_POOL.Add(114112, ResMonsterHpRateChangeMessage);
MESSAGE_POOL.Add(114113, ResWGBossListToClientMessage);
MESSAGE_POOL.Add(114114, ResWGBossInfoToClientMessage);
MESSAGE_POOL.Add(114115, ResBossDamageInfosToClientMessage);
MESSAGE_POOL.Add(114116, ResUndergroundBossPanelInfosToClientMessage);
MESSAGE_POOL.Add(114117, ResMyBossDamageInfoToClientMessage);
MESSAGE_POOL.Add(114118, ResUndergroundBossAllDieToClientMessage);

