///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ServiceInfo NPC服务信息类

// 请求消息
//104201,ReqNpcServices 请求服务器npc服务列表
//104202,ReqService 请求npc脚本服务

// 接收消息
//104101,ResNpcServices 返回服务器npc服务列表
//104102,ResStartGather 玩家开始采集
//104103,ResStopGather 玩家停止采集
//104104,ResNpcAction npc行为
//104105,ResTaskNpcGatherFinish 任务NPC采集完成消息
//104106,ResNpcHpChange 生命变化
//104107,ResNpcStateChange npc状态变化
//104108,ResNpcGatherNumsInfo NPC采集个数信息


var ServiceInfo = cc.Class.extend({
	ctor:function(){
		this.serviceId = 0; // 服务Id
        this.serviceName = null; // 服务名称
        this.level = 0; // 服务需要等级限制
        this.serviceParameter = null; // 服务参数
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.serviceId);
        _buf.WriteString(this.serviceName);
        _buf.WriteVarInt(this.level);
        _buf.WriteString(this.serviceParameter);
	},
	
	reading:function( _buf ){
		this.serviceId = _buf.ReadVarInt();
        this.serviceName = _buf.ReadString();
        this.level = _buf.ReadVarInt();
        this.serviceParameter = _buf.ReadString();
	},
});
////////////////////
// 返回服务器npc服务列表 //
////////////////////
var ResNpcServicesMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
        this.services = []; // npc服务列表集合 ServiceInfo
	},

	getId:function(){
		return 104101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteShort( this.services.length );
        for (var i = 0; i < this.services.length; i++) {
            _buf.WriteBean(this.services[i]);
        }
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        var services_length = _buf.ReadShort();
        for (var i = 0; i < services_length; i++) {
            this.services[i] = _buf.ReadBean(ServiceInfo);
        }
	},

	action:function(){
		Mgr.npc.RecvResNpcServicesMessage(this);
	},

});
////////////////////
// 玩家开始采集 //
////////////////////
var ResStartGatherMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
        this.tatget = null; // 行为目标
        this.costtime = 0; // 采集时间
	},

	getId:function(){
		return 104102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
        _buf.WriteLong(this.tatget);
        _buf.WriteVarInt(this.costtime);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
        this.tatget = _buf.ReadLong();
        this.costtime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.npc.RecvResStartGatherMessage(this);
	},

});
////////////////////
// 玩家停止采集 //
////////////////////
var ResStopGatherMessage = cc.Class.extend( {
	ctor:function(){
		this.personId = null; // 角色Id
	},

	getId:function(){
		return 104103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.personId);
	},
	
	reading:function( _buf ){
        this.personId = _buf.ReadLong();
	},

	action:function(){
		Mgr.npc.RecvResStopGatherMessage(this);
	},

});
////////////////////
// npc行为 //
////////////////////
var ResNpcActionMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
        this.tatget = null; // 行为目标
        this.actionType = 0; // 行为类型
	},

	getId:function(){
		return 104104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteLong(this.tatget);
        _buf.WriteVarInt(this.actionType);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        this.tatget = _buf.ReadLong();
        this.actionType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.npc.RecvResNpcActionMessage(this);
	},

});
////////////////////
// 任务NPC采集完成消息 //
////////////////////
var ResTaskNpcGatherFinishMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
	},

	getId:function(){
		return 104105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
	},

	action:function(){
		Mgr.npc.RecvResTaskNpcGatherFinishMessage(this);
	},

});
////////////////////
// 生命变化 //
////////////////////
var ResNpcHpChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // 角色Id
        this.currentHp = 0; // 当前HP
	},

	getId:function(){
		return 104106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteVarInt(this.currentHp);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        this.currentHp = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.npc.RecvResNpcHpChangeMessage(this);
	},

});
////////////////////
// npc状态变化 //
////////////////////
var ResNpcStateChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
        this.state = 0; // NPC状态 0正常, 1行走 ,2被人采集中
	},

	getId:function(){
		return 104107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteVarInt(this.state);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        this.state = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.npc.RecvResNpcStateChangeMessage(this);
	},

});
////////////////////
// NPC采集个数信息 //
////////////////////
var ResNpcGatherNumsInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.gaherNums = 0; // 已采集数
	},

	getId:function(){
		return 104108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.gaherNums);
	},
	
	reading:function( _buf ){
        this.gaherNums = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.npc.RecvResNpcGatherNumsInfoMessage(this);
	},

});
////////////////////
// 请求服务器npc服务列表 //
////////////////////
var ReqNpcServicesMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
	},

	getId:function(){
		return 104201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
	},

});
////////////////////
// 请求npc脚本服务 //
////////////////////
var ReqServiceMessage = cc.Class.extend( {
	ctor:function(){
		this.npcId = null; // npcId
        this.serviceParameter = null; // 服务参数
	},

	getId:function(){
		return 104202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.npcId);
        _buf.WriteString(this.serviceParameter);
	},
	
	reading:function( _buf ){
        this.npcId = _buf.ReadLong();
        this.serviceParameter = _buf.ReadString();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(104101, ResNpcServicesMessage);
MESSAGE_POOL.Add(104102, ResStartGatherMessage);
MESSAGE_POOL.Add(104103, ResStopGatherMessage);
MESSAGE_POOL.Add(104104, ResNpcActionMessage);
MESSAGE_POOL.Add(104105, ResTaskNpcGatherFinishMessage);
MESSAGE_POOL.Add(104106, ResNpcHpChangeMessage);
MESSAGE_POOL.Add(104107, ResNpcStateChangeMessage);
MESSAGE_POOL.Add(104108, ResNpcGatherNumsInfoMessage);

