﻿var NpcModMgr = NpcModMgr || cc.Class.extend({

	_curNpcSID:0,
	_curNpcGID:0,
	_curNpcMID	:0,
	_npcConfigData:null,

	_npcPanel:null,

	// 周围NPC列表 gid/info
	roundNpcList : null,
	isCollection:false,//采集中
	curCollectionNpcId:0,

	ctor:function() {
		this.roundNpcList = new HashMap();
	},

	SetNpcPanel:function (Panel)
	{
		this._npcPanel = Panel;
	},

	ShowNpcPanel:function () {
        var data  = JSON.parse(Q_global.Get(1113).q_string_value);

        //npc不让对话,基于护送最后一步走这里做判定是否是护送
        if( !(this._curNpcMID == data[2] && Mgr.convoy.isHuSong)) return;

		Mgr.uiMgr.ShowPanelByType( TaskNpcTalkMainExt.PanelName);
		var npcm = Q_npc.Get(this._curNpcMID);
		this._npcPanel.SetData(npcm)
	},
		
	ShowTaskPanel:function () {
		var isTask = false;
		var mainPlayerLevel = Mgr.player.mainPlayer.attributeData.level;
		var npcm = Q_npc.Get(this._curNpcMID);
		if (npcm != null && npcm.q_task != null ) {
			var taskList = this._npcConfigData.q_task.split(";");
			var taskID = Mgr.task.aCurTaskId;
			var taskData = Q_mission_base.Get(taskID);
			var nexttaskData = Q_mission_base.Get(Mgr.task.aNextTaskId);
			var tData = null;
			for (var i = 0; i < taskList.length; i++) {
				if (taskList[i] == taskID && taskData != null && mainPlayerLevel >= taskData.q_needLevel) {
					isTask = true;
					tData = taskData;
					break;
				}
				else if (taskID == 0 && taskList[i] == this.aNextTaskId && nexttaskData != null && mainPlayerLevel >= nexttaskData.q_needLevel) {
					isTask = true;
					tData = nexttaskData;
					break;
				}
			}

			if (isTask) {
				Mgr.uiMgr.ShowPanelByType( TaskNpcTalkMainExt.PanelName);
				this._npcPanel.SetData(npcm, tData)
			}
		}
		return isTask;
	},

	RecvResNpcServicesMessage:function(msg) {
		this.curCollectionNpcId = 0;
		var npcV = Mgr.sceneObj.FindObject(msg.npcId.toGID());
		if (npcV == null)
			return;
		var npcm = Q_npc.Get(npcV.nBodyModelId);
		if (npcm == null)
			return;

		this._npcConfigData = npcm;
		this._curNpcSID = msg.npcId;
		this._curNpcMID = npcV.nBodyModelId;

		//显示面板
		if (msg.services && msg.services.length > 0) {
			var isTask = false;
			for (var i = 0; i != msg.services.length; i++) {
				var type = msg.services[i].serviceId;
				if (type == NpcTaskType.NPC_PANEL_TASK) {
					isTask = this.NpcSubFunction(type);
					break;
				}
				if(type==NpcTaskType.NPC_PANEL_ESCORT){
                    // TIP第一个娃儿特殊重试
                    var data = JSON.parse(Q_global.Get(1113).q_string_value);
                    if(npcV.nBodyModelId == data[0]){
                        Mgr.uiMgr.ShowPanelByType(HuSongPanelExt.PanelName);
                    }else{
                        var panel = Mgr.uiMgr.ShowPanelByType(HuSongCuePanelExt.PanelName, UIMgr.PANEL_LAYER_POP);
                        panel.UpdateInfoByModelId(npcV.nBodyModelId);
                    }
					isTask = true;
					break;
				}
			}

			if (!isTask) {
				this.ShowNpcPanel();
			}
		}
		else {
			this.ShowNpcPanel();
		}
		if( npcm.q_npctalk ){
			Mgr.gameSoundMgr.PlaySound(npcm.q_npctalk,SoundType.NpcTalk,false);
		}
	},
	RecvResStartGatherMessage:function(msg) {
		if (msg.personId.toGID() == Mgr.player.mainPlayer.sid.toGID()) {
			//开始采集
			//Mgr.mainPlayer.StartCollect(msg.costtime);
			EngineMgr.uiMgr.ShowPanelByType(TopicBoxExt.PanelName);
			var panel = Mgr.uiMgr.GetPanelByType(TopicBoxExt.PanelName);
			if(panel)
			{
				panel.SetTime(msg.costtime/1000,ENUM_TOPICBOX.CAIJI, msg.tatget);
				panel.SetInfo();
			}
		}
	},

	RecvResStopGatherMessage:function(msg) {
		//cc.log( "==============================stop collect  ");
		if (msg.personId.toGID() == Mgr.player.mainPlayer.sid.toGID()) {
			//停止采集
			//Mgr.mainPlayer.StopCollect();
			EngineMgr.uiMgr.HidePanelByType(TopicBoxExt.PanelName);
		}
		this.curCollectionNpcId = 0;
	},

	RecvResNpcActionMessage:function(msg) {	
	},

	RecvResTaskNpcGatherFinishMessage:function(msg) {
		EngineMgr.uiMgr.HidePanelByType(TopicBoxExt.PanelName);
	},

	RecvResNpcStateChangeMessage:function(msg){
		var npc = Mgr.sceneObj.FindObject( msg.npcId.toGID() );
		if( npc ){
			npc.SetState(msg.state);
		}
	},

    RecvResNpcGatherNumsInfoMessage:function(msg){
        MasterBucketUtil.UpdateGatherCount(msg.gaherNums);
    },

    RecvResNpcHpChangeMessage:function(msg){

    },

	SendReqNpcServicesMessage:function(npcId) {
		var msg = new ReqNpcServicesMessage();
		msg.npcId = npcId;
		Mgr.msgMgr.Send( msg );
	},

	SendReqServiceMessage:function(msg) {	
	},

	SelectNpcByMid:function( mid ){
		this.SelectNpc(NpcUtil.GetNpcInfoByMid(mid));
	},

	SelectNpc:function( npc ){
		if( npc ){
			Mgr.map.SelTarget(npc);
			this.curCollectionNpcId = npc.nBodyModelId;
			var checkdis = NpcUtil.GetNpcTalkDis(npc.nBodyModelId);
			if( ToolMap.CalcDistance( npc.GetGridPt(), Mgr.mainPlayer.GetGridPt() ) >= checkdis ){
				Mgr.mainPlayer.oCtrlAutoPath.RunToPt( npc.GetGridPt(), AutoPathParam.CreateSelectNpcInfo(npc) );
			}else {
                // 处理特殊的逻辑
                if(MarriageUtil.DoSpecialWithSelectNpc(npc.nBodyModelId)) return;
                if(TaskUtil.DoSpecialWithSelectNpc(npc.nBodyModelId)) return;

                this.SendReqNpcServicesMessage( npc.oSid );
			}
		}
		else
			Mgr.map.SelTarget(null);
	},

	ClickSceneNpc:function(npc){
		this.SelectNpc(npc);
	},

	NpcSubFunction:function(type)
	{
		var ret = false;
		switch(type)
		{
			case NpcTaskType.NPC_PANEL_TASK:
			{
				ret = this.ShowTaskPanel();
				break;
			}
			case NpcTaskType.NPC_PANEL_SHOP:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_FLY:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_FORGE:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_STORE:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_SCRIPT:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_CATAPULTS:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_ESCORT:
			{
				break;
			}
			case NpcTaskType.NPC_PANEL_CLOSE:
			{
				break;
			}
			default:
				break;
		}

		return ret;
	},

	TurnToMainplayer:function(){
		var npcs = Mgr.sceneObj.oRoundNpcList.oHashList.aList;
		var len = npcs.length;
		for( var i = 0; i < len; i++ ){
			var npc = npcs[i];
            if(NpcUtil.IsNpcNoNeedTurnToPlayer(npc)) continue;
			npc.TurnToObj(Mgr.mainPlayer);
		}
	},

	UpdateTaskState:function(){
		var npcs = Mgr.sceneObj.oRoundNpcList.oHashList.aList;
		var len = npcs.length;
		for( var i = 0; i < len; i++ ){
			var npc = npcs[i];
			npc.UpdateTaskState();
		}
	}
});