/*------------------任务面板类型-------------------------*/
var NpcTaskType = NpcTaskType || {};
// 任务
NpcTaskType.NPC_PANEL_TASK = 1;
// 商店
NpcTaskType.NPC_PANEL_SHOP = 2;
// 传送
NpcTaskType.NPC_PANEL_FLY = 3;
// 锻造
NpcTaskType.NPC_PANEL_FORGE = 4;
// 仓库
NpcTaskType.NPC_PANEL_STORE = 5;
// 攻城车指挥官
NpcTaskType.NPC_PANEL_CATAPULTS = 6;
// 美人护送
NpcTaskType.NPC_PANEL_ESCORT = 7;
// 关闭NPC面板选项
NpcTaskType.NPC_PANEL_CLOSE = 8;
// 群英论剑攻城车
NpcTaskType.NPC_PANEL_QUNYINGCATAPULTS = 9;
// 脚本
NpcTaskType.NPC_PANEL_SCRIPT = 20;

var NpcUtil = NpcUtil || {

    //NPC对话默认格子数
    NpcTalkDis:5,

    BAO_XIANG_ID:1021,      //掌门斗宝npcid

    IsValidType:function (type)
    {
        if (type > NpcTaskType.NPC_PANEL_TASK && type <= NpcTaskType.NPC_PANEL_CLOSE)
            return true;

        if (type == NpcTaskType.NPC_PANEL_SCRIPT)
            return true;

        return false;
    },

    /**
     * 通过taskMid取得绑定的npcV
     * @param taskMId
     * @return
     *
     */
    GetNpcSidByTaskMid:function (taskMId) {
        var npcList = Mgr.sceneObj.oRoundNpcList.oHashList.aList;
        for (var i = 0; i < npcList.length; i++) {
            var npcm = Q_npc.Get(npcList[i].nBodyModelId);
            if (npcm == null || npcm.q_task == null )
                continue;

            var taskList = npcm.q_task.split(";");
            for (var k = 0; k < taskList.length; k++ ) {
                if ( taskList[k] == taskMId ) {
                    return npcList[i];

                }
            }

        }
        return null;
    },

    /**
     * 通过npcMid取得最近的npc
     * @param mid
     * @return
     *
     */
    GetNpcInfoByMid:function (mid) {
        var npcList = Mgr.sceneObj.oRoundNpcList.oHashList.aList;
        var nearestNpc = null;
        var nearestDis = LongUtil.MAX_UINT;
        for (var i = 0; i < npcList.length; i++) {
            var npc = npcList[i];
            if ( npc.nBodyModelId == mid ) {
                var dis = ToolMap.CalcDistance( Mgr.mainPlayer.GetGridPt(), npc.GetGridPt());
                if( dis < nearestDis ){
                    nearestNpc = npc;
                    nearestDis = dis;
                }
            }
        }
        return nearestNpc;
    },

    /**
     * npc 对话格子数
     * @return
     *
     */
    GetNpcTalkDis:function (mid)
    {
        var npcm = Q_npc.Get(mid);
        if (npcm == null)
            return this.NpcTalkDis;

        // 有配置数量
        if (npcm.q_Interactive != 0)
            return npcm.q_Interactive;

        return this.NpcTalkDis;
    },

    GetNpcName:function (mid)
    {
        var npcm = Q_npc.Get(mid);
        if (npcm == null)
            return encodeURI(encodeURI("未知NPC："));
        return npcm.q_name;
    },

    /**
     * 传送点颜色
     * @param lv
     * @return
     *
     */
    GetNpcFlyColor:function(lv)
    {
        var color = 0xff0000;
        var deltaLevel = lv - Mgr.mainPlayer.curLevel;
        if (deltaLevel <= -10)
            color = 0x777777;// 灰
        else if (deltaLevel <= -5)
            color = ColorUtil.N_WRITE_UINT;// 白
        else if (deltaLevel <= 5)
            color = 0x00ff00;// 绿
        else if (deltaLevel <= 10)
            color = 0xffee00;// 黄
        else if (deltaLevel >= 10)
            color = 0xff0000;// 红
        return color;
    },

    IsNpcNameBlocked:function(sceneNpc){
        var arr = Mgr.guardcpital.GetNpcIdList();



        for(var k=0,len=arr.length,v=arr[k];k!=len;v=arr[++k]){
            if(v == sceneNpc.nBodyModelId) return true;
        }

        return false;
    },

    IsNpcNoNeedTurnToPlayer:function(sceneNpc){
        var arr = Mgr.guardcpital.GetNpcIdList();

        if( this.BAO_XIANG_ID == sceneNpc.nBodyModelId )
            return true;

        var npc = Q_npc.Get(sceneNpc.nBodyModelId);
        if( npc.q_collecttime > 0 )
            return true;

        for(var k=0,len=arr.length,v=arr[k];k!=len;v=arr[++k]){
            if(v == sceneNpc.nBodyModelId) return true;
        }

        return false;
    },

    IsNpcShowName:function(npc){
        if( npc.nBodyModelId == this.BAO_XIANG_ID )
            return false;
        return true;
    }
}