/**
 * 属性管理
 * */
var AttributeMgr = AttributeMgr || cc.Class.extend({
    _attHash:null,
    _attPowerHash:null,
    _zhuanshenAttPowerHash:null,
    ctor:function(){

    },

    /**
     * 获得一点属性所对应的战斗力数值
     * */
    GetAttributeRate:function(aType, zhuanshengLv)
    {
        zhuanshengLv = 0;//全部以自己的转生为准显示属性；
        if( zhuanshengLv > 0 )
        {
            if( !this._zhuanshenAttPowerHash )
            {
                this._zhuanshenAttPowerHash = new HashMap();
                var tempArr = Q_global.Get( 567 ).q_string_value.split(";");
                for( var i = 0; i < tempArr.length; i++ )
                {
                    if( tempArr[i].toString().length > 2 )
                    {
                        var strArr = tempArr[i].toString().split(",");
                        this._zhuanshenAttPowerHash.Put( strArr[0], strArr[1] );
                    }
                }
            }
            return this._zhuanshenAttPowerHash.Get(aType);
        }
        else
        {
            if( !this._attPowerHash )
            {
                this._attPowerHash = new HashMap();
                var tempArr = Q_global.Get( 35 ).q_string_value.split(";");
                for( var i = 0; i < tempArr.length; i++ )
                {
                    if( tempArr[i].toString().length > 2 )
                    {
                        var strArr = tempArr[i].toString().split(",");
                        this._attPowerHash.Put( strArr[0], strArr[1] );
                    }
                }
            }
            return this._attPowerHash.Get(aType);
        }
    },

    GetAttribute:function(type, num, reinLevel)
    {
        reinLevel = arguments[2] ? arguments[2] : 0;
        // if ( reinLevel == -1 )
        //     reinLevel = Mgr.mainPlayer.reinLevel;
        if( reinLevel > 0 )
        {
            if( !this._attHash )
            {
                this._attHash = new HashMap();
                var tempArr = Q_global.Get( 568 ).q_string_value.split(";");
                for( var i = 0; i < tempArr.length; i++ )
                {
                	var str = tempArr[i];
                	if( str.length > 2 )
                    {
                		var strArr = str.split(",");
                        this._attHash.put( strArr[0], strArr[1] );
                    }
                }
            }
            if( this._attHash.getValue(type) )
                return this._attHash.getValue(type)*num;
        }
        return num;
    },
    
    /**
     * 得到强化属性增加值
     * @param value
     * @param level
     * @param type
     * @param isSuper	是否万能强化
     * @return
     */
    GetStrengAddValue:function(mid, type, level, isSuper)
    {
        var itemStrengthm;
        if ( isSuper )
            itemStrengthm = Q_attribute_rise_add.Get(mid + '_' + level);
        else
            itemStrengthm = Q_attribute_rise.Get(mid + '_' + level);

        if (itemStrengthm == null)
            return 0;
        switch (type)
        {
            case EnumAttribute.ANTI_CRIT:
                return this.GetAttribute(EnumAttribute.ANTI_CRIT, itemStrengthm.q_antiCrit);
            case EnumAttribute.ATTACK:
                return this.GetAttribute(EnumAttribute.ATTACK, itemStrengthm.q_attack);
            case EnumAttribute.CRIT:
                return this.GetAttribute(EnumAttribute.CRIT, itemStrengthm.q_crit);
            case EnumAttribute.DEFEND:
                return this.GetAttribute(EnumAttribute.DEFEND, itemStrengthm.q_defence);
            case EnumAttribute.DODGE:
                return this.GetAttribute(EnumAttribute.DODGE, itemStrengthm.q_dodge);
            case EnumAttribute.HIT:
                return this.GetAttribute(EnumAttribute.HIT, itemStrengthm.q_hit);
            case EnumAttribute.MAX_BASEHP:
                return this.GetAttribute(EnumAttribute.MAX_BASEHP, itemStrengthm.q_max_hp);
        }

        return 0;
    },

    GetAttributeRatiosDescription:function(type,value){
        type = parseInt(type);
        value = parseInt(value);

        switch(type){
            case EnumAttribute.ATTACK               : return ["攻击加成",	value / 100 + "%"];  break;
            case EnumAttribute.DEFEND               : return ["防御加成",	value / 100 + "%"];  break;
            case EnumAttribute.CRIT                 : return ["暴击加成",	value / 100 + "%"];  break;
            case EnumAttribute.ANTI_CRIT            : return ["抗暴击加成",	value / 100 + "%"];  break;
            case EnumAttribute.DODGE                : return ["闪避值加成",	value / 100 + "%"];  break;
            case EnumAttribute.HIT                  : return ["命中值加成",	value / 100 + "%"];  break;
            case EnumAttribute.MAX_BASEHP           : return ["生命加成",	value / 100 + "%"];  break;
        }
        return [type,value];
    },

    GetAttrDes:function(type,value){
        type = parseInt(type);
        value = parseInt(value);
        switch(type){
            case EnumAttribute.ATTACK               : return ["攻击",         value];  break;
            case EnumAttribute.DEFEND               : return ["防御",         value];  break;
            case EnumAttribute.CRIT                 : return ["暴击",         value];  break;
            case EnumAttribute.ANTI_CRIT            : return ["抗暴击",       value];  break;
            case EnumAttribute.DODGE                : return ["闪避值",       value];  break;
            case EnumAttribute.HIT                  : return ["命中值",       value];  break;
            case EnumAttribute.MAX_BASEHP           : return ["生命",         value];  break;
            case EnumAttribute.ATTACK_SPEED         : return ["攻击速度",     value / 10 + "%"];  break;
            case EnumAttribute.MOVE_SPEED           : return ["移动速度",     value / 10 + "%"];  break;
            case EnumAttribute.HOLY_DAMAGE          : return ["附加伤害",     value];  break;
            case EnumAttribute.DAMAGE_BONUS         : return ["伤害加成",     value / 100 + "%"];  break;
            case EnumAttribute.DAMAGE_REDUCE        : return ["伤害减免",     value / 100 + "%"];  break;
            case EnumAttribute.AUTO_RECOVER_HP      : return ["自动回复",     value];  break;
            case EnumAttribute.CRIT_DAMAGE_BONUS    : return ["暴击伤害加成", value / 100 + "%"];  break;
            case EnumAttribute.CRIT__REDUCE         : return ["暴击减免",     value / 100 + "%"];  break;
            case EnumAttribute.EXP_BONUS            : return ["经验加成",     value / 100 + "%"];  break;
            case EnumAttribute.SKILL_BONUS          : return ["技能伤害加成", value / 100 + "%"];  break;
            case EnumAttribute.BRILLIANT_DAMAGE     : return ["神武伤害",     value];  break;

            case EnumAttribute.ATTACK_PERCENT       : return ["攻击加成",     value / 10 + "%"];  break;
            case EnumAttribute.DEFEND_PERCENT       : return ["防御加成",     value / 10 + "%"];  break;
            case EnumAttribute.CRIT_PERCENT         : return ["暴击加成",     value / 10 + "%"];  break;
            case EnumAttribute.ANTI_CRIT_PERCENT    : return ["抗暴加成",     value / 10 + "%"];  break;
            case EnumAttribute.DODGE_PERCENT        : return ["闪避加成",     value / 10 + "%"];  break;
            case EnumAttribute.HIT_PERCENT          : return ["命中加成",     value / 10 + "%"];  break;
            case EnumAttribute.MAXHP_PERCENT        : return ["生命加成",     value / 10 + "%"];  break;
            case EnumAttribute.ATTACK_SPEED_PERCENT : return ["攻击速度加成", value / 10 + "%"];  break;
            case EnumAttribute.MOVE_SPEED_PERCENT   : return ["移动速度加成", value / 10 + "%"];  break;
            case EnumAttribute.DODGE_PERCENT        : return ["闪避加成", value / 10 + "%"];  break;

            case EnumAttribute.PALSY_PERCENT        : return ["麻痹",         value / 100 + "%"];  break;
            case EnumAttribute.ANTI_PALSY_PERCENT   : return ["抗麻痹",       value / 100 + "%"];  break;
        }

        return [type,value];
    },

    GetReslineNameByType:function(type){
        switch(parseInt(type)){
            case EnumResline.WING                   : return "光翼";      break;
            case EnumResline.TAIJI                  : return "VIP升级";     break;
            case EnumResline.PLAYER                 : return "角色";      break;
            case EnumResline.HORSE                  : return "坐骑";      break;
            case EnumResline.GUANGWU                : return "光武";      break;
            case EnumResline.SHUTONG                : return "书童";      break;
            case EnumResline.BAOQI                  : return "宝骑";      break;
            case EnumResline.DRAGON                 : return "法器";      break;
            case EnumResline.WUXUE                  : return "武学";      break;
            case EnumResline.SCABBARD               : return "剑鞘";      break;
            case EnumResline.STEP                   : return "脚印";      break;
            case EnumResline.ZHAOSHI                : return "招式";      break;
            case EnumResline.JIANLING               : return "剑灵";      break;
        }
        // return "";
    },

    GetFightPowerWithAttrData:function(attrData){
        if(!attrData) return 0;

        var power = 0;
        for(var k in EnumAttribute){
            var v = EnumAttribute[k];
            var val = attrData.GetAttribute(v,AttributeData.Fight);
            var factor = Mgr.attributeMgr.GetAttributeRate(v);
            power +=  val * factor;
        }

        return power;
    },

    GetShutongAttributeData:function(){
        var attr = new AttributeData();

        var mgr = Mgr.resline.GetMgrByType(EnumResline.SHUTONG);
        var layer = Math.max(mgr.curShowLayer, 1);
        var stars = mgr.GetCurShowStars();
        var attrArr = mgr.GetAttribute( 0,
                layer,
                stars,
                mgr.GetDanDataArr(layer, stars),
                mgr.GetDanNumArr()
            );

        attrArr.forEach(v=>{
            let type = parseInt(v.type);
            let value = parseInt(v.value);
            let val = attr.GetAttribute(type,AttributeData.Fight);
            attr.PutAttribute(type,val + value,AttributeData.Fight);
        })

        let equips = Mgr.equip.GetEquipsByType(EnumItemType.Equip_Shutong);
        equips.forEach(function(v){
            let attrV = DuanzaoUtil.GetAttributeV(v.itemModelId,v ? v.strenthenLv : v.itemLevel);
            if(!attrV) return;

            let type =  parseInt(attrV.type);
            let value =  parseInt(attrV.value);
            let val = attr.GetAttribute(type,AttributeData.Fight);
            attr.PutAttribute(type,val + value,AttributeData.Fight);
        });

        return attr;
    },
});