/**
 * 玩家游戏状态枚举
 * Created by Merlin on 2016/5/31.
 */
var StateElm = StateElm || cc.Class.extend({
        state:0,
        mark:0,
        ctor:function (s, m) {
            this.state = s;
            this.mark = m;
        }
    });

var EnumPlayerState = EnumPlayerState ||{
    /**
     * 正常
     */
    MORMAL:new StateElm(0x00000000, 0xFFFFFFF0),

    /**
     * 登陆
     */
    LOGIN:new StateElm(0x00000001, 0xFFFFFFF0),

    /**
     * 退出中
     */
    QUITING:new StateElm(0x00000002, 0xFFFFFFF0),

    /**
     * 退出
     */
    QUIT:new StateElm(0x00000004, 0xFFFFFFF0),

    /**
     * 无状态
     */
    NOTHING:new StateElm(0x00000000, 0xFFFFFF0F),

    /**
     * 战斗
     */
    FIGHT:new StateElm(0x00000010, 0xFFFFFF0F),

    /**
     * 死亡
     */
    DIE:new StateElm(0x00000020, 0xFFFF000F),

    /**
     * 站立
     */
    STAND:new StateElm(0x00000000, 0xFFFF00FF),

    /**
     * 走动
     */
    RUN:new StateElm(0x00000100, 0xFFFF00FF),

    /**
     * 跳跃
     */
    JUMP:new StateElm(0x00000200, 0xFFFF00FF),

    /**
     * 二次跳跃
     */
    DOUBLEJUMP:new StateElm(0x00000400, 0xFFFF00FF),

    /**
     * 格挡准备
     */
    BLOCKPREPARE:new StateElm(0x00000800, 0xFFFF00FF),

    /**
     * 格挡
     */
    BLOCK:new StateElm(0x00001000, 0xFFFF00FF),

    /**
     * 打坐
     */
    SIT:new StateElm(0x00002000, 0xFFFF00FF),

    /**
     * 游泳
     */
    SWIM:new StateElm(0x00004000, 0xFFFF00FF),

    /**
     * 无复活
     */
    NOREVIVE:new StateElm(0x00000000, 0xFFFEFFFF),

    /**
     * 自动复活
     */
    AUTOREVIVE:new StateElm(0x00010000, 0xFFFEFFFF),

    /**
     * 非交易状态
     */
    NOTRANSACTION:new StateElm(0x00000000, 0xFFFDFFFF),

    /**
     * 交易
     */
    TRANSACTION:new StateElm(0x00020000, 0xFFFDFFFF),

    /**
     * 非挂机状态
     */
    NOAUTOFIGHT:new StateElm(0x00000000, 0xFFFBFFFF),

    /**
     * 挂机
     */
    AUTOFIGHT:new StateElm(0x00040000, 0xFFFBFFFF),

    /**
     * 龙元心法计时结束
     */
    LONGYUANEND:new StateElm(0x00000000, 0xFFF7FFFF),

    /**
     * 龙元心法开始计时状态（用来防止计时器重复调用）
     */
    LONGYUANSTART:new StateElm(0x00080000, 0xFFF7FFFF),

    /**
     * 原地复活计时结束
     */
    REVIVEEND:new StateElm(0x00000000, 0xFFEFFFFF),

    /**
     * 原地复活开始计时状态（用来防止计时器重复调用）
     */
    REVIVESTART:new StateElm(0x00100000, 0xFFEFFFFF),
};
EnumPlayerState.CheckState = function(selm, stateValue){
    return ((stateValue & ~(selm.mark)) == selm.state);
};