var JinJieMainExt = JinJieMain.extend ( {
	_className:"JinJieMainExt",
	
	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function(){
		var self = this;
		JinJieMain.prototype.Init.call( this );
		this.btnYes.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		 // action
		// var rotateby = new cc.RotateBy(2, 360).repeatForever();
		// this.imgGuang.runAction(rotateby);
	},

	SetData:function (reslineType) {
		var mgr = Mgr.resline.GetMgrByType( reslineType );
		// cur value
		var layer = mgr.GetLayer();
		var stars = mgr.GetCurShowStars();

		if( !this._uiModel ){
			this._uiModel = new UIModel(layer, reslineType)
			this.imgModel.addChild(this._uiModel);
		}
		else{
			this._uiModel.SetModelId(layer);
		}

		var attHash = mgr.GetAtt( 0, layer, stars, mgr.GetDanDataArr(layer, stars), mgr.GetDanNumArr() );
		var attackV = attHash.Get(EnumAttribute.ATTACK);
		var defV = attHash.Get(EnumAttribute.DEFEND);
		var hpV = attHash.Get(EnumAttribute.MAX_BASEHP);

		var attInfos = mgr.GetAttribute( 0, layer, stars, mgr.GetDanDataArr(layer, stars), mgr.GetDanNumArr() );
		var powerV = Mgr.fight.GetAttrsPowerList(attInfos);

		// last value
		var lastAttrHash = mgr.GetLastAtt();
		this.ShowAndHideParam(lastAttrHash != null);
		if ( lastAttrHash ) {
			var lastAttackV = lastAttrHash.Get(EnumAttribute.ATTACK);
			var lastDefV = lastAttrHash.Get(EnumAttribute.DEFEND);
			var lastHpV = lastAttrHash.Get(EnumAttribute.MAX_BASEHP);

			var addAttack = attackV - lastAttackV;
			var addDef = defV - lastDefV;
			var addHp = hpV - lastHpV;

			var lastPower = mgr.GetLastFighting();
			var addPower = powerV - lastPower;

			this.ShowAddAttr(addAttack, addDef, addHp, addPower);
		}

		this.labAtk1.SetHtmlText( attackV);
		this.labDef1.SetHtmlText( defV);
		this.labHp1.SetHtmlText(hpV);

		this.labFight.SetString( powerV );
	},

	ShowAddAttr:function ( attack, def, hp, power ) {
		this.labAtk11.SetString(attack);
		this.labAtk111.SetString(def);
		this.labAtk1111.SetString(hp);
		this.labFight1.SetString(power);

		var blink = cc.blink(3, 3);
		//var out =cc.fadeOut(0.5);
		//var rep = cc.sequence(blink, out);
		this.imgUp1.runAction(blink);
		this.labAtk11.runAction(blink.clone());

		this.imgUp11.runAction(blink.clone());
		this.labAtk111.runAction(blink.clone());

		this.imgUp111.runAction(blink.clone());
		this.labAtk1111.runAction(blink.clone());

		this.imgUp.runAction(blink.clone());
		this.labFight1.runAction(blink.clone());
	},

	ShowAndHideParam:function (visible) {
		var opacity = visible ? 255 : 0;
		this.imgUp1.visible = visible;
		this.imgUp1.setOpacity(opacity);
		this.labAtk11.visible = visible;
		this.labAtk11.setOpacity(opacity);

		this.imgUp11.visible = visible;
		this.imgUp11.setOpacity(opacity);
		this.labAtk111.visible = visible;
		this.labAtk111.setOpacity(opacity);

		this.imgUp111.visible = visible;
		this.imgUp111.setOpacity(opacity);
		this.labAtk1111.visible = visible;
		this.labAtk1111.setOpacity(opacity);

		this.imgUp.visible = visible;
		this.imgUp.setOpacity(opacity);
		this.labFight1.visible = visible;
		this.labFight1.setOpacity(opacity);
	},
	OnHide:function(){
		this._super();
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	}
} );
JinJieMainExt.PanelName = "JinJieMainExt";
PanelClassDic["JinJieMainExt"] = JinJieMainExt;
