var OtherRoleItem2Ext = OtherRoleItem2.extend ( {
	_className:"OtherRoleItem2Ext",

	_reslineKind:0,
	_reslineModelId:0,
	_skills:null,
	_openSkillGridNull:0,
	_equips:null,
	_job:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		OtherRoleItem2.prototype.Init.call(this);
		this.labJihuo.visible = false;
		this.imgLock.visible = false;
		this.imgModel.x += 30;
		this.imgModel.y += 15;
	},

	SetData:function (data) {
		this._reslineKind = data.reslineType;
		this._reslineModelId = data.reslineModelId;
		this._equips = data.equips;
		this._skills  = data.euipSkillInfo;
		this._openSkillGridNull = data.skillBoxNum;
		this._job = data.job;

		var q_id = this._reslineKind.toString() + "_" + this._reslineModelId.toString();
		var q_resline = Q_resline.Get(q_id);
		// name
		this.labName.SetString(q_resline.q_name);

		if( !this._uiModel ){
			this._uiModel = new UIModel(this._reslineModelId, this._reslineKind)
			this.imgModel.addChild(this._uiModel);
		}
		else{
			this._uiModel.SetModelId(this._reslineModelId, this._reslineKind);
		}

		this._updataGrid();
	},

	_updataGrid:function()
	{
		//初始化技能grid
		this._gridVec = [ this.gridEquip, this.gridEquip2, this.gridEquip3, this.gridEquip4, this.gridEquip5, this.gridEquip6 ];
		var skills = this.GetSkillArray();
		for ( var i = 0; i < skills.length; i++)
		{
			if ( this._gridVec.length <= i )
				break;

			var grid = this._gridVec[i];
			var skillid = skills[i][1];
			var reslineVo = new Object();
			reslineVo.reslinetype = this._reslineKind;
			reslineVo.reslinelayer = skills[i][0];
			GridUtil.SetSkillGridByMID( GridInteractionType.RESLINESKILLSHOW,grid, skillid, this.GetSkillLev( skillid ), reslineVo );

			if ( this._openSkillGridNull > i ) {
				Filter.UnGray(grid);

				// lock
				if ( grid.lock )
					grid.lock.visible = false;
			}
			else {
				Filter.GrayScale(grid);

				// lock
				if ( !grid.lock ) {
					var icon = new MUIImage();
					icon.ParseJson(this.imgLock.jsonobj);
					icon.Init();
					icon.setPosition(this.imgLock.getPosition());
					grid.addChild(icon, 2, 30);
					grid.lock = icon;
				}
				grid.lock.visible = true;
			}
		}
		//初始化装备grid
		this._gridVec1 = [ this.gridEquip5, this.gridEquip6 ];
		var equips = this._equips;
		for ( var i = 0; i < equips.length; i++)
		{
			if ( this._gridVec1.length <= i )
				break;

			var grid = this._gridVec1[i];
			var item = equips[i];
			GridUtil.SetItemGrid(grid,item);
		}
		//设置需要填充资源线名字的地方
		var reslinename;
		if ( this._reslineKind == EnumResline.HORSE )
			reslinename = "坐骑";
		else if ( this._reslineKind == EnumResline.DRAGON )
			reslinename = "法器";
		else if ( this._reslineKind == EnumResline.GUANGWU )
			reslinename = "光武";
		else if ( this._reslineKind == EnumResline.SHUTONG )
			reslinename = "书童";
		else if ( this._reslineKind == EnumResline.BAOQI )
			reslinename = "宝骑";
		UIUtil.ConnectLabelHtmlText( this.labSkill, [reslinename] );
		UIUtil.ConnectLabelHtmlText( this.labSkill1, [reslinename] );
	},

	GetSkillArray:function()
	{
		var reslineList = ReslineUtil.GetReslineContainer(this._reslineKind);
		reslineList.sort(this.sortQDataId);
		var skillArr = [];
		for( var i = 0; i < reslineList.length; i++ )
		{
			var q_resline = reslineList[i];
			if( q_resline.q_skill > 0 )
			{
				var layer = q_resline.q_id.split("_")[1];
				skillArr.push( [layer,q_resline.q_skill] );
			}
		}
		return skillArr;
	},

	sortQDataId:function (p1, p2)
	{
		if (p1.q_id < p2.q_id)
			return -1;
		else if (p2.q_id < p1.q_id)
			return 1;

		return 0;
	},

	GetSkillLev:function( skillID )
	{
		if ( this._skills == null )
			return 0;
		for ( var i = 0; i < this._skills.length; i++ )
		{
			var skillInfo = this._skills[i];//SkillInfo
			if ( skillInfo._skills == skillID )
				return skillInfo.skillLevel;
		}
		return 0;
	},

	OnHide:function(){
		this._super();
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	}
} );
OtherRoleItem2Ext.PanelName = "OtherRoleItem2Ext";
PanelClassDic["OtherRoleItem2Ext"] = OtherRoleItem2Ext;
