var OtherRoleItemExt = OtherRoleItem.extend ( {
	_className:"OtherRoleItemExt",

	_roleBriefInfo:null,
	_gridArr:null,
	_uiModel:null,
	modUrl:null,
	wepUrl:null,

	ctor:function(){
		this._super();
	},
  
	Init:function() {
		OtherRoleItem.prototype.Init.call(this);
		this.img1.x += 25;
		this.img1.y -= 20;
		this.img1.setLocalZOrder(-1);

        this.btnFlower.addClickEventListener(_=>{
            OpenFuncUtil.OpenSendFlowerPanel({
                playerId : this._roleBriefInfo.playerid,
                name : this._roleBriefInfo.playerName,
                sex : this._roleBriefInfo.job,
            })
        })

		this._InitPanel();
	},

	_InitPanel:function () {
		this._InitParam();
	},

	_InitParam:function () {
		this._gridArr = [
			{obj:this.gridEquip,type:EnumEquipPos.EQUIP_WEAPONS},
			{obj:this.gridEquip2,type:EnumEquipPos.EQUIP_CLOTHES},
			{obj:this.gridEquip3,type:EnumEquipPos.EQUIP_HUTUI},
			{obj:this.gridEquip4,type:EnumEquipPos.EQUIP_HUFU_LEFT},
			{obj:this.gridEquip5,type:EnumEquipPos.EQUIP_RING_LEFT},
			{obj:this.gridEquip6,type:EnumEquipPos.EQUIP_BELT},
			{obj:this.gridEquip7,type:EnumEquipPos.EQUIP_BRACELET_LEFT},
			{obj:this.gridEquip8,type:EnumEquipPos.EQUIP_SHOES},
			{obj:this.gridEquip9,type:EnumEquipPos.EQUIP_HUFU_RIGHT},
			{obj:this.gridEquip10,type:EnumEquipPos.EQUIP_RING_RIGHT}
		];
	},

	SetData:function ( briefInfo ) {
		this._roleBriefInfo = briefInfo;
		this._UpDataPanel()
	},

	_UpDataPanel:function () {
		//this.Clear();

		if (!this._roleBriefInfo)
			return;

		// guild name
		if(this._roleBriefInfo.guildName) {
            var str = this._roleBriefInfo.guildName.split(".");
            this.labGuild.SetString("[帮派]." + str[1]);
        }
		else {
            this.labGuild.SetString("");
        }

		// role name
		this.labName.SetString(this._roleBriefInfo.playerName);

		// model
		this._AddPlayerModule();

		// equips
		var equips = this._roleBriefInfo.equips;
		this._SetEquips(equips);

		// fight
		var fight = this._roleBriefInfo.fightpower;
		this.labNumber.SetString( fight);
	},

	_AddPlayerModule:function() {
		if( !this._uiModel ){
			this._uiModel = new UIModel(SceneObjUtil.GetBodyIdByInfo(this._roleBriefInfo));
			this.img1.addChild(this._uiModel);
		}
		else{
			this._uiModel.SetModelId(SceneObjUtil.GetBodyIdByInfo(this._roleBriefInfo));
		}
		for( var i = 0; i < this._roleBriefInfo.reslineInfo.length; i++ ){
			var resline = this._roleBriefInfo.reslineInfo[i];
			if( resline.reslineType == EnumResline.GUANGWU )
				this._uiModel.AddWeapon(SceneObjUtil.GetGodWeaponResId(this._roleBriefInfo.illusionDataInfos) || resline.reslineModelId, this._roleBriefInfo.job);
		}

	},

	_SetEquips:function(equips)
	{
		this._AddEquips( equips );
	},

	_AddEquips:function( equips )
	{
		for ( var i = 0; i < this._gridArr.length; i++ ) {
			var equip = null;
			for ( var j = 0; j < equips.length; j++ ) {
				var equipC = Q_item.Get(equips[j].itemModelId);
				if ( this._gridArr[i].type == equipC.q_kind ) {
					equip = equips[j];
					break;
				}
			}
			this._SetEquipGrid( this._gridArr[i].obj, equip );
		}
	},

	_SetEquipGrid:function ( grid, equipV ) {
		grid.Clean();
		if ( equipV ) {
            GridUtil.SetItemGrid(grid, equipV, equipV.itemModelId, false, null, false, false, false, false, null, true);
			grid.equipV = equipV;

			// callback
			//var item = ItemUtil.ItemIdToItem(equipV.itemModelId);  这个取的不对自己取下
            var q_item = Q_item.Get(equipV.itemModelId);
			var item;
			var equips=this._roleBriefInfo.equips;
			for(var i=0;i<equips.length;++i){
				if(equipV.itemModelId==equips[i].itemModelId){
                    item=equips[i];
                    break;
				}
			}
            var gemInfoList=this._roleBriefInfo.gemInfos;
            var refineInfoList=this._roleBriefInfo.refineSysInfos;          //这些应该都是只有一个元素的(*^__^*)
			//取宝石
            var GemData=[];
			for(var k=0;k<gemInfoList.length;++k){
				var gemInfo=gemInfoList[k];
                var stoneMidS=[];
                for(var i=0;i<gemInfo.equipLocationList.length;++i){
                    if(gemInfo.equipLocationList[i]==q_item.q_kind){
                        stoneMidS.push(gemInfo.gemModelList[i]);
                    }
                }
                for(var i=0;i<stoneMidS.length;++i){
                    var stoneC=Q_item.Get(stoneMidS[i].gemModelId);
                    var data = { equip_type:q_item.q_kind, stone_type:null, mid:stoneMidS[i].gemModelId, stoneC:stoneC };
                    GemData.push(data);
                }
			}
			//精炼
            var refineData=new HashMap();
			for(var k=0;k<refineInfoList.length;++k){
				var refineInfo=refineInfoList[k];
                var stoneInfo=null;
                for(var i=0;i<refineInfo.equipRefinelList.length;++i){
                    //cc.log(" 部位：  "+refineInfo.equipRefinelList[i].equipLocation+"数量："+refineInfo.equipRefinelList[i].refinelList[1]+"id "+refineInfo.equipRefinelList[i].refinelList[0]);
                    if(q_item.q_kind==refineInfo.equipRefinelList[i].equipLocation){
                        stoneInfo=refineInfo.equipRefinelList[i].refinelList;

                        for(var kk = 0;kk < stoneInfo.length / 2;kk++){
                            var type = stoneInfo[kk * 2];
                            var num = stoneInfo[kk * 2 + 1];

                            var itemC=Q_item.Get(type);
                            var maxNum = 0;
                            var numData = DuanzaoUtil.GetRefineStoneNumByQuility(q_item.q_rank);
                            if(numData){
                                for (var j = 0; j != numData.length; j++) {
                                    if (itemC.q_location == numData[j].location) {
                                        maxNum = numData[j].num;
                                        break;
                                    }
                                }
                            }
                            refineData.Put(itemC.q_location,{ item:itemC, bagNum:0, maxNum:maxNum, usedNum:num});
                        }
                    }
                }
			}
			//精炼的没有也要加0
            var stoneTypeEnum = [RefineStoneEnum.ATTACK, RefineStoneEnum.DEFENSE,RefineStoneEnum.HP];
            for (var i = 0; i != stoneTypeEnum.length; i++) {
            	if(!refineData.Get(stoneTypeEnum[i])) {
                    var itemC = null;
                    var configList = DuanzaoUtil.GetStoneByType(EnumItemType.RefineStone, stoneTypeEnum[i]);
                    if (configList.length > 0)
                        itemC = configList[0];
                    var maxNum = 0;
                    var data = DuanzaoUtil.GetRefineStoneNumByQuility(q_item.q_rank);
                    if (data) {
                        for (var j = 0; j != data.length; j++) {
                            if (stoneTypeEnum[i] == data[j].location) {
                                maxNum = data[j].num;
                                break;
                            }
                        }
                    }
                    refineData.Put(stoneTypeEnum[i],{ item:itemC, bagNum:0, maxNum:maxNum, usedNum:0});
				}
            }
			//套装
            var suit=SuitMakeUtil.GetSuitAttr(this._roleBriefInfo.equips,this._roleBriefInfo.equipSuitInfos);
            grid.setTouchEnabled(true);
            grid.addClickEventListener(function () {
                var panel = Mgr.uiMgr.ShowPanelByType(EquipTipsPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP);
                panel.setLocalZOrder(10000);
                panel.Updatedata( item,GridTypeEnum.EQUIPOTHER,{gem:GemData,refine:refineData,suit:suit});
            });

			//GridUtil.SetGridInteraction( grid, GridInteractionType.ITEMSHOW, item );
		}
	},

	OnHide:function(){
		this._super();
		if( this._uiModel )
			this._uiModel.Dispose();
		this._uiModel = null;
	}
} );
OtherRoleItemExt.PanelName = "OtherRoleItemExt";
PanelClassDic["OtherRoleItemExt"] = OtherRoleItemExt;
