///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//PlugSetInfo 自动挂机设置内容
//SysSetInfo 玩家系统设置信息
//ChatSetInfo 聊天设置

// 请求消息
//113201,ReqPlugSetInfo 改变挂机设置
//113202,ReqPlugBackToCity 请求回城
//113203,ReqSetMenuStatus 改变系统设置
//113204,ReqSetChatSet 改变聊天设置

// 接收消息
//113101,ResPlugSetInfo 发送自动挂机设置内容
//113102,ResMenuStatus 发送玩家个人系统设置设定状态
//113103,ResSystemExpMagnification 系统多倍通知(登录和改变的时候通知)


var PlugSetInfo = cc.Class.extend({
	ctor:function(){
		this.range = 0; // 挂机范围
        this.pickup = 0; // 拾取道具类型
        this.autoBuyRevive = 0; // 自动买活
        this.autoInvite = 0; // 队长状态自动邀请
        this.autoAgree = 0; // 没队伍自动接收邀请
        this.smeltingQuality = 0; // 熔炼品质
        this.reinforcementLevel = 0; // 强化等级
        this.autoPickup = 0; // 自动拾取
        this.skillauto = 0; // 技能自动释放
	},

	writing:function( _buf ){
		_buf.WriteByte(this.range);
        _buf.WriteByte(this.pickup);
        _buf.WriteByte(this.autoBuyRevive);
        _buf.WriteByte(this.autoInvite);
        _buf.WriteByte(this.autoAgree);
        _buf.WriteVarInt(this.smeltingQuality);
        _buf.WriteVarInt(this.reinforcementLevel);
        _buf.WriteByte(this.autoPickup);
        _buf.WriteByte(this.skillauto);
	},
	
	reading:function( _buf ){
		this.range = _buf.ReadByte();
        this.pickup = _buf.ReadByte();
        this.autoBuyRevive = _buf.ReadByte();
        this.autoInvite = _buf.ReadByte();
        this.autoAgree = _buf.ReadByte();
        this.smeltingQuality = _buf.ReadVarInt();
        this.reinforcementLevel = _buf.ReadVarInt();
        this.autoPickup = _buf.ReadByte();
        this.skillauto = _buf.ReadByte();
	},
});
var SysSetInfo = cc.Class.extend({
	ctor:function(){
		this.clientset = 0; // 客户端设定值
        this.banAddFriend = 0; // 拒絕他人加我好友
        this.banInviteTeam = 0; // 拒绝组队邀请
        this.banInviteGuild = 0; // 拒绝他人邀请我加帮会
        this.banPrivateChat = 0; // 拒绝私聊
        this.music = 0; // 音乐
        this.sound = 0; // 音效
        this.performance = 0; // 性能
        this.shield = 0; // 屏蔽选项
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.clientset);
        _buf.WriteByte(this.banAddFriend);
        _buf.WriteByte(this.banInviteTeam);
        _buf.WriteByte(this.banInviteGuild);
        _buf.WriteByte(this.banPrivateChat);
        _buf.WriteByte(this.music);
        _buf.WriteByte(this.sound);
        _buf.WriteByte(this.performance);
        _buf.WriteByte(this.shield);
	},
	
	reading:function( _buf ){
		this.clientset = _buf.ReadVarInt();
        this.banAddFriend = _buf.ReadByte();
        this.banInviteTeam = _buf.ReadByte();
        this.banInviteGuild = _buf.ReadByte();
        this.banPrivateChat = _buf.ReadByte();
        this.music = _buf.ReadByte();
        this.sound = _buf.ReadByte();
        this.performance = _buf.ReadByte();
        this.shield = _buf.ReadByte();
	},
});
var ChatSetInfo = cc.Class.extend({
	ctor:function(){
		this.channelDisplay = 0; // 频道显示
        this.wifiAutoPlay = 0; // wifi自动播放
        this.noWifiAutoPlay = 0; // 非wifi自动播放
	},

	writing:function( _buf ){
		_buf.WriteByte(this.channelDisplay);
        _buf.WriteByte(this.wifiAutoPlay);
        _buf.WriteByte(this.noWifiAutoPlay);
	},
	
	reading:function( _buf ){
		this.channelDisplay = _buf.ReadByte();
        this.wifiAutoPlay = _buf.ReadByte();
        this.noWifiAutoPlay = _buf.ReadByte();
	},
});
////////////////////
// 发送自动挂机设置内容 //
////////////////////
var ResPlugSetInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.plugsetinfo = null; // 挂机设置
        this.sysSetInfo = null; // 系统设置
        this.chatSetInfo = null; // 聊天设置
	},

	getId:function(){
		return 113101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.plugsetinfo);
        _buf.WriteBean(this.sysSetInfo);
        _buf.WriteBean(this.chatSetInfo);
	},
	
	reading:function( _buf ){
        this.plugsetinfo = _buf.ReadBean(PlugSetInfo);
        this.sysSetInfo = _buf.ReadBean(SysSetInfo);
        this.chatSetInfo = _buf.ReadBean(ChatSetInfo);
	},

	action:function(){
		Mgr.plugset.RecvResPlugSetInfoMessage(this);
	},

});
////////////////////
// 发送玩家个人系统设置设定状态 //
////////////////////
var ResMenuStatusMessage = cc.Class.extend( {
	ctor:function(){
		this.sysSetInfo = null; // 玩家系统设置信息
	},

	getId:function(){
		return 113102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.sysSetInfo);
	},
	
	reading:function( _buf ){
        this.sysSetInfo = _buf.ReadBean(SysSetInfo);
	},

	action:function(){
		Mgr.plugset.RecvResMenuStatusMessage(this);
	},

});
////////////////////
// 系统多倍通知(登录和改变的时候通知) //
////////////////////
var ResSystemExpMagnificationMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 0关闭 1开启
        this.time = 0; // 开启状态的剩余时间
	},

	getId:function(){
		return 113103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.state);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.plugset.RecvResSystemExpMagnificationMessage(this);
	},

});
////////////////////
// 改变挂机设置 //
////////////////////
var ReqPlugSetInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.plugsetinfo = null; // 挂机设置
	},

	getId:function(){
		return 113201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.plugsetinfo);
	},
	
	reading:function( _buf ){
        this.plugsetinfo = _buf.ReadBean(PlugSetInfo);
	},

});
////////////////////
// 请求回城 //
////////////////////
var ReqPlugBackToCityMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 113202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 改变系统设置 //
////////////////////
var ReqSetMenuStatusMessage = cc.Class.extend( {
	ctor:function(){
		this.sysSetInfo = null; // 系统设置
	},

	getId:function(){
		return 113203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.sysSetInfo);
	},
	
	reading:function( _buf ){
        this.sysSetInfo = _buf.ReadBean(SysSetInfo);
	},

});
////////////////////
// 改变聊天设置 //
////////////////////
var ReqSetChatSetMessage = cc.Class.extend( {
	ctor:function(){
		this.chatSetInfo = null; // 聊天设置
	},

	getId:function(){
		return 113204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.chatSetInfo);
	},
	
	reading:function( _buf ){
        this.chatSetInfo = _buf.ReadBean(ChatSetInfo);
	},

});
// 接收消息注册
MESSAGE_POOL.Add(113101, ResPlugSetInfoMessage);
MESSAGE_POOL.Add(113102, ResMenuStatusMessage);
MESSAGE_POOL.Add(113103, ResSystemExpMagnificationMessage);

