var PlugsetModMgr = PlugsetModMgr || cc.Class.extend({ 
		
	_plugSetInfo:null,
	_sysSetInfo:null,
	_chatSetInfo:null,
	// 聊天频道显示
	_CHAT_CHANNEL_SYS             :"00000001",
	_CHAT_CHANNEL_WORLD           :"00000010",
	_CHAT_CHANNEL_GUILD           :"00000100",
	_CHAT_CHANNEL_TEAM            :"00001000",
	_CHAT_CHANNEL_PRIVATE         :"00010000",
	// 自动播放 -- wifi
	_CHAT_WIFI_PRIVATE            :"00000001",
	_CHAT_WIFI_WORLD              :"00000010",
	_CHAT_WIFI_GUILD              :"00000100",
	_CHAT_WIFI_TEAM               :"00001000",

	// 自动播放 -- 4g
	_CHAT_4G_PRIVATE              :"00000001",
	_CHAT_4G_WORLD                :"00000010",
	_CHAT_4G_GUILD                :"00000100",
	_CHAT_4G_TEAM                 :"00001000",
	// 自动拾取  (最高位-开关)
	_PICKUP_EQUIP         :"00000001",
	_PICKUP_METARIAL      :"00000010",
	_PICKUP_TUJIAN        :"00000100",
	_PICKUP_STONE         :"00001000",
	_PICKUP_OTHER         :"00010000",
	ctor:function() {	
	},

	RecvResPlugSetInfoMessage:function(msg) {
		this._plugSetInfo = msg.plugsetinfo;
		this._sysSetInfo = msg.sysSetInfo;
		this._chatSetInfo = msg.chatSetInfo;
		this._SetSystemVolume(msg.sysSetInfo);

		// var panel = Mgr.uiMgr.GetPanelByType(SettingPanelExt.PanelName);
		// if ( panel && Mgr.uiMgr.IsPanelShow(panel) )
		// 	panel.OnShow();
	},

	RecvResMenuStatusMessage:function(msg) {
		cc.log("-------------------RecvResMenuStatusMessage----------------")
	},

	RecvResSystemExpMagnificationMessage:function(msg) {
		cc.log("--------------------RecvResSystemExpMagnificationMessage-------------------------")
	},

	SendReqPlugSetInfoMessage:function( info ) {
		cc.log("------  发送挂机设置  ------  " +JSON.stringify(info) )
		var msg=new ReqPlugSetInfoMessage();
		msg.plugsetinfo = info;
		this._plugSetInfo = info;
		Mgr.msgMgr.Send(msg);
	},

	SendReqPlugBackToCityMessage:function(msg) {	
	},

	SendReqSetChatSetMessage:function(info) {
		cc.log("------  发送频道设置  ------  " +JSON.stringify(info) )
		var msg=new ReqSetChatSetMessage();
		msg.chatSetInfo = info;
		this._chatSetInfo = info;
		Mgr.msgMgr.Send(msg);
	},

	SendReqSetMenuStatusMessage:function(info) {
		cc.log("------  发送系统设置  ------  " +JSON.stringify(info) )
		var msg=new ReqSetMenuStatusMessage();
		msg.sysSetInfo = info;
		this._sysSetInfo = info;
		Mgr.msgMgr.Send(msg);
	},

	GetPlugSetInfo:function () {
		if (!this._plugSetInfo)
			this._plugSetInfo = new PlugSetInfo();
		return this._plugSetInfo;
	},
	GetSysSetInfo:function () {
		if (!this._sysSetInfo)
			this._sysSetInfo = new SysSetInfo();
		return this._sysSetInfo;
	},
	GetChatSetInfo:function () {
		if (!this._chatSetInfo)
			this._chatSetInfo = new ChatSetInfo();
		return this._chatSetInfo;
	},
	_SetSystemVolume:function(msg)
	{
		var on_off = (msg.music>>7);
		var volume = msg.music & 0x7f;
		Mgr.gameSoundMgr.StartMusic(on_off > 0);
		Mgr.gameSoundMgr.SetBackgroundVolume(volume);
		on_off = (msg.sound>>7);
		volume = msg.sound & 0x7f;
		Mgr.gameSoundMgr.StartSound(on_off > 0);
		Mgr.gameSoundMgr.SetEffectVolume(volume);
	},
	IsReceiveCurrentChannelChatInfo:function(type)
	{
		var value = this.GetChatSetInfo().channelDisplay;
		var sample = 0;
		switch (type)
		{
			case EnumChatChannelType.SYSTEM:
			{
				sample = parseInt(this._CHAT_CHANNEL_SYS,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.WORLD:
			{
				sample = parseInt(this._CHAT_CHANNEL_WORLD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.FACTION:
			{
				sample = parseInt(this._CHAT_CHANNEL_GUILD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.TEAM:
			{
				sample = parseInt(this._CHAT_CHANNEL_TEAM,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.SOUND:
			{
				sample = parseInt(this._CHAT_CHANNEL_PRIVATE,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			default:return true;
		}
		return false;
	},
	IsAutoPlayYuyingOnWifi:function(type)
	{
		var value = this.GetChatSetInfo().wifiAutoPlay;
		var sample = 0;
		switch (type)
		{
			case EnumChatChannelType.WORLD:
			{
				sample = parseInt(this._CHAT_WIFI_WORLD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.FACTION:
			{
				sample = parseInt(this._CHAT_WIFI_GUILD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.TEAM:
			{
				sample = parseInt(this._CHAT_WIFI_TEAM,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.PRIVATE:
			{
				sample = parseInt(this._CHAT_WIFI_PRIVATE,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			default:return true;
		}
		return false;
	},
	IsAutoPlayYuyingOnFourG:function(type)
	{
		var value = this.GetChatSetInfo().noWifiAutoPlay;
		var sample = 0;
		switch (type)
		{
			case EnumChatChannelType.WORLD:
			{
				sample = parseInt(this._CHAT_4G_WORLD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.FACTION:
			{
				sample = parseInt(this._CHAT_4G_GUILD,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.TEAM:
			{
				sample = parseInt(this._CHAT_4G_TEAM,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumChatChannelType.PRIVATE:
			{
				sample = parseInt(this._CHAT_4G_PRIVATE,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			default:return true;
		}
		return false;
	},
	IsAutoPickByType:function(type)
	{
		var value = this.GetPlugSetInfo().pickup;
		var sample = 0;
		switch (type)
		{
			case EnumItemType.Equip:
			{
				sample = parseInt(this._PICKUP_EQUIP,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumItemType.MATERIAL:
			{
				sample = parseInt(this._PICKUP_METARIAL,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumItemType.Handbook:
			{
				sample = parseInt(this._PICKUP_TUJIAN,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			case EnumItemType.GEM:
			{
				sample = parseInt(this._PICKUP_STONE,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
			default://其他
			{
				sample = parseInt(this._PICKUP_OTHER,2).toString(10);
				if ( (value & sample) > 0 )
				{
					return true;
				}
				break;
			}
		}
		return false;
	},
});













