///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//RedPacketMoneyInfo 红包领取金钱信息
//RedPacketReceiveRecords 红包领取记录
//RedPacketInfo 红包详细信息
//RedPacketBriefInfo 红包简要信息

// 请求消息
//133201,ReqOpenRedPacketPanel 请求红包详细信息
//133202,ReqGetRedPacket 领取红包
//133207,ReqOpenRedPacketRecordPanel 请求红包领取记录信息面板
//133203,ReqSendRedPacket 玩家发送红包
//133204,ReqOpenRechargeRedPacketPanel 玩家打开充值红包面板
//133205,ReqSendRechargeRedPacket 客户端请求发红包
//133206,ReqGetRechargeRedPacket 客户端请求领取充值红包

// 接收消息
//133101,ResRedPacketPanel 红包详细信息面板
//133102,ResRedPacketBrief 通知红包来了
//133103,ResDeleteRedPacketList 删除红包列表
//133104,ResRedPacketGetLog 红包领取记录面板（废弃）
//133105,ResRedPacketMyLog 发送我的领取记录
//133106,ResRechargeNum 告诉客户端今日可发送充值红包金额
//133107,ResRechargeIcon 显示充值红包按钮(目前只有在充值满2000后和登录的时候调用)


var RedPacketMoneyInfo = cc.Class.extend({
	ctor:function(){
		this.playerName = null; // 领取人姓名
        this.playerId = null; // 玩家id
        this.num = 0; // 领取数额
        this.time = 0; // 领取时间
	},

	writing:function( _buf ){
		_buf.WriteString(this.playerName);
        _buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
		this.playerName = _buf.ReadString();
        this.playerId = _buf.ReadLong();
        this.num = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},
});
var RedPacketReceiveRecords = cc.Class.extend({
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.senderName = null; // 发送者姓名
        this.itemModel = 0; // 红包货币类型(对应货币modelid)
        this.receiverNum = 0; // 领取数额
        this.time = 0; // 时间戳(大于7天的不显示查看按钮)
        this.packetType = 0; // 红包类型(0全部,1帮会,2世界boss)
        this.optimum = 0; // 是否是手气最佳 1是 0不是
	},

	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteString(this.senderName);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.receiverNum);
        _buf.WriteVarInt(this.time);
        _buf.WriteByte(this.packetType);
        _buf.WriteByte(this.optimum);
	},
	
	reading:function( _buf ){
		this.uniqueId = _buf.ReadLong();
        this.senderName = _buf.ReadString();
        this.itemModel = _buf.ReadVarInt();
        this.receiverNum = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
        this.packetType = _buf.ReadByte();
        this.optimum = _buf.ReadByte();
	},
});
var RedPacketInfo = cc.Class.extend({
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.packetType = 0; // 红包类型(0全部,1帮会,2世界boss)
        this.itemModel = 0; // 红包货币类型(对应货币modelid)
        this.itemNum = 0; // 货币总数
        this.senderName = null; // 发送者姓名
        this.title = null; // 红包内容描述
        this.senderId = null; // 发送者Id
        this.bestPlayerid = null; // 最佳手气玩家id
        this.senderNum = 0; // 发送红包数量
        this.myNum = 0; // 我领取的数量
        this.reveivers = []; // 领取列表 RedPacketMoneyInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteByte(this.packetType);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.itemNum);
        _buf.WriteString(this.senderName);
        _buf.WriteString(this.title);
        _buf.WriteLong(this.senderId);
        _buf.WriteLong(this.bestPlayerid);
        _buf.WriteVarInt(this.senderNum);
        _buf.WriteVarInt(this.myNum);
        _buf.WriteShort( this.reveivers.length );
        for (var i = 0; i < this.reveivers.length; i++) {
            _buf.WriteBean(this.reveivers[i]);
        }
	},
	
	reading:function( _buf ){
		this.uniqueId = _buf.ReadLong();
        this.packetType = _buf.ReadByte();
        this.itemModel = _buf.ReadVarInt();
        this.itemNum = _buf.ReadVarInt();
        this.senderName = _buf.ReadString();
        this.title = _buf.ReadString();
        this.senderId = _buf.ReadLong();
        this.bestPlayerid = _buf.ReadLong();
        this.senderNum = _buf.ReadVarInt();
        this.myNum = _buf.ReadVarInt();
        var reveivers_length = _buf.ReadShort();
        for (var i = 0; i < reveivers_length; i++) {
            this.reveivers[i] = _buf.ReadBean(RedPacketMoneyInfo);
        }
	},
});
var RedPacketBriefInfo = cc.Class.extend({
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.packetType = 0; // 红包类型(0全部,1帮会,2世界boss)
        this.itemModel = 0; // 红包货币类型(对应货币modelid)
        this.itemNum = 0; // 货币总数
        this.senderName = null; // 发送者姓名
        this.title = null; // 红包内容描述
        this.senderId = null; // 发送者Id
        this.senderNum = 0; // 发送红包数量
	},

	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteByte(this.packetType);
        _buf.WriteVarInt(this.itemModel);
        _buf.WriteVarInt(this.itemNum);
        _buf.WriteString(this.senderName);
        _buf.WriteString(this.title);
        _buf.WriteLong(this.senderId);
        _buf.WriteVarInt(this.senderNum);
	},
	
	reading:function( _buf ){
		this.uniqueId = _buf.ReadLong();
        this.packetType = _buf.ReadByte();
        this.itemModel = _buf.ReadVarInt();
        this.itemNum = _buf.ReadVarInt();
        this.senderName = _buf.ReadString();
        this.title = _buf.ReadString();
        this.senderId = _buf.ReadLong();
        this.senderNum = _buf.ReadVarInt();
	},
});
////////////////////
// 红包详细信息面板 //
////////////////////
var ResRedPacketPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.redPacketInfo = null; // 红包信息
	},

	getId:function(){
		return 133101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.redPacketInfo);
	},
	
	reading:function( _buf ){
        this.redPacketInfo = _buf.ReadBean(RedPacketInfo);
	},

	action:function(){
		Mgr.redpacket.RecvResRedPacketPanelMessage(this);
	},

});
////////////////////
// 通知红包来了 //
////////////////////
var ResRedPacketBriefMessage = cc.Class.extend( {
	ctor:function(){
		this.redPacketBriefInfo = null; // 红包简要信息
	},

	getId:function(){
		return 133102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.redPacketBriefInfo);
	},
	
	reading:function( _buf ){
        this.redPacketBriefInfo = _buf.ReadBean(RedPacketBriefInfo);
	},

	action:function(){
		Mgr.redpacket.RecvResRedPacketBriefMessage(this);
	},

});
////////////////////
// 删除红包列表 //
////////////////////
var ResDeleteRedPacketListMessage = cc.Class.extend( {
	ctor:function(){
		this.rplist = []; // 需要前端删除红包的列表 long
	},

	getId:function(){
		return 133103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.rplist.length );
        for (var i = 0; i < this.rplist.length; i++) {
            _buf.WriteLong(this.rplist[i]);
        }
	},
	
	reading:function( _buf ){
        var rplist_length = _buf.ReadShort();
        for (var i = 0; i < rplist_length; i++) {
            this.rplist[i] = _buf.ReadLong();
        }
	},

	action:function(){
		Mgr.redpacket.RecvResDeleteRedPacketListMessage(this);
	},

});
////////////////////
// 红包领取记录面板（废弃） //
////////////////////
var ResRedPacketGetLogMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
        this.packetType = 0; // 红包类型(0全部 1帮会,2全服绑定)
        this.senderName = null; // 发送者姓名
        this.senderId = null; // 发送者Id
        this.senderNumSum = 0; // 红包总数量
        this.senderMoneySum = 0; // 红包总数额
        this.reveivers = []; // 领取列表 RedPacketMoneyInfo
	},

	getId:function(){
		return 133104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
        _buf.WriteByte(this.packetType);
        _buf.WriteString(this.senderName);
        _buf.WriteLong(this.senderId);
        _buf.WriteVarInt(this.senderNumSum);
        _buf.WriteVarInt(this.senderMoneySum);
        _buf.WriteShort( this.reveivers.length );
        for (var i = 0; i < this.reveivers.length; i++) {
            _buf.WriteBean(this.reveivers[i]);
        }
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
        this.packetType = _buf.ReadByte();
        this.senderName = _buf.ReadString();
        this.senderId = _buf.ReadLong();
        this.senderNumSum = _buf.ReadVarInt();
        this.senderMoneySum = _buf.ReadVarInt();
        var reveivers_length = _buf.ReadShort();
        for (var i = 0; i < reveivers_length; i++) {
            this.reveivers[i] = _buf.ReadBean(RedPacketMoneyInfo);
        }
	},

	action:function(){
		Mgr.redpacket.RecvResRedPacketGetLogMessage(this);
	},

});
////////////////////
// 发送我的领取记录 //
////////////////////
var ResRedPacketMyLogMessage = cc.Class.extend( {
	ctor:function(){
		this.records = []; // 记录列表 RedPacketReceiveRecords
	},

	getId:function(){
		return 133105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
	},
	
	reading:function( _buf ){
        var records_length = _buf.ReadShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(RedPacketReceiveRecords);
        }
	},

	action:function(){
		Mgr.redpacket.RecvResRedPacketMyLogMessage(this);
	},

});
////////////////////
// 告诉客户端今日可发送充值红包金额 //
////////////////////
var ResRechargeNumMessage = cc.Class.extend( {
	ctor:function(){
		this.canSendNum = 0; // 今日可发送充值红包金额
        this.rechargeNum = 0; // 今日充值金额
	},

	getId:function(){
		return 133106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.canSendNum);
        _buf.WriteVarInt(this.rechargeNum);
	},
	
	reading:function( _buf ){
        this.canSendNum = _buf.ReadVarInt();
        this.rechargeNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.redpacket.RecvResRechargeNumMessage(this);
	},

});
////////////////////
// 显示充值红包按钮(目前只有在充值满2000后和登录的时候调用) //
////////////////////
var ResRechargeIconMessage = cc.Class.extend( {
	ctor:function(){
		this.canSendNum = 0; // 今日可发送充值红包金额
	},

	getId:function(){
		return 133107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.canSendNum);
	},
	
	reading:function( _buf ){
        this.canSendNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.redpacket.RecvResRechargeIconMessage(this);
	},

});
////////////////////
// 请求红包详细信息 //
////////////////////
var ReqOpenRedPacketPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
	},

	getId:function(){
		return 133201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
	},

});
////////////////////
// 领取红包 //
////////////////////
var ReqGetRedPacketMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
	},

	getId:function(){
		return 133202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
	},

});
////////////////////
// 请求红包领取记录信息面板 //
////////////////////
var ReqOpenRedPacketRecordPanelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 133207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 玩家发送红包 //
////////////////////
var ReqSendRedPacketMessage = cc.Class.extend( {
	ctor:function(){
		this.packetType = 0; // 红包类型(0全部 1帮会,2全服绑定)
        this.num = 0; // 红包个数
        this.money = 0; // 总金额
	},

	getId:function(){
		return 133203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.packetType);
        _buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.money);
	},
	
	reading:function( _buf ){
        this.packetType = _buf.ReadByte();
        this.num = _buf.ReadVarInt();
        this.money = _buf.ReadVarInt();
	},

});
////////////////////
// 玩家打开充值红包面板 //
////////////////////
var ReqOpenRechargeRedPacketPanelMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
	},

	getId:function(){
		return 133204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
	},

});
////////////////////
// 客户端请求发红包 //
////////////////////
var ReqSendRechargeRedPacketMessage = cc.Class.extend( {
	ctor:function(){
		this.sendbindGold = 0; // 总金额
	},

	getId:function(){
		return 133205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.sendbindGold);
	},
	
	reading:function( _buf ){
        this.sendbindGold = _buf.ReadVarInt();
	},

});
////////////////////
// 客户端请求领取充值红包 //
////////////////////
var ReqGetRechargeRedPacketMessage = cc.Class.extend( {
	ctor:function(){
		this.uniqueId = null; // 唯一Id
	},

	getId:function(){
		return 133206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.uniqueId);
	},
	
	reading:function( _buf ){
        this.uniqueId = _buf.ReadLong();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(133101, ResRedPacketPanelMessage);
MESSAGE_POOL.Add(133102, ResRedPacketBriefMessage);
MESSAGE_POOL.Add(133103, ResDeleteRedPacketListMessage);
MESSAGE_POOL.Add(133104, ResRedPacketGetLogMessage);
MESSAGE_POOL.Add(133105, ResRedPacketMyLogMessage);
MESSAGE_POOL.Add(133106, ResRechargeNumMessage);
MESSAGE_POOL.Add(133107, ResRechargeIconMessage);

