/**
 * 资源线管理
 */
var SubReslineMgr = SubReslineMgr || cc.Class.extend({
        nowBlessnum: 0,
        clearDate: null,
        _reslinetype: -1,
        curShowLayer: 0,
        _stars: 0,
        _curReslineDataInfo: null,
        _skillInfoVec: null,
        _equips: null,
        _reslineTypeShow: [],
        _defaultModelId: 0,
        _equipModel: 0,
        _lastEquipModel: 0,
        _reslineMainPanel: null,
        //暂时只是资源线每阶星数计算用
        _reslineDataHash: null,
        _skillHash: null,
        _maxLayer: 0,
        _attribute: null,
        _lastAttrHash: null,
        _lastFighting: 0,

        _opened : false,

        //一些资源路径
        _LayerUrl: "other/juese/word/jieshu/",
        ctor: function () {
            this._serverOpened = false;
        },

        IsOpenedOnServer:function(){
            return this._serverOpened;
        },
        OnOpenedOnServer:function(){
            var pushEvent = !this._serverOpened;

            this._serverOpened = true;
            if(pushEvent) BtnGroupUtil.MainPlayerLevelUpHandler();
        },

        SetReslineType: function (value) {
            this._reslinetype = value;

            this.InitReslineDataList();
            this.InitSkillHash();
        },
        SetPanel: function (pan) {
            this._reslineMainPanel = pan;
        },
        GetReslineMainPanel: function () {
            return this._reslineMainPanel;
        },
        GetCurReslineDataInfo: function () {
            return this._curReslineDataInfo;
        },
        GetEquipModelId: function () {
            return this._equipModel;
        },
        GetLastEquipModelId: function () {
            return this._lastEquipModel;
        },
        GetMaxstarByLayer: function (mid) {
            return this._reslineDataHash.Get(mid);
        },
        GetSkillidByLayer: function (layer) {
            return this._skillHash.Get(layer);
        },
        /**
         * 获取数据库中配置的资源线最大阶层
         */
        GetMaxLayer: function () {
            if (this._maxLayer == 0) {
                var arr = ReslineUtil.GetReslineContainer(this._reslinetype);
                this._maxLayer = arr.length;
                return this._maxLayer;
            }
            return this._maxLayer;
        },
        GetModeIdByLayer: function (layerNum) {
            switch (this._reslinetype) {
                case EnumResline.GIANT:
                    break;
            }
            return layerNum;
        },
        GetLayerByModeId: function (mid) {
            return mid;
        },
        GetMaxModelId: function () {
            return this._maxModelId;
        },
        /**
         * 当前最高星数
         **/
        GetCurShowStars: function () {
            if (this.curShowLayer == this._maxModelId)
                return this.GetStars();
            else
                return this.GetMaxstarByLayer(this.curShowLayer);
        },
        /**
         * 获取资源线技能当前等级
         * @param skillID
         * @return
         *
         */
        GetSysSkillLev: function (skillID) {
            if (this._skillInfoVec == null)
                return 0;
            for (var i = 0; i < this._skillInfoVec.length; i++) {
                var skillInfo = this._skillInfoVec[i];//SkillInfo
                if (skillInfo.skillModelId == skillID)
                    return skillInfo.skillLevel;
            }
            return 0;
        },
        GetSkillArray: function () {
            var reslineList = ReslineUtil.GetReslineContainer(this._reslinetype);
            reslineList.sort(this.sortQDataId);
            var skillArr = [];
            for (var i = 0; i < reslineList.length; i++) {
                var q_resline = reslineList[i];
                if (q_resline.q_skill > 0) {
                    var layer = q_resline.q_id.split("_")[1];
                    skillArr.push([layer, q_resline.q_skill]);
                }
            }
            return skillArr;
        },
        /**
         * 当前最高资源线等级
         **/
        GetLayer: function () {
            if (this._maxModelId != 0)
                return this._maxModelId;
            else
                return this._defaultModelId;
        },
        /**
         * 当前最高资源线星数
         **/
        GetStars: function () {
            if (this._curReslineDataInfo == null)
                return 0;

            return this._stars;
        },
        GetDanNumArr: function () {
            var numArr = [0, 0];
            if(this._curReslineDataInfo == null) return numArr;
            for (var i = 0; i < this._curReslineDataInfo.attList.length; i++) {
                numArr[i] = this._curReslineDataInfo.attList[i];
            }
            return numArr;
        },
        GetDanDataArr: function (layer, starsparams) {
            var list = [[0, 0], [0, 0]];
            var reslineModelId = -1;
            var stars = "";

            if (reslineModelId == -1) {
                reslineModelId = layer ? layer : this.GetMaxModelId();
                stars = "_" + ( starsparams ? starsparams : this.GetStars() );
            }

            var q_base = Q_resline_up.Get(this._reslinetype.toString() + "_" + reslineModelId.toString() + stars);
            if (q_base && q_base.q_intensify_item) {
                var array = JSON.parse(q_base.q_intensify_item);
                for (var i = 0; i != array.length; i++) {
                    list[i] = array[i];
                }
            }
            return list;
        },
        /**
         * 获取资源线加成属性
         * @param reinlv 转生次数
         * @param layer 资源线等级
         * @param stars 资源线星数
         * @param danIdArr 资源线属性丹数据(上一个方法)
         * @param danNumArr 资源线属性丹使用数据
         * @param equiplist 资源线装备
         * @param horsePsychicInfos 资源线通灵数据
         * @return
         */
        GetAtt: function (reinlv, layer, stars, danIdArr, danNumArr, equiplist, horsePsychicInfos) {
            var additionData = this._GetAdditionData(this._reslinetype, layer, stars, reinlv);
            if (additionData == null)
                return [0, 0, 0, 0, 0, 0, 0, 0, 0];
            var key = "";
            if (reinlv > 0)
                key = reinlv.toString() + "_" + this._reslinetype.toString() + "_" + layer.toString() + "_" + stars.toString();
            else
                key = this._reslinetype.toString() + "_" + layer.toString() + "_" + stars.toString();
            var attHash = new HashMap();
            var attributeHashorg = this._GetAttribute(key);
            var self = this;
            attributeHashorg.EachKey(function (key) {
                var value = getParam(attributeHashorg.Get(key), 0);
                value += (self.GetReslineEquipAtt(equiplist, key) + self.GetDanAttribute(reinlv, layer, stars, danIdArr, danNumArr, key) );
                attHash.Put(key, Math.floor(value))
            })

            return attHash;
        },

        /**
         * 获取资源线的加成属性
         * @param id-资源线ID
         *
         */
        GetAttribute: function (reinlv, layer, stars, danIdArr, danNumArr, equiplist, horsePsychicInfos) {
            var resultArr = [];
            var attHash = this.GetAtt(reinlv, layer, stars, danIdArr, danNumArr, equiplist, horsePsychicInfos);
            if (attHash != null) {
                attHash.EachKey(function (key) {
                    var attinfo = new AttributeInfo();
                    attinfo.type = key;
                    attinfo.value = attHash.Get(key);
                    resultArr.push(attinfo);
                })
            }
            return resultArr;
        },
        /**
         * 获取资源线潜能丹的加成属性
         * @param id-资源线ID
         */
        GetQnDanAttribute: function (reinlv, reslineShowLayer, stars, danId, useNum, type) {
            var attr = 0;
            // *****************************  潜能丹  *********************************
            var itemSimpac = Q_item_simpact.Get(danId);
            if (itemSimpac && itemSimpac.q_attribute) {
                var jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(itemSimpac.q_attribute));
                for (var keyStr in jsonData) {
                    var _type = parseInt(keyStr);
                    var _value = parseInt(jsonData[keyStr]);

                    if (type == _type) {
                        attr += Mgr.attributeMgr.GetAttribute(type, _value, reinlv) * useNum
                        break;
                    }
                }
            }
            return attr;
        },

        /**
         * 获取资源线幻化丹的加成属性
         * @param id-资源线ID
         */
        GetHhDanAttribute: function (reinlv, reslineShowLayer, stars, danId, useNum, type) {
            var attr = 0;
            var additionData;
            if (reinlv > 0)
                additionData = Q_reincarnation_res_addition.Get(reinlv.toString() + "_" + this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString());
            else
                additionData = Q_resline_addition.Get(this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString());

            if (additionData && additionData.q_attribute) {
                var jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(additionData.q_attribute));
                for (var keyStr in jsonData) {
                    var _type = parseInt(keyStr);
                    var _value = parseInt(jsonData[keyStr]);

                    if (type == _type) {
                        attr += _value * useNum / 100;
                        break;
                    }
                }
            }
            return attr;
        },

        /**
         * 获取资源线属性丹的加成属性
         * @param id-资源线ID
         */
        GetDanAttribute: function (reinlv, id, stars, danIdArr, danNumArr, type) {
            if (!danNumArr || (danNumArr[0] == 0 && danNumArr[1] == 0) || (danIdArr[0][0] == 0 && danIdArr[1][0] == 0))
                return 0;

            var potentialDanId = danIdArr[0][0];
            var potentialDanUseNum = danNumArr[0];
            var fluctuateDanId = danIdArr[1][0];
            var fluctuateDanUseNum = danNumArr[1];

            reinlv = 0;
            var attr = 0;

            // *****************************  潜能丹  *********************************
            var itemSimpac = Q_item_simpact.Get(potentialDanId);
            if (itemSimpac && itemSimpac.q_attribute) {
                var jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(itemSimpac.q_attribute));
                for (var keyStr in jsonData) {
                    var _type = parseInt(keyStr);
                    var _value = parseInt(jsonData[keyStr]);

                    if (type == _type) {
                        attr += Mgr.attributeMgr.GetAttribute(type, _value, reinlv) * potentialDanUseNum
                        break;
                    }
                }
            }

            // //  资源线阶数加成
            // var additionData;
            // if ( reinlv > 0 )
            //         additionData = Q_reincarnation_res_addition.Get( reinlv.toString() + "_" + this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString());
            // else
            //         additionData = Q_resline_addition.Get( this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString() );
            //
            // if (additionData && additionData.q_attribute) {
            //         jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(additionData.q_attribute));
            //         for (var keyStr in jsonData) {
            //                 var _type = parseInt(keyStr);
            //                 var _value = parseInt(jsonData[keyStr]);
            //
            //                 if (type == _type) {
            //                         attr += _value * potentialDanUseNum;
            //                         break;
            //                 }
            //         }
            // }


            // *****************************  幻化丹  *********************************
            var itemSimpac = Q_item_simpact.Get(fluctuateDanId);
            if (itemSimpac && itemSimpac.q_attribute) {
                var jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(itemSimpac.q_attribute));
                for (var keyStr in jsonData) {
                    var _type = parseInt(keyStr);
                    var _value = parseInt(jsonData[keyStr]);

                    if (type == _type) {
                        attr += Mgr.attributeMgr.GetAttribute(type, _value, reinlv) * fluctuateDanUseNum
                        break;
                    }
                }
            }

            //
            var additionData;
            if (reinlv > 0)
                additionData = Q_reincarnation_res_addition.Get(reinlv.toString() + "_" + this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString());
            else
                additionData = Q_resline_addition.Get(this._reslinetype.toString() + "_" + id.toString() + "_" + stars.toString());

            if (additionData && additionData.q_attribute) {
                jsonData = JSON.parse(ParseUtil.FormatFastJsonStr(additionData.q_attribute));
                for (var keyStr in jsonData) {
                    var _type = parseInt(keyStr);
                    var _value = parseInt(jsonData[keyStr]);

                    if (type == _type) {
                        attr += _value * fluctuateDanUseNum / 100;
                        break;
                    }
                }
            }

            return attr;
        },
        /**
         * 获取资源线装备某个类型的属性
         * @param type
         * @return
         */
        GetReslineEquipAtt: function (equipInfo, type) {
            var allAddAtt = 0;
            if (equipInfo == null)
                return 0;
            for (var i = 0; i < equipInfo.length; i++) {
                if (equipInfo[i].itemModelId > 0) {
                    // 基础属性
                    var baseAtt = Mgr.equip.GetAttribute(type, equipInfo[i].itemModelId);

                    var equ = ItemUtil.ItemInfoToItem(equipInfo[i]);
                    // 附加属性
                    var addAtt = Mgr.equip.GetAddAttribute(type, equ);
                    // 强化
                    var strenAtt = Mgr.attributeMgr.GetStrengAddValue(equipInfo[i].itemModelId, type, equipInfo[i].strenthenLv)
                    //baseAtt=int(baseAtt*(1+Mgr.refiningMgr.getAdvLevelPercent(equ.advancedLv)*0.01));强化处理这两块不忙处理
                    //strenAtt=int(strenAtt*(1+Mgr.refiningMgr.getAdvLevelPercent(equ.advancedLv)*0.01));
                    allAddAtt += baseAtt;
                    allAddAtt += strenAtt;
                    allAddAtt += addAtt;
                }
            }
            return allAddAtt;
        },
        sortQDataId: function (p1, p2) {
            if (p1.q_id < p2.q_id)
                return -1;
            else if (p2.q_id < p1.q_id)
                return 1;

            return 0;
        },
        RecReslineAddToClient: function () {
            this.OnOpenedOnServer();
            switch (this._reslinetype) {
                case EnumResline.HORSE:
                    break;
            }
        },
        /**
         * 发送当前ID给地图周围的玩家(改变外观)
         * ResReslineIllusionToClientMessage
         * */
        recReslineIllusionToClient: function (msg) {
            var reslineModeId = msg.reslineModelid;

            this._lastEquipModel = Math.abs(reslineModeId);
            // 判断是否负数
            if (reslineModeId < 0) {
                msg.reslineModelid = 0;
            }

            var gid = msg.playerId.toGID();
            var player = Mgr.sceneObj.FindObject(gid);//ScenePlayer

            if (player != null) {
                player.UpdateReslineModelid(msg.reslineType, msg.reslineModelid);

                if (msg.reslineType != EnumResline.HORSE) {
                    var resfreshBody = player.RefreshResline(msg.reslineType);
                    if (resfreshBody)
                        player.RefreshShowBody();
                }
                else {
                    player.OnRideJump(msg.reslineModelid);
                }
                var isFind = false;
                if (gid == Mgr.mainPlayer.nGid) {
                    this._equipModel = msg.reslineModelid;

                    var reslineInfo = Mgr.player.mainPlayer.playerResLineInfo;
                    for(var i = 0, len = reslineInfo.length; i < len; i++){
                        var resline = reslineInfo[i];
                        if(resline.type == msg.reslineType){
                            resline.modelid = msg.reslineModelid;
                            isFind = true;
                            break;
                        }
                    }
                    if(!isFind){
                        reslineInfo.push({type:msg.reslineType, modelid:msg.reslineModelid});
                    }
                    //刷面板
                    var pan = this.GetReslineMainPanel();
                    if (pan != null)
                        pan.UpdateBtnState();

                    if(this._reslinetype == EnumResline.SHUTONG){
                        var p = ShutongEquipPanelExt.getInstance();
                        if(p) p.UpdateBtnState();
                    }
                }
            }
            // msg.devourList
        },
        GetLastAtt: function () {
            return this._lastAttrHash;
        },
        GetLastFighting: function () {
            return this._lastFighting;
        },
        /**收到整个资源线信息*/
        RecAllInfoToClient: function (msg) {
            this.OnOpenedOnServer();

            // 保存上一次属性值
            if (this.GetLayer() && this.GetLayer() != msg.reslineModelId) {
                var layer = this.GetLayer();
                var stars = this.GetCurShowStars();
                this._lastAttrHash = this.GetAtt(0, layer, stars, this.GetDanDataArr(layer, stars), this.GetDanNumArr());
                var attInfos = this.GetAttribute(0, layer, stars, this.GetDanDataArr(layer, stars), this.GetDanNumArr());
                this._lastFighting = Mgr.fight.GetAttrsPowerList(attInfos);
            }

            this._curReslineDataInfo = msg;
            this.clearDate = msg.advanceTime * 1000 + 24 * 3600 * 1000;
            this._skillInfoVec = msg.euipSkillInfo;
            this._equips = msg.equips;
            this._defaultModelId = msg.rideReslineModelId;
            this._stars = msg.reslineStar;
            this._maxModelId = this.GetModeIdByLayer(msg.reslineModelId);
            this.curShowLayer = this._maxModelId;
            this._equipModel = this._curReslineDataInfo.rideReslineModelId;
            //这里调用需要更新的地方update
            this.nowBlessnum = msg.exp;
            this.advanceNum = msg.advanceNum;
            if (Mgr.resline.IsShowPanel(this._reslinetype)) {
                this._reslineMainPanel.showInfo(true);
            }

            var q_base = Q_resline_up.Get(this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars());
            var isFull = ( q_base && q_base.q_ismax == 1 );
            // 以下待处理
            // var index = (msg.reslineType-EnumResline.GIANT);
            // Mgr.taskPanelMgr.updateTaskTrackOperation(EnumOperationType.TYPE_GIANT_STAGEUP + index*2, _curReslineDataInfo.reslineModelId > 0 && !isFull );
            // Mgr.taskPanelMgr.updateTaskTrackOperation(EnumOperationType.TYPE_GIANT_BLESSVALUE + index*2, _nowBlessnum > 0);
            // if(msg.reslineType == EnumResline.GIANT || msg.reslineType == EnumResline.JULING)
            // {
            //         updateModel(msg.reslineType,_defaultModelId);
            // }

        },
        /**收到已经穿戴的技能信息*/
        RecReslineEquipSkillInfoToClient: function (euipSkillInfo) {
            if (euipSkillInfo == null)
                return;

            if (this._skillInfoVec) {
                //这里是比如面板打开时使用技能书打开面板的表现
                var noskill = true;
                for (var i = 0; i < this._skillInfoVec.length; i++) {
                    if (this._skillInfoVec[i].skillModelId == euipSkillInfo[i].skillModelId && euipSkillInfo[i].skillLevel > this._skillInfoVec[i].skillLevel) {
                        // Mgr.rgMgr.showOrHideResline(this._reslinetype, true);
                        // this._reslineMainPanel.showUpSkillEff(this._skillInfoVec[i].skillModelId);
                        noskill = false;
                        break;
                    }
                }
                if (noskill) {
                    // Mgr.rgMgr.showOrHideResline(this._reslinetype, true);
                    // this._reslineMainPanel.showUpSkillEff(this._skillInfoVec[i].skillModelId);
                }
            }
            this._skillInfoVec = euipSkillInfo;

            // if( Mgr.resline.IsShowPanel(this._reslinetype) )//if ( this._reslineMainPanel )
            //         this._reslineMainPanel.onSkillUpdata();
        },
        SendReqReslineAddToGameMessage: function () {
            var msg = new ReqReslineAddToGameMessage();
            msg.reslineType = this._reslinetype;
            Mgr.msgMgr.Send(msg);
        },
        SendReqSendReslineInfoToGameMessage: function (modelId) {
            var msg = new ReqSendReslineInfoToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.reslineModelid = modelId;
            Mgr.msgMgr.Send(msg);
        },
        SendReqReslineStratumUpToGameMessage: function (costType, isAuto) {
            costType = arguments[0] ? arguments[0] : 0;
            isAuto = arguments[1] ? arguments[1] : 0;
            var msg = new ReqReslineStratumUpToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.costType = costType;
            msg.autoUp = isAuto;
            Mgr.msgMgr.Send(msg);
        },
        SendReqReslineIllusionToGameMessage: function (modelid) {
            var msg = new ReqReslineIllusionToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.reslineModelid = modelid;
            Mgr.msgMgr.Send(msg);
        },
        SendReqReslinekDevourToGameMessage: function (resoursetype) {
            var msg = new ReqReslinekDevourToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.resourseType = resoursetype;
            Mgr.msgMgr.Send(msg);
        },
        SendReqReslineSkillUpByModelidToGameMessage: function (skillid, type) {
            var msg = new ReqReslineSkillUpByModelidToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.skillModelId = skillid;
            msg.type = type;
            Mgr.msgMgr.Send(msg);
        },
        SendReqReslineExtendToGameMessage: function (optype, parameters) {
            var msg = new ReqReslineExtendToGameMessage();
            msg.reslineType = this._reslinetype;
            msg.opType = optype;
            msg.parameters = parameters;
            Mgr.msgMgr.Send(msg);
        },
        //以下方法不要外部调用
        InitReslineDataList: function () {
            this._reslineDataHash = new HashMap();
            var list = ReslineUtil.GetReslineUpVector(this._reslinetype);
            if (list == null) {
                cc.log("未处理的资源线GetReslineUpVector(this._reslinetype):" + this._reslinetype);
                return;
            }
            for (var i = 0; i < list.length; i++) {
                var tempArr = list[i].q_modelID.split("_");
                var layer = tempArr[1];
                var stars = tempArr.length > 1 ? tempArr[2] : 0;
                if (this._reslineDataHash.Get(layer) == null || this._reslineDataHash.Get(layer) < stars)
                    this._reslineDataHash.Put(layer, stars);
            }
        },
        InitSkillHash: function () {
            this._skillHash = new HashMap();
            var list = ReslineUtil.GetReslineUpVector(this._reslinetype);
            if (list == null) {
                cc.log("未处理的资源线InitSkillHash(this._reslinetype):" + this._reslinetype);
                return;
            }
            for (var i = 0; i < list.length; i++) {
                var tempArr = list[i].q_modelID.split("_");
                var removeArr = [];
                if (list[i].q_remove)
                    removeArr = JSON.parse(list[i].q_remove);
                for (var j = 0; j < removeArr.length; j++) {
                    var actArr = this._skillHash.Get(removeArr[j]);
                    var needLayer = tempArr[1];
                    var needStars = tempArr[2];
                    if (actArr == null || ( needLayer <= actArr[0] && needStars <= actArr[1] ))
                        this._skillHash.Put(removeArr[j], [needLayer, needStars]);
                }
            }
        },

        _GetAdditionData: function (reslinetype, layer, stars, reinlv) {
            reinlv = arguments.length > 3 ? parseInt(reinlv) : 0;

            var additionData;
            if (reinlv > 0)
                additionData = Q_reincarnation_res_addition.Get(reinlv.toString() + "_" + reslinetype.toString() + "_" + layer.toString() + "_" + stars.toString());
            else
                additionData = Q_resline_addition.Get(reslinetype.toString() + "_" + layer.toString() + "_" + stars.toString());

            if (additionData == null && layer != 0) {
                if (reinlv > 0)
                    additionData = Q_reincarnation_res_addition.Get(reinlv.toString() + "_" + reslinetype.toString() + "_" + (layer + 1).toString() + ReslineUtil.DEFAULTSUFFIX);
                else
                    additionData = Q_resline_addition.Get(reslinetype.toString() + "_" + (layer + 1).toString() + ReslineUtil.DEFAULTSUFFIX);
            }
            return additionData;
        },

        _GetAttribute: function (key, reinlv) {
            if (this._attribute == null)
                this._attribute = new HashMap();

            var ret = this._attribute.Get(key);//HashMap
            if (ret == null) {
                ret = new HashMap();
                var additionData;
                var jsonData;
                if (reinlv > 0)
                    additionData = Q_reincarnation_res_addition.Get(key);
                else
                    additionData = Q_resline_addition.Get(key);
                try {
                    var str = ParseUtil.FormatFastJsonStr(additionData.q_attribute);
                    jsonData = JSON.parse(str);
                    for (var keyStr in jsonData) {
                        ret.Put(parseInt(keyStr), parseInt(jsonData[keyStr]));
                    }
                    var check = this._attribute;
                    this._attribute.Put(key, ret)
                }
                catch (e) {
                    throw new Error("subreslinemgr parse json [" + key + "] failed : " + e);
                    return;
                }
            }
            return ret;
        },

        GetLayerUrl: function (layer) {
            return this._LayerUrl + layer + ".png";
        },
        GetEquip: function () {
            return this._equips;
        },

        IsOpenFunc: function () {
            //打开进阶
            var _type = 0
            var _sub = 0;
            if (this._reslinetype == EnumResline.HORSE) {
                _type = BtnGroupUtil.M_ROLE;
                _sub = BtnGroupUtil.ROLE_RIDE;
            }
            else if (this._reslinetype == EnumResline.GUANGWU) {
                _type = BtnGroupUtil.M_ROLE;
                _sub = BtnGroupUtil.ROLE_GUANGWU;
            }
            else if (this._reslinetype == EnumResline.DRAGON) {
                _type = BtnGroupUtil.M_ROLE;
                _sub = BtnGroupUtil.ROLE_DRAGON;
            }
            else if (this._reslinetype == EnumResline.SHUTONG) {
                _type = BtnGroupUtil.M_SHUTONG;
                _sub = BtnGroupUtil.SHUTONG_SHUTONG;
            }
            else if (this._reslinetype == EnumResline.BAOQI) {
                _type = BtnGroupUtil.M_SHUTONG;
                _sub = BtnGroupUtil.SHUTONG_RIDE;
            }
            else if (this._reslinetype == EnumResline.WUXUE) {
                _type = BtnGroupUtil.M_ROLE;
                _sub = BtnGroupUtil.ROLE_WUXUE;
            }
            else if (this._reslinetype == EnumResline.STEP) {
                _type = BtnGroupUtil.M_SHUTONG;
                _sub = BtnGroupUtil.SHUTONG_JIAOYING;
            }
            else if (this._reslinetype == EnumResline.ZHAOSHI) {
                _type = BtnGroupUtil.M_SHUTONG;
                _sub = BtnGroupUtil.SHUTONG_JIANZHAO;
            }
            else if (this._reslinetype == EnumResline.JIANLING) {
                _type = BtnGroupUtil.M_SHUTONG;
                _sub = BtnGroupUtil.SHUTONG_JIANLING;
            }
            if (BtnGroupUtil.IsFunctionOpen(_type, _sub))
                return true;
            return false;
        },

        GetResLineName: function () {
            var reslinename = "未知资源线名称";
            if (this._reslinetype == EnumResline.HORSE)
                reslinename = "坐骑";
            else if (this._reslinetype == EnumResline.DRAGON)
                reslinename = "法器";
            else if (this._reslinetype == EnumResline.GUANGWU)
                reslinename = "光武";
            else if (this._reslinetype == EnumResline.SHUTONG)
                reslinename = "书童";
            else if (this._reslinetype == EnumResline.BAOQI)
                reslinename = "宝骑";
            else if (this._reslinetype == EnumResline.WUXUE)
                reslinename = "武学";
            else if (this._reslinetype == EnumResline.SCABBARD)
                reslinename = "剑鞘";
            else if (this._reslinetype == EnumResline.STEP)
                reslinename = "脚印";
            else if (this._reslinetype == EnumResline.ZHAOSHI)
                reslinename = "招式";
            else if (this._reslinetype == EnumResline.JIANLING)
                reslinename = "剑灵";

            return reslinename;
        },

        GetResLineEquipName:function(){
            var equipName = ["null", "null"];
            if (this._reslinetype == EnumResline.HORSE)
                equipName = ["坐鞍", "挂件", "缰绳", "脚蹬"];
            else if (this._reslinetype == EnumResline.DRAGON)
                equipName = ["肩羽", "飞羽", "覆角", "覆羽"];
            else if (this._reslinetype == EnumResline.GUANGWU)
                equipName = ["护鞘", "利刃", "护柄", "玉璇"];
            else if (this._reslinetype == EnumResline.SHUTONG)
                equipName = ["头饰", "衣服", "鞋子", "护手"];
            else if (this._reslinetype == EnumResline.BAOQI)
                equipName = ["首凯", "蹬具", "蹄铁", "鞍甲"];
            else if (this._reslinetype == EnumResline.WUXUE)
                equipName = ["内功", "外功", "心法", "技击"];
            else if (this._reslinetype == EnumResline.SCABBARD)
                equipName = ["鞘口", "护环", "名牌", "剑镖"];
            else if (this._reslinetype == EnumResline.STEP)
                equipName = ["勇气", "力量", "愤怒", "无畏"];
            else if (this._reslinetype == EnumResline.ZHAOSHI)
                equipName = ["贯通", "青炉", "化神", "奥义"];
            else if (this._reslinetype == EnumResline.JIANLING)
                equipName = ["魂心", "魂精", "魂气", "魂魄"];

            return equipName;
        },

        /***
         * 进阶材料是否足够
         * @returns {boolean}
         * @constructor
         */
        IsShortMaterial: function (isCheckGold) {
            isCheckGold = isCheckGold || true;
            var psychicData = Q_resline_up.Get(this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars());
            if (!psychicData) {
                // zz.Error("读取配置表（Q_resline_up）出错， key：" + this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars())
            }
            else {
                var firstItemArr = JSON.parse(psychicData.q_replace_item);
                var needItemNum = psychicData.q_up_item_num;
                var needItemID = psychicData.q_up_item_id;
                var array = JSON.parse(psychicData.q_shop_data);
                var needBuyIds = {gold_id: parseInt(array[1]), bindGold_id: parseInt(array[0])};
                for (var i = 0; i < firstItemArr.length; i++) {
                    var itemNum = Mgr.backpack.GetItemNumber(firstItemArr[i], true);
                    if (itemNum >= needItemNum)
                        return false;
                }

                // 替代材料不足,判断正规材料
                var itemNum = Mgr.backpack.GetItemNumber(needItemID, true);
                if (itemNum < needItemNum) {
                    var isAutoBuyItem = false;
                    if (this._reslineMainPanel != null) {
                        isAutoBuyItem = this._reslineMainPanel._isAutoBuyItem;
                    }
                    if (isAutoBuyItem && !isCheckGold) {
                        var myGold = Mgr.mainPlayer.attributeData.Allgold();
                        var myBindGold = Mgr.mainPlayer.attributeData.AllBindGold();

                        var dexNum = needItemNum - itemNum;

                        var bind_shopvos = Mgr.shop.GetShopItemVoDatas(needBuyIds.bindGold_id, EnumShopType.BINDGOLD_SHOP);
                        if (bind_shopvos.length > 0) {
                            var needMoney = bind_shopvos[0].price * dexNum
                            if (needMoney <= myBindGold)
                                return false;
                        }

                        // 绑定元宝不足
                        var shopvos = Mgr.shop.GetShopItemVoDatas(needBuyIds.gold_id, EnumShopType.GOLD_SHOP);
                        if (shopvos.length > 0) {
                            var needMoney = shopvos[0].price * dexNum
                            if (needMoney <= myGold)
                                return false;
                        }
                    }
                }
                else{//这里是处理资源线会清空情况下不显示红点（与剩余数量无关）
                    var mgr = Mgr.resline.GetMgrByType(this._reslinetype);
                    var showkey = this._reslinetype + "_" + mgr.GetMaxModelId();
                    var beltBasicData = Q_resline.Get( showkey );
                    showkey = beltBasicData.q_id.toString() + "_" + mgr.GetStars().toString();
                    var beltUp = Q_resline_up.Get( showkey );
                    if(beltUp.q_reset_time > 0 && mgr.nowBlessnum == 0){
                        return true
                    }
                    return false;
                }
            }
            return true;
        },

        IsResSkillEnableUp:function () {
            var mgr = Mgr.resline.GetMgrByType(this._reslinetype);
            var skills = mgr.GetSkillArray();
            for(var i = 0, len = skills.length; i < len; i++){
                var skillId = skills[i][1];
                var lv = mgr.GetSysSkillLev( skillId );
                if ( lv > 0 ) {
                    var curGradeId = skillId + "_" + lv;
                    var needInfo = Q_resline_skills.Get(curGradeId);
                    if(Mgr.backpack.GetItemNumber(needInfo.q_item) >= needInfo.q_item_num && lv < 10){
                        return true;
                    }
                }
            }
            return false;
        },

        IsDanUsable:function(){
            var danArr = this.GetDanDataArr();
            var numArr = this.GetDanNumArr();
            var mid = danArr[0][0];
            var mid1 = danArr[1][0];
            var ownNum =  Mgr.backpack.GetItemNumber( mid, true );
            var ownNum1 =  Mgr.backpack.GetItemNumber( mid1, true );

            return (ownNum > 0 && numArr[0] < danArr[0][1])
                || (ownNum1 > 0 && numArr[1] < danArr[1][1]);
        },

		IsEnableUpgrade:function(isCheckGold){
			var psychicData = Q_resline_up.Get(this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars());
			if (!psychicData) {
				// zz.Error("读取配置表（Q_resline_up）出错， key：" + this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars())
			}
			else {
				var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
				var ifRoleLv = psychicData.q_up_figure_level <= pLevel;  //角色等级是否足够
				var ifMax = psychicData.q_ismax == 1; // 是否满级
				var ifMaterial = !this.IsShortMaterial(isCheckGold);  // 材料是否足够

				if (ifRoleLv && !ifMax && ifMaterial)
					return true;
			}
			return false;
		},

        // 是否能够进阶
        IsEnableUp: function (isCheckGold) {
            var psychicData = Q_resline_up.Get(this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars());
            if (!psychicData) {
                // zz.Error("读取配置表（Q_resline_up）出错， key：" + this._reslinetype + "_" + this.GetLayer() + "_" + this.GetStars())
            }
            else {
                var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
                var ifRoleLv = psychicData.q_up_figure_level <= pLevel;  //角色等级是否足够
                var ifMax = psychicData.q_ismax == 1; // 是否满级
                var ifMaterial = !this.IsShortMaterial(isCheckGold);  // 材料是否足够
                var isSkillUp = this.IsResSkillEnableUp();
                var isDanUsable = this.IsDanUsable();

                if ((ifRoleLv && !ifMax && ifMaterial) || isSkillUp || isDanUsable)
                    return true;
            }
            return false;
        },
    })