///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ServerConfigInfo 游戏服务器信息
//FightServerInfo 跨服战斗服务器信息

// 请求消息
//203101,ReqRegisterGameForPublic 普通服注册到公共服务器
//203102,ReqRegisterGameForFight 普通服注册到跨服战斗服务器
//203103,ReqRegisterFightForPublic 战斗服注册到公共服务器
//203201,ResRegisterGameForPublic 普通服注册到公共服务器返回消息
//203202,ResRegisterGameForFight 普通服注册到跨服战斗服务器返回消息
//203203,ResConnectGameToFight 返回游戏服所有跨服战斗服务器

// 接收消息


var ServerConfigInfo = cc.Class.extend({
	ctor:function(){
		this.serverKey = 0; // serverKey
        this.type = 0; // 服务器类型(1game 2public 3fight)
        this.version = 0; // 版本号
        this.servers = []; // 包含服务器列表 string
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.serverKey);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.version);
        _buf.WriteShort( this.servers.length );
        for (var i = 0; i < this.servers.length; i++) {
            _buf.WriteString(this.servers[i]);
        }
	},
	
	reading:function( _buf ){
		this.serverKey = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
        this.version = _buf.ReadVarInt();
        var servers_length = _buf.ReadShort();
        for (var i = 0; i < servers_length; i++) {
            this.servers[i] = _buf.ReadString();
        }
	},
});
var FightServerInfo = cc.Class.extend({
	ctor:function(){
		this.ip = null; // ip
        this.innerPort = 0; // 内部端口号,用于服务器之间的通信
        this.clientPort = 0; // 客户端端口号,用于客户端与战斗服通信
        this.clientSSLPort = 0; // 客户端安全端口号,用于客户端与战斗服通信
        this.version = 0; // 版本号
	},

	writing:function( _buf ){
		_buf.WriteString(this.ip);
        _buf.WriteVarInt(this.innerPort);
        _buf.WriteVarInt(this.clientPort);
        _buf.WriteVarInt(this.clientSSLPort);
        _buf.WriteVarInt(this.version);
	},
	
	reading:function( _buf ){
		this.ip = _buf.ReadString();
        this.innerPort = _buf.ReadVarInt();
        this.clientPort = _buf.ReadVarInt();
        this.clientSSLPort = _buf.ReadVarInt();
        this.version = _buf.ReadVarInt();
	},
});
////////////////////
// 普通服注册到公共服务器 //
////////////////////
var ReqRegisterGameForPublicMessage = cc.Class.extend( {
	ctor:function(){
		this.servers = []; // 服务器列表 ServerConfigInfo
	},

	getId:function(){
		return 203101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.servers.length );
        for (var i = 0; i < this.servers.length; i++) {
            _buf.WriteBean(this.servers[i]);
        }
	},
	
	reading:function( _buf ){
        var servers_length = _buf.ReadShort();
        for (var i = 0; i < servers_length; i++) {
            this.servers[i] = _buf.ReadBean(ServerConfigInfo);
        }
	},

});
////////////////////
// 普通服注册到跨服战斗服务器 //
////////////////////
var ReqRegisterGameForFightMessage = cc.Class.extend( {
	ctor:function(){
		this.servers = []; // 服务器列表 ServerConfigInfo
	},

	getId:function(){
		return 203102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.servers.length );
        for (var i = 0; i < this.servers.length; i++) {
            _buf.WriteBean(this.servers[i]);
        }
	},
	
	reading:function( _buf ){
        var servers_length = _buf.ReadShort();
        for (var i = 0; i < servers_length; i++) {
            this.servers[i] = _buf.ReadBean(ServerConfigInfo);
        }
	},

});
////////////////////
// 战斗服注册到公共服务器 //
////////////////////
var ReqRegisterFightForPublicMessage = cc.Class.extend( {
	ctor:function(){
		this.serverInfo = null; // 服务器
	},

	getId:function(){
		return 203103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.serverInfo);
	},
	
	reading:function( _buf ){
        this.serverInfo = _buf.ReadBean(FightServerInfo);
	},

});
////////////////////
// 普通服注册到公共服务器返回消息 //
////////////////////
var ResRegisterGameForPublicMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 203201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 普通服注册到跨服战斗服务器返回消息 //
////////////////////
var ResRegisterGameForFightMessage = cc.Class.extend( {
	ctor:function(){
		this.servers = []; // 服务器列表 ServerConfigInfo
	},

	getId:function(){
		return 203202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.servers.length );
        for (var i = 0; i < this.servers.length; i++) {
            _buf.WriteBean(this.servers[i]);
        }
	},
	
	reading:function( _buf ){
        var servers_length = _buf.ReadShort();
        for (var i = 0; i < servers_length; i++) {
            this.servers[i] = _buf.ReadBean(ServerConfigInfo);
        }
	},

});
////////////////////
// 返回游戏服所有跨服战斗服务器 //
////////////////////
var ResConnectGameToFightMessage = cc.Class.extend( {
	ctor:function(){
		this.serverInfo = null; // 服务器
	},

	getId:function(){
		return 203203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.serverInfo);
	},
	
	reading:function( _buf ){
        this.serverInfo = _buf.ReadBean(FightServerInfo);
	},

});
// 接收消息注册

