var ChatSettingMainExt = ChatSettingMain.extend ( {
	_className:"ChatSettingMainExt",

	// // 频道显示
	// _CHAT_CHANNEL_SYS             :0x1,
	// _CHAT_CHANNEL_WORLD           :0x2,
	// _CHAT_CHANNEL_GUILD           :0x4,
	// _CHAT_CHANNEL_TEAM            :0x8,
	// _CHAT_CHANNEL_PRIVATE         :0x10,
    //
	// // 自动播放 -- wifi
	// _CHAT_WIFI_PRIVATE            :0x1,
	// _CHAT_WIFI_WORLD              :0x2,
	// _CHAT_WIFI_GUILD              :0x4,
	// _CHAT_WIFI_TEAM               :0x8,
    //
	// // 自动播放 -- 4g
	// _CHAT_4G_PRIVATE              :0x1,
	// _CHAT_4G_WORLD                :0x2,
	// _CHAT_4G_GUILD                :0x4,
	// _CHAT_4G_TEAM                 :0x8,

	_channelBoxList:null,
	_wifiBoxList:null,
	_4gBoxList:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		ChatSettingMain.prototype.Init.call(this);
		this._InitParam();

		var len = this._channelBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._channelBoxList[i].btn;
			button.type = this._channelBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseChannel(event.type);
			});
		}

		var len = this._wifiBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._wifiBoxList[i].btn;
			button.type = this._wifiBoxList[i].type;
			button.addClickEventListener(function (event){
				self.UseWifi(event.type);
			});
		}

		var len = this._4gBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._4gBoxList[i].btn;
			button.type = this._4gBoxList[i].type;
			button.addClickEventListener(function (event){
				self.Use4g(event.type);
			});
		}
	},

	_InitParam:function () {
		this._channelBoxList = [
			{btn:this.sbtnGouxuan,type:SettingConstant._CHAT_CHANNEL_SYS},
			{btn:this.sbtnGouxuan1,type:SettingConstant._CHAT_CHANNEL_WORLD},
			{btn:this.sbtnGouxuan2,type:SettingConstant._CHAT_CHANNEL_GUILD},
			{btn:this.sbtnGouxuan3,type:SettingConstant._CHAT_CHANNEL_TEAM},
			{btn:this.sbtnGouxuan4,type:SettingConstant._CHAT_CHANNEL_PRIVATE}
		];
		this._wifiBoxList = [
			{btn:this.sbtnGouxuan5,type:SettingConstant._CHAT_WIFI_PRIVATE},
			{btn:this.sbtnGouxuan6,type:SettingConstant._CHAT_WIFI_WORLD},
			{btn:this.sbtnGouxuan7,type:SettingConstant._CHAT_WIFI_GUILD},
			{btn:this.sbtnGouxuan8,type:SettingConstant._CHAT_WIFI_TEAM},
		];
		this._4gBoxList = [
			{btn:this.sbtnGouxuan9,type:SettingConstant._CHAT_4G_PRIVATE},
			{btn:this.sbtnGouxuan10,type:SettingConstant._CHAT_4G_WORLD},
			{btn:this.sbtnGouxuan11,type:SettingConstant._CHAT_4G_GUILD},
			{btn:this.sbtnGouxuan12,type:SettingConstant._CHAT_4G_TEAM},
		];
	},

	UseChannel:function (ch) {
		//ch = parseInt(ch,2)
		var info = Mgr.plugset.GetChatSetInfo();
		var old_ch = info.channelDisplay;
		if ( (old_ch & ch) > 0 )
			ch = old_ch - ch;
		else
			ch = old_ch + ch;

		this._ShowChannel(ch);
		info.channelDisplay = ch;
		Mgr.plugset.SendReqSetChatSetMessage(info);
	},
	_ShowChannel:function (ch) {
		var len = this._channelBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._channelBoxList[i].btn;
			var type = this._channelBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);
			if ( (ch & type) > 0 )
				button.SetButtonState("check");
			else
				button.SetButtonState( "uncheck" );
		}
	},

	UseWifi:function (ch) {
		//ch = parseInt(ch,2)
		var info = Mgr.plugset.GetChatSetInfo();
		var old_ch = info.wifiAutoPlay;
		if ( (old_ch & ch) > 0 )
			ch = old_ch - ch;
		else
			ch = old_ch + ch;

		this._ShowWifi(ch);
		info.wifiAutoPlay = ch;
		Mgr.plugset.SendReqSetChatSetMessage(info);
	},
	_ShowWifi:function (ch) {
		var len = this._wifiBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._wifiBoxList[i].btn;
			var type = this._wifiBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);
			if ( (ch & type) > 0 )
				button.SetButtonState("check");
			else
				button.SetButtonState( "uncheck" );
		}
	},

	Use4g:function (ch) {
		//ch = parseInt(ch,2)
		var info = Mgr.plugset.GetChatSetInfo();
		var old_ch = info.noWifiAutoPlay;
		if ( (old_ch & ch) > 0 )
			ch = old_ch - ch;
		else
			ch = old_ch + ch;

		this._Show4g(ch);
		info.noWifiAutoPlay = ch;
		Mgr.plugset.SendReqSetChatSetMessage(info);
	},
	_Show4g:function (ch) {
		var len = this._4gBoxList.length;
		for ( var i = 0; i != len; i++ ) {
			var button = this._4gBoxList[i].btn;
			var type = this._4gBoxList[i].type;
			//var sample = parseInt(type,2).toString(10);
			if ( (ch & type) > 0 )
				button.SetButtonState("check");
			else
				button.SetButtonState( "uncheck" );
		}
	},

	OnShow:function () {
		var info = Mgr.plugset.GetChatSetInfo();
		this._ShowChannel(info.channelDisplay);
		this._ShowWifi(info.wifiAutoPlay);
		this._Show4g(info.noWifiAutoPlay);
	},
} );
ChatSettingMainExt.PanelName = "ChatSettingMainExt";
PanelClassDic["ChatSettingMainExt"] = ChatSettingMainExt;
