///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ShopItemInfo 商品动态信息
//MythRefreshInfo 神秘商店刷新信息

// 请求消息
//149201,ReqBuyItem 购买物品
//149202,ReqSellItem 出售物品
//149203,ReqRebuy 回购物品
//149204,ReqRebuyList 回购列表
//149205,ReqShopList 请求商店出售物品列表
//149206,ReqSellItems 出售物品列表
//149207,ReqRefreshShop 刷新商品列表
//149208,ReqAddOrDeleteShoppingCart 加入或则删除购物车商品
//149209,ReqShoppingCartInfo 请求购物车商品信息

// 接收消息
//149101,ResSaleSuccess 销售成功消息
//149102,ResRebuySuccess 回购成功消息
//149103,ResRebuyItemInfos 回购物品列表
//149104,ResShopItemList 商品列表
//149105,ResBuyItemResult 购买成功消息
//149106,ResMythShopRefreshPreciousInfoGameToClient 神秘商店刷新极品信息到Client
//149107,ResShoppingCartInfoGameToClient 发送打折商店购物车信息


var ShopItemInfo = cc.Class.extend({
	ctor:function(){
		this.shopItemId = 0; // 商品ID(shop_data主键)
        this.shopItemNum = 0; // 商品库存量
        this.buyoneLimit = 0; // 单次购买个数限制
        this.moneyInfo = null; // 售价信息
        this.discount = 0; // 折扣信息
        this.hot = 0; // 热销标识 0无热销，1热销中，2折扣，3热销+折扣
        this.item = null; // 物品
        this.otherlimit = null; // 其他限制
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.shopItemId);
        _buf.WriteVarInt(this.shopItemNum);
        _buf.WriteVarInt(this.buyoneLimit);
        _buf.WriteString(this.moneyInfo);
        _buf.WriteVarInt(this.discount);
        _buf.WriteByte(this.hot);
        _buf.WriteBean(this.item);
        _buf.WriteString(this.otherlimit);
	},
	
	reading:function( _buf ){
		this.shopItemId = _buf.ReadVarInt();
        this.shopItemNum = _buf.ReadVarInt();
        this.buyoneLimit = _buf.ReadVarInt();
        this.moneyInfo = _buf.ReadString();
        this.discount = _buf.ReadVarInt();
        this.hot = _buf.ReadByte();
        this.item = _buf.ReadBean(TempItemInfo);
        this.otherlimit = _buf.ReadString();
	},
});
var MythRefreshInfo = cc.Class.extend({
	ctor:function(){
		this.playerName = null; // 玩家姓名
        this.item = null; // 物品
	},

	writing:function( _buf ){
		_buf.WriteString(this.playerName);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
		this.playerName = _buf.ReadString();
        this.item = _buf.ReadBean(TempItemInfo);
	},
});
////////////////////
// 销售成功消息 //
////////////////////
var ResSaleSuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.item = null; // 物品
	},

	getId:function(){
		return 149101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.shop.RecvResSaleSuccessMessage(this);
	},

});
////////////////////
// 回购成功消息 //
////////////////////
var ResRebuySuccessMessage = cc.Class.extend( {
	ctor:function(){
		this.item = null; // 物品
	},

	getId:function(){
		return 149102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.item = _buf.ReadBean(ItemInfo);
	},

	action:function(){
		Mgr.shop.RecvResRebuySuccessMessage(this);
	},

});
////////////////////
// 回购物品列表 //
////////////////////
var ResRebuyItemInfosMessage = cc.Class.extend( {
	ctor:function(){
		this.items = []; // 物品信息列表 ItemInfo
        this.timeKeys = []; // 物品卖出时间信息列表 string
	},

	getId:function(){
		return 149103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteShort( this.timeKeys.length );
        for (var i = 0; i < this.timeKeys.length; i++) {
            _buf.WriteString(this.timeKeys[i]);
        }
	},
	
	reading:function( _buf ){
        var items_length = _buf.ReadShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(ItemInfo);
        }
        var timeKeys_length = _buf.ReadShort();
        for (var i = 0; i < timeKeys_length; i++) {
            this.timeKeys[i] = _buf.ReadString();
        }
	},

	action:function(){
		Mgr.shop.RecvResRebuyItemInfosMessage(this);
	},

});
////////////////////
// 商品列表 //
////////////////////
var ResShopItemListMessage = cc.Class.extend( {
	ctor:function(){
		this.shopId = 0; // 商店编号
        this.shopItemList = []; // 指定页的列表 ShopItemInfo
        this.nextRefreshTime = 0; // 下次刷新时间
        this.refreshCost = 0; // 刷新消耗
	},

	getId:function(){
		return 149104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopId);
        _buf.WriteShort( this.shopItemList.length );
        for (var i = 0; i < this.shopItemList.length; i++) {
            _buf.WriteBean(this.shopItemList[i]);
        }
        _buf.WriteVarInt(this.nextRefreshTime);
        _buf.WriteVarInt(this.refreshCost);
	},
	
	reading:function( _buf ){
        this.shopId = _buf.ReadVarInt();
        var shopItemList_length = _buf.ReadShort();
        for (var i = 0; i < shopItemList_length; i++) {
            this.shopItemList[i] = _buf.ReadBean(ShopItemInfo);
        }
        this.nextRefreshTime = _buf.ReadVarInt();
        this.refreshCost = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.shop.RecvResShopItemListMessage(this);
	},

});
////////////////////
// 购买成功消息 //
////////////////////
var ResBuyItemResultMessage = cc.Class.extend( {
	ctor:function(){
		this.shopModelId = 0; // 销售Id
        this.costType = 0; // 花费类型
        this.costNumber = 0; // 花费金额
        this.item = null; // 物品
	},

	getId:function(){
		return 149105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopModelId);
        _buf.WriteVarInt(this.costType);
        _buf.WriteVarInt(this.costNumber);
        _buf.WriteBean(this.item);
	},
	
	reading:function( _buf ){
        this.shopModelId = _buf.ReadVarInt();
        this.costType = _buf.ReadVarInt();
        this.costNumber = _buf.ReadVarInt();
        this.item = _buf.ReadBean(TempItemInfo);
	},

	action:function(){
		Mgr.shop.RecvResBuyItemResultMessage(this);
	},

});
////////////////////
// 神秘商店刷新极品信息到Client //
////////////////////
var ResMythShopRefreshPreciousInfoGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.myinfos = []; // 我的信息信息 TempItemInfo
        this.platforminfos = []; // 全平台信息 MythRefreshInfo
	},

	getId:function(){
		return 149106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.myinfos.length );
        for (var i = 0; i < this.myinfos.length; i++) {
            _buf.WriteBean(this.myinfos[i]);
        }
        _buf.WriteShort( this.platforminfos.length );
        for (var i = 0; i < this.platforminfos.length; i++) {
            _buf.WriteBean(this.platforminfos[i]);
        }
	},
	
	reading:function( _buf ){
        var myinfos_length = _buf.ReadShort();
        for (var i = 0; i < myinfos_length; i++) {
            this.myinfos[i] = _buf.ReadBean(TempItemInfo);
        }
        var platforminfos_length = _buf.ReadShort();
        for (var i = 0; i < platforminfos_length; i++) {
            this.platforminfos[i] = _buf.ReadBean(MythRefreshInfo);
        }
	},

	action:function(){
		Mgr.shop.RecvResMythShopRefreshPreciousInfoGameToClientMessage(this);
	},

});
////////////////////
// 发送打折商店购物车信息 //
////////////////////
var ResShoppingCartInfoGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.shopItemId = []; // 商品ID(shop_data主键) int
	},

	getId:function(){
		return 149107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.shopItemId.length );
        for (var i = 0; i < this.shopItemId.length; i++) {
            _buf.WriteVarInt(this.shopItemId[i]);
        }
	},
	
	reading:function( _buf ){
        var shopItemId_length = _buf.ReadShort();
        for (var i = 0; i < shopItemId_length; i++) {
            this.shopItemId[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.shop.RecvResShoppingCartInfoGameToClientMessage(this);
	},

});
////////////////////
// 购买物品 //
////////////////////
var ReqBuyItemMessage = cc.Class.extend( {
	ctor:function(){
		this.shopType = 0; // 商店model(shop_base主键，商店种类)
        this.itemModelId = 0; // 物品模型ID
        this.shopItemId = 0; // 商品ID(shop_data主键)
        this.shopItemSid = null; // 商店生成物品的唯一id(TempItemInfo里面的唯一id)
        this.moneyInfo = null; // 售价信息
        this.moneyType = 0; // 货币类型
        this.num = 0; // 购买数量
        this.discountItemid = null; // 使用的打折卡唯一ID,不用就传0
	},

	getId:function(){
		return 149201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopType);
        _buf.WriteVarInt(this.itemModelId);
        _buf.WriteVarInt(this.shopItemId);
        _buf.WriteLong(this.shopItemSid);
        _buf.WriteString(this.moneyInfo);
        _buf.WriteVarInt(this.moneyType);
        _buf.WriteVarInt(this.num);
        _buf.WriteLong(this.discountItemid);
	},
	
	reading:function( _buf ){
        this.shopType = _buf.ReadVarInt();
        this.itemModelId = _buf.ReadVarInt();
        this.shopItemId = _buf.ReadVarInt();
        this.shopItemSid = _buf.ReadLong();
        this.moneyInfo = _buf.ReadString();
        this.moneyType = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.discountItemid = _buf.ReadLong();
	},

});
////////////////////
// 出售物品 //
////////////////////
var ReqSellItemMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 149202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 回购物品 //
////////////////////
var ReqRebuyMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = null; // 物品Id
	},

	getId:function(){
		return 149203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.itemId);
	},
	
	reading:function( _buf ){
        this.itemId = _buf.ReadLong();
	},

});
////////////////////
// 回购列表 //
////////////////////
var ReqRebuyListMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 149204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求商店出售物品列表 //
////////////////////
var ReqShopListMessage = cc.Class.extend( {
	ctor:function(){
		this.shopModelId = 0; // 模型编号
	},

	getId:function(){
		return 149205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopModelId);
	},
	
	reading:function( _buf ){
        this.shopModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 出售物品列表 //
////////////////////
var ReqSellItemsMessage = cc.Class.extend( {
	ctor:function(){
		this.itemId = []; // 物品Id long
	},

	getId:function(){
		return 149206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.itemId.length );
        for (var i = 0; i < this.itemId.length; i++) {
            _buf.WriteLong(this.itemId[i]);
        }
	},
	
	reading:function( _buf ){
        var itemId_length = _buf.ReadShort();
        for (var i = 0; i < itemId_length; i++) {
            this.itemId[i] = _buf.ReadLong();
        }
	},

});
////////////////////
// 刷新商品列表 //
////////////////////
var ReqRefreshShopMessage = cc.Class.extend( {
	ctor:function(){
		this.shopModelId = 0; // 模型编号
	},

	getId:function(){
		return 149207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopModelId);
	},
	
	reading:function( _buf ){
        this.shopModelId = _buf.ReadVarInt();
	},

});
////////////////////
// 加入或则删除购物车商品 //
////////////////////
var ReqAddOrDeleteShoppingCartMessage = cc.Class.extend( {
	ctor:function(){
		this.shopModelId = 0; // 模型编号
        this.optype = 0; // 操作类型（1是加入购物车2是删除）
	},

	getId:function(){
		return 149208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.shopModelId);
        _buf.WriteVarInt(this.optype);
	},
	
	reading:function( _buf ){
        this.shopModelId = _buf.ReadVarInt();
        this.optype = _buf.ReadVarInt();
	},

});
////////////////////
// 请求购物车商品信息 //
////////////////////
var ReqShoppingCartInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 149209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(149101, ResSaleSuccessMessage);
MESSAGE_POOL.Add(149102, ResRebuySuccessMessage);
MESSAGE_POOL.Add(149103, ResRebuyItemInfosMessage);
MESSAGE_POOL.Add(149104, ResShopItemListMessage);
MESSAGE_POOL.Add(149105, ResBuyItemResultMessage);
MESSAGE_POOL.Add(149106, ResMythShopRefreshPreciousInfoGameToClientMessage);
MESSAGE_POOL.Add(149107, ResShoppingCartInfoGameToClientMessage);

