var ShouChongMainExt = ShouChongMain.extend ( {
    _className:"ShouChongMainExt",

    buttonPanel:null,
    awardPanel:null,
    heightMargin:3,
    buttonList:[],
    awardList:[],
    model:null,
    _curActivity:null,
    _buyAc:null,

    ctor:function(){
        this._super();
        this.layoutCom.layoutType = MLLAYOUT_C;
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
    },

    Init:function () {
        var self = this;
        ShouChongMain.prototype.Init.call(this);
        this.buttonList = [this.btnAnNiu6, this.btnAnNiu30, this.btnAnNiu50, this.btnAnNiu68];
        this.awardList = [this.gridKuang, this.gridKuang1, this.gridKuang2, this.gridKuang3, this.gridKuang4];
        this.btnAnNiu6.moneyIcon = this.img1;
        this.btnAnNiu6.moneyLabel = this.imglabNum1;
        this.btnAnNiu6.goldLabel = this.labYuanBao;
        this.btnAnNiu30.moneyIcon = this.img2;
        this.btnAnNiu30.moneyLabel = this.imglabNum2;
        this.btnAnNiu30.goldLabel = this.labYuanBao2;
        this.btnAnNiu50.moneyIcon = this.img3;
        this.btnAnNiu50.moneyLabel = this.imglabNum3;
        this.btnAnNiu50.goldLabel = this.labYuanBao3;
        this.btnAnNiu68.moneyIcon = this.img4;
        this.btnAnNiu68.moneyLabel = this.imglabNum4;
        this.btnAnNiu68.goldLabel = this.labYuanBao4;
        this.imglabNum.y += 7;

        for( let i = 0, len = this.buttonList.length; i < len; i++ ){
            (function(a){
                self.buttonList[a].addClickEventListener(function(target){
                    if(target.acInfo.status == 1){
                        if(target.info.money != self._buyAc)return;
                        Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(target.acInfo.activityId, 1);
                    }else if(target.acInfo.status == 2){
                        Mgr.recharge.Recharge(target.info.buyId);
                    }
                });
            })(i);
        }

        this.btnClose.addClickEventListener(function (event) {
            EngineMgr.uiMgr.HidePanel(self);
        });
    },

    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activityList = list;
        this.UpdatePanel(list[0]);
        this.SetButtonInfo();

    },

    UpdateSingleActivity:function (info) {
        for(var i = 0, len = this.activityList.length; i < len; i++){
            var ac = this.activityList[i];
            if(ac.activityId == info.activityId){
                ac.status = info.status;
                break;
            }
        }
        this.SetButtonInfo();
    },

    SetButtonInfo:function () {
        var info = this.activityList[0];
        if(info.status == 1){
            var gold = info.special[0].beanInfo.gold;
            this.buttonList.forEach(v=>{
                if(gold >= v.info.money){
                    this._buyAc = v.info.money;
                    return true
                }
            })
        }

        for(var i = 0; i < this.buttonList.length; i++){
            var button = this.buttonList[i];
            button.acInfo = info;
            if(info.status == 1){
                if(button.info.money == this._buyAc) {
                    Filter.UnGray(button);
                    if (!button.lab) {
                        var label = new MUILabel();
                        label.jsonobj = this.lab1.jsonobj;
                        label.Init();
                        label.x = 30;
                        label.y = 90;
                        button.lab = label;
                        button.addChild(label);
                    }
                    button.lab.SetText("领\n取\n奖\n励");
                    this.imgHot.setVisible(false);
                    button.moneyIcon.setVisible(false);
                    button.moneyLabel.setVisible(false);
                }else {
                    EngineMgr.uiMgr.GetAsynResByUrl("other/shouchong/xin/word/qian.png", function(btn){
                        Filter.GrayScale(btn);
                    }, this, button);
                }
            }
            button.goldLabel.SetHtmlText(TextUtil.FormatStr(button.goldLabel.GetHtmlText(), [button.info.money * 5]));
        }
    },

    UpdateRewards:function(){
        var awards = this._curActivity.GetRewardList();
        for(var i = 0, len = awards.length; i < len; i++){//生成奖励列表
            var award = this.awardList[i];
            if(award){
                GridUtil.SetItemGrid(award, awards[i]);
            }
        }

        for(var i = awards.length; i < this.awardList.length; i++){
            var cell = this.awardList[i];
            this.awardPanel.removeChild(cell);
        }
    },

    //刷新面板信息
    UpdatePanel:function (info) {
        this._curActivity = info;

        this.UpdateRewards();
        this.imglabNum.SetText(info.GetFlagValue(EnumActivityFlag.F_POWER));

        //// 动态更新价格
        var buyrecharge = info.resFlag.Get("buyrecharge")
        var rechargeInfo = buyrecharge ? buyrecharge.split("|") : []
        this.buttonList.forEach((v,k)=>{
            let i = rechargeInfo[k]

            if(!i){
                v.visible = false
                return
            }
            v.visible = true;

            let s = i.split("_")
            let buyId = s[0]
            let money = parseInt(s[1])

            v.moneyLabel.SetAlign(LableAlign.CENTER)
            v.moneyLabel.SetText(Math.ceil(money) / MGameDefine.RECHARGE_RATE)

            v.info = {money: money, buyId:buyId};
        })
    },

    OnHide:function(){
        this._super();
        if( this.model )
            this.model.Dispose();
        this.model = null;
    }
} );
ShouChongMainExt.PanelName = "ShouChongMainExt";
PanelClassDic["ShouChongMainExt"] = ShouChongMainExt;
