﻿var SkillModMgr = SkillModMgr || cc.Class.extend({
	
	skillInfos:null,
	fightStateId:1,			//技能特效循环状态  1-7
		 shoePanel:null,
	ctor:function() {	
		this.skillInfos = new HashMap();
	},

	/**
	 * 收到全部技能消息
	 */
	RecvResSkillInfosMessage:function(msg) {
		this.skillInfos.Clear();
		var skill;
		SkillUtil.NORMAL_SKILL_MID_PLAYER = [];
		for( var i = 0; i < msg.skills.length; i++ ){
			skill = new SkillData(msg.skills[i]);
			this.skillInfos.Put(skill.Mid(), skill);
			if( SkillUtil.IsBaseSkill(skill.Mid())){
				SkillUtil.NORMAL_SKILL_MID_PLAYER.push(skill.Mid());
			}
		}

		cc.log(this.skillInfos + "   -   " + JSON.stringify(this.skillInfos) + "   -   " + msg.skills.length);

		Mgr.player.shortPanel.UpdateSkillInfo();

		var panel = Mgr.uiMgr.GetPanelByType(SkillPanelExt.PanelName);
		if ( panel && panel.showPanel )
			panel.showPanel.SetData(panel.curSkillIds);
	},

	RecvResSkillAddMessage:function(msg) {
			var skill = new SkillData(msg.skillInfo);
			var isNew = this.skillInfos.Get( skill.Mid() ) == null;
			this.skillInfos.Put( skill.Mid(), skill );

			if( SkillUtil.IsBaseSkill(skill.Mid())){
				SkillUtil.NORMAL_SKILL_MID_PLAYER.push(skill.Mid());
			}

			if(isNew && (skill.Model().q_skill_user != 4) && (skill.Model().q_trigger_type != 2)){
				// 弹出技能学习成果的新技能Get面板
                Mgr.player.shortPanel.OnSkillAdd(skill.Mid());
                EngineMgr.uiMgr.ShowPanelByType(NewSkillCueExt.PanelName);
                Mgr.uiMgr.GetPanelByType(NewSkillCueExt.PanelName).SetKillId(skill.Mid());
			}

		// Mgr.tips.ShowNotice(UIUtil._ConectParam( "技能升级，{@}技能升级到{@}级 ", [ skill.Name(), skill.FullLevel() ] ));

		var panel = Mgr.uiMgr.GetPanelByType(SkillPanelExt.PanelName);
		if ( panel && panel.showPanel )
			panel.showPanel.SetData(panel.curSkillIds)
	},

	RecvResSkillStartLevelUpMessage:function(msg) {
		cc.log("技能开始升级")
	},

	RecvResSkillRemoveMessage:function(msg) {
		cc.log("技能移除")
	},

	_lastResetTime:0,
	RecvResSkillResetEffectsidMessage:function(msg) {	
		var now = TimerUtil.GetTimer();
		if( now - this.lastResetTime > 2000 )	//2秒cd 不能一直重置 不然服务器发快了也会出问题
		{
			this.fightStateId++;
			if( this.fightStateId > this.MAX_FIGHT_STATE )
				this.fightStateId = 1;
			this.lastResetTime = now;
		}
	},

	RecvResSkillChangeMessage:function(msg) {
		var skill = new SkillData(msg.skillInfo);
		this.skillInfos.Put(skill.Mid(), skill);

		// Mgr.tips.ShowNotice(UIUtil._ConectParam( "技能升级，{@}技能升级到{@}级 ", [ skill.Name(), skill.FullLevel() ] ));

		var panel = Mgr.uiMgr.GetPanelByType(SkillPanelExt.PanelName);
		if ( panel && panel.showPanel )
			panel.showPanel.SetData(panel.curSkillIds)

		//update shortcutpanel

		// // 是否自动升级   可能后端直接操作，
		// var mid = msg.skillInfo.skillModelId;
		// var level = msg.skillInfo.skillLevel || 1;
		// var exp = msg.skillInfo.skillExp;
		// if ( this.IsAutoUpLevel( mid, level, exp ) ){
		// 	this.SendReqLevelUpSkillMessage( mid );
		// }
	},

	RecvResSkillCooldownInfoMessage:function(msg){
		for( var i = msg.skillCooldownInfos.length - 1; i >= 0; i-- ){
			var info = msg.skillCooldownInfos[i];
			Mgr.mainPlayer.oCtrlAutoFight.UpdateSkillCoolDown(info.skillModelId, info.remain + ToolBase.GetTimer());
		}
	},

	RecvResSkillCooldownCorrectionMessage:function(msg){
		Mgr.mainPlayer.oCtrlAutoFight.UpdateSkillCoolDown(msg.skillModelId, msg.cd + ToolBase.GetTimer());
	},

	SendReqLevelUpSkillMessage:function(mid) {	
		var msg = new ReqLevelUpSkillMessage();
		msg.skillModelId = mid;
		Mgr.msgMgr.Send(msg);
	},

	SendReqSetDefaultSkillMessage:function(msg) {	
		//没这个功能
	},
	
	GetFightState:function(){
		var state = this.fightStateId;
//		if( isAutoFight )
//			state |= SkillUtil.AUTOFIGHT_STATE;
		return state;
	},

	AutoUpdateSkill:function(skillId){
		var skill = this.skillInfos.Get(skillId);
		if( skill ){
			skill.ExpAddOne();
		}
	},

	// 判断材料是否足够
	ShortMetarial:function ( mid, lv ) {
		var id_level = mid + "_" + 1;
		var skill_model = Q_skill_model.Get(id_level);
		cc.assert(null != skill_model, "Q_skill_model Item can't be nil!  id_level: " + id_level);
		if ( lv >= skill_model.q_max_level ) {   // 最大等级  不需要提醒，直接返个true
			return true;
		}

		var level = lv + 1;
		var id_level_next = mid + "_" + level;
		var skill_model_next = Q_skill_model.Get(id_level_next);
		cc.assert(null != skill_model_next, "Q_skill_model Item can't be nil!  id_level: " + id_level_next);

		// 材料
		var metrial_id = skill_model_next.q_upgrade_item;
		var metrialNeedNum = skill_model_next.q_upgrade_item_num;

		// 附上升级所需条件
		if (Mgr.backpack.GetItemNumber(metrial_id, true) < metrialNeedNum)
			return true;

		return false;
	},
});

var SkillUtil = SkillUtil || {
	NORMAL_SKILL_MID_PLAYER:[13],
	NORMAL_SKILL_MID_MONSTER:2,
	BASE_SKILL_CD:null,
	MAX_FIGHT_STATE:0x04,
	AUTOFIGHT_STATE:0x40,

	IsBaseSkill:function(mid){
		return mid <= 100;
	},

	IsNuqiSkill:function(mid){
		return mid == 10041 || mid == 10042;
	},

	GetSkillCd:function( cd ){
		var magic = (1.0 + Mgr.mainPlayer.attributeData.attackSpeed / 1000.0);
		if (magic > 2)
			magic = 2;

		if(!magic)
		{
			magic = 1;
		}

		return cd / magic;
	},

	GetSkillDis:function (mid)
	{
		var skill = Mgr.skill.skillInfos.Get(mid);
		if(!skill)
		{
			skill = Mgr.skill.skillInfos.Get(SkillUtil.NORMAL_SKILL_MID_PLAYER[0]);
		}
		if( skill )
			return skill.FullModel().q_range_limit;
		return 3;
	},

	GetSkillIcon:function (mid , sizetype, isGround )
	{
		var url = ResUrl.GetSkillIconKey(mid);
		var defaultUrl = ResUrl.GetDefaultItemUrl();
		var bmp = UIUtil.GetIconByUrl(url, defaultUrl, false);
		return bmp;
	},

	IsAutoUpLevel:function (mid, level, exp) {

		var autoType = false, enableUp = false;

		var skill_public = Q_skill_public.Get( mid );
		cc.assert(null != skill_public, "Q_skill_public Item can't be nil!  mid: " + mid);
		autoType = skill_public.q_index != 2;  // 2：被动技能

		var id_level = mid + "_" + level;
		var skill_model = Q_skill_model.Get( id_level );
		cc.assert(null != skill_model, "Q_skill_model Item can't be nil!  id_level: " + id_level);
		var needExp = skill_model.q_upgrade_proficiency;
		enableUp = exp >= needExp;

		return (autoType && enableUp);
	},
};