var SkillActivePanelExt = SkillActivePanel.extend ( {
	_className:"SkillActivePanelExt",

	skillArry:null,
    lvLabelArr:null,
	_curSelectItem:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		SkillActivePanel.prototype.Init.call(this);

		this._InitPanel();
	},

	_InitPanel:function () {
		this._InitPosition();
		this._InitParam();
	},

	_InitPosition:function () {
		// pos
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function () {
		this.imgSelect.visible = false;
		this.labMaxLevel.visible = false;
		this.skillArry=[this.imgSkillIcon,this.imgSkillIcon1,this.imgSkillIcon2,this.imgSkillIcon3,this.imgSkillIcon4,this.imgSkillIcon5, this.imgSkillIcon6];
		this.lvLabelArr = [this.labSkillA, this.labSkillB, this.labSkillC, this.labSkillD, this.labSkillE, this.labSkillF, this.labSkillG];
	},

	SetData:function (ids) {
        this._ShowSkillIcon(ids);
        this._AutoSelect();
    },

	_AutoSelect:function () {
		if ( !this._curSelectItem )
			this._curSelectItem = this.skillArry[0];
		this._SetClickItem( );
	},

	_ShowSkillIcon:function ( ids ) {
		for ( var i = 0; i != ids.length; i++ ) {
			if ( this.skillArry[i] ) {
				var str = "other/zhujiemian/btn/skill/";
				str += ids[i].toString() + ".png";
				// 通用目录
				// var job = Q_skill_public.Get(ids[i]).q_job;
				// if ( job == 0 )
				// 	str += "_common/" + ids[i].toString() + ".png";
				// else {
				// 	str += (job == 1 ? "_nan/" : "_nv/") + ids[i].toString() + ".png";
				// }
				var imgMode = this.skillArry[i];
				UIUtil.LoadImage(imgMode, str);

                var msgData = Mgr.skill.skillInfos.Get( ids[i] );

                if ( msgData ) {
                    var curLevel =  msgData.FullLevel();
                   Filter.UnGray(imgMode);
                   this.lvLabelArr[i].setVisible(true);
                   if(curLevel > 0){
                       this.lvLabelArr[i].SetText("Lv:"+curLevel);
                   }else {
                       this.lvLabelArr[i].SetText("Lv:"+0);
                	}
                }else {
                   this.lvLabelArr[i].setVisible(false);
                   Filter.GrayScale(imgMode);
                };

				// callback
				this.skillArry[i].skillId = ids[i];
				this.skillArry[i].setTouchEnabled(true);
				this.skillArry[i].addTouchEventListener(function (sender, type) {
					if (type == ccui.Widget.TOUCH_ENDED) {
						var panel = Mgr.uiMgr.GetPanelByType(SkillPanelExt.PanelName)
						if (panel) {
							var page = panel.panelMgr[SkillPanelType.PANEL_ACTIVE];
							if (page) {
								if (page._curSelectItem && page._curSelectItem.effect)
									page._curSelectItem.effect.visible = false;
								page._curSelectItem = sender;
								page._SetClickItem();
							}
						}
					}
				});
			}
		}
	},

	_SetClickItem:function () {
		if ( !this._curSelectItem.effect ) {
			var imgEffect = new MUIImage();
			imgEffect.ParseJson(this.imgSelect.jsonobj);
			imgEffect.Init();
			imgEffect.x = this.imgSelect.x + 11;
			imgEffect.y = this.imgSelect.y + 11;
			this._curSelectItem.parent.addChild(imgEffect, 0, 10);
			this._curSelectItem.effect = imgEffect;
		}
		this._curSelectItem.effect.visible = true;
		this._curSelectItem.reorderChild(this._curSelectItem.effect, 3);

		// set info
		var mid = this._curSelectItem.skillId;
		this._SetSkillInfo( mid );
	},

	_SetSkillInfo:function ( mid ) {
		var skill_public = Q_skill_public.Get( mid );
		cc.assert(null != skill_public, "Q_skill_public Item can't be nil!  mid: " + mid);

		var curLevel = 0;

		var exp = 0;
		// 判断技能是否激活
		var msgData = Mgr.skill.skillInfos.Get( mid );
		if ( msgData ) {
			curLevel =  msgData.FullLevel()
			exp = msgData.Exp();
		}

		// 0级不存在与配置中
		var id_level = mid + "_" + curLevel;
		if ( curLevel <= 0 )
			id_level = mid + "_1";

		var skill_model = Q_skill_model.Get( id_level );
		cc.assert(null != skill_model, "Q_skill_model Item can't be nil!  id_level: " + id_level);

		// icon
		var url = "other/zhujiemian/btn/skill/";
		url += mid.toString() + ".png";
		// 根据职业获取url
		// var job = Q_skill_public.Get(mid).q_job;
		// if ( job == 0 )
		// 	url += "_common/" + mid.toString() + ".png";
		// else {
		// 	url += (job == 1 ? "_nan/" : "_nv/") + mid.toString() + ".png";
		// }
		// cc.log("---- url ----  " + url )

		var imgMode = this.imgIcon;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function(){
			imgMode.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgMode);

		// name
		var str = skill_model.q_skillName;
		this.labSkillName.SetString(str);

		// type
		str = skill_public.q_tips;
		this.labType1.SetString(str);

		// 根据技能类型显示
		var skillKind = skill_public.q_index;
		if ( skillKind == 3 ) { // 心法技能
			this.labLevel.visible = false;
			this.labRateStr.visible = false;
			//this.labZhanli.visible = false;
			//this.labZhanli2.visible = false;

			// effect
			var strC = skill_model.q_introduce;
			strC=strC.substring(1,strC.length-1);
			var array=strC.split(",");
			this.labXiaoguo.SetString(TextUtil.ConectParam( skill_public.q_desc, array));

			// next effect  心法技能不存在升级
			this.labMaxLevel.setVisible(true);
			this.labXiaoguo1.SetString("");

			// tips
			this.labCue4.visible = false;
			this.labCue3.visible = true;
		}
		else {
			// level
			this.labLevel.visible = true;
			str = curLevel + "/" + skill_model.q_max_level;
			this.labLevel1.SetString(str);

			// rate
			this.labRateStr.visible = true;
			var needExp = skill_model.q_upgrade_proficiency;
			var rate = parseFloat(exp / needExp) * 100;
			this.progJindutiao.setPercent(rate);
			str = exp + "/" + needExp;
			this.labRate.SetString(str);

			// effect
			var strC = skill_model.q_introduce;
			strC=strC.substring(1,strC.length-1);
			var array=strC.split(",");
			this.labXiaoguo.SetString(TextUtil.ConectParam( skill_public.q_desc, array));
			// fight
			var fight_cur = parseInt(skill_model.q_fight_bonus)
			if ( fight_cur > 0 ) {
				//this.labZhanli.visible = true;
				//this.labZhanli1.SetString(fight_cur);
			}
			else {
				//this.labZhanli.visible = false;
			}

			// next effect
			if ( skill_model.q_grade >= skill_model.q_max_level ) {
				this.labMaxLevel.visible = true;
				// des
				this.labXiaoguo.SetString("");
				// fight
				//this.labZhanli2.visible = false;
			}
			else {
				this.labMaxLevel.visible = false;

				var nextLv = curLevel + 1;
				var next_id_level = mid + "_" + nextLv;
				var next_skill_model = Q_skill_model.Get( next_id_level );
				cc.assert(null != next_skill_model, "Q_skill_model Item can't be nil!  next_id_level: " + next_id_level);
				// des
				var strC = next_skill_model.q_introduce;
				strC=strC.substring(1,strC.length-1);
				var array=strC.split(",");
				this.labXiaoguo1.SetString(TextUtil.ConectParam( skill_public.q_desc, array));
				// fight
				var fight_next = parseInt(next_skill_model.q_fight_bonus)
				if ( fight_next > 0 ) {
					//this.labZhanli2.visible = true;
					//this.labZhanli21.SetString(fight_next);
				}
				else {
					//this.labZhanli2.visible = false;
				}
			}
			// tips
			this.labCue4.visible = true;
			this.labCue3.visible = false;
		}
	},
} );
SkillActivePanelExt.PanelName = "SkillActivePanelExt";
PanelClassDic["SkillActivePanelExt"] = SkillActivePanelExt;
