var SkillStaticPanelExt = SkillStaticPanel.extend ( {
	_className:"SkillStaticPanelExt",

	skillArry:null,
    lvLabelArr:null,
	_curSelectItem:null,

	ctor:function(){
		this._super();
	},

	Init:function() {
		var self = this;
		SkillStaticPanel.prototype.Init.call(this);

		this._InitPanel();

		this.btnLearn.addClickEventListener(function (event){
			self._SendUpProp();
		});
	},

	_SendUpProp:function () {
		var mid = this._curSelectItem.skillId;
		if ( this._curSelectItem.metrialShort ) {
			Mgr.tips.ShowNotice("升级材料不足");
			return;
		}
		if ( this._curSelectItem.levelShort ) {
			Mgr.tips.ShowNotice("请先提升角色等级");
			return;
		}
		Mgr.skill.SendReqLevelUpSkillMessage( mid );
	},

	_InitPanel:function () {
		this._InitPosition();
		this._InitParam();
	},

	_InitPosition:function () {
		// pos
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function () {
		this.labkUp.visible = false;
		this.labMaxLevel.visible = false;
		this.imgSelect.visible = false;
		this.skillArry=[this.imgSkillIcon,this.imgSkillIcon1,this.imgSkillIcon2];
		this.lvLabelArr = [this.labSkill1, this.labSkill2, this.labSkill3];
	},

	SetData:function (bdIds) {
		// 被动技能 icon
		this._ShowSkillIcon( bdIds );
		this._AutoSelect();
	},

	_AutoSelect:function () {
		if ( !this._curSelectItem )
			this._curSelectItem = this.skillArry[0];
		this._SetClickItem( );
	},

	_ShowSkillIcon:function ( ids ) {
        var x = this.gridSkillIcon.x;
        var y = this.gridSkillIcon.y;
        var intX = 135;
        var intY = 140;

		for ( var i = 0; i != ids.length; i++ ) {
            if (!this.skillArry[i]) {
                var cell = this.gridSkillIcon1.Clone();
                this.gridSkillIcon1.parent.addChild(cell);
                cell.x = x + (i % 4) * intX;
                cell.y = y - Math.floor((i / 4)) * intY;
                this.skillArry[i] = cell.imgSkillIcon1;
                this.lvLabelArr[i] = cell.labSkill2;
            }

			if ( this.skillArry[i] ) {
				var str = "other/zhujiemian/btn/skill/";
				str += ids[i].toString() + ".png";
				// // 根据职业获取url
				// var job = Q_skill_public.Get(ids[i]).q_job;
				// if ( job == 0 )
				// 	str += "_common/" + ids[i].toString() + ".png";
				// else {
				// 	str += (job == 1 ? "_nan/" : "_nv/") + ids[i].toString() + ".png";
				// }
				var imgMode = this.skillArry[i];
                UIUtil.LoadImage(imgMode, str);

				// 可升级、可激活
				var lv = 0;
				if ( Mgr.skill.skillInfos.Get(ids[i]) ){
                    Filter.UnGray(imgMode);
					lv = Mgr.skill.skillInfos.Get(ids[i]).FullLevel();
                    this.lvLabelArr[i].setVisible(true);
					if(lv > 0){
                        this.lvLabelArr[i].SetHtmlText(TextUtil.FormatStr(this.lvLabelArr[i].GetHtmlText(), [lv]));
					}else {
                        this.lvLabelArr[i].SetHtmlText(TextUtil.FormatStr(this.lvLabelArr[i].GetHtmlText(), [0]));
					}
				}else {
					this.lvLabelArr[i].setVisible(false);
					Filter.GrayScale(imgMode);
				}
				if ( !Mgr.skill.ShortMetarial( ids[i], lv ) ) {
					if ( !imgMode.warn ) {
						// 可镶嵌
						var icon = new MUILabel();
						icon.ParseJson(this.labkUp.jsonobj);
						icon.Init();
						icon.setPosition(this.labkUp.getPosition());
						imgMode.addChild(icon, 1, 20);
						icon.EnableOutline(0x295d1d,2);
						imgMode.warn = icon;
					}
					imgMode.warn.visible = true;
					if ( lv == 0 )
						imgMode.warn.SetString("可激活");
					else
						imgMode.warn.SetString("可升级");
				}
				else {
					if ( imgMode.warn )
						imgMode.warn.visible = false;
				}

				// callback
				this.skillArry[i].skillId = ids[i];
				this.skillArry[i].setTouchEnabled(true);
				this.skillArry[i].addTouchEventListener(function (sender, type) {
					if (type == ccui.Widget.TOUCH_ENDED) {
						var panel = Mgr.uiMgr.GetPanelByType(SkillPanelExt.PanelName)
						if (panel) {
							var page = panel.panelMgr[SkillPanelType.PANEL_STATIC];
							if ( page ) {
								if (page._curSelectItem && page._curSelectItem.effect)
									page._curSelectItem.effect.visible = false;
								page._curSelectItem = sender;
								page._SetClickItem();
							}
						}
					}
				});
			}
		}
	},

	_SetClickItem:function ( ) {
		if ( !this._curSelectItem.effect ) {
			var imgEffect = new MUIImage();
			imgEffect.ParseJson(this.imgSelect.jsonobj);
			imgEffect.Init();
			imgEffect.x = this.imgSelect.x + 11;
			imgEffect.y = this.imgSelect.y + 11;
			this._curSelectItem.parent.addChild(imgEffect, 0, 10);
			this._curSelectItem.effect = imgEffect;
		}
		this._curSelectItem.effect.visible = true;
		this._curSelectItem.reorderChild(this._curSelectItem.effect, 3);

		// set info
		var mid = this._curSelectItem.skillId;
		this._SetSkillInfo( mid );
	},

	_SetSkillInfo:function ( mid ) {
		var skill_public = Q_skill_public.Get(mid);
		cc.assert(null != skill_public, "Q_skill_public Item can't be nil!  mid: " + mid);

		var curLevel = 0;
		// 判断技能是否激活
		var isLearn = false;
		var msgData = Mgr.skill.skillInfos.Get(mid);
		if (msgData) {
			isLearn = true;
			curLevel =  msgData.FullLevel()
		}

		// 0级不存在与配置中
		var id_level = mid + "_" + curLevel;
		if ( curLevel <= 0 )
			id_level = mid + "_1";

		var skill_model = Q_skill_model.Get(id_level);
		cc.assert(null != skill_model, "Q_skill_model Item can't be nil!  id_level: " + id_level);

		// icon
		var url = "other/zhujiemian/btn/skill/";
		url += mid.toString() + ".png";
		// // 根据职业获取url
		// var job = Q_skill_public.Get(mid).q_job;
		// if ( job == 0 )
		// 	url += "_common/" + mid.toString() + ".png";
		// else {
		// 	url += (job == 1 ? "_nan/" : "_nv/") + mid.toString() + ".png";
		// }
		var imgMode = this.imgIcon;
		EngineMgr.uiMgr.GetAsynResByUrl(url, function () {
			imgMode.loadTexture(url, ccui.Widget.PLIST_TEXTURE);
		}, imgMode);

		// name
		var str = skill_model.q_skillName;
		this.labSkillName.SetString(str);

		// type
		str = skill_public.q_tips;
		this.labType1.SetString(str);

		// level
		str = curLevel + "/" + skill_model.q_max_level;
		this.labLevel1.SetString(str);

		// effect
		if (!isLearn) {
			this.btnLearn.setTitleText( "激活" );
			this.labXiaoguo.SetString("");
			this.labZhanli.visible = false;
			this.labIsActive.visible = true;
		}
		else {
			this.btnLearn.setTitleText( "升级" );
			this.labIsActive.visible = false;

			// des
			this.labZhanli.visible = true;
			if (skill_model.q_attribute) {
				var array = [];
				var str1 = ParseUtil.FormatFastJsonStr(skill_model.q_attribute);
				var jsonData = JSON.parse(str1);
				for (var keyStr in jsonData) {
					array.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
				}

				// des
				var strC = skill_model.q_introduce;
				strC=strC.substring(1,strC.length-1);
				var array=strC.split(",");
				this.labXiaoguo.SetString(TextUtil.ConectParam( skill_public.q_desc, array));

				// fight
				var fight_cur = parseInt(skill_model.q_fight_bonus);
				if (fight_cur > 0) {
					this.labZhanli.visible = true;
					this.labZhanli1.SetString(fight_cur);
				}
				else
					this.labZhanli.visible = false;
			}
		}

		// next effect
		if ( skill_model.q_grade >= skill_model.q_max_level ) {
			this.labCailiao.visible = false;
			this.labMaxLevel.visible = true;
			// des
			this.labXiaoguo1.SetString("");
			// fight
			this.labZhanli2.visible = false;
		}
		else {
			this.labCailiao.visible = true;
			this.labMaxLevel.visible = false;

			var nextLv = curLevel + 1;
			var next_id_level = mid + "_" + nextLv;
			var next_skill_model = Q_skill_model.Get(next_id_level);
			cc.assert(null != next_skill_model, "Q_skill_model Item can't be nil!  next_id_level: " + next_id_level);

			// 材料
			var metrial_id = next_skill_model.q_upgrade_item;
			var q_item = Q_item.Get(metrial_id);
			cc.assert(null != q_item, "Q_item Item can't be nil!  metrial_id: " + metrial_id);
			var metrialName = q_item.q_name;
			var metrialNeedNum = next_skill_model.q_upgrade_item_num;
			str = metrialName + " X" + metrialNeedNum;
			this.labCailiao1.SetString(str);

			// 附上升级所需条件
			if (Mgr.backpack.GetItemNumber(metrial_id, true) < metrialNeedNum) {
				this.labCailiao1.SetColor("0xEE0000");
				this._curSelectItem.metrialShort = true;
			}
			else {
				this.labCailiao1.SetColor("0x5abb5c");
				this._curSelectItem.metrialShort = false;
			}

			this._curSelectItem.levelShort = true;
			if ( Mgr.player.mainPlayer.attributeData.level >= skill_model.q_level_up )
				this._curSelectItem.levelShort = false;

			// attr
			if (next_skill_model.q_attribute) {
				var array = [];
				var str1 = ParseUtil.FormatFastJsonStr(next_skill_model.q_attribute);
				var jsonData = JSON.parse(str1);
				for (var keyStr in jsonData) {
					array.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
				}

				var strC = next_skill_model.q_introduce;
				strC=strC.substring(1,strC.length-1);
				var array=strC.split(",");
				this.labXiaoguo1.SetString(TextUtil.ConectParam( skill_public.q_desc, array));
			}
			// fight
			var fight_next = parseInt(next_skill_model.q_fight_bonus);
			if (fight_next > 0) {
				this.labZhanli2.visible = true;
				this.labZhanli21.SetString(fight_next);
			}
			else {
				this.labZhanli2.visible = false;
			}
		}
	},

	_GetSkillAttrStr:function (type) {
		var typeStr = null;
		if (type == EnumAttribute.MAX_BASEHP)
			typeStr = "气血";
		else if (type == EnumAttribute.ATTACK)
			typeStr = "攻击";
		else if (type == EnumAttribute.DEFEND)
			typeStr = "防御";
		else if (type == EnumAttribute.HIT)
			typeStr = "命中";
		else if (type == EnumAttribute.DODGE)
			typeStr = "闪避";
		else if (type == EnumAttribute.CRIT)
			typeStr = "暴击";
		else if (type == EnumAttribute.ANTI_CRIT)
			typeStr = "抗暴击";

		return typeStr;
	},

} );
SkillStaticPanelExt.PanelName = "SkillStaticPanelExt";
PanelClassDic["SkillStaticPanelExt"] = SkillStaticPanelExt;
