///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//SpecialInfo 太极特权信息
//SpecialDataInfo 整个太极特权信息

// 请求消息
//190201,ReqSpecialDataInfoToGame 请求获取太极特权信息
//190202,ReqBuySpecialToGame 购买太极特权
//190203,ReqGetSpecialAwardToGame 领取当日太极特权奖励

// 接收消息
//190101,ResSpecialDataInfoToClient 发送整个太极特权信息


var SpecialInfo = cc.Class.extend({
	ctor:function(){
		this.type = 0; // 太极特权类型
        this.time = 0; // 剩余时间（秒）
        this.state = 0; // 今日领取状态(0不可领取 1可以领取 2已经领取)
	},

	writing:function( _buf ){
		_buf.WriteByte(this.type);
        _buf.WriteVarInt(this.time);
        _buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
		this.type = _buf.ReadByte();
        this.time = _buf.ReadVarInt();
        this.state = _buf.ReadByte();
	},
});
var SpecialDataInfo = cc.Class.extend({
	ctor:function(){
		this.infoList = []; // 单个太极特权列表 SpecialInfo
	},

	writing:function( _buf ){
		_buf.WriteShort( this.infoList.length );
        for (var i = 0; i < this.infoList.length; i++) {
            _buf.WriteBean(this.infoList[i]);
        }
	},
	
	reading:function( _buf ){
		var infoList_length = _buf.ReadShort();
        for (var i = 0; i < infoList_length; i++) {
            this.infoList[i] = _buf.ReadBean(SpecialInfo);
        }
	},
});
////////////////////
// 发送整个太极特权信息 //
////////////////////
var ResSpecialDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.specialDataInfo = null; // 整个太极特权信息
	},

	getId:function(){
		return 190101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.specialDataInfo);
	},
	
	reading:function( _buf ){
        this.specialDataInfo = _buf.ReadBean(SpecialDataInfo);
	},

	action:function(){
		Mgr.special.RecvResSpecialDataInfoToClientMessage(this);
	},

});
////////////////////
// 请求获取太极特权信息 //
////////////////////
var ReqSpecialDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 190201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 购买太极特权 //
////////////////////
var ReqBuySpecialToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 太极特权类型（0全部购买1是绿砖2是紫砖3是皇砖）
	},

	getId:function(){
		return 190202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 领取当日太极特权奖励 //
////////////////////
var ReqGetSpecialAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 太极特权类型（1是绿砖2是紫砖3是皇砖）
	},

	getId:function(){
		return 190203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadByte();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(190101, ResSpecialDataInfoToClientMessage);

