///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//StallGoodsInfo 摊位物品信息
//StallInfo 摊位信息
//StallLogInfo 摊位单个交易日志
//StallItemPriceInfo 摊位道具最低单价和最近售价信息

// 请求消息
//142201,ReqStallGoodsOpen 请求打开摊位商品信息列表
//142202,ReqStallInfo 点击某个摊位，进行看摊
//142203,ReqStallADDGoods 商品上架
//142204,ReqStallDeleteGoods 商品下架
//142205,ReqStallChangeGoods 商品调整
//142206,ReqStallBuy 购买商品
//142207,ReqChangeStallName 修改摊位名字
//142208,ReqStallSearch 摊位搜索
//142209,ReqLookStallLog 查看摊位交易日志
//142210,ReqStallItemPrice 请求摊位道具最低单价和最近售价信息

// 接收消息
//142101,ResStallGoods 发送摊位商品信息列表
//142102,ResStallInfo 发送人物摊位信息（查看，购买后更新，上下架，摊位信息更新 都用这个）
//142103,ResChangeStallName 修改摊位名字
//142104,ResStallGoodsSearch 摊位搜索结果
//142105,ResLookStallLog 个人摊位交易日志
//142106,ResStallItemPrice 发送摊位道具最低单价和最近售价信息


var StallGoodsInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 所属摊主ID
        this.playerName = null; // 摊主名
        this.goodsIndex = 0; // 商品索引
        this.gold = 0; // 元宝价格
        this.time = null; // 上架时间
        this.iteminfo = null; // 出售的道具信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteVarInt(this.goodsIndex);
        _buf.WriteVarInt(this.gold);
        _buf.WriteLong(this.time);
        _buf.WriteBean(this.iteminfo);
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.goodsIndex = _buf.ReadVarInt();
        this.gold = _buf.ReadVarInt();
        this.time = _buf.ReadLong();
        this.iteminfo = _buf.ReadBean(ItemInfo);
	},
});
var StallInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 角色Id
        this.playerName = null; // 角色名
        this.stallName = null; // 摊位名字
        this.stallIndex = 0; // 摊位索引
        this.stallgoodsinfo = []; // 摊位物品信息列表 StallGoodsInfo
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteString(this.stallName);
        _buf.WriteVarInt(this.stallIndex);
        _buf.WriteShort( this.stallgoodsinfo.length );
        for (var i = 0; i < this.stallgoodsinfo.length; i++) {
            _buf.WriteBean(this.stallgoodsinfo[i]);
        }
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.stallName = _buf.ReadString();
        this.stallIndex = _buf.ReadVarInt();
        var stallgoodsinfo_length = _buf.ReadShort();
        for (var i = 0; i < stallgoodsinfo_length; i++) {
            this.stallgoodsinfo[i] = _buf.ReadBean(StallGoodsInfo);
        }
	},
});
var StallLogInfo = cc.Class.extend({
	ctor:function(){
		this.playerId = null; // 交易者ID
        this.name = null; // 交易者名字
        this.type = 0; // 交易类型，0出售，1购买
        this.time = 0; // 交易时间（秒）
        this.gold = 0; // 元宝价格
        this.exp = 0; // 获得经验
        this.taxGold = 0; // 交易税
        this.iteminfo = null; // 交易的道具信息
	},

	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteString(this.name);
        _buf.WriteByte(this.type);
        _buf.WriteVarInt(this.time);
        _buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.taxGold);
        _buf.WriteBean(this.iteminfo);
	},
	
	reading:function( _buf ){
		this.playerId = _buf.ReadLong();
        this.name = _buf.ReadString();
        this.type = _buf.ReadByte();
        this.time = _buf.ReadVarInt();
        this.gold = _buf.ReadVarInt();
        this.exp = _buf.ReadVarInt();
        this.taxGold = _buf.ReadVarInt();
        this.iteminfo = _buf.ReadBean(ItemInfo);
	},
});
var StallItemPriceInfo = cc.Class.extend({
	ctor:function(){
		this.minPrices = []; // 其他玩家正在出售的最低单价前3名 int
        this.lastPrice = 0; // 最近成交单价
	},

	writing:function( _buf ){
		_buf.WriteShort( this.minPrices.length );
        for (var i = 0; i < this.minPrices.length; i++) {
            _buf.WriteVarInt(this.minPrices[i]);
        }
        _buf.WriteVarInt(this.lastPrice);
	},
	
	reading:function( _buf ){
		var minPrices_length = _buf.ReadShort();
        for (var i = 0; i < minPrices_length; i++) {
            this.minPrices[i] = _buf.ReadVarInt();
        }
        this.lastPrice = _buf.ReadVarInt();
	},
});
////////////////////
// 发送摊位商品信息列表 //
////////////////////
var ResStallGoodsMessage = cc.Class.extend( {
	ctor:function(){
		this.maxType = 0; // 商品大类型
        this.minType = 0; // 商品小类型
        this.indexStart = 0; // 索引起点
        this.indexEnd = 0; // 索引终点
        this.searchType = 0; // 搜索类型(1是名字模糊搜索，2是类型搜索)
        this.stallGoodsInfoList = []; // 摊位商品信息列表 StallGoodsInfo
	},

	getId:function(){
		return 142101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.maxType);
        _buf.WriteVarInt(this.minType);
        _buf.WriteVarInt(this.indexStart);
        _buf.WriteVarInt(this.indexEnd);
        _buf.WriteByte(this.searchType);
        _buf.WriteShort( this.stallGoodsInfoList.length );
        for (var i = 0; i < this.stallGoodsInfoList.length; i++) {
            _buf.WriteBean(this.stallGoodsInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        this.maxType = _buf.ReadVarInt();
        this.minType = _buf.ReadVarInt();
        this.indexStart = _buf.ReadVarInt();
        this.indexEnd = _buf.ReadVarInt();
        this.searchType = _buf.ReadByte();
        var stallGoodsInfoList_length = _buf.ReadShort();
        for (var i = 0; i < stallGoodsInfoList_length; i++) {
            this.stallGoodsInfoList[i] = _buf.ReadBean(StallGoodsInfo);
        }
	},

	action:function(){
		Mgr.stall.RecvResStallGoodsMessage(this);
	},

});
////////////////////
// 发送人物摊位信息（查看，购买后更新，上下架，摊位信息更新 都用这个） //
////////////////////
var ResStallInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.stallInfo = null; // 摊位详细信息
	},

	getId:function(){
		return 142102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.stallInfo);
	},
	
	reading:function( _buf ){
        this.stallInfo = _buf.ReadBean(StallInfo);
	},

	action:function(){
		Mgr.stall.RecvResStallInfoMessage(this);
	},

});
////////////////////
// 修改摊位名字 //
////////////////////
var ResChangeStallNameMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 摊位名字
        this.status = 0; // 修改结果，0成功1失败
	},

	getId:function(){
		return 142103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
        _buf.WriteByte(this.status);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
        this.status = _buf.ReadByte();
	},

	action:function(){
		Mgr.stall.RecvResChangeStallNameMessage(this);
	},

});
////////////////////
// 摊位搜索结果 //
////////////////////
var ResStallGoodsSearchMessage = cc.Class.extend( {
	ctor:function(){
		this.stallGoodsInfoList = []; // 摊位商品信息列表 StallGoodsInfo
	},

	getId:function(){
		return 142104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.stallGoodsInfoList.length );
        for (var i = 0; i < this.stallGoodsInfoList.length; i++) {
            _buf.WriteBean(this.stallGoodsInfoList[i]);
        }
	},
	
	reading:function( _buf ){
        var stallGoodsInfoList_length = _buf.ReadShort();
        for (var i = 0; i < stallGoodsInfoList_length; i++) {
            this.stallGoodsInfoList[i] = _buf.ReadBean(StallGoodsInfo);
        }
	},

	action:function(){
		Mgr.stall.RecvResStallGoodsSearchMessage(this);
	},

});
////////////////////
// 个人摊位交易日志 //
////////////////////
var ResLookStallLogMessage = cc.Class.extend( {
	ctor:function(){
		this.stallLogList = []; // 摊位交易日志列表 StallLogInfo
	},

	getId:function(){
		return 142105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.stallLogList.length );
        for (var i = 0; i < this.stallLogList.length; i++) {
            _buf.WriteBean(this.stallLogList[i]);
        }
	},
	
	reading:function( _buf ){
        var stallLogList_length = _buf.ReadShort();
        for (var i = 0; i < stallLogList_length; i++) {
            this.stallLogList[i] = _buf.ReadBean(StallLogInfo);
        }
	},

	action:function(){
		Mgr.stall.RecvResLookStallLogMessage(this);
	},

});
////////////////////
// 发送摊位道具最低单价和最近售价信息 //
////////////////////
var ResStallItemPriceMessage = cc.Class.extend( {
	ctor:function(){
		this.stallItemPriceInfo = null; // 最低单价和最近售价信息
	},

	getId:function(){
		return 142106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.stallItemPriceInfo);
	},
	
	reading:function( _buf ){
        this.stallItemPriceInfo = _buf.ReadBean(StallItemPriceInfo);
	},

	action:function(){
		Mgr.stall.RecvResStallItemPriceMessage(this);
	},

});
////////////////////
// 请求打开摊位商品信息列表 //
////////////////////
var ReqStallGoodsOpenMessage = cc.Class.extend( {
	ctor:function(){
		this.maxType = 0; // 商品大类型
        this.minType = 0; // 商品小类型
        this.indexStart = 0; // 商品索引起点
        this.indexEnd = 0; // 商品索引终点
	},

	getId:function(){
		return 142201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.maxType);
        _buf.WriteVarInt(this.minType);
        _buf.WriteVarInt(this.indexStart);
        _buf.WriteVarInt(this.indexEnd);
	},
	
	reading:function( _buf ){
        this.maxType = _buf.ReadVarInt();
        this.minType = _buf.ReadVarInt();
        this.indexStart = _buf.ReadVarInt();
        this.indexEnd = _buf.ReadVarInt();
	},

});
////////////////////
// 点击某个摊位，进行看摊 //
////////////////////
var ReqStallInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 摆摊的玩家ID
	},

	getId:function(){
		return 142202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
	},

});
////////////////////
// 商品上架 //
////////////////////
var ReqStallADDGoodsMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsId = null; // 道具唯一ID
        this.gold = 0; // 元宝价格
        this.num = 0; // 上架的道具数量
	},

	getId:function(){
		return 142203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.goodsId);
        _buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.goodsId = _buf.ReadLong();
        this.gold = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},

});
////////////////////
// 商品下架 //
////////////////////
var ReqStallDeleteGoodsMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsId = null; // 道具唯一ID
	},

	getId:function(){
		return 142204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.goodsId);
	},
	
	reading:function( _buf ){
        this.goodsId = _buf.ReadLong();
	},

});
////////////////////
// 商品调整 //
////////////////////
var ReqStallChangeGoodsMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsId = null; // 道具唯一ID
        this.oldGold = 0; // 原始元宝价格
        this.oldNum = 0; // 原始数量（只是用来检测，后端另有验证）
        this.newGold = 0; // 新的元宝价格
	},

	getId:function(){
		return 142205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.goodsId);
        _buf.WriteVarInt(this.oldGold);
        _buf.WriteVarInt(this.oldNum);
        _buf.WriteVarInt(this.newGold);
	},
	
	reading:function( _buf ){
        this.goodsId = _buf.ReadLong();
        this.oldGold = _buf.ReadVarInt();
        this.oldNum = _buf.ReadVarInt();
        this.newGold = _buf.ReadVarInt();
	},

});
////////////////////
// 购买商品 //
////////////////////
var ReqStallBuyMessage = cc.Class.extend( {
	ctor:function(){
		this.playerId = null; // 摆摊的玩家ID
        this.goodsIndex = 0; // 商品索引(验证用)
        this.gold = 0; // 商品元宝价格
        this.num = 0; // 商品数量(验证用)
        this.goodsId = null; // 商品道具唯一ID
	},

	getId:function(){
		return 142206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteLong(this.playerId);
        _buf.WriteVarInt(this.goodsIndex);
        _buf.WriteVarInt(this.gold);
        _buf.WriteVarInt(this.num);
        _buf.WriteLong(this.goodsId);
	},
	
	reading:function( _buf ){
        this.playerId = _buf.ReadLong();
        this.goodsIndex = _buf.ReadVarInt();
        this.gold = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
        this.goodsId = _buf.ReadLong();
	},

});
////////////////////
// 修改摊位名字 //
////////////////////
var ReqChangeStallNameMessage = cc.Class.extend( {
	ctor:function(){
		this.name = null; // 摊位名字
	},

	getId:function(){
		return 142207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.name);
	},
	
	reading:function( _buf ){
        this.name = _buf.ReadString();
	},

});
////////////////////
// 摊位搜索 //
////////////////////
var ReqStallSearchMessage = cc.Class.extend( {
	ctor:function(){
		this.goodsName = null; // 道具名称
        this.isDefaultSearch = 0; // 是否是打开面板首次默认搜索 1是0不是
	},

	getId:function(){
		return 142208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.goodsName);
        _buf.WriteByte(this.isDefaultSearch);
	},
	
	reading:function( _buf ){
        this.goodsName = _buf.ReadString();
        this.isDefaultSearch = _buf.ReadByte();
	},

});
////////////////////
// 查看摊位交易日志 //
////////////////////
var ReqLookStallLogMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 142209;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求摊位道具最低单价和最近售价信息 //
////////////////////
var ReqStallItemPriceMessage = cc.Class.extend( {
	ctor:function(){
		this.modelId = 0; // 道具模板ID
	},

	getId:function(){
		return 142210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.modelId);
	},
	
	reading:function( _buf ){
        this.modelId = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(142101, ResStallGoodsMessage);
MESSAGE_POOL.Add(142102, ResStallInfoMessage);
MESSAGE_POOL.Add(142103, ResChangeStallNameMessage);
MESSAGE_POOL.Add(142104, ResStallGoodsSearchMessage);
MESSAGE_POOL.Add(142105, ResLookStallLogMessage);
MESSAGE_POOL.Add(142106, ResStallItemPriceMessage);

