///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//StepDataInfo 步步高升信息

// 请求消息
//148201,ReqStepDataInfoToGame 获取步步高升信息
//148202,ReqThrowToGame 投掷骰子

// 接收消息
//148101,ResStepDataInfoToClient 发送步步高升信息
//148102,ResThrowResultToClient 发送投掷骰子结果


var StepDataInfo = cc.Class.extend({
	ctor:function(){
		this.boxId = 0; // 当前格子ID
        this.layer = 0; // 当前层数
        this.doubleFlage = 0; // 下一次投掷奖励是否翻倍（1是翻倍）
        this.awardInfos = []; // 当前层的所有奖励信息(索引0对应格子ID的1),如果TempItem的ID为888那么表示双倍 TempItemInfo
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.boxId);
        _buf.WriteVarInt(this.layer);
        _buf.WriteVarInt(this.doubleFlage);
        _buf.WriteUShort( this.awardInfos.length );
        for (var i = 0; i < this.awardInfos.length; i++) {
            _buf.WriteBean(this.awardInfos[i]);
        }
	},
	
	reading:function( _buf ){
		this.boxId = _buf.ReadVarInt();
        this.layer = _buf.ReadVarInt();
        this.doubleFlage = _buf.ReadVarInt();
        var awardInfos_length = _buf.ReadUShort();
        for (var i = 0; i < awardInfos_length; i++) {
            this.awardInfos[i] = _buf.ReadBean(TempItemInfo);
        }
	},
});
////////////////////
// 发送步步高升信息 //
////////////////////
var ResStepDataInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.stepDataInfo = null; // 步步高升信息
	},

	getId:function(){
		return 148101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.stepDataInfo);
	},
	
	reading:function( _buf ){
        this.stepDataInfo = _buf.ReadBean(StepDataInfo);
	},

	action:function(){
		Mgr.step.RecvResStepDataInfoToClientMessage(this);
	},

});
////////////////////
// 发送投掷骰子结果 //
////////////////////
var ResThrowResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.num = 0; // 投掷的点数（1-6）
        this.boxId = 0; // 当前格子ID
        this.layer = 0; // 当前层数
        this.awardInfo = null; // 奖励
	},

	getId:function(){
		return 148102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.num);
        _buf.WriteVarInt(this.boxId);
        _buf.WriteVarInt(this.layer);
        _buf.WriteBean(this.awardInfo);
	},
	
	reading:function( _buf ){
        this.num = _buf.ReadVarInt();
        this.boxId = _buf.ReadVarInt();
        this.layer = _buf.ReadVarInt();
        this.awardInfo = _buf.ReadBean(TempItemInfo);
	},

	action:function(){
		Mgr.step.RecvResThrowResultToClientMessage(this);
	},

});
////////////////////
// 获取步步高升信息 //
////////////////////
var ReqStepDataInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 148201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 投掷骰子 //
////////////////////
var ReqThrowToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 148202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(148101, ResStepDataInfoToClientMessage);
MESSAGE_POOL.Add(148102, ResThrowResultToClientMessage);

