var ZoneTaskTrackPanelExt = MUIPanel.extend({
    _className: "ZoneTaskTrackPanelExt",

    timerId: 0,
    numAllMonster: 0,
    dirty : true,

    ctor: function(parent) {
        this._super();

        this.mapLables = {};
        this.arrLabels = [];
        this.arrLablesCache = [];

        this.width = parent.width;
        this.height = parent.height;

        var labTitle = new MUILabel();
        labTitle.x = 5;
        labTitle.y = this.height - 30;
        labTitle.SetFontSize(22);
        labTitle.SetColor("0xf2a757");

        //labTitle.SetText("#副本名字");
        this.addChild(labTitle);
        this.labTitle = labTitle;


        this.confMap = Q_map.Get(Mgr.sceneMap.nMapId);
        this.zoneType = Mgr.sceneMap.ZoneType();

        labTitle.SetText("[" + this.confMap.q_map_name + "]");
    },
    onEnter: function() {
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 0.1);

        this.OnTimer();
    },
    onExit: function() {
        this._super();
        if (this.timerId != 0) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },


    Init: function() {
        this._super();
    },

    CreateBossLabel: function(id,obj) {
        var label = this.mapLables[id];
        if (!label) {
            if (this.arrLablesCache.length > 0) {
                label = this.arrLablesCache.pop();
                this.mapLables[id] = label;
            } else {
                label = new MUILabel();
                label.x = 5;
                this.addChild(label);

                this.mapLables[id] = label;
            }

            label.__id = id;
            this.arrLabels.push(label);

            label.setTouchEnabled(true);
            label.addClickEventListener(function(){
                Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(Mgr.sceneMap.nMapId, obj.oServPt, AutoPathParam.CreateAutoFight());
            });
            this.dirty = true;
        }

        label.visible = true;
        return label;
    },
    HasBossLabel: function(id) {
        return this.mapLables[id];
    },
    RecycleBossLabel: function(id) {
        if (this.mapLables[id]) {
            this.mapLables[id].visible = false;
            this.arrLablesCache.push(this.mapLables[id]);
            this.mapLables[id] = null;

            for (var list = this.arrLabels, k = 0, length = list.length, v = list[k]; k < length; v = list[++k]) {
                if (v.__id == id) {
                    list.splice(k, 1);
                }
            }
        }

        this.dirty = true;
    },

    OnTimer: function() {
        // update exp zone name
        if (this.zoneType == EnumZoneType.TYPE_JY &&
            Mgr.zone.jingyanDeployNum != this.numExpZoneWave &&
            Mgr.zone.jingyanDeployNum != 0) {
            this.numExpZoneWave = Mgr.zone.jingyanDeployNum;
            this.labTitle.SetText("[" + this.confMap.q_map_name + "]" + "第" + this.numExpZoneWave + "波");
        }

        var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
        var numAliveMonster = 0,
            numAliveBoss = 0,
            monsterPos;

        for (var i = 0, v = list[i], length = list.length; i < length; v = list[++i]) {
            if (v.IsBoss()) {
                if (!v.IsDeadState()) numAliveBoss++;
            } else {
                if (!v.IsDeadState()) {
                    numAliveMonster++;
                    if (!monsterPos) monsterPos = v.oServPt;
                }
            }
        }
        var dirty = false;
        var showBoss = false;
        // 删除老的BOSS
        for (var arr = this.arrLabels, k = 0, length = arr.length, v = arr[k]; k < length; v = arr[++k]) {
            var hasBoss = false;
            for (i = 0, vv = list[i]; i < list.length; vv = list[++i]) {
                if(v.__id == vv.nGid){
                    hasBoss = true;
                    break;
                }
            }
            // 刷小怪了，说明这个不是最终boss，删掉
            if(!hasBoss && v.__id != "__monster" && (numAliveBoss > 0 || numAliveMonster > 0)){
                arr.splice(k, 1);
                if(this.mapLables[v.__id ]){
                    this.mapLables[v.__id ].visible = false;
                    this.arrLablesCache.push(this.mapLables[v.__id ]);
                    this.mapLables[v.__id ] = null;
                }
            }
        }

        // create Boss labels,
        for (i = 0, v = list[i],length = list.length; i < length; v = list[++i]) {
            if (!v.IsBoss()) continue;
            if (v.IsDeadState()) {
                //刷小怪了，说明这个不是最终boss，删掉
                if (numAliveBoss > 0 || numAliveMonster > 0) {
                    this.RecycleBossLabel(v.nGid);
                } else {
                    showBoss = true;
                    // update boss killed status
                    var label = this.HasBossLabel(v.nGid);
                    if (label) {
                        var bossName = Q_monster.Get(v.nBodyModelId).q_name;
                        label.SetText(TextUtil.AddColor("击败首领", "ececec") +"<u>"+ TextUtil.AddColor(bossName + "</u>(1/1)", "76fd56"));
                        label.setTouchEnabled(false);
                    }
                }
            } else {
                showBoss = true;
                if(!this.HasBossLabel(v.nGid)){
                    var label = this.CreateBossLabel(v.nGid,v);
                    var bossName = Q_monster.Get(v.nBodyModelId).q_name;
                    label.SetText(TextUtil.AddColor("击败首领", "ececec") +"<u>"+ TextUtil.AddColor(bossName + "</u>(0/1)", "76fd56"));
                }
            }
        }

        // if showBoss then hide the monster label.
        if (showBoss) {
            this.RecycleBossLabel("__monster")
        } else {
            if (numAliveMonster > this.numAllMonster) {
                this.numAllMonster = numAliveMonster;
            } else if (numAliveMonster == 0 && this.zoneType != EnumZoneType.TYPE_JY) {
                this.numAllMonster = 0;
            }

            if (numAliveMonster > 0) {
                var label = this.HasBossLabel("__monster");
                if(!label){
                    label = this.CreateBossLabel("__monster");
                }
                var text = TextUtil.AddColor("击败", "ececec")
                        + TextUtil.AddColor("所有目标(" + (this.numAllMonster - numAliveMonster) + "/" + this.numAllMonster + ")", "76fd56")
                label.SetText(text);

                label.setTouchEnabled(true);
                label.addClickEventListener(function(){
                    Mgr.mainPlayer.oCtrlAutoPath.RunToPt(monsterPos, AutoPathParam.CreateAutoFight(), true);
                });

            } else if (numAliveMonster == 0) {
                //text = TextUtil.AddColor("击败", "ececec") +
                //    TextUtil.AddColor("所有目标(" + this.numAllMonster + "/" + this.numAllMonster + ")", "76fd56")
                this.RecycleBossLabel("__monster");
            }
        }

        if(!this.dirty) return;
        this.dirty = false;

        var height = Math.max(80,40 + this.arrLabels.length * 35);
        this.height = height;
        this.parent.height = height;
        this.labTitle.y = height - 30;
        for(var list = this.arrLabels,length=list.length,k=0,v=list[length - k - 1];k<length;v=[length - 1- ++k]){
            v.y = 10 + k * 35;
        }
    },

    UpdateView:function(){

    },

});
ZoneTaskTrackPanelExt.PanelName = "ZoneTaskTrackPanelExt";
PanelClassDic["ZoneTaskTrackPanelExt"] = ZoneTaskTrackPanelExt;

var WorldBossTaskTrackPanelExt = MUIPanel.extend({
    _className: "WorldBossTaskTrackPanelExt",

    ctor: function(parent) {
        this._super();

        parent.height = 80;

        this.width = parent.width;
        this.height = parent.height;

        var labTitle = new MUILabel();
        labTitle.x = 5;
        labTitle.y = this.height - 30;
        labTitle.SetFontSize(22);
        labTitle.SetColor("0xf2a757");
        this.addChild(labTitle);
        labTitle.SetText("")

        this.labTitle = labTitle;

        this.UpdateView();
    },
    Init: function() {
        this._super();
    },
    onEnter: function() {
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },
    onExit: function() {
        this._super();
        if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    OnTimer:function(){
        var list = Mgr.sceneObj.oRoundMonsterList.oHashList.aList;
        for (var i = 0, v = list[i], length = list.length; i < length; v = list[++i]) {
            if (v.IsBoss()) {
                if (!v.IsDeadState()) break;
            }
        }
        if (this._bossInfo != v) {
            this._bossInfo = v;
            if(this._bossInfo){
                this.confBoss = Q_monster.Get(this._bossInfo.nBodyModelId);
                this.UpdateBossInfo();
                return true;
            }
        }
    },
    UpdateView: function() {
        this.confBoss = null;
        this._bossInfo = null;

        if(!this.OnTimer()){
            this.setTouchEnabled(false);
            this.labTitle.SetText(TextUtil.AddColor("已完成挑战",ColorUtil.N_GREEN_STR));
        }
    },
    UpdateBossInfo:function(){
        var name = this.confBoss && this.confBoss.q_name || "???";
        var num = this._bossInfo && !this._bossInfo.IsDeadState() ? 0 : 1;
        this.labTitle.SetText("[挑战]<u>" + name + "</u>(" + num + "/1)");

        this.setTouchEnabled(true);
        this.addClickEventListener(function(){
            if(this._bossInfo && !this._bossInfo.IsDeadState()){
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(this._bossInfo.oServPt, AutoPathParam.CreateAutoFight(), true);
            }
        }.bind(this));
    },
});
WorldBossTaskTrackPanelExt.PanelName = "WorldBossTaskTrackPanelExt";
PanelClassDic["WorldBossTaskTrackPanelExt"] = WorldBossTaskTrackPanelExt;

var GuardCapitalTaskTrackPanelExt = MUIPanel.extend({
    _className: "GuardCapitalTaskTrackPanelExt",


    timerId:0,
    ctor: function(parent,taskPanel) {
        this._super();

        this.taskPanel = taskPanel;
        this.labTrackList = [];
//        parent.height = 80;

        this.width = parent.width;
        this.height = parent.height;

        var labTitle = new MUILabel();
        labTitle.x = 5;
        labTitle.y = this.height - 30;
        labTitle.SetFontSize(22);
        labTitle.SetColor("0xf2a757");
        this.addChild(labTitle);
        labTitle.SetText("[活动] 京城守卫");

        var labIndex = new MUILabel();
        labIndex.x = 5;
        labIndex.y = this.height - 60;
        labIndex.SetFontSize(22);
        labIndex.SetColor("0xf2a757");
        this.addChild(labIndex);
        this.labIndex = labIndex;


        var labTimeTotal = new MUILabel();
        labTimeTotal.x = 5;
        labTimeTotal.y = 35;
        labTimeTotal.SetFontSize(18);
        labTimeTotal.SetColor("0xf2a757");
        this.addChild(labTimeTotal);
        this.labTimeTotal = labTimeTotal;

        var labTimeNext = new MUILabel();
        labTimeNext.x = 5;

        labTimeNext.SetFontSize(18);
        labTimeNext.SetColor("0xf2a757");
        this.addChild(labTimeNext);
        this.labTimeNext = labTimeNext;

        this.UpdateView();
    },
    Init:function(){
        this._super();

    },
    onEnter: function() {
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },
    onExit: function() {
        this._super();
        if (this.timerId != 0) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    OnTimer:function(){
        var serverTime = Mgr.login.GetServerTime()/1000;
        var nextTime = Mgr.guardcpital.__nextRoundTime - serverTime;
        //var totalTime = Mgr.guardcpital.__endTime - serverTime;
        var data = Mgr.guardcpital.CheckActivityIsOpen()

        if(!data){
            this.taskPanel.UpdateView();
            return;
        }

         var totalTime = data.startTime + data.endTime - serverTime;

        if(nextTime < 0){
            this.labTimeNext.visible = false;
        }else{
            this.labTimeNext.visible = true;
            this.labTimeNext.SetText( "下一波刷新：" + TextUtil.SecondToHMS2( nextTime));
        }

        if(totalTime < 0){
            this.labTimeTotal.visible = false;
        }else{
            this.labTimeTotal.visible = true;
            this.labTimeTotal.SetText( "活动倒计时：" + TextUtil.SecondToHMS2(totalTime));
        }
    },

    UpdateView:function(){
        this.OnTimer();

        var dataMonster = Mgr.guardcpital.GetMonsterConfigHashMap();
        var curRound = Mgr.guardcpital.GetCurrentRound();
        var monsters = Mgr.guardcpital.GetKillTargetList();
        var roundNum = dataMonster.Size();
        this.labIndex.SetText("当前第" + (curRound + 1) + "/" + roundNum + "波")


        var killTarget = dataMonster.Get(curRound);
        var killTargetId = killTarget.Keys();

        var labLength = this.labTrackList.length;
        var dataLength = killTarget.Size();
        var length = Math.max(labLength,dataLength);

        var y = this.labIndex.y;

        for(var k=0;k<length;k++){
            if(k<dataLength){
                var label = this.labTrackList[k];
                if(!label){
                    label = new MUILabel();
                    label.x = 5;
                    label.SetFontSize(22);
                    label.SetColor("0xf2a757");
                    this.addChild(label);

                    this.labTrackList[k] = label;
                }

                var monsterId = killTargetId[k];
                var monster = Q_monster.Get(monsterId);

                var killNum = 0;
                for(var kk=0;kk < monsters.length;++kk){
                    if(monsters[kk] == monsterId){
                        killNum = monsters[kk+ 1] ;
                    }
                    ++kk;
                }

                var needNum = killTarget.Get(monsterId);

                var color = killNum >= needNum ? "76fd56" : "ded8c7";
                label.SetText( "[击杀:<u>" +TextUtil.AddColor(monster.q_name, color) + "</u>](" + killNum+"/" +  needNum +")");
                label.setTouchEnabled(true);
                label.__index = k;
                label.addClickEventListener(function (sender){
                    Mgr.guardcpital.AutoPath2ActivityRange(sender.__index);
                });

                y-=35;
                label.y = y ;

            }else{
                if(this.labTrackList[k]) this.labTrackList[k].visible = false;
            }
        }

        y-=35;
        this.labTimeTotal.y = y;
        y-=35;
        this.labTimeNext.y = y;
    },
});
GuardCapitalTaskTrackPanelExt.PanelName = "GuardCapitalTaskTrackPanelExt";
PanelClassDic["GuardCapitalTaskTrackPanelExt"] = GuardCapitalTaskTrackPanelExt;

var SwordTaskTrackPanelExt = MUIPanel.extend({
    _className: "SwordTaskTrackPanelExt",

    timerId:0,
    ctor: function(parent) {
        this._super();

        this.labTrackList = [];
        // parent.height = 80;

        this.width = parent.width;
        this.height = parent.height;


        this.confLab = [
            { name : "labTitle" , size:22,color:"0xf2a757",},
            { name : "labelScore" , size:22,color:"0xf2a757",},
            { name : "labKillDes" , size:22,color:"0xf2a757",},
            { name : "labNeedKill" , size:22,color:"0xf2a757",},
            { name : "labCapName" , size:22,color:"0xf2a757",},
            { name : "labCapScore" , size:22,color:"0xf2a757",},
        ];

        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30;
            label.SetFontSize(v.size);
            label.SetColor(v.color);
            this.addChild(label);
            this[v.name] = label;

        }

        this.labTitle.SetText("[活动] 华山论剑");
        //        this.UpdateView();
    },

    Init: function() {
        this._super();
    },

    UpdateView: function() {
        var layer = Mgr.sword._curlayer;
        var score = Mgr.sword._myscore;
        var name = Mgr.sword.wangzheName;
        var firstscore = Mgr.sword.wangzheScore;

        if (layer < 3) {
//            this.labelScore.SetText("华山积分：" + score + "/" + TextUtil.AddColor(Mgr.sword.GetNeedScore(), "76fd56"));
            this.labelScore.SetText("华山积分：" + score);
            this.labKillDes.SetText(TextUtil.AddColor("每击杀一人可获得" + Mgr.sword.GetKillOneScore() + "积分", "76fd56"));
            this.labNeedKill.SetText(TextUtil.AddColor("继续击杀" + TextUtil.AddColor(Mgr.sword.NeedKillPlayerNum(), "FE2323") + "人可进入下一层", "76fd56"));

        } else {
            this.labelScore.SetText("华山元宝：" + score + "/" + TextUtil.AddColor(Mgr.sword.GetBindGold(), "76fd56"));
            this.labKillDes.SetText(TextUtil.AddColor("击杀其他玩家和元宝宝箱均可", "76fd56"));
            this.labNeedKill.SetText(TextUtil.AddColor("获得元宝", "76fd56"));

        }

        var showname = (name == null ? "暂无" : name);
        var showScore = (firstscore == null ? "暂无" : firstscore);
        this.labCapName.SetText("今日王者：" + TextUtil.AddColor(showname, "ececec"));
        this.labCapScore.SetText("获得积分：" + TextUtil.AddColor(showScore, "ececec"));


        var height = this.height - 30;
        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            this[v.name].y = height;

            height -= 30;
        }
    },
});
SwordTaskTrackPanelExt.PanelName = "SwordTaskTrackPanelExt";
PanelClassDic["SwordTaskTrackPanelExt"] = SwordTaskTrackPanelExt;

var ErenguTaskTrackPanelExt = MUIPanel.extend({
    _className:"ErenguTaskTrackPanelExt",
    timerId:0,

    labBossList:null,
    listView:null,

    ctor:function(parent){
        this._super();

        this.width = parent.width;
        this.height = parent.height;

        this.labBossList = [];

        this.listView = new ccui.ListView();
        this.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
        this.listView.setTouchEnabled(true);					//触摸开启
        this.listView.inertiaScrollEnabled = true; 			//滚动惯性
        this.listView.setScrollBarEnabled(false);				//滚动条
        this.listView.setBounceEnabled(true);					//边界回弹
        this.listView.addEventListener(this._SelectedItemEvent);
        this.addChild(this.listView);

        this.listView.setSize(cc.size( this.width, this.height));

        this.configLabel = [
            {name:"labTitle", size:22, color:"0xf2a757"},
            {name:"labTime", size:20, color:"0xf2a757"},
        ];

        for(var i = 0; i < this.configLabel.length; i++){
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30 * (i + 1);
            label.SetFontSize(this.configLabel[i].size);
            label.SetColor(this.configLabel[i].color);
            this.listView.addChild(label);
            this[this.configLabel[i].name] = label;
        }

        this.labTitle.SetText("[活动] 恶人谷");
        this.listView.setInnerContainerSize(cc.size(this.width, 2 * 30));
    },

    Init:function(){
        this._super();
    },

    onEnter:function(){
        this._super();
        var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_ERENGU);
        this.endTime = activeInfo.startTime + activeInfo.endTime;
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);

    },

    OnTimer:function(){
        var serverTime = Mgr.login.GetServerTime()/1000;
        var leftTime = this.endTime - serverTime;
        this.labTime.SetText("活动剩余时间: " + TextUtil.AddColor(TextUtil.SecondToHMS2(leftTime), ColorUtil.SYS_RED));
        for(var i = 0; i < this.labBossList.length; i++){
            if(this.labBossList[i].alive <= 0){
                this.labBossList[i].SetText(
                    TextUtil.AddColor(TextUtil.SecondToHMS2(this.labBossList[i].liveTime - Mgr.login.GetServerTime()/1000), ColorUtil.SYS_RED)
                    + "  " + this.labBossList[i].monsterName);
            }
        }
    },

    RefreshBossInfo:function(info){
        var bossInfos = info.bossInfos;
        var self = this;
        for(var i = 0; i < bossInfos.length; i++){
            if(!this.labBossList[i]){
                var label = new MUILabel();
                label.x = 5;
                label.y = this.height - 30 * (i + 3);
                label.SetFontSize(20);
                label.SetColor("0xf2a757");
                this.listView.addChild(label);
                this.labBossList.push(label);
            }
            var monsterInfo = Q_monster.Get(bossInfos[i].modeldId);
            this.labBossList[i].monsterName = monsterInfo.q_name + "(" + monsterInfo.q_grade + ")";
            this.labBossList[i].SetText(this.labBossList[i].monsterName);
            this.labBossList[i].SetTextAlign(cc.TEXT_ALIGNMENT_RIGHT);
            this.labBossList[i].alive = bossInfos[i].alive;
            if(bossInfos[i].alive > 0){
                this.labBossList[i].SetColor(ColorUtil.SYS_RED);
            }
            else{
                this.labBossList[i].liveTime = Mgr.login.GetServerTime()/1000 - bossInfos[i].alive;
                this.labBossList[i].SetText(TextUtil.AddColor(TextUtil.SecondToHMS2(this.labBossList[i].liveTime - Mgr.login.GetServerTime()/1000), ColorUtil.SYS_RED)
                    + "  " + this.labBossList[i].monsterName);
                this.labBossList[i].SetColor(ColorUtil.SYS_GREEN);
            }
            this.labBossList[i].SetUISize(this.width*2/3, 30);
            this.labBossList[i].setContentSize(cc.size(this.width*2/3, 30));
            this.labBossList[i].ignoreContentAdaptWithSize(false);
            this.labBossList[i].info = bossInfos[i];
            (function(i){
                self.labBossList[i].setTouchEnabled(true);
                self.labBossList[i].addTouchEventListener(function(target,state)
                {
                    if(state == ccui.Widget.TOUCH_ENDED)
                    {
                        if(!self.nCurMoveParam)
                            self.nCurMoveParam = new AutoPathParam();
                        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(bossInfos[i].x, bossInfos[i].y), self.nCurMoveParam, true);
                    }
                })
            })(i);
        }
        this.listView.setInnerContainerSize(cc.size(this.width, (bossInfos.length + 2) * 30));
    },

    _SelectedItemEvent:function(sender, type){
        switch (type) {
            case ccui.ListView.ON_SELECTED_ITEM_END:
                var parent = sender.parent;
                if(!parent.nCurMoveParam)
                    parent.nCurMoveParam = new AutoPathParam();
                var idx = sender.getCurSelectedIndex();
                var itemSelect = sender.getItem(idx);
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(itemSelect.info.x, itemSelect.info.y), parent.nCurMoveParam, true);
                break;
            default:
                break;
        }
    },

    UpdateView:function(){

    },

});
ErenguTaskTrackPanelExt.PanelName = "ErenguTaskTrackPanelExt";
PanelClassDic["ErenguTaskTrackPanelExt"] = ErenguTaskTrackPanelExt;

var ZhujiantianxiaTaskTrackPanelExt = MUIPanel.extend({
    _className:"ZhujiantianxiaTaskTrackPanelExt",

    timerId:0,

    labBossList:null,
    listView:null,

    ctor:function(parent){
        this._super();

        this.width = parent.width;
        this.height = parent.height;
        this.labBossList = [];
        this.listView = new ccui.ListView();
        this.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);//视图滚动方向
        this.listView.setTouchEnabled(true);					//触摸开启
        this.listView.inertiaScrollEnabled = true; 			//滚动惯性
        this.listView.setScrollBarEnabled(false);				//滚动条
        this.listView.setBounceEnabled(true);					//边界回弹
        this.listView.addEventListener(this._SelectedItemEvent);
        this.addChild(this.listView);

        this.listView.setSize(cc.size( this.width, this.height));

        this.configLabel = [
            {name:"labTitle", size:22, color:"0xf2a757"},
            {name:"labTime", size:20, color:"0xf2a757"},
        ];

        for(var i = 0; i < this.configLabel.length; i++){
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30 * (i + 1);
            label.SetFontSize(this.configLabel[i].size);
            label.SetColor(this.configLabel[i].color);
            this.listView.addChild(label);
            this[this.configLabel[i].name] = label;
        }

        this.labTitle.SetText("[活动] 铸剑天下");
        this.labTime.SetText("  ");
    },

    onEnter:function(){
        this._super();
        // var activeInfo = Mgr.majorevents.activityHash.Get(EnumZoneActiveType.TYPE_ZHUJIANTIANXIA);
        // this.endTime = activeInfo.startTime + activeInfo.endTime;
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    OnTimer:function(){
        var leftTime = Math.ceil(this.refreshTime - Mgr.login.GetServerTime()/1000);
        if(leftTime > 0)
            this.labTime.SetText("距离首领刷新还有: " + TextUtil.AddColor(TextUtil.SecondToHMS2(leftTime), ColorUtil.SYS_RED));
        else
            this.labTime.SetText("首领已刷新");
    },

    RefreshBossInfo:function(info){
        var bossInfos = info.bossInfos;
        var self = this;
        this.refreshTime = info.refreshTime;
        Mgr.sceneMap.RefreshbossDieEffect(info.bossInfos);
        for(var i = 0; i < bossInfos.length; i++){
            if(!this.labBossList[i]){
                var label = new MUILabel();
                label.x = 5;
                label.y = this.height - 30 * (i + 3);
                label.SetFontSize(20);
                // label.SetColor("0xf2a757");
                this.listView.addChild(label);
                this.labBossList.push(label);
            }
            var monsterInfo = Q_monster.Get(bossInfos[i].modeldId);
            this.labBossList[i].monsterName = monsterInfo.q_name + "(" + monsterInfo.q_grade + ")";
            this.labBossList[i].SetText(this.labBossList[i].monsterName);
            this.labBossList[i].SetTextAlign(cc.TEXT_ALIGNMENT_RIGHT);
            this.labBossList[i].alive = bossInfos[i].alive;
            if(bossInfos[i].alive == 2){
                this.labBossList[i].SetColor(ColorUtil.SYS_RED);
            }
            else if(bossInfos[i].alive == 1){
                this.labBossList[i].SetColor(ColorUtil.SYS_GREEN);
            }
            else if(bossInfos[i].alive == 0){
                this.labBossList[i].SetColor("0x908478");
            }
            this.labBossList[i].SetUISize(this.width*2/3, 30);
            this.labBossList[i].setContentSize(cc.size(this.width*2/3, 30));
            this.labBossList[i].ignoreContentAdaptWithSize(false);
            this.labBossList[i].info = bossInfos[i];
            (function(i){
                self.labBossList[i].setTouchEnabled(true);
                self.labBossList[i].addTouchEventListener(function(target,state)
                {
                    if(state == ccui.Widget.TOUCH_ENDED)
                    {
                        if(!self.nCurMoveParam)
                            self.nCurMoveParam = new AutoPathParam();
                        Mgr.mainPlayer.oCtrlAutoPath.RunToPt(cc.p(bossInfos[i].x, bossInfos[i].y), self.nCurMoveParam, true);
                    }
                })
            })(i);
        }
        this.listView.setInnerContainerSize(cc.size(this.width, (bossInfos.length + 2) * 30));
    },

    Init:function(){
        this._super();
    },

    UpdateView:function(){

    },

});
ZhujiantianxiaTaskTrackPanelExt.PanelName = "ZhujiantianxiaTaskTrackPanelExt";
PanelClassDic["ZhujiantianxiaTaskTrackPanelExt"] = ZhujiantianxiaTaskTrackPanelExt;

var RanKingTastTrackPanelExt = MUIPanel.extend({
    _className:"RanKingTastTrackPanelExt",
    timerId:0,

    ctor:function(parent){
        this._super();

        this.width = parent.width;
        this.height = parent.height;

        this.configLabel = [
            {name:"labTitle", size:22, color:"0xf2a757", line:1},
            {name:"labZoneInfo", size:20, color:"0xf2a757", line:3},
            {name:"labRank1", size:20, color:"0xf2a757", line:1},
            {name:"labRank2", size:20, color:"0xf2a757", line:1},
            {name:"labRank3", size:20, color:"0xf2a757", line:1},
        ];

        for(var i = 0, line = 0; i < this.configLabel.length; i++){
            line +=this.configLabel[i].line;
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30 * line;
            label.SetFontSize(this.configLabel[i].size);
            label.SetColor(this.configLabel[i].color);
            this.addChild(label);
            this[this.configLabel[i].name] = label;
        }
        this.labTitle.SetText("[活动] 铸剑天下 排名");
        this.labZoneInfo.SetText(TextUtil.AddColor("挑战说明\n", "0x28d9ff")
        + TextUtil.AddColor("排行", "0xececec") + TextUtil.AddColor("前三名", "0x01ab25")
            + TextUtil.AddColor("可获得", "0xececec") + TextUtil.AddColor("铸件荣誉礼包\n", "0x01ab25")
        + TextUtil.AddColor("最后一击", "0x01ab25") + TextUtil.AddColor("可获得", "0xececec")
            + TextUtil.AddColor("铸件幸运礼包\n", "0x01ab25"));
    },

    Init:function(){
        this._super();
    },

    RefreshRanking:function(info){
        for(var i = 0; i< info.BossDamageInfos.length; i++){
            var pro = Math.ceil(info.BossDamageInfos[i].damage/1000/info.totalDamage*100);
            if(i < 3)
                this["labRank" + (i+1)].SetText(info.BossDamageInfos[i].playerName
                + TextUtil.AddColor("    (" + (pro > 100 ? 100 : pro) + "%)", "0xececec"));
            else
                break;
        }
    },

    UpdateView:function(){

    },
});
RanKingTastTrackPanelExt.PanelName = "RanKingTastTrackPanelExt";
PanelClassDic["RanKingTastTrackPanelExt"] = RanKingTastTrackPanelExt;

var MarriageZoneTrackPanelExt = MUIPanel.extend({
    _className:"MarriageZoneTrackPanelExt",
    timerId:0,

    ctor:function(parent){
        this._super();

        this.$startTime = 0

        this.width = parent.width;
        this.height = parent.height;

        this.configLabel = [
            {name:"labTitle", size:22, color:"0xf2a757", line:1},
            {name:"labBo", size:20, color:"0xffffff", line:1},
            {name:"labTime", size:20, color:"0xffffff", line:1},
        ];

        for(var i = 0, line = 0; i < this.configLabel.length; i++){
            line +=this.configLabel[i].line;
            var label = new MUILabel();
            label.x = 5;
            label.y = this.height - 30 * line;
            label.SetFontSize(this.configLabel[i].size);
            label.SetColor(this.configLabel[i].color);
            this.addChild(label);
            this[this.configLabel[i].name] = label;
        }
        this.labTitle.SetText("[情缘副本]");
    },

    Init:function(){
        this._super();
    },

    onEnter: function() {
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.UpdateView();
    },
    onExit: function() {
        this._super();
        if (this.timerId != 0) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },
    OnTimer:function(){
        var serverTime = Mgr.login.GetServerTime()/1000;
        var sTime = TimeUtil.SecondToDHMS2(Math.max(0,this.$startTime - serverTime))
        this.labTime.SetText(TextUtil.FormatStr("剩余时间:{@}",[TextUtil.AddColor(sTime, "0x28d9ff")]));
    },
    UpdateView:function(msg){
    },
    UpdateLeftTime:function(time){
        this.$startTime = Mgr.login.GetServerTime()/1000 + time;
        this.OnTimer()
    },
    UpdateWave:function(msg){
        if(this.$startTime == 0){
            /// 初始化时间
            var time = Q_zone.Get(Mgr.zone._curZoneId).q_exist_time;
            this.UpdateLeftTime(time / 1000)
        }

        var current =  msg.deployNum & 0xFFFF
        var total = msg.deployNum >>> 16

        var curWave = TextUtil.AddColor(current + "/" + total, "0x28d9ff")
        this.labBo.SetText(TextUtil.FormatStr("当前波束:{@}波",[TextUtil.AddColor(curWave, "0x28d9ff")]));
    },
});
MarriageZoneTrackPanelExt.PanelName = "MarriageZoneTrackPanelExt";
PanelClassDic["MarriageZoneTrackPanelExt"] = MarriageZoneTrackPanelExt;