var MasterBucketTaskTrackPanelExt = MasterBucketTaskTrackPanelExt || MUIPanel.extend({
    _className : "MasterBucketTaskTrackPanelExt",

    ctor:function(parent,taskTrackPanel){
        this._super();
        this.taskTrackPanel = taskTrackPanel;

        parent.height = 270;
        this.width = parent.width;
        this.height = parent.height;

        this.confLab = [
            { name : "labTitle" , size:24,color:"0xf2a757",},
            { name : "labGather" , size:20,color:EnumFontFormat.COMMON_COLOR01,},
            { name : "labLeftTime" , size:22,color:EnumFontFormat.COMMON_COLOR01,},
            { name : "labTarget" , size:20,color:EnumFontFormat.COMMON_COLOR01,},
            { name : "labTarget0" , size:20,color:EnumFontFormat.COMMON_COLOR01,},
        ];

        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            var label = new MUILabel();
            label.x = 10;
            label.SetFontSize(v.size);
            label.SetColor(v.color);
            this.addChild(label);
            this[v.name] = label;
        }

        this.labTitle.SetText("[定时活动] 掌门斗宝");
        this.labGather.SetText("今日采集:");
        this.labLeftTime.SetText("活动倒计时");
        this.labTarget.SetText(TextUtil.AddHyperlink("东集市掌门宝箱",0));
        this.labTarget0.SetText(TextUtil.AddHyperlink("西集市掌门宝箱",1));

        this.labTarget.__href = 0;
        this.labTarget0.__href = 1;

        // this.labTarget.SetOpenUrlCallback(this.OnHyperlink,this);
        // this.labTarget0.SetOpenUrlCallback(this.OnHyperlink,this)
        this.labTarget.setTouchEnabled(true);
        this.labTarget0.setTouchEnabled(true);
        this.labTarget.addClickEventListener(this.OnBtnClicked.bind(this));
        this.labTarget0.addClickEventListener(this.OnBtnClicked.bind(this));


        var height = this.height - 35;
        for (var list = this.confLab, length = list.length, k = 0, v = list[k]; k < length; v = list[++k]) {
            this[v.name].y = height;
            height -= this[v.name].GetHeight() + 20;
        }

        this.UpdateView();
    },

    Init:function(){
        this._super();
    },

    onEnter:function(){
        this._super();
        this.timerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);

        this.OnTimer();
    },

    onExit:function(){
        this._super();
        if (this.timerId) TimerUtil.ClearTimeUpdate(this.timerId, this);
    },

    OnBtnClicked:function(sender){
        var href = sender.__href;
        this.OnHyperlink(href);
    },

    OnHyperlink:function(href){
        MasterBucketUtil.AutoPath2ActivityRange(href);
    },

    OnTimer:function(){
        // 如果在活动范围内才显示
        var inArea = MasterBucketUtil.CheckPlayerInActivityMapArea();
        if(this.bInArea == null || this.bInArea != inArea){
            this.bInArea = inArea;
            if(inArea) this.taskTrackPanel.ShowOtherTrack();
            else this.taskTrackPanel.HideOtherTrack();
        }

        var leftTime = 0;
        if(this.data) {
            var curTime = Mgr.login.GetServerTime() / 1000;
            leftTime = Math.max(this.data.startTime + this.data.endTime - curTime,0);;
        }

        this.labLeftTime.SetText("活动倒计时:"
            + TextUtil.AddColor(TimeUtil.SecondToDHMS2(leftTime),EnumFontFormat.COMMON_COLOR04));
    },

    UpdateView:function(){
        this.data = MasterBucketUtil.CheckActivityIsOpen();
        var gatherNum = MasterBucketUtil.GetGatherCount();
        this.labGather.SetText("今日采集:"
             + TextUtil.AddColor(gatherNum[0] + "/" + gatherNum[1],EnumFontFormat.COMMON_COLOR04));

    },
});
MasterBucketTaskTrackPanelExt.PanelName = "MasterBucketTaskTrackPanelExt";
PanelClassDic["MasterBucketTaskTrackPanelExt"] = MasterBucketTaskTrackPanelExt;