var AlertExt = Alert.extend ( {
	_className:"AlertExt",

	_type:null,
	_args:null,
	_alian:null,

	_onBtnTitle:null,
	_offBtnTitle:null,

	_leftPt:null,
	_rightPt:null,
	_centerPt:null,

	_onTimerId:null,
	_onTime:null,
	_offTimerId:null,
	_offTime:null,

	ctor:function(){
		this._super();
		this._onTimerId = 0;
		this._offTimerId = 0;
		this._onBtnTitle = "确定";
		this._offBtnTitle = "取消";
		this.showLayerType = UIMgr.PANEL_LAYER_TIP;
		this.modelPanelType = MUIPanelModelType.ALPHABLACK;
	},

	Init:function() {
		var self = this;
		Alert.prototype.Init.call(this);

		this._leftPt = this.btnSure.getPosition();
		this._rightPt = this.btnFalse.getPosition();
		this._centerPt = cc.p( (this.width - this.btnFalse.width)/2, this._leftPt.y );

		this._InitPosition();
		this.labName.SetString("系统提示");

		this.btnClose.addClickEventListener(function (event){
			self.ClearTimerOn();
			self.ClearTimerOff();
			self._operatorOff();
			// Mgr.uiMgr.HidePanel(self);
		});
		this.btnSure.addClickEventListener(function (event){
			self.ClearTimerOn();
			self.ClearTimerOff();
			self._operatorOn();
		});
		this.btnFalse.addClickEventListener(function (event){
			self.ClearTimerOn();
			self.ClearTimerOff();
			self._operatorOff(true);
		});
	},

	_operatorOn:function () {
		if ( this._args && this._args._onFunc )
			this._args._onFunc();
		Mgr.uiMgr.HidePanel(this);
	},

	_operatorOff:function (notClose) {
		if ( this._args && this._args._offFunc )
			this._args._offFunc(notClose);
		Mgr.uiMgr.HidePanel(this);
	},

	_InitPosition:function () {
		var size = cc.director.getWinSize();
		// pos
		this.x = (size.width - this.uiWidth) / 2;
		this.y = (size.height - this.uiHeight) / 2;
	},

	SetButtonTitle:function (on_name, off_name) {
		if ( on_name != undefined )
			this._onBtnTitle = on_name;
		if ( off_name != undefined )
			this._offBtnTitle = off_name;

		this.btnSure.setTitleText( this._onBtnTitle );
		this.btnFalse.setTitleText( this._offBtnTitle );
	},

	SetData:function( html, type, args, alian ) {
		type = type || TipsEnum.BUTTON_SURE;
		args = args || null;
		alian = alian || 1;
		this._type = type;
		this._model =
		this._args = args;
		this._alian = alian;

		this.SetButtonTitle( "确定", "取消");

		this.labCue.SetText(html);
		this.labCue.SetTextAlign(this._alian);
		this.labCue.y = this.labCue.initY - (this.labCue.uiHeight - this.labCue.GetTextHeight())/2;

		if ( type == TipsEnum.BUTTON_SURE ) {
			this.btnFalse.setVisible(false);
			this.btnSure.setVisible(true);
			this.btnSure.setPosition(this._centerPt);
		}
		else if ( type == TipsEnum.BUTTON_FALSE ) {
			this.btnSure.setVisible(false);
			this.btnFalse.setVisible(true);
			this.btnFalse.setPosition(this._centerPt);
		}
		else if ( type == TipsEnum.BUTTON_SURE_AND_FALSE ) {
			this.btnFalse.setVisible(true);
			this.btnFalse.setPosition(this._rightPt);
			this.btnSure.setVisible(true);
			this.btnSure.setPosition(this._leftPt);
		}

		this.btnSure.setTitleText( this._onBtnTitle );
		this.btnFalse.setTitleText( this._offBtnTitle );

		// _onTimerUp
		this.ClearTimerOn();
		if ( args && args._onTime && args._onTime > 0 ) {
			this._onTime = args._onTime;
			this._onTimerId = TimerUtil.TimeUpdate(this.OnTimer, this, 1);
			this.OnTimer();
		}

		// _offTimerUp
		this.ClearTimerOff();
		if ( args && args._offTime && args._offTime > 0 ) {
			this._offTime = args._offTime;
			this._offTimerId = TimerUtil.TimeUpdate(this.OffTimer, this, 1);
			this.OffTimer();
		}
	},

	OnTimer:function () {
		this._onTime--;
		if ( this._onTime <= 0 )
		{
			this.ClearTimerOn();
			this._operatorOn();
		}
		var btnName = this._onBtnTitle.toString() + " (" + this._onTime.toString() + "秒)";
		this.btnSure.setTitleText( btnName );
	},

	OffTimer:function () {
		this._offTime--;
		if ( this._offTime <= 0 )
		{
			this.ClearTimerOff();
			this._operatorOff();
		}
		var btnName = this._offBtnTitle.toString() + " (" + this._offTime.toString() + "秒)";
		this.btnFalse.setTitleText( btnName );
	},
	
	ClearTimerOn:function () {
		if ( this._onTimerId != 0 )
			TimerUtil.ClearTimeUpdate(this._onTimerId, this);
		this._onTimerId = 0;
		this._onTime = 0;
	},

	ClearTimerOff:function () {
		if ( this._offTimerId != 0 )
			TimerUtil.ClearTimeUpdate(this._offTimerId, this);
		this._offTimerId = 0;
		this._offTime = 0;
	},
} );
AlertExt.PanelName = "AlertExt";
PanelClassDic["AlertExt"] = AlertExt;

/***
 * ------------ 窗体Tips ----------------------
 * @param html
 * @param type
 * @param args			_onFunc  _offFunc
 * @param alian
 * @constructor
 */
AlertExt.Show = function(html, type, args, alian, isRight) {
	var panel = Mgr.uiMgr.ShowPanelByType(AlertExt.PanelName);
	if( isRight )
		panel.x += panel.uiWidth;
	panel.SetData(html, type, args, alian);

}

AlertExt.SetButtonTitle = function (on_name, off_name) {
	var ins = Mgr.uiMgr.GetPanelByType(AlertExt.PanelName);
	if ( ins ) {
		ins.SetButtonTitle(on_name, off_name);
	}
}

AlertExt.NoEnoughGold = function( goldNum ){
	var html = "元宝不足";
	if( goldNum )
		html = TextUtil.FormatStr("元宝不足，还需要" + TextUtil.AddColor("{1}元宝", "2ed515"), [goldNum]);
	AlertExt.Show(html,TipsEnum.BUTTON_SURE, {
		_onFunc:function(){
            OpenFuncUtil.OpenRecharge();
		},
	},1);
	AlertExt.SetButtonTitle("前往充值");
}
