///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//TitleInfo 称号info

// 请求消息
//110201,ReqTitleActivateInfo 请求称号完成条件信息
//110202,ReqActivateTitle 请求激活称号
//110203,ReqUseTitle 请求穿戴称号
//110204,ReqHeadTitleInfo 请求头衔信息
//110205,ReqHeadTitleUpLevel 请求头衔升级

// 接收消息
//110101,ResTitleInfo 返回所有称号信息（上线发）
//110102,ResTitleActivateInfo 返回称号完成条件信息
//110103,ResActivateTitle 返回激活称号消息
//110104,ResTitleChange 广播称号改变消息
//110105,ResTitleLost 称号过期消息
//110106,ResHeadTitleInfo 头衔信息


var TitleInfo = cc.Class.extend({
	ctor:function(){
		this.titleModel = 0; // 称号model
        this.lostTime = 0; // 过期时间（时间戳秒 0表示永久称号）
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
        _buf.WriteVarInt(this.lostTime);
	},
	
	reading:function( _buf ){
		this.titleModel = _buf.ReadVarInt();
        this.lostTime = _buf.ReadVarInt();
	},
});
////////////////////
// 返回所有称号信息（上线发） //
////////////////////
var ResTitleInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.titleInfos = []; // 返回身上所有称号信息 TitleInfo
	},

	getId:function(){
		return 110101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.titleInfos.length );
        for (var i = 0; i < this.titleInfos.length; i++) {
            _buf.WriteBean(this.titleInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var titleInfos_length = _buf.ReadShort();
        for (var i = 0; i < titleInfos_length; i++) {
            this.titleInfos[i] = _buf.ReadBean(TitleInfo);
        }
	},

	action:function(){
		Mgr.title.RecvResTitleInfoMessage(this);
	},

});
////////////////////
// 返回称号完成条件信息 //
////////////////////
var ResTitleActivateInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model
        this.progress = []; // 进度分子（分母对应表的q_activate字段 道具兑换的前端自己判断） int
	},

	getId:function(){
		return 110102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
        _buf.WriteShort( this.progress.length );
        for (var i = 0; i < this.progress.length; i++) {
            _buf.WriteVarInt(this.progress[i]);
        }
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
        var progress_length = _buf.ReadShort();
        for (var i = 0; i < progress_length; i++) {
            this.progress[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.title.RecvResTitleActivateInfoMessage(this);
	},

});
////////////////////
// 返回激活称号消息 //
////////////////////
var ResActivateTitleMessage = cc.Class.extend( {
	ctor:function(){
		this.actTitleInfo = null; // 激活成功的称号
	},

	getId:function(){
		return 110103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.actTitleInfo);
	},
	
	reading:function( _buf ){
        this.actTitleInfo = _buf.ReadBean(TitleInfo);
	},

	action:function(){
		Mgr.title.RecvResActivateTitleMessage(this);
	},

});
////////////////////
// 广播称号改变消息 //
////////////////////
var ResTitleChangeMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model（0表示卸下称号）
        this.playerid = null; // 玩家id
	},

	getId:function(){
		return 110104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
        _buf.WriteLong(this.playerid);
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
        this.playerid = _buf.ReadLong();
	},

	action:function(){
		Mgr.title.RecvResTitleChangeMessage(this);
	},

});
////////////////////
// 称号过期消息 //
////////////////////
var ResTitleLostMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model（0表示卸下称号）
	},

	getId:function(){
		return 110105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.title.RecvResTitleLostMessage(this);
	},

});
////////////////////
// 头衔信息 //
////////////////////
var ResHeadTitleInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.headTitleId = 0; // 头衔modelId
	},

	getId:function(){
		return 110106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.headTitleId);
	},
	
	reading:function( _buf ){
        this.headTitleId = _buf.ReadByte();
	},

	action:function(){
		Mgr.title.RecvResHeadTitleInfoMessage(this);
	},

});
////////////////////
// 请求称号完成条件信息 //
////////////////////
var ReqTitleActivateInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model
	},

	getId:function(){
		return 110201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求激活称号 //
////////////////////
var ReqActivateTitleMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model
	},

	getId:function(){
		return 110202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求穿戴称号 //
////////////////////
var ReqUseTitleMessage = cc.Class.extend( {
	ctor:function(){
		this.titleModel = 0; // 称号model
        this.type = 0; // 1穿戴 0卸下
	},

	getId:function(){
		return 110203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.titleModel);
        _buf.WriteByte(this.type);
	},
	
	reading:function( _buf ){
        this.titleModel = _buf.ReadVarInt();
        this.type = _buf.ReadByte();
	},

});
////////////////////
// 请求头衔信息 //
////////////////////
var ReqHeadTitleInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 110204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求头衔升级 //
////////////////////
var ReqHeadTitleUpLevelMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 110205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(110101, ResTitleInfoMessage);
MESSAGE_POOL.Add(110102, ResTitleActivateInfoMessage);
MESSAGE_POOL.Add(110103, ResActivateTitleMessage);
MESSAGE_POOL.Add(110104, ResTitleChangeMessage);
MESSAGE_POOL.Add(110105, ResTitleLostMessage);
MESSAGE_POOL.Add(110106, ResHeadTitleInfoMessage);

