var PHBDuiBiExt = PHBDuiBi.extend({
    _className: "PHBDuiBiExt",

    _vScrollView: null,
    _playerInfo: null,
    _typeList: [],
    _powerBarList: [],

    ctor: function() {
        this._super();
    },

    Init: function() {
        PHBDuiBi.prototype.Init.call(this);
        var self = this;
        this.btnClose.addClickEventListener(function(event) {
            Mgr.uiMgr.HidePanelByType(PHBDuiBiExt.PanelName);
        });

        this.InitView();
    },

    InitPlayerInfo: function(info) {
        this._playerInfo = info;
        this.labName.SetString(info.playerName);
        this.labZhanli.SetString(info.fightpower);
        this.labName1.SetString(Mgr.player.mainPlayer.name);
        this.labZhanli1.SetString(Mgr.player.mainPlayer.fightpower);
        UIUtil.LoadImage( this.imgHead, ResUrl.GetPlayerHeadUrl(info.job));
        UIUtil.LoadImage( this.imgHead1, ResUrl.GetPlayerHeadUrl(Mgr.player.mainPlayer.job));

        this.UpdatePowerBar();
    },

    InitView: function() {
        if (!this._vScrollView) {
            this._vScrollView = new ccui.ScrollView();
            this._vScrollView.setDirection(ccui.ScrollView.DIR_VERTICAL); //视图滚动方向
            this._vScrollView.setTouchEnabled(true); //触摸开启
            this._vScrollView.inertiaScrollEnabled = true; //滚动惯性
            this._vScrollView.setScrollBarEnabled(false); //滚动条
            this._vScrollView.setBounceEnabled(true); //边界回弹
            this._vScrollView.setSize(cc.size(this.imgBg.uiWidth, this.imgBg.uiHeight));
            //            this._vScrollView.setScrollBarAutoHideTime(0);
            this.imgBg.addChild(this._vScrollView, 1);
        }
    },

    CreatePowerBar: function() {
        var bar = new DuiBiList1Ext();
        bar.LoadPanel();
        this._vScrollView.addChild(bar);
        return bar;
    },

    UpdatePowerBar: function() {
        var i, cell;

        var data = FightPowerUtils.GetMainData(this._playerInfo);

        var cellCount = data.length;
        var count = Math.max(cellCount, this._powerBarList.length);
        this._powerBarList
        for (var i = 0; i < count; i++) {
            var cell = this._powerBarList[i];

            if (i < cellCount) {
                if (!cell) {
                    cell = new PHBDuiBiExtCell(this._vScrollView.width, this.OnViewUpdated.bind(this));
                    this._vScrollView.addChild(cell);
                    this._powerBarList.push(cell);
                }

                cell.visible = true;
                cell.InitData(i + 1, data[i]);
            } else {
                if (cell) cell.visible = false;
            }
        }

        this.OnViewUpdated();
    },

    OnViewUpdated: function(target) {
        var height = 0;

        for (var v of this._powerBarList) {
            if (v.visible) {
                if (target != v) v.SetExpanded(false);

                v.UpdateView();
                height += v.height;
            }
        }

        height = Math.max(this._vScrollView.height, height);
        this._vScrollView.setInnerContainerSize(cc.size(this.imgBg.uiWidth, height));

        for (var v of this._powerBarList) {
            if (v.visible) {
                height -= v.height;
                v.y = height;
            }
        }

        if(!target) return;

        // 矫正位置,避免拉开后看不到
        this._vScrollView.stopAutoScroll();
        var pos = this._vScrollView.getInnerContainerPosition();
        var rect = cc.rect(target.x + 1, target.y + 1, target.width - 2, target.height - 2);
        var visRect = cc.rect(pos.x, -pos.y, this._vScrollView.width, this._vScrollView.height);
        if (!cc.rectContainsRect(visRect, rect)) {
            this._vScrollView.setInnerContainerPosition(cc.p(target.x,
                Math.min(0,-target.y + this._vScrollView.height / 2 - target.height / 2)));
        }
    },
});
PHBDuiBiExt.PanelName = "PHBDuiBiExt";
PanelClassDic["PHBDuiBiExt"] = PHBDuiBiExt;

var PHBDuiBiExtCell = ccui.Layout.extend({
    callback: null,
    data: null,
    type: 0,
    expanded: false,

    mainView: null,
    subView: null,

    ctor: function(width, callback) {
        this._super();

        this.width = width;
        this.callback = callback;
        this.subView = [];
    },
    InitData: function(type, data) {
        this.type = type;
        this.data = data;
        this.expanded = false;

        if (!sys.isObjectValid(this.mainView)) {
            var view = new DuiBiList1Ext();
            view.LoadPanel();
            this.addChild(view);
            this.mainView = view;
        }

        this.mainView.UpdateView(data, this.SwitchExpandedStatus.bind(this));

        var i, cell;
        var cellCount = data.sub.length;
        var count = Math.max(cellCount, this.subView.length);
        var height = 0
        for (i = 0; i < count; i++) {
            cell = this.subView[i];

            if (i < cellCount) {
                if (!cell) {
                    cell = new DuiBiListExt();
                    cell.LoadPanel();
                    this.addChild(cell);
                    this.subView.push(cell);
                }

                cell.__used = true;
                cell.InitData(data.sub[i]);
            } else {
                if (cell) cell.__used = false;
            }
        }
    },

    SwitchExpandedStatus: function() {
        this.expanded = !this.expanded;
        if (this.callback) {
            this.callback(this);
        }
    },

    SetExpanded: function(expanded) {
        this.expanded = expanded;
    },

    UpdateView: function() {
        var height = 0;

        for (var k in this.subView) {
            var v = this.subView[this.subView.length - k - 1];
            if (v.__used) {
                v.y = height;
                v.visible = this.expanded;
                height += v.height;
            } else {
                v.visible = false;
            }
        }

        this.mainView.UpdateExpanded(this.expanded);

        this.height = this.expanded ? this.mainView.height + height : this.mainView.height;
        this.mainView.y = this.height - this.mainView.height;
    }
})