//图鉴类型
var EnumTujianType = EnumTujianType || {
	/**
	 *野外图鉴
	 */
	TYPE_YW : 1,
	/**
	 *跨服图鉴
	 */
	TYPE_KF : 2,
};

var TujianModMgr = TujianModMgr || cc.Class.extend({ 
	tujianpanel:null,
	_tujianHash:null,
	tujianMonsterInfoHash:null,
	needJihuoHash:null,//未激活的图鉴 {key：图鉴id  value：[itemModId, num]}
	canJihuoHash:null,//未激活图鉴是否能激活 {key:图鉴id value：[能否激活boolean, 类型]}
	_tujianIdByItemIdHash:null,
	ctor:function() {	
		
	},

	InitHash:function () {
		this._tujianHash = new HashMap();
		var list = Q_tujian.GetList().sort(this.SortTujianById);
		for(var i = 0; i < list.length; i++){
			var idArr = list[i].q_id.split("_");
			if( parseInt(idArr[1]) == 0 ){
				if( !this._tujianHash.Get( list[i].q_main_type + "_" + list[i].q_second_type) ){
					var tempArr = new Array();
					this._tujianHash.Put( list[i].q_main_type + "_" + list[i].q_second_type, tempArr );
				}
				this._tujianHash.Get( list[i].q_main_type + "_" + list[i].q_second_type).push(list[i]);
			}
		}
	},
	
	TujianHash:function () {
		if( !this._tujianHash ){
			this.InitHash();
		}
		return this._tujianHash;
	},

	SortTujianById:function( p1, p2 ){
		var arr1 = p1.q_id.split("_");
		var arr2 = p2.q_id.split("_");
		if (arr1[1] < arr2[1])
			return -1;
		else if (arr2[1] < arr1[1])
			return 1;

		return 0;
	},
	
	UpdataNeedJihuoHash:function(){
		if(!this.needJihuoHash){
			this.needJihuoHash = new HashMap();
			var list = Q_tujian.GetList();
			for(var j = 0; j < list.length; j++){
				var tujianinfo = this.tujianMonsterInfoHash.Get(list[j].q_id);
				if(tujianinfo){
					if(tujianinfo.level == 0 && this.needJihuoHash.Get(tujianinfo.tujianId) == null){
						var nextqtujian = Q_tujian.Get(tujianinfo.tujianId + "_1");
						this.needJihuoHash.Put(tujianinfo.tujianId, [nextqtujian.q_item, nextqtujian.q_num]);
						this.UpdataCanJihuo(tujianinfo.tujianId);
					}else if(tujianinfo.level > 0 && this.needJihuoHash.Get(tujianinfo.tujianId)){
						this.needJihuoHash.Remove(tujianinfo.tujianId);
						this.UpdataCanJihuo(ttujianinfo.tujianId + "_0");
					}
				}else{
					var tempArr = list[j].q_id.split("_");
					if(this.needJihuoHash.Get(tempArr[0]) == null && tempArr[1] == "0"){
						var nextqtujian = Q_tujian.Get(tempArr[0] + "_1");
						this.needJihuoHash.Put(tempArr[0], [nextqtujian.q_item, nextqtujian.q_num]);
						this.UpdataCanJihuo(tempArr[0] + "_0");
					}
				}
			}
		}
	},
	
	TujianIdByItemIdHash:function(){
		if(!this._tujianIdByItemIdHash){
			this._tujianIdByItemIdHash = new HashMap();
			var list = Q_tujian.GetList();
			for(var j = 0; j < list.length; j++){
				var tempArr = list[j].q_id.split("_");
				if(tempArr[1] == "0")
					this._tujianIdByItemIdHash.Put(list[j].q_item, list[j].q_id);
			}
		}
		return this._tujianIdByItemIdHash;
	},
	
	CheckJihuoItem:function(itemId){
		this.UpdataNeedJihuoHash();
		var tujianid = this.TujianIdByItemIdHash().Get(itemId);
		if(tujianid){
			this.UpdataCanJihuo(tujianid);
		}
		Mgr.player.shortPanel.UpDataTujianWarn();
	},
	
	UpdataCanJihuo:function(tujianid){
		if(!this.canJihuoHash)
			this.canJihuoHash = new HashMap();
		var tempArr = tujianid.split("_");
		var arr = this.needJihuoHash.Get(tempArr[0]);
		var qtujian = Q_tujian.Get(tujianid);
		var canActive = false;
		if(arr){
			canActive = Mgr.backpack.GetItemNumber(arr[0]) >= arr[1]
			this.canJihuoHash.Put(tujianid, [canActive, qtujian.q_main_type]);
		}
		else{
			var info = this.tujianMonsterInfoHash.Get(tempArr[0]);
			qtujian = Q_tujian.Get(info.tujianId + "_" + (info.level+2));
			if(qtujian){
//				canActive = Mgr.backpack.GetItemNumber(qtujian.q_item) >= qtujian.q_num;
				canActive = Mgr.backpack.GetItemNumber(qtujian.q_item) > 0;
				this.canJihuoHash.Put(tujianid, [canActive, qtujian.q_main_type]);
			}
			else
				this.canJihuoHash.Remove(tujianid);
		}
	},
	
	CanUp:function(){
		for(var i = 0; i < this.canJihuoHash.Values().length; i++){
			var canJihuoArr = this.canJihuoHash.Values()[i];
			if(canJihuoArr && canJihuoArr[0]){
				return true;
			}
		}
		return false;
	},

	RecvResTujianInfoToClientMessage:function(msg) {
		if(!this.tujianMonsterInfoHash)
			this.tujianMonsterInfoHash = new HashMap();
		this.UpdataNeedJihuoHash();
		for(var i = 0; i < msg.tujianMonsterInfo.length; i++){
			this.tujianMonsterInfoHash.Put(msg.tujianMonsterInfo[i].tujianId, msg.tujianMonsterInfo[i]);
			if(msg.tujianMonsterInfo[i].level == 0 && this.needJihuoHash.Get(msg.tujianMonsterInfo[i].tujianId) == null){
				var nextqtujian = Q_tujian.Get(msg.tujianMonsterInfo[i].tujianId + "_1");
				this.needJihuoHash.Put(msg.tujianMonsterInfo[i].tujianId, [nextqtujian.q_item, nextqtujian.q_num]);
				this.UpdataCanJihuo(msg.tujianMonsterInfo[i].tujianId + "_0");
			}else if(msg.tujianMonsterInfo[i].level > 0 && this.needJihuoHash.Get(msg.tujianMonsterInfo[i].tujianId)){
				this.needJihuoHash.Remove(msg.tujianMonsterInfo[i].tujianId);
				this.UpdataCanJihuo(msg.tujianMonsterInfo[i].tujianId + "_0");
			}
		}
//		this.UpdataNeedJihuoHash();
		if(Mgr.uiMgr.IsPanelShowByName(TujianPanelExt.PanelName)){
			this.tujianpanel.UpdataInfo();
		}
		Mgr.player.shortPanel.UpDataTujianWarn();
	},

	RecvResTujianUpToClientMessage:function(msg) {	
		if(msg.success == 1){
		}
		this.tujianMonsterInfoHash.Put(msg.tujianMonsterInfo.tujianId, msg.tujianMonsterInfo);
		this.needJihuoHash.Remove(msg.tujianMonsterInfo.tujianId);
		this.UpdataCanJihuo(msg.tujianMonsterInfo.tujianId + "_0");
		if(Mgr.uiMgr.IsPanelShowByName(TujianPanelExt.PanelName)){
			this.tujianpanel.UpdataOneInfo(msg.tujianMonsterInfo);
		}
		Mgr.player.shortPanel.UpDataTujianWarn();
	},
	
	// 请求图鉴信息 
	SendReqTujianInfoToGameMessage:function(tujianType) {
		var msg = new ReqTujianInfoToGameMessage();
		msg.tujianType = tujianType;
		Mgr.msgMgr.Send( msg );
	},
	
	// 请求图鉴升级
	SendReqTujianUpToGameMessage:function(tujianType, tujianId) {
		var msg = new ReqTujianUpToGameMessage();
		msg.tujianType = tujianType;
		msg.tujianId = tujianId;
		Mgr.msgMgr.Send( msg );
	},
});