///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//VacantInfo 个人虚空之门副本信息
//VacantMopUpInfo 个人虚空之门副本扫荡信息

// 请求消息
//187201,ReqVacantInfoToGame 请求个人虚空之门副本信息
//187202,ReqVacantOpenToGame 请求虚空之门副本开启
//187203,ReqVacantAwardToGame 请求领取虚空副本通关奖励
//187204,ReqVacantResetToGame 请求重置虚空之门副本
//187205,ReqVacantMopUpToGame 请求虚空之门副本一键扫荡
//187206,ReqVacantOpenAgainToGame 请求虚空之门副本再次挑战或者挑战下一关
//187207,ReqVacantMopUpAwardToGame 请求领取虚空之门扫荡奖励

// 接收消息
//187101,ResVacantInfoToClient 发送个人虚空之门副本数据信息 
//187102,ResVacantfinishToClient 发送虚空之门副本完成信息
//187103,ResVacantMopUpResultToClient 发送领取扫荡奖励信息
//187104,ResVacantBossSpeakToClient 发送虚空之门BOSS喊话信息
//187105,ResVacantEnterToClient 发送进入虚空之门信息
//187106,ResVacantMopUpInfoToClient 发送虚空之门副本扫荡未领取的奖励信息


var VacantInfo = cc.Class.extend({
	ctor:function(){
		this.useResetNum = 0; // 今日已重置次数
        this.resetNum = 0; // 今日剩余重置次数
        this.maxVacantId = 0; // 历史通关最高层数
        this.nowVacantId = 0; // 当前通关最高层数
        this.resetFlage = 0; // 是否重置过(1是重置过0是未重置过)
        this.finishVacantIds = []; // 今日已经通关的层数 int
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.useResetNum);
        _buf.WriteVarInt(this.resetNum);
        _buf.WriteVarInt(this.maxVacantId);
        _buf.WriteVarInt(this.nowVacantId);
        _buf.WriteByte(this.resetFlage);
        _buf.WriteShort( this.finishVacantIds.length );
        for (var i = 0; i < this.finishVacantIds.length; i++) {
            _buf.WriteVarInt(this.finishVacantIds[i]);
        }
	},
	
	reading:function( _buf ){
		this.useResetNum = _buf.ReadVarInt();
        this.resetNum = _buf.ReadVarInt();
        this.maxVacantId = _buf.ReadVarInt();
        this.nowVacantId = _buf.ReadVarInt();
        this.resetFlage = _buf.ReadByte();
        var finishVacantIds_length = _buf.ReadShort();
        for (var i = 0; i < finishVacantIds_length; i++) {
            this.finishVacantIds[i] = _buf.ReadVarInt();
        }
	},
});
var VacantMopUpInfo = cc.Class.extend({
	ctor:function(){
		this.day = 0; // 1970年到现在的天数
        this.startVacantId = 0; // 未领取的开始层数
        this.endVacantId = 0; // 未领取的结束层数
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.day);
        _buf.WriteVarInt(this.startVacantId);
        _buf.WriteVarInt(this.endVacantId);
	},
	
	reading:function( _buf ){
		this.day = _buf.ReadVarInt();
        this.startVacantId = _buf.ReadVarInt();
        this.endVacantId = _buf.ReadVarInt();
	},
});
////////////////////
// 发送个人虚空之门副本数据信息  //
////////////////////
var ResVacantInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.firstName = null; // 王者玩家名字
        this.firstId = null; // 王者玩家ID
        this.maxVacantId = 0; // 王者玩家通关的历史最高层数
        this.vacantInfo = null; // 个人虚空之门副本信息
	},

	getId:function(){
		return 187101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteString(this.firstName);
        _buf.WriteLong(this.firstId);
        _buf.WriteVarInt(this.maxVacantId);
        _buf.WriteBean(this.vacantInfo);
	},
	
	reading:function( _buf ){
        this.firstName = _buf.ReadString();
        this.firstId = _buf.ReadLong();
        this.maxVacantId = _buf.ReadVarInt();
        this.vacantInfo = _buf.ReadBean(VacantInfo);
	},

	action:function(){
		Mgr.vacant.RecvResVacantInfoToClientMessage(this);
	},

});
////////////////////
// 发送虚空之门副本完成信息 //
////////////////////
var ResVacantfinishToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.vacantId = 0; // 层数ID
        this.isMaxRecord = 0; // 是否是全服新记录（1表示是 0表示不是）
	},

	getId:function(){
		return 187102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vacantId);
        _buf.WriteVarInt(this.isMaxRecord);
	},
	
	reading:function( _buf ){
        this.vacantId = _buf.ReadVarInt();
        this.isMaxRecord = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.vacant.RecvResVacantfinishToClientMessage(this);
	},

});
////////////////////
// 发送领取扫荡奖励信息 //
////////////////////
var ResVacantMopUpResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.itemInfos = []; // 奖励信息 TempItemInfo
	},

	getId:function(){
		return 187103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.itemInfos.length );
        for (var i = 0; i < this.itemInfos.length; i++) {
            _buf.WriteBean(this.itemInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var itemInfos_length = _buf.ReadShort();
        for (var i = 0; i < itemInfos_length; i++) {
            this.itemInfos[i] = _buf.ReadBean(TempItemInfo);
        }
	},

	action:function(){
		Mgr.vacant.RecvResVacantMopUpResultToClientMessage(this);
	},

});
////////////////////
// 发送虚空之门BOSS喊话信息 //
////////////////////
var ResVacantBossSpeakToClientMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

	action:function(){
		Mgr.vacant.RecvResVacantBossSpeakToClientMessage(this);
	},

});
////////////////////
// 发送进入虚空之门信息 //
////////////////////
var ResVacantEnterToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.vacantId = 0; // 层数ID
        this.creatTime = 0; // 副本创建时间(秒)
	},

	getId:function(){
		return 187105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vacantId);
        _buf.WriteVarInt(this.creatTime);
	},
	
	reading:function( _buf ){
        this.vacantId = _buf.ReadVarInt();
        this.creatTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.vacant.RecvResVacantEnterToClientMessage(this);
	},

});
////////////////////
// 发送虚空之门副本扫荡未领取的奖励信息 //
////////////////////
var ResVacantMopUpInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.vacantMopUplist = []; // 虚空之门副本扫荡奖励列表信息 VacantMopUpInfo
	},

	getId:function(){
		return 187106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.vacantMopUplist.length );
        for (var i = 0; i < this.vacantMopUplist.length; i++) {
            _buf.WriteBean(this.vacantMopUplist[i]);
        }
	},
	
	reading:function( _buf ){
        var vacantMopUplist_length = _buf.ReadShort();
        for (var i = 0; i < vacantMopUplist_length; i++) {
            this.vacantMopUplist[i] = _buf.ReadBean(VacantMopUpInfo);
        }
	},

	action:function(){
		Mgr.vacant.RecvResVacantMopUpInfoToClientMessage(this);
	},

});
////////////////////
// 请求个人虚空之门副本信息 //
////////////////////
var ReqVacantInfoToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求虚空之门副本开启 //
////////////////////
var ReqVacantOpenToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求领取虚空副本通关奖励 //
////////////////////
var ReqVacantAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.vacantId = 0; // 层数ID
	},

	getId:function(){
		return 187203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vacantId);
	},
	
	reading:function( _buf ){
        this.vacantId = _buf.ReadVarInt();
	},

});
////////////////////
// 请求重置虚空之门副本 //
////////////////////
var ReqVacantResetToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求虚空之门副本一键扫荡 //
////////////////////
var ReqVacantMopUpToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求虚空之门副本再次挑战或者挑战下一关 //
////////////////////
var ReqVacantOpenAgainToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0是再次挑战1是挑战下一关
	},

	getId:function(){
		return 187206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
	},

});
////////////////////
// 请求领取虚空之门扫荡奖励 //
////////////////////
var ReqVacantMopUpAwardToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 187207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(187101, ResVacantInfoToClientMessage);
MESSAGE_POOL.Add(187102, ResVacantfinishToClientMessage);
MESSAGE_POOL.Add(187103, ResVacantMopUpResultToClientMessage);
MESSAGE_POOL.Add(187104, ResVacantBossSpeakToClientMessage);
MESSAGE_POOL.Add(187105, ResVacantEnterToClientMessage);
MESSAGE_POOL.Add(187106, ResVacantMopUpInfoToClientMessage);

