///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//VipDataInfo VIP信息

// 请求消息
//206201,ReqGetWeeklyAward 领取vip周奖励
//206202,ReqGetVipAward 领取vip等级奖励（没用了 消息先不删）
//206203,ReqVipDataInfo 请求VIP信息
//206210,ReqPlatformVipRewardState 请求平台vip状态判断
//206211,ReqGetPlatformVipReward 请求平台vip领奖
//206212,ReqGetVipLevelReward 请求领取vip等级奖励
//206213,ReqGetWeekRewardGift 请求领取每周礼包vip等级奖励
//206214,ReqbuyRewardGift 请求购买VIP礼包

// 接收消息
//206101,ResVipDataInfo 发送VIP信息
//206110,ResPlatformVipRewardState 发送平台VIP领奖状态


var VipDataInfo = cc.Class.extend({
	ctor:function(){
		this.exp = 0; // VIP经验
        this.vipLevel = 0; // VIP等级
        this.weekRewardRemain = 0; // 周奖励剩余可领个数 大于0就是可领取
        this.levelReward = []; // 已经领取的vip等级奖励 int
        this.weekRewardGift = []; // 已经领取每周礼包(每个等级每周都有) int
        this.buyRewardGift = []; // 已经购买的等级礼包(每个等级都有) int
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.vipLevel);
        _buf.WriteVarInt(this.weekRewardRemain);
        _buf.WriteShort( this.levelReward.length );
        for (var i = 0; i < this.levelReward.length; i++) {
            _buf.WriteVarInt(this.levelReward[i]);
        }
        _buf.WriteShort( this.weekRewardGift.length );
        for (var i = 0; i < this.weekRewardGift.length; i++) {
            _buf.WriteVarInt(this.weekRewardGift[i]);
        }
        _buf.WriteShort( this.buyRewardGift.length );
        for (var i = 0; i < this.buyRewardGift.length; i++) {
            _buf.WriteVarInt(this.buyRewardGift[i]);
        }
	},
	
	reading:function( _buf ){
		this.exp = _buf.ReadVarInt();
        this.vipLevel = _buf.ReadVarInt();
        this.weekRewardRemain = _buf.ReadVarInt();
        var levelReward_length = _buf.ReadShort();
        for (var i = 0; i < levelReward_length; i++) {
            this.levelReward[i] = _buf.ReadVarInt();
        }
        var weekRewardGift_length = _buf.ReadShort();
        for (var i = 0; i < weekRewardGift_length; i++) {
            this.weekRewardGift[i] = _buf.ReadVarInt();
        }
        var buyRewardGift_length = _buf.ReadShort();
        for (var i = 0; i < buyRewardGift_length; i++) {
            this.buyRewardGift[i] = _buf.ReadVarInt();
        }
	},
});
////////////////////
// 发送VIP信息 //
////////////////////
var ResVipDataInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.vipInfo = null; // VIP信息
	},

	getId:function(){
		return 206101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.vipInfo);
	},
	
	reading:function( _buf ){
        this.vipInfo = _buf.ReadBean(VipDataInfo);
	},

	action:function(){
		Mgr.vip.RecvResVipDataInfoMessage(this);
	},

});
////////////////////
// 发送平台VIP领奖状态 //
////////////////////
var ResPlatformVipRewardStateMessage = cc.Class.extend( {
	ctor:function(){
		this.state = 0; // 位运算 左移vip等级位 0未领 1领
	},

	getId:function(){
		return 206110;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.state);
	},
	
	reading:function( _buf ){
        this.state = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.vip.RecvResPlatformVipRewardStateMessage(this);
	},

});
////////////////////
// 领取vip周奖励 //
////////////////////
var ReqGetWeeklyAwardMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 206201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 领取vip等级奖励（没用了 消息先不删） //
////////////////////
var ReqGetVipAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.vipLevel = 0; // vip等级
	},

	getId:function(){
		return 206202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteByte(this.vipLevel);
	},
	
	reading:function( _buf ){
        this.vipLevel = _buf.ReadByte();
	},

});
////////////////////
// 请求VIP信息 //
////////////////////
var ReqVipDataInfoMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 206203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求平台vip状态判断 //
////////////////////
var ReqPlatformVipRewardStateMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 206210;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
////////////////////
// 请求平台vip领奖 //
////////////////////
var ReqGetPlatformVipRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.vipLevel = 0; // vip等级
	},

	getId:function(){
		return 206211;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vipLevel);
	},
	
	reading:function( _buf ){
        this.vipLevel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求领取vip等级奖励 //
////////////////////
var ReqGetVipLevelRewardMessage = cc.Class.extend( {
	ctor:function(){
		this.vipLevel = 0; // vip等级
	},

	getId:function(){
		return 206212;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vipLevel);
	},
	
	reading:function( _buf ){
        this.vipLevel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求领取每周礼包vip等级奖励 //
////////////////////
var ReqGetWeekRewardGiftMessage = cc.Class.extend( {
	ctor:function(){
		this.vipLevel = 0; // vip等级
	},

	getId:function(){
		return 206213;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vipLevel);
	},
	
	reading:function( _buf ){
        this.vipLevel = _buf.ReadVarInt();
	},

});
////////////////////
// 请求购买VIP礼包 //
////////////////////
var ReqbuyRewardGiftMessage = cc.Class.extend( {
	ctor:function(){
		this.vipLevel = 0; // vip等级
	},

	getId:function(){
		return 206214;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.vipLevel);
	},
	
	reading:function( _buf ){
        this.vipLevel = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(206101, ResVipDataInfoMessage);
MESSAGE_POOL.Add(206110, ResPlatformVipRewardStateMessage);

