var VipInfoPanelExt = VipInfoPanel.extend ( {
	_className:"VipInfoPanelExt",

	// 链表三件套
	_listView : null,
	_itemList:null,
	_curSelectItem:null,

	_vipLevel:null,
	_vipExp:null,
	_isEnableGet:null,

	_showEffect:null,
	_downEffect:null,

	_layOutLabel:null,

	ctor:function(){
		this._super();
		this._itemList = [];
		this._vipExp = 0;
		this._vipLevel = 0;
		this._isEnableGet = false;

        this._arrDot = [];
        this._arrDesLable = [];
	},

	Init:function() {
		var self = this;
		VipInfoPanel.prototype.Init.call(this);

        this.imgVipGrade.SetAlign(LableAlign.CENTER);
        this.imgVipGrade.SetString("0");

        // TODO 实现这部分
        this.labCue.visible = false;
        this.labCue1.visible = false;
        this.labCue2.visible = false;
        this.labCue4.visible = false;
        this.imgJiaGe.visible = false;

        this._arrDot.push(this.imgVipDian);
        this._arrDesLable.push(this.labVipPowerStr);

        this.btnBug.addClickEventListener(function(){
            if (this._vipLevel == 0) {
                Mgr.tips.ShowNotice("您还不是VIP，请先充值！");
                return;
            }else{
                if(this._vipLevel < this._curVipData.q_level){
                    Mgr.tips.ShowNotice("您的VIP等级不足，请先升级！");
                    if( Mgr.gossip.taijiPanel )
                        Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
                    return;
                }

                if(this._levelRewarded ){
                    return;
                }else{
                    Mgr.vip.SendReqGetVipAwardMessage({
                        vipLevel :  this._curVipData.q_level,
                    });
                }
            }
        }.bind(this));
        this.btnRecharge.setTitleText("升 级")
        this.btnRecharge.addClickEventListener(function(){
            // OpenFuncUtil.OpenRecharge();
            if( Mgr.gossip.taijiPanel )
                Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
        });
        this.InitScrollView();
        this.initVipRewardGrid();
        this.initVipBtn();
	},

    InitScrollView:function(){
        if(!this.scrollView){
            this.scrollView = new ccui.ScrollView();
            this.scrollView.setDirection(ccui.ScrollView.DIR_HORIZONTAL);//视图滚动方向
            this.scrollView.setTouchEnabled(true);					//触摸开启
            this.scrollView.inertiaScrollEnabled = true; 			//滚动惯性
            this.scrollView.setScrollBarEnabled(false);				//滚动条
            this.scrollView.setBounceEnabled(true);					//边界回弹
            this.scrollView.setSize(cc.size(this.imgDi.uiWidth, this.imgVipBtns.uiHeight + 5));
            this.scrollView.y = 5;
            this.imgVipBtns.addChild(this.scrollView);
        }
    },

    initVipBtn:function(){
        if(this._arrBtnVip) return;
        var p = this.scrollView;
        this.sbtnVip1.removeFromParent();

        var l = [];
        var list = Q_vip.GetList();
        var x = 0;
        for(var i=0;i!=list.length;++i){
            var btn = null;
            if(i == 0){
                btn = this.sbtnVip1;
                btn.imgVipDengJi = this.imgVipDengJi;
                btn.imgDot = this.imgDot;
            }else{
                btn = this.sbtnVip1.clone();
                x+=101;
                btn.x = x;
            }
            p.addChild(btn);
            btn.imgDot.visible = false;

            var v = list[i];
            btn.imgVipDengJi.SetString(v.q_level);
            btn.addClickEventListener(this.onBtnClicked_Vip.bind(this))
            l.push({
                btn :  btn,
                config : v,
            });
        }

        this._arrBtnVip = l;

        this.scrollView.setInnerContainerSize(cc.size(this.sbtnVip1.uiWidth + 101 * (list.length - 1 ), this.sbtnVip1.uiHeight));

        this.onBtnClicked_Vip(this.sbtnVip1);
    },
    initVipRewardGrid:function(){
        if(this._arrGrid) return;
        var p = this.grid1.getParent();

        var l = [];
        for(var i=0;i!=8;++i){
            var grid = null;
            if(i == 0){
                grid = this.grid1;
            }else{
                grid = this.grid1.Clone();
                p.addChild(grid);
                grid.x = i % 4 * 102;
                grid.y = Math.floor(i /4) ? 0 : 97;
            }
            l.push({
                grid : grid,
            });
        }
        this._arrGrid = l;
    },

    onBtnClicked_Vip:function(sender,handled){
        sender.SetButtonState("check");

        for(var k=0;k!=this._arrBtnVip.length;++k){
            var v = this._arrBtnVip[k];
            if(v.btn == sender){
                this.onVipViewChanged(v.config);
                this.scrollView.scrollToPercentHorizontal(k*100/(this._arrBtnVip.length - 1), 0.5, true);
            }else{
                if(handled) v.btn.SetButtonState("uncheck");
            }
        }
    },

    onVipViewChanged:function(cvip){
        this.imgVipGrade1.SetString(cvip.q_level);
        this.imgVipPower.x = this.imgVipGrade1.x + this.imgVipGrade1.width + 2;


        /// 左侧描述
        var data = cvip.q_introduce.split("\r")
        for(var i=0;i!=this._arrDot.length;++i){
            this._arrDot[i].visible = false;
        }
        for(var i=0;i!=this._arrDesLable.length;++i){
            this._arrDesLable[i].visible = false;
        }
        var heightDot = 282;
        var heightLabel = 295;
        for(i=0;i<data.length;++i){
            var v = data[i];
            v.replace(/\r/g,"");
            var dot =  this._arrDot[i];
            var label =  this._arrDesLable[i];
            if(dot == null){
                dot = this.imgVipDian.clone();
                dot.x = this.imgVipDian.x;
                this.imgVipDian.parent.addChild(dot);
                this._arrDot[i] = dot;
            }
            if(label == null){
                label = this.labVipPowerStr.clone();
                label.x = this.labVipPowerStr.x;
                this.labVipPowerStr.parent.addChild(label);
                this._arrDesLable[i] = label;
            }

            label.uiWidth = 370;
            label.uiHeight = null;
            label.setAnchorPoint(cc.p(0,1));
            dot.setAnchorPoint(cc.p(0,1));
            label.SetLeading(5);
            label.SetHtmlText(v);
            label.y = heightLabel;
            dot.y = heightDot;

            heightLabel -= label.GetHeight() + 10;
            heightDot -= label.GetHeight() + 10;

            label.visible = true;
            dot.visible = true;
        }

        // 右侧奖励
        var data = JSON.parse(cvip.q_vip_once_reward);
        var length = Math.max(8,data.length);
        for(i=0;i<length;++i){
            var v = data[i];
            var grid = this._arrGrid[i].grid;
            if(v){
                var data01 = ItemUtil.ItemIdToItem(v.mod,v.num);
                GridUtil.SetItemGrid(grid,data01,null,null,null,null,true);
            }else{
                grid.Clean();
            }
        }

        var data = this.data || {};
        var levelReward = data.levelReward || [];

        var rewarded = false;
        for(var i=0;i!=levelReward.length;++i){
            if(cvip.q_level == levelReward[i]){
                rewarded = true;
                break;
            }
        }


        if(this._vipLevel < cvip.q_level){
            this.btnBug.setTitleText("VIP等级不够");
        }else{
            if(rewarded){
                this.btnBug.setTitleText("已领取");
                Filter.GrayScale(this.btnBug);
            }else{
               this.btnBug.setTitleText("领取");
               Filter.UnGray(this.btnBug);
            }
        }

        this._curVipData = cvip;
        this._levelRewarded = rewarded;
    },

	SetData:function (data) {
        this.data = data;

		this._vipExp = 0;
		this._vipLevel = 0;
		this._isEnableGet = false;
		if ( data ) {
			this._vipExp = data.exp;
			this._vipLevel = data.vipLevel;
			this._isEnableGet = data.weekRewardRemain > 0 ? true:false;
		}

		// vip level
		this.imgVipGrade.SetString(this._vipLevel);

		// rate
		var curExp = Mgr.gossip.taijiExp;//this._vipExp;
        var info = Q_vip.Get(this._vipLevel + 1);
        var needExp = info ? info.q_exp : curExp;

		UIUtil.ConnectLabelHtmlText( this.labRate, [curExp, needExp] );
		var rate = parseFloat(curExp / needExp)*100;
		this.progRate.setPercent(rate);


        var levelReward = data.levelReward || [];

        var rewardConf = null;
        for(var i=0;i!=this._arrBtnVip.length;++i){
            var v = this._arrBtnVip[i];
            var rewarded = false;
            for(var j=0;j!=levelReward.length;++j){
                if(v.config.q_level == levelReward[j]){
                    rewarded = true;
                    break;
                }
            }
            if(!rewarded && this._vipLevel >= v.config.q_level) {
                rewardConf = v;
            }
            UIUtil.SetRedTipVisible(v.btn.imgDot, !rewarded && this._vipLevel >= v.config.q_level);
        }

        /// 有可以领奖的，跳过去
        if(rewardConf){
            this.onBtnClicked_Vip(rewardConf.btn,true);
            this.__firstTime = true;
        }else{
            /// 第一次进界面转至当前玩家等级
            if(!this.__firstTime){
                var level = this._vipLevel || 1;
                this.onBtnClicked_Vip(this._arrBtnVip[level - 1].btn,true);
                this.__firstTime = true;
            }else{
                this.onVipViewChanged(this._curVipData);
            }
        }
	},

	OnShow:function () {
        this.__firstTime = false;
		Mgr.vip.SendReqVipDataInfoMessage();
	},
} );
VipInfoPanelExt.PanelName = "VipInfoPanelExt";
PanelClassDic["VipInfoPanelExt"] = VipInfoPanelExt;
