var VipInfoPanelExt = VipInfoPanel.extend ( {
	_className:"VipInfoPanelExt",

	// 链表三件套
	_listView : null,
	_itemList:null,
	_curSelectItem:null,

	_maxVip:null,
	_vipLevel:null,
	_vipExp:null,
	_isEnableGet:null,

	_showEffect:null,
	_downEffect:null,

	_layOutLabel:null,

	ctor:function(){
		this._super();
		this._itemList = [];
		this._vipExp = 0;
		this._vipLevel = 0;
		this._isEnableGet = false;
	},

	Init:function() {
		var self = this;
		VipInfoPanel.prototype.Init.call(this);

		this._InitParam();

		this.btnRecharge.addClickEventListener(function (event) {
			OpenFuncUtil.OpenRecharge();
		});

		this.btnGet.addClickEventListener(function (event) {
			if ( self._vipLevel <= 0 ) {
				Mgr.tips.ShowNotice("您还不是VIP，请先充值！");
				return;
			}

			Mgr.vip.SendReqGetWeeklyAwardMessage();
		});

		this.btnGeted.addClickEventListener(function (event) {
			Mgr.tips.ShowNotice("已领取奖励!");
		});
	},

	_InitPosition:function () {
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function () {
		this._InitPosition();
		this._CreateListView();
		this._CreateLableScross();

		this.labCue.visible = false;
		this.labVipPowerStr.retain();
		this.labVipPowerStr.SetLeading(7);
		this.labVipPowerStr.removeFromParent();
	},

	_CreateLableScross:function () {
		// listView 2
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.labVipPowerStr.uiWidth, this.labVipPowerStr.uiHeight));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.addEventListener(this._SelectedItemEvent);
		list.setItemsMargin(1);
		list.setAnchorPoint(0, 0);
		list.setPosition(this.labVipPowerStr.x,this.labVipPowerStr.y);
		this.labVipPowerStr.parent.addChild(list);
		this._listView2 = list;
	},

	_CreateListView:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg1.width, this.imgBg1.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.addEventListener(this._SelectedItemEvent);
		list.setItemsMargin(1);
		list.setAnchorPoint(0, 0);
		list.setPosition(0,0);
		this.imgBg1.addChild(list);
		this._listView = list;

		this._LaodItems();
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:
				var parent = sender.parent.parent;
				if ( parent._curSelectItem != null) {
					parent._curSelectItem.SetSelect(false);
					parent._curSelectItem = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent._curSelectItem = itemSelect;
				parent._SetClick(itemSelect);
				break;

			default:
				break;
		}
	},

	_LaodItems:function () {
		var list = Q_vip.GetList();
		this._maxVip = list.length;
		for ( var i = 0; i != list.length; i++ ) {
			var item;
			if ( i < this._itemList.length )
				item = this._itemList[i];
			else {
				item = new VipGradeButtonExt();
				item.LoadPanel();
				item.retain();
				this._itemList.push(item);
			}
			item.SetData( list[i] );
			if (this._listView.getIndex(item) == -1)
				this._AddItem(item);
		}
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	SetData:function (data) {
		this._vipExp = 0;
		this._vipLevel = 0;
		this._isEnableGet = false;
		if ( data ) {
			this._vipExp = data.exp;
			this._vipLevel = data.vipLevel;
			this._isEnableGet = data.weekRewardRemain > 0 ? true:false;
		}

		// vip level
		this.labVipGrade.SetString(this._vipLevel);

		// rate
		var curExp = this._vipExp;
		var needExp = 0;
		if ( this._vipLevel >= this._maxVip ) {
			needExp = curExp;
		}
		else {
			var lv = this._vipLevel + 1;
			var info = Q_vip.Get(lv);
			needExp = info.q_exp;
		}
		UIUtil.ConnectLabelHtmlText( this.labRate, [curExp, needExp] );
		var rate = parseFloat(curExp / needExp)*100;
		this.progRate.setPercent(rate);

		//count
		this.labCue1.SetText(TextUtil.ConectParam(this.labCue1.GetHtmlText(), [(data.vipLevel - data.weekRewardRemain),10]));


		this.btnGet.visible = false;
		this.btnGeted.visible = false;

		this.labBoxDes.visible = false;
		this.labBoxDes1.visible = false;
		this.labBoxDes11.visible = false;
		// is get
		if ( this._vipLevel == 0 ) {
			this.labBoxDes1.visible = true;
			this.btnGet.visible = true;
		}
		else {
			if ( !this._isEnableGet ) {  // 已领取
				this.labBoxDes11.visible = true;
				this.btnGeted.visible = true;
			}
			else {
				this.labBoxDes.visible = true;
				UIUtil.ConnectLabelHtmlText( this.labBoxDes, [this._vipLevel, data.weekRewardRemain] );
				this.btnGet.visible = true;
			}
		}

		if ( !this._curSelectItem ) {
			var item;
			var items = this._listView.getItems();
			for ( var i = 0; i != items.length; i++ ) {
				var info = items[i].GetData();
				var curLv = this._vipLevel > 0 ? this._vipLevel : 1;
				if ( info.q_level == curLv ) {
					item = items[i];
					break;
				}
			}

			if ( item ) {
				item.SetSelect(true);
				this._curSelectItem = item;
				this._SetClick(item);
			}
		}
	},

	_SetClick:function (item) {

		// if ( !this._layOutLabel ) {
		// 	this._layOutLabel = new ccui.Layout();
		// 	this._listView2.pushBackCustomItem(this._layOutLabel);
		// }

		// label

		var vipData = item.GetData();
		var modelUrl = "";
		var modelX = 0;
		var modelY = 70;
		var modelAction = "stand5";
		var modelScale = 1;
		var downUrl = "";
		var downX = 0;
		var downY = 70;
		switch (vipData.q_level){
			case 1:
				modelUrl = "113";
				downUrl = "114";
				modelY = downY = 60;
				break;
			case 2:
			case 3:
			case 4:
				modelUrl = "84";
				break;
			case 5:
				modelUrl = "82";
				break;
			case 6:
				modelUrl = "76";
				break;
			case 7:
				modelUrl = "roleshow/player/1105";
				// downUrl = "27";
				modelAction = "stand";
				modelY = -60;
				break;
			case 8:
				modelUrl = "81";
				break;
			case 9:
				modelUrl = "1000";
				break;
			case 10:
				modelUrl = "2049";
				break;
		}

		if( downUrl ){
			if( !this._downEffect ){
				this._downEffect = new MAnimationObject();
				this.imgIco.addChild(this._downEffect);
			}
			this._downEffect.x = downX;
			this._downEffect.y = downY;
			this._downEffect.SetResUrlBase( "res/animation/effect/ui/" + downUrl );
			this._downEffect.DoAction("stand5", 0, EnumDefaultResType.NONE);
			this._downEffect.visible = true;
		}
		else if( this._downEffect ){
			this._downEffect.visible = false;
		}

		if( !this._showEffect ){
			this._showEffect = new MAnimationObject();
			this.imgIco.addChild(this._showEffect);
		}
		this._showEffect.x = modelX;
		this._showEffect.y = modelY;
		this._showEffect.scale = modelScale;
		this._showEffect.SetResUrlBase( "res/animation/effect/ui/" + modelUrl );
		this._showEffect.DoAction(modelAction, 0, EnumDefaultResType.NONE);




		this.labVipPowerStr.SetHtmlText(vipData.q_introduce);
		if ( this.labVipPowerStr.parent )
			this.labVipPowerStr.removeFromParent();
		this._listView2.removeAllChildren();
		this._listView2.pushBackCustomItem(this.labVipPowerStr);
		var height = this.labVipPowerStr._textHeight * this.labVipPowerStr.GetRows();
		// 超出范围才可滑动
		if ( this._listView2.getContentSize().height >= height )
			this._listView2.setTouchEnabled(false);
		else
			this._listView2.setTouchEnabled(true);
	},

	OnShow:function () {
		Mgr.vip.SendReqVipDataInfoMessage();
	},
} );
VipInfoPanelExt.PanelName = "VipInfoPanelExt";
PanelClassDic["VipInfoPanelExt"] = VipInfoPanelExt;
