///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//VitalityTaskInfo 活跃度任务信息
//VitalityInfo 活跃度信息

// 请求消息
//205201,ReqGetAward 领取活跃度奖励
//205202,ReqGetVTaskAward 领取活跃度任务奖励

// 接收消息
//205101,ResSendVitalityInfo 发送活跃度信息


var VitalityTaskInfo = cc.Class.extend({
	ctor:function(){
		this.model = 0; // 任务ModelId
        this.count = 0; // 完成次数
        this.state = 0; // 领奖状态(单个任务的奖励0不可领取 1可领取 2已领取)
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.model);
        _buf.WriteVarInt(this.count);
        _buf.WriteByte(this.state);
	},
	
	reading:function( _buf ){
		this.model = _buf.ReadVarInt();
        this.count = _buf.ReadVarInt();
        this.state = _buf.ReadByte();
	},
});
var VitalityInfo = cc.Class.extend({
	ctor:function(){
		this.value = 0; // 当前活跃度
        this.history = 0; // 历史活跃度
        this.taskInfos = []; // 任务列表 VitalityTaskInfo
        this.hasGetAwardList = []; // 已经领取的活跃度奖励(活跃度值奖励) int
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.value);
        _buf.WriteVarInt(this.history);
        _buf.WriteShort( this.taskInfos.length );
        for (var i = 0; i < this.taskInfos.length; i++) {
            _buf.WriteBean(this.taskInfos[i]);
        }
        _buf.WriteShort( this.hasGetAwardList.length );
        for (var i = 0; i < this.hasGetAwardList.length; i++) {
            _buf.WriteVarInt(this.hasGetAwardList[i]);
        }
	},
	
	reading:function( _buf ){
		this.value = _buf.ReadVarInt();
        this.history = _buf.ReadVarInt();
        var taskInfos_length = _buf.ReadShort();
        for (var i = 0; i < taskInfos_length; i++) {
            this.taskInfos[i] = _buf.ReadBean(VitalityTaskInfo);
        }
        var hasGetAwardList_length = _buf.ReadShort();
        for (var i = 0; i < hasGetAwardList_length; i++) {
            this.hasGetAwardList[i] = _buf.ReadVarInt();
        }
	},
});
////////////////////
// 发送活跃度信息 //
////////////////////
var ResSendVitalityInfoMessage = cc.Class.extend( {
	ctor:function(){
		this.vitalityInfo = null; // 活跃度信息
	},

	getId:function(){
		return 205101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteBean(this.vitalityInfo);
	},
	
	reading:function( _buf ){
        this.vitalityInfo = _buf.ReadBean(VitalityInfo);
	},

	action:function(){
		Mgr.vitality.RecvResSendVitalityInfoMessage(this);
	},

});
////////////////////
// 领取活跃度奖励 //
////////////////////
var ReqGetAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.awardModel = 0; // 奖励model
	},

	getId:function(){
		return 205201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.awardModel);
	},
	
	reading:function( _buf ){
        this.awardModel = _buf.ReadVarInt();
	},

});
////////////////////
// 领取活跃度任务奖励 //
////////////////////
var ReqGetVTaskAwardMessage = cc.Class.extend( {
	ctor:function(){
		this.taskModel = 0; // 活跃度任务类型
	},

	getId:function(){
		return 205202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.taskModel);
	},
	
	reading:function( _buf ){
        this.taskModel = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(205101, ResSendVitalityInfoMessage);

