///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//WeddingInfo 婚宴信息

// 请求消息
//166201,ReqWeddinginfoToGame 获取婚宴信息列表
//166204,ReqReserveWeddingToGame 请求预定下次的婚宴

// 接收消息
//166101,ResWeddinginfoToClient 返回婚宴信息列表
//166102,ResWeddingStateToClient 返回当前婚宴信息（上线和改变的时候发）
//166105,ResWeddingOrderSuccessToClient 返回自己成功预订婚宴信息


var WeddingInfo = cc.Class.extend({
	ctor:function(){
		this.index = 0; // 场次
        this.marriageId = null; // 婚姻id
        this.playerA = null; // 玩家1名字
        this.jobA = 0; // 玩家1职业
        this.playerB = null; // 玩家2名字
        this.jobB = 0; // 玩家2职业
        this.type = 0; // 婚宴类型
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
        _buf.WriteLong(this.marriageId);
        _buf.WriteString(this.playerA);
        _buf.WriteByte(this.jobA);
        _buf.WriteString(this.playerB);
        _buf.WriteByte(this.jobB);
        _buf.WriteVarInt(this.type);
	},

	reading:function( _buf ){
		this.index = _buf.ReadVarInt();
        this.marriageId = _buf.ReadLong();
        this.playerA = _buf.ReadString();
        this.jobA = _buf.ReadByte();
        this.playerB = _buf.ReadString();
        this.jobB = _buf.ReadByte();
        this.type = _buf.ReadVarInt();
	},
});
////////////////////
// 返回婚宴信息列表 //
////////////////////
var ResWeddinginfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.WeddingInfolist = []; // 婚宴信息列表 WeddingInfo
        this.weddingOrderlist = []; // 参与预订下一场的婚宴信息列表 WeddingInfo
	},

	getId:function(){
		return 166101;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteUShort( this.WeddingInfolist.length );
        for (var i = 0; i < this.WeddingInfolist.length; i++) {
            _buf.WriteBean(this.WeddingInfolist[i]);
        }
        _buf.WriteUShort( this.weddingOrderlist.length );
        for (var i = 0; i < this.weddingOrderlist.length; i++) {
            _buf.WriteBean(this.weddingOrderlist[i]);
        }
	},

	reading:function( _buf ){
        var WeddingInfolist_length = _buf.ReadUShort();
        for (var i = 0; i < WeddingInfolist_length; i++) {
            this.WeddingInfolist[i] = _buf.ReadBean(WeddingInfo);
        }
        var weddingOrderlist_length = _buf.ReadUShort();
        for (var i = 0; i < weddingOrderlist_length; i++) {
            this.weddingOrderlist[i] = _buf.ReadBean(WeddingInfo);
        }
	},

	action:function(){
		Mgr.wedding.RecvResWeddinginfoToClientMessage(this);
	},

});
////////////////////
// 返回当前婚宴信息（上线和改变的时候发） //
////////////////////
var ResWeddingStateToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.index = 0; // 场次（0表示没有正在进行的婚礼）
        this.state = 0; // 1开始 2结束
        this.playerIdA = null; // 婚宴玩家1的id
        this.playerIdB = null; // 婚宴玩家2的id
        this.marriageId = null; // 婚宴唯一id
	},

	getId:function(){
		return 166102;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
        _buf.WriteVarInt(this.state);
        _buf.WriteLong(this.playerIdA);
        _buf.WriteLong(this.playerIdB);
        _buf.WriteLong(this.marriageId);
	},

	reading:function( _buf ){
        this.index = _buf.ReadVarInt();
        this.state = _buf.ReadVarInt();
        this.playerIdA = _buf.ReadLong();
        this.playerIdB = _buf.ReadLong();
        this.marriageId = _buf.ReadLong();
	},

	action:function(){
		Mgr.wedding.RecvResWeddingStateToClientMessage(this);
	},

});
////////////////////
// 返回自己成功预订婚宴信息 //
////////////////////
var ResWeddingOrderSuccessToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.info = null; // 成功预订婚宴信息
	},

	getId:function(){
		return 166105;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteBean(this.info);
	},

	reading:function( _buf ){
        this.info = _buf.ReadBean(WeddingInfo);
	},

	action:function(){
		Mgr.wedding.RecvResWeddingOrderSuccessToClientMessage(this);
	},

});
////////////////////
// 获取婚宴信息列表 //
////////////////////
var ReqWeddinginfoToGameMessage = cc.Class.extend( {
	ctor:function(){

	},

	getId:function(){
		return 166201;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){

	},

	reading:function( _buf ){

	},

});
////////////////////
// 请求预定下次的婚宴 //
////////////////////
var ReqReserveWeddingToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.index = 0; // 预定场次(1开始)
        this.type = 0; // 婚宴类型
	},

	getId:function(){
		return 166204;
	},

	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.index);
        _buf.WriteVarInt(this.type);
	},

	reading:function( _buf ){
        this.index = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(166101, ResWeddinginfoToClientMessage);
MESSAGE_POOL.Add(166102, ResWeddingStateToClientMessage);
MESSAGE_POOL.Add(166105, ResWeddingOrderSuccessToClientMessage);

