var DuorenFrameExt = DuorenFrame.extend ( {
	_className:"DuorenFrameExt",
	isTeam:false,
	data:null,
	index:null,
	ctor:function(data,index){
		this._super();
		this.data = data;
		this.index = index;
	},
	Init:function()
	{
		DuorenFrame.prototype.Init.call(this);
		this._HandleButton();
		this._JugementAndControl(this.data);
	},
	_HandleButton:function()
	{
		var self = this,data = this.data;
		this.btnJiaru.addClickEventListener(function()
		{
			var msg = {
				teamid : data.teamId, // 队伍Id（id为0表示快速加入）
				zoneModelId : data.zoneModelId, // 副本模版
				passWord : null, // 队伍密码
			}
			var type = Mgr.zoneteam.GetDuorenPanel().zonetype;
			if(type == EnumZoneType.TYPE_LFDR)
			{
				var readyNum = Mgr.zoneteam.GetDuorenPanel().mainPanel.isAutoReady ? 1 : 0;
				Mgr.zoneteam.SendReqZoneTeamJoinClientToGameMessage(data.teamId,readyNum, EnumZoneType.TYPE_LFDR);
			}
			else if(type == EnumZoneType.TYPE_KFDR)
			{
				Mgr.crossteam.SendReqJoinCrossTeamClientToGameMessage(msg);
			}
		});
		this.btnYaoqing.addClickEventListener(function()
		{
			if(Mgr.crossteam.JugementTeamMaster())//队长
			{
				EngineMgr.uiMgr.ShowPanelByType(YaoqingMainExt.PanelName,UIMgr.PANEL_LAYER_TOP);
			}
			else
			{
				Mgr.tips.ShowNotice("无权限");
			}
		});
		this.btnOut.addClickEventListener(function()
		{
			if(Mgr.crossteam.JugementTeamMaster())//队长
			{
				var type = Mgr.zoneteam.GetDuorenPanel().zonetype;
				if(type == EnumZoneType.TYPE_LFDR)
				{
					Mgr.zoneteam.SendReqZoneTeamPickClientToGameMessage(self.data.memberId);
				}
				else if(type == EnumZoneType.TYPE_KFDR)
				{
					Mgr.crossteam.SendReqKickMemberClientToGameMessage(self.data.memberId);
				}
			}
			else
			{
				Mgr.tips.ShowNotice("无权限");
			}
		});
	},
	_JugementAndControl:function(data)
	{
		if(data)
		{
			this.isTeam = this.data.teamId ? true : false;
			this.imgA1.visible = this.isTeam;
			this.imgA.visible = !this.isTeam;
			this.btnYaoqing.visible = false;
			this.btnOut.visible = false;
			this.imgHead.visible = false;
			this.labName.visible = true;
			this.labKongwei.visible = false;
			this.SetInformation(data);
			this._SetZhunbeiState();
		}
		else
		{
			this.btnOut.visible = false;
			this.imgA.visible = false;
			this.imgA1.visible = false;
			this.imgHead.visible = false;
			this.labName.visible = false;
			this.btnYaoqing.visible = true;
			this.labKongwei.visible =  true;
		}
	},
	SetInformation:function(data)
	{
        var mainPanel = Mgr.zoneteam.GetDuorenPanel().mainPanel;
		var type = Mgr.zoneteam.GetDuorenPanel().zonetype;
		this.data = data;
		if(this.isTeam)
		{
			if(type == EnumZoneType.TYPE_LFDR)
			{
				this.labZhanli1.SetString("战斗力需求："+0);
			}
			else if(type == EnumZoneType.TYPE_KFDR)
			{
				this.labZhanli1.SetString("战斗力需求：" + (data.needFightPower || 0));
			}
			this.labNumber.SetString(data.memberinfo.length+"/"+EnumCrossteamType.TEAM_MEM_NUMBER);
			if(data.memberinfo[0])
			{
				this.labName.SetString(data.memberinfo[0].name);
			}
		}
		else
		{
			this.labZhanli.SetString("战斗力："+data.fightPower);
			this.labName.SetString(data.name);
			if(this.index == EnumCrossteamType.TEAM_CAPTAIN)//队长
			{
				this.labZhunbei.visible = false;
				this.labDuizhang.visible =true;
				if(data.isReady != EnumCrossteamType.STATE_READY)
				{
					if(type == EnumZoneType.TYPE_LFDR)
					{
						Mgr.zoneteam.SendReqZoneTeamReadyClientToGameMessage(EnumCrossteamType.STATE_READY);
					}
					else if(type == EnumZoneType.TYPE_KFDR)
					{
						Mgr.crossteam.SendReqChangeStateClientToGameMessage(EnumCrossteamType.STATE_READY, mainPanel.selectedItem.data.base.zoneModelid);
					}
				}
			}
			else
			{
				this.btnOut.visible = true;
				this.labDuizhang.visible =false;
				if(data.isReady == EnumCrossteamType.STATE_READY)
				{
					this.labZhunbei.visible =  true;
				}
				else
				{
					this.labZhunbei.visible =  false;
				}
			}
			var pId = Mgr.player.mainPlayer.sid.toGID();
			if(data.memberId.toGID() == pId)
			{
				var panel = Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName ).mainPanel;
				panel.UpdateButtonState(this.index, data);
			}
			if(!Mgr.crossteam.JugementTeamMaster())
			{
				this.btnOut.visible = false;
			}
		}
	},
	_SetZhunbeiState:function()
	{
		var mainPanel = Mgr.zoneteam.GetDuorenPanel().mainPanel;
		var typee = Mgr.zoneteam.GetDuorenPanel().zonetype;
		if(mainPanel.isAutoReady && this.data.isReady == EnumCrossteamType.STATE_READY_NOT&&!Mgr.crossteam.isCancelReady)
		{
			if(typee == EnumZoneType.TYPE_LFDR)
			{
				Mgr.zoneteam.SendReqZoneTeamReadyClientToGameMessage(EnumCrossteamType.STATE_READY);
			}
			else if(typee == EnumZoneType.TYPE_KFDR)
			{
				Mgr.crossteam.SendReqChangeStateClientToGameMessage(EnumCrossteamType.STATE_READY, mainPanel.selectedItem.data.base.zoneModelid);
			}
		}
	},
	UpdateFrameData:function(data)
	{
		this.data = data;
		this._JugementAndControl(data);
	}
} );
DuorenFrameExt.PanelName = "DuorenFrameExt";
PanelClassDic["DuorenFrameExt"] = DuorenFrameExt;
