///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ZoneBasicInfo 副本基本信息

// 请求消息
//155201,ReqZoneBasicObtainToGame 获取副本信息
//155202,ReqZoneEnterToGame 进入副本
//155203,ReqleZoneSweepToGame 扫荡副本
//155204,ReqZoneOutToGame 前端请求退出副本
//155205,ReqPayZoneToGame 前端购买副本次数
//155206,ReqExpFirstRewardToGame 前端请求领取经验副本首通奖励
//155207,ReqClimbTowerFirstRewardToGame 前端请求领取爬塔副本首通奖励
//155208,ReqClimbTowerFasionToGame 前端请求改变爬塔王者造型

// 接收消息
//155101,ResZoneBasicInfoObtainToClient 返回前端副本信息
//155102,ResZoneClearanceToClient 返回前端副本通关
//155103,ResZoneFailureToClient 返回副本失败消息(所有副本通用)
//155104,ResZoneTrackingToClient 返回副本追踪内容信息
//155105,ResZoneCountdownToClient 副本通用倒计时（通用！！）
//155106,ResExpZoneInfoToClient 返回求经验副本信息
//155107,ResExpZoneResultToClient 返回经验副本挑战结果
//155108,ResClimbTowerZoneInfoToClient 返回求爬塔副本信息
//155109,ResClimbTowerZoneResultToClient 返回爬塔副本挑战结果
//155110,ResClimbTowerFasionToClient 返回爬塔王者造型信息


var ZoneBasicInfo = cc.Class.extend({
	ctor:function(){
		this.isFirst = 0; // 是否首次,1首次
        this.zoneModelid = 0; // 副本模组ID
        this.crossnum = 0; // 今日通关次数
        this.paynum = 0; // 今日已经购买次数
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.isFirst);
        _buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.crossnum);
        _buf.WriteVarInt(this.paynum);
	},
	
	reading:function( _buf ){
		this.isFirst = _buf.ReadVarInt();
        this.zoneModelid = _buf.ReadVarInt();
        this.crossnum = _buf.ReadVarInt();
        this.paynum = _buf.ReadVarInt();
	},
});
////////////////////
// 返回前端副本信息 //
////////////////////
var ResZoneBasicInfoObtainToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // zonetype
        this.zoneInfos = []; // 副本信息列表 ZoneBasicInfo
	},

	getId:function(){
		return 155101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteShort( this.zoneInfos.length );
        for (var i = 0; i < this.zoneInfos.length; i++) {
            _buf.WriteBean(this.zoneInfos[i]);
        }
	},
	
	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        var zoneInfos_length = _buf.ReadShort();
        for (var i = 0; i < zoneInfos_length; i++) {
            this.zoneInfos[i] = _buf.ReadBean(ZoneBasicInfo);
        }
	},

	action:function(){
		Mgr.zone.RecvResZoneBasicInfoObtainToClientMessage(this);
	},

});
////////////////////
// 返回前端副本通关 //
////////////////////
var ResZoneClearanceToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
        this.time = 0; // 通关用时(秒)
	},

	getId:function(){
		return 155102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResZoneClearanceToClientMessage(this);
	},

});
////////////////////
// 返回副本失败消息(所有副本通用) //
////////////////////
var ResZoneFailureToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本ID
	},

	getId:function(){
		return 155103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResZoneFailureToClientMessage(this);
	},

});
////////////////////
// 返回副本追踪内容信息 //
////////////////////
var ResZoneTrackingToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本ID
        this.deployNum = 0; // 怪物波次
        this.countdown = 0; // 当前波次倒计时(秒)(0就是没用)
        this.monsterSum = 0; // 当前波次怪物总数
        this.monsterNum = []; // 当前波次活着怪物数 int
        this.monsterid = []; // 当前波次活着怪物ID int
	},

	getId:function(){
		return 155104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.deployNum);
        _buf.WriteVarInt(this.countdown);
        _buf.WriteVarInt(this.monsterSum);
        _buf.WriteShort( this.monsterNum.length );
        for (var i = 0; i < this.monsterNum.length; i++) {
            _buf.WriteVarInt(this.monsterNum[i]);
        }
        _buf.WriteShort( this.monsterid.length );
        for (var i = 0; i < this.monsterid.length; i++) {
            _buf.WriteVarInt(this.monsterid[i]);
        }
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
        this.deployNum = _buf.ReadVarInt();
        this.countdown = _buf.ReadVarInt();
        this.monsterSum = _buf.ReadVarInt();
        var monsterNum_length = _buf.ReadShort();
        for (var i = 0; i < monsterNum_length; i++) {
            this.monsterNum[i] = _buf.ReadVarInt();
        }
        var monsterid_length = _buf.ReadShort();
        for (var i = 0; i < monsterid_length; i++) {
            this.monsterid[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.zone.RecvResZoneTrackingToClientMessage(this);
	},

});
////////////////////
// 副本通用倒计时（通用！！） //
////////////////////
var ResZoneCountdownToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本ID
        this.type = 0; // 倒计时类型
        this.time = 0; // 倒计时秒
	},

	getId:function(){
		return 155105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
        _buf.WriteVarInt(this.type);
        _buf.WriteVarInt(this.time);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
        this.time = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResZoneCountdownToClientMessage(this);
	},

});
////////////////////
// 返回求经验副本信息 //
////////////////////
var ResExpZoneInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.nowWave = 0; // 当前波数（1开始）
        this.maxWave = 0; // 最大挑战波数
        this.fristRewardWave = []; // 领取过的首通奖励的关卡数 int
        this.challengeTimes = 0; // 可挑战次数
	},

	getId:function(){
		return 155106;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.nowWave);
        _buf.WriteVarInt(this.maxWave);
        _buf.WriteShort( this.fristRewardWave.length );
        for (var i = 0; i < this.fristRewardWave.length; i++) {
            _buf.WriteVarInt(this.fristRewardWave[i]);
        }
        _buf.WriteVarInt(this.challengeTimes);
	},
	
	reading:function( _buf ){
        this.nowWave = _buf.ReadVarInt();
        this.maxWave = _buf.ReadVarInt();
        var fristRewardWave_length = _buf.ReadShort();
        for (var i = 0; i < fristRewardWave_length; i++) {
            this.fristRewardWave[i] = _buf.ReadVarInt();
        }
        this.challengeTimes = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResExpZoneInfoToClientMessage(this);
	},

});
////////////////////
// 返回经验副本挑战结果 //
////////////////////
var ResExpZoneResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.nowWave = 0; // 当前波数
        this.result = 0; // 1挑战成功 2挑战失败
	},

	getId:function(){
		return 155107;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.nowWave);
        _buf.WriteVarInt(this.result);
	},
	
	reading:function( _buf ){
        this.nowWave = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResExpZoneResultToClientMessage(this);
	},

});
////////////////////
// 返回求爬塔副本信息 //
////////////////////
var ResClimbTowerZoneInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.nowWave = 0; // 当前波数（1开始）
        this.maxWave = 0; // 最大挑战波数
        this.fristRewardWave = []; // 领取过的首通奖励的关卡数 int
        this.challengeTimes = 0; // 可挑战次数
	},

	getId:function(){
		return 155108;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.nowWave);
        _buf.WriteVarInt(this.maxWave);
        _buf.WriteShort( this.fristRewardWave.length );
        for (var i = 0; i < this.fristRewardWave.length; i++) {
            _buf.WriteVarInt(this.fristRewardWave[i]);
        }
        _buf.WriteVarInt(this.challengeTimes);
	},
	
	reading:function( _buf ){
        this.nowWave = _buf.ReadVarInt();
        this.maxWave = _buf.ReadVarInt();
        var fristRewardWave_length = _buf.ReadShort();
        for (var i = 0; i < fristRewardWave_length; i++) {
            this.fristRewardWave[i] = _buf.ReadVarInt();
        }
        this.challengeTimes = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResClimbTowerZoneInfoToClientMessage(this);
	},

});
////////////////////
// 返回爬塔副本挑战结果 //
////////////////////
var ResClimbTowerZoneResultToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.nowWave = 0; // 当前波数
        this.result = 0; // 1挑战成功 2挑战失败
	},

	getId:function(){
		return 155109;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.nowWave);
        _buf.WriteVarInt(this.result);
	},
	
	reading:function( _buf ){
        this.nowWave = _buf.ReadVarInt();
        this.result = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResClimbTowerZoneResultToClientMessage(this);
	},

});
////////////////////
// 返回爬塔王者造型信息 //
////////////////////
var ResClimbTowerFasionToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.type = 0; // 0没有使用 ，1使用中 (对王者本人有效)
        this.wingId = null; // 0没有 ，王者id
        this.wingName = null; // 王者名字
        this.wingWave = 0; // 王者最大通关层数
	},

	getId:function(){
		return 155110;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.type);
        _buf.WriteLong(this.wingId);
        _buf.WriteString(this.wingName);
        _buf.WriteVarInt(this.wingWave);
	},
	
	reading:function( _buf ){
        this.type = _buf.ReadVarInt();
        this.wingId = _buf.ReadLong();
        this.wingName = _buf.ReadString();
        this.wingWave = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zone.RecvResClimbTowerFasionToClientMessage(this);
	},

});
////////////////////
// 获取副本信息 //
////////////////////
var ReqZoneBasicObtainToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // 副本zonetype
	},

	getId:function(){
		return 155201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
	},
	
	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
	},

});
////////////////////
// 进入副本 //
////////////////////
var ReqZoneEnterToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
	},

	getId:function(){
		return 155202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
	},

});
////////////////////
// 扫荡副本 //
////////////////////
var ReqleZoneSweepToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zonetype = 0; // zonetype
        this.zoneModelid = 0; // 副本模组ID
	},

	getId:function(){
		return 155203;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zonetype);
        _buf.WriteVarInt(this.zoneModelid);
	},
	
	reading:function( _buf ){
        this.zonetype = _buf.ReadVarInt();
        this.zoneModelid = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求退出副本 //
////////////////////
var ReqZoneOutToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
	},

	getId:function(){
		return 155204;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
	},

});
////////////////////
// 前端购买副本次数 //
////////////////////
var ReqPayZoneToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.zoneModelid = 0; // 副本模组ID
	},

	getId:function(){
		return 155205;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.zoneModelid);
	},
	
	reading:function( _buf ){
        this.zoneModelid = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求领取经验副本首通奖励 //
////////////////////
var ReqExpFirstRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.wave = 0; // 层数
	},

	getId:function(){
		return 155206;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.wave);
	},
	
	reading:function( _buf ){
        this.wave = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求领取爬塔副本首通奖励 //
////////////////////
var ReqClimbTowerFirstRewardToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.wave = 0; // 层数
	},

	getId:function(){
		return 155207;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.wave);
	},
	
	reading:function( _buf ){
        this.wave = _buf.ReadVarInt();
	},

});
////////////////////
// 前端请求改变爬塔王者造型 //
////////////////////
var ReqClimbTowerFasionToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.modle = 0; // 造型模型
        this.type = 0; // 0使用 ，1取消使用
	},

	getId:function(){
		return 155208;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.modle);
        _buf.WriteVarInt(this.type);
	},
	
	reading:function( _buf ){
        this.modle = _buf.ReadVarInt();
        this.type = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(155101, ResZoneBasicInfoObtainToClientMessage);
MESSAGE_POOL.Add(155102, ResZoneClearanceToClientMessage);
MESSAGE_POOL.Add(155103, ResZoneFailureToClientMessage);
MESSAGE_POOL.Add(155104, ResZoneTrackingToClientMessage);
MESSAGE_POOL.Add(155105, ResZoneCountdownToClientMessage);
MESSAGE_POOL.Add(155106, ResExpZoneInfoToClientMessage);
MESSAGE_POOL.Add(155107, ResExpZoneResultToClientMessage);
MESSAGE_POOL.Add(155108, ResClimbTowerZoneInfoToClientMessage);
MESSAGE_POOL.Add(155109, ResClimbTowerZoneResultToClientMessage);
MESSAGE_POOL.Add(155110, ResClimbTowerFasionToClientMessage);

