﻿//副本类型
var EnumZoneType = EnumZoneType || {
	/**
	 *剧情副本
	 */
	TYPE_JQ : 1,
	/**
	 *进阶副本
	 */
	TYPE_JJ : 2,
	/**
	 *经验副本
	 */
	TYPE_JY : 3,
	/**
	 *问鼎江湖
	 */
	TYPE_WD : 5,
	/**
	 *VIP
	 */
	TYPE_VIP : 4,
	/**
	 * 跨服多人组队副本
	 */
	TYPE_KFDR : 6,
	/**
	 * 帮会BOSS副本
	 */
	TYPE_GUILDBOSS : 7,
	/**
	 * 华山论剑
	 */
	TYPE_SWORD : 8,
	/**
	 * 连服多人组队副本
	 */
	TYPE_LFDR : 9,
    /**
     * 心魔副本
     */
    TYPE_XINGMO : 10,
    /**
     * 帮会争霸
     */
	TYPE_KINGGUID : 12,
    /**
     * 皇城战
     */
	TYPE_KINGNEUTRAL : 13,
    TYPE_QINGYUAN : 16,     /// 情缘副本
	/**
     * 恶人谷
     */
    TYPE_ERENGU : 17,
    /**
     * 光武悬赏
     */
    TYPE_GUANGWU : 101,
};

var ZoneModMgr = ZoneModMgr || cc.Class.extend({
	battleZoneBackGroundPanel:null,
	_vipArr:null,
	_zoneVipHash:null,
	_zoneIdHash:null,
	_storyZoneHash:null,
	_monsterZoneHash:null,
	_zoneInfos:null,
	_curZoneId:0,//当前副本id
	jingyanNowWave:1,
	jingyanFristRewardWave:[],
	jingyanMaxWave:0,
	jingyanDeployNum:0,//当前经验副本波次
	_zoneType:-1,
	juqingZoneMax:10000,
	ctor:function() {	
		this._vipArr = [];
		this._zoneVipHash = new HashMap();
		this._zoneIdHash = new HashMap();
		this._monsterZoneHash = new HashMap();
	},

	InitData:function(){
		var qGloble = Mgr.dataMgr.GetConfig(357);
		var zoneidArr = JSON.parse(qGloble.q_string_value);
		for( var i = 0; i < zoneidArr.length; i++ )
		{
			this._vipArr.push( parseInt(zoneidArr[i][1]) );
			this._zoneVipHash.Put( parseInt(zoneidArr[i][0]), parseInt(zoneidArr[i][1]) );
			this._zoneIdHash.Put( parseInt(zoneidArr[i][1]), parseInt(zoneidArr[i][0]) );
		}
	},
	SetCurrentZoneType:function(type)
	{
		this._zoneType = type;
	},
	GetCurrentZoneType:function()
	{
		return this._zoneType;
	},
	InitStoryHash:function() {
		this._storyZoneHash = new HashMap();
		var list = Q_story.GetList();
		for (var i = 0; i < list.length; i++) {
			if (this._storyZoneHash.Get(list[i].q_base_id) == null)
			{
				this._storyZoneHash.Put(list[i].q_base_id, []);
			}
			this._storyZoneHash.Get(list[i].q_base_id)[list[i].q_level_id - 1] = list[i];
		}
	},
	
	StoryZoneHash:function(){
		if( this._storyZoneHash==null ){
			this.InitStoryHash();
		}
		return this._storyZoneHash;
	},

	VipArr:function(){
		if( this._vipArr.length == 0 ){
			this.InitData();
		}
		return this._vipArr;
	},

	GetZoneId:function( vip ){
		return this._zoneIdHash.Get(vip);
	},
	
	SortBattleZoneInfoById:function( p1, p2 ){
		if (p1.zoneModelid < p2.zoneModelid)
			return -1;
		else if (p2.zoneModelid < p1.zoneModelid)
			return 1;

		return 0;
	},
	
	StoryIsFirst:function(mid){
		if( mid == 0 || mid == null )
			return 1;
		for(var i = 0; i < this._zoneInfos.length; i++){
			if(this._zoneInfos[i].zoneModelid == mid){
				return this._zoneInfos[i].isFirst;
			}
		}
		return 0;
	},

	// 返回前端副本信息
	RecvResZoneBasicInfoObtainToClientMessage:function(msg) {
		this._zoneInfos = msg.zoneInfos.sort(this.SortBattleZoneInfoById);
		if(this.battleZoneBackGroundPanel && Mgr.uiMgr.IsPanelShow( this.battleZoneBackGroundPanel ) ){
			if( msg.zonetype == EnumZoneType.TYPE_JQ  && this.battleZoneBackGroundPanel.storyPanel){
				cc.log("juqingfuben")
				this.battleZoneBackGroundPanel.storyPanel.UpdateData( this._zoneInfos );}
			else if( msg.zonetype == EnumZoneType.TYPE_JJ  && this.battleZoneBackGroundPanel.jinjiePanel )
				this.battleZoneBackGroundPanel.jinjiePanel.UpdateData( this._zoneInfos );
			else if( msg.zonetype == EnumZoneType.TYPE_VIP  && this.battleZoneBackGroundPanel.vipFubenPanel )
				this.battleZoneBackGroundPanel.vipFubenPanel.UpdateData( this._zoneInfos );
		}
		if(msg.zonetype == EnumZoneType.TYPE_KFDR)
		{
			EngineMgr.uiMgr.ShowPanelByType(DuorenPanelExt.PanelName);
			var panel = Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName);
			if(panel)
			{
				panel.ShowContentByType(EnumZoneType.TYPE_KFDR);
			}
			Mgr.crossteam.HandleZoneListData(this._zoneInfos);
		}
		else if( msg.zonetype == EnumZoneType.TYPE_LFDR)
		{
			EngineMgr.uiMgr.ShowPanelByType(DuorenPanelExt.PanelName);
			var panel = Mgr.uiMgr.GetPanelByType(DuorenPanelExt.PanelName);
			if(panel)
			{
				panel.ShowContentByType(EnumZoneType.TYPE_LFDR);
			}
			Mgr.zoneteam.HandleZoneListData(this._zoneInfos);
		}else if( msg.zonetype == EnumZoneType.TYPE_GUANGWU)
        {
            if(Mgr.luckydraw.guangwuPanel)
            {
                Mgr.luckydraw.guangwuPanel.RefreshZone(msg.zoneInfos);
            }
        }else if( msg.zonetype == EnumZoneType.TYPE_QINGYUAN){
            cc.log("???????????")
            //s.dumpJson(msg)
        }
	},

	// 返回前端副本通关
	RecvResZoneClearanceToClientMessage:function(msg) {//TODO
		cc.log("====返回前端副本通关====")
		if(Mgr.sword.IsInZoneMap()){
			EngineMgr.uiMgr.ShowPanelByType(ExpFubenWinExt.PanelName);
			Mgr.uiMgr.GetPanelByType(ExpFubenWinExt.PanelName).SetInfo(Mgr.sword._curlayer+1);
		}else{
            //心魔副本不弹出结算
            var zoneType = Mgr.sceneMap.ZoneType();
            if(zoneType == EnumZoneType.TYPE_XINGMO){
				TimerUtil.SetTimeout( this, Mgr.zone.SendReqZoneOutToGameMessage, 1000 );
                return;
            }

            // 跨服多人，不直接显示。先退出后显示
            if(this.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR){
                Mgr.cross.SendReqQuitClientToFightMessage();

                this.j_kfdr_rewardMsg = msg;
            }else{
                EngineMgr.uiMgr.ShowPanelByType(FubenWinExt.PanelName);
                Mgr.uiMgr.GetPanelByType(FubenWinExt.PanelName).SetInfo(msg.zoneModelid);
            }
		}
	},

	// 返回副本失败消息(所有副本通用)
	RecvResZoneFailureToClientMessage:function(msg) {
		Mgr.uiMgr.ShowPanelByType(FubenDefeatedExt.PanelName);
		//Mgr.uiMgr.GetPanelByType(FubenDefeatedExt.PanelName).OnShow();
	},
	
	// 返回副本追踪内容信息/msg:{"__instanceId":23568,"zoneModelid":6001,"deployNum":1,"countdown":29,"monsterSum":0,"monsterNum":[],"monsterid":[]}
	RecvResZoneTrackingToClientMessage:function(msg) {
        this._curZoneId = msg.zoneModelid;
        var zoneType = Mgr.sceneMap.ZoneType();
        this.jingyanDeployNum = msg.deployNum;
        if( Mgr.task._taskTrackPanel._curJingyanZoneNum == 0 )
            Mgr.task._taskTrackPanel._curJingyanZoneNum = this.jingyanDeployNum;


        if(zoneType != EnumZoneType.TYPE_KFDR)
            Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(msg.countdown);
        if( zoneType == EnumZoneType.TYPE_JY){
			if(this.jingyanDeployNum == 8 && Mgr.task.aCurTaskId == 10076)
                		TimerUtil.SetTimeout( this, Mgr.zone.SendReqZoneOutToGameMessage, 500 );

			var list = [];
            var allList = Mgr.zone.GetConditionList(Mgr.zone._curZoneId);
			// for(var i = 0; i < allList.length; i++){
			// 	if(allList[i].q_order == msg.deployNum){
             //        list.push(allList[i]);
             //        break;
			// 	}
			// }
			//根据order ID 来获得
            list.push(allList[msg.deployNum - allList[0].q_order]);

            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
			panel.visible = true;
            panel.__panel.InitView(list);
            panel.__teamPanel.InitView();
            panel.__panel.SetTime(msg.countdown);
            if(this.jingyanDeployNum%5 == 0)
                Mgr.zone.SendReqZoneBasicObtainToGameMessage(EnumZoneType.TYPE_JY);
		}
        else if(zoneType == EnumZoneType.TYPE_WD){
            var list = [];
            var monsterId = JSON.parse(Q_temple.Get(Mgr.zone.jingyanDeployNum).q_id_boss)[0];
            var info = {q_monster : monsterId, q_num : 1,
				q_center_x: JSON.parse(Q_temple.Get(Mgr.zone.jingyanDeployNum).q_id_boss)[1], q_center_y: JSON.parse(Q_temple.Get(Mgr.zone.jingyanDeployNum).q_id_boss)[2]};
            list.push(info);
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.InitView(list);
            panel.__teamPanel.InitView();
            panel.__panel.SetTime(msg.countdown);
		}
		else if(zoneType == EnumZoneType.TYPE_KFDR){
            //var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            //panel.__panel.SetTime(msg.countdown);
        }else if(zoneType == EnumZoneType.TYPE_QINGYUAN){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.UpdateWave(msg)
        }
	},

	StartCountdown:function(){
		var time = Q_zone.Get(this._curZoneId).q_exist_time;
		if(time && time > 0){
            Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(time/1000);
            var zoneType = Mgr.sceneMap.ZoneType();
            if(zoneType == EnumZoneType.TYPE_JQ || zoneType == EnumZoneType.TYPE_JJ || zoneType == EnumZoneType.TYPE_JY || zoneType == EnumZoneType.TYPE_WD
			|| zoneType == EnumZoneType.TYPE_VIP ){
            	var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                // panel.__panel.InitView();
                // panel.__teamPanel.InitView();
                panel.__panel.SetTime(time/1000);
			}
		}
	},
	
	// 返回副本通用倒计时（通用！！）
	///  @param type 0 是开场 1是波次 2是结束 ，3是副本总的倒计时
	RecvResZoneCountdownToClientMessage:function(msg) {
		this._curZoneId = msg.zoneModelid;
        var zoneType = Mgr.sceneMap.ZoneType();
        if(zoneType == EnumZoneType.TYPE_JQ || zoneType == EnumZoneType.TYPE_JJ || zoneType == EnumZoneType.TYPE_VIP ){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.InitView();
            panel.__teamPanel.InitView();
        }
        if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_XINGMO){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__panel.InitView();
            panel.__panel.SetTime(Q_zone.Get(Mgr.zone._curZoneId).q_exist_time/1000);
        }else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_QINGYUAN){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            if(msg.type == 3) panel.__panel.UpdateLeftTime(msg.time);
        }
		// var zoneData = Q_zone.Get(msg.zoneModelid);
		// if(msg.time == 0)
		// 	Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(zoneData.q_exist_time/100)
		Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(0);
		if(msg.type == 0){
			if(!Mgr.uiMgr.IsPanelShowByName(FubenTimeCueExt.PanelName)){
				Mgr.uiMgr.ShowPanelByType(FubenTimeCueExt.PanelName);
			}
			Mgr.sceneMap.enterMapTime = msg.time * 1000;
			Mgr.uiMgr.GetPanelByType(FubenTimeCueExt.PanelName).ShowBeginTime(msg.time);
		}
	},
	
	// 返回经验副本信息
	RecvResExpZoneInfoToClientMessage:function(msg) {
		cc.log("返回经验副本信息");

        /// 判断是否是领取奖励的返回
        if(this.__ReqExpFirstReward_param){
            var wave = this.__ReqExpFirstReward_param.wave;
            var contained = false;
            this.jingyanFristRewardWave = this.jingyanFristRewardWave || [];
            for(var i=0;i!=this.jingyanFristRewardWave.length;++i){
                if(wave == this.jingyanFristRewardWave[i]){
                    contained = true;
                    break;
                }
            }
            // 旧的不包含
            if(!contained){
                for(var i=0;i!=msg.fristRewardWave.length;++i){
                    if(wave == msg.fristRewardWave[i]){
                        contained = true;
                        break;
                    }
                }
                // 新的包含
                // TIP 理论上说可以直接通过this.__ReqExpFirstReward_param来判定
                if(contained){
                    this.__ReqExpFirstReward_param = null;

                    var reward = JSON.parse(Q_exp_zone.Get(wave).q_reward_first);
                    var items = [];
                    for(var i=0;i!=reward.length;++i){
                        var v = reward[i];
                        items.push({
                            itemModelId : v.mod,
                            num : v.num,
                            bind : v.bind,
                        })
                    }

                    var panel = EngineMgr.uiMgr.ShowPanelByType(AwardZhanshiExt.PanelName,UIMgr.PANEL_LAYER_POP);
                    panel.UpdateWithItemDisplay({
                        type : 1,
                        title : "经验副本奖励",
                        content : "这是你通关第" + wave + "关的奖励。",
                        items : items,
                    });
                }
            }
        }


		this.jingyanNowWave = msg.nowWave;
		this.jingyanFristRewardWave = msg.fristRewardWave;
		this.jingyanMaxWave = msg.maxWave;
        if( Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JY){
            var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
            panel.__teamPanel.UpdateView();
        }
		if(this.battleZoneBackGroundPanel && Mgr.uiMgr.IsPanelShow( this.battleZoneBackGroundPanel ) ){
			if( this.battleZoneBackGroundPanel.jingyanfubenPanel )
				this.battleZoneBackGroundPanel.jingyanfubenPanel.UpdateData(msg.nowWave, msg.maxWave, msg.fristRewardWave);
		}
	},
	
	// 返回经验副本挑战结果
	RecvResExpZoneResultToClientMessage:function(msg) {
		cc.log("返回经验副本挑战结果");
		if(msg.result == 1){
			Mgr.uiMgr.ShowPanelByType(ExpFubenWinExt.PanelName);
			Mgr.uiMgr.GetPanelByType(ExpFubenWinExt.PanelName).SetInfo(msg.nowWave);
		}else if(msg.result == 2){
			Mgr.uiMgr.ShowPanelByType(FubenDefeatedExt.PanelName);
		}
	},

	// 获取副本信息
	SendReqZoneBasicObtainToGameMessage:function(zonetype) {
		var msg = new ReqZoneBasicObtainToGameMessage();
		msg.zonetype = zonetype;
		Mgr.msgMgr.Send( msg );
	},

	// 进入副本
	SendReqZoneEnterToGameMessage:function(id) {
		var msg = new ReqZoneEnterToGameMessage();
		msg.zoneModelid = id;
		Mgr.msgMgr.Send( msg );
	},

	// 扫荡副本
	SendReqBattleZoneSweepToGameMessage:function(zonetype, zoneModelid) {
		var msg = new ReqleZoneSweepToGameMessage();
		msg.zonetype = zonetype;
		msg.zoneModelid = zoneModelid;
		Mgr.msgMgr.Send( msg );
	},

	// 前端请求退出副本
	SendReqZoneOutToGameMessage:function() {
		var msg = new ReqZoneOutToGameMessage();
		msg.zoneModelid = this._curZoneId;
		Mgr.msgMgr.Send( msg );
	},

	// 前端购买副本次数
	SendReqPayBattleToGameMessage:function(id) {
		var msg = new ReqPayZoneToGameMessage();
		msg.zoneModelid = id;
		Mgr.msgMgr.Send( msg );
	},

	// 前端请求领取经验副本首通奖励
	SendReqExpFirstRewardToGameMessage:function(wave) {
		var msg = new ReqExpFirstRewardToGameMessage();
		msg.wave = wave;
        this.__ReqExpFirstReward_param = {
            wave : wave,
        }
		Mgr.msgMgr.Send( msg );
	},

	IsInZoneMap:function () {
		var zoneType = Mgr.sceneMap.ZoneType();
		return zoneType != 0 ? true : false;
	},
	IsInWangchengMap:function()
	{
		var maparr = JSON.parse(Q_zone.Get(12003).q_mapid);
		for(var i = 0;i<maparr.length;i++)
		{
			if(Mgr.sceneMap.nMapId == maparr[i])
			{
				return true;
			}
		}
		return false;
	},
	IsInGuildMap:function () {//帮派驻地
		var map = Mgr.sceneMap.nMapId;
		var guildMap = Q_zone.Get(7001);
		var guildMapId = JSON.parse(guildMap.q_mapid)[0];

		if(map == guildMapId){
			return true;
		}

		return false;
    },
	IsInXinMoMap:function()
	{
		var map = Mgr.sceneMap.nMapId;
		var xinMo = Q_zone.Get(10001);
		var xinMoMap = JSON.parse(xinMo.q_mapid)[0];
		if(map == xinMoMap && Mgr.task.aCurTaskId == 10030 && !Mgr.player.isAutoFight)
		{
			EngineMgr.uiMgr.ShowPanelByType(GuaJiCueExt.PanelName);
		}
		else
		{
			EngineMgr.uiMgr.HidePanelByType(GuaJiCueExt.PanelName);
		}
	},
	IsInZoneMapTwo:function()
	{
		var zoneType = Mgr.sceneMap.ZoneType();
		if(  zoneType!= 0 )
		{
			if(zoneType ==  EnumZoneType.TYPE_LFDR)
			{
				if(!Mgr.zoneteam.isInZoneFight)
				{
					Mgr.uiMgr.HidePanelByType(DuorenPanelExt.PanelName);
					this.SetCurrentZoneType(EnumZoneType.TYPE_LFDR);
					var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
					if(panel)
					{
						panel.UpdateTeamZoneTeamHead();
					}
				}
				Mgr.zoneteam.isInZoneFight = true;
			}else if(zoneType == EnumZoneType.TYPE_QINGYUAN){
                EngineMgr.uiMgr.HidePanelByType(MarriageMainExt.PanelName);
			}
			return true;
		}
		else
		{
			if(Mgr.zoneteam.isInZoneFight)
			{
				Mgr.zoneteam.isInZoneFight = false;
				Mgr.crossteam.isInteam = false;//TODO
				//Mgr.zoneteam.SendReqZoneTeamLeaveClientToGameMessage();
				Mgr.crossteam.ClearPlayerPanelInZone();
				var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
				if(panel)
				{
					panel.ClearPlayerInZoneTeam();
				}
			}
			return false;
		}
	},
	ShowOutZonePanel:function()
	{
		if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_KFDR)
		{
			AlertExt.Show( "是否确认退出多人副本?",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.cross.SendReqQuitClientToFightMessage();
				},
			},1, true);
		}
		else if(Mgr.zone.GetCurrentZoneType() == EnumZoneType.TYPE_LFDR)
		{
			AlertExt.Show( "是否确认退出多人副本?",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.zone.SetCurrentZoneType(-1);
					Mgr.zone.SendReqZoneOutToGameMessage();
				},
			},1, true);
		}
		else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_GUILDBOSS) {
			if ( Mgr.guild.isExistGuildBoss ) {
				AlertExt.Show( "是否确认退出帮会boss副本?",TipsEnum.BUTTON_SURE_AND_FALSE, {
					_onFunc:function(){
						Mgr.zone.SendReqZoneOutToGameMessage();
					},
				},1, true);
			}
			else {
				Mgr.zone.SendReqZoneOutToGameMessage();
			}
		}
        else if(Mgr.sceneMap.ZoneType() == EnumZoneType.TYPE_JY) {
            AlertExt.Show( "是否确认退出经验副本?",TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    // Mgr.zone.SendReqZoneOutToGameMessage();
                    var curexp = JSON.parse(Q_exp_zone.Get(Mgr.zone.jingyanDeployNum).q_reward)[0].num;
                    var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
                    panel.visible = true;
                    if(panel.__panel.allExp >　curexp){
                        EngineMgr.uiMgr.ShowPanelByType(ExpFubenWinExt.PanelName);
                        Mgr.uiMgr.GetPanelByType(ExpFubenWinExt.PanelName).SetInfo(Mgr.zone.jingyanNowWave);
					}
					else{
                        Mgr.uiMgr.ShowPanelByType(FubenDefeatedExt.PanelName);
					}
                },
            },1, true);
        }
		else if(Mgr.monster.IsInMonsterMap())
		{
			if(Mgr.monster.curWorldBossInfo && Mgr.monster.curWorldBossInfo.status == 0 && Mgr.monster.isFindBoss)
			{
				AlertExt.Show("当前BOSS未死亡，是否离开",TipsEnum.BUTTON_SURE_AND_FALSE, {
					_onFunc:function(){
						Mgr.map.SendReqReturnToPreviousMapMessage();
					},
				},1);
			}
			else
			{
				Mgr.map.SendReqReturnToPreviousMapMessage();
			}
		}
		else
		{
			AlertExt.Show( "您要放弃本次挑战吗？",TipsEnum.BUTTON_SURE_AND_FALSE, {
				_onFunc:function(){
					Mgr.zone.SendReqZoneOutToGameMessage();
				},
			},1);
		}
	},

    GetConditionList:function(zoneId){
        var list, temps = [] , item = null, data = null;
        var zones = Q_scene_monter_zone.GetList();
        var zoneType = Mgr.sceneMap.ZoneType();
        list = this._monsterZoneHash.Get(zoneId);
        if(!list || !list.length){
            list = [];
            for (var i = 0; i < zones.length; i++)
            {
                if (zones[i].q_zone == zoneId && (Q_monster.Get(zones[i].q_monster).q_monster_type != 1 || zoneType == EnumZoneType.TYPE_JY)){
                    temps.push(zones[i]);
                }
            }

            for (var i = 0; i < temps.length; i++) {
                data = temps[i];
                item = null;
                for (j = 0; j < list.length; j++) {
                    if (data.q_monster == list[j].q_monster) {
                        item = list[j];
                        break;
                    }
                }
                if (item == null) {
                    item = {q_monster: data.q_monster, q_num: data.q_num, q_order: data.q_order, q_center_x: data.q_center_x, q_center_y: data.q_center_y};
                    list.push(item);
                }
                else {
                    item.q_num += data.q_num;
                }
            }
            list.sort(function(a, b){
            	return a.q_order > b.q_order;
			});
            this._monsterZoneHash.Put(zoneId, list);
		}

        return list;
    },

    OnMapChanged:function(){
        if(this.GetCurrentZoneType() == -1
            && this.j_kfdr_rewardMsg){
            var p = EngineMgr.uiMgr.ShowPanelByType(FubenWinExt.PanelName);
            if(p) p.SetInfo(this.j_kfdr_rewardMsg.zoneModelid,EnumZoneType.TYPE_KFDR);
            this.j_kfdr_rewardMsg = null;
        }

        // 跨服副本更新倒计时
        var zoneType = this.GetCurrentZoneType();
        if(zoneType == EnumZoneType.TYPE_KFDR){
            var data =  Q_zone.Get(Mgr.crossteam.curzoneModelId)
            var time = Q_zone.Get(Mgr.crossteam.curzoneModelId).q_exist_time;
            if(time && time > 0){
                Mgr.uiMgr.GetPanelByType(MiniMapPanelExt.PanelName).SetZoneData(time/1000);

                var panel = Mgr.uiMgr.GetPanelByType(TaskTrackPanelExt.PanelName);
				if( panel.__panel )
                	panel.__panel.SetTime(time/1000);
            }
            return
        }

        var zoneType = Mgr.sceneMap.ZoneType();
        if(zoneType == EnumZoneType.TYPE_JY){
            this.jingyanEntermapWave = this.jingyanNowWave;
        }
    },

	AddbuttonEffect:function(btn, id, isShow){
		if(!btn.effect){
			if(isShow){
                var effect = new MAnimationObject();
                effect.sResUrlBase = "res/animation/effect/ui/" + id;
                effect.SetPlaySpeedScale(0.5);
                effect.DoAction("stand5");
                if(id == 995){
                    // btn.getParent().addChild(effect);
                    // btn.setOpacity(100);
                    effect.x = btn.uiWidth/2;
                    effect.y = btn.uiHeight/2;
				}
				else if(id == 996){
                    // btn.addChild(effect);
                    effect.x = btn.uiWidth/2 + 5;
                    effect.y = btn.uiHeight/2 - 5;
				}
				else{
                    // btn.addChild(effect);
                    effect.x = btn.uiWidth/2;
                    effect.y = btn.uiHeight/2;
				}
                btn.addChild(effect);
                btn.effect = effect;
                btn.effect.visible = true;
			}
			else if(btn.effect)
                btn.effect.visible = false;
		}
        else if(!isShow)
            btn.effect.visible = false;
	},
});

var ActiveMarkModMgr = ActiveMarkModMgr || cc.Class.extend({
		_panelMgr:null,
		_panels:null,

		ctor:function() {
			this._panelMgr = {};
			this._panels = [];
		},

		GetPanels:function () {
			return this._panels;
		},

		GetPanelByType:function (type) {
			return this._panelMgr[type];
		},

		Show:function ( type,info ) {
			if(!info){return;}
			var data = this.GetDataByType(type,info);
			var pLevel = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumBaseAttribute.LEVEL, AttributeData.Base);
			if(!data || data.q_level>pLevel)
			{
				return;
			}
			var panel = this._panelMgr[type];
			if ( !panel ) {
				panel = new ActiveMarkExt();
				panel.LoadPanel();
				Mgr.uiMgr._popLayer.addChild(panel);
				this._panelMgr[type] = panel;
				this._panels.push(panel);

				var winSize = cc.director.getWinSize();
				panel.x = winSize.width + panel.layoutCom.layoutOffx - panel.uiWidth;
				panel.y = 200;
			}
			panel.SetType(type,info);
			panel.visible = true;
		},
		GetDataByType:function(type,info)
		{
			var startD = new Date(info.startTime*1000);
			var startH = startD.getHours();
			var startM = startD.getMinutes()>=10 ? startD.getMinutes() : "0"+startD.getMinutes();
			var startTime = Number(String(startH)+String(startM));
			var endDD = new Date((Number(info.startTime)*1000+Number(info.endTime)*1000));
			var startHH = endDD.getHours();
			var startMM = endDD.getMinutes()>=10 ? endDD.getMinutes() : "0"+endDD.getMinutes();
			var endTime = Number(String(startHH)+String(startMM));
			var list = Q_timing.GetList();
			var data = null;
			for(var i = 0; i <list.length;i++)
			{
				if(list[i].q_type == type)
				{
					var q_time=list[i].q_time;
					var arr = q_time.split("-");
					var start = Number(arr[0].replace(":",""));
					var end = Number(arr[1].replace(":",""));
					if(startTime==start && endTime==end)
					{
						data = list[i];
					}
				}
			}
			return data;
		},

        GotoActivity:function(type){
            if(type == EnumZoneActiveType.TYPE_GUARDCPITAL){
                Mgr.guardcpital.isGoToActive = true;
                Mgr.guardcpital.Fly2ActivityArea();
            }else if(type == EnumZoneActiveType.TYPE_SWORD){
                Mgr.sword.SendReqEnterSwordZoneMessage();
            }
            else if(type == EnumZoneActiveType.TYPE_GUILD){
                Mgr.chat.curChatChannel = EnumChatChannelType.FACTION;
                Mgr.chat.ShowHideChatPanel(true);
                Mgr.guild.SendReqGuildEnterForbiddenMessage();
            }
            else if(type == EnumZoneActiveType.TYPE_ZONE){
                Mgr.zoneteam.RequestZoneListData();
            }
            else if(type == EnumZoneActiveType.TYPE_GUILDBOSS){
                Mgr.guild.SendReqGuildEnterForbiddenMessage();
            }
            else if(type == EnumZoneActiveType.TYPE_HUSONG){
                Mgr.convoy.FlyNpc();
            }else if(type == EnumZoneActiveType.TYPE_KINGGUID
                || type == EnumZoneActiveType.TYPE_KINGNEUTRAL
            ){
                Mgr.kingguild.SendReqkingguildClientToGameMessage();
                Mgr.kingneutral.SendReqkingneutralClientToGameMessage();
				EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName).ChangeView(EnumGrossipType.TYPE_GUILD);
            }else if(type == EnumZoneActiveType.TYPE_MASTERBUCKET){
                MasterBucketUtil.Fly2ActivityArea();
            }else if(type == EnumZoneActiveType.TYPE_WORLDBOSS){
                // Mgr.monster.SendReqQueryBossListMessage(0, 0);
                EngineMgr.uiMgr.ShowPanelByType(WorldBossPanelExt.PanelName);
            }else if(type == EnumZoneActiveType.TYPE_ZHUJIANTIANXIA){
                Mgr.map.SendReqGoldMapTransMessage(1003);
            }else if(type == EnumZoneActiveType.TYPE_ERENGU){
                Mgr.monster.SendReqQueryBossListMessage(0, 0);
                Mgr.monster.showType = 3;
            }
        },

        GotoActivityOnMapChanged:function(type){
            this._tempType = type;
        },

        OnMapChanged:function(){
            if(this._tempType){
                this.GotoActivity(this._tempType);
                this._tempType = null;
            }
        },
});