///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//ZorkBossInfo 魔界Boss信息

// 请求消息
//186201,ReqSendEnterZorkToGame 请求进入魔界副本消息

// 接收消息
//186101,ResSendZorkOpenToClient 发送活动开启消息 
//186102,ResSendZorkBossInfoToClient 发送BOSS信息列表消息 
//186103,ResSendZorkEarningsToClient 发送本次进入魔界收益消息 


var ZorkBossInfo = cc.Class.extend({
	ctor:function(){
		this.bossModelid = 0; // BOSS模板ID
        this.x = 0; // 怪物坐标X
        this.y = 0; // 怪物坐标Y
        this.state = 0; // 怪物当前状态（0是活着 1是死亡）
        this.reviveTime = 0; // 下次复活时间（秒）
        this.hprate = 0; // 血量倍率
        this.hp = 0; // 当前血量
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.bossModelid);
        _buf.WriteVarInt(this.x);
        _buf.WriteVarInt(this.y);
        _buf.WriteVarInt(this.state);
        _buf.WriteVarInt(this.reviveTime);
        _buf.WriteVarInt(this.hprate);
        _buf.WriteVarInt(this.hp);
	},
	
	reading:function( _buf ){
		this.bossModelid = _buf.ReadVarInt();
        this.x = _buf.ReadVarInt();
        this.y = _buf.ReadVarInt();
        this.state = _buf.ReadVarInt();
        this.reviveTime = _buf.ReadVarInt();
        this.hprate = _buf.ReadVarInt();
        this.hp = _buf.ReadVarInt();
	},
});
////////////////////
// 发送活动开启消息  //
////////////////////
var ResSendZorkOpenToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.openTime = 0; // 活动开启时间(秒)
	},

	getId:function(){
		return 186101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.openTime);
	},
	
	reading:function( _buf ){
        this.openTime = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zork.RecvResSendZorkOpenToClientMessage(this);
	},

});
////////////////////
// 发送BOSS信息列表消息  //
////////////////////
var ResSendZorkBossInfoToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.zorkBossInfos = []; // 魔界Boss信息列表 ZorkBossInfo
	},

	getId:function(){
		return 186102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.zorkBossInfos.length );
        for (var i = 0; i < this.zorkBossInfos.length; i++) {
            _buf.WriteBean(this.zorkBossInfos[i]);
        }
	},
	
	reading:function( _buf ){
        var zorkBossInfos_length = _buf.ReadShort();
        for (var i = 0; i < zorkBossInfos_length; i++) {
            this.zorkBossInfos[i] = _buf.ReadBean(ZorkBossInfo);
        }
	},

	action:function(){
		Mgr.zork.RecvResSendZorkBossInfoToClientMessage(this);
	},

});
////////////////////
// 发送本次进入魔界收益消息  //
////////////////////
var ResSendZorkEarningsToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.exp = 0; // 经验
        this.zhengqi = 0; // 真气
	},

	getId:function(){
		return 186103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.exp);
        _buf.WriteVarInt(this.zhengqi);
	},
	
	reading:function( _buf ){
        this.exp = _buf.ReadVarInt();
        this.zhengqi = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.zork.RecvResSendZorkEarningsToClientMessage(this);
	},

});
////////////////////
// 请求进入魔界副本消息 //
////////////////////
var ReqSendEnterZorkToGameMessage = cc.Class.extend( {
	ctor:function(){
		
	},

	getId:function(){
		return 186201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		
	},
	
	reading:function( _buf ){
        
	},

});
// 接收消息注册
MESSAGE_POOL.Add(186101, ResSendZorkOpenToClientMessage);
MESSAGE_POOL.Add(186102, ResSendZorkBossInfoToClientMessage);
MESSAGE_POOL.Add(186103, ResSendZorkEarningsToClientMessage);

