﻿/**
 * 上层网络消息管理器
 */
var MESSAGE_POOL = MESSAGE_POOL || {
		_messagemap:{},
		Add:function(id, msgtype){
			if (!this._messagemap[id])
				this._messagemap[id] = msgtype;
			else
				zz.Error("Message id is extist! id:" + id );
		}
	}

var GameMsgMgr = cc.Class.extend( {

	_msgMgr:null,
	_crossSocket:null,
	_orgSendMsgNum:0,
	_crossMsgNum:0,
	// _remainBytesCnt:0,
	// _crossRemainCnt:0,

	_sendMsgCnt:0,
	_msgSendMap:null,
	_lastCheckMsgCntTime:0,

	_msgBuff:null,
	_crossBuff:null,

	_cbOnOpen:null,
	_cbOnError:null,
	_cbOnClose:null,

	_cbOnCrossOpen:null,
	_cbOnCrossError:null,
	_cbOnCrossClose:null,

	replaceIp:null,
	isCanReconnect:true,

	ctor:function(){
		this._msgMgr = new MessageMgr_JSB();
		this._msgBuff = new BinStream();
		this._remainBytesCnt = 0;
		this._msgSendMap = {};
		this.InitCrossHash();
	},

	OnOpen:function(isCross){
		ConnectMgr.Stop(false);
		cc.log( "服务器连接成功! isCross: " + isCross );
	},

	OnError:function( isCross ){
		if( isCross ){
			AlertExt.Show( "跨服服务器连接错误! " );
			if( this._cbOnCrossError ) this._cbOnCrossError();
		}
		else{
			if( !ConnectMgr.isReconnect || ConnectMgr.isEnd || !this.isCanReconnect )		//非重连的连接超时(非连接断开)  重连结束 不进行重连
				AlertExt.Show("服务器连接关闭!");
			else
				ConnectMgr.Start();
			if( this._cbOnError ) this._cbOnError();
		}
	},

	OnClose:function( isCross ){
		this.CloseSocket(isCross);
		if( !isCross ){		//原服断了 跨服也会断的 直接断开
			this.CloseSocket(true);
			Mgr.cross.OnCrossClose();
		}
		if( this.replaceIp ){
			AlertExt.Show( "您的账号在IP:[" + this.replaceIp + "]处登录上线了" );
		}
		else {
			if (!isCross) {
				if( ConnectMgr.isEnd || !this.isCanReconnect )
					AlertExt.Show("服务器连接关闭!");
				else
					ConnectMgr.Start();
			}
			else {
				AlertExt.Show("跨服服务器连接关闭!");
			}
		}
		if( isCross ){
			if( this._cbOnCrossClose ) this._cbOnCrossClose();
		}
		else{
			if( this._cbOnClose ) this._cbOnClose();
		}
	},

	Connect: function (ip, port, cbopen, cberror, cbclose) {
		this._cbOnOpen = cbopen;
		this._cbOnError = cberror;
		this._cbOnClose = cbclose;
		this._orgSendMsgNum = 0;
		// this._remainBytesCnt = 0;
		this._msgMgr.Connect(ip, port, this, false);
	},

	ConnectCross:function( ip, port, cbopen, cberror, cbclose ){
		this._cbOnCrossOpen = cbopen;
		this._cbOnCrossError = cberror;
		this._cbOnCrossClose = cbclose;
		this._crossMsgNum = 0;
		// this._crossRemainCnt = 0;
		if( !this._crossSocket ){
			this._crossSocket = new MessageMgr_JSB();
			this._crossBuff = new BinStream();
		}
		this._crossSocket.Connect( ip, port, this, true );
	},

	Recconect:function(){
		this._msgMgr.Connect(this._msgMgr._ip, this._msgMgr._port, this, false, 5);
	},

	OnMessage:function( evt, isCross ){
		var msgBuff = isCross ? this._crossBuff : this._msgBuff;
		Profiler.RecordUpdate(Profiler.BEFORE_NET);
		var unit8Data = new Uint8Array( evt );
		var reicveData = [];
		for ( var i = 0; i < unit8Data.length; i++ )
			reicveData[i] = unit8Data[i];

		var actionArray = [];


		msgBuff.WriteBytes( reicveData );
		msgBuff.Rewind();
		var remainBytesCount = msgBuff._bytesAvailable;
		while ( true ) {
			if ( remainBytesCount >= 4 ){

				var length = msgBuff.ReadInt();

				//	ff  			ffffff
				// 是否压缩(0,1)     长度
				var flag = ( length >> 24 ) & 0xff;
				length = ( length & 0x00ffffff );
				if ( remainBytesCount >= length + 4 ){
					// 取出消息id
					var id = msgBuff.ReadInt();
					var msgClass = MESSAGE_POOL._messagemap[id];

					var isPass = false;
					if( msgClass ){
						var message = new msgClass;
					}
					else{
						cc.log( "客户端缺少消息 " + id + "上一个消息:" + this._lastMsgID + " isCross: " + isCross );
						isPass = true;
					}

					this._lastMsgID = id;

					if ( isPass ){
						var readLen = length - 4;
						if ( readLen > 0 )
							msgBuff.ReadBytes( readLen );

						// 缓存为空
						remainBytesCount = msgBuff.bytesAvailable();
						if ( remainBytesCount == 0 ){
							msgBuff.Clear();
							break;
						}
						else{
							continue;
						}
					}

					try {
						var bytesMsg = null;
						var readMsgLen = length - 4;
						if ( readMsgLen > 0 ){
							bytesMsg = msgBuff.ReadBytes( readMsgLen );

							// 如果存在压缩则解压
							if ( flag == 1 ){
								var zlibData = new Zlib.Inflate(bytesMsg);
								bytesMsg = zlibData.decompress();
							}
						}

						var msgBytesArray = new BinStream( bytesMsg );
						message.reading( msgBytesArray );

						if ( msgBytesArray._bytesAvailable > 0 ){
							//					AlertSuperPanelExt.showMsg( "客户端与服务器不匹配！！！");
							AlertExt.Show( "消息错误信息：" + id + " isCross: " + isCross );
							cc.log( "消息错误信息：" + " length:" + length + "  remain: " + remainBytesCount + " buf.length:" + msgBuff.length() + " id:" + message.getId() + " isCross: " + isCross  );
							this.CloseSocket(isCross);
							return;
						}
					}
					catch (e) {
						// TODO: handle exception
						var errStr = "消息错误信息：" + id + " isCross: " + isCross;
						cc.log(errStr);
						AlertExt.Show( errStr );
						cc.log( e );
						this.CloseSocket(isCross);
						return;
					}

					actionArray.push( message );

					remainBytesCount = msgBuff.bytesAvailable();
				}
				else{
					msgBuff._pos = msgBuff._pos - 4;
					msgBuff._bytesAvailable += 4;
					var tmpData = msgBuff.ReadBytes( msgBuff._bytesAvailable );
					msgBuff.Rewind(tmpData);
					break;
				}
			}
			else{
				var tmpData = msgBuff.ReadBytes( msgBuff._bytesAvailable );
				msgBuff.Rewind(tmpData);
				break;
			}

			// 缓存为空
			if ( remainBytesCount == 0 ){
				msgBuff.Clear();
				break;
			}
		}

//		// 统计每秒消息数
		var curTime = new Date().getTime();
		if ( curTime - this._msgPerSecondTime > 1000 ){
			this._msgPerSceCount = 0;
			this._msgPerSecondTime = curTime;
		}

		this._msgPerSceCount += actionArray.length;

		for ( var i = 0; i < actionArray.length; i++ ){
			var msgId = actionArray[i].getId();
			if( msgId == 100107 ){		//加密序号消息 直接在这里处理了  --merlin
				this.RecSessionId(actionArray[i].id1, actionArray[i].id2, actionArray[i].rnd, isCross );
				zz.Log("收到sesstionId " + isCross);
				//真正连接成功回调  开始登录
				if( isCross ){
					if( this._cbOnCrossOpen ) this._cbOnCrossOpen();
				}
				else{
					if( this._cbOnOpen ) this._cbOnOpen();
				}
				continue;
			}
			if ( !Mgr.mainPlayer ){		//先判断主玩家是否存在
				if( Math.floor( msgId / 1000) != 100 && msgId != 103101 && msgId != 200101 ){
					zz.Log( "玩家未初始化，忽略消息:" + msgId + " isCross: " + isCross );
					continue;
				}
			}
			Profiler.LogMessage(msgId);
			try {
				actionArray[i].action();
			}
			catch (e) {
				var errLog = "消息调用执行错误:" + msgId + "		" + e.message + "\n" + e.stack.substr(0, e.stack.length - 1);
				errLog = errLog.replace(/\n/g, "\nERROR : ");
				zz.Error( errLog + "\n");
			}
			Profiler.LogMessage(msgId, true);
		}
		Profiler.RecordUpdate(Profiler.AFTER_NET);
	},

	IsLoginMsg:function(msgId){
		return msgId == 100201 || msgId == 100205 || msgId == 100209 || msgId == 100206;
	},


	/**
	 * 发送消息
	 * */
	Send:function( msg ){
		var isCross = this.CheckUseCross(msg);
		if( isCross == -1 )
			return;
		this._sendMsgCnt++;

		var id = msg.getId();
		var count = this._msgSendMap[id];
		if( count )
			count++;
		else
			count = 1;

		this._msgSendMap[id] = count;

		var time = TimerUtil.GetTimer();
		if( time - this._lastCheckMsgCntTime > 1000 ){
			this._lastCheckMsgCntTime = time;
			if( this._sendMsgCnt > 15 ){
				cc.error( "每秒消息量过大: " + JSON.stringify(this._msgSendMap) );
			}
			this._msgSendMap = {};
			this._sendMsgCnt = 0;
		}

		if( this._sendMsgCnt >= 25 ){
			zz.Error( "每秒消息量过大 抛弃消息发送:" + msg.getId() + "  " + msg );
			return;
		}

		this._RealSend(msg, isCross == 1);
		if( isCross == 2 )
			this._RealSend(msg, true);
	},

	/**
	 * 跨服存在双向发送， 所以还是二次封装下方法
	 */
	_RealSend:function( msg, isCross ){
		var sendMsgNum = 0;
		if( isCross )
		{
			if( this._crossMsgNum == 0 && msg.getId() != 250201 )	//跨服登录消息
				return;
			sendMsgNum = this._crossMsgNum;
		}
		else
		{
			if( ( !Mgr.login.isLoginSuccess || this._orgSendMsgNum == 0 ) && !this.IsLoginMsg( msg.getId() ) )
				return;
			sendMsgNum = this._orgSendMsgNum;
		}

		var baseData = new BinStream();
		//写进去的是消息类型服务器才知道是什么消息
		msg.writeSendHead( baseData, sendMsgNum, sendMsgNum == 0 ? 0 : Mgr.login.ServerTimeCheck() );
		//差不多就是数据序列化
		msg.writing( baseData );

		// 插入加密序号
		var magicValue = ( ( ~sendMsgNum & ( baseData.length() ) ) | ( sendMsgNum & ~( baseData.length() ) ) );
		magicValue = ( ( ~magicValue & ( 1 << 7 ) ) | ( magicValue & ~( 1 << 7 ) ) );

		baseData._pos = 0;
		baseData.WriteInt( magicValue );


		// 写入消息头长度
		var len = baseData.length();
		var finalData = [];
		finalData[0] = 0xff & ( len >> 24 );
		finalData[1] = 0xff & ( len >> 16 );
		finalData[2] = 0xff & ( len >> 8 );
		finalData[3] = 0xff & ( len  );
		finalData = finalData.concat( baseData._baseData );

		var msgDatas = new Uint8Array(finalData);

		if ( isCross )
		{
			// 发送序列
			if ( this._crossSocket.Send( msgDatas, msgDatas.length  ) == true )
				this._crossMsgNum++;
		}
		else
		{
			// 发送序列
			if ( this._msgMgr.Send( msgDatas, msgDatas.length  ) == true )
				this._orgSendMsgNum++;
		}
	},

	RecSessionId:function( id1, id2, rnd, isCross )
	{
		var newId = id1;
		if( isCross )
			this._crossMsgNum = ( newId >> ( newId % 10 ) );
		else
			this._orgSendMsgNum = ( newId + rnd >> ( newId % 5 ) + 2 );
	},

	InitCrossHash:function()
	{
		this.sendCrossHash = new HashMap();
		//战斗
		var i;
		for( i = 102201; i <= 102208; i++ )
			this.sendCrossHash.Put( i, 1 );
		//移动
		for( i = 101201; i <= 101215; i++ )
			this.sendCrossHash.Put( i, 1 );

		//心跳
		this.sendCrossHash.Put( 100204, 1 );

		//加载完成
		this.sendCrossHash.Put( 100203, 1 );

		//复活 挂机
		for( i = 103201; i <= 103205; i++ )
			this.sendCrossHash.Put( i, 1 );

		//查看他人
		this.sendCrossHash.Put( 103210, 1 );

		//窗口改变
		this.sendCrossHash.Put( 103211, 1 );

		//包裹操作
		this.sendCrossHash.Put( 108209, 1 );
		this.sendCrossHash.Put( 108211, 1 );

		//打坐
		for( i = 136201; i <= 136204; i++ )
			this.sendCrossHash.Put( i, 1 );

		//上下马
		this.sendCrossHash.Put( 214204, 2 );

		//GM
		this.sendCrossHash.Put( 200201, 1 );

		//roll点
		this.sendCrossHash.Put( 210201, 1 );

		//跨服登录
		this.sendCrossHash.Put( 250201, 1 );

		//跨服退出
		this.sendCrossHash.Put( 250202, 1 );

		//万灵血战里面到处飞
		this.sendCrossHash.Put( 255203, 1 );

		//侍宠坐骑攻击
		this.sendCrossHash.Put( 102208, 1 );
		this.sendCrossHash.Put( 102209, 1 );

		//战魂同步
		this.sendCrossHash.Put( 135202, 1 );

		//boss传送  跨服中不允许使用
		this.sendCrossHash.Put( 101210, -1 );
		this.sendCrossHash.Put( 101216, -1 );
		//选线跨服众不允许使用
		this.sendCrossHash.Put( 101211, -1);
	},

	CheckUseCross:function( msg ){
		var isCross = 0;
		if( this._crossSocket && this._crossSocket.IsConnected() ){
			var id = msg.getId();
			isCross = this.sendCrossHash.Get(id);
			isCross = isCross || 0;
			if( id === 112201 ){
				var type = msg.type;
				if( type === EnumChatChannelType.PRIVATE )	//私聊双向发送
					isCross = 2;
			}
			else if( id === 108203 ){
				var item = Mgr.backpack.GetItemById(msg.itemId);
				if( item ){
					var qItem = Q_item.Get(item.itemModelId);
					if( qItem.q_type == EnumItemType.Drug || qItem.q_type == EnumItemType.ADDBUFF )
						isCross = 1;
				}
			}
		}
		return isCross;
	},

	CloseSocket:function(isCross){
		if( isCross ){
			if( this._crossSocket )this._crossSocket.Close();
		}
		else{
			if( this._msgMgr )this._msgMgr.Close();
		}
	},


	IsInCross:function(){
		return this._crossSocket && this._crossSocket.IsConnected();
	}

} );
var ConnectMgr = ConnectMgr || {
	_timeId:-1,
	isEnd:false,
	isReconnect:false,		//本次连接是否是重连 重连登录后直接切场景 不走加载
	_endTime:0,
	Start:function(){
		if( this._timeId < 0 ){
			this._timeId = TimerUtil.TimeUpdate( this.OnTimer, this, 5, 1000 );
			this._endTime = TimerUtil.GetTimer() + 10 * 60 * 1000;
		}
		this.isReconnect = true;
		Mgr.msgMgr.Recconect();
	},

	Stop:function(isEnd){
		this.isEnd = isEnd != false;
		if( this.isEnd )
			this.isReconnect = false;
		if( this._timeId >= 0 )
			TimerUtil.ClearTimeUpdate( this._timeId, this );
		this._timeId = -1;
	},

	OnTimer:function(){
		var now = TimerUtil.GetTimer();
		Mgr.tips.ShowNotice("网络不稳，系统自动重连中，操作可能会有延迟，请稍后。");
		if( now > this._endTime ){
			this.Stop();
			Mgr.msgMgr.CloseSocket();
		}
	}
};