var U8Impl = ChannelImpl.extend({
    getPlatform:function(){ return this.getChannelId(); },
    getChannelId: function() {
        var key
        switch(cc.sys.os){
            case cc.sys.OS_ANDROID: key = "U8_ChannelName"; break;
            case cc.sys.OS_IOS: key = "ChannelName"; break;
        }
        return key && this.GetDevelopInfo(key);
    },
    getGameId:function(){
        var key
        switch(cc.sys.os){
            case cc.sys.OS_ANDROID: key = "U8_APPID"; break;
            case cc.sys.OS_IOS: key = "AppId"; break;
        }
        return key && this.GetDevelopInfo(key);
    },

    init:function(){
        if (typeof u8 == "undefined") return false;

        u8.init(this.OnSDKCallBack.bind(this));

        var channel = this.getChannelId()
        if (channel == null || channel == "") return false;

        // 初始化网关地址
        var gateway = this.GetGameGateway();
        cc.log("gateway======>>>>",gateway)
        if(gateway) GameConfig.GATEWAY_URL = gateway;

        return true;
    },

    login:function(){
        u8.login();
    },

    logout:function(){
        if( u8.isSupportLogout() )
            u8.logout();
        else    /// 木有接口,直接退出游戏
            EnterGameMgr.Logout();
    },
    exit:function(){
        if( u8.isSupportExit() )
            u8.exit();
        else{
            AlertExt.Show( "你确定要退出游戏吗？", TipsEnum.BUTTON_SURE_AND_FALSE, {
                _onFunc:function(){
                    cc.game.end();
                },
            });
        }
    },
    pay:function(data){
        u8.pay({
            buyNum			: data.buyNum				,
            coinNum			: data.coinNum				,
            extension		: data.extension			,
            orderID			: data.orderID				,
            productId		: data.productId			,
            productName		: data.productName			,
            productDesc		: data.productDesc			,
            price			: data.price				,
            roleId			: data.roleId				,
            roleName		: data.roleName				,
            roleLevel		: data.roleLevel			,
            serverId		: data.serverId				,
            serverName		: data.serverName			,
            vip				: data.vip	,
        });
    },

    onLogin:function(new_role){
        this.SubmitExtraData(new_role ? this.DATA_TYPE.TYPE_CREATE_ROLE : this.DATA_TYPE.TYPE_ENTER_GAME);
    },
    onLevelUp:function(){
        this.SubmitExtraData(this.DATA_TYPE.TYPE_LEVEL_UP);
    },
    onServerSelected:function(){
        this.SubmitExtraData(this.DATA_TYPE.TYPE_SELECT_SERVER);
    },

    OnSDKCallBack:function(type, data){
        data = data || {}

        cc.log("=============1", JSON.stringify(type))
        cc.log("=============2", JSON.stringify(data))
        cc.log(data.isSwitchAccount)

        switch (type) {
            case "init_suc":
                this.util.OnSDK_Init(0,data)
                break;
            case "login_suc":
                this.util.OnSDK_Login(0,data)
                break;
            case "switch_login":
                this.util.OnSDK_SwitchAccount(0,data)
                break;
            case "logout":
                this.util.OnSDK_Logout(0,data)
                break;
            case "exit":
                var isSdkExit = data.isSDKExit;
                if( isSdkExit )
                    this.util.OnSDK_Exit(0,data)
                else
                    AlertExt.Show( "你确定要退出游戏吗？", TipsEnum.BUTTON_SURE_AND_FALSE, {
                        _onFunc:function(){
                            cc.game.end();
                        },
                    });
                break;
        }
    },

    DATA_TYPE : {
        TYPE_SELECT_SERVER : 1,			//选择服务器
        TYPE_CREATE_ROLE : 2,			//创建角色
        TYPE_ENTER_GAME : 3,			//进入游戏
        TYPE_LEVEL_UP : 4,				//等级提升
        TYPE_EXIT_GAME : 5,				//退出游戏
        TYPE_ENTER_COPY : 6,			//进入副本
        TYPE_EXIT_COPY : 7,				//退出副本
        TYPE_VIP_LEVELUP : 8,			//vip升级

        EVENT_PAY_SUCCESS : 1,				//支付成功
        EVENT_GAME_LOADED : 2,				//游戏加载完
        EVENT_PLATFORM_LOGIN_SUCCESS : 3	// 渠道登录成功
    },

    GetDevelopInfo: function(key) {
        key = key || "";

        var result;
        if (cc.sys.os == cc.sys.OS_ANDROID) {
            result = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getU8DevelopInfo", "(Ljava/lang/String;)Ljava/lang/String;", key);
        } else if (cc.sys.os == cc.sys.OS_IOS) {
            result = jsb.reflection.callStaticMethod("AppController", "getU8DevelopInfo:",key);
        }

        return result && result != "" ? result : null
    },


    GetGameGateway:function(){
        return this.GetDevelopInfo("GAME_GATEWAY_URL");
    },

    GetGameDebug:function(){
        return this.GetDevelopInfo("GAME_DEBUG") === "true";
    },

    SubmitExtraData:function(type){
        var channelKey = this.getChannelId();

        if( channelKey == "alidwd" )        //阿里有些参数没有  由服务器上报
            return;

        var data = {};
        data["dataType"] = type;

        data["roleID"]      = Mgr.player.mainPlayer.sid ?Mgr.player.mainPlayer.sid.toString(10) : "";
        data["roleName"]    = Mgr.player.mainPlayer.name  || "";
        data["roleLevel"]   = Mgr.player.mainPlayer.attributeData.level || "";
        data["moneyNum"]    = Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money) || "";

        data["serverId"] = GameConfig.current.SERVER_ID.toString();
        data["serverName"] = GameConfig.current.NAME;


        cc.log("SubmitExtraData====>>>",JSON.stringify(data))

        // TODO 后续代码分离
        if(channelKey === "13yx"){
            // TIP 接口不接受空参数，设置默认0
            var url = "http://logcollect.13yx.com/logcollect/data/get/loginChooseServer"
            var token = "hbb81G19SIibvnFw";
            var param = {}
            param["eventTime"]      = Date.now();
            param["uid"]            = GameConfig.u8login ? GameConfig.u8login.sdkUserID : "0";
            param["gid"]            = NativeUtil.getApplicationMetaData("AppID") || "0";
            param["playerName"]     = data.roleName || "0";
            param["channel"]        = channelKey || "0";
            param["playerId"]       = data.roleID || "0";
            param["playerLevel"]    = data.roleLevel || "0";
            param["packageId"]      = NativeUtil.getAppPackageName() || "0";
            param["eventId"]        = data.roleID + "" + param["eventTime"];
            param["serverId"]       = data.serverId || "0";

            for(var k in param){
                param[k] = encodeURI(param[k]);
            }

            param["sign"]           = ""
                + "channel=" + param.channel
                + "&eventId=" + param.eventId
                + "&eventTime=" + param.eventTime
                + "&gid=" + param.gid
                + "&packageId=" + param.packageId
                + "&playerId=" + param.playerId
                + "&playerLevel=" + param.playerLevel
                + "&playerName=" + param.playerName
                + "&serverId=" + param.serverId
                + "&uid=" + param.uid
                + token;

            param["sign"] = cc.MD5.GetMD5OfString(param.sign);

            url += "?"
                + "channel=" + param.channel
                + "&eventId=" + param.eventId
                + "&eventTime=" + param.eventTime
                + "&gid=" + param.gid
                + "&packageId=" + param.packageId
                + "&playerId=" + param.playerId
                + "&playerLevel=" + param.playerLevel
                + "&playerName=" + param.playerName
                + "&serverId=" + param.serverId
                + "&uid=" + param.uid
                + "&sign=" + param.sign

            cc.log(url)

            var xhr = cc.loader.getXMLHttpRequest();
            xhr.open("POST", url, true);
            xhr.setRequestHeader("Accept-Charset", "x-user-defined");
            var self = this;
            xhr.onload = function() {
                cc.log("xhr.readyState",xhr.readyState,xhr.status)
                if (xhr.readyState === 4 && xhr.status === 200) {
                    var result = JSON.parse(xhr.response);
                    cc.log("result==>>",xhr.response);
                    if (result && result.success >= 0) {

                    }
                }
            }.bind(this);
            xhr.send();
            return;
        }

        u8.submitData(data);
    },
})