var ChannelUtil = ChannelUtil || {
    enabled: false,
    impl : null,
    Init: function() {
        var name = this.getSdkName();
        cc.log("==============SDK name",name)
        switch(name){
            case "U8": this.impl = new U8Impl(this); break;
            case "QUICK": this.impl = new QuickImpl(this); break;
            case "EU": this.impl = new EUImpl(this); break;
            default: this.impl = new ChannelImpl(this); break;
        }
        if( name != "QUICK" )
            return this.InitImpl();
        this.enabled = true;
        return false;
    },

    InitImpl:function(){
        this.enabled = this.impl.init();

        if(this.enabled){
            this._tempServer = GameConfig.serverList;
            GameConfig.serverList = [];
            GameConfig.current = null;
        }else{
            cc.log("==================impl not enabled")
        }

        return this.enabled;
    },

    Login:function(){
        var name = this.getSdkName();
        if( name == "QUICK" )
            this.InitImpl();
        if( this.enabled )
            this.impl.login();      //理论上要灯带初始化完成 实际上我们加载js后登录已经是很后面了
    },
    GetPlatform:function(){
        if(!this.enabled) return;
        return this.impl.getPlatform();
    },    
    GetChannelId:function(){
        if (!this.enabled) return;

        return this.impl.getChannelId()
    },
    GetGameId:function(){
        if (!this.enabled) return;

        return this.impl.getGameId()
    },
    GetClientGameKey:function(){
        var result;
        if(typeof MLMark != "undefined" && MLMark >= 1){
            try{
                if (cc.sys.os == cc.sys.OS_ANDROID) {
                    result = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getApplicationMetaData", "(Ljava/lang/String;)Ljava/lang/String;", "game_name");
                } else if (cc.sys.os == cc.sys.OS_IOS) {
                    result = jsb.reflection.callStaticMethod("SDKExt", "getGameName");
                }
            }catch(e){
                cc.log(e)
            }
        }
        cc.log("================",result)
        return result;
    },

    getSdkName:function(){
        var name = "NONE"
        if(typeof MLMark != "undefined" && MLMark >= 1){
            try{
                switch(cc.sys.os){
                    case cc.sys.OS_ANDROID:
                        name = jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "getSdkName", "()Ljava/lang/String;");
                        break;
                    case cc.sys.OS_IOS:
                        name = jsb.reflection.callStaticMethod("SDKExt", "getSdkName");
                        break;
                }
            }catch(e){
                cc.log(e)
            }
        }else if(typeof  MLMark == "undefined") name = "EU";

        return name;
    },

    /// @code 0 suc  1 failed
    OnSDK_Init:function(code,params){
    },
    /// @code 0 suc 1 failed 2 canceled
    OnSDK_Login:function(code,params){
        if(code != 0){
            EnterGameMgr.Logout();
            this.impl.login()
            return;
        }

        params = params || {};
        GameConfig.u8login = params;
        // 测试模式，直接拉取服务器列表。否则拉取平台信息
        //this.GetGameDebug() ? this.RequestServerList() : this.RequestPlatformInfo();
        this.RequestServerList();
        // TODO delete test code
        //GameConfig.serverList = [BTTEST,BTRELEASE,BTLOCAL,ZhangRong,ZhangRong2,ZengJunFei,ZengJunFei2,HuangPu,HELIANG,WangBing,ZhouSong];
        //GameConfig.serverList.forEach(v=>{
        //    v.LOGIN_TYPE = 2
        //})
        //Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();
    },
    /// @code 0 suc 1 failed 2 canceled
    OnSDK_Logout:function(code,params){
        if(code != 0) return;

        EnterGameMgr.Logout();
        this.impl.login()
    },
    /// @code 0 suc 1 failed 2 canceled
    OnSDK_SwitchAccount:function(code,params){
        if(code != 0) return;

        EnterGameMgr.Logout();  //切换账号退到登陆
        params = params || {};
        GameConfig.u8login = params;
        // 测试模式，直接拉取服务器列表。否则拉取平台信息
        //this.GetGameDebug() ? this.RequestServerList() : this.RequestPlatformInfo();
        this.RequestServerList();
        // TODO delete test code
        //GameConfig.serverList.forEach(v=>{
        //    v.LOGIN_TYPE = 2
        //})
        //Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();
    },
    /// @code 0 suc 1 failed 2 canceled
    OnSDK_Pay:function(code,params){},
    /// @code 0 suc 1 failed 2 canceled
    OnSDK_Exit:function(code,params){
        if(code != 0) return;
        cc.game.end();
    },

    OnGame_Login:function(new_role){
        if(!this.enabled) return;

        this.impl.onLogin(new_role)
    },
    OnGame_LevelUp:function(){
        if(!this.enabled) return;

        this.impl.onLevelUp()
    },
    OnGame_Logout:function(){
        if(!this.enabled){
            EnterGameMgr.Logout();
            return;
        }
        this.impl.logout();
    },
    OnGame_Exit:function(){
        if(!this.enabled) {
            cc.game.end();
            return;
        }
        this.impl.exit();
    },

    OnGame_ServerSelected:function(){
        if(!this.enabled) return;

        this.impl.onServerSelected()
    },

    OnRequestServerFailed:function UU__ORSF(m){
        GameConfig.serverList = this._tempServer;
        Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();

        m = m || "";
        AlertExt.Show(m + "请重新获取服务器列表！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestServerList();
            }.bind(this),
        },1);
    },
    OnRequestRoleFailed:function UU__ORSF(m){
        m = m || "";
        AlertExt.Show(m + "请重新获取角色列表！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestRoleList();
            }.bind(this),
        },1);
    },
    OnRequestPlatformInfoFailed:function UU__ORSF(m){
        m = m || "";
        AlertExt.Show(m + "请重新获取网关信息！",TipsEnum.BUTTON_SURE, {
            _onFunc:function(){
               this.RequestPlatformInfo();
            }.bind(this),
        },1);
    },

    /// 拉取网关信息
    RequestPlatformInfo:function(){
        var platform = this.GetPlatform();
        var url = GameConfig.GATEWAY_URL + "getAllPlatform?pf=" + platform;
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.state == 0) {
                    var serverList = [];
                    var data = result.data || {};
                    var version = result.version || {};

                    var cdn = data.cdn;
                    var stresver = version.stresver;
                    var dataver = version.dataresver;
                    if(!cdn){
                        this.OnRequestPlatformInfoFailed("连接网关失败！")
                        return
                    }
                    var fixPath = function(path){
                        if( path.charAt(path.length -1) != "/")
                            path += "/";
                        return path;
                    }
                    GameConfig.CDN_URL = fixPath( cdn );
                    if( dataver )
                        GameConfig.CDN_URL += dataver + "/";
                    GameConfig.WEB_CDN_URL = fixPath( cdn );
                    if( stresver )
                        GameConfig.WEB_CDN_URL += stresver + "/";
                    cc.log("更新GameConfig.CDN_URL" + GameConfig.CDN_URL + "  " + GameConfig.WEB_CDN_URL);

                    this.RequestServerList();
                }else{
                    this.OnRequestPlatformInfoFailed("连接网关失败！！！")
                }
            } else {
                this.OnRequestPlatformInfoFailed("连接网关失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    /// 拉取服务器列表
    RequestServerList:function UU__RSL(){
        var gameId = this.GetGameId();
        var platform = this.GetPlatform();
        var channel = this.GetChannelId();
        var url = GameConfig.GATEWAY_URL + "getAllServer?gameId=" + gameId + "&pf=" + platform;
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.state == 0) {
                    var serverList = [];
                    var data = result.data || [];

                    if(data.length == 0){
                        this.OnRequestServerFailed("服务器列表为空！")
                        return
                    }
                    cc.log(data.length)
                    for (var k = 0, len = data.length, v = data[k]; k != len; v = data[++k]) {
                        serverList.push({
                            SERVER_IP: v.serverAppIp,
                            SERVER_PORT: v.gateMinaServerPort,
                            LOGIN_TYPE: EnumLoginType.App,
                            USER_NAME: "",
                            PASSWORD: "",
                            PLATFORM: channel,//v.platformAlias,

                            SERVER_ID: v.serverId,
                            SCALE: 1,
                            NAME: v.serverName,

                            OPENDAYS: v.openDays,
                            OPEN_TIME: v.openTime,
                            STATE: v.state,

                            BASE_DATA : v,
                        });
                    }

                    serverList.sort(function(a,b){
                        return b.OPEN_TIME - a.OPEN_TIME;
                    })

                    GameConfig.serverList = serverList;
                    Mgr.uiMgr.ShowPanelByType(DengLuPanelExt.PanelName, UIMgr.PANEL_LAYER_TOP).ShowDeluUI();
                    Mgr.uiMgr.ShowPanelByType(GonggaoMainExt.PanelName);
                    this.RequestRoleList();
                }else{
                    this.OnRequestServerFailed("拉取服务器失败！！！")
                }
            } else {
                this.OnRequestServerFailed("拉取服务器失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    /// 拉取玩家列表
    RequestRoleList:function(){
        cc.log("RequestRoleList")
        var type = 1;
        var pf = this.GetChannelId();
        var userName = GameConfig.u8login.userID;
        var time = Math.floor(Date.now() / 1000);
        var key = "NLyGg0ImuB[zw:Nu=CQ[J{SN@>VEI&}4";
        var url = GameConfig.GATEWAY_URL + "doGetUser?type=" + type
            + "&pf=" + pf
            + "&userName=" + userName
            + "&time=" + time
            + "&sign=" + cc.MD5.GetMD5OfString(pf + userName + time + key)
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        var self = this;
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.code >= 0) {
                    if(result.code == 0){
                         GameConfig.roleData = null;
                    }else{
                        var data = result.data;
                        // 兼容傻逼后台没给serverid
                        for(var i=0;i!=data.length;++i){
                            var v = data[i];
                            if(!v.serverId){
                                var ret = v.roleName.match(/s(\d+)\..+/);
                                if(ret) data[i].serverId = ret[1];
                            }
                        }

                        GameConfig.roleData = data;
                    }

                    if(Mgr.uiMgr.IsPanelShowByName(ChooseServerPanelExt.PanelName)){
                        Mgr.uiMgr.GetPanelByType(ChooseServerPanelExt.PanelName).UpdateSever();
                    }
                }else{
                    this.OnRequestRoleFailed("拉取玩家列表失败！！！")
                }
            } else {
                this.OnRequestRoleFailed("拉取玩家列表失败！！！")
            }
        }.bind(this);
        xhr.send();
    },

    /// 拉取玩家列表
    RequestNotice:function(){
        cc.log("RequestNotice")
        var type = 2;
        var pf = this.GetPlatform();
        var url = GameConfig.GATEWAY_URL + "platformBulletion?type=" + type
            + "&pf=" + pf
        cc.log("url==>>",url)
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Accept-Charset", "x-user-defined");
        xhr.onload = function() {
            cc.log("xhr.readyState",xhr.readyState,xhr.status)
            if (xhr.readyState === 4 && xhr.status === 200) {
                var result = JSON.parse(xhr.response);
                cc.log("result==>>",xhr.response);
                if (result && result.code >= 0) {
                    if(Mgr.uiMgr.IsPanelShowByName(GonggaoMainExt.PanelName)){
                        Mgr.uiMgr.GetPanelByType(GonggaoMainExt.PanelName).SetData(result.data);
                    }
                }else{
                    if(Mgr.uiMgr.IsPanelShowByName(GonggaoMainExt.PanelName)){
                        Mgr.uiMgr.GetPanelByType(GonggaoMainExt.PanelName).SetData(null);
                    }
                }
            } else {
                if(Mgr.uiMgr.IsPanelShowByName(GonggaoMainExt.PanelName)){
                    Mgr.uiMgr.GetPanelByType(GonggaoMainExt.PanelName).SetData(null);
                }
            }
        }.bind(this);
        xhr.send();
    },

    /// 充值
    Recharge: function(param) {
        if (!this.enabled) return;

        var data = {}
        data["productId"] = "" + (param.productId || "");
        data["productName"] = param.productName;
        data["productDesc"] = param.productDesc || param.productName;

        data["price"] = param.moneys;

        data["buyNum"] =  param.productId > 100 ? 1 : param.moneys * MGameDefine.RECHARGE_RATE;
        data["coinNum"] = param.moneys * MGameDefine.RECHARGE_RATE;

        data["serverId"] = GameConfig.current.SERVER_ID.toString();
        data["serverName"] = GameConfig.current.NAME;
        data["roleId"] = Mgr.player.mainPlayer &&  Mgr.player.mainPlayer.sid && Mgr.player.mainPlayer.sid.hexValue || "0";
        data["roleName"] = Mgr.player.mainPlayer.name || "";

        data["roleLevel"] = Mgr.player.mainPlayer.attributeData.level.toString();
        data["vip"] = Mgr.player.mainPlayer &&  Mgr.player.mainPlayer.VIP && Mgr.player.mainPlayer.VIP.toString() || "0";

        data["orderID"] = param.orderId || "";
        data["extension"] = param.ext || "";

        //          params->productId = "1";
        //          params->productName = "元宝";
        //          params->productDesc = "购买100元宝，赠送20元宝";
        //          params->price = 100;
        //          params->buyNum = 1;
        //          params->coinNum = 300;
        //          params->serverId = "10";
        //          params->serverName = "地狱之恋";
        //          params->roleId = "u8_24532452";
        //          params->roleName = "麻利麻利吼";
        //          params->roleLevel = 15;
        //          params->vip = "v15";
        //
        //          //去服务器获取游戏中商品的订单号以及扩展数据,这里测试
        //          params->orderID = "345435634534";
        //          params->extension = "test111";

        this.impl.pay(data);
    },
}

/// 渠道扩展
var ChannelImpl = cc.Class.extend({
    ctor:function(util){
        this.util = util;
    },
    /// 平台
    getPlatform:function(){},
    /// 渠道ID
    getChannelId:function(){},
    /// 游戏ID
    getGameId:function(){},
    /// 初始化
    init:function(){},
    /// 登录
    login:function(){},
    logout:function(){
        EnterGameMgr.Logout();
    },
    /// 退出
    exit:function(){},
    /// 支付
    pay:function(){},
    /// 游戏登陆后的回调
    onLogin:function(){},
    // 升级
    onLevelUp:function(){},
    /// 游戏选择服务器后的回调
    onServerSelected:function(){},


    ///
    GetMoney:function(){
        if(!Mgr.player.mainPlayer) return 0;
        if(!Mgr.player.mainPlayer.attributeData) return 0;

        return Mgr.player.mainPlayer.attributeData.GetAttribute(EnumMoney.GOLD, AttributeData.Money) || 0;
    },
    GetRoleId:function(){
        if(!Mgr.player.mainPlayer) return 0;
        return Mgr.player.mainPlayer.sid ? Mgr.player.mainPlayer.sid.toString(10) : "";
    },
    GetRoleName:function(){
        if(!Mgr.player.mainPlayer) return "";
        return Mgr.player.mainPlayer.name  || "";
    },
    GetRoleLevel:function(){
        if(!Mgr.player.mainPlayer) return 0;
        if(!Mgr.player.mainPlayer.attributeData) return 0;

        return Mgr.player.mainPlayer.attributeData.level || 0
    },
    GetServerId:function(){
        return GameConfig.current.SERVER_ID;
    },
    GetServerName:function(){
        return GameConfig.current.NAME;
    },
    GetVipLevel:function(){
        if(!Mgr.player.mainPlayer) return 0;
        if(!Mgr.player.mainPlayer.VIP) return 0;
        return Mgr.player.mainPlayer.VIP.toString();
    },
})