﻿/**
 * 格子工具类
 */

var GridUtil = GridUtil || {
	SetGridInteraction:function( grid, type, interactiondata ){
		grid.setTouchEnabled(true);//这里先加一下，若在组件里处理了就删掉
        grid.addTouchEventListener(function (sender,_type) {
            var data = interactiondata || grid.gridData;
            if( !data )
                return;
            if ( _type == ccui.Widget.TOUCH_BEGAN ){
                sender._startPos = sender.getTouchBeganPosition();
            }else if ( _type == ccui.Widget.TOUCH_ENDED ){
                var endPos = sender.getTouchEndPosition();
                if(!grid.isSwallow && Math.abs(endPos.y - sender._startPos.y) > 20) return;

                if(grid.isSkillUp)
                {
					var upPanel = Mgr.uiMgr.ShowPanelByType(JiNengShengJiExt.PanelName, UIMgr.PANEL_LAYER_TOP);
					upPanel.SetData(data);
                    return;
                }
                var panelName;
                switch ( type )
                {
                    case GridInteractionType.BLACK:
                        return;
                    case GridInteractionType.NORMALSKILLSHOW:
                        panelName = SkillTipsExt.PanelName;
                        break;
                    case GridInteractionType.RESLINESKILLSHOW:
                        panelName = SkillTipsExt.PanelName;
                        break;
                    case GridInteractionType.ITEMSHOW:
                        ItemUtil.ShowTips(data,grid.gridType);
                        return;
                    default:
                        throw new Error("未知的格子点击展示类型");
                        return;
                }
                var panel = Mgr.uiMgr.ShowPanelByType(panelName, UIMgr.PANEL_LAYER_TOP);
                panel.setLocalZOrder(10000);
                panel.Updatedata(data, type);
            }
        })
	},

	SetItemGrid:function( grid, item, iconMode,showLock, hasItemFlag, isAddInteraction,
			showNum , showSpecialAtt , isShowZero, numColor ,showLevelNum){
		if(item instanceof ItemInfo){
			item=ItemUtil.ItemInfoToItem(item);
		}
        if(item instanceof TempItemInfo){
            item=ItemUtil.TempItemInfoToItem(item);
        }
		var isGrid = false;
		if(!grid)
		{
			isGrid = true;
			grid = this._GetNewGrid();
		}
		if(grid == null)
			return false;
		//====================默认参数==================
		if(iconMode == null)
			iconMode = -1;
		if(showLock == null)
			showLock = item && item.itemBind;
		if(hasItemFlag == null)
			hasItemFlag = true;
		if(isAddInteraction == null)
			isAddInteraction = true;
		if(showNum == null)
			showNum = true;
		if(showSpecialAtt == null)
			showSpecialAtt = false;
		if(isShowZero == null)
			isShowZero = false;
		if(numColor == null)
			numColor = 0x00ff32;
		if(showLevelNum == null)
		{
			showLevelNum = false;
		}
		//==================法逻辑=====================
		grid.Clean();
		if( item == null)
			return false;

		// 自动
		if ( iconMode == -1 )
		{
			if ( grid == null )
				return false;
			else
			{
				if (grid.width >= 60)
					iconMode = ResUrl.ITEM_SIZE_60;
				else if (grid.width >= 46)
					iconMode = ResUrl.ITEM_SIZE_46;
				else
					iconMode = ResUrl.ITEM_SIZE_28;
			}
		}
		var itemicon = ItemUtil.GetItemIcon(item.itemModelId , iconMode );

        itemicon.setScaleX(grid.uiWidth/84);
        itemicon.setScaleY(grid.uiHeight/84);
        itemicon.x = (grid.uiWidth - itemicon.width*grid.uiWidth/84) / 2;
        itemicon.y = (grid.uiHeight - itemicon.height*grid.uiHeight/84) / 2;
        grid.SetGridIcon( itemicon );
        grid.gridData = item;
		if ( showNum )
		{
			this.AddItemNum( grid, item, isShowZero, numColor );
		}
		if(showLevelNum)
		{
			this.AddItemLevelNum( grid, item, isShowZero, numColor );
		}
		// 加装备小图标 五个 锁定
		if ( item != null && hasItemFlag )
		{
			this.AddItemFlag( grid, item, iconMode,showLock );
		}
		if ( isAddInteraction )
		{
			GridUtil.SetGridInteraction( grid, GridInteractionType.ITEMSHOW);
		}
        // 显示时限标记
        this.AddOverdueTime(grid,item);



		//加品质边框
		var type = ItemUtil.GetItemQuality(item);
        // var box = new MUIImage();
		grid.AddGridQuality(type);

		if(!isGrid)
		{
			return itemicon;
		}
		return grid;
	},

	CleanGridQuality:function (grid) {
		if(grid.background && grid.background._imageRenderer){	//先临时修复下
            EngineMgr.uiMgr.GetAsynResByUrl("public/grid/74x74.png", function(){
                grid.background._imageRenderer.initWithSpriteFrameName("public/grid/74x74.png");
            },grid);
            grid.background.setPosition(grid.uiWidth / 2, grid.uiHeight / 2);
            grid.background.setScale(grid.uiWidth/84);
		}
    },

    AddOverdueTime:function(grid,item){
        this.ClearOverdueTime(grid);

        if(!(item instanceof Item)) return;
        if(item.GetOverdueTime() <= 0) return;

        var image = new MUIImage();
        var imageRes= item.IsOverdue() ? "other/beibao/word/guoqi.png" : "other/beibao/word/shixian.png";

        Mgr.uiMgr.LoadOtherRes("other/beibao",{Callback:function(){},ErrCallback : function(){},});
        UIUtil.LoadImage(image,imageRes,false,true,function(){
             image.x = grid.uiWidth -image.width/2 - 2;
             image.y = grid.uiHeight - image.height/2 - 2;
        });
        image.x = grid.uiWidth - 24;
        image.y = grid.uiHeight - 15;
        grid.addChild(image,9999);

        grid.iconOverdueTime = image;
    },
    ClearOverdueTime:function(grid){
        if(grid.iconOverdueTime){
            grid.removeChild(grid.iconOverdueTime);
            grid.iconOverdueTime = null;
        }
    },

	AddLock:function (grid, scale) {
		scale == undefined ? null : scale;
		var lock = new MUIImage();
		lock.retain();          //不加一的话第一次会被释放掉但是后面就不会有点怪的
		var imageRes="other/zhujiemian/image/Suo.png";
		EngineMgr.uiMgr.GetAsynResByUrl(imageRes, function(){
			lock.loadTexture(imageRes, ccui.Widget.PLIST_TEXTURE);
            lock.x = lock.width/2;
            lock.y = lock.height/2;
			lock.release();
		}, lock);
		if(scale){
            lock.setScaleX(scale.sx);
            lock.setScaleY(scale.sy);
            lock.x = lock.width*scale.sx/2;
            lock.y = lock.height*scale.sy/2;
		}
		else{
            lock.setScale(grid.uiWidth/84);
            lock.x = lock.width/2*grid.uiWidth/84;
            lock.y = lock.height/2*grid.uiWidth/84;
		}
		grid.lock = lock;
		grid.addChild(lock,10000);
	},

	ClearLock:function(grid){
        if(grid.lock){
            grid.removeChild(grid.lock);
            grid.lock = null;
        }
	},

	AddFightTag:function (item,grid) {
        //战斗力比较
        if(ItemUtil.IsEquip(Q_item.Get(item.itemModelId).q_type)) {
			var fightDif = ItemUtil.GetFightPowerFromCurrent(item);
			if (fightDif != 0) {
				var dif = new MUIImage();
                UIUtil.LoadImage(dif, "other/beibao/image/" + (fightDif > 0 ? "shang" : "xia") + ".png",false,true);
				dif.x = 70;
				dif.y = 70;
				grid.AddDisplay(dif, 1000);
			}
		}
	},
	SetSkillGridByMID:function(type, grid, mid, lv, skillParameter, sizeType)
	{
		if(grid == null)
			return false;

		if( mid == null || mid <= 0 )
			return false;

		lv = lv || 0;//0未激活

		grid.Clean();
		var icon = SkillUtil.GetSkillIcon(mid);
		if (icon != null)
		{
            icon.setScaleX(grid.uiWidth/84);
            icon.setScaleY(grid.uiHeight/84);
            icon.x = (grid.uiWidth - icon.width*grid.uiWidth/84) / 2;
            icon.y = (grid.uiHeight - icon.height*grid.uiHeight/84) / 2;
			grid.SetGridIcon(icon);
		}

		var skillpublic = Q_skill_public.Get(mid);
		grid.SetGridText(skillpublic.q_mark, ColorUtil.N_ORANGE_SKILL_UINT);

		var skillVo = new SkillVo();
		skillVo.skillParameter = skillParameter;
		skillVo.skillmid = mid;
		skillVo.skilllv = lv;

		GridUtil.SetGridInteraction( grid, type, skillVo );
	},

	//添加显示数量
	AddItemNum:function(grid, item,isShowZero,numColor){
		if(isShowZero == null)
			isShowZero = false;

		if(isShowZero)
		{
			if(!item.isNumPic)
			{
				if(item.itemNum==0)
					this.AddItemNumByNum(grid, item.itemNum,ColorUtil.SYS_RED);
				else
					this.AddItemNumByNum(grid, item.itemNum,ColorUtil.SYS_GREEN);
			}
			else
				this.AddItemNumPicByNum(grid, item.itemNum);
		}
		else
		{
			if (item.itemNum > 0)
			{
				if(!item.isNumPic)
					this.AddItemNumByNum(grid, item.itemNum,numColor);
				else
					this.AddItemNumPicByNum(grid, item.itemNum);
			}
		}
	},
	AddItemNumByNum:function(grid, num,numColor){
        if(num == 0) return
		if(num>10000)
		{
			num = Math.floor(num/10000)+"万";
		}
		grid.SetGridText(num, numColor);
	},
	AddItemLevelNum:function(grid, item,isShowZero,numColor){
		if(isShowZero == null)
			isShowZero = false;

		if(isShowZero)
		{
			if(!item.isNumPic)
			{
				if(item.itemLevel==0)
					this.AddItemLevelNumByNum(grid, item.itemLevel,ColorUtil.SYS_RED);
				else
					this.AddItemLevelNumByNum(grid, item.itemLevel,ColorUtil.SYS_GREEN);
			}
			else
				this.AddItemNumPicByNum(grid, item.itemLevel);
		}
		else
		{
			if (item.itemLevel > 0)
			{
				if(!item.isNumPic)
					this.AddItemLevelNumByNum(grid, item.itemLevel,numColor);
				else
					this.AddItemNumPicByNum(grid, item.itemLevel);
			}
		}
	},
	AddItemLevelNumByNum:function(grid, num,numColor){
		grid.SetGridText01("+"+num, numColor);
	},
	AddItemNumPicByNum:function(grid, num)
	{
		//暂未实现
//		var bmp:Bitmap = GlobalFunction.createNum3(num);
//		bmp.x = grid.uiWidth - bmp.width;
//		bmp.y = grid.uiHeight - bmp.height;
//		grid.addDisplay(bmp);
	},
	AddItemFlag:function(grid, item, iconMode,showLock ){
		var itemmodel =Q_item.Get( item.itemModelId );
		var equip;
		if(item.itemBind&&showLock)
			this.AddLock(grid);
//		if( item instanceof Equip)
//			equip = item;

		var curBitmap;
		var curPoint = cc.p(0,0);

		// ------------------------------------------ 左上图标
		curPoint.x = 2;
		curPoint.y = 2;

		// ------------------------------------------ 左下图标
		curPoint.x = 5;
		curPoint.y = grid.uiHeight - 5;

		// ------------------------------------------ 右上图标
		curPoint.x = grid.uiWidth - 5;
		curPoint.y = 5;

		// ------------------------------------------ 右下图标
		curPoint.x = grid.uiWidth - 5;
		curPoint.y = grid.uiHeight - 5;

	},
	_GetNewGrid:function()
	{
		var grid = new MUIGrid();
        grid.background = grid.AddBgImage("public/grid/74x74.png");
		grid.setAnchorPoint(0,0);
		grid.setContentSize(cc.size(grid.uiWidth,grid.uiHeight));
		return grid;
	}

}